    MODULE CO2BD2
!>--------------------------------------------------------------------------------------------------
!> MODULE CO2BD2
!>
!> ABSTRACT:
!> MODULE CO2BD2 CONTAINS CO2 TRANSMISSION FUNCTIONS AND TEMPERATURE AND PRESSURE DERIVATIVES FOR 
!> THE 560-670 CM-1 PART OF THE 15 UM CO2 BAND. THESE DATA ARE IN BLOCK DATA BD2.
!>
!> CO231 - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)=1013.25 MB
!> CO238 - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)= ^810   MB
!> CDT31 - FIRST  TEMPERATURE DERIVATIVE OF CO231
!> CDT38 - FIRST  TEMPERATURE DERIVATIVE OF CO238
!> C2D31 - SECOND TEMPERATURE DERIVATIVE OF CO231
!> C2D38 - SECOND TEMPERATURE DERIVATIVE OF CO231
!>
!> USE MODULES: F77KINDS 
!>              RDPARM
!>
!> DRIVER     : CO2DTA
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : LP1
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & CO231   , CO238   ,                                                                         &
    & CDT31   , CDT38   ,                                                                         &
    & C2D31   , C2D38
!
    END MODULE CO2BD2

!-------------------------------------------------------------
! SET PRIMARY GRID DIMENSIONS AND PRESSURE OUTPUT LEVELS
      INTEGER(KIND=I4KIND), PARAMETER :: IM  = 101
      INTEGER(KIND=I4KIND), PARAMETER :: JM  = 159
      INTEGER(KIND=I4KIND), PARAMETER :: LM  =  50
      INTEGER(KIND=I4KIND), PARAMETER :: LSM =  22
!-------------------------------------------------------------
! SET THE NUMBER OF PEs IN THE I-DIRECTION AND J-DIRECTION
      INTEGER(KIND=I4KIND), PARAMETER :: INPES = 1
      INTEGER(KIND=I4KIND), PARAMETER :: JNPES = 4
!-------------------------------------------------------------
      INTEGER(KIND=I4KIND), PARAMETER :: IGSTL = -5
      INTEGER(KIND=I4KIND), PARAMETER :: IGSTR =  5
      INTEGER(KIND=I4KIND), PARAMETER :: JGSTL = -5
      INTEGER(KIND=I4KIND), PARAMETER :: JGSTR =  5
!
      INTEGER(KIND=I4KIND), PARAMETER :: ITAIL = IM - (INPES * (IM / INPES))
      INTEGER(KIND=I4KIND), PARAMETER :: JTAIL = JM - (JNPES * (JM / JNPES))

      INTEGER(KIND=I4KIND), PARAMETER :: IDIM1 = IGSTL
      INTEGER(KIND=I4KIND), PARAMETER :: IDIM2 = IM / INPES + IGSTR + 1
      INTEGER(KIND=I4KIND), PARAMETER :: JDIM1 = JGSTL
      INTEGER(KIND=I4KIND), PARAMETER :: JDIM2 = JM / JNPES + JGSTR + 1

    SUBROUTINE SFCDIF(LMHK , SM   , THS  , QS   , UZ0  , VZ0  , THZ0 , QZ0  , USTAR, WSTAR, Z0   ,&
    &                 ZEFF , AKMS , AKHS , HPBL , CT   , U10  , V10  , TH02 , TH10 , Q02  , Q10  ,&
    &                 TH100, Q100 , U100 , V100 , ULM  , VLM  , T    , Q    , APE  , Z    , PD   ,&
    &                 PT   , TLM)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SFCDIF
!>
!> SUBROUTINE: SFCDIF - SURFACE LAYER
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> AMMENDED TO USE THE "EFFECTIVE ROUGHNESS" OF MASON (1986, SEE GEORGELIN ET AL., MWR JULY 1994)
!>
!> PROGRAM HISTORY LOG:
!> 96-03-28  BLACK      - ORIGINATOR
!> 97-06-??  MEYS       - MODIFIED FOR DISTRIBUTED MEMORY
!> 99-07-06  BLACK      - FULL ARRAY RATHER THAN JUST EDGES
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LMHK  - 
!> SM    - 
!> THS   - 
!> QS    -
!> ZEFF  -
!> HPBL  - 
!> VLM   -
!> T     -
!> Q     - 
!> Z     -
!> PD    - 
!> PT    - 
!> TLM   - 
!>
!> OUTPUT ARGUMENT LIST:
!> CT    - 
!> U10   - 
!> V10   -
!> TH02  -
!> TH10  - 
!> Q02   -
!> Q10   -
!> TH100 -
!> U100  -
!> V100  - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> UZ0   - 
!> VZ0   - 
!> THZ0  - 
!> QZ0   -
!> USTAR - 
!> Z0    -
!> AKMS  - 
!> AKHS  - 
!> ULM   - 
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MOMENTO
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>     
!> DRIVER     : TURBL
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MOMENTO
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1   = LM + 1
!
    REAL   (KIND=R4KIND), PARAMETER :: WWST   = 1.2
    REAL   (KIND=R4KIND), PARAMETER :: WWST2  = WWST * WWST
    REAL   (KIND=R4KIND), PARAMETER :: G      = 9.8
    REAL   (KIND=R4KIND), PARAMETER :: USTFC  = 0.018 / G
    REAL   (KIND=R4KIND), PARAMETER :: VKRM   = 0.40 
    REAL   (KIND=R4KIND), PARAMETER :: RIC    = 0.183
    REAL   (KIND=R4KIND), PARAMETER :: RFC    = 0.191
    REAL   (KIND=R4KIND), PARAMETER :: FHNEU  = 0.8
    REAL   (KIND=R4KIND), PARAMETER :: RRIC   = 1.0   / RIC
    REAL   (KIND=R4KIND), PARAMETER :: RFAC   = RIC   / (FHNEU * RFC * RFC)
    REAL   (KIND=R4KIND), PARAMETER :: EXCM   = 0.001 
    REAL   (KIND=R4KIND), PARAMETER :: BETA   = 1.    / 270.
    REAL   (KIND=R4KIND), PARAMETER :: BTG    = BETA  * G 
    REAL   (KIND=R4KIND), PARAMETER :: ELFC   = VKRM  * BTG
    REAL   (KIND=R4KIND), PARAMETER :: CNV    = 0.608 * G / BTG
    REAL   (KIND=R4KIND), PARAMETER :: WOLD   =  .15
    REAL   (KIND=R4KIND), PARAMETER :: WNEW   = 1.    - WOLD 
!
    INTEGER(KIND=I4KIND), PARAMETER :: ITRMX  = 5  
!        
    REAL   (KIND=R4KIND), PARAMETER :: PIHF   =   3.14159265 / 2. 
    REAL   (KIND=R4KIND), PARAMETER :: PIFR   =   3.14159265 / 4. 
    REAL   (KIND=R4KIND), PARAMETER :: EPSU2  =   1.E-4
    REAL   (KIND=R4KIND), PARAMETER :: EPSUST =   0.07 
    REAL   (KIND=R4KIND), PARAMETER :: EPSIT  =   1.E-4
    REAL   (KIND=R4KIND), PARAMETER :: EPSA   =   1.E-8
    REAL   (KIND=R4KIND), PARAMETER :: ZTMIN  =  -5.
    REAL   (KIND=R4KIND), PARAMETER :: ZTMAX  =   1.
    REAL   (KIND=R4KIND), PARAMETER :: GLKBS  =  30.0
    REAL   (KIND=R4KIND), PARAMETER :: GLKBR  =  10.0
    REAL   (KIND=R4KIND), PARAMETER :: GRRS   =  GLKBR / GLKBS
    REAL   (KIND=R4KIND), PARAMETER :: VISC   =   1.5E-5
    REAL   (KIND=R4KIND), PARAMETER :: TVISC  =   2.1E-5
    REAL   (KIND=R4KIND), PARAMETER :: QVISC  =   2.1E-5
    REAL   (KIND=R4KIND), PARAMETER :: RVISC  =   1. / VISC 
    REAL   (KIND=R4KIND), PARAMETER :: RTVISC =   1. / TVISC
    REAL   (KIND=R4KIND), PARAMETER :: RQVISC =   1. / QVISC
    REAL   (KIND=R4KIND), PARAMETER :: SQPR   =   0.84
    REAL   (KIND=R4KIND), PARAMETER :: SQSC   =   0.84
    REAL   (KIND=R4KIND), PARAMETER :: ZQRZT  =  SQSC / SQPR
    REAL   (KIND=R4KIND), PARAMETER :: USTR   =   0.225  
    REAL   (KIND=R4KIND), PARAMETER :: USTC   =   0.7
    REAL   (KIND=R4KIND), PARAMETER :: FZT1   =  RVISC  * TVISC * SQPR
    REAL   (KIND=R4KIND), PARAMETER :: FZQ1   =  RTVISC * QVISC * ZQRZT
    REAL   (KIND=R4KIND), PARAMETER :: FZQ2   =  RTVISC * QVISC * ZQRZT
    REAL   (KIND=R4KIND), PARAMETER :: M      =  30.0
    REAL   (KIND=R4KIND), PARAMETER :: ZTFC   =   1.0
    REAL   (KIND=R4KIND), PARAMETER :: CZIL   =    .2000
    REAL   (KIND=R4KIND), PARAMETER :: SQVISC = 258.2 
    REAL   (KIND=R4KIND), PARAMETER :: ZILFC  = -CZIL * VKRM * SQVISC
    REAL   (KIND=R4KIND), PARAMETER :: PQ0    = 379.90516
    REAL   (KIND=R4KIND), PARAMETER :: A2     =  17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3     = 273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4     =  35.86
    REAL   (KIND=R4KIND), PARAMETER :: CAPA   =   0.28589641E0
    REAL   (KIND=R4KIND), PARAMETER :: H1M5   =   1.E-5
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::&
    & T       , Q       , APE
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                  , INTENT(IN)          ::&
    & Z
!
    REAL   (KIND=R4KIND), DIMENSION(4)                                    , INTENT(IN)          ::&
    & ZEFF
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LMHK
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & SM      , THS     , QS      , HPBL    , VLM     , PD      , PT      , TLM 
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)       ::&
    & WSTAR   , CT      , U10     , V10     , TH02    , TH10    , Q02     , Q10     , Q100    ,   &
    & U100    , V100    , TH100
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)       ::&
    & UZ0     , VZ0     , THZ0    , QZ0     , USTAR   , Z0      , AKMS    , AKHS    , ULM  
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LMHP    , ML      , MH      , ITR
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & PSLMU   , ZZ      , PSLMS   , PSLHU   , PSPMU   , XX      , PSPMS   , YY      , PSPHU   ,   &
    & PSPHS   , THLM    , QLM     , RR      , SMALL   , CZIV    , FZUI1   , FZT2    , PSLHS   ,   &
    & FZU1    , ZU      , WGHT    , RWGH    , ZT      , ZQ      , ALPHA   , X       , WLOW    ,   &
    & ZSL     , RDZ     , CXCH    , DTHV    , DU2     , RIB     , BTBH    , WSTAR2  , ZSLU    ,   &
    & ZSLT    , RLOGU   , RLOGT   , BTGH    , RLMO    , ZETALT  , ZETALU  , ZETAU   , ZETAT   ,   &
    & PSMZ    , SIMM    , PSHZ    , SIMH    , USTARK  , RLMN    , RLMP    , RLMA    , XLU4    ,   &
    & XLT4    , XU4     , XT4     , XLU     , XLT     , XU      , XT      , HSFLX   , HLFLX   ,   &
    & AKMS100 , AKHS02  , AKHS100 , ZU10    , ZU100   , ZT02    , ZT10    , ZT100   , RLNU10  ,   &
    & RLNU100 , RLNT02  , RLNT10  , RLNT100 , ZTAU10  , ZTAU100 , ZTAT02  , ZTAT100 , SIMM10  ,   &
    & SIMM100 , XLU104  , AKHS10  , ZTAT10  , SIMH02  , SIMH10  , SIMH100 , XLU1004 , XLT024  ,   &
    & XLT104  , XLT1004 , XLU10   , XLU100  , XLT02   , XLT10   , XLT100  , PDS     , TERM1   ,   &
    & PSHLTR  , T02     , QSAT2   , T10     , QSAT10  , P100    , T100    , QSAT100 , U10E    ,   &
    & V10E    , U100E   , V100E   , ZUUZ    , ZTAU    , XU104   , XU10    , EKMS10  , EKMS100
!
    PSLMU(ZZ) = -0.96 * ALOG(1.0 - 4.5 * ZZ)
    PSLMS(ZZ) =  ZZ * RRIC - 2.076 * (1. - 1. / (ZZ + 1.))
    PSLHU(ZZ) = -0.96 * ALOG(1.0 - 4.5 * ZZ)
    PSLHS(ZZ) =  ZZ * RFAC - 2.076 * (1. - 1. / (ZZ + 1.))
    PSPMU(XX) = -2. * ALOG((XX + 1.) * 0.5) - ALOG((XX * XX + 1.) * 0.5) + 2. * ATAN(XX) - PIHF
    PSPMS(YY) =  5. * YY
    PSPHU(XX) = -2. * ALOG((XX * XX + 1.) * 0.5)
    PSPHS(YY) =  5. * YY
!
    LMHP = LMHK + 1
!
    THLM = T(LMHK) * APE(LMHK)
    QLM  = Q(LMHK)
!
    Z0 = (1. - SM) * Z0 + SM * AMAX1(USTFC * USTAR * USTAR, 1.59E-5)
!-----------------  
! VISCOUS SUBLAYER 
!-----------------
    IF (SM > 0.5 .AND. USTAR < USTC) THEN
!----------------------------
! MALAGUTTI CLASS EXPERIMENTS
!----------------------------
        RR    = USTAR * Z0 * 1 / VISC
        SMALL = 11 / (M * (RR ** 0.25))
        CZIV  = SMALL * GLKBS
        FZU1  = CZIV * VISC
        FZT2  = CZIV * GRRS * TVISC * SQPR
!
        IF (USTAR < USTR) THEN
!        
            ZU   = FZU1 * SQRT(SQRT(Z0 * USTAR * RVISC)) / USTAR
            WGHT = AKMS * ZU * RVISC
            RWGH = WGHT / (WGHT + 1.)
            UZ0  = (ULM * RWGH + UZ0) * 0.5
            VZ0  = (VLM * RWGH + VZ0) * 0.5
!        
            ZT   = FZT1 * ZU
            WGHT = AKHS * ZT * RTVISC
            THZ0 = ((WGHT * THLM + THS) / (WGHT + 1.) + THZ0) * 0.5
!        
            ZQ   = FZQ1 * ZT
            WGHT = AKHS * ZQ * RQVISC
            QZ0  = ((WGHT * QLM + QS)   / (WGHT + 1.) + QZ0)  * 0.5
!        
        END IF
!
        IF (USTAR >= USTR .AND. USTAR < USTC) THEN
!        
            ZU  = Z0
            UZ0 = 0.
            VZ0 = 0.
!        
            ZT   = FZT2 * SQRT(SQRT(Z0 * USTAR * RVISC)) / USTAR
            WGHT = AKHS * ZT * RTVISC
            THZ0 = ((WGHT * THLM + THS) / (WGHT + 1.) + THZ0) * 0.5
!        
            ZQ   = FZQ2 * ZT
            WGHT = AKHS * ZQ * RQVISC
            QZ0  = ((WGHT * QLM + QS)   / (WGHT + 1.) + QZ0)  * 0.5
        END IF
!
    ELSE
!
        ZU = Z0
!
        IF (SM <= 0.5) THEN
            IF (ULM == 0.) ULM = EPSU2
!
            ALPHA = ABS(ATAN(VLM / ULM) + PIHF - EPSA)
            X     = ALPHA / PIFR
            ML    = 1 + X
            ML    = MIN(4,ML)
            MH    = 1 + MOD(ML,4)
            WLOW  = X - ML + 1
            ZU    = WLOW * ZEFF(ML) + (1. - WLOW) * ZEFF(MH)
        END IF
!
        UZ0 = 0.
        VZ0 = 0.
!    
        ZT   = Z0
        THZ0 = THS
!    
        ZQ  = Z0
        QZ0 = QS
!
    END IF
!
    ZSL = (Z(LMHK) - Z(LMHP)) * 0.5
!
    ZU = AMIN1(ZU,0.5*ZSL)
!
    RDZ = 1. / ZSL
    CXCH = EXCM * RDZ
!
    IF (SM > 0.5) THEN
        DTHV = (0.608 * QLM + 1.) * THLM - (0.608 * QZ0 + 1.) * THZ0
    ELSE
        DTHV = (QLM - QZ0) * CNV + THLM - THZ0
        ZT = Z0 * ZTFC
    END IF
!
    DU2 = AMAX1((ULM - UZ0) ** 2 + (VLM-VZ0) ** 2, EPSU2)
!
    RIB = BTG * DTHV * ZSL / DU2
!----------------------------    
! BELJARS CORRECTION OF USTAR 
!---------------------------- 
    BTGH   = BTG * HPBL
    WSTAR2 = WWST2 * ABS(BTGH * AKHS * DTHV) ** (2. / 3.)
    USTAR  = AMAX1(SQRT(AKMS * SQRT(DU2 + WSTAR2)), EPSUST)
!---------------------------- 
! MALAGUTTI CLASS EXPERIMENTS
!---------------------------- 
    RR    = USTAR * Z0 * 1 / VISC
    SMALL = 11 / (M * (RR ** 0.25))
    CZIV  = SMALL * GLKBS
    FZU1  = CZIV * VISC
    FZT2  = CZIV * GRRS * TVISC * SQPR
!--------------------------  
! ZILITINKEVITCH FIX FOR ZT 
!--------------------------
    IF (SM < 0.5) ZT = EXP(ZILFC * SQRT(USTAR * Z0)) * Z0
!
    IF (SM > 0.5 .AND. RIB >= RIC) THEN
!
        AKMS = AMAX1( VISC * RDZ, CXCH)
        AKHS = AMAX1(TVISC * RDZ, CXCH)
!
    ELSE
!
        ZSLU = ZSL + ZU
        ZSLT = ZSL + ZT
!    
        RLOGU = ALOG(ZSLU / ZU)
        RLOGT = ALOG(ZSLT / ZT)
!    
        RLMO = ELFC * AKHS * DTHV / USTAR ** 3
!----------------- 
! SEA POINTS FIRST
!-----------------
        IF (SM > 0.5) THEN
            DO 100 ITR=1,ITRMX
!-------------------------------
! 1./MONIN-OBUKKHOV LENGTH-SCALE 
!-------------------------------
                ZETALT = AMAX1(ZSLT*RLMO,ZTMIN)
                RLMO   = ZETALT / ZSLT
                ZETALU = ZSLU   * RLMO            
                ZETAU  = ZU     * RLMO
                ZETAT  = ZT     * RLMO
!---------------------- 
! LL FUNCTIONS OVER SEA 
!----------------------
                IF (RLMO < 0.) THEN
                    PSMZ =          PSLMU(ZETAU)
                    SIMM =          PSLMU(ZETALU) - PSMZ + RLOGU
                    PSHZ =          PSLHU(ZETAT)
                    SIMH = FHNEU * (PSLHU(ZETALT) - PSHZ + RLOGT)
                ELSE
                    PSMZ =         PSLMS(ZETAU)
                    SIMM =         PSLMS(ZETALU) - PSMZ  + RLOGU
                    PSHZ =          PSLHS(ZETAT)
                    SIMH = FHNEU * (PSLHS(ZETALT) - PSHZ + RLOGT)
                END IF
!------------------------------ 
! BELJAARS CORRECTION FOR USTAR
!------------------------------
                USTAR = AMAX1(SQRT(AKMS * SQRT(DU2 + WSTAR2)), EPSUST)
!---------------------------- 
! MALAGUTTI CLASS EXPERIMENTS
!----------------------------
                RR    = USTAR * Z0 * 1 / VISC
                SMALL = 11 / (M * (Rr ** 0.25))
                CZIV  = SMALL * GLKBS
                FZU1  = CZIV * VISC
                FZT2  = CZIV * GRRS * TVISC * SQPR
!
                USTARK = USTAR * VKRM
                AKMS   = AMAX1(USTARK / SIMM, CXCH)
                AKHS   = AMAX1(USTARK / SIMH, CXCH)
!
                WSTAR2 = WWST2 * ABS(BTGH * AKHS * DTHV) ** (2. / 3.)
                RLMN   = ELFC * AKHS * DTHV / USTAR ** 3
!
                RLMP = RLMO
                RLMA = RLMO * WOLD + RLMN * WNEW
!
                RLMO = RLMA
!
        100 END DO
!
        110 CONTINUE
!----------------------------
! END OF SEA POINT PROCESSING 
!----------------------------
        ELSE
!---------------- 
! NOW LAND POINTS 
!---------------- 
            DO 200 ITR=1,ITRMX
!-------------------------------
! 1./MONIN-OBUKKHOV LENGTH-SCALE
!-------------------------------
                ZETALT = AMAX1(ZSLT * RLMO, ZTMIN)
                RLMO   = ZETALT/ZSLT
                ZETALU = ZSLU * RLMO   
                ZETAU  = ZU   * RLMO
                ZETAT  = ZT   * RLMO
!-----------------------------------------------
! PAULSON 1970 FUNCTIONS OVER LAND W RAD. SKIN T
!-----------------------------------------------
                IF (RLMO < 0.) THEN
                    XLU4 = 1. -16. * ZETALU
                    XLT4 = 1. -16. * ZETALT
                    XU4  = 1. -16. * ZETAU
                    XT4  = 1. -16. * ZETAT
!                
                    XLU = SQRT(SQRT(XLU4))
                    XLT = SQRT(SQRT(XLT4))
                    XU  = SQRT(SQRT(XU4 ))
                    XT  = SQRT(SQRT(XT4 ))
!                
                    PSMZ = PSPMU(XU )
                    SIMM = PSPMU(XLU) - PSMZ + RLOGU
                    PSHZ = PSPHU(XT )
                    SIMH = PSPHU(XLT) - PSHZ + RLOGT
                ELSE
                    ZETAU  = AMIN1(ZETAU , ZTMAX)
                    ZETAT  = AMIN1(ZETAT , ZTMAX)
                    ZETALU = AMIN1(ZETALU, ZTMAX)
                    ZETALT = AMIN1(ZETALT, ZTMAX)
                    PSMZ   = PSPMS(ZETAU )
                    SIMM   = PSPMS(ZETALU) - PSMZ + RLOGU
                    PSHZ   = PSPHS(ZETAT )
                    SIMH   = PSPHS(ZETALT) - PSHZ + RLOGT
                END IF
!------------------------------ 
! BELJAARS CORRECTION FOR USTAR 
!------------------------------ 
                USTAR = AMAX1(SQRT(AKMS * SQRT(DU2 + WSTAR2)), EPSUST)
!-------------------------- 
! ZILITINKEVITCH FIX FOR ZT
!--------------------------  
                ZT    = EXP(ZILFC * SQRT(USTAR * Z0)) * Z0
                ZSLT  = ZSL + ZT
                RLOGT = ALOG(ZSLT / ZT)
!
                USTARK = USTAR * VKRM
                AKMS   = AMAX1(USTARK / SIMM, CXCH)
                AKHS   = AMAX1(USTARK / SIMH, CXCH)
!
                WSTAR2 = WWST2 * ABS(BTGH * AKHS * DTHV) ** (2./3.)
                RLMN   = ELFC * AKHS * DTHV / USTAR ** 3
!
                RLMP = RLMO
                RLMA = RLMO * WOLD + RLMN * WNEW
                RLMO = RLMA
!
        200 END DO
!
        210 CONTINUE
!---------------------------------------------------- 
! END OF LAND POINT PROCESSING AND SEA-LAND BRANCHING
!----------------------------------------------------
        END IF
!------------------------------------------ 
! END OF TURBULENCE-NO TURBULENCE BRANCHING
!------------------------------------------ 
    END IF
!-------------------- 
! COUNTERGRADIENT FIX 
!-------------------- 
    CT = 0.
!-----------------  
! DIAGNOSTIC BLOCK
!-----------------
    WSTAR = SQRT(WSTAR2) / WWST
!
    UMFLX = AKMS * (ULM  - UZ0 )
    VMFLX = AKMS * (VLM  - VZ0 )
    HSFLX = AKHS * (THLM - THZ0)
    HLFLX = AKHS * (QLM  - QZ0 )
!
    IF (SM > 0.5 .AND. RIB >= RIC) THEN
!
        AKMS10 = AMAX1( VISC / 10., 4. * CXCH)
!---------   
! SM v100M
!---------
        AKMS100 = AMAX1( VISC / 100., 4. * CXCH)
        AKHS02  = AMAX1(TVISC /  02., 4. * CXCH)    
        AKHS10  = AMAX1(TVISC /  10., 4. * CXCH)
        AKHS100 = AMAX1(TVISC / 100., 4. * CXCH)
!
    ELSE
!
        ZU10 = ZU + 10.
!---------   
! SM v100M
!---------
        ZU100   = ZU + 100.
        ZT02    = ZT + 02.
        ZT10    = ZT + 10.
        ZT100   = ZT + 100.
!
        RLNU10  = ALOG(ZU10  / ZU)
        RLNU100 = ALOG(ZU100 / ZU)
        RLNT02  = ALOG(ZT02  / ZT)
        RLNT10  = ALOG(ZT10  / ZT)
        RLNT100 = ALOG(ZT100 / ZT)
!
        ZTAU10  = ZU10  * RLMP
        ZTAU100 = ZU100 * RLMP
        ZTAT02  = ZT02  * RLMP
        ZTAT10  = ZT10  * RLMP
        ZTAT100 = ZT100 * RLMP
!---------------------- 
! LL FUNCTIONS OVER SEA 
!---------------------- 
        IF (SM > 0.5) THEN
!
            IF (RLMP < 0.) THEN
                SIMM10  = PSLMU(ZTAU10)  - PSMZ + RLNU10
!---------   
! SM v100M
!---------
                SIMM100 = PSLMU(ZTAU100) - PSMZ + RLNU100
                SIMH02  = FHNEU * (PSLHU(ZTAT02)  - PSHZ + RLNT02)
                SIMH10  = FHNEU * (PSLHU(ZTAT10)  - PSHZ + RLNT10)
                SIMH100 = FHNEU * (PSLHU(ZTAT100) - PSHZ + RLNT100)
!
            ELSE
!
                SIMM10 = PSLMS(ZTAU10)   - PSMZ + RLNU10
!---------   
! SM v100M
!---------
                SIMM100 = PSLMS(ZTAU100) - PSMZ + RLNU100
                SIMH02  = FHNEU * (PSLHS(ZTAT02)  - PSHZ + RLNT02)
                SIMH10  = FHNEU * (PSLHS(ZTAT10)  - PSHZ + RLNT10)
                SIMH100 = FHNEU * (PSLHS(ZTAT100) - PSHZ + RLNT100)
            END IF
!----------------------------------------------- 
! PAULSON 1970 FUNCTIONS OVER LAND W RAD. SKIN T 
!----------------------------------------------- 
        ELSE
!
            IF (RLMP < 0.) THEN
                XLU104 = 1. -16. * ZTAU10
!---------   
! SM v100M
!---------
                XLU1004 = 1. -16. * ZTAU100
                XLT024  = 1. -16. * ZTAT02
                XLT104  = 1. -16. * ZTAT10
                XLT1004 = 1. -16. * ZTAT100
!
                XLU10   = SQRT(SQRT(XLU104 ))
                XLU100  = SQRT(SQRT(XLU1004))
                XLT02   = SQRT(SQRT(XLT024 ))
                XLT10   = SQRT(SQRT(XLT104 ))
                XLT100  = SQRT(SQRT(XLT1004))
!
                SIMM10  = PSPMU(XLU10 ) - PSMZ + RLNU10
                SIMM100 = PSPMU(XLU100) - PSMZ + RLNU100
                SIMH02  = PSPHU(XLT02 ) - PSHZ + RLNT02
                SIMH10  = PSPHU(XLT10 ) - PSHZ + RLNT10
                SIMH100 = PSPHU(XLT100) - PSHZ + RLNT100
            ELSE
                ZTAU10 = AMIN1(ZTAU10,ZTMAX)
!---------   
! SM v100M
!---------
                ZTAU100 = AMIN1(ZTAU100, ZTMAX)
                ZTAT02  = AMIN1(ZTAT02 , ZTMAX)
                ZTAT10  = AMIN1(ZTAT10 , ZTMAX)
                ZTAT100 = AMIN1(ZTAT100, ZTMAX)     
!
                SIMM10  = PSPMS(ZTAU10 ) - PSMZ + RLNU10
                SIMM100 = PSPMS(ZTAU100) - PSMZ + RLNU100
                SIMH02  = PSPHS(ZTAT02 ) - PSHZ + RLNT02
                SIMH10  = PSPHS(ZTAT10 ) - PSHZ + RLNT10
                SIMH100 = PSPHS(ZTAT100) - PSHZ + RLNT100
            END IF
!
        END IF
!
        AKMS10 = AMAX1(USTARK / SIMM10, CXCH)
!---------   
! SM v100M
!---------
        AKMS100 = AMAX1(USTARK / SIMM100, CXCH)
        AKHS02  = AMAX1(USTARK / SIMH02 , CXCH)
        AKHS10  = AMAX1(USTARK / SIMH10 , CXCH)
        AKHS100 = AMAX1(USTARK / SIMH100, CXCH)
    END IF
!
    U10 = UMFLX / AKMS10 + UZ0
!---------   
! SM v100M
!---------
    U100  = UMFLX / AKMS100 +  UZ0
    V100  = VMFLX / AKMS100 +  VZ0
    V10   = VMFLX / AKMS10  +  VZ0
    TH02  = HSFLX / AKHS02  + THZ0
    TH10  = HSFLX / AKHS10  + THZ0
    TH100 = HSFLX / AKHS100 + THZ0
!--------------------------------------------------------------------------------------------------  
! GSM - CHANGED THIS SECTION IN RESPONSE TO PROBLEM WITH 2-M DEW POINT OCCASIONALLY BEING GREATER
!       THAN 2-M TEMPERATURE AND SIMILAR PROBLEM AT 10-M. NOW, A SATURATION Q IS CALCULATED AT 
!       EACH LEVEL, AND THE Q IS CONSTRAINED TO BE NO HIGHER THAN THE SATURATION VALUE.
!--------------------------------------------------------------------------------------------------
    PDS    = PD + PT
    TERM1  = -0.068283 / TLM
    PSHLTR = PDS * EXP(TERM1)
    T02    = TH02 * (PSHLTR * H1M5) ** CAPA
    QSAT2  = PQ0 / PSHLTR * EXP(A2 * (T02 - A3) / (T02 - A4))
    Q02    = HLFLX / AKHS02 + QZ0
!
    IF (Q02 < 0.) THEN
        IF (QLM > 0.) THEN
            Q02 = QLM
        ELSE
            Q02 = 0.0001
        END IF
    END IF
!
    IF (Q02 > QSAT2) THEN
        Q02 = QSAT2
    END IF
!
    T10    = TH10 * (PSHLTR * H1M5) ** CAPA
    QSAT10 = PQ0 / PSHLTR * EXP(A2 * (T10 - A3) / (T10 - A4))
    Q10    = HLFLX / AKHS10 + QZ0
!
    IF (Q10 < 0.) THEN
        IF (QLM > 0.) THEN
            Q10 = QLM
        ELSE
            Q10 = 0.0001
        END IF
    END IF
!
    IF (Q10 > QSAT10) THEN
        Q10 = QSAT10
    END IF
!---------   
! SM v100M
!---------
    P100    = PDS * EXP(-100.0 * G / (287.04 * TLM))
    T100    = TH100 * (P100 * H1M5) ** CAPA
    QSAT100 = PQ0 / P100 * EXP(A2 * (T100 - A3) / (T100 - A4))
    Q100    = HLFLX / AKHS100 + QZ0
!
    IF (Q100 < 0.) THEN
        IF (QLM > 0.) THEN
            Q100 = QLM
        ELSE
            Q100 = 0.0001
        END IF
    END IF
!
    IF (Q100 > QSAT100) THEN
        Q100 = QSAT100
    END IF
!---------   
! SM v100M
!---------
!
!------------------------------
! NEW CLACULATION OF 10-M WINDS
!------------------------------ 
    U10E = U10
    V10E = V10
!---------   
! SM v100M
!---------
    U100E = U100
    V100E = V100
!
    IF (SM < 0.5)  THEN
        ZUUZ = AMIN1(ZU * 0.50, 0.10)
        ZU   = AMAX1(ZU * 0.10, ZUUZ)
        ZU10 = ZU + 10.
!---------   
! SM v100M
!---------
        ZU100   = ZU + 100.
        RLNU10  = ALOG(ZU10 / ZU)
        RLNU100 = ALOG(ZU100 / ZU)
        ZTAU    = ZU    * RLMP
        ZTAU10  = ZU10  * RLMP
        ZTAU100 = ZU100 * RLMP
!
        IF (RLMP < 0) THEN
            XLU104 = 1. -16. * ZTAU10
!---------   
! SM v100M
!---------
            XLU1004 = 1. -16. * ZTAU100
            XU104   = 1. -16. * ZTAU
            XLU10   = SQRT(SQRT(XLU104))
            XLU100  = SQRT(SQRT(XLU1004))
            XU10    = SQRT(SQRT(XU104))
            SIMM10  = PSPMU(XLU10)  - PSPMU(XU10) + RLNU10
            SIMM100 = PSPMU(XLU100) - PSPMU(XU10) + RLNU100
        ELSE
            ZTAU10 = AMIN1(ZTAU10, ZTMAX)
!---------   
! SM v100M
!---------
            ZTAU100 = AMIN1(ZTAU100, ZTMAX)
            SIMM10  = PSPMS(ZTAU10)  - PSPMS(ZTAU) + RLNU10
            SIMM100 = PSPMS(ZTAU100) - PSPMS(ZTAU) + RLNU100
        END IF
!
        EKMS10 = AMAX1(USTARK / SIMM10, CXCH)
!---------   
! SM v100M
!---------
        EKMS100 = AMAX1(USTARK / SIMM100, CXCH)
        U10E    = UMFLX / EKMS10  + UZ0
        V10E    = VMFLX / EKMS10  + VZ0
        U100E   = UMFLX / EKMS100 + UZ0
        V100E   = VMFLX / EKMS100 + VZ0
    END IF
!
    RETURN
!
    END SUBROUTINE SFCDIF

    SUBROUTINE MPI_FIRST
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE MPI_FIRST
!>
!>
!> SUBROUTINE: MPI_FIRST - INTIALIZES MPI STUFF
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-20
!>
!> ABSTRACT:
!> INTIALIZES MPI STUFF
!>
!> PROGRAM HISTORY LOG:
!> 00-01-20  TUCCILLO - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> EXIT STATES:
!> COND =   0 - NORMAL EXIT
!>
!> USE MODULES: GLB_TABLE
!>              F77KINDS
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : QUILT
!>
!> CALLS      : MPI_ABORT
!>              MPI_COMM_RANK
!>              MPI_COMM_SIZE           
!>              PARA_RANGE
!>--------------------------------------------------------------------------------------------------
    USE GLB_TABLE
    USE F77KINDS
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE 'mpif.h'
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IERR
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LNIP    , LNJP    ,                                                                         &
    & JS_X    , JE_X    ,                                                                         &
    & IRMND   , JRMND   ,                                                                         &
    & IPOSN   , JPOSN   ,                                                                         &
    & I       ,                                                                                   &
    & IPE
!
    LNIP = IM / INPES
    LNJP = JM / JNPES
!-------------------------------------------------------------------------
! NUM_PROCS IS THE NUMBER OF TASKS DOING THE QUILTING IN THIS SERVER GROUP
!-------------------------------------------------------------------------
    CALL MPI_COMM_SIZE(MPI_COMM_COMP, NUM_PROCS, IERR)
    CALL MPI_COMM_RANK(MPI_COMM_COMP, ME       , IERR)
!
    PRINT *, ' NUM_PROCS = ', NUM_PROCS
!
    IF ( NUM_PROCS > JNPES ) THEN
        PRINT *, ' TOO MANY MPI TASKS, MAX IS ',JNPES, ', STOPPING'
        CALL MPI_ABORT(MPI_COMM_WORLD, 1, IERR)
    END IF
!
    IF ( NUM_PROCS > 2800 ) THEN
        PRINT *, ' TOO MANY MPI TASKS, MAX IS 1024, STOPPING'
        CALL MPI_ABORT(MPI_COMM_WORLD, 1, IERR)
    END IF
!--------------------------------------------------------------------------------------------------
! JS_X AND JS_Y ARE THE STARTING AND ENDING ROWS OF TASKS IN THE MODEL FORECAST DECOMPOSITION THAT 
! WILL BE SENDING TO EACH QUILT TASK
!
! JSTA IS THE FIRST FORECAST TASK AND JEND IS THE LAST FORECAST TASK IN THE ENTIRE RANGE OF 
! FORECAST TASKS THAT WILL BE SENDING TO EACH QUILT TASK. 
! REMEMBER THAT AN INTEGER NUMBER OF FORECAST TASK ROWS IS SENT TO EACH QUILT TASK.
!--------------------------------------------------------------------------------------------------
    DO I = 0, NUM_PROCS-1
        CALL PARA_RANGE(0, JNPES-1, NUM_PROCS, I, JS_X, JE_X)
!
        JSTA(I) = JS_X * INPES
        JEND(I) = JSTA(I) + (JE_X-JS_X+1) * INPES-1
!
        IF (ME == 0) THEN
            PRINT *, ' TASK ID, JSTA, END = ', I, JSTA(I), JEND(I)
        END IF
    END DO
!--------------------------------------------------------------------------------------------------
! LOCATIONS
!
! PARAMETER LNIP (LNJP) IS SMALLEST THAT THE I (J) EXTENT OF EACH SUBDOMAIN CAN BE.
! IRMND (JRMND) IS THE NUMBER OF "REMAINDER" I (J) POINTS THAT WILL BE GIVEN TO THE LEFTMOST 
! (LOWERMOST) PES.
!--------------------------------------------------------------------------------------------------
    IRMND = MOD(IM, INPES)
    JRMND = MOD(JM, JNPES)
!
    DO IPE=0,NPES-1
!    
        IPOSN = MOD(IPE, INPES) + 1
        JPOSN = IPE / INPES + 1
!------------------------------------    
! GLOBAL LIMITS OF THIS PES SUBDOMAIN
!------------------------------------     
        MY_IS_GLB_A(IPE) = (IPOSN-1) * LNIP + MIN(IRMND, IPOSN-1) + 1
        MY_IE_GLB_A(IPE) = MY_IS_GLB_A(IPE) + LNIP - 1
!
        IF (IPOSN <= IRMND) MY_IE_GLB_A(IPE) = MY_IE_GLB_A(IPE) + 1
!    
        MY_JS_GLB_A(IPE) = (JPOSN-1) * LNJP + MIN(JRMND, JPOSN-1) + 1
        MY_JE_GLB_A(IPE) = MY_JS_GLB_A(IPE) + LNJP - 1
!
        IF (JPOSN <= JRMND) MY_JE_GLB_A(IPE) = MY_JE_GLB_A(IPE) + 1
!
    END DO
!------------------------- 
! DIMENSIONING INFORMATION
!------------------------- 
    MY_ISD = 1
    MY_IED = IM
    MY_JSD = MY_JS_GLB_A(JSTA(ME)) - 2
    MY_JED = MY_JE_GLB_A(JEND(ME)) + 2
!
    IF ( MY_JSD < 1  ) MY_JSD = 1
    IF ( MY_JED > JM ) MY_JED = JM
!
    PRINT *, ' ME, MY_ISD,MY_IED,MY_JSD,MY_JED = ', ME, MY_ISD, MY_IED, MY_JSD, MY_JED
!
    JSTA_I = MY_JS_GLB_A(JSTA(ME))
    JEND_I = MY_JE_GLB_A(JEND(ME))
!
    JSTA_IM  = JSTA_I
    JSTA_IM2 = JSTA_I
    JEND_IM  = JEND_I
    JEND_IM2 = JEND_I
!
    IF (ME == 0) THEN
        JSTA_IM  = 2
        JSTA_IM2 = 3
    END IF
!
    IF (ME == NUM_PROCS-1) THEN
        JEND_IM=JM-1
        JEND_IM2=JM-2
    END IF
!
    PRINT *, ' JSTA_I, JEND_I, JSTA_IM, JEND_IM, JSTA_IM2, JEND_IM2= ',                           &
    &          JSTA_I, JEND_I, JSTA_IM, JEND_IM, JSTA_IM2, JEND_IM2
!----------  
! NEIGHBORS
!----------
    IUP = ME + 1
    IDN = ME - 1
!
    IF (ME == 0) THEN
        IDN = MPI_PROC_NULL
    END IF
!
    IF (ME == NUM_PROCS-1) THEN
        IUP = MPI_PROC_NULL
    END IF
!
    END SUBROUTINE MPI_FIRST

    MODULE MPPCOM
!>--------------------------------------------------------------------------------------------------
!> MODULE MPPCOM
!>
!> ABSTRACT:
!> IT WAS CREATED FROM MPP.h
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLO89
!>              CLTEND
!>              COLLECT
!>              CONRAD
!>              CUCNVC
!>              DDAMP
!>              DIFCOF
!>              DIGFLT
!>              DIST
!>              DIVHOA
!>              DIVHOAST
!>              DSTRB
!>              E1E290
!>              E290
!>              E2SPEC
!>              E3V88
!>              EBU
!>              EPS
!>              FILT25
!>              FST88
!>              GOSSIP
!>              GSCOND
!>              GSMCOLUMN
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              IDSTRB
!>              INIT
!>              INITS
!>              LOC2GLB
!>              LWR88
!>              MIXLEN
!>              MODULE_EXCHM
!>              MPI_FIRST
!>              MPPINIT
!>              NEWFLT
!>              OZON2D
!>              PDNEW
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              QUILT
!>              RADFS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SFCDIF
!>              SFCDIF_BHS
!>              SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!>              SPA88
!>              SURFCE
!>              SWR93
!>              TABLE
!>              TTBLEX
!>              TURBL
!>              TWR
!>              UPDATE
!>              VADZ
!>              VDIFH
!>              VDIFV
!>              VTADV
!>              VTADVF
!>              VWR
!>              ZENITH
!>              ZERO2
!>              ZERO3
!>              ZERO3_T 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : INPES, JNPES
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & MYPE              , NPES              ,                                                     &
    & MY_IS_GLB         , MY_IE_GLB         ,                                                     &
    & MY_JS_GLB         , MY_JE_GLB         ,                                                     &
    & MY_IS_LOC         , MY_IE_LOC         ,                                                     &
    & MY_JS_LOC         , MY_JE_LOC         ,                                                     &
    & MYIS              , MYIS1             ,                                                     &
    & MYIS2             , MYIE              ,                                                     &
    & MYIE1             , MYIE2             ,                                                     &
    & MYIS_P1           , MYIS_P2           ,                                                     &
    & MYIS_P3           , MYIS_P4           ,                                                     &
    & MYIS_P5           ,                                                                         &
    & MYIS1_P1          , MYIS1_P2          ,                                                     &
    & MYIS1_P3          , MYIS1_P4          ,                                                     &
    & MYIE_P1           , MYIE_P2           ,                                                     &
    & MYIE_P3           , MYIE_P4           ,                                                     &
    & MYIE_P5           ,                                                                         &
    & MYIE1_P1          , MYIE1_P2          ,                                                     &
    & MYIE1_P3          , MYIE1_P4          ,                                                     &
    & MYIE2_P1          ,                                                                         &
    & MYJS              , MYJS1             ,                                                     &
    & MYJS2             , MYJS3             ,                                                     &
    & MYJS4             , MYJS5             ,                                                     &
    & MYJS_P1           , MYJS_P2           ,                                                     &
    & MYJS_P3           , MYJS_P4           ,                                                     &
    & MYJS_P5           ,                                                                         &
    & MYJS1_P1          , MYJS1_P2          ,                                                     &
    & MYJS1_P3          , MYJS1_P4          ,                                                     &
    & MYJS2_P1          , MYJS2_P2          ,                                                     &
    & MYJS2_P3          , MYJS2_P4          ,                                                     &
    & MYJS3_P4          ,                                                                         &
    & MYJS4_P1          , MYJS4_P4          ,                                                     &
    & MYJS5_P1          , MYJS5_P2          ,                                                     &
    & MYJE              , MYJE1             ,                                                     &
    & MYJE2             , MYJE3             ,                                                     &
    & MYJE4             , MYJE5             ,                                                     &
    & MYJE_P1           , MYJE_P2           ,                                                     &
    & MYJE_P3           , MYJE_P4           ,                                                     &
    & MYJE_P5           ,                                                                         &
    & MYJE1_P1          , MYJE1_P2          ,                                                     &
    & MYJE1_P3          , MYJE1_P4          ,                                                     &
    & MYJE2_P1          , MYJE2_P2          ,                                                     &
    & MYJE2_P3          , MYJE2_P4          ,                                                     &
    & MYJE3_P4          ,                                                                         &
    & MYJE4_P1          , MYJE4_P4          ,                                                     &
    & MYJE5_P1          , MYJE5_P2          ,                                                     &
    & MY_N              , MY_E              ,                                                     &
    & MY_S              , MY_W              ,                                                     &
    & MY_NE             , MY_SE             ,                                                     &
    & MY_SW             , MY_NW
!
    INTEGER(KIND=I4KIND), DIMENSION(8)                                                          ::&
    & MY_NEB
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ILCOL   , IRCOL   ,                                                                         &
    & IBROW   , ITROW   ,                                                                         &
    & ILPAD1  , ILPAD2  ,                                                                         &
    & ILPAD3  , ILPAD4  ,                                                                         &
    & ILPAD5  ,                                                                                   &
    & IRPAD1  , IRPAD2  ,                                                                         &
    & IRPAD3  , IRPAD4  ,                                                                         &
    & IRPAD5  ,                                                                                   &
    & JBPAD1  , JBPAD2  ,                                                                         &
    & JBPAD3  , JBPAD4  ,                                                                         &
    & JBPAD5  ,                                                                                   &
    & JTPAD1  , JTPAD2  ,                                                                         &
    & JTPAD3  , JTPAD4  ,                                                                         &
    & JTPAD5
!
    INTEGER(KIND=I4KIND), DIMENSION(0:INPES*JNPES)                                              ::&
    & IS_LOC_TABLE      , JS_LOC_TABLE      ,                                                     &
    & IE_LOC_TABLE      , JE_LOC_TABLE      ,                                                     &
    & ICHUNKTAB
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & MPI_COMM_COMP     , MPI_COMM_INTER    ,                                                     &
    & IQUILT_GROUP 
!
    INTEGER(KIND=I4KIND), DIMENSION(100)                                                        ::&
    & MPI_COMM_INTER_ARRAY        , INUMQ
!
    END MODULE MPPCOM

    SUBROUTINE IDSTRB(ARRG, ARRL)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE IDSTRB
!> 
!> SUBPROGRAM: IDSTRB - DISTRIBUTE INTEGER GLOBAL ARRAY TO LOCAL ONES
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 97-08-29
!>
!> ABSTRACT:
!> IDSTRB DISTRIBUTES THE ELEMENTS OF INTEGER GLOBAL ARRAY ARRG TO THE INTEGER LOCAL ARRAYS ARRL. 
!> LG IS THE VERTICAL DIMENSION OF THE GLOBAL ARRAY. 
!> LL IS THE VERTICAL DIMENSION OF THE LOCAL ARRAY. 
!> L1 IS THE SPECIFIC LEVEL OF ARRL THAT IS BEING FILLED DURING THIS CALL 
!> (PERTINENT WHEN LG=1 AND LL>1).
!>
!> PROGRAM HISTORY LOG:
!> 97-08-29  BLACK      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT ARGUMENT LIST:
!> ARRG - GLOBAL ARRAY
!>
!> OUTPUT ARGUMENT LIST:
!> ARRL - LOCAL ARRAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: GLB_TABLE
!>              F77KINDS
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : READ_NHB
!>              READ_RESTRT
!>
!> CALLS      : MPI_BARRIER
!>              MPI_RECV
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
    USE GLB_TABLE
    USE F77KINDS
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!--------------------------------------- 
! DISTRIBUTE ARRAYS FROM GLOBAL TO LOCAL
!---------------------------------------
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(IM, JM)                               , INTENT(IN)          ::&
    & ARRG     
!
    INTEGER(KIND=I4KIND), DIMENSION(IM*JM)                                                      ::&
    & ARRX   
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2,JDIM1:JDIM2)              , INTENT(INOUT)       ::&
    & ARRL
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , JGLB    , LOCJ    , IGLB    , LOCI    , IPE     , KNT     , ISEND   ,   &
    & NUMVALS , IRECV   , IRTN 
!--------------------------------------------------------------------------------------- 
! PE0 FILLS ITS OWN LOCAL DOMAIN THEN PARCELS OUT ALL THE OTHER PIECES TO THE OTHER PEs.
!--------------------------------------------------------------------------------------- 
    IF (MYPE == 0) THEN
!    
        DO JGLB=JS_GLB_TABLE(0),JE_GLB_TABLE(0)
            LOCJ = G2LJ(JGLB)
            DO IGLB=IS_GLB_TABLE(0),IE_GLB_TABLE(0)
                LOCI = G2LI(IGLB)
                ARRL(LOCI,LOCJ) = ARRG(IGLB,JGLB)
            END DO
        END DO
!    
        DO IPE=1,NPES-1
!
            KNT = 0
!        
            DO JGLB=JS_GLB_TABLE(IPE),JE_GLB_TABLE(IPE)
                DO IGLB=IS_GLB_TABLE(IPE),IE_GLB_TABLE(IPE)
                    KNT = KNT + 1
                    ARRX(KNT) = ARRG(IGLB,JGLB)
                END DO
            END DO
!        
            CALL MPI_SEND(ARRX, KNT, MPI_INTEGER, IPE, IPE, MPI_COMM_COMP, ISEND)
        END DO
!----------------------------------------------------------------------------  
! ALL OTHER PEs RECEIVE THEIR PIECE FROM PE0 AND THEN FILL THEIR LOCAL ARRAY.
!---------------------------------------------------------------------------- 
    ELSE
        NUMVALS = (IE_GLB_TABLE(MYPE) - IS_GLB_TABLE(MYPE) + 1)                                   &
    &           * (JE_GLB_TABLE(MYPE) - JS_GLB_TABLE(MYPE) + 1)
! 
        CALL MPI_RECV(ARRX, NUMVALS, MPI_INTEGER, 0, MYPE, MPI_COMM_COMP, ISTAT, IRECV)
!    
        KNT = 0
!
        DO J=MY_JS_LOC,MY_JE_LOC
            DO I=MY_IS_LOC,MY_IE_LOC
                KNT = KNT + 1
                ARRL(I,J) = ARRX(KNT)
            END DO
        END DO
!    
    END IF
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!
    RETURN
!
    END SUBROUTINE IDSTRB

    SUBROUTINE READ_RESTRT
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_RESTRT
!>
!> SUBPROGRAM: READ_RESTRT - READ AND DISTRIBUTE RESTRT FILE
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 98-10-22
!>
!> ABSTRACT:
!> READ_RESTRT READS IN QUANTITIES FROM THE NFC FILE OR THE RESTRT FILE AND DISTRIBUTES THEM TO THE 
!> OTHER NODES/PES
!>
!> PROGRAM HISTORY LOG:
!v 97-??-??  MEYS       - ORIGINATOR
!> 97-08-??  BLACK      - REWROTE FOR BENCHMARK
!> 98-??-??  TUCCILLO   - MODIFIED FOR SINGLE OR DOUBLE PRECISION
!> 98-10-23  BLACK      - MODIFIED FOR NEWEST RESTART FILE
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLD
!>              ACMCLH 
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              OUTFIL
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PRFHLD
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : DSTRB
!>              IDSTRB
!>              MPI_BARRIER
!>              MPI_BCAST
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE OUTFIL
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PRFHLD 
    USE PVRBLS
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: D00    =    0.0
    REAL   (KIND=R4KIND), PARAMETER :: D50    =     .50
    REAL   (KIND=R4KIND), PARAMETER :: H1     =    1.0
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CM1    = 2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2    =    4.9283
    REAL   (KIND=R4KIND), PARAMETER :: CM3    =   23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS    =    0.622
    REAL   (KIND=R4KIND), PARAMETER :: Q2INI  =     .50
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2  =    2.E-2
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    2.E-12 
    REAL   (KIND=R4KIND), PARAMETER :: EPSWET =    0.0
    REAL   (KIND=R4KIND), PARAMETER :: Z0LAND =     .10
    REAL   (KIND=R4KIND), PARAMETER :: Z0SEA  =     .001 
    REAL   (KIND=R4KIND), PARAMETER :: FCM    =     .00001 
    REAL   (KIND=R4KIND), PARAMETER :: DTR    =    0.1745329E-1
    REAL   (KIND=R4KIND), PARAMETER :: H360   =  360.0
    REAL   (KIND=R4KIND), PARAMETER :: H1905  =  190.5
    REAL   (KIND=R4KIND), PARAMETER :: H105   =  105.0
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JMP1 = JM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMT  =  2 * IM - 1
!------------------  
! DECLARE VARIABLES
!------------------ 
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUNB
!
    CHARACTER(32)                                                                               ::&
    & LABEL
!
    CHARACTER(40)                                                                               ::&
    & CONTRL  , FILALL  , FILMST  , FILTMP  , FILTKE  , FILUNV  , FILCLD  , FILRAD  , FILSFC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PSLP
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM, NSOIL)                                              ::&
    & TEMPSOIL
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDATB   
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
#ifdef DP_REAL
!
    LOGICAL(KIND=L8KIND)                                                                        ::&
    & RUNX    , FIRSTX
!
    INTEGER(KIND=I8KIND), DIMENSION(3)                                                          ::&
    & IDATX
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & IHRSTX  , NTSDX   , IOUTX   , NSHDEX
!
    INTEGER(KIND=I8KIND), DIMENSION(IM, JM)                                                     ::&
    & ITEMPX  , ITEMP2X
!
#endif
!
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , N       , IER     , IRTN    , IYR     , IMNTH   , IDAY    ,   &
    & LBM2    , IHOUR 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART  , PDOMG   , RESOMG  , DUMMY   , TEMP9   , TEMP10  , TEMP11 
!------------------------------------ 
! TSTART IS THE INITIAL TIME IN HOURS
!------------------------------------ 
    TSTART = NSTART * DT / 3600.
!----------------------------------------- 
! READ INITIAL CONDITIONS OR RESTART FILE.
! FIRST, THE .NOT. RESTART FILE CASE.
!----------------------------------------- 
    NFCST = 13
!
    OPEN(UNIT=NFCST, FILE='INIT.file', STATUS='OLD', FORM='UNFORMATTED')
!
    IF (.NOT. RESTRT) THEN
        IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!   
            READ(NFCST) RUNX, IDATX, IHRSTX, NTSDX
            RUN   = RUNX
            IDAT  = IDATX
            IHRST = IHRSTX
            NTSD  = NTSDX
!
#else
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD
!
#endif
!           
            IF (NTSD == 1 ) NTSD = 0
        ELSE
            READ(NFCST) DUMMY
        END IF
!    
        CALL MPI_BCAST  (RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BARRIER(                            MPI_COMM_COMP, IRTN)
!-------------- 
! DISTRIBUTE PD
!-------------- 
        IF (MYPE == 0) THEN
            READ(NFCST)TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, PD, 1, 1, 1)
!--------------- 
! DISTRIBUTE RES
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, RES, 1, 1, 1)
!---------------
! DISTRIBUTE FIS
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, FIS, 1, 1, 1)
!------------- 
! DISTRIBUTE U
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, U, 1, LM, K)
        END DO
!------------- 
! DISTRIBUTE V
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, V, 1, LM, K)
        END DO
!------------- 
! DISTRIBUTE T
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, T, 1, LM, K)
        END DO

!------------- 
! DISTRIBUTE Q
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, Q, 1, LM, K)
        END DO
!-------------- 
! DISTRIBUTE SI
!--------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, SI, 1, 1, 1)
!---------------
! DISTRIBUTE SNO
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, SNO, 1, 1, 1)
!---------------
! DISTRIBUTE SMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SMC, NSOIL, NSOIL, NSOIL)
!---------------
! DISTRIBUTE CMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, CMC, 1, 1, 1)
!---------------
! DISTRIBUTE STC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST)TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, STC, NSOIL, NSOIL, NSOIL)
!----------------
! DISTRIBUTE SH2O
!----------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SH2O, NSOIL, NSOIL, NSOIL)
!------------------
! DISTRIBUTE ALBEDO
!------------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, ALBEDO, 1, 1, 1)
!
        IYR   = IDAT(3) - 1900
        IMNTH = IDAT(1)
        IDAY  = IDAT(2)
!
        IF (MYPE == 0) WRITE(LIST,*) 'INIT: READ INITIAL CONDITION FILE'
!-------------------------------
! SECOND, THE RESTART FILE CASE.
!-------------------------------    
    ELSE
        IF (MYPE == 0) WRITE(LIST,*)'INIT:  READ RESTART FILE'
!
        IF (MYPE == 0) THEN
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR
!
            IF (NTSD == 1) NTSD = 0
!
            READ(NFCST) PDOMG, RESOMG
        END IF
!    
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!------------------ 
! DISTRIBUTE OMGALF
!------------------
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
!
            CALL DSTRB(TEMP1, OMGALF, 1, LM, K)
!
        END DO
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ  ',LABEL
!    
        IF (MYPE == 0) THEN
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR, FIRST, IOUT, NSHDE
!
            IF (NTSD == 1) NTSD = 0
        END IF
!    
        FIRST = .TRUE. 
!    
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(FIRST  , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IOUT   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NSHDE  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3
        END IF
!    
        CALL DSTRB(TEMP1,PD ,1,1,1)
        CALL DSTRB(TEMP2,RES,1,1,1)
        CALL DSTRB(TEMP3,FIS,1,1,1)
!
        LBM2 = LB * LM * 2
!
        IF (MYPE == 0) THEN
            IF (NINT(TSTART) == 0) THEN
                READ(NFCST) PDB, TB, QB, UB, VB
            ELSE
                READ(NFCST) PDB, TB, QB, UB, VB, Q2B, CWMB
            END IF
        END IF
!    
        CALL MPI_BCAST(PDB(1,1)  , LB  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(PDB(1,2)  , LB  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(TB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(QB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(UB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(VB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!    
        IF (NINT(TSTART) > 0) THEN
            CALL MPI_BCAST(Q2B (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
            CALL MPI_BCAST(CWMB(1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        END IF
!------------------ 
    print*, "read_restrt jump"

    END IF
!--------------------------------------------------- 
! DONE READING INITIAL CONDITIONS OR A RESTART FILE.
!---------------------------------------------------
!
!------------------------------ 
! END OF SUBROUTINE READ_RESTRT
!------------------------------ 
    IF (MYPE == 0) THEN
        WRITE(LIST,*) 'INIT:  EXIT READ_RESTRT'
        WRITE(LIST,*) ' '
    END IF
!
    RETURN
!
    END SUBROUTINE READ_RESTRT

    SUBROUTINE HDIFFS
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE HDIFFS
!>
!> SUBPROGRAM: HDIFFS - HORIZONTAL DIFFUSION
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-11-17
!>
!> ABSTRACT:
!> HDIFF CALCULATES THE CONTRIBUTION OF THE HORIZONTAL DIFFUSION TO THE TENDENCIES OF TEMPERATURE, 
!> SPECIFIC HUMIDITY, WIND COMPONENTS AND TURBULENT KINETIC ENERGY AND THEN UPDATES THOSE VARIABLES.
!> A SECOND-ORDER NONLINEAR SCHEME SIMILAR TO SMAGORINSKYS IS USED WHERE THE DIFFUSION COEFFICIENT 
!> IS A FUNCTION OF THE DEFORMATION FIELD AND OF THE TURBULENT KINETIC ENERGY.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC                           - ORIGINATOR
!> 95-03-25  BLACK                            - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-28  BLACK                            - ADDED EXTERNAL EDGE
!> 98-10-30  BLACK                            - MODIFIED FOR DISTRIBUTED MEMORY
!> 13-09-09  MESINGER, SUEIRO, GOMES, MORELLI - CODE CHANGED TO ACCOUNT FOR SLOPES 
!>                                              (LINES MARKED BY CFM AND CGCM)
!>                                              CHANGES DUE TO DIFFUSION LIMITED NOT TO CHANGE THE 
!>                                              SIGN OF THE LAPLACIAN, IN ORDER TO PREVENT 
!>                                              INSTABILITY DUE TO LARGE VALUES OF DEF
!> 18-01-15  LUCCI                            - MODERNIZATION OF THE CODE, INCLUDING:
!>                                              * F77 TO F90/F95
!>                                              * INDENTATION & UNIFORMIZATION CODE
!>                                              * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                                              * DOCUMENTATION WITH DOXYGEN
!>                                              * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CTLBLK
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS	
!>              PVRBLS
!>              SLOPES
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : ZERO2
!>--------------------------------------------------------------------------------------------------
! M CALCULATON OF HDIFF V AT POINTS THAT HAVE A NEIGHBORING "BLOCKED" V
! SWITCHED ON (LOOPS 410 AND 420), USING VELOCITIES AT POINTS ON SLOPES, BUT ONLY HALF OF THE 
! DIFFUSION COEFFICIENT (NOTE FIG. 2 OF THE "UPGRADED ETA" PAPER) 
! FM AND SANDRA MORELLI, JUNE-JULY 2013
!--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE SLOPES
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: DEFC  =  8.0
    REAL   (KIND=R4KIND), PARAMETER :: DEFM  = 32.0
    REAL   (KIND=R4KIND), PARAMETER :: SCQ2  = 50.0
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2 =  0.2
    REAL   (KIND=R4KIND), PARAMETER :: FCDIF =  1.0
    REAL   (KIND=R4KIND), PARAMETER :: RFCP  =   .25 / 1004.6
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 1
    INTEGER(KIND=I4KIND), PARAMETER :: JAMD  = (JAM * 2 - 10) * 3
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SECOND  , HEAT    , STTDF
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & Q2L     , UT      ,                                                                         &
    & HKNE    , HKSE    ,                                                                         &
    & VKNE    , VKSE    ,                                                                         &
    & HMASK   , HMSKL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & TNE     , TSE     ,                                                                         &
    & QNE     , QSE     ,                                                                         &
    & Q2NE    , Q2SE    ,                                                                         &
    & UNE     , USE     ,                                                                         &
    & VNE     , VSE     ,                                                                         &
    & TDIF    , QDIF    ,                                                                         &
    & UDIF    , VDIF    ,                                                                         &
    & Q2DIF   ,                                                                                   &
    & DEF     , CKE 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LUL     , I       , J       , K       , IDEFMAX , JDEFMAX , LDEFMAX , MYPEDEFMAX        ,   &
    & NNTMP
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DEFS    , DEFTK   , DEFSK   , DH4     , DHM     , UTK     , VTK     , DCMD    , CKET    ,   &
    & TFPAV   , QFPAV   , UFPAV   , VFPAV   , VARTMP1 , VARTMP2
!------------------------------------------------------------------- 
! DIFFUSING Q2 AT GROUND LEVEL DOESNT MATTER, USTAR2 IS RECALCULATED
!------------------------------------------------------------------- 
    SECOND = .TRUE. 
    HEAT   = .TRUE. 
    LUL    = UL(1)
!-------------------------------------------------- 
! M FILL THE V POINTS AT SLOPES WITH THE WIND ABOVE
!-------------------------------------------------- 
    DO 205 K=2,LM
        DO 205 J=MYJS_P1,MYJE_P1
            DO 205 I=MYIS_P1,MYIE_P1
                IF (VTMS(I,J,K) == 1) THEN
                    U(I,J,K) = U(I,J,K-1)
                    V(I,J,K) = V(I,J,K-1)
                END IF
205 END DO
!------------------------------- 
! MAIN VERTICAL INTEGRATION LOOP 
!------------------------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (CKE      , DEF     , DEFSK   , DEFTK   , HKNE    , HKSE    , HMSKL   , Q2DIF   ,   &
!$omp          Q2L      , Q2NE    , Q2SE    , QDIF    , QNE     , QSE     , TDIF    , TNE     ,   &
!$omp          TSE      , UDIF    , UNE     , USE     , UTK     , VDIF    , VKNE    , VKSE    ,   &
!$omp          VNE      , VSE     , VTK     )
!
    DO 500 K=1,LM
!
        CALL ZERO2(DEF)
        CALL ZERO2(Q2NE)
        CALL ZERO2(Q2SE)
        CALL ZERO2(QNE)
        CALL ZERO2(QSE)
        CALL ZERO2(TNE)
        CALL ZERO2(TSE)
        CALL ZERO2(UNE)
        CALL ZERO2(USE)
        CALL ZERO2(VSE)
        CALL ZERO2(VNE)
        CALL ZERO2(CKE)
        CALL ZERO2(TDIF)
        CALL ZERO2(QDIF)
        CALL ZERO2(UDIF)
        CALL ZERO2(VDIF)
        CALL ZERO2(Q2DIF)
!
        DEFS = -1
!
        DO 210 J=MYJS_P1,MYJE_P1
            DO 210 I=MYIS_P1,MYIE_P1
                Q2L(I,J) = AMAX1(Q2(I,J,K),EPSQ2)
    210 END DO
!------------- 
! DEFORMATIONS
!-------------
        DO 220 J=MYJS1_P1,MYJE1_P1
            DO 220 I=MYIS_P1,MYIE1_P1
!            
                DEFTK = U(I+IHE(J),J  ,K) - U(I+IHW(J),J  ,K)                                     &
    &                 - V(I       ,J+1,K) + V(I       ,J-1,K)
!
                DEFSK = U(I       ,J+1,K) - U(I       ,J-1,K)                                     &
    &                 + V(I+IHE(J),J  ,K) - V(I+IHW(J),J  ,K)
!
                DEF(I,J) = DEFTK * DEFTK + DEFSK * DEFSK
                DEF(I,J) = SQRT(DEF(I,J) + DEF(I,J)) * HBM2(I,J)
!
                IF (DEF(I,J) > DEFS) THEN
                    DEFS       = DEF(I,J)
                    IDEFMAX    = I
                    JDEFMAX    = J
                    LDEFMAX    = K
                    MYPEDEFMAX = MYPE
                END IF

!--------------------------------------------------------------------------------------------------
! MAXIMAZING DEF SO AS NOT TO BE LESS THAN DEFC, THE LINE BELOW, THAT SOMEONE UNCOMMENTED, LED TO 
! THE CRASH OF A 1 KM RUN AT CPTEC.
! COMMENTING THE LINE BACK, AS IT WAS SOME YEARS AGO, REMOVED THE PROBLEM. APPARENTLY, THE LINE LED
! TO THE DIFFUSION COEFFICIENT GREATER THAT IT IS ALLOWED FOR STABILITY.
!
! DEF(I,J)=AMAX1(DEF(I,J),DEFC)
! DEF(I,J)=AMIN1(DEF(I,J),DEFM)
! DEF(I,J)=DEF(I,J)*HMSKL(I,J)
!--------------------------------------------------------------------------------------------------
    220 END DO
!-------------------------------- 
! T, Q, Q2 DIAGONAL CONTRIBUTIONS
!--------------------------------
        DO 250 J=MYJS_P1,MYJE1_P1
            DO 250 I=MYIS_P1,MYIE1_P1
                HKNE(I,J) = (DEF(I,J) + DEF(I+IHE(J),J+1)) * HTM(I,J,K) * HTM(I+IHE(J),J+1,K)
!
                TNE (I,J) = (T (I+IHE(J),J+1,K) - T (I,J,K)) * HKNE(I,J)
                QNE (I,J) = (Q (I+IHE(J),J+1,K) - Q (I,J,K)) * HKNE(I,J)
                Q2NE(I,J) = (Q2(I+IHE(J),J+1,K) - Q2(I,J,K)) * HKNE(I,J)
    250 END DO
!    
        DO 260 J=MYJS1_P1,MYJE_P1
            DO 260 I=MYIS_P1,MYIE1_P1
                HKSE(I,J) = (DEF(I+IHE(J),J-1)   + DEF(I,J))  * HTM(I+IHE(J),J-1,K) * HTM(I,J,K)
!
                TSE (I,J) = ( T (I+IHE(J),J-1,K) - T (I,J,K)) * HKSE(I,J)
                QSE (I,J) = ( Q (I+IHE(J),J-1,K) - Q (I,J,K)) * HKSE(I,J)
                Q2SE(I,J) = ( Q2(I+IHE(J),J-1,K) - Q2(I,J,K)) * HKSE(I,J)
    260 END DO
!
        DO 270 J=MYJS1,MYJE1
            DO 270 I=MYIS1,MYIE
                TDIF (I,J) = (TNE (I,J) - TNE (I+IHW(J),J-1)                                      &
    &                      +  TSE (I,J) - TSE (I+IHW(J),J+1))                                     &
    &                      *  HDAC(I,J)
!
                QDIF (I,J) = (QNE (I,J) - QNE (I+IHW(J),J-1)                                      &
    &                      +  QSE (I,J) - QSE (I+IHW(J),J+1))                                     &
    &                      *  HDAC(I,J) * FCDIF
!
                Q2DIF(I,J) = (Q2NE(I,J) - Q2NE(I+IHW(J),J-1)                                      &
    &                      +  Q2SE(I,J) - Q2SE(I+IHW(J),J+1))                                     &
    &                      *  HDAC(I,J)
    270 END DO
!--------------------- 
! 2-ND ORDER DIFFUSION 
!--------------------- 
        IF (SECOND) THEN
            DO 280 J=MYJS2,MYJE2
                DO 280 I=MYIS1,MYIE1 
!--------------------------------------------------------------------------------------------------
! M DO NOT PERMIT SIGN CHANGE DUE TO HORIZONTAL DIFFUSION. 
! THIS WILL PREVENT INSTABILITY DUE TO LARGE DEF AS WELL.
!--------------------------------------------------------------------------------------------------
                    TFPAV = .25 * (T(I+IHE(J),J+1,K) + T(I+IHW(J),J+1,K)                          &
    &                     +        T(I+IHW(J),J-1,K) + T(I+IHE(J),J-1,K))
!
                    IF (ABS(TDIF(I,J)) > ABS(TFPAV-T(I,J,K))) THEN
                        TDIF(I,J) = TFPAV-T(I,J,K)
                    END IF
!                
                    T(I,J,K) = T(I,J,K) + TDIF(I,J)
!                
                    QFPAV = .25 * (Q(I+IHE(J),J+1,K) + Q(I+IHW(J),J+1,K)                          &
    &                     +        Q(I+IHW(J),J-1,K) + Q(I+IHE(J),J-1,K))
!
                    IF (ABS(QDIF(I,J)) > ABS(QFPAV-Q(I,J,K))) THEN
                        QDIF(I,J) = QFPAV - Q(I,J,K)
                    END IF
!                
                    Q(I,J,K) = Q(I,J,K) + QDIF(I,J)
!                
        280 END DO
!
            IF (K /= LM) THEN
                DO 290 J=MYJS2,MYJE2
                    DO 290 I=MYIS1,MYIE1
                        Q2(I,J,K) = AMAX1(Q2(I,J,K),EPSQ2)
                290 END DO
            END IF
!        
            GOTO 360
!
        END IF
!----------------------------------  
! 4-TH ORDER DIAGONAL CONTRIBUTIONS 
!---------------------------------- 
        DO 310 J=MYJS,MYJE1
            DO 310 I=MYIS,MYIE1
                TNE (I,J) = (TDIF (I+IHE(J),J+1) - TDIF (I,J)) * HKNE(I,J)
                QNE (I,J) = (QDIF (I+IHE(J),J+1) - QDIF (I,J)) * HKNE(I,J)
                Q2NE(I,J) = (Q2DIF(I+IHE(J),J+1) - Q2DIF(I,J)) * HKNE(I,J)
    310 END DO
!    
        DO 320 J=MYJS1,MYJE
            DO 320 I=MYIS,MYIE1
                TSE (I,J) = (TDIF (I+IHE(J),J-1) - TDIF (I,J)) * HKSE(I,J)
                QSE (I,J) = (QDIF (I+IHE(J),J-1) - QDIF (I,J)) * HKSE(I,J)
                Q2SE(I,J) = (Q2DIF(I+IHE(J),J-1) - Q2DIF(I,J)) * HKSE(I,J)
    320 END DO
!
        DO 330 J=MYJS2,MYJE2
            DO 330 I=MYIS1,MYIE1
                T(I,J,K) = T(I,J,K)-(TNE (I,J) - TNE (I+IHW(J),J-1)                               &
    &                    +           TSE (I,J) - TSE (I+IHW(J),J+1))                              &
    &                    *           HDAC(I,J)
!
                Q(I,J,K) = Q(I,J,K) - (QNE (I,J) - QNE (I+IHW(J),J-1)                             &
    &                    +             QSE (I,J) - QSE (I+IHW(J),J+1))                            &
    &                    *             HDAC(I,J) * FCDIF
    330 END DO
!
        IF (K /= LM) THEN
            DO 340 J=MYJS2,MYJE2
                DO 340 I=MYIS1,MYIE1
                    Q2(I,J,K) = Q2(I,J,K) - (Q2NE(I,J) - Q2NE(I+IHW(J),J-1)                       &
    &                         +              Q2SE(I,J) - Q2SE(I+IHW(J),J+1))                      &
    &                         *              HDAC(I,J) * HTM(I,J,K+1)
        340 END DO
        END IF
!----------------------------  
! U,V, DIAGONAL CONTRIBUTIONS
!----------------------------
    360 DO 410 J=MYJS_P1,MYJE1_P1
        DO 410 I=MYIS_P1,MYIE1_P1
            VARTMP1=VTM(I+IVE(J),J+1,K)
            VARTMP2=VTMS(I+IVE(J),J+1,K)
            VKNE(I,J) = (DEF(I+IVE(J),J) + DEF(I,J+1))                                            &
    &                 * MAX(VARTMP1, VARTMP2)
            UNE(I,J)  = (U(I+IVE(J),J+1,K) - U(I,J,K)) * VKNE(I,J)
            VNE(I,J)  = (V(I+IVE(J),J+1,K) - V(I,J,K)) * VKNE(I,J)
    410 END DO
!    
        DO 420 J=MYJS1_P1,MYJE_P1
            DO 420 I=MYIS_P1,MYIE1_P1
                VARTMP1=VTM(I+IVE(J),J-1,K)
                VARTMP2=VTMS(I+IVE(J),J-1,K)
                VKSE(I,J) = (DEF(I,J-1) + DEF(I+IVE(J),J))                                        &
    &                      * MAX(VARTMP1, VARTMP2)
!
                USE(I,J)  = (U(I+IVE(J),J-1,K) - U(I,J,K)) * VKSE(I,J)
                VSE(I,J)  = (V(I+IVE(J),J-1,K) - V(I,J,K)) * VKSE(I,J)
    420 END DO
!
        DO 430 J=MYJS1,MYJE1
            DO 430 I=MYIS,MYIE1
                UDIF(I,J) =  (UNE(I,J) - UNE(I+IVW(J),J-1)                                        &
    &                     +   USE(I,J) - USE(I+IVW(J),J+1))                                       &
    &                     * HDACV(I,J)
!
                VDIF(I,J) =  (VNE(I,J) - VNE(I+IVW(J),J-1)                                        &
    &                     +   VSE(I,J) - VSE(I+IVW(J),J+1))                                       &
    &                     * HDACV(I,J)
    430 END DO
!---------------------
! 2-ND ORDER DIFFUSION
!--------------------- 
        IF (SECOND) THEN
            DO 440 J=MYJS2,MYJE2
                DO 440 I=MYIS1,MYIE1
!--------------------------------------------------------------------------------------------------
! M DO NOT PERMIT SIGN CHANGE DUE TO HORIZONTAL DIFFUSION. 
! THIS WILL PREVENT INSTABILITY DUE TO LARGE DEF AS WELL.
!--------------------------------------------------------------------------------------------------
                    UFPAV = .25 * (U(I+IVE(J),J+1,K) + U(I+IVW(J),J+1,K)                          &
    &                     +        U(I+IVW(J),J-1,K) + U(I+IVE(J),J-1,K))
!
                    IF (ABS(UDIF(I,J)) > ABS(UFPAV-U(I,J,K))) THEN
                        UDIF(I,J) = UFPAV-U(I,J,K)
                    END IF
!
                    VFPAV = .25 * (V(I+IVE(J),J+1,K) + V(I+IVW(J),J+1,K)                          &
    &                     +        V(I+IVW(J),J-1,K) + V(I+IVE(J),J-1,K))
!
                    IF (ABS(VDIF(I,J)) > ABS(VFPAV-V(I,J,K))) THEN
                        VDIF(I,J) = VFPAV-V(I,J,K)
                    END IF
!                
                    UTK   = U(I,J,K)
                    VTK   = V(I,J,K)
!
                    NNTMP = VTM(I+IVW(J),J+1,K) * VTM(I+IVE(J),J+1,K)                             &
    &                     * VTM(I+IVW(J),J-1,K) * VTM(I+IVE(J),J-1,K)
!
                    DCMD  = NNTMP + 0.5 * MOD(NNTMP+1,2)
!
                    U(I,J,K) = U(I,J,K) + UDIF(I,J) * VTM(I,J,K) * DCMD
                    V(I,J,K) = V(I,J,K) + VDIF(I,J) * VTM(I,J,K) * DCMD
!
                    CKE(I,J) = 0.5 * (U(I,J,K) * U(I,J,K) - UTK * UTK                             &
    &                        +        V(I,J,K) * V(I,J,K) - VTK * VTK)
!----------------------------------------------------------------------------------
! LET INDIVIDUAL CKE BE POSITIVE, BUT NOT THE FOUR POINT AVERAGE USED TO INCREASE T
! IF (CKE(I,J).GT.0) THEN
!     CKE(I,J)=0.
! END IF
!----------------------------------------------------------------------------------                
        440 END DO
!
        ELSE
!---------------------------------- 
! 4-TH ORDER DIAGONAL CONTRIBUTIONS
!----------------------------------  
            DO 450 J=MYJS,MYJE1
                DO 450 I=MYIS,MYIE1
                    UNE(I,J) = (UDIF(I+IVE(J),J+1) - UDIF(I,J)) * VKNE(I,J)
                    VNE(I,J) = (VDIF(I+IVE(J),J+1) - VDIF(I,J)) * VKNE(I,J)
        450 END DO
!        
            DO 460 J=MYJS1,MYJE
                DO 460 I=MYIS,MYIE1
                    USE(I,J) = (UDIF(I+IVE(J),J-1) - UDIF(I,J)) * VKSE(I,J)
                    VSE(I,J) = (VDIF(I+IVE(J),J-1) - VDIF(I,J)) * VKSE(I,J)
        460 END DO
!
            DO 470 J=MYJS2,MYJE2
                DO 470 I=MYIS1,MYIE1
                    UTK = U(I,J,K)
                    VTK = V(I,J,K)
!
                    U(I,J,K) = U(I,J,K) - (UNE(I,J) - UNE(I+IVW(J),J-1)                           &
    &                        +             USE(I,J) - USE(I+IVW(J),J+1))                          &
    &                        *           HDACV(I,J)
!
                    V(I,J,K) = V(I,J,K) - (VNE(I,J) - VNE(I+IVW(J),J-1)                           &
    &                        +             VSE(I,J) - VSE(I+IVW(J),J+1))                          &
    &                        *           HDACV(I,J)
!
                    CKE(I,J) = 0.5 * (U(I,J,K) * U(I,J,K) - UTK * UTK                             &
    &                        +        V(I,J,K) * V(I,J,K) - VTK * VTK)
        470 END DO
        END IF
!
        IF (HEAT) THEN
            DO 480 J=MYJS2,MYJE2
                DO 480 I=MYIS1,MYIE1
                    CKET = CKE(I+IHE(J),J) + CKE(I,J+1) + CKE(I+IHW(J),J) + CKE(I,J-1)
                    IF (CKET > 0.) CKET = 0.
                    T(I,J,K) = -RFCP * CKET * HBM2(I,J) + T(I,J,K)
        480 END DO
        END IF
!---------------------------------------------- 
! M FILL THE V POINTS AT SLOPES BACK WITH ZEROS
!---------------------------------------------- 
        IF (K > 1) THEN
            DO 485 J=MYJS_P1,MYJE_P1
                DO 485 I=MYIS_P1,MYIE_P1
                    IF (VTMS(I,J,K) == 1) THEN
                        U(I,J,K) = 0.
                        V(I,J,K) = 0.
                    END IF
        485 END DO
        END IF
!
500 END DO
!
!
    RETURN
!
    END SUBROUTINE HDIFFS

    SUBROUTINE VADZ
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VADZ
!>
!> SUBROUTINE: VADZ - VERTICAL ADVECTION OF HEIGHT
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-11-17
!>
!> ABSTRACT:
!> VADV CALCULATES THE CONTRIBUTION OF THE VERTICAL ADVECTION OF HEIGHT IN ORDER TO COMPUTE 
!> W = DZ / DT DIAGNOSTICALLY
!>
!> PROGRAM HISTORY LOG:
!> 93-11-17  JANJIC     - ORIGINATOR
!> 00-01-04  BLACK      - DISTRIBUTED MEMORY AND THREADS
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : -----            
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 0
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PRET    , TTB     , ALP1    , FNE     , FSE     , ETADTL
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & G       , RG      , RDT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K    

    REAL   (KIND=R4KIND)                                                                        ::&
    & ZETA    , DTLRG   , ALP1P   , DZ      , TTAL
!
    G   = 9.8
    RG  = 1. / 9.8
    RDT = 1. / DT
!
!$omp parallel do 
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            W(I,J,LM+1) = 0.
            Z(I,J,LM+1) = 0.
            IF (SIGMA) Z(I,J,LM+1) = FIS(I,J) * RG
            ALP1(I,J) = ALOG(PINT(I,J,LM+1))
        END DO
    END DO
!
    DO 50 K=LM,1,-1
        ZETA  =  DFL(K) * RG
        DTLRG = DETA(K) * RG
!
!$omp parallel do 
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                ALP1P = ALOG(PINT(I,J,K))
                DZ = (Q(I,J,K) * 0.608 - CWM(I,J,K) + 1.) * T(I,J,K) * (ALP1(I,J) - ALP1P)        &
    &              *  R / (DWDT(I,J,K) * G)
!
                    Z(I,J,K) =   (Z(I,J,K+1) + DZ-ZETA) * HTM(I,J,K) + ZETA
                PDWDT(I,J,K) = DWDT(I,J,K)
                 DWDT(I,J,K) =    W(I,J,K)
                    W(I,J,K) = (DZ - RTOP(I,J,K) * PDSLO(I,J) * DTLRG) * HTM(I,J,K)               &
    &                        * HBM2(I,J) + W(I,J,K+1)
!
                 ALP1(I,J)   = ALP1P
            END DO
        END DO
!
 50 END DO
!
    DO K=1,LM
!
!$omp parallel do 
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                Z(I,J,K) = (Z(I,J,K) + Z(I,J,K+1)) * 0.5
                W(I,J,K) = (W(I,J,K) + W(I,J,K+1)) * HTM(I,J,K) * HBM2(I,J) * 0.5 * RDT
            END DO
        END DO
    END DO
!
!$omp parallel do 
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            TTB(I,J) = 0.
        END DO
    END DO
!
    DO K=1,LM-1
!
!$omp parallel do 
!
        DO J=MYJS2,MYJE2
            DO I=MYIS1,MYIE1
                TTAL     = (Z(I,J,K+1) - Z(I,J,K)) * ETADT(I,J,K) * 0.5
                W(I,J,K) = (TTAL+TTB(I,J)) * RDETA(K) + W(I,J,K)
                TTB(I,J) = TTAL
            END DO
        END DO
    END DO
!
!$omp parallel do 
!
    DO J=MYJS2,MYJE2
        DO I=MYIS1,MYIE1
            W(I,J,LM) = TTB(I,J) * RDETA(LM) + W(I,J,LM)
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE VADZ

    SUBROUTINE HZADV_LM1
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE HZADV_LM1
!>
!> SUBPROGRAM: HZADV_LM1 - HORIZONTAL ADVECTION
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-10-28
!>
!> ABSTRACT:
!> HZADV CALCULATES THE CONTRIBUTION OF THE HORIZONTAL ADVECTION TO THE TENDENCIES OF TEMPERATURE,
!> WIND COMPONENTS, AND TURBULENT KINETIC ENERGY AND THEN UPDATES THOSE VARIABLES.
!> THE JANJIC ADVECTION SCHEME FOR THE ARAKAWA E GRID IS USED FOR ALL VARIABLES INSIDE THE FIFTH ROW
!> AN UPSTREAM SCHEME IS USED ON ALL VARIABLES IN THE THIRD, FOURTH, AND FIFTH OUTERMOST ROWS. 
!> A MODIFIED EULER-BACKWARD TIME SCHEME (HEUN) IS USED. UNDERGROUND WINDS MUST BE EQUAL TO ZERO 
!> SINCE THEY ARE USED EXPLICITLY WITHOUT THE VELOCITY MASK IN THE FLUX CALCULATIONS.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!> 
!> USE MODULES: CLDWTR
!>              CONTIN 
!>              CTLBLK 
!>              DYNAM 
!>              F77KINDS  
!>              GLB_TABLE    
!>              INDX  
!>              LOOPS
!>              MAPPINGS 
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : ZERO2
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND), PARAMETER :: TLC  = 2. * 0.703972477
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IM1  = IM - 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JAMD = (JAM * 2 - 10) * 3
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & ITER2
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & HM      , VM      ,                                                                         &
    & RDPD    ,                                                                                   &
    & ADPDX   , ADPDY   ,                                                                         &
    & RDPDX   , RDPDY   ,                                                                         &
    & ADT     ,                                                                                   &
    & ADU     , ADV     ,                                                                         &
    & ADQ2M   , ADQ2L   ,                                                                         &
    & Q2MNS   , Q2LNS   ,                                                                         &
    & UDY     , VDX   
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DPDE    ,                                                                                   &
    & TEMPA   , TEMPB   ,                                                                         &
    & TST     ,                                                                                   &
    & UST     , VST     ,                                                                         &
    & Q2M     , Q2L     ,                                                                         &
    & TEW     , TNS     ,                                                                         &
    & Q2MEW   , Q2LEW 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & TNE     , TSE     ,                                                                         &
    & Q2MNE   , Q2MSE   ,                                                                         &
    & Q2LNE   , Q2LSE   ,                                                                         &
    & UEW     , UNS     ,                                                                         &
    & VEW     , VNS     ,                                                                         &
    & UNE     , USE     ,                                                                         &
    & VNE     , VSE     ,                                                                         &
    & FEW     , FNS     ,                                                                         &
    & FNE     , FSE   
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2 , LM)                              ::&
    & ADQ2HL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2 , LM+1)                            ::&
    & Q2ML
!
    REAL   (KIND=R4KIND), DIMENSION(JAMD)                                                       ::&
    & ARRAY0  , ARRAY1  , ARRAY2  , ARRAY3 
!
    INTEGER(KIND=R4KIND), DIMENSION(JAMD)                                                       ::&
    & KHHAS   , IHLAS   , JHLAS   , KVHAS   , IVLAS   , JVLAS   , ISPA    , ISQA
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & UPSTRM
!
    LOGICAL(KIND=L4KIND), DIMENSION(JAM)                                                        ::&
    & LJRA
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IEND    , I       , J       , K       , JAKONE  , JA      , IHL     , IHH     , JAKTWO  ,   &
    & IVL     , IVH     , JAK     , IX      , JX      , ISP     , ISQ     , IFP     , IFQ     ,   &
    & IPQ        
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TTA     , TTB     , PP      , QP      , F0      , F1     , F2       , F3
!
    INCLUDE "CHECKIN"
!-------------------------------------------- 
! FIGURE OUT IF WE ARE IN THE UPSTREAM REGION
!-------------------------------------------- 
    UPSTRM = .FALSE. 
!
    IF (MYPE <= INPES-1)        UPSTRM = .TRUE. 
    IF (MYPE >= NPES-INPES)     UPSTRM = .TRUE. 
    IF (MOD(MYPE,INPES) == 0)   UPSTRM = .TRUE. 
    IF (MOD(MYPE+1,INPES) == 0) UPSTRM = .TRUE. 
!
    JAKONE = 0
!
    DO 25 JA=1,JAM
        IHL = IHLA(JA)
        IHH = IHHA(JA)
        J   =  JRA(JA)
!
        LJRA(JA) = .FALSE. 
!    
        IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
            LJRA(JA) = .TRUE. 
            DO I=IHL,IHH
                IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                    JAKONE = JAKONE + 1
!
                    KHHAS(JAKONE) = JA
                    IHLAS(JAKONE) = I
                    JHLAS(JAKONE) = J
                END IF
            END DO
        END IF
!    
 25 END DO
!
    JAKTWO = 0
!
    DO 50 JA=1,JAM
        IVL = IVLA(JA)
        IVH = IVHA(JA)
        J   =  JRA(JA)
!    
        DO 50 I=IVL,IVH
            IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2                                 &
    &                                 .AND.                                                       &
    &           J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                JAKTWO = JAKTWO + 1
!
                KVHAS(JAKTWO) = JA
                IVLAS(JAKTWO) = I
                JVLAS(JAKTWO) = J
            END IF
 50 END DO
!
    DO 70 J=MYJS_P5,MYJE_P5
        DO 70 I=MYIS_P4,MYIE_P4
            Q2ML(I,J,1) = 0.
 70 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO 80 K=2,LM+1
        DO 80 J=MYJS_P5,MYJE_P5
            DO 80 I=MYIS_P4,MYIE_P4
                Q2ML(I,J,K) = Q2(I,J,K-1)
 80 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (ADPDX    , ADPDY   , ADQ     , ADQ2L   , ADQ2M   , ADT     , ADU     , ADV     ,   &
!$omp          ARRAY0   , ARRAY1  , ARRAY2  , ARRAY3  , DPDE    , F0      , F1      , F2      ,   &
!$omp          F3       , FEW     , FNE     , FNS     , FSE     , HM      , I       , IFP     ,   &
!$omp          IFQ      , IHH     , IHL     , IPQ     , ISP     , ISPA    , ISQ     , ISQA    ,   &
!$omp          ITER2    , IX      , IY      , J       , JA      , JAK     , K       , PP      ,   &
!$omp          Q2L      , Q2LEW   , Q2LNE   , Q2LNS   , Q2LSE   , Q2M     , Q2MEW   , Q2MNE   ,   &
!$omp          Q2MNS    , Q2MSE   , QEW     , QNE     , QNS     , QP      , QSE     , QST     ,   &
!$omp          RDPD     , RDPDX   , RDPDY   , TEMPA   , TEMPB   , TEW     , TNE     , TNS     ,   &
!$omp          TSE      , TST     , TTA     , TTB     , UDY     , UEW     , UNE     , UNS     ,   &
!$omp          USE      , UST     , VDX     , VEW     , VM      , VNE     , VNS     , VSE     ,   &
!$omp          VST      )
!
    DO 500 K=LM,1,-1
!
        CALL ZERO2(ADT)
        CALL ZERO2(ADU)
        CALL ZERO2(ADV)
        CALL ZERO2(ADQ2M)
        CALL ZERO2(ADQ2L)
        CALL ZERO2(DPDE)
        CALL ZERO2(FEW)
        CALL ZERO2(FNE)
        CALL ZERO2(FNS)
        CALL ZERO2(FSE)
        CALL ZERO2(Q2L)
        CALL ZERO2(Q2LEW)
        CALL ZERO2(Q2LNE)
        CALL ZERO2(Q2LSE)
        CALL ZERO2(Q2M)
        CALL ZERO2(Q2MEW)
        CALL ZERO2(Q2MNE)
        CALL ZERO2(Q2MSE)
        CALL ZERO2(RDPD)
        CALL ZERO2(TEMPA)
        CALL ZERO2(TEMPB)
        CALL ZERO2(TEW)
        CALL ZERO2(TNE)
        CALL ZERO2(TNS)
        CALL ZERO2(TSE)
        CALL ZERO2(TST)
        CALL ZERO2(UDY)
        CALL ZERO2(UEW)
        CALL ZERO2(UNE)
        CALL ZERO2(UNS)
        CALL ZERO2(USE)
        CALL ZERO2(UST)
        CALL ZERO2(VEW)
        CALL ZERO2(VNE)
        CALL ZERO2(VNS)
        CALL ZERO2(VSE)
        CALL ZERO2(VST)
        CALL ZERO2(VM)
!
        ITER2 = .FALSE. 
!
        DO J=MYJS_P4,MYJE_P4
            DO I=MYIS_P4,MYIE_P4
                Q2M(I,J) = Q2ML(I,J,K)
            END DO
        END DO
!    
        DO 110 J=MYJS_P5,MYJE_P5
            DO 110 I=MYIS_P4,MYIE_P4
                  HM(I,J) =  HTM(I,J,K) * HBM2(I,J)
                DPDE(I,J) = PDSL(I,J)   * DETA(K)
                RDPD(I,J) = 1. / DPDE(I,J)
                 UST(I,J) =    U(I,J,K  )
                 VST(I,J) =    V(I,J,K  )
                 TST(I,J) =    T(I,J,K  )
                 Q2L(I,J) = Q2ML(I,J,K+1)
    110 END DO
!
        DO 120 J=MYJS1_P4,MYJE1_P4
            DO 120 I=MYIS_P4,MYIE_P4
                   VM(I,J) = VTM(I,J,K) * VBM2(I,J)
                ADPDX(I,J) = DPDE(I+IVW(J),J  ) + DPDE(I+IVE(J),J  )
                ADPDY(I,J) = DPDE(I       ,J-1) + DPDE(I       ,J+1)
                RDPDX(I,J) = 1. / ADPDX(I,J)
                RDPDY(I,J) = 1. / ADPDY(I,J)
    120 END DO
!----------------------------------------------------------- 
! MASS FLUXES AND MASS POINTS ADVECTION COMPONENTS 
! 
! THE NS AND EW FLUXES IN THE FOLLOWING LOOP ARE ON V POINTS
!-----------------------------------------------------------
    125 DO 130 J=MYJS1_P4,MYJE1_P4
            DO 130 I=MYIS_P4,MYIE_P4
                  UDY(I,J) = UST(I,J) * DY
                  FEW(I,J) = UDY(I,J) * ADPDX(I,J)
                  TEW(I,J) = FEW(I,J) *  (TST(I+IVE(J),J  ) - TST(I+IVW(J),J  ))
                Q2MEW(I,J) = FEW(I,J) *  (Q2M(I+IVE(J),J  ) - Q2M(I+IVW(J),J  ))
                Q2LEW(I,J) = FEW(I,J) *  (Q2L(I+IVE(J),J  ) - Q2L(I+IVW(J),J  ))
                  VDX(I,J) = VST(I,J) *    DX(I       ,J  )
                  FNS(I,J) = VDX(I,J) * ADPDY(I       ,J  )
                  TNS(I,J) = FNS(I,J) *  (TST(I       ,J+1) - TST(I       ,J-1))
                Q2MNS(I,J) = FNS(I,J) *  (Q2M(I       ,J+1) - Q2M(I       ,J-1))
                Q2LNS(I,J) = FNS(I,J) *  (Q2L(I       ,J+1) - Q2L(I       ,J-1))
    130 END DO
!-------------------------------------------------------------------------------------- 
! DIAGONAL FLUXES AND DIAGONALLY AVERAGED WIND 
! 
! THE NE AND SE FLUXES ARE ON H POINTS (ACTUALLY JUST TO THE NE AND SE OF EACH H POINT)
!--------------------------------------------------------------------------------------
        DO 145 J=MYJS2_P4,MYJE2_P4
            DO 145 I=MYIS_P4,MYIE_P4
                TEMPA(I,J) = UDY(I,J) + VDX(I,J)
                TEMPB(I,J) = UDY(I,J) - VDX(I,J)
    145 END DO
!    
        DO 150 J=MYJS2_P4,MYJE2_P4
            DO 150 I=MYIS_P4,MYIE_P4
                  FNE(I,J) = (TEMPA(I+IHE(J),J) + TEMPA(I,J+1)) * (DPDE(I,J) + DPDE(I+IHE(J),J+1))
                  TNE(I,J) = FNE(I,J) * (TST(I+IHE(J),J+1) - TST(I,J))
                Q2MNE(I,J) = FNE(I,J) * (Q2M(I+IHE(J),J+1) - Q2M(I,J))
                Q2LNE(I,J) = FNE(I,J) * (Q2L(I+IHE(J),J+1) - Q2L(I,J))
                  FSE(I,J) = (TEMPB(I+IHE(J),J) + TEMPB(I,J-1)) * (DPDE(I,J) + DPDE(I+IHE(J),J-1))
                  TSE(I,J) = FSE(I,J) * (TST(I+IHE(J),J-1) - TST(I,J))
                Q2MSE(I,J) = FSE(I,J) * (Q2M(I+IHE(J),J-1) - Q2M(I,J))
                Q2LSE(I,J) = FSE(I,J) * (Q2L(I+IHE(J),J-1) - Q2L(I,J))
    150 END DO
!---------------------------------------------- 
! THERMODYNAMIC EQUATION AND MOISTURE 
!
! THE AD ARRAYS IN THE 170 LOOP ARE ON H POINTS
!----------------------------------------------
        DO 170 J=MYJS5_P2,MYJE5_P2
            DO 170 I=MYIS_P2,MYIE_P2
                  ADT(I,J) = (TEW(I+IHW(J),J  ) + TEW(I+IHE(J),J  )                               &
    &                      +  TNS(I       ,J-1) + TNS(I       ,J+1)                               &
    &                      +  TNE(I+IHW(J),J-1) + TNE(I       ,J  )                               &
    &                      +  TSE(I       ,J  ) + TSE(I+IHW(J),J+1))                              &
    &                      * RDPD(I       ,J  ) * FAD(I       ,J   )
!
                ADQ2M(I,J) = (Q2MEW(I+IHW(J),J  ) + Q2MEW(I+IHE(J),J  )                           &
    &                      +  Q2MNS(I       ,J-1) + Q2MNS(I       ,J+1)                           &
    &                      +  Q2MNE(I+IHW(J),J-1) + Q2MNE(I       ,J  )                           &
    &                      +  Q2MSE(I       ,J  ) + Q2MSE(I+IHW(J),J+1))                          &
    &                      *   RDPD(I       ,J  ) *   FAD(I       ,J  )
!
                ADQ2L(I,J) = (Q2LEW(I+IHW(J),J  ) + Q2LEW(I+IHE(J),J  )                           &
    &                      +  Q2LNS(I       ,J-1) + Q2LNS(I       ,J+1)                           &
    &                      +  Q2LNE(I+IHW(J),J-1) + Q2LNE(I       ,J  )                           &
    &                      +  Q2LSE(I       ,J  ) + Q2LSE(I+IHW(J),J+1))                          &
    &                      *   RDPD(I       ,J  ) *   FAD(I       ,J  )
    170 END DO
!---------------------------------- 
! UPSTREAM ADVECTION OF T, Q AND Q2 
!---------------------------------- 
        IF (UPSTRM) THEN
            DO 171 JAK=1,JAKONE
                JA = KHHAS(JAK)
                I =  IHLAS(JAK)
                J =  JHLAS(JAK)
!
                IX = I - MY_IS_GLB + 1
                JX = J - MY_JS_GLB + 1
!
                TTA = EMT(JA) * (UST(IX        ,JX-1) + UST(IX+IHW(JX),JX  )                      &
    &               +            UST(IX+IHE(JX),JX  ) + UST(IX        ,JX+1))
!
                TTB = ENT     * (VST(IX        ,JX-1) + VST(IX+IHW(JX),JX  )                      &
    &               +            VST(IX+IHE(JX),JX  ) + VST(IX        ,JX+1))
!
                PP = -TTA - TTB
                QP =  TTA - TTB
!            
                IF (PP < 0.) THEN
                    ISPA(JAK) = -1
                ELSE
                    ISPA(JAK) =  1
                END IF
!            
                IF (QP < 0.) THEN
                    ISQA(JAK) = -1
                ELSE
                    ISQA(JAK) =  1
                END IF
!            
                PP = ABS(PP)
                QP = ABS(QP)
!
                ARRAY3(JAK) = PP * QP
                ARRAY0(JAK) = ARRAY3(JAK) - PP - QP
                ARRAY1(JAK) = PP - ARRAY3(JAK)
                ARRAY2(JAK) = QP - ARRAY3(JAK)
        171 END DO
!        
            JAK = 0
!
            DO 173 JA=1,JAM
                IHL = IHLA(JA)
                IHH = IHHA(JA)
                J   =  JRA(JA)
!
                IF ( .NOT. LJRA(JA)) GOTO 173
!            
                DO I=IHL,IHH
                    IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                        JAK = JAK + 1
                        ISP = ISPA(JAK)
                        ISQ = ISQA(JAK)
                        IFP = ( ISP - 1  ) / 2
                        IFQ = (-ISQ - 1  ) / 2
                        IPQ = ( ISP - ISQ) / 2
!                    
                        IX = I - MY_IS_GLB + 1
                        JX = J - MY_JS_GLB + 1
!                    
                        IF (HTM(IX+IHE(JX)+IFP,JX+ISP    ,K) *                                    &
    &                       HTM(IX+IHE(JX)+IFQ,JX    +ISQ,K) *                                    &
    &                       HTM(IX        +IPQ,JX+ISP+ISQ,K) > 0.1) GOTO 172
!                    
                        IF (HTM(IX+IHE(JX)+IFP,JX+ISP    ,K) +                                    &
    &                       HTM(IX+IHE(JX)+IFQ,JX    +ISQ,K) +                                    &
    &                       HTM(IX        +IPQ,JX+ISP+ISQ,K) < 0.1) THEN
!
                            TST(IX+IHE(JX)+IFP,JX+ISP    ) = TST(IX,JX)
                            TST(IX+IHE(JX)+IFQ,JX    +ISQ) = TST(IX,JX)
                            TST(IX        +IPQ,JX+ISP+ISQ) = TST(IX,JX)
!
                        ELSE IF (HTM(IX+IHE(JX)+IFP,JX+ISP    ,K) +                               &
    &                            HTM(IX        +IPQ,JX+ISP+ISQ,K) < 0.99) THEN
!
                            TST(IX+IHE(JX)+IFP,JX+ISP    ) = TST(IX            ,JX    )
                            TST(IX        +IPQ,JX+ISP+ISQ) = TST(IX+IHE(JX)+IFQ,JX+ISQ)
!
                        ELSE IF (HTM(IX+IHE(JX)+IFQ,JX    +ISQ,K) +                               &
    &                            HTM(IX+IPQ        ,JX+ISP+ISQ,K) < 0.99) THEN

                            TST(IX+IHE(JX)+IFQ,JX    +ISQ) = TST(IX            ,JX    )
                            TST(IX        +IPQ,JX+ISP+ISQ) = TST(IX+IHE(JX)+IFP,JX+ISP)
!
                        ELSE IF (HTM(IX+IHE(JX)+IFP,JX+ISP    ,K) +                               &
    &                            HTM(IX+IHE(JX)+IFQ,JX    +ISQ,K) < 0.99) THEN
!
                            TST(IX+IHE(JX)+IFP,JX+ISP    ) = 0.5                                  &
    &                                                      * (TST(IX    ,JX        )              &
    &                                                      +  TST(IX+IPQ,JX+ISP+ISQ))
!
                            TST(IX+IHE(JX)+IFQ,JX    +ISQ) = TST(IX+IHE(JX)+IFP,JX+ISP)
!
                        ELSE IF (HTM(IX+IHE(JX)+IFP,JX+ISP,K) < 0.99) THEN
!
                            TST(IX+IHE(JX)+IFP,JX+ISP) = TST(IX            ,JX        )           &
    &                                                  + TST(IX+IPQ        ,JX+ISP+ISQ)           &
    &                                                  - TST(IX+IHE(JX)+IFQ,JX    +ISQ)
!
                        ELSE IF (HTM(IX+IHE(JX)+IFQ,JX+ISQ,K) < 0.99) THEN
!
                            TST(IX+IHE(JX)+IFQ,JX+ISQ) = TST(IX            ,JX        )           &
    &                                                  + TST(IX+IPQ        ,JX+ISP+ISQ)           &
    &                                                  - TST(IX+IHE(JX)+IFP,JX+ISP    )
                        ELSE
                            TST(IX+IPQ,JX+ISP+ISQ) = TST(IX+IHE(JX)+IFP,JX+ISP    )               &
    &                                              + TST(IX+IHE(JX)+IFQ,JX    +ISQ)               &
    &                                              - TST(IX            ,JX        )
                        END IF
!                    
                    172 CONTINUE
!                    
                        F0 = ARRAY0(JAK)
                        F1 = ARRAY1(JAK)
                        F2 = ARRAY2(JAK)
                        F3 = ARRAY3(JAK)
!
                        ADT(IX,JX) = F0 * TST(IX,JX) + F1 * TST(IX+IHE(JX)+IFP,JX+ISP    )        &
    &                              +                   F2 * TST(IX+IHE(JX)+IFQ,JX    +ISQ)        &
    &                              +                   F3 * TST(IX+IPQ        ,JX+ISP+ISQ)
                    END IF
!
                END DO
        173 END DO
!        
            DO 175 JAK=1,JAKONE
                I = IHLAS(JAK)
                J = JHLAS(JAK)
!            
                IX = I - MY_IS_GLB + 1
                JX = J - MY_JS_GLB + 1
!            
                ISP = ISPA(JAK)
                ISQ = ISQA(JAK)
!
                IFP = ( ISP-1  ) / 2
                IFQ = (-ISQ-1  ) / 2
                IPQ = ( ISP-ISQ) / 2
!
                F0 = ARRAY0(JAK)
                F1 = ARRAY1(JAK)
                F2 = ARRAY2(JAK)
                F3 = ARRAY3(JAK)
!
                ADQ2M(IX,JX) = F0 * Q2M(IX,JX) + F1 *  Q2M(IX+IHE(JX)+IFP,JX+ISP    )             &
    &                        +                   F2 *  Q2M(IX+IHE(JX)+IFQ,JX    +ISQ)             &
    &                        +                   F3 *  Q2M(IX+IPQ        ,JX+ISP+ISQ)
!
                ADQ2L(IX,JX) = F0 * Q2L(IX,JX) + F1 * Q2L(IX+IHE(JX)+IFP,JX+ISP    )              &
    &                        +                   F2 * Q2L(IX+IHE(JX)+IFQ,JX    +ISQ)              &
    &                        +                   F3 * Q2L(IX+IPQ        ,JX+ISP+ISQ)
        175 END DO
!        
        END IF
!----------------------------------------------- 
! END OF THIS UPSTREAM REGION
!
! CALCULATION OF MOMENTUM ADVECTION COMPONENTS 
!
! THE FOLLOWING EW AND NS ARRAYS ARE ON H POINTS
!-----------------------------------------------
        DO 180 J=MYJS4_P4,MYJE4_P4
            DO 180 I=MYIS_P4,MYIE_P4
               UEW(I,J) = (FEW(I+IHW(J),J  ) + FEW(I+IHE(J),J  ))                                 &
    &                   * (UST(I+IHE(J),J  ) - UST(I+IHW(J),J  ))
!
               UNS(I,J) = (FNS(I+IHW(J),J  ) + FNS(I+IHE(J),J  ))                                 &
    &                   * (UST(I       ,J+1) - UST(I       ,J-1))
!
               VEW(I,J) = (FEW(I       ,J-1) + FEW(I       ,J+1))                                 &
    &                   * (VST(I+IHE(J),J  ) - VST(I+IHW(J),J  ))
!
               VNS(I,J) = (FNS(I       ,J-1) + FNS(I       ,J+1))                                 &
    &                   * (VST(I       ,J+1) - VST(I       ,J-1))
!---------------------------------------------------- 
! THE FOLLOWING NE AND SE ARRAYS ARE TIED TO V POINTS
!---------------------------------------------------- 
               UNE(I,J) = (FNE(I+IVW(J),J  ) + FNE(I+IVE(J),J  ))                                 &
    &                   * (UST(I+IVE(J),J+1) - UST(I      ,J   ))
!
               USE(I,J) = (FSE(I+IVW(J),J  ) + FSE(I+IVE(J),J  ))                                 &
    &                   * (UST(I+IVE(J),J-1) - UST(I       ,J  ))
!
               VNE(I,J) = (FNE(I       ,J-1) + FNE(I       ,J+1))                                 &
    &                   * (VST(I+IVE(J),J+1) - VST(I       ,J  ))
!
               VSE(I,J) = (FSE(I       ,J-1) + FSE(I       ,J+1))                                 &
    &                   * (VST(I+IVE(J),J-1) - VST(I       ,  J))
    180 END DO
!----------------------------  
! EQUATION OF MOTION 
!
! ADU AND ADV ARE ON V POINTS
!----------------------------  
        DO 200 J=MYJS5_P2,MYJE5_P2
            DO 200 I=MYIS_P2,MYIE_P2
                ADU(I,J) =  (UEW(I+IVW(J),J  ) + UEW(I+IVE(J),J  )                                &
    &                    +   UNS(I       ,J-1) + UNS(I       ,J+1)                                &
    &                    +   UNE(I+IVW(J),J-1) + UNE(I       ,J  )                                &
    &                    +   USE(I       ,J  ) + USE(I+IVW(J),J+1))                               &
    &                    * RDPDX(I       ,J  ) * FAD(I+IVW(J),J  )
!
                ADV(I,J) =  (VEW(I+IVW(J),J  ) + VEW(I+IVE(J),J  )                                &
    &                    +   VNS(I       ,J-1) + VNS(I       ,J+1)                                &
    &                    +   VNE(I+IVW(J),J-1) + VNE(I       ,J  )                                &
    &                    +   VSE(I       ,J  ) + VSE(I+IVW(J),J+1))                               &
    &                    * RDPDY(I       ,J  ) * FAD(I+IVW(J),J  )
    200 END DO
!------------------------------------------     
! UPSTREAM ADVECTION OF VELOCITY COMPONENTS 
!------------------------------------------    
        IF (UPSTRM) THEN
            DO 205 JAK=1,JAKTWO
                JA = KVHAS(JAK)
                I  = IVLAS(JAK)
                J  = JVLAS(JAK)
!            
                IX = I - MY_IS_GLB + 1
                JX = J - MY_JS_GLB + 1
!            
                TTA = EM(JA) * UST(IX,JX)
                TTB = EN     * VST(IX,JX)
!
                PP = -TTA - TTB
                QP =  TTA - TTB
!            
                IF (PP < 0.) THEN
                    ISP = -1
                ELSE
                    ISP =  1
                END IF
!            
                IF (QP < 0.) THEN
                    ISQ = -1
                ELSE
                    ISQ =  1
                END IF
!            
                IFP = ( ISP - 1  ) / 2
                IFQ = (-ISQ - 1  ) / 2
                IPQ = ( ISP - ISQ) / 2
!
                PP = ABS(PP)
                QP = ABS(QP)
!
                F3 = PP * QP
                F0 = F3 - PP - QP
                F1 = PP - F3
                F2 = QP - F3
!
                ADU(IX,JX) = F0 * UST(IX,JX) + F1 * UST(IX+IVE(JX)+IFP,JX+ISP    )                &
    &                      +                   F2 * UST(IX+IVE(JX)+IFQ,JX    +ISQ)                &
    &                      +                   F3 * UST(IX        +IPQ,JX+ISP+ISQ)
!
                ADV(IX,JX) = F0 * VST(IX,JX) + F1 * VST(IX+IVE(JX)+IFP,JX+ISP    )                &
    &                                        + F2 * VST(IX+IVE(JX)+IFQ,JX    +ISQ)                &
    &                                        + F3 * VST(IX        +IPQ,JX+ISP+ISQ)
        205 END DO
        END IF
!---------------------------- 
! END OF THIS UPSTREAM REGION
!----------------------------
        IF (ITER2) GOTO 235
!
        DO 220 J=MYJS2_P2,MYJE2_P2
            DO 220 I=MYIS1_P2,MYIE1_P2
                TST(I,J) = ADT  (I,J) * (HM(I,J) * TLC) + TST(I,J)
                Q2M(I,J) = ADQ2M(I,J) * (HM(I,J) * TLC) + Q2M(I,J)
                Q2L(I,J) = ADQ2L(I,J) * (HM(I,J) * TLC) + Q2L(I,J)
    220 END DO
!    
        DO 230 J=MYJS2_P2,MYJE2_P2
            DO 230 I=MYIS1_P2,MYIE1_P2
                UST(I,J) = ADU(I,J) * VM(I,J) * TLC + UST(I,J)
                VST(I,J) = ADV(I,J) * VM(I,J) * TLC + VST(I,J)
    230 END DO
!
        ITER2 = .TRUE.
! 
        GOTO 125
!
    235 DO 240 J=MYJS2,MYJE2
        DO 240 I=MYIS1,MYIE1
            T(I,J,K) = ADT(I,J) * (2.0*HM(I,J)) + T(I,J,K)
    240 END DO
!    
        DO 250 J=MYJS2,MYJE2
            DO 250 I=MYIS1,MYIE1
                U(I,J,K) = ADU(I,J) * (2.0*VM(I,J)) + U(I,J,K)
                V(I,J,K) = ADV(I,J) * (2.0*VM(I,J)) + V(I,J,K)
    250 END DO
!
        IF (K == LM) THEN
            DO 260 J=MYJS2,MYJE2
                DO 260 I=MYIS1,MYIE1
                    ADQ2HL(I,J,LM-1) = ADQ2M(I,J)
        260 END DO
!
        ELSE IF (K > 1 .AND. K < LM) THEN
            DO 270 J=MYJS2,MYJE2
                DO 270 I=MYIS1,MYIE1
                    ADQ2HL(I,J,K-1) = ADQ2M(I,J)
                        Q2(I,J,K  ) = ADQ2L(I,J) * HM(I,J) + Q2(I,J,K)
        270 END DO
!
        ELSE
            DO 280 J=MYJS2,MYJE2
                DO 280 I=MYIS1,MYIE1
                    Q2(I,J,K) = ADQ2L(I,J) * HM(I,J) + Q2(I,J,K)
        280 END DO
        END IF
!
500 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (HM)
!
    DO 600 K=2,LM-1
        DO J=MYJS2,MYJE2
            DO I=MYIS1,MYIE1
                HM(I,J)   =    HTM(I,J,K) * HBM2(I,J)
                Q2(I,J,K) = ADQ2HL(I,J,K) *   HM(I,J) + Q2(I,J,K)
            END DO
        END DO
600 END DO
!
    RETURN
!
    END SUBROUTINE HZADV_LM1

    SUBROUTINE DIVHOA
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE DIVHOA
!>
!> SUBPROGRAM: DIVHOA - DIVERGENCE/HORIZONTAL OMEGA-ALPHA
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-10-28
!>
!> ABSTRACT:
!> DIVHOA COMPUTES THE DIVERGENCE INCLUDING THE MODIFICATION PREVENTING GRAVITY WAVE GRID SEPARATION
!> AND CALCULATES THE HORIZONTAL PART OF THE OMEGA-ALPHA TERM (THE PART PROPORTIONAL TO THE 
!> ADVECTION OF MASS ALONG ETA/SIGMA SURFACES).
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-29  BLACK      - ADDED EXTERNAL EDGE
!> 97-03-17  MESINGER   - SPLIT FROM PFDHT
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 00-10-20  BLACK      - INCORPORATED PRESSURE GRADIENT METHOD FROM MESO MODEL
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CLDWTR 
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              TEMPCOM 
!>              TOPO
!>              VRBLS
!>  
!> DRIVER     : DIGFLT
!>              EBU
!>              NEWFLT
!>
!> CALLS      : ZERO2                
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM+1)                             ::&
    & PINTLG
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::& 
    & FIM     ,                                                                                   &
    & FILO    , RDPD    ,                                                                         &
    & ADPDX   , RDPDX   ,                                                                         &
    & ADPDY   , RDPDY   ,                                                                         &
    & ADPDNE  , ADPDSE  ,                                                                         &
    & PEW     , PNS     ,                                                                         &
    & PCEW    , PCNS    ,                                                                         &
    & DPFEW   , DPFNS   ,                                                                         &
    & FNS     , TNS     ,                                                                         &
    & HM      , VM      ,                                                                         &
    & EDIV    , DIVL  
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DPDE    ,                                                                                   &
    & APEL    , PCXC    ,                                                                         &
    & ALP1    ,                                                                                   &
    & DFDZ    ,                                                                                   &
    & UDY     , VDX     ,                                                                         &
    & TEW     , FEW     ,                                                                         &
    & TNE     , TSE     ,                                                                         &
    & FNE     , FSE     ,                                                                         &
    & PNE     , PSE     ,                                                                         &
    & CNE     , CSE     ,                                                                         &
    & PPNE    , PPSE    ,                                                                         & 
    & PCNE    , PCSE  
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ALP1P   , ALP1X   , DFI     , RDPDS   , FIUPK   , ALP1PL  , ALP2P   , ALP2PL  , DPNEK   ,   &
    & DPSEK   , DCNEK   , DCSEK   , PVNEK   , PVSEK
!
    CALL ZERO2(ALP1)
    CALL ZERO2(DPDE)
    CALL ZERO2(APEL)
    CALL ZERO2(PCXC)
    CALL ZERO2(DFDZ)
    CALL ZERO2(UDY)
    CALL ZERO2(VDX)
    CALL ZERO2(TEW)
    CALL ZERO2(FEW)
    CALL ZERO2(TNE)
    CALL ZERO2(TSE)
    CALL ZERO2(FNE)
    CALL ZERO2(FSE)
    CALL ZERO2(PNE)
    CALL ZERO2(PSE)
    CALL ZERO2(CNE)
    CALL ZERO2(CSE)
    CALL ZERO2(PPNE)
    CALL ZERO2(PPSE)
    CALL ZERO2(PCNE)
    CALL ZERO2(PCSE)
!------------------------- 
! PREPARATORY CALCULATIONS 
!------------------------- 
    IF (SIGMA) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 50 J=MYJS_P5,MYJE_P5
            DO 50 I=MYIS_P5,MYIE_P5
                FILO(I,J) = FIS(I,J)
                PDSL(I,J) = PD (I,J)
     50 END DO
!
    ELSE
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO 100 J=MYJS_P5,MYJE_P5
            DO 100 I=MYIS_P5,MYIE_P5
                FILO(I,J) = 0.0
                PDSL(I,J) = RES(I,J) * PD(I,J)
    100 END DO
!
    END IF
!
    IF (HYDRO) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    PINTLG(I,J,K) = ALOG(ETA(K) * PDSL(I,J) + PT)
                END DO
            END DO
        END DO
!
    ELSE
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    PINTLG(I,J,K) = ALOG(PINT(I,J,K))
                END DO
            END DO
        END DO
!
    END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO K=1,LM
        DO J=MYJS_P4,MYJE_P4
            DO I=MYIS_P4,MYIE_P4
                OMGALF(I,J,K) = 0.
                DIV   (I,J,K) = 0.
            END DO
        END DO
    END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1X)
!
    DO J=MYJS_P5,MYJE_P5
        DO I=MYIS_P5,MYIE_P5
            ALP1X = PINTLG(I,J,LM+1)
            ALP1(I,J) = ALP1X
        END DO
    END DO
!-------------------------------
! MAIN VERTICAL INTEGRATION LOOP  
!------------------------------- 
    DO 400 K=LM,1,-1
!---------------------------
! INTEGRATE THE GEOPOTENTIAL
!---------------------------
        FIM = 0. 
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1P  , DFI     , FIUPK   , RDPDS)
!
        DO 125 J=MYJS_P5,MYJE_P5
            DO 125 I=MYIS_P5,MYIE_P5
!            
                ALP1P = PINTLG(I,J,K)
!
                DFI = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1(I,J) - ALP1P)                &
    &               / (1 + CWM(I,J,K)) / DWDT(I,J,K)
!            
                RDPDS       = 1. / (DETA(K) * PDSL(I,J))
                RTOP(I,J,L) = RDPDS * DFI
                FIUPK       = FILO(I,J) + DFI
                FIM(I,J)    = FILO(I,J) + FIUPK
!
                IF (ABS(FIM(I,J)) <= 5.E+10) THEN
!
                ELSE
                    WRITE(6,*) 'BAD FIM ', I, J, FIM(I,J), FILO(I,J), DFI
                    WRITE(6,*) 'Q,T,ALP1,ALP1P,DWDT: ', Q(I,J,K),    T(I,J,K), ALP1(I,J),         &
    &                                                   ALP1P   , DWDT(I,J,K)
                    STOP
!
                END IF
!            
                FILO(I,J) = (FIUPK - DFL(K)) * HTM(I,J,K) + DFL(K)
                ALP1(I,J) = ALP1P
    125 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1P  , ALP1PL  , ALP2P   , ALP2PL  , DFI)
!
        DO 205 J=MYJS_P5,MYJE_P5
            DO 205 I=MYIS_P5,MYIE_P5
                HM(I,J) = HTM(I,J,K) * HBM2(I,J)
                VM(I,J) = VTM(I,J,K) * VBM2(I,J)
!            
                ALP1P  = PINTLG(I,J,K  )
                ALP1PL = PINTLG(I,J,K+1)
                ALP2P  = ALP1P  * ALP1P
                ALP2PL = ALP1PL * ALP1PL
!
                DFI = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1PL-ALP1P)                     &
    &               / (1 + CWM(I,J,K)) / DWDT(I,J,K)
                DFDZ(I,J) = DFI * DWDT(I,J,K) / (ALP2PL-ALP2P)
                APEL(I,J) = (ALP2PL + ALP2P) * 0.5
    205 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 210 J=MYJS_P4,MYJE_P4
            DO 210 I=MYIS_P4,MYIE_P4
                DPDE(I,J) = DETA(K) * PDSL(I,J)
                DIVL(I,J) = 0.
                EDIV(I,J) = 0.
    210 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 215 J=MYJS_P1,MYJE_P1
            DO 215 I=MYIS_P1,MYIE_P1
                RDPD(I,J) = 1. / DPDE(I,J)
    215 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 220 J=MYJS1_P3,MYJE1_P3
            DO 220 I=MYIS_P3,MYIE_P3
                ADPDX(I,J) = DPDE(I+IVW(J),J) + DPDE(I+IVE(J),J)
                ADPDY(I,J) = DPDE(I,J-1) + DPDE(I,J+1)
                RDPDX(I,J) = 1. / ADPDX(I,J)
                RDPDY(I,J) = 1. / ADPDY(I,J)
    220 END DO
!--------------------------------------------------    
! DIAGONAL CONTRIBUTIONS TO PRESSURE GRADIENT FORCE
!--------------------------------------------------     
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 240 J=MYJS_P4,MYJE_P4
            DO 240 I=MYIS_P4,MYIE_P4
                ADPDNE(I,J) = DPDE(I+IHE(J),J+1) + DPDE(I,J)
                PNE   (I,J) = (FIM(I+IHE(J),J+1) - FIM (I,J)) * (DWDT(I+IHE(J),J+1,K)+DWDT(I,J,K))
!
                IF ( ABS(PNE(I,J)) <= 5.E10) THEN
!
                ELSE
!
                    WRITE(6,*) 'CRAZY PNE ', I, J, PNE(I,J)
                    WRITE(6,*) 'PIECES', I+IHE(J), J+1, FIM(I+IHE(J),J+1)
!
                END IF
!
                PPNE(I,J) = PNE(I,J) * ADPDNE(I,J)
                CNE(I,J)  = (DFDZ(I+IHE(J),J+1)+DFDZ(I,J)) * 2. * (APEL(I+IHE(J),J+1)-APEL(I,J))
                PCNE(I,J) = CNE(I,J) * ADPDNE(I,J)
    240 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 250 J=MYJS1_P4,MYJE_P4
            DO 250 I=MYIS_P4,MYIE1_P4
                ADPDSE(I,J) = DPDE(I+IHE(J),J-1) + DPDE(I,J)
                PSE( I,J)   = (FIM(I+IHE(J),J-1)-FIM(I,J)) * (DWDT(I+IHE(J),J-1,K)+DWDT(I,J,K))
                PPSE(I,J)   = PSE(I,J) * ADPDSE(I,J)
                CSE (I,J)   = (DFDZ(I+IHE(J),J-1)+DFDZ(I,J)) * 2. * (APEL(I+IHE(J),J-1)-APEL(I,J))
                PCSE(I,J)   = CSE(I,J) * ADPDSE(I,J)
    250 END DO
!---------------------------------     
! CONTINUITY EQUATION MODIFICATION 
!---------------------------------
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 260 J=MYJS1_P1,MYJE1_P1
            DO 260 I=MYIS_P1,MYIE_P1
                PCXC(I,J) = VBM3(I,J) * VTM(I,J,K) * (PNE(I+IVW(J),J) + CNE(I+IVW(J),J)           &
    &                     +                           PSE(I+IVW(J),J) + CSE(I+IVW(J),J)           &
    &                     -                           PNE(I,J-1) - CNE(I,J-1)                     &
    &                     -                           PSE(I,J+1) - CSE(I,J+1))
    260 END DO
!
        DO 270 J=MYJS2,MYJE2
            DO 270 I=MYIS1,MYIE1
                DIV(I,J,K) = DETA(K) * WPDAR(I,J) * (PCXC(I+IHE(J),J) - PCXC(I,J+1)               &
    &                      +                         PCXC(I+IHW(J),J) - PCXC(I,J-1))
    270 END DO
!---------------------------------------      
! LAT AND LONG PRESSURE FORCE COMPONENTS
!---------------------------------------      
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (DCNEK  , DCSEK   , DPNEK   , DPSEK)
!
        DO 280 J=MYJS1_P3,MYJE1_P3
            DO 280 I=MYIS_P3,MYIE_P3
                DPNEK     = PNE(I+IVW(J),J) + PNE(I,J-1)
                DPSEK     = PSE(I+IVW(J),J) + PSE(I,J+1)
                PEW(I,J)  = DPNEK           + DPSEK
                PNS(I,J)  = DPNEK           - DPSEK
                DCNEK     = CNE(I+IVW(J),J) + CNE(I,J-1)
                DCSEK     = CSE(I+IVW(J),J) + CSE(I,J+1)
                PCEW(I,J) = (DCNEK+DCSEK)   * ADPDX(I,J)
                PCNS(I,J) = (DCNEK-DCSEK)   * ADPDY(I,J)
    280 END DO
!----------------------------------------------      
! LAT AND LON FLUXES AND OMEGA-ALPHA COMPONENTS
!----------------------------------------------    
!------- 
! OPENMP
!------- 
!$omp parallel do
!
        DO 310 J=MYJS1_P3,MYJE1_P3
            DO 310 I=MYIS_P3,MYIE_P3
                UDY(I,J) = DY       * U    (I,J,K)
                FEW(I,J) = UDY(I,J) * ADPDX(I,J)
                TEW(I,J) = UDY(I,J) * PCEW (I,J)
                VDX(I,J) = DX (I,J) * V    (I,J,K)
                FNS(I,J) = VDX(I,J) * ADPDY(I,J)
                TNS(I,J) = VDX(I,J) * PCNS (I,J)
    310 END DO
!---------------------------------------------      
! DIAGONAL FLUXES AND DIAGONALLY AVERAGED WIND
!---------------------------------------------   
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (PVNEK)
!
        DO 320 J=MYJS1_P2,MYJE2_P2
            DO 320 I=MYIS_P2,MYIE1_P2
                PVNEK    = (UDY(I+IHE(J),J) + VDX(I+IHE(J),J)) + (UDY(I,J+1) + VDX(I,J+1))
                FNE(I,J) = PVNEK * ADPDNE(I,J)
                TNE(I,J) = PVNEK * PCNE(I,J) * 2.
    320 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (PVSEK)
!
        DO 330 J=MYJS2_P2,MYJE1_P2
            DO 330 I=MYIS_P2,MYIE1_P2
                PVSEK    = (UDY(I+IHE(J),J) - VDX(I+IHE(J),J)) + (UDY(I,J-1) - VDX(I,J-1))
                FSE(I,J) = PVSEK * ADPDSE(I,J)
                TSE(I,J) = PVSEK * PCSE(I,J) * 2.
    330 END DO
!----------------------------------------------     
! HORIZONTAL PART OF OMEGA-ALPHA AND DIVERGENCE
!----------------------------------------------  
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO 340 J=MYJS2_P1,MYJE2_P1
            DO 340 I=MYIS1_P1,MYIE1_P1
                OMGALF(I,J,K) = (TEW(I+IHE(J),J) + TEW(I+IHW(J),J) + TNS(I,J+1) + TNS(I,J-1)      &
    &                         +  TNE(I,J) + TNE(I+IHW(J),J-1)                                     &
    &                         +  TSE(I,J) + TSE(I+IHW(J),J+1))                                    &
    &                         * RDPD(I,J) * FCP(I,J) * HM(I,J)
!
                T(I,J,K)      = OMGALF(I,J,K) + T(I,J,K)
!
                EDIV(I,J) = ((FEW(I+IHE(J),J  ) + FNS(I       , J+1)                              &
    &                     +   FNE(I       ,J  ) + FSE(I       , J  ))                             &
    &                     -  (FEW(I+IHW(J),J  ) + FNS(I       , J-1)                              &
    &                     +   FNE(I+IHW(J),J-1) + FSE(I+IHW(J), J+1)))                            &
    &                     *  FDIV(I       ,J  )
!
                DIVL(I,J) = EDIV(I,J) * HBM2(I,J)
    340 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 390 J=MYJS,MYJE
            DO 390 I=MYIS,MYIE
                DIV(I,J,K) = (DIV(I,J,K) + DIVL(I,J)) * HM(I,J)
    390 END DO
!
400 END DO
!
    RETURN 
!
    END SUBROUTINE DIVHOA

    SUBROUTINE DIGFLT
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE DIGFLT
!> 
!> SUBPROGRAM: DIGFLT - ?????
!> PROGRAMMER: ?????
!> ORG: ??????
!> DATE: ??-??-??       
!>     
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                       * F77 TO F90/F95
!>                       * INDENTATION & UNIFORMIZATION CODE
!>                       * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                       * DOCUMENTATION WITH DOXYGEN
!>                       * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              EXCHM
!>              F77KINDS
!>              GLB_TABLE
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : BOCOHF
!>              BOCOV
!>              DIVHOA
!>              DSTRB
!>              EXCH
!>              HZADV
!>              LOC2GLB
!>              MPI_BARRIER
!>              MPI_BCAST
!>              PDTEDT
!>              PGCOR
!>              VTADVF
!>              ZERO2            
!>--------------------------------------------------------------------------------------------------   
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), PARAMETER :: PIQ  =    3.141592654
!--------------------------------------- 
! NTIM IS A HALF-SPAN IN TIME STEP UNITS
! ACTUAL TIME IS NTIM*DT
!--------------------------------------- 
    INTEGER(KIND=I4KIND), PARAMETER :: NTIM =  110
!
    REAL   (KIND=R4KIND), PARAMETER :: CM1  = 2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2  =    4.9283 
    REAL   (KIND=R4KIND), PARAMETER :: CM3  =   23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS  =    0.622
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PDQ     , RELHUM  , PDSL0
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & TQ      , UQ      , VQ
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & KNT     , IUNRH   , IUNDF   , I       , J       , K       , IRTN    , NT      , JK
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & CLOGES  , ESE     , PRS     , QIJ     , E       , HSPAN   , TIME    , QNT     , TETC    ,   &
    & CSTT    , SQ      , FNT     , AS1     , AS2     , ASS1    , ASS2    , BNT     , BS1     ,   &
    & BS2     , BSS1    , BSS2    , HNTSD   , TSPH    , BCHR
!
    DATA KNT/0/, IUNRH/51/, IUNDF/52/
!
    NBOCO = 0
!
    REWIND IUNRH
    REWIND IUNDF
!-------------------------------------------- 
! COMPUTE AND WRITE OUT THE RELATIVE HUMIDITY
!--------------------------------------- ----
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDSL0(I,J) = RES(I,J) * PD(I,J)
        END DO
    END DO
!
    DO K=1,LM
!    
        CALL ZERO2(RELHUM)
!    
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                IF (HTM(I,J,K) > 0.5) THEN
                    CLOGES = - CM1 / T(I,J,K) - CM2 * ALOG10(T(I,J,K)) + CM3
                    ESE = 10. ** (CLOGES + 2.)
                    PRS = AETA(K) * PDSL0(I,J) + PT
                    QIJ = Q(I,J,K)
                    E   = PRS * QIJ / (EPS * (1.-QIJ) + QIJ)
                    RELHUM(I,J) = AMIN1(E/ESE,0.98)
                ELSE
                    RELHUM(I,J) = 0.
                END IF
            END DO
        END DO
!-----------------------------------------
! SMOOTH THE INITIAL RH FIELD THEN SAVE IT
!--------------------------------------- --
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                RELHUM(I,J) = AMIN1(RELHUM(I,J),0.98)
                RELHUM(I,J) = AMAX1(RELHUM(I,J),0.02)
            END DO
        END DO
!-----------------------  
! ASSEMBLE GLOBAL RELHUM
!-----------------------  
        CALL LOC2GLB(RELHUM,TEMP1)
!    
        IF (MYPE == 0) WRITE(IUNRH) TEMP1
!-------------------------------------------------------------------------     
! SMOOTH THE INITIAL TEMPERATURE FIELD BEFORE EXECUTING THE DIGITAL FILTER
!-------------------------------------------------------------------------    
    END DO
!------------------------------------------------------- 
! SAVE CURRENT PROG VARIABLES IN WORK FILE FOR LATER USE
!--------------------------------------- ---------------
    CALL LOC2GLB(PD, TEMP1)
!
    IF (MYPE == 0) WRITE(IUNDF) TEMP1
!
    DO K=1,LM
!
        CALL LOC2GLB(T(IDIM1,JDIM1,K), TEMP1)
!
        IF(MYPE == 0)  WRITE(IUNDF) TEMP1
!    
        CALL LOC2GLB(U(IDIM1,JDIM1,K), TEMP1)
!
        IF (MYPE == 0) WRITE(IUNDF) TEMP1
!    
        CALL LOC2GLB(V(IDIM1,JDIM1,K), TEMP1)
!
        IF (MYPE == 0) WRITE(IUNDF) TEMP1
!
    END DO
!---------------------------------------------- 
! SET UP ARRAYS TO HOLD SUMS FOR DIGITAL FILTER
!----------------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDQ(I,J) = PD(I,J)
        END DO
    END DO
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TQ(I,J,K) = T(I,J,K)
                UQ(I,J,K) = U(I,J,K)
                VQ(I,J,K) = V(I,J,K)
            END DO
        END DO
    END DO
!
    HSPAN = FLOAT(NTIM) * DT / 3600.
!
    IF (MYPE == 0) WRITE(6,100) HSPAN
    100 FORMAT(' ','INITIALIZATION CALLED WITH HALF-SPAN',F5.1,' HOURS')
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!-------------------------------------------------------------
! RUN THE FORECAST MODEL FORWARD AND BACKWARD (DIGITAL FILTER)
!
! FIRST, FORWARD INTEGRATION
!
!--------------------------------------------------------------------------------------------------
! CALCULATE NORM NEEDED FOR LANCZOS WINDOW
!
! 'TETC' DEFINES CUT-OFF FREQUENCY FOR THE WINDOW (FACTOR 2 APPEARS ONLY TO SHOW GENERAL FORMULA) 
! (IT SHOULD BE TETC=PIQ/FLOAT(NTIM))
! 'NTIM' IS A NUMBER OF TIME STEPS IN A HALF-SPAN
! 'TIME' CORRESPONDS TO NUMBER OF TIME STEPS OF A SPAN
!--------------------------------------------------------------------------------------------------
    TIME = 2. * FLOAT(NTIM)
    QNT  =      FLOAT(NTIM+1)
    TETC = 2. * PIQ / TIME
    CSTT =     TETC / PIQ
    SQ   =     CSTT

    DO NT=1,NTIM
        FNT  = FLOAT(NT)
        AS1  = PIQ * FNT / QNT
        AS2  = FNT * TETC
        ASS1 = SIN(AS1) / AS1
        ASS2 = SIN(AS2) / AS2
        SQ   = SQ + 2. * CSTT * ASS1 * ASS2
    END DO

!-------------------------------------
! NORMALIZATION OF THE WINDOW FUNCTION
!-------------------------------------
    CSTT = CSTT / SQ
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDQ(I,J) = PDQ(I,J) * CSTT
        END DO
    END DO
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TQ(I,J,K) = TQ(I,J,K) * CSTT
                UQ(I,J,K) = UQ(I,J,K) * CSTT
                VQ(I,J,K) = VQ(I,J,K) * CSTT
            END DO
        END DO
    END DO
!
    NTSD = 0
!------------------------- 
! ENTRY INTO THE TIME LOOP
!------------------------- 
    2010 NTSD = NTSD + 1
          KNT = KNT  + 1
    IF (MYPE == 0) WRITE(6,2015) NTSD, NTIM
    2015 FORMAT(' NTSD=',I5,'  NTSTM=',I4)
!-------------------------------------------------------
! DIVERGENCE AND HORIZONTAL PART OF THE OMEGA-ALPHA TERM
!-------------------------------------------------------
    IF (NTSD > 1) CALL EXCH(T, LM, U, LM, V, LM, 2, 2) !EXCHANGE T, U AND V
    CALL DIVHOA
!----------------------------------------------
! PRESS. TEND.,ETA DOT AND VERTICAL OMEGA-ALPHA
!----------------------------------------------
    CALL PDTEDT
!------------------- 
! VERTICAL ADVECTION
!-------------------
    IF (MOD(NTSD-1,IDTAD) == 0) THEN
        CALL EXCH(ETADT, LM-1, 1, 1)
!
        CALL VTADVF
!    
        CALL EXCH(T, LM, U, LM, V, LM, Q2, LM, 1, 1)
    END IF
!------------------------------------- 
! UPDATE SURFACE PRESSURE (MINUS PTOP)
!------------------------------------- 
    CALL PDNEW
!------------------------- 
! UPDATE H BOUNDARY POINTS
!------------------------- 
    IF (MOD(NTSD,IDTAD) == 0) THEN
        CALL EXCH(T, LM, Q2, LM, 1, 1)
    END IF
!
    CALL EXCH(PD, 1, 1, 1)
!
    CALL BOCOHF
!-------------------------------------------
! PRESSURE GRADIENT AND CORIOLIS FORCE TERMS
!-------------------------------------------
    CALL EXCH(PD, 1, T, LM, 2, 2) !EXCHANGE PD AND T
!
    CALL PGCOR
!
    CALL EXCH(PDSL, 1, 5, 5)
!------------------------- 
! UPDATE V BOUNDARY POINTS
!------------------------- 
    CALL EXCH(U, LM, V, LM, 1, 1) !EXCHANGE U AND V
!
    CALL BOCOV
!---------------------
! HORIZONTAL ADVECTION
!---------------------
    IF (MOD(NTSD,IDTAD) == 0) THEN
        CALL EXCH(T, LM, U, LM, V, LM, 4, 4) !EXCHANGE T, U, AND V
!        
        CALL EXCH(Q2, LM, 5, 5)
!    
        CALL HZADV
 !   
        CALL EXCH(U, LM, V, LM, 2, 2) !EXCHANGE U AND V
    END IF
!--------------------------- 
! CALCULATE WINDOW PARAMETER
!---------------------------
    BNT   = FLOAT(NTSD)
    BS1   = BNT * PIQ / QNT
    BS2   = BNT * TETC
    BSS1  = SIN(BS1) / BS1
    BSS2  = SIN(BS2) / BS2
    HNTSD = CSTT * BSS1 * BSS2
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TQ(I,J,K) = TQ(I,J,K) + HNTSD * T(I,J,K)
                UQ(I,J,K) = UQ(I,J,K) + HNTSD * U(I,J,K)
                VQ(I,J,K) = VQ(I,J,K) + HNTSD * V(I,J,K)
            END DO
        END DO
    END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDQ(I,J) = PDQ(I,J) + HNTSD * PD(I,J)
        END DO
    END DO
!
    IF (NTSD == NTIM) GOTO 2013
!
    GOTO 2010
!------------------------ 
! EXIT FROM THE TIME LOOP 
!------------------------
    2013 CONTINUE
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!---------------------------------------------------------
! NOW BACKWARD INTEGRATION, STARTING FROM THE INITIAL TIME
!---------------------------------------------------------
!
!-----------------------------------------------
! CHANGE (SIGN ONLY OF) IMPORTANT TIME CONSTANTS
!-----------------------------------------------
    DT    = -DT
    CPGFV = -CPGFV
    EN    = -EN
    ENT   = -ENT
    F4D   = -F4D
    F4Q   = -F4Q
    EF4T  = -EF4T
!
    DO JK=1,JAM
        EM (JK) = - EM(JK)
        EMT(JK) = -EMT(JK)
    END DO
!
    DO K=1,LM
        F4Q2(K) = -F4Q2(K)
    END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            WPDAR(I,J) = -WPDAR(I,J)
            CPGFU(I,J) = -CPGFU(I,J)
             CURV(I,J) =  -CURV(I,J)
              FCP(I,J) =   -FCP(I,J)
              FAD(I,J) =   -FAD(I,J)
                F(I,J) =     -F(I,J)
        END DO
    END DO
!
    CALL EXCH(WPDAR, 1, CPGFU, 1, 2, 2)
    CALL EXCH(CURV , 1, FCP  , 1, 2, 2)
    CALL EXCH(FAD  , 1, F    , 1, 2, 2)
!-------------- 
! END OF CHANGE 
!--------------  
!
!-----------------------------------------------------------------------------------------------
! DEFINE INITIAL DATA FOR BACKWARD INTEGRATION (PDQ,TQ,UQ,VQ ARE SUMS NEEDED FOR DIGITAL FILTER)
!-----------------------------------------------------------------------------------------------
    IF (MYPE == 0) THEN
        REWIND IUNDF
        READ(IUNDF) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, PD, 1, 1, 1)
!
    DO K=1,LM
        IF (MYPE == 0) THEN
            READ(IUNDF) TEMP1
            READ(IUNDF) TEMP2
            READ(IUNDF) TEMP3
        END IF
!
        CALL DSTRB(TEMP1, T, 1, LM, K)
        CALL DSTRB(TEMP2, U, 1, LM, K)
        CALL DSTRB(TEMP3, V, 1, LM, K)
    END DO
!
    CALL EXCH(T , LM, U, LM, V, LM, 5, 5) !EXCHANGE T, U, AND V
    CALL EXCH(PD,  1, 5, 5)
!
    NTSD = 0
    FIRST = .TRUE. 
    TSPH = -3600. / DT
    IF (MYPE == 0) THEN
        IF (.NOT. NEST) THEN
            REWIND NBC
            READ(NBC)
            READ(NBC) BCHR
        ELSE
            READ(NBC,REC=2) BCHR
        END IF
    END IF
!
    CALL MPI_BCAST(BCHR, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    NBOCO = INT(BCHR * TSPH + 0.5)
!------------------------- 
! ENTRY INTO THE TIME LOOP
!------------------------- 
    2020 NTSD = NTSD + 1
          KNT = KNT  + 1
!
    IF (MYPE == 0) WRITE(6,2015) NTSD, NTIM
!-------------------------------------------------------
! DIVERGENCE AND HORIZONTAL PART OF THE OMEGA-ALPHA TERM
!-------------------------------------------------------
    IF (NTSD > 1) CALL EXCH(T, LM, U, LM, V, LM, 2, 2) !EXCHANGE T, U, AND V
!
    CALL DIVHOA
!
!--------------------------------------------
! PRESS. TEND.,ETA DOT & VERTICAL OMEGA-ALPHA
!--------------------------------------------
    CALL PDTEDT
!------------------- 
! VERTICAL ADVECTION
!------------------- 
    IF (MOD(NTSD-1,IDTAD) == 0) THEN
        CALL EXCH(ETADT, LM-1, 1, 1)
!    
        CALL VTADVF
!    
        CALL EXCH(T, LM, U, LM, V, LM, Q2, LM, 1, 1) !EXCHANGE T, U, AND V
    END IF
!------------------------------------- 
! UPDATE SURFACE PRESSURE (MINUS PTOP)
!-------------------------------------
    CALL PDNEW
!------------------------- 
! UPDATE H BOUNDARY POINTS
!------------------------- 
    IF (MOD(NTSD,IDTAD) == 0) THEN
        CALL EXCH(T, LM, Q2, LM, 1, 1)
    END IF
!
    CALL EXCH(PD, 1, 1, 1)
!
    CALL BOCOHF
!-------------------------------------------
! PRESSURE GRADIENT AND CORIOLIS FORCE TERMS
!-------------------------------------------
    CALL EXCH(PD, 1, T, LM, 2, 2) !EXCHANGE PD AND T
!
    CALL PGCOR
!
    CALL EXCH(PDSL, 1, 5, 5)
!------------------------- 
! UPDATE V BOUNDARY POINTS
!-------------------------
    CALL EXCH(U, LM, V, LM, 1, 1) !EXCHANGE U AND V
!
    CALL BOCOV
!--------------------- 
! HORIZONTAL ADVECTION
!--------------------- 
    IF (MOD(NTSD,IDTAD) == 0) THEN
!    
        CALL EXCH(T, LM, U, LM, V, LM, 4, 4) !EXCHANGE T, U, AND V
!
        CALL EXCH(Q2, LM, 5, 5)
!    
        CALL HZADV
!    
        CALL EXCH(U, LM, V, LM, 2, 2) !EXCHANGE U AND V
    END IF
!---------------------------
! CALCULATE WINDOW PARAMETER
!---------------------------
    BNT   = FLOAT(NTSD)
    BS1   = BNT * PIQ / QNT
    BS2   = BNT * TETC
    BSS1  = SIN(BS1) / BS1
    BSS2  = SIN(BS2) / BS2
    HNTSD = CSTT * BSS1 * BSS2
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TQ(I,J,K) = TQ(I,J,K) + HNTSD * T(I,J,K)
                UQ(I,J,K) = UQ(I,J,K) + HNTSD * U(I,J,K)
                VQ(I,J,K) = VQ(I,J,K) + HNTSD * V(I,J,K)
            END DO
        END DO
    END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDQ(I,J) = PDQ(I,J) + HNTSD * PD(I,J)
        END DO
    END DO
!
    IF (NTSD == NTIM) GOTO 2022
!
    GOTO 2020
!------------------------
! EXIT FROM THE TIME LOOP
!------------------------
    2022 CONTINUE
!-------------------------------------------------
! CHANGE BACK (SIGN ONLY) IMPORTANT TIME CONSTANTS
!-------------------------------------------------
    DT    = -DT
    CPGFV = -CPGFV
    EN    = -EN
    ENT   = -ENT
    F4D   = -F4D
    F4Q   = -F4Q
    EF4T  = -EF4T
!
    DO JK=1,JAM
         EM(JK) = - EM(JK)
        EMT(JK) = -EMT(JK)
    END DO
!
    DO K=1,LM
        F4Q2(K) = -F4Q2(K)
    END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            WPDAR(I,J) = -WPDAR(I,J)
            CPGFU(I,J) = -CPGFU(I,J)
             CURV(I,J) =  -CURV(I,J)
              FCP(I,J) =   -FCP(I,J)
              FAD(I,J) =   -FAD(I,J)
                F(I,J) =     -F(I,J)
        END DO
    END DO
!
    CALL EXCH(WPDAR, 1, CPGFU, 1, 2, 2)
!
    CALL EXCH(CURV , 1, FCP  , 1, 2, 2)
!
    CALL EXCH(FAD  , 1, F    , 1, 2, 2)
!----------------------------------------
! UPDATE INITIALIZED PROGNOSTIC VARIALBES
!----------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PD(I,J) = PDQ(I,J)
        END DO
    END DO
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                T(I,J,K) = TQ(I,J,K)
                U(I,J,K) = UQ(I,J,K)
                V(I,J,K) = VQ(I,J,K)
            END DO
        END DO
    END DO
!---------------------------------------------------------------------------------------------------------
! RETRIEVE THE INITIAL RELATIVE HUMIDITY AND COMPUTE Q SO AS TO MAINTAIN THE RH GIVEN THE NEW TEMPERATURES
!---------------------------------------------------------------------------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDSL0(I,J) = RES(I,J) * PD(I,J)
        END DO
    END DO
!
    IF (MYPE == 0) REWIND IUNRH
!
    DO K=1,LM
        IF (MYPE == 0) READ(IUNRH) TEMP1
!
        CALL DSTRB(TEMP1, RELHUM, 1, 1, 1)
!    
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                IF (HTM(I,J,K) > 0.5) THEN
                    CLOGES   = -CM1 / T(I,J,K) - CM2 * ALOG10(T(I,J,K)) + CM3
                    ESE      = 10. ** (CLOGES + 2.)
                    PRS      = AETA(K) * PDSL0(I,J) + PT
                    E        = RELHUM(I,J) * ESE
                    Q(I,J,K) = EPS * E / (PRS + E * (EPS - 1.))
                END IF
            END DO
        END DO
    END DO
!
    CALL EXCH(T, LM, Q, LM, U, LM, V, LM, 4, 4) !EXCHANGE T, Q, U, AND V
!
    CALL EXCH(PD, 1, 5, 5)
!---------------------------------
! RETURN BC FILE TO START FORECAST
!---------------------------------
    NTSD = 0
    IF (MYPE == 0) THEN
        IF (.NOT. NEST) THEN
            REWIND NBC
            READ(NBC)
            READ(NBC) BCHR
        ELSE
            READ(NBC,REC=2) BCHR
        END IF
    END IF
!
    CALL MPI_BCAST(BCHR, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!
    NBOCO = INT(BCHR * TSPH + 0.5)
!-------------- 
! END OF CHANGE  
!-------------- 
    RETURN
!
    END SUBROUTINE DIGFLT

    SUBROUTINE GSMDRIVE
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GSMCONST
!> 
!> SUBPROGRAM: GSMDRIVE - GRID-SCALE MICROPHYSICAL PROCESSES - CONDENSATION AND PRECIPITATION
!> PROGRAMMER: FERRIER
!> ORG: W/NP22     
!> DATE: 01-02-??
!>
!> ABSTRACT:
!> MERGES ORIGINAL GSCOND & PRECPD SUBROUTINES.
!> ODE HAS BEEN SUBSTANTIALLY STREAMLINED AND RESTRUCTURED.
!> EXCHANGE BETWEEN WATER VAPOR & SMALL CLOUD CONDENSATE IS CALCULATED USING THE ORIGINAL 
!> ASAI (1965, J. JAPAN) ALGORITHM.
!> SEE ALSO REFERENCES TO YAU AND AUSTIN (1979, JAS), RUTLEDGE AND HOBBS (1983, JAS), AND 
!> TAO ET AL. (1989, MWR).
!> THIS ALGORITHM REPLACES THE SUNDQVIST ET AL. (1989, MWR) PARAMETERIZATION.
!> DRIVER OF THE NEW MICROPHYSICS 
!>
!> NOTE:  CODE IS CURRENTLY SET UP W/O THREADING
!>
!> PROGRAM HISTORY LOG:
!> 01-04-XX    FERRIER  - BETA-TESTED VERSION
!> 01-05-21    FERRIER  - ADDED GRADUAL LATENT HEATING TO REMOVE EXTERNAL WAVES
!> 01-05-30    FERRIER  - CHANGED DEFAULT TO UNIFORM MARITIME CONDITIONS FOR TESTING
!> 18-01-15    LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> PRIOR PROGRAM HISTORY LOG:
!> HERITAGE AS SUBROUTINE GSCOND:
!> 94-??-??  ZHAO       - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-11-02  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!>
!> HERITAGE AS SUBROUTINE PRECPD:
!> 94-??-??  ZHAO       - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 96-03-29  BLACK      - REMOVED SCRCH COMMON
!> 96-07-18  ZHAO       - NEW WMIN CALCULATION
!> 96-09-25  BALDWIN    - NEW SR CALCULATION
!> 98-11-02  BLACK      - MODIFICATION FOR DISTRIBUTED MEMORY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES:  ACMCLH
!>               CLDWTR
!>               CMICRO_START
!>               CMICRO_STATS
!>               CTLBLK
!>               C_FRACN
!>               DYNAM
!>               F77KINDS
!>               GLB_TABLE
!>               LOOPS
!>               MAPPINGS
!>               MASKS
!>               MPPCOM
!>               PARMETA
!>               PARM_TBL
!>               PHYS
!>               PPTASM
!>               PVRBLS
!>               TEMPCOM
!>               TOPO
!>               VRBLS 
!>
!> DRIVER      : EBU
!>
!> CALLS       : GSMCOLUMN
!>               GSMCONST
!>               MPI_REDUCE
!>--------------------------------------------------------------------------------------------------
    USE ACMCLH
    USE CLDWTR
    USE CMICRO_START
    USE CMICRO_STATS
    USE CTLBLK
    USE C_FRACN
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PPTASM
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & NOZ
!----------------------------------------------------
! THIS VARIABLE IS FOR DEBUGGING PURPOSES (IF .TRUE.)
!---------------------------------------------------- 
    LOGICAL(KIND=L4KIND), PARAMETER :: PRINT_DIAG = .TRUE. 
!-------------------------------------------------------------------------
! THE FOLLOWING VARIABLES ARE FOR MICROPHYSICAL STATISTICS (NON-ESSENTIAL)
!-------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: ITHILO    = ITHI   - ITLO + 1
    INTEGER(KIND=I4KIND), PARAMETER :: ITHILO_N  = ITHILO *  4
    INTEGER(KIND=I4KIND), PARAMETER :: ITHILO_QM = ITHILO *  5
    INTEGER(KIND=I4KIND), PARAMETER :: ITHILO_QT = ITHILO * 22
!
    INTEGER(KIND=I4KIND), DIMENSION(ITLO:ITHI,  4)                                              ::&
    & NSTATS_0
!
    REAL   (KIND=R4KIND), DIMENSION(ITLO:ITHI,  5)                                              ::&
    & QMAX_0
!
    REAL   (KIND=R4KIND), DIMENSION(ITLO:ITHI, 22)                                              ::&
    & QTOT_0
!
    REAL   (KIND=R4KIND), SAVE                                                                  ::&
    & THOUR_PRINT
!
    REAL   (KIND=R4KIND), DIMENSION(2), SAVE                                                    ::&
    & PRECMAX , PRECTOT , PRECMAX_0, PRECTOT_0
!
    REAL   (KIND=R4KIND), PARAMETER :: DTHOUR_PRINT = 3. ! PRINT STATISTICS EVERY 3 H
!--------------------------------------- 
! BEGIN SECTION ON HYDROMETEOR FRACTIONS
!--------------------------------------- 
!
!------------------------------------------------------------ 
! SAVED VALUES USE REAL (REAL*4) ARRAYS RATHER THAN INTEGER*2
!------------------------------------------------------------ 
    REAL   (KIND=R4KIND)                                                                        ::&
    & FICE    , FRAIN   , DUM
!----------------------------------------------------- 
! SAVED VALUES USE INTEGER*2 ARRAYS RATHER THAN REAL*4
!----------------------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
! PARAMETERS USED IN CONVERTING FROM REAL TO INTEGER*2 FIELDS FOR FRACTION OF ICE (F_ICE), FRACTION 
! OF RAIN (F_RAIN), AND MASS RATIO OF RIMED ICE ("RIME FACTOR", F_RIMEF).
!--------------------------------------------------------------------------------------------------
!
!------------------------------------- 
! END SECTION ON HYDROMETEOR FRACTIONS
!------------------------------------- 
!
!---------------------------------------- 
! LOCAL ARRAYS AND PARAMETERS IN GSMDRIVE 
!---------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
! COMMENTS ON 23 AUGUST 2001
! EPSQ=1.E-20 IS THE LOWER LIMIT FOR SPECIFIC HUMIDITY AND CLOUD CONDENSATE.
! THE VALUE OF EPSQ WILL NEED TO BE CHANGED IN THE OTHER SUBROUTINES IN ORDER TO MAKE IT CONSISTENT
! THROUGHOUT THE ETA CODE.
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    1.E-20
    REAL   (KIND=R4KIND), PARAMETER :: GRAV   =    9.81
    REAL   (KIND=R4KIND), PARAMETER :: RHOL   = 1000.
    REAL   (KIND=R4KIND), PARAMETER :: T0C    =  273.15
    REAL   (KIND=R4KIND), PARAMETER :: T_ICE  =  -10.
    REAL   (KIND=R4KIND), PARAMETER :: T_ICEK = T0C + T_ICE
    REAL   (KIND=R4KIND), PARAMETER :: RRHOL  = 1.  / RHOL
    REAL   (KIND=R4KIND), PARAMETER :: CLIMIT =    1.E-12
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ARAIN   , ASNOW
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & P_COL   , QI_COL  , QR_COL  , QV_COL    , QW_COL  , RIMEF_COL, T_COL   , THICK_COL ,        &
    & WC_COL
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTPH    , PDSL    , CONSTA  , TIME_MODEL, HDTPH   , DEL_HYD  , DEL_QT  , RIMEF_BULK,        &
    & TC      , WC      , QI      , QR        , QW
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , LSFC      , I_INDEX , J_INDEX  , IRTN    , II        ,        &
    & JJ      , KK
!---------------- 
! BEGIN EXECUTION 
!---------------- 
!
!------------------------  
! MICROPHYSICAL CONSTANTS 
!------------------------ 
    DTPH = DTQ2 ! PHYSICS TIME STEP (S)
!------------------------------------ 
! INITIALIZE CONSTANTS FOR STATISTICS 
!------------------------------------ 
    IF (MICRO_START) THEN
        MICRO_START = .FALSE. ! NO NEED TO CALCULATE THESE PARAMETERS AGAIN
!------------------------------------------------------------------------     
! BEGIN: INITIALIZE ARRAYS IF NOT INITIALIZED IN RESTART FILES (01/16/02)
!------------------------------------------------------------------------     
        DUM = 0.
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
                IF (HBM2(I,J) > 0.5) THEN
                    LSFC = LMH(I,J) ! "K" OF SURFACE
                    DO K=1,LSFC
                        DUM = MAX(DUM,F_RAIN(K,I,J), F_ICE(K,I,J), F_RIMEF(K,I,J))
                        IF (DUM > 0.) GO TO 110
                    END DO
                END IF
            END DO
        END DO
!
    110 IF (DUM <= 0.) THEN
            IF (MYPE == 0) WRITE(0, "(A,2I3)" ) 'INITIALIZE INTERNAL MICROPHYSICS ARRAYS'
            DO J=MYJS2,MYJE2
                DO I=MYIS,MYIE
                    IF (HBM2(I,J) > 0.5) THEN
                        LSFC = LMH(I,J) ! "K" OF SURFACE
                        DO K=1,LSFC
                               F_RAIN(K,I,J) = 0.
!
                            IF (T(I,J,K) <= T_ICEK) THEN
                                F_ICE(K,I,J) = 1.
                            ELSE
                                F_ICE(K,I,J) = 0.
                            END IF
!
                              F_RIMEF(K,I,J) = 1.
                        END DO
                    END IF
                END DO
            END DO
        END IF
!    
        CALL GSMCONST(DTPH) ! INITIALIZE LOOKUP TABLES & CONSTANTS
!
        THOUR_PRINT = -DTPH / 3600.
!
        IF (PRINT_DIAG) THEN
!-----------------------------         
! TOTAL AND MAXIMUM QUANTITIES
!-----------------------------          
            NSTATS  = 0     ! MICROPHYSICAL STATISTICS DEALING W/ GRID-POINT COUNTS
            QMAX    = 0.    ! MICROPHYSICAL STATISTICS DEALING W/ HYDROMETEOR MASS
            QTOT    = 0.    ! MICROPHYSICAL STATISTICS DEALING W/ HYDROMETEOR MASS
            PRECMAX = 0.    ! MAXIMUM PRECIP RATES (RAIN, SNOW) AT SURFACE (MM/H)
            PRECTOT = 0.    ! TOTAL PRECIPITATION (RAIN, SNOW) ACCUMULATION AT SURFACE
        END IF
    END IF
!---------------------------------  
! LOOP HORIZONTALLY THROUGH DOMAIN 
!--------------------------------- 
    DO 100 J=MYJS2,MYJE2
        DO 100 I=MYIS,MYIE
            IF (HBM2(I,J) < 0.5) GOTO 100    ! IGNORE COLUMNS NEAR LATERAL BOUNDARIES
            LSFC   = LMH(I,J)                ! "K" OF SURFACE
            PDSL   =  PD(I,J) * RES(I,J)     ! (PSFC-PTOP)/ETA_SFC
            CONSTA = PDSL / GRAV             ! (PSFC-PTOP)/(G*ETA_SFC), USED FOR THICK BELOW
!-----------------------------------         
! INITIALIZE COLUMN DATA (1D ARRAYS)
!-----------------------------------         
            IF (CWM(I,J,1) <= CLIMIT) CWM(I,J,1) = EPSQ
              F_ICE(1,I,J) = 1.
             F_RAIN(1,I,J) = 0.
            F_RIMEF(1,I,J) = 1.
!--------------------------------  
! INICIALIZACAO DA VARIAVEL T_COL
!--------------------------------  
            T_COL(1:LM) = 0.
!
            DO K=1,LSFC
!-----------------------------------------------             
! PRESSURE (PA) = (PSFC-PTOP)*(ETA/ETA_SFC)+PTOP
!-----------------------------------------------            
                P_COL(K) = PDSL * AETA(K) + PT
!-----------------------------------------------------------------            
! LAYER THICKNESS = RHO*DZ = -DP/G = (PSFC-PTOP)*D_ETA/(G*ETA_SFC)
!----------------------------------------------------------------- 
                THICK_COL(K) = CONSTA * DETA(K)
                    T_COL(K) = T(I,J,K)
                          TC = T_COL(K) - T0C
                   QV_COL(K) = MAX(EPSQ, Q(I,J,K))
!
                IF (CWM(I,J,K) <= CLIMIT) THEN
                    WC_COL(K) = 0.
!
                    IF (TC < T_ICE) THEN
                        F_ICE(K,I,J) = 1.
                    ELSE
                        F_ICE(K,I,J) = 0.
                    END IF
!
                       F_RAIN(K,I,J) = 0.
                      F_RIMEF(K,I,J) = 1.
                ELSE
                    WC_COL(K) = CWM(I,J,K)
                END IF
!---------------------------------------------------------------------------             
! DETERMINE COMPOSITION OF CONDENSATE IN TERMS OF CLOUD WATER, ICE, AND RAIN
 !---------------------------------------------------------------------------           
                WC = WC_COL(K)
                QI = 0.
                QR = 0.
                QW = 0.
!
                FICE =   F_ICE(K,I,J)
                FRAIN = F_RAIN(K,I,J)
!---------------------             
! REAL*4 ARRAY STORAGE
!---------------------             
                IF (FICE >= 1.) THEN
                    QI = WC
                ELSE IF (FICE <= 0.) THEN
                    QW = WC
                ELSE
                    QI = FICE * WC
                    QW = WC   - QI
                END IF
!
                IF (QW > 0. .AND. FRAIN > 0.) THEN
                    IF (FRAIN >= 1.) THEN
                        QR = QW
                        QW = 0.
                    ELSE
                        QR = FRAIN * QW
                        QW = QW    - QR
                    END IF
                END IF
!
                RIMEF_COL(K) = F_RIMEF(K,I,J) ! (REAL)
!
                QI_COL(K) = QI
                QR_COL(K) = QR
                QW_COL(K) = QW
            END DO
!------------------------------------------------------ 
! PERFORM THE MICROPHYSICAL CALCULATIONS IN THIS COLUMN
!------------------------------------------------------        
            I_INDEX = I
            J_INDEX = J
!
            CALL GSMCOLUMN(ARAIN , ASNOW , DTPH  , I_INDEX  , J_INDEX, LSFC     , P_COL , QI_COL, &
    &                      QR_COL, QV_COL, QW_COL, RIMEF_COL, T_COL  , THICK_COL, WC_COL)
!----------------------  
! UPDATE STORAGE ARRAYS
!----------------------        
            DO K=1,LSFC
                 TRAIN(I,J,K) = (T_COL(K) - T(I,J,K)) / DTPH
                     T(I,J,K) =  T_COL(K)
                     Q(I,J,K) = QV_COL(K)
                TLATGS(I,J,K) =  T_COL(K) - T(I,J,K)
                   CWM(I,J,K) = WC_COL(K)
!---------------------             
! REAL*4 ARRAY STORAGE
!---------------------            
                F_RIMEF(K,I,J) = MAX(1., RIMEF_COL(K))
!
                IF (QI_COL(K) <= CLIMIT) THEN
                    F_ICE(K,I,J) = 0.
                    IF (T_COL(K) < T_ICEK) F_ICE(K,I,J) = 1.
                ELSE
                    F_ICE(K,I,J) = MAX(0., MIN(1., QI_COL(K) / WC_COL(K)))
                END IF
!
                IF (QR_COL(K) <= CLIMIT) THEN
                    DUM = 0
                ELSE
                    DUM = QR_COL(K) / (QR_COL(K) + QW_COL(K))
                END IF
!
                   F_RAIN(K,I,J) = DUM
!
            END DO
!--------------------------------------------------------------------------------------------------        
! UPDATE ACCUMULATED PRECIPITATION STATISTICS
!       
! SURFACE PRECIPITATION STATISTICS; 
! SR IS FRACTION OF SURFACE PRECIPITATION (IF >0) ASSOCIATED WITH SNOW
!--------------------------------------------------------------------------------------------------       
             APREC(I,J) = (ARAIN + ASNOW) * RRHOL  ! ACCUMULATED SURFACE PRECIP (DEPTH IN M) - YING
!
              PREC(I,J) =   PREC(I,J) + APREC(I,J)
            ACPREC(I,J) = ACPREC(I,J) + APREC(I,J)
!
            IF (APREC(I,J) < 1.E-8) THEN
                SR(I,J) = 0.
            ELSE
                SR(I,J) = RRHOL * ASNOW / APREC(I,J)
            END IF
!-----------------         
! DEBUG STATISTICS
!-----------------         
            IF (PRINT_DIAG) THEN
                PRECTOT(1) = PRECTOT(1) + ARAIN
                PRECTOT(2) = PRECTOT(2) + ASNOW
!
                PRECMAX(1) = MAX(PRECMAX(1), ARAIN)
                PRECMAX(2) = MAX(PRECMAX(2), ASNOW)
            END IF
!       
            CONTINUE ! END "I" & "J" LOOPS
100 END DO
!------------------------------ 
! END OF MAIN MICROPHYSICS LOOP 
!------------------------------ 
    TIME_MODEL = FLOAT(NTSD-1) * DT / 3600.
!
    IF (PRINT_DIAG .AND. TIME_MODEL >= THOUR_PRINT) THEN
        CALL MPI_REDUCE(NSTATS , NSTATS_0 , ITHILO_N , MPI_INTEGER, MPI_SUM, 0, MPI_COMM_COMP,IRTN)
        CALL MPI_REDUCE(QMAX   , QMAX_0   , ITHILO_QM, MPI_REAL   , MPI_MAX, 0, MPI_COMM_COMP,IRTN)
        CALL MPI_REDUCE(PRECMAX, PRECMAX_0, 2        , MPI_REAL   , MPI_MAX, 0, MPI_COMM_COMP,IRTN)
        CALL MPI_REDUCE(QTOT   , QTOT_0   , ITHILO_QT, MPI_REAL   , MPI_SUM, 0, MPI_COMM_COMP,IRTN)
        CALL MPI_REDUCE(PRECTOT, PRECTOT_0, 2        , MPI_REAL   , MPI_SUM, 0, MPI_COMM_COMP,IRTN)
!
        IF (MYPE == 0) THEN
            HDTPH = 3600. / DTPH ! CONVERT PRECIP RATES TO MM/H
!
            DO K=ITLO,ITHI
                QMAX_0(K,1) = 1000. * QMAX_0(K,1)
                QMAX_0(K,2) = 1000. * QMAX_0(K,2)
                QMAX_0(K,3) = 1000. * QMAX_0(K,3)
                QMAX_0(K,4) = HDTPH * QMAX_0(K,4)
                QMAX_0(K,5) = HDTPH * QMAX_0(K,5)
            END DO
!
            PRECMAX_0(1) = HDTPH * PRECMAX_0(1)
            PRECMAX_0(2) = HDTPH * PRECMAX_0(2)
        
            WRITE(6,"(A,F5.2,4(A,G11.4))") '{ TIME(H)=',TIME_MODEL,'  TRAIN_SFC=',PRECTOT_0(1),   &
    &       '  TSNOW_SFC=',PRECTOT_0(2),'  RRMAX_SFC(MM/H)=',PRECMAX_0(1),                        &
    &       '  SRMAX_SFC(MM/H)=',PRECMAX_0(2)
!  
            WRITE(6,"(3A)") '{ (C) <--------- COUNTS ----------> ',                               &
    &       '<----------- G/KG ----------> <----- MM/H ------>'   ,                               &
            ' <---- KG/M**2 * # GRIDS ---->'
!
            WRITE(6,"(3A)") '{  T     NCICE  NCMIX  NCWAT NCRAIN  '       ,                       &
    &       'QIMAX     QWMAX     QRMAX     SRMAX     RRMAX     QITOT     ',                       &
    &       'QWTOT     QRTOT'
!
            DO K=ITLO,ITHI
                WRITE(6,"(A,I3,I9,3I7,8G10.4)") '{ ', K, (NSTATS_0(K,II), II=1,4),                &
    &                                                      (QMAX_0(K,JJ), JJ=1,5),                &
    &                                                      (QTOT_0(K,KK), KK=1,3)
            END DO
 !       
            WRITE(6,"(3A)") '{  T   TCOND     TICND     TIEVP     TIDEP     TREVP     ',          &
    &       'TRAUT     TRACW     TIMLT     TIACW     TIACWI    TIACWR    ','TIACR'
!
            DO K=ITLO,ITHI
                WRITE(6,"(A,I3,12G10.4)") '{ ',K,(QTOT_0(K,II), II=4,15)
            END DO
!        
            WRITE(6,"(2A)") '{  T   DEL_QT   TVDIF   DEL_HYD        TWDIF  TIDIF       ',         &
    &       'TRDIF    DARAIN   DASNOW    RIMEF'
!
            DO K=ITLO,ITHI
                DEL_HYD = 0.
!
                DO II=17,19
                    DEL_HYD = DEL_HYD + QTOT_0(K,II)
                END DO
!
                DEL_QT = 0.
!
                DO II=16,21
                    DEL_QT = DEL_QT + QTOT_0(K,II)
                END DO
!
                IF (QTOT_0(K,22) > 0.) THEN
                    RIMEF_BULK = QTOT_0(K,1) / QTOT_0(K,22)
                ELSE
                    RIMEF_BULK = 1.
                END IF
!
                WRITE(6,"(A,I3,9G10.4)") '{ ', K, DEL_QT, QTOT_0(K,16),            DEL_HYD   ,    &
    &                                                    (QTOT_0(K,II), II=17,21), RIMEF_BULK
            END DO
!       
        END IF
!
        NSTATS  = 0     ! MICROPHYSICAL STATISTICS DEALING W/ GRID-POINT COUNTS
        QMAX    = 0.    ! MICROPHYSICAL STATISTICS DEALING W/ HYDROMETEOR MASS
        QTOT    = 0.    ! MICROPHYSICAL STATISTICS DEALING W/ HYDROMETEOR MASS
        PRECMAX = 0.    ! MAXIMUM PRECIP RATES (RAIN, SNOW) AT SURFACE (MM/H)
        PRECTOT = 0.    ! TOTAL PRECIPITATION (RAIN, SNOW) ACCUMULATION AT SURFACE
!
        THOUR_PRINT = THOUR_PRINT + DTHOUR_PRINT
    END IF
!----------------------- 
! RETURN TO MAIN PROGRAM 
!----------------------- 
    RETURN
!
200 FORMAT(A2,I5,F6.2,4(1X,A10,G11.4))
210 FORMAT(A2,I5,F6.2,4(1X,A10,I7))
!
    END SUBROUTINE GSMDRIVE

    SUBROUTINE PGCOR
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PGCOR
!>
!> SUBROUTINE: PGCOR - PRESSURE GRADIENT/CORIOLIS CALC
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-10-28
!>
!> ABSTRACT:
!> PGCOR CALCULATES THE PRESSURE GRADIENT FORCE, UPDATES THE VELOCITY COMPONENTS DUE TO THE EFFECT
!> OF THE PRESSURE GRADIENT AND CORIOLIS FORCES.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-29  BLACK      - ADDED EXTERNAL EDGE
!> 97-03-17  MESINGER   - SPLIT FROM PFDHT
!> 98-10-28  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 00-10-20  BLACK      - INCORPORATED PRESSURE GRADIENT METHOD FROM MESO MODEL
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : DIGFLT
!>              EBU
!>              NEWFLT
!>
!> CALLS      : ZERO2         
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R8KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM+1)                             ::&
    & PINTLG

    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & FIM     ,                                                                                   &
    & FILO    , RDPD    ,                                                                         &
    & ADPDX   , RDPDX   ,                                                                         &
    & ADPDY   , RDPDY   ,                                                                         &
    & ADPDNE  , ADPDSE  ,                                                                         &
    & PEW     , PNS     ,                                                                         &
    & PCEW    , PCNS    ,                                                                         &
    & DPFEW   , DPFNS   ,                                                                         &
    & FNS     , TNS     ,                                                                         &
    & HM      , VM    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DPDE    ,                                                                                   &
    & PNE     , PSE     ,                                                                         &
    & CNE     , CSE     ,                                                                         &
    & PPNE    , PPSE    ,                                                                         &
    & PCNE    , PCSE  
!
    REAL   (KIND=R8KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & APEL    ,                                                                                   &
    & ALP1    ,                                                                                   &
    & DFDZ    
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & RDPDS   , FIUPK   , F0K     ,                                                               &
    & DPNEK   , DPSEK   ,                                                                         &
    & DCNEK   , DCSEK   ,                                                                         &
    & DPFNEK  , DPFSEK  ,                                                                         &
    & UPK     , VPK     ,                                                                         &
    & UTK     , VTK 
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & ALP1P   , ALP1PL  ,                                                                         &
    & ALP2P   , ALP2PL  ,                                                                         &
    & DFI     ,                                                                                   &
    & TMP1    , TMP2    , TMP3
!
    CALL ZERO2(DPDE)
    CALL ZERO2(APEL)
    CALL ZERO2(ADPDX)
    CALL ZERO2(ADPDY)
    CALL ZERO2(DFDZ)
    CALL ZERO2(PNE)
    CALL ZERO2(PSE)
    CALL ZERO2(CNE)
    CALL ZERO2(CSE)
    CALL ZERO2(PPNE)
    CALL ZERO2(PPSE)
    CALL ZERO2(PCNE)
    CALL ZERO2(PCSE)
!------------------------- 
! PREPARATORY CALCULATIONS 
!------------------------- 
    IF (SIGMA) THEN
!
!$omp parallel do 
!
        DO 50 J=MYJS_P5,MYJE_P5
            DO 50 I=MYIS_P5,MYIE_P5
                FILO(I,J) = FIS(I,J)
                PDSL(I,J) =  PD(I,J)
     50 END DO
!
    ELSE
!
!$omp parallel do  
!
        DO 100 J=MYJS_P5,MYJE_P5
            DO 100 I=MYIS_P5,MYIE_P5
                FILO(I,J) = 0.0
                PDSL(I,J) = RES(I,J) * PD(I,J)
    100 END DO
    END IF
!
    IF (HYDRO) THEN
!
!$omp parallel do 
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    TMP1=ETA(K)
                    TMP2=PDSL(I,J)
                    TMP3=PT
                    PINTLG(I,J,K) = DLOG(TMP1 * TMP2 + TMP3)
                END DO
            END DO
        END DO
    ELSE
!
!$omp parallel do  
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    TMP1=PINT(I,J,K)
                    PINTLG(I,J,K) = DLOG(TMP1)
                    IF (K > 1) THEN
                        IF (PINTLG(I,J,K) == PINTLG(I,J,K-1)) THEN
                            WRITE(6,*) 'SAME PINTLG AT DIFFERENT LEVELS: ', MYPE,I,J,K,LMH(I,J)
                            WRITE(6,*) 'PINT VALS: ', PINT(I,J,K  ), PINT(I,J,K-1),               &
    &                                                 PINT(I,J,K-2), PINT(I,J,K-3)
!
                            TMP1=ETA(K)
                            TMP2=PDSL(I,J)
                            TMP3=PT
                            PINTLG(I,J,K) = DLOG(TMP1 * TMP2 + TMP3)

!                            PINT(I,J,K) = PDSL(I,J) * DETA(K) + PINT(I,J,K-1)
!                            TMP1=PINT(I,J,K)
!                            PINTLG(I,J,K) = DLOG(TMP1)
!
                            IF (PINTLG(I,J,K) == PINTLG(I,J,K-1)) THEN
                               TMP1=ETA(K-1)
                               TMP2=PDSL(I,J)
                               TMP3=PT
                               PINTLG(I,J,K-1) = DLOG(TMP1 * TMP2 + TMP3)

!                                PINT(I,J,K-1) = PDSL(I,J) * DETA(K) + PINT(I,J,K-2)
!                                TMP1=PINT(I,J,K-1)
!                                PINTLG(I,J,K-1) = DLOG(TMP1)
                                IF (PINTLG(I,J,K) == PINTLG(I,J,K-1)) THEN
                                    WRITE(6,*) 'SAME PINTLG_NEW AT DIFFERENT LEVELS: ', MYPE   ,  &
    &                                                                                  I       ,  &
    &                                                                                  J       ,  &
    &                                                                                  K       ,  &
    &                                                                                  LMH(I,J)
!
                                    WRITE(6,*) 'PINT_NEW VALS: ', PINT(I,J,K), PINT(I,J,K-1)
                                    STOP 700
                               END IF
                            END IF
                        END IF
                    END IF
                END DO
            END DO
        END DO
    END IF
!
!$omp parallel do private (ALP1P)
!
    DO J=MYJS_P5,MYJE_P5
        DO I=MYIS_P5,MYIE_P5
            ALP1P     = PINTLG(I,J,LM+1)
            ALP1(I,J) = ALP1P
        END DO
    END DO
!------------------------------- 
! MAIN VERTICAL INTEGRATION LOOP 
!------------------------------- 
    FIM = 0.
!
    DO 400 K=LM,1,-1
!--------------------------- 
! INTEGRATE THE GEOPOTENTIAL
!--------------------------- 
!
!$omp parallel do private (ALP1P  , DFI     , FIUPK   , RDPDS)
!
        doout125: DO J=MYJS_P5,MYJE_P5
            doin125: DO I=MYIS_P5,MYIE_P5
!            
                ALP1P = PINTLG(I,J,K)
!            
                DFI = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1(I,J) - ALP1P) / DWDT(I,J,K)
!
                IF (ABS(DFI) < 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD DFI: '  , DFI
                    WRITE(6,*) 'I,J,K,Q,T: ', I,J,K      , Q(I,J,K)   , T(I,J,K)
                    WRITE(6,*) 'ALP VALS: ' , ALP1(I,J)  , ALP1P
                    WRITE(6,*) 'DWDT= '     , DWDT(I,J,K)
                END IF
!           
                RDPDS = 1. / (DETA(K) * PDSL(I,J))
                FIUPK = FILO(I,J) + DFI
!
                IF (ABS(FIUPK) < 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD FIUPK.  FILO, DFI ', FILO(I,J), DFI
                END IF
!
                 FIM(I,J) = FILO(I,J) + FIUPK
            
                FILO(I,J) = (FIUPK - DFL(K)) * HTM(I,J,K) + DFL(K)
!
                IF (ABS(FILO(I,J)) < 20000000.) THEN
                ELSE
                    WRITE(6,*) 'BAD FILO VALUE ', FILO(I,J),' ON PE: ' ,MYPE, 'AT ', I, J
                    WRITE(6,*) 'FIUPK,DFL: ', FIUPK, DFL(K)
                    STOP 999
                END IF
!
                ALP1(I,J) = ALP1P
            END DO doin125
         END DO doout125
!
!$omp parallel do private (ALP1P  , ALP1PL  , ALP2P   , ALP2PL  , DFI)
!
        DO 205 J=MYJS_P5,MYJE_P5
            DO 205 I=MYIS_P5,MYIE_P5
                HM(I,J) = HTM(I,J,K) * HBM2(I,J)
                VM(I,J) = VTM(I,J,K) * VBM2(I,J)
!            
                ALP1P  = PINTLG(I,J,K  )
                ALP1PL = PINTLG(I,J,K+1)
                ALP2P  = ALP1P  * ALP1P
                ALP2PL = ALP1PL * ALP1PL
!            
                DFI = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1PL - ALP1P) / DWDT(I,J,K)
!
                IF (ABS(DFI) <= 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD DFI     '   , DFI
                END IF
!
                IF (ABS(DWDT(I,J,K)) <= 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD DWDTI     ' , DWDT(I,J,K)
                END IF

                IF (ABS(ALP2PL) <= 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD ALP2PL     ', ALP2PL
                END IF

                IF (ABS(ALP2P) <= 2.E13) THEN
                ELSE
                    WRITE(6,*) 'BAD ALP2P     ' , ALP2P
                END IF
!            	
                DFDZ(I,J) = DFI * DWDT(I,J,K) / (ALP2PL - ALP2P)
!
                IF (ABS(DFDZ(I,J)) <= 2.E13) THEN
                ELSE
                    WRITE(6,*) 'ON PE: '     , MYPE
                    WRITE(6,*) 'AT = '       , I,J,K
                    WRITE(6,*) 'DFDZ= '      , DFDZ(I,J)
                    WRITE(6,*) 'DFI= '       , DFI
                    WRITE(6,*) 'DWDT= '      , DWDT(I,J,K)
                    WRITE(6,*) 'DENOM= '     , ALP2PL - ALP2P
                    WRITE(6,*) 'PINTLG(K) '  , PINTLG(I,J,K)
                    WRITE(6,*) 'PINTLG(K+1) ', PINTLG(I,J,K+1)
                END IF
!
                APEL(I,J) = (ALP2PL + ALP2P) * 0.5
                DPDE(I,J) = DETA(K) * PDSL(I,J)
    205 END DO
!
!$omp parallel do
! 
        DO 215 J=MYJS_P1,MYJE_P1
            DO 215 I=MYIS_P1,MYIE_P1
                RDPD(I,J) = 1. / DPDE(I,J)
        215 END DO
!
!$omp parallel do 
!
        DO 220 J=MYJS1_P3,MYJE1_P3
            DO 220 I=MYIS_P3,MYIE_P3
                ADPDX(I,J) = DPDE(I+IVW(J),J  ) + DPDE(I+IVE(J),J  )
                ADPDY(I,J) = DPDE(I       ,J-1) + DPDE(I       ,J+1)
                RDPDX(I,J) = 1./ ADPDX(I,J)
                RDPDY(I,J) = 1./ ADPDY(I,J)
    220 END DO
!--------------------------------------------------     
! DIAGONAL CONTRIBUTIONS TO PRESSURE GRADIENT FORCE 
!--------------------------------------------------  
!  
!$omp parallel do 
!
        IF (MYPE == 5 .AND. K == LM) THEN
            I = MYIE_P4
            J = MYJE_P4 - 2
        END IF
!
        DO 240 J=MYJS_P4,MYJE_P4
            DO 240 I=MYIS_P4,MYIE_P4
                ADPDNE(I,J) = DPDE(I+IHE(J),J+1) + DPDE(I,J)
!
                IF (ABS(FIM (I+IHE(J),J+1)) < 2000000.) THEN
                ELSE
                    WRITE(6,*) 'USING FIM VAL: ', FIM (I+IHE(J),J+1), 'AT POINT',I+IHE(J),J+1,    &
    &                          'ON PE: ', MYPE
                END IF
!
                 PNE(I,J) = (FIM (I+IHE(J),J+1)   - FIM (I,J))                                    &
    &                     * (DWDT(I+IHE(J),J+1,K) + DWDT(I,J,K))
!
                PPNE(I,J) = PNE(I,J) * ADPDNE(I,J)
!
                 CNE(I,J) = (DFDZ(I+IHE(J),J+1) + DFDZ(I,J)) * 2.                                 &
    &                     * (APEL(I+IHE(J),J+1) - APEL(I,J))
!
                PCNE(I,J) = CNE(I,J) * ADPDNE(I,J)
    240 END DO
!
!$omp parallel do 
!
        DO 250 J=MYJS1_P4,MYJE_P4
            DO 250 I=MYIS_P4,MYIE1_P4
                ADPDSE(I,J) = DPDE(I+IHE(J),J-1) + DPDE(I,J)
!
                   PSE(I,J) = (FIM (I+IHE(J),J-1)   - FIM (I,J))                                  &
    &                       * (DWDT(I+IHE(J),J-1,K) + DWDT(I,J,K))
!
                  PPSE(I,J) = PSE(I,J)*ADPDSE(I,J)
!
                   CSE(I,J) = (DFDZ(I+IHE(J),J-1) + DFDZ(I,J)) * 2.                               &
    &                       * (APEL(I+IHE(J),J-1) - APEL(I,J))
!
                  PCSE(I,J) = CSE(I,J) * ADPDSE(I,J)
    250 END DO
!---------------------------------------    
! LAT AND LONG PRESSURE FORCE COMPONENTS 
!---------------------------------------    
! 
!$omp parallel do private (DCNEK  , DCSEK   , DPNEK   , DPSEK)
!
        DO 280 J=MYJS1_P3,MYJE1_P3
            DO 280 I=MYIS_P3,MYIE_P3
                DPNEK = PNE(I+IVW(J),J) + PNE(I,J-1)
                DPSEK = PSE(I+IVW(J),J) + PSE(I,J+1)
!
                PEW(I,J) = DPNEK + DPSEK
                PNS(I,J) = DPNEK - DPSEK
!
                DCNEK = CNE(I+IVW(J),J) + CNE(I,J-1)
                DCSEK = CSE(I+IVW(J),J) + CSE(I,J+1)
!
                PCEW(I,J) = (DCNEK + DCSEK) * ADPDX(I,J)
                PCNS(I,J) = (DCNEK - DCSEK) * ADPDY(I,J)
    280 END DO
!----------------------------------      
! UPDATE U AND V (CORIOLIS AND PGF) 
!----------------------------------  
!   
!$omp parallel do private (DPFNEK , DPFSEK)
!
        DO 290 J=MYJS2_P3,MYJE2_P3
            DO 290 I=MYIS_P3,MYIE1_P3
                DPFNEK = ((PPNE(I+IVW(J),J)+PPNE(I,J-1))                                          &
    &                  +  (PCNE(I+IVW(J),J)+PCNE(I,J-1))) * 2.
!
                DPFSEK = ((PPSE(I+IVW(J),J)+PPSE(I,J+1))                                          &
    &                  +  (PCSE(I+IVW(J),J)+PCSE(I,J+1))) * 2.
!
                DPFEW(I,J) = DPFNEK + DPFSEK
                DPFNS(I,J) = DPFNEK - DPFSEK
    290 END DO
!
!$omp parallel do private (F0K    , UPK     , UTK     , VPK     , VTK)
!
        DO 300 J=MYJS2_P2,MYJE2_P2
            DO 300 I=MYIS_P2,MYIE1_P2
                F0K     =   U(I,J,K) * CURV(I,J) + F(I,J)
                VM(I,J) = VTM(I,J,K) * VBM2(I,J)
!
                UPK = ((DPFEW(I,J) + PCEW(I,J)) * RDPDX(I,J)   + PEW(I,J))                        &
    &               *   CPGFU(I,J) + F0K        *     V(I,J,K) +   U(I,J,K)
!
                VPK = ((DPFNS(I,J) + PCNS(I,J)) * RDPDY(I,J)   + PNS(I,J))                        &
    &               *   CPGFV      - F0K        *     U(I,J,K) +   V(I,J,K)
!
                UTK = U(I,J,K)
                VTK = V(I,J,K)
!
                U(I,J,K) = ((F0K * VPK + UPK)     / (F0K * F0K + 1.) - UTK) * VM(I,J) + UTK
                V(I,J,K) =  (VPK - F0K * U(I,J,K)                    - VTK) * VM(I,J) + VTK
    300 END DO
!
400 END DO
!
    RETURN
!
    END SUBROUTINE PGCOR

    MODULE CO2BD4
!>--------------------------------------------------------------------------------------------------
!> MODULE CO2BD4
!>
!> ABSTRACT:
!> MODULE CO2BD4 CONTAINS CO2 TRANSMISSION FUNCTIONS AND TEMPERATURE AND PRESSURE DERIVATIVES FOR 
!> THE 670-800 CM-1 PART OF THE 15 UM CO2 BAND. THESE DATA ARE IN BLOCK DATA BD4.
!>
!> CO271 - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)=1013.25 MB
!> CO278 - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)= ^810 MB
!> CDT71 - FIRST  TEMPERATURE DERIVATIVE OF CO271
!> CDT78 - FIRST  TEMPERATURE DERIVATIVE OF CO278
!> C2D71 - SECOND TEMPERATURE DERIVATIVE OF CO271
!> C2D78 - SECOND TEMPERATURE DERIVATIVE OF CO271
!>
!> USE MODULES: F77KINDS
!>              RDPARM
!>
!> DRIVER     : CO2DTA
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : LP1
!
    IMPLICIT NONE
!
    SAVE
! 
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & CO271   , CO278   , CDT71   , CDT78   , C2D71   , C2D78
! 
    END MODULE CO2BD4

    SUBROUTINE GOSSIP
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GOSSIP
!>
!> SUBPROGRAM: GOSSIP - EXCHANGE OF FIELDS BETWEEN PROCESSORS
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 97-08-30
!>
!> ABSTRACT:
!> GOSSIP EXCHANGES MANY FIELDS BETWEEN PROCESSORS IN ORDER TO FILL THE HALOES
!>
!> PROGRAM HISTORY LOG:
!> 97-05-??  MEYS       - ORIGINATOR
!> 98-10-23  BLACK      - MODIFIED FOR CURRENT VERSION OF MODEL
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: ACMCLD
!>              ACMCLH
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS 
!>              ACMSFC
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              DYNAM
!>              F77KINDS 
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              RDPARM
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>              Z0EFFT
!>
!> DRIVER     : EBU
!>
!> CALLS      : EXCH
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE RDPARM   , ONLY : LP1
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
    USE Z0EFFT
!
    IMPLICIT NONE   
!
    INCLUDE "EXCHM.h"
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & J
!
#include "sp.h"   
!--------------- 
! THE NHB ARRAYS
!---------------    
    CALL EXCH(LMH    , 1    , 5 , 5)
    CALL EXCH(LMV    , 1    , 5 , 5)
    CALL EXCH(HBM2   , 1    , 5 , 5)
    CALL EXCH(HBM3   , 1    , 5 , 5)
    CALL EXCH(VBM2   , 1    , 5 , 5)
    CALL EXCH(VBM3   , 1    , 5 , 5)
    CALL EXCH(SM     , 1    , 5 , 5)
    CALL EXCH(SICE   , 1    , 5 , 5)
    CALL EXCH(HTM    , LM   , 5 , 5)
    CALL EXCH(VTM    , LM   , 5 , 5)
    CALL EXCH(DX     , 1    , 5 , 5)
    CALL EXCH(WPDAR  , 1    , 5 , 5)
    CALL EXCH(CPGFU  , 1    , 5 , 5)
    CALL EXCH(CURV   , 1    , 5 , 5)
    CALL EXCH(FCP    , 1    , 5 , 5)
    CALL EXCH(FDIV   , 1    , 5 , 5)
    CALL EXCH(FAD    , 1    , 5 , 5)
    CALL EXCH(F      , 1    , 5 , 5)
    CALL EXCH(DDMPU  , 1    , 5 , 5)
    CALL EXCH(DDMPV  , 1    , 5 , 5)
    CALL EXCH(GLAT   , 1    , 5 , 5)
    CALL EXCH(GLON   , 1    , 5 , 5)
    CALL EXCH(MXSNAL , 1    , 5 , 5)
    CALL EXCH(EPSR   , 1    , 5 , 5)
    CALL EXCH(TG     , 1    , 5 , 5)
    CALL EXCH(GFFC   , 1    , 5 , 5)
    CALL EXCH(SST    , 1    , 5 , 5)
    CALL EXCH(ALBASE , 1    , 5 , 5)
    CALL EXCH(HDAC   , 1    , 5 , 5)
    CALL EXCH(HDACV  , 1    , 5 , 5)
    CALL EXCH(IVGTYP , 1    , 5 , 5)
    CALL EXCH(ISLTYP , 1    , 5 , 5)
    CALL EXCH(ISLOPE , 1    , 5 , 5)
    CALL EXCH(VEGFRC , 1    , 5 , 5)
!-----------------------  
! THE RESTRT FILE ARRAYS
!----------------------- 
    CALL EXCH (OMGALF, LM   , 5 , 5)
    CALL EXCH (PD    , 1    , 5 , 5)
    CALL EXCH (RES   , 1    , 5 , 5)
    CALL EXCH (FIS   , 1    , 5 , 5)
    CALL EXCH (T     , LM   , 5 , 5)
    CALL EXCH (U     , LM   , 5 , 5)
    CALL EXCH (V     , LM   , 5 , 5)
    CALL EXCH (Q     , LM   , 5 , 5)
    CALL EXCH (Q2    , LM   , 5 , 5)
    CALL EXCH (CWM   , LM   , 5 , 5)
    CALL EXCH (TRAIN , LM   , 5 , 5)
    CALL EXCH (TCUCN , LM   , 5 , 5)
    CALL EXCH (RSWIN , 1    , 5 , 5)
    CALL EXCH (RSWOUT, 1    , 5 , 5)
    CALL EXCH (TG    , 1    , 5 , 5)
    CALL EXCH (Z0    , 1    , 5 , 5)
    CALL EXCH (AKMS  , 1    , 5 , 5)
    CALL EXCH (CZEN  , 1    , 5 , 5)
    CALL EXCH (AKHS  , 1    , 5 , 5)
    CALL EXCH (THS   , 1    , 5 , 5)
    CALL EXCH (QS    , 1    , 5 , 5)
    CALL EXCH (TWBS  , 1    , 5 , 5)
    CALL EXCH (QWBS  , 1    , 5 , 5)
    CALL EXCH (HBOT  , 1    , 5 , 5)
    CALL EXCH (CFRACL, 1    , 5 , 5)
    CALL EXCH (THZ0  , 1    , 5 , 5)
    CALL EXCH (QZ0   , 1    , 5 , 5)
    CALL EXCH (UZ0   , 1    , 5 , 5)
    CALL EXCH (VZ0   , 1    , 5 , 5)
    CALL EXCH (USTAR , 1    , 5 , 5)
    CALL EXCH (HTOP  , 1    , 5 , 5)
    CALL EXCH (CFRACM, 1    , 5 , 5)
    CALL EXCH (SNO   , 1    , 5 , 5)
    CALL EXCH (SI    , 1    , 5 , 5)
    CALL EXCH (CLDEFI, 1    , 5 , 5)
    CALL EXCH (RF    , 1    , 5 , 5)
    CALL EXCH (CUPPT , 1    , 5 , 5)
    CALL EXCH (CFRACH, 1    , 5 , 5)
    CALL EXCH (SOILTB, 1    , 5 , 5)
    CALL EXCH (SFCEXC, 1    , 5 , 5)
    CALL EXCH (SMSTAV, 1    , 5 , 5)
    CALL EXCH (SMSTOT, 1    , 5 , 5)
    CALL EXCH (GRNFLX, 1    , 5 , 5)
    CALL EXCH (PCTSNO, 1    , 5 , 5)
    CALL EXCH (RLWIN , 1    , 5 , 5)
    CALL EXCH (RADOT , 1    , 5 , 5)
    CALL EXCH (CZMEAN, 1    , 5 , 5)
    CALL EXCH (SIGT4 , 1    , 5 , 5)
    CALL EXCH (U00   , 1    , 5 , 5)
    CALL EXCH (LC    , 1    , 5 , 5)
    CALL EXCH (SR    , 1    , 5 , 5)
    CALL EXCH (PREC  , 1    , 5 , 5)
    CALL EXCH (ACPREC, 1    , 5 , 5)
    CALL EXCH (ACCLIQ, 1    , 5 , 5)
    CALL EXCH (CUPREC, 1    , 5 , 5)
    CALL EXCH (ACFRCV, 1    , 5 , 5)
    CALL EXCH (NCFRCV, 1    , 5 , 5)
    CALL EXCH (ACFRST, 1    , 5 , 5)
    CALL EXCH (NCFRST, 1    , 5 , 5)
    CALL EXCH (ACSNOW, 1    , 5 , 5)
    CALL EXCH (ACSNOM, 1    , 5 , 5)
    CALL EXCH (SSROFF, 1    , 5 , 5)
    CALL EXCH (BGROFF, 1    , 5 , 5)
    CALL EXCH (SFCSHX, 1    , 5 , 5)
    CALL EXCH (SFCLHX, 1    , 5 , 5)
    CALL EXCH (SUBSHX, 1    , 5 , 5)
    CALL EXCH (SNOPCX, 1    , 5 , 5)
    CALL EXCH (SFCUVX, 1    , 5 , 5)
    CALL EXCH (SFCEVP, 1    , 5 , 5)
    CALL EXCH (POTEVP, 1    , 5 , 5)
    CALL EXCH (ASWIN , 1    , 5 , 5)
    CALL EXCH (ASWOUT, 1    , 5 , 5)
    CALL EXCH (ASWTOA, 1    , 5 , 5)
    CALL EXCH (ALWIN , 1    , 5 , 5)
    CALL EXCH (ALWOUT, 1    , 5 , 5)
    CALL EXCH (ALWTOA, 1    , 5 , 5)
    CALL EXCH (SMC   , NSOIL, 5 , 5)
    CALL EXCH (CMC   , 1    , 5 , 5)
    CALL EXCH (STC   , NSOIL, 5 , 5)
    CALL EXCH (SH2O  , NSOIL, 5 , 5)
    CALL EXCH( ALBEDO, 1    , 5 , 5)
    CALL EXCH (PINT  , LM+1 , 5 , 5)
    CALL EXCH (Z     , LM+1 , 5 , 5)
    CALL EXCH (DWDT  , LM   , 5 , 5)
!
    DO J=MYJS_P4,MYJE_P4
        IVW(J) = IVWG(J + MY_JS_GLB - 1)
        IVE(J) = IVEG(J + MY_JS_GLB - 1)
        IHE(J) = IHEG(J + MY_JS_GLB - 1)
        IHW(J) = IHWG(J + MY_JS_GLB - 1)
    END DO
!
    CALL EXCH (ZEFFIJ, 4    , 5 , 5)
!
    RETURN
!
    END SUBROUTINE GOSSIP

    SUBROUTINE TTBLEX(TREF, TTBL, ITB , JTB , KNUM , IARR , JARR, PDSL , AETAL, HTML, PT, PL, QQ, &
    &                   PP, RDP , THE0, STHE, RDTHE, THESP, IPTB, ITHTB)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE TTBLEX
!>
!> SUBPROGRAM: TTBLEX - DESIGNED TO DUPLICATE TIMEF
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> EXTRACT TEMPERATURE OF THE MOIST ADIABAT FROM THE APPROPRIATE TTBL
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> TTBL  - 
!> ITB   - 
!> JTB   - 
!> KNUM  -
!> IARR  -
!> JARR  - 
!> PDSL  -
!> AETAL -
!> HTML  - 
!> PT    - 
!> PL    -
!> RDP   - 
!> THE0  -
!> STHE  - 
!> RDTHE -
!> THESP - 
!> IPTB  - 
!>
!> OUTPUT ARGUMENT LIST:
!> TREF  - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> QQ    -
!> PP    -
!> IPTB  - 
!> ITHTB - 

!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : CUCNVC
!>
!> CALLS      : -----
!>-------------------------------------------------------------------------------------------------- 
    USE F77KINDS
    USE GLB_TABLE    
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM_LOC = IDIM2 * JDIM2
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM     = IM    *    JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: IMXJM    = IM    *    JM
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & TREF
!
    REAL   (KIND=R4KIND), DIMENSION(JTB,ITB)                              , INTENT(IN)          ::&
    & TTBL
!
    REAL   (KIND=R4KIND), DIMENSION(ITB)                                  , INTENT(IN)          ::&
    & THE0    , STHE
!
    INTEGER(KIND=I4KIND), DIMENSION(IMJM_LOC)                             , INTENT(IN)          ::&
    & IARR    , JARR
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(IN)          ::&
    & PDSL    , THESP   , HTML
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & PP      , QQ     
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & IPTB    , ITHTB    
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & PT      , PL      , RDP     , RDTHE         
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITB     , JTB     , KNUM    , I       , J       , IPTBK   , ITH     , IP      , KK     
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & AETAL   , PK      , TPK     , BTHE00K , STHE00K , BTHE10K , STHE10K , BTHK    , STHK    ,   &
    & TTHK    , T00K    , T10K    , T01K    , T11K 
!
    DO 500 KK=1,KNUM
!---------------------------------- 
! SCALING PRESSURE & TT TABLE INDEX
!---------------------------------- 
        I         = IARR(KK)
        J         = JARR(KK)
         PK       = PDSL(I,J) * AETAL + PT
        TPK       = (PK - PL) * RDP
          QQ(I,J) = TPK - AINT(TPK)
        IPTB(I,J) = INT(TPK) + 1
!--------------------------------- 
! KEEPING INDICES WITHIN THE TABLE 
!--------------------------------- 
        IF (IPTB(I,J) < 1) THEN
            IPTB(I,J) = 1
              QQ(I,J) = 0.
        END IF
!
        IF (IPTB(I,J) >= ITB) THEN
            IPTB(I,J) = ITB - 1
              QQ(I,J) = 0.
        END IF
!-------------------------------- 
! BASE AND SCALING FACTOR FOR THE 
!--------------------------------- 
        IPTBK = IPTB(I,J)
        BTHE00K = THE0(IPTBK)
        STHE00K = STHE(IPTBK)
        BTHE10K = THE0(IPTBK + 1)
        STHE10K = STHE(IPTBK + 1)
!------------------------------- 
! SCALING THE AND TT TABLE INDEX 
!------------------------------- 
        BTHK = (BTHE10K    - BTHE00K) * QQ(I,J) + BTHE00K
        STHK = (STHE10K    - STHE00K) * QQ(I,J) + STHE00K
        TTHK = (THESP(I,J) - BTHK)    / STHK    * RDTHE
!
           PP(I,J) = TTHK - AINT(TTHK)
        ITHTB(I,J) = INT(TTHK) + 1
!--------------------------------- 
! KEEPING INDICES WITHIN THE TABLE
!--------------------------------- 
        IF (ITHTB(I,J) < 1) THEN
            ITHTB(I,J) = 1
               PP(I,J) = 0.
        END IF
!
        IF (ITHTB(I,J) >= JTB) THEN
            ITHTB(I,J) = JTB - 1
               PP(I,J) = 0.
        END IF
!---------------------------------------------- 
! TEMPERATURE AT FOUR SURROUNDING TT TABLE PTS. 
!----------------------------------------------
        ITH  = ITHTB(I,J)
        IP   =  IPTB(I,J)
        T00K = TTBL(ITH  ,IP  )
        T10K = TTBL(ITH+1,IP  )
        T01K = TTBL(ITH  ,IP+1)
        T11K = TTBL(ITH+1,IP+1)
!------------------- 
! PARCEL TEMPERATURE
!-------------------
        TREF(I,J) = (T00K + (T10K - T00K)        * PP(I,J) + (T01K - T00K)    * QQ(I,J)                     &
    &             + (T00K - T10K  - T01K + T11K) * PP(I,J)                    * QQ(I,J)) * HTML(I,J)
!
500 END DO
!
    RETURN
!
    END SUBROUTINE TTBLEX

    SUBROUTINE CLO89(CLDFAC, CAMT, NCLDS, KBTM, KTOP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE CLO89
!>
!> SUBPROGRAM: CLO89 - ?????
!> PROGRAMMER: Q. ZHAO
!> ORG: W/NP2
!> DATE: 95-03-22
!>
!> ABSTRACT: 
!> COMPUTES CLOUD TRANSMISSION FUNCTIONS FOR THE LONGWAVE CODE,USING CODE WRITTEN BY BERT
!> KATZ (301-763-8161) AND MODIFIED BY DAN SCHWARZKOPF IN DECEMBER, 1988.
!>
!> PROGRAM HISTORY LOG:
!> 95-03-22  Q. ZHAO  - ORIGINATOR            
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> CAMT   -
!> KTOP   -
!> KBTM   -
!> NCLDS  -
!>
!> OUTPUT ARGUMENT LIST:
!> CLDFAC -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              TEMPCOM
!>              TOPO
!> 
!> DRIVER     : RADFS
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!----------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
!
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS.
!
! NB,KO2 ARE SHORTWAVE PARAMETERS; OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS
!----------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: IMAX   = IM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLY   = 15
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1    = L     + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1V   = LP1   * (1 + 2 * L / 2)
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IQ      , ITOP    , JTOP    , IP      , IR      , J       , I       , K1      , K2      ,   &
    & KB      , K       , KP      , KT      , NC
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & XCLD
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & NCLDS
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & KTOP    , KBTM
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & CAMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                , INTENT(INOUT)       ::&
    & CLDFAC
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & CLDROW
!
    REAL   (KIND=R4KIND), DIMENSION(LP1, LP1, 64)                                               ::&
    & CLDIPT
!
    DO 1 IQ=MYIS,MYIE,64
        ITOP = IQ + 63
        IF (ITOP > MYIE) ITOP = MYIE
        JTOP = ITOP - IQ + 1
        DO 11 IP=1,JTOP
            IR = IQ + IP - 1
!
            IF (NCLDS(IR) == 0) THEN
                DO 25 J=1,LP1
                    DO 25 I=1,LP1
                        CLDIPT(I,J,IP) = 1.
                 25 END DO
            END IF
!
            IF (NCLDS(IR) >= 1) THEN
                XCLD = 1. - CAMT(IR,2)
                K1   = KTOP(IR,2) + 1
                K2   = KBTM(IR,2)
!
                DO 27 J=1,LP1
                    CLDROW(J) = 1.
             27 END DO
!
                DO 29 J=1,K2
                    CLDROW(J) = XCLD
             29 END DO
!
                KB = MAX(K1,K2+1)
!
                DO 33 K=KB,LP1
                    DO 33 KP=1,LP1
                        CLDIPT(KP,K,IP) = CLDROW(KP)
             33 END DO
!
                DO 37 J=1,LP1
                    CLDROW(J) = 1.
             37 END DO
!
                DO 39 J=K1,LP1
                    CLDROW(J) = XCLD
             39 END DO
!
                KT = MIN(K1-1,K2)
!
                DO 43 K=1,KT
                    DO 43 KP=1,LP1
                        CLDIPT(KP,K,IP) = CLDROW(KP)
            43  END DO
!    
                IF (K2+1 <= K1-1) THEN
!
                    DO 31 J=K2+1,K1-1
                        DO 31 I=1,LP1
                            CLDIPT(I,J,IP) = 1.
                 31 END DO
!
                ELSE IF (K1 <= K2) THEN
!
                    DO 32 J=K1,K2
                        DO 32 I=1,LP1
                            CLDIPT(I,J,IP) = XCLD
                 32 END DO
!
                END IF
!    
            END IF
!
            IF (NCLDS(IR) >= 2) THEN
                DO 21 NC=2,NCLDS(IR)
                    XCLD = 1. - CAMT(IR,NC+1)
                    K1 = KTOP(IR,NC+1) + 1
                    K2 = KBTM(IR,NC+1)
!
                    DO 47 J=1,LP1
                        CLDROW(J) = 1.
                 47 END DO
!
                    DO 49 J=1,K2
                        CLDROW(J) = XCLD
                 49 END DO
!
                    KB = MAX(K1,K2+1)
!
                    DO 53 K=KB,LP1
                        DO 53 KP=1,LP1
                            CLDIPT(KP,K,IP) = CLDIPT(KP,K,IP) * CLDROW(KP)
                 53 END DO
!
                    DO 57 J=1,LP1
                        CLDROW(J) = 1.
                 57 END DO
!
                    DO 59 J=K1,LP1
                        CLDROW(J) = XCLD
                 59 END DO
!
                    KT = MIN(K1-1,K2)
                    DO 63 K=1,KT
                        DO 63 KP=1,LP1
                            CLDIPT(KP,K,IP) = CLDIPT(KP,K,IP) * CLDROW(KP)
                 63 END DO
!
                    IF (K1 <= K2) THEN
                        DO 52 J=K1,K2
                            DO 52 I=1,LP1
                                CLDIPT(I,J,IP) = CLDIPT(I,J,IP) * XCLD
                     52 END DO
                    END IF

             21 END DO
            END IF
!
     11 END DO
!
        DO 71 J=1,LP1
            DO 71 I=1,LP1
                DO 71 IP=1,JTOP
                    IR = IQ + IP - 1
                    CLDFAC(IR,I,J) = CLDIPT(I,J,IP)
     71 END DO
!
  1 END DO
!
    RETURN
!
    END SUBROUTINE CLO89

    SUBROUTINE BOCOHF
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE BOCOHF
!>
!> SUBPROGRAM: BOCOH - UPDATE MASS POINTS ON BOUNDARY
!> PROGRAMMER: JANJIC 
!> ORG: W/NP22
!> DATE: 94-03-08
!>
!> ABSTRACT:
!> TEMPERATURE, SPECIFIC HUMIDITY, AND SURFACE PRESSURE ARE UPDATED ON THE DOMAIN BOUNDARY BY 
!> APPLYING THE PRE-COMPUTED TENDENCIES AT EACH TIME STEP.
!>
!> PROGRAM HISTORY LOG:
!> 87-??-??  MESINGER   - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-12-13  BLACK      - FINAL MODIFICATION FOR NESTED RUNS
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 00-01-06  BLACK      - MODIFIED FOR JANJIC NONHYDROSTATIC CODE
!> 00-09-14  BLACK      - MODIFIED FOR DIRECT ACCESS READ
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>  
!> USE MODULES: BOCO
!>              CLDWTR
!>              CTLBLK
!>              DYNAM
!>              GLB_TABLE
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : DIGFLT
!>              NEWFLT
!>
!> CALLS      : MPI_BCAST
!>--------------------------------------------------------------------------------------------------                 
    USE BOCO
    USE CLDWTR
    USE CTLBLK
    USE DYNAM
    USE GLB_TABLE
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: ISIZ1 = 2  * LB
    INTEGER(KIND=I4KIND), PARAMETER :: ISIZ2 = 2  * LB * LM
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NREC    , JK      , JN      , JL      , IRTN    , IIM     , JJM     , N       , I       ,   &
    & II      , J       , JJ      , K
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & BCHR    , SHTM    , RHTM
!--------------------------------------
! READ FRESH BOUNDARY DATA IF NECESSARY 
!--------------------------------------
    IF (NTSD-1 == NBOCO) THEN
        IF (MYPE == 0 .AND. NEST) THEN
            NREC = NINT((NTSD - 1) * ABS(DT) / 3600.) + 2
            READ(NBC,REC=NREC)   BCHR                                   ,                         &
    &                           ((PDB(K   ,N), K=1,LB)          , N=1,2),                         &
    &                           (((TB(K,JL,N), K=1,LB), JL=1,LM), N=1,2),                         &
    &                           (((QB(K,JL,N), K=1,LB), JL=1,LM), N=1,2),                         &
    &                           (((UB(K,JL,N), K=1,LB), JL=1,LM), N=1,2),                         &
    &                           (((VB(K,JL,N), K=1,LB), JL=1,LM), N=1,2),                         &
    &                          (((Q2B(K,JL,N), K=1,LB), JL=1,LM), N=1,2),                         &
    &                         (((CWMB(K,JL,N), K=1,LB), JL=1,LM), N=1,2)
        END IF
!
        IF (MYPE == 0 .AND. .NOT. NEST) THEN
            READ(NBC) PDB
            READ(NBC) TB
            READ(NBC) QB
            READ(NBC) UB
            READ(NBC) VB
            READ(NBC) Q2B
            READ(NBC) CWMB
        END IF
!    
        CALL MPI_BCAST(PDB, ISIZ1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(TB , ISIZ2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(UB , ISIZ2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(VB , ISIZ2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(Q2B, ISIZ2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!---------------------------------- 
! FIND NEXT BOUNDARY CONDITION READ
!----------------------------------
        IF (NTSD < NTSTM) THEN
            IF (MYPE == 0 .AND. NEST) BCHR = BCHR + 1    ! THIS ASSUMES 1-HRLY BCS
            IF (MYPE == 0 .AND. .NOT. NEST) READ(NBC) BCHR
!
            CALL MPI_BCAST(BCHR, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!
            NBOCO = INT(BCHR * TSPH + 0.5)
        END IF
!    
    END IF
!
    IIM = IM - MY_IS_GLB + 1
    JJM = JM - MY_JS_GLB + 1
!---------------------------- 
! UPDATE THE SURFACE PRESSURE
!---------------------------- 
    N = 1
    DO 101 I=1,IM
        PDB(N,1) = PDB(N,1) + PDB(N,2) * DT
        IF (MY_JS_GLB == 1 .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
            II = I - MY_IS_GLB + 1
            PD(II,1) = PDB(N,1)
        END IF
        N = N + 1
101 END DO
!
    DO 102 I=1,IM
        PDB(N,1) = PDB(N,1) + PDB(N,2) * DT
        IF (MY_JE_GLB == JM .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
            II = I - MY_IS_GLB + 1
            PD(II,JJM) = PDB(N,1)
        END IF
        N = N + 1
102 END DO
!
    DO 103 J=3,JM-2,2
        PDB(N,1) = PDB(N,1) + PDB(N,2) * DT
        IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
            JJ = J - MY_JS_GLB + 1
            PD(1,JJ) = PDB(N,1)
        END IF
        N = N + 1
103 END DO
!
    DO 104 J=3,JM-2,2
        PDB(N,1) = PDB(N,1) + PDB(N,2) * DT
        IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
            JJ = J - MY_JS_GLB + 1
            PD(IIM,JJ) = PDB(N,1)
        END IF
        N = N + 1
104 END DO
!------------------------------ 
! UPDATE THE 3-D MASS VARIABLES
!------------------------------ 
    DO 115 JL=1,LM
!
        N = 1
        DO 111 I=1,IM
             TB(N,JL,1) =  TB(N,JL,1) +  TB(N,JL,2) * DT
            Q2B(N,JL,1) = Q2B(N,JL,1) + Q2B(N,JL,2) * DT
            IF (MY_JS_GLB == 1 .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                II = I - MY_IS_GLB + 1
                   T(II,1,JL  ) =  TB(N,JL,1)
                  Q2(II,1,JL  ) = Q2B(N,JL,1)
                PINT(II,1,JL+1) =  PD(II,1) * ETA(JL+1) + PT
            END IF
            N = N + 1
    111 END DO
!    
        DO 112 I=1,IM
             TB(N,JL,1) =  TB(N,JL,1) +  TB(N,JL,2) * DT
            Q2B(N,JL,1) = Q2B(N,JL,1) + Q2B(N,JL,2) * DT
            IF (MY_JE_GLB == JM .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                II = I - MY_IS_GLB + 1
                   T(II,JJM,JL  ) =  TB(N,JL,1)
                  Q2(II,JJM,JL  ) = Q2B(N,JL,1)
                PINT(II,JJM,JL+1) =  PD(II,JJM) * ETA(JL+1) + PT
            END IF
            N = N + 1
    112 END DO
!   
        DO 113 J=3,JM-2,2
             TB(N,JL,1) =  TB(N,JL,1) +  TB(N,JL,2) * DT
            Q2B(N,JL,1) = Q2B(N,JL,1) + Q2B(N,JL,2) * DT
            IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                   T(1,JJ,JL  ) =  TB(N,JL,1)
                  Q2(1,JJ,JL  ) = Q2B(N,JL,1)
                PINT(1,JJ,JL+1) = PD(1,JJ) * ETA(JL+1) + PT
            END IF
            N = N + 1
    113 END DO
!    
        DO 114 J=3,JM-2,2
             TB(N,JL,1) =  TB(N,JL,1) +  TB(N,JL,2) * DT
            Q2B(N,JL,1) = Q2B(N,JL,1) + Q2B(N,JL,2) * DT
            IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                   T(IIM,JJ,JL  ) =  TB(N,JL,1)
                  Q2(IIM,JJ,JL  ) = Q2B(N,JL,1)
                PINT(IIM,JJ,JL+1) =  PD(IIM,JJ) * ETA(JL+1) + PT
            END IF
            N = N + 1
    114 END DO
!    
115 END DO
!------------------------------------------------------
! SPACE INTERPOLATION OF PD AND T AT THE INNER BOUNDARY
!------------------------------------------------------
    IF (IBROW == 1) THEN
        DO 121 I=MYIS,MYIE1
            SHTM = HTM(I,1,LM) + HTM(I+1,1,LM) + HTM(I,3,LM) + HTM(I+1,3,LM)
!
            PD(I,2) = (PD(I,1) * HTM(I,1,LM) + PD(I+1,1) * HTM(I+1,1,LM)                          &
    &               +  PD(I,3) * HTM(I,3,LM) + PD(I+1,3) * HTM(I+1,3,LM))                         &
    &               /  SHTM
    121 END DO
    END IF
!
    IF (ITROW == 1) THEN
        DO 122 I=MYIS,MYIE1
            SHTM = HTM(I,JJM-2,LM) + HTM(I+1,JJM-2,LM) + HTM(I,JJM,LM) + HTM(I+1,JJM,LM)
!
            PD(I,JJM-1) = (PD(I,JJM-2) * HTM(I,JJM-2,LM) + PD(I+1,JJM-2) * HTM(I+1,JJM-2,LM)      &
    &                   +  PD(I,JJM  ) * HTM(I,JJM  ,LM) + PD(I+1,JJM  ) * HTM(I+1,JJM  ,LM))     &
    &                   /  SHTM
    122 END DO
    END IF
!
    IF (ILCOL == 1) THEN
        DO 123 J=4,JM-3,2
            IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                SHTM = HTM(1,JJ-1,LM) + HTM(2,JJ-1,LM) + HTM(1,JJ+1,LM) + HTM(2,JJ+1,LM)
!
                PD(1,JJ) = (PD(1,JJ-1) * HTM(1,JJ-1,LM) + PD(2,JJ-1) * HTM(2,JJ-1,LM)             &
    &                    +  PD(1,JJ+1) * HTM(1,JJ+1,LM) + PD(2,JJ+1) * HTM(2,JJ+1,LM))            &
    &                    /  SHTM
            END IF
    123 END DO
    END IF
!
    IF (IRCOL == 1) THEN
        DO 124 J=4,JM-3,2
            IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                SHTM = HTM(IIM-1,JJ-1,LM) + HTM(IIM,JJ-1,LM)                                      &
    &                + HTM(IIM-1,JJ+1,LM) + HTM(IIM,JJ+1,LM)
!
                PD(IIM-1,JJ) = (PD(IIM-1,JJ-1) * HTM(IIM-1,JJ-1,LM)                               &
    &                        +  PD(IIM  ,JJ-1) * HTM(IIM  ,JJ-1,LM)                               &
    &                        +  PD(IIM-1,JJ+1) * HTM(IIM-1,JJ+1,LM)                               &
    &                        +  PD(IIM  ,JJ+1) * HTM(IIM  ,JJ+1,LM))                              &
    &                        /  SHTM
            END IF
    124 END DO
    END IF
!
    DO 135 JL=1,LM
!
        IF (IBROW == 1) THEN
            DO 131 I=MYIS,MYIE1
                RHTM= 1. / (HTM(I,1,JL) + HTM(I+1,1,JL) + HTM(I,3,JL) + HTM(I+1,3,JL))
!
                T(I,2,JL  ) =    (T(I,1,JL  ) * HTM(I,1,JL) +    T(I+1,1,JL  ) * HTM(I+1,1,JL)    &
    &                       +     T(I,3,JL  ) * HTM(I,3,JL) +    T(I+1,3,JL  ) * HTM(I+1,3,JL))   &
    &                       *     RHTM
!
               Q2(I,2,JL  ) =   (Q2(I,1,JL  ) * HTM(I,1,JL) +   Q2(I+1,1,JL  ) * HTM(I+1,1,JL)    &
    &                       +    Q2(I,3,JL  ) * HTM(I,3,JL) +   Q2(I+1,3,JL  ) * HTM(I+1,3,JL))   &
    &                       *    RHTM
!
             PINT(I,2,JL+1) = (PINT(I,1,JL+1) * HTM(I,1,JL) + PINT(I+1,1,JL+1) * HTM(I+1,1,JL)    &
    &                       +  PINT(I,3,JL+1) * HTM(I,3,JL) + PINT(I+1,3,JL+1) * HTM(I+1,3,JL))   &
    &                       *  RHTM
        131 END DO
        END IF
!    
        IF (ITROW == 1) THEN
            DO 132 I=MYIS,MYIE1
                RHTM = 1. / (HTM(I,JJM-2,JL) + HTM(I+1,JJM-2,JL) + HTM(I,JJM,JL) + HTM(I+1,JJM,JL))
!
                T(I,JJM-1,JL  ) =    (T(I  ,JJM-2,JL  ) * HTM(I  ,JJM-2,JL)                       &
    &                           +     T(I+1,JJM-2,JL  ) * HTM(I+1,JJM-2,JL)                       &
    &                           +     T(I  ,JJM  ,JL  ) * HTM(I  ,JJM  ,JL)                       &
    &                           +     T(I+1,JJM  ,JL  ) * HTM(I+1,JJM  ,JL))                      &
    &                           *     RHTM
!
               Q2(I,JJM-1,JL  ) =   (Q2(I  ,JJM-2,JL  ) * HTM(I  ,JJM-2,JL)                       &
    &                           +    Q2(I+1,JJM-2,JL  ) * HTM(I+1,JJM-2,JL)                       &
    &                           +    Q2(I  ,JJM  ,JL  ) * HTM(I  ,JJM  ,JL)                       &
    &                           +    Q2(I+1,JJM  ,JL  ) * HTM(I+1,JJM  ,JL))                      &
    &                           *    RHTM
!
             PINT(I,JJM-1,JL+1) = (PINT(I  ,JJM-2,JL+1) * HTM(I  ,JJM-2,JL)                       &
    &                           +  PINT(I+1,JJM-2,JL+1) * HTM(I+1,JJM-2,JL)                       &
    &                           +  PINT(I  ,JJM  ,JL+1) * HTM(I  ,JJM  ,JL)                       &
    &                           +  PINT(I+1,JJM  ,JL+1) * HTM(I+1,JJM  ,JL))                      &
    &                           *  RHTM
        132 END DO
        END IF
!    
        IF (ILCOL == 1) THEN
            DO 133 J=4,JM-3,2
                IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    RHTM = 1. / (HTM(1,JJ-1,JL) + HTM(2,JJ-1,JL) + HTM(1,JJ+1,JL) + HTM(2,JJ+1,JL))
!
                    T(1,JJ,JL  ) =    (T(1,JJ-1,JL  ) * HTM(1,JJ-1,JL)                            &
    &                            +     T(2,JJ-1,JL  ) * HTM(2,JJ-1,JL)                            &
    &                            +     T(1,JJ+1,JL  ) * HTM(1,JJ+1,JL)                            &
    &                            +     T(2,JJ+1,JL  ) * HTM(2,JJ+1,JL))                           &
    &                            *     RHTM
!
                   Q2(1,JJ,JL  ) =   (Q2(1,JJ-1,JL  ) * HTM(1,JJ-1,JL)                            &
    &                            +    Q2(2,JJ-1,JL  ) * HTM(2,JJ-1,JL)                            &
    &                            +    Q2(1,JJ+1,JL  ) * HTM(1,JJ+1,JL)                            &
    &                            +    Q2(2,JJ+1,JL  ) * HTM(2,JJ+1,JL))                           &
    &                            *    RHTM
!
                 PINT(1,JJ,JL+1) = (PINT(1,JJ-1,JL+1) * HTM(1,JJ-1,JL)                            &
    &                            +  PINT(2,JJ-1,JL+1) * HTM(2,JJ-1,JL)                            &
    &                            +  PINT(1,JJ+1,JL+1) * HTM(1,JJ+1,JL)                            &
    &                            +  PINT(2,JJ+1,JL+1) * HTM(2,JJ+1,JL))                           &
    &                            *  RHTM
                END IF
        133 END DO
        END IF
!    
        IF (IRCOL == 1) THEN
            DO 134 J=4,JM-3,2
                IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    RHTM = 1. / (HTM(IIM-1,JJ-1,JL) + HTM(IIM,JJ-1,JL)                            &
    &                    +       HTM(IIM-1,JJ+1,JL) + HTM(IIM,JJ+1,JL))
!
                    T(IIM-1,JJ,JL  ) =    (T(IIM-1,JJ-1,JL  ) * HTM(IIM-1,JJ-1,JL)                &
    &                                +     T(IIM  ,JJ-1,JL  ) * HTM(IIM  ,JJ-1,JL)                &
    &                                +     T(IIM-1,JJ+1,JL  ) * HTM(IIM-1,JJ+1,JL)                &
    &                                +     T(IIM  ,JJ+1,JL  ) * HTM(IIM  ,JJ+1,JL))               &
    &                                *     RHTM
!
                   Q2(IIM-1,JJ,JL  ) =   (Q2(IIM-1,JJ-1,JL  ) * HTM(IIM-1,JJ-1,JL)                &
    &                                +    Q2(IIM  ,JJ-1,JL  ) * HTM(IIM  ,JJ-1,JL)                &
    &                                +    Q2(IIM-1,JJ+1,JL  ) * HTM(IIM-1,JJ+1,JL)                & 
    &                                +    Q2(IIM  ,JJ+1,JL  ) * HTM(IIM  ,JJ+1,JL))               &
    &                                *    RHTM
!
                 PINT(IIM-1,JJ,JL+1) = (PINT(IIM-1,JJ-1,JL+1) * HTM(IIM-1,JJ-1,JL)                &
    &                                +  PINT(IIM  ,JJ-1,JL+1) * HTM(IIM  ,JJ-1,JL)                &
    &                                +  PINT(IIM-1,JJ+1,JL+1) * HTM(IIM-1,JJ+1,JL)                &
    &                                +  PINT(IIM  ,JJ+1,JL+1) * HTM(IIM  ,JJ+1,JL))               &
    &                                *  RHTM
                END IF
        134 END DO
        END IF
135 END DO
!
    RETURN
!
    END SUBROUTINE BOCOHF

    MODULE INDX
!>--------------------------------------------------------------------------------------------------
!> MODULE INDX
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : CHKOUT
!>              CUCNVC
!>              DDAMP
!>              DIVHOA
!>              DIVHOAST
!>              EPS
!>              EXIT
!>              FILT25
!>              GOSSIP
!>              HADZ
!>              HDIFF
!>              HDIIFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              PDTEDT
!>              PGCOR
!>              RADTN
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              TURBL
!>              VADZ
!>              VTADV
!>              VTADVF     
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IM, JM, IDIM1, IDIM2, JDIM1, JDIM2
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND), DIMENSION(JDIM1:JDIM2)                                                ::&
    & IHE     , IHW     ,                                                                         &
    & IVE     , IVW
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & IRAD
!
    INTEGER(KIND=I4KIND), DIMENSION(JM)                                                         ::&
    & IHEG    , IHWG    ,                                                                         &
    & IVEG    , IVWG
!
    INTEGER(KIND=I4KIND), DIMENSION(2*IM-1)                                                     ::&
    & IRADG
!
    END MODULE INDX

    MODULE CUPARM
!>--------------------------------------------------------------------------------------------------
!> MODULE CUPARM
!>
!> ABSTRACT:
!> AUGUST 91: SCHEME HAVING THE OPTION OF USING DIFFERENT FAST AND SLOW PROFILES FOR SEA AND FOR 
!> LAND POINTS; AND ALSO THE "SEA" AND THE "LAND" SCHEME EVERYWHERE.
!> OVER LAND PROFILES DEPART FROM THE FAST (DRY) PROFILES ONLY FOR PRECIPITATION/TIME STEP .GT. A 
!> PRESCRIBED VALUE (CURRENTLY, IN THE VERSION #3 DONE WEDNESDAY 18 SEPTEMBER, 1/4 INCH/24 H).
!> USE OF VARIOUS SWITCHES AS FOLLOWS.
!>
!> THE "OLD" ("HARD", = ZAVISA OCT. 1990) LAND SCHEME WITH FIXED LAND PROFILES IS RUN BY:
!>
!> - SETTING OCT90 = .TRUE. IN THE FIRST EXECUTABLE LINE FOLLOWING THESE COMMENTS (THIS REACTIVATES
!>   EFI=1. OVER LAND IF .NOT. UNIS, AND CLDEFI(K) = EFIMN AS THE LEFTOVER CLDEFI VALUE AT SWAP 
!>   POINTS)
!> - DEFINING FAST LAND PROFILES SAME AS FAST SEA PROFILES (OR BY CHOOSING ANOTHER SET OF LAND 
!>   PROFILES ZAVISA USED AT EARLIER TIME)
!> - SETTING FSL = 1.
!> - DEFINING STEFI (STARTING EFI) EQUAL TO AVGEFI. (THE LAST THREE POINTS ARE HANDLED BY SWITCHING
!>   AROUND THE "CFM" COMMENTS AT TWO PLACES)
!>
!> THE "OLD,OLD" (APPR. ORIGINAL BETTS) SCHEME IS RUN BY:
!> - SPECIFYING UNIL=.TRUE.;
!> - SETTING FSL=1.;
!> - SETTING OCT90=.TRUE. (WITH THESE SETTINGS FAST LAND PROFILES ONLY ARE USED).
!>
!> IN THIS VERSION 3.5, OVER LAND AND FOR THE FAST PROFILES, DSPB IS PRESCRIBED TO BE 25 PERCENT 
!> DRIER THAN THE FAST SEA VALUE (IN ROUGH AGREEMENT WITH BINDER, QJ, IN PRESS) WHILE DSP0 AND
!> DSPT ARE EACH 20 PERCENT DRIER THAN THE CORRESPONDING FAST SEA VALUES.
!> WITH FSL = .875 THIS MAKES THE AVERAGE OF THE FAST AND THE SLOW LAND PROFILES SOMEWHAT DRIER THAN
!> THE OCT90 FIXED LAND PROFILES.
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : CUCNVC
!>              INIT
!>              INITS
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CP     = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: CAPA   =    0.28589641
    REAL   (KIND=R4KIND), PARAMETER :: ELWV   =    2.50E6
    REAL   (KIND=R4KIND), PARAMETER :: ELIVW  =    2.72E6 
    REAL   (KIND=R4KIND), PARAMETER :: ROW    =    1.E3  
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: A2     =   17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3     =  273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4     =   35.86
    REAL   (KIND=R4KIND), PARAMETER :: TFRZ   =  273.15
    REAL   (KIND=R4KIND), PARAMETER :: T1     =  274.16
    REAL   (KIND=R4KIND), PARAMETER :: PQ0    =  379.90516 
    REAL   (KIND=R4KIND), PARAMETER :: STRESH =    1.10
!
    END MODULE CUPARM

    MODULE MAPOT
!>--------------------------------------------------------------------------------------------------
!> MODULE MAPOT
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>              RDPARM
!>
!> DRIVER     : INIT
!>              INITS
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : LM , LSM
    USE RDPARM  , ONLY : LP1   
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LSL     , IXM     , IYM
!
    INTEGER(KIND=I4KIND), DIMENSION(999999)                                                     ::&
    & ISHDE
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSPH    , WBD     , SBD     , TLM0D   , TPH0D   , DLMD    , DPHD    , CMLD    , DP30    ,   &
    & X1P     , Y1P     , DISLP   , Z0SLP
!
    REAL   (KIND=R4KIND), DIMENSION(LSM)                                                        ::&
    & SPL     , ALSL
!
    REAL   (KIND=R4KIND), DIMENSION(999999)                                                     ::&
    & TSHDE
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ERLAM0  , CPHI0   , SPHI0

    END MODULE MAPOT

    SUBROUTINE FILT25(ZI, TM, IPASS)
!>--------------------------------------------------------------------------------------------------  
!> SUBROUTINE FILT25
!> 
!> SUBPROGRAM: FILT25 - FILTERS THE ARRAY ZI
!> PROGRAMMER: DIMEGO
!> ORG: W/NP22
!> DATE: 86-07-18
!>
!> ABSTRACT:
!> FILTERS AN ARRAY USING A 25PT BLECK FILTER IN THE INTERIOR OF THE DOMAIN.
!>
!> PROGRAM HISTORY LOG:
!> 86-07-18  G DIMEGO  - ORIGINATOR
!> 88-09-23  B SCHMIDT - ADDED THE DOCBLOCK
!> 90-11-27  G DIMEGO  - LEFT Z AS INTERNAL WORK ARRAY ON CRAY
!> 93-06-21  R TREADON - STREAMLINED CODE
!> 95-06-21  T BLACK   - MODIFIED FOR THE E-GRID
!> 99-08-25  T BLACK   - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI     - MODERNIZATION OF THE CODE, INCLUDING:
!>                       * F77 TO F90/F95
!>                       * INDENTATION & UNIFORMIZATION CODE
!>                       * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                       * DOCUMENTATION WITH DOXYGEN
!>                       * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> TM    - ARRAY CONTAINING THE TOPOGRAPHY MASK
!> IPASS - NUMBER OF PASSES THROUGH THE FILTER
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> ZI    - ARRAY CONTAINING THE ARRAY TO BE FILTERED / FILTERED FIELD
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              INDX
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : NEWFLT
!>
!> CALLS      : EXCH
!>--------------------------------------------------------------------------------------------------
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ZI
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & Z
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(IN)          ::&
    & TM
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & IPASS
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                                        ::&
    & CF1     , CF2     , CF3     , CF4     , CF5     , CF6     , HTOT    , SUMH    , RSUMH
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , IP      , IPC     , IIHE    , IIHW   
!
    DATA CF1/0.279372/  , CF2/ 0.171943/    , CF3/-0.006918/    ,                                 &
    &    CF4/0.077458/  , CF5/-0.024693/    , CF6/-0.012940/
!
    IPC = IPASS
!
    DO J=JDIM1,JDIM2
        DO I=IDIM1,IDIM2
            Z(I,J) = 0.
        END DO
    END DO
!---------------------------------------------------
! FILTER THE INTERIOR POINTS WITH 25-PT BLECK FILTER
!---------------------------------------------------
    DO 105 IP=1,IPC
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (HTOT   , I       , IIHE    , IIHW    , RSUMH   , SUMH)
!
        DO 102 J=MYJS4,MYJE4
            DO 101 I=MYIS2,MYIE2
!            
                IIHE = I + IHE(J)
                IIHW = I + IHW(J)
                12345 FORMAT(' MASK=',F2.0,' IHE=',I2,' IHW=',I2,' L=',I2)
                12346 FORMAT(' 2ND ROW=',4(1x,F2.0))
                12347 FORMAT(' 3RD ROW=',4(1x,F2.0))
                12348 FORMAT(' 4TH ROW=',4(1x,F2.0))
                12349 FORMAT(' 5TH ROW=',4(1x,F2.0))
                12350 FORMAT(' 6TH ROW=',4(1x,F2.0))
                12351 FORMAT(' 7TH ROW=',4(1x,F2.0))
!
                HTOT = TM(I     ,J  )                                                             &
    &                + TM(IIHW  ,J-1) + TM(IIHE  ,J-1) + TM(IIHE  ,J+1) + TM(IIHW  ,J+1)          &
    &                + TM(I-1   ,J-2) + TM(I+1   ,J-2) + TM(I+1   ,J+2) + TM(I-1   ,J+2)          &
    &                + TM(I     ,J-2) + TM(I     ,J+2) + TM(I+1   ,J  ) + TM(I-1   ,J  )          &
    &                + TM(IIHE  ,J-3) + TM(IIHE+1,J-1) + TM(IIHW  ,J-3) + TM(IIHE+1,J+1)          &
    &                + TM(IIHW-1,J-1) + TM(IIHE  ,J+3) + TM(IIHW-1,J+1) + TM(IIHW  ,J+3)          &
    &                + TM(I     ,J-4) + TM(I+2   ,J  ) + TM(I-2   ,J  ) + TM(I     ,J+4)
!            
                IF (HTOT > 0.) THEN
                SUMH = CF1 *  TM(I     ,J  )                                                      &
    &                + CF2 * (TM(IIHW  ,J-1) + TM(IIHE  ,J-1) + TM(IIHE  ,J+1) + TM(IIHW  ,J+1))  &
    &                + CF3 * (TM(I-1   ,J-2) + TM(I+1   ,J-2) + TM(I+1   ,J+2) + TM(I-1   ,J+2))  &
    &                + CF4 * (TM(I     ,J-2) + TM(I     ,J+2) + TM(I+1   ,J  ) + TM(I-1   ,J  ))  &
    &                + CF5 * (TM(IIHE  ,J-3) + TM(IIHE+1,J-1) + TM(IIHW  ,J-3) + TM(IIHE+1,J+1)   &
    &                +        TM(IIHW-1,J-1) + TM(IIHE  ,J+3) + TM(IIHW-1,J+1) + TM(IIHW  ,J+3))  &
    &                + CF6 * (TM(I     ,J-4) + TM(I+2   ,J  ) + TM(I-2   ,J  ) + TM(I     ,J+4))
!                
                RSUMH = 1. / SUMH
!                
                Z(I,J) = (CF1  *  ZI(I     ,J  ) * TM(I     ,J  )                                 &
    &                  +  CF2  * (ZI(IIHW  ,J-1) * TM(IIHW  ,J-1)                                 &
    &                  +          ZI(IIHE  ,J-1) * TM(IIHE  ,J-1)                                 &
    &                  +          ZI(IIHE  ,J+1) * TM(IIHE  ,J+1)                                 &
    &                  +          ZI(IIHW  ,J+1) * TM(IIHW  ,J+1))                                &
    &                  +  CF3  * (ZI(I-1   ,J-2) * TM(I-1   ,J-2)                                 &
    &                  +          ZI(I+1   ,J-2) * TM(I+1   ,J-2)                                 &
    &                  +          ZI(I+1   ,J+2) * TM(I+1   ,J+2)                                 &
    &                  +          ZI(I-1   ,J+2) * TM(I-1   ,J+2))                                &
    &                  +  CF4  * (ZI(I     ,J-2) * TM(I     ,J-2)                                 &
    &                  +          ZI(I     ,J+2) * TM(I     ,J+2)                                 &
    &                  +          ZI(I+1   ,J  ) * TM(I+1   ,J  )                                 &
    &                  +          ZI(I-1   ,J  ) * TM(I-1   ,J  ))                                &
    &                  +  CF5  * (ZI(IIHE  ,J-3) * TM(IIHE  ,J-3)                                 &
    &                  +          ZI(IIHE+1,J-1) * TM(IIHE+1,J-1)                                 &
    &                  +          ZI(IIHW  ,J-3) * TM(IIHW  ,J-3)                                 &
    &                  +          ZI(IIHE+1,J+1) * TM(IIHE+1,J+1)                                 &
    &                  +          ZI(IIHW-1,J-1) * TM(IIHW-1,J-1)                                 &
    &                  +          ZI(IIHE  ,J+3) * TM(IIHE  ,J+3)                                 &
    &                  +          ZI(IIHW-1,J+1) * TM(IIHW-1,J+1)                                 &
    &                  +          ZI(IIHW  ,J+3) * TM(IIHW  ,J+3))                                &
    &                  +  CF6  * (ZI(I     ,J-4) * TM(I     ,J-4)                                 &
    &                  +          ZI(I+2   ,J  ) * TM(I+2   ,J  )                                 &
    &                  +          ZI(I-2   ,J  ) * TM(I-2   ,J  )                                 &
    &                  +          ZI(I     ,J+4) * TM(I     ,J+4)))                               &
    &                  * RSUMH
                END IF
!            
        101 END DO
    102 END DO 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO J=MYJS4,MYJE4
            DO I=MYIS2,MYIE2
                IF (TM(I,J) > 0.5) THEN
                    ZI(I,J) = Z(I,J)
                END IF
            END DO
        END DO
!    
        CALL EXCH(ZI, 1, 4, 4)
!    
105 END DO
!
    RETURN
!
    END SUBROUTINE FILT25

    SUBROUTINE READ_NHB(NHB)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_NHB
!>
!> SUBPROGRAM: READ_NHB - READ AND DISTRIBUTE NHB FILE
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 98-10-22
!>
!> ABSTRACT:
!> READ_NHB READS IN QUANTITIES FROM THE NHB FILE AND THEN DISTRIBUTES THEM TO THE OTHER NODES/PES 
!> AS NEEDED
!>
!> PROGRAM HISTORY LOG:
!> 97-??-??  MEYS       - ORIGINATOR
!> 97-08-??  BLACK      - REWROTE FOR BENCHMARK
!> 98-??-??  TUCCILLO   - MODIFIED FOR SINGLE OR DOUBLE PRECISION
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NHB - FILE NUMBER OF THE NHB FILE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLD
!>              ACMCLH
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              SLOPES
!>              SOIL
!>              TEMPCOM
!>              TOPO     
!>              VRBLS     
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : DSTRB
!>              IDSTRB
!>              MPI_BARRIER
!>              MPI_BCAST
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE SLOPES
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CM1    = 2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2    =    4.9283
    REAL   (KIND=R4KIND), PARAMETER :: CM3    =   23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS    =    0.622
    REAL   (KIND=R4KIND), PARAMETER :: Q2INI  =     .50
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2  =    2.E-2
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: EPSWET =    0.0
    REAL   (KIND=R4KIND), PARAMETER :: Z0LAND =     .10
    REAL   (KIND=R4KIND), PARAMETER :: Z0SEA  =     .001
    REAL   (KIND=R4KIND), PARAMETER :: FCM    =     .00001
    REAL   (KIND=R4KIND), PARAMETER :: DTR    =    0.1745329E-1
    REAL   (KIND=R4KIND), PARAMETER :: H360   =  360.0
    REAL   (KIND=R4KIND), PARAMETER :: H1905  =  190.5
    REAL   (KIND=R4KIND), PARAMETER :: H105   =  105.0
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM * JM - JM / 2
    REAL   (KIND=R4KIND), PARAMETER :: JMP1   = JM + 1
    REAL   (KIND=R4KIND), PARAMETER :: IMT    =  2 * IM - 1
!------------------   
! DECLARE VARIABLES
!------------------ 
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUNB
! 
    CHARACTER(32)                                                                               ::&
    & LABEL
!
    CHARACTER(40)                                                                               ::&
    & CONTRL  , FILALL  , FILMST  , FILTMP  , FILTKE  , FILUNV  , FILCLD  , FILRAD  , FILSFC
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDATB      
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(IM, JM)                                                     ::&
    & ILMH
!
#ifdef DP_REAL
    INTEGER(KIND=I8KIND), DIMENSION(IM, JM)                                                     ::&
    & ITEMPX
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & NFCSTX  , NBCX    , LISTX   , IDTADX  , KHLAX   , KHHAX   , KVLAX   , KVHAX   , KHL2X   ,   &
    & KHH2X   , KVL2X   , KVH2X   , IXMX    , IYMX
!
    LOGICAL(KIND=L8KIND)                                                                        ::&
    & SIGMAX
#endif
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & NHB
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NMAP    , NRADSH  , NRADLH  , KVL2    , KHLA    , KHHA    , KVLA    , KVHA    , KHL2    ,   &
    & KVH2    , IRTN    , I       , J       , JG      , IHL     , IHH     , IG      , K       ,   &
    & LMHN    , LMHS    , LMHE    , LMHW    , KHH2    , N       , NSST_UP , ISST_UP     
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART  , TEND    , TCP     , TDDAMP 
!------------------ 
! DECLARE NAMELIST.
!------------------ 
    NAMELIST /FCSTDATA/                                                                           &
    & TSTART, TEND , TCP  , RESTRT, SUBPOST, NMAP, TSHDE, SPL, NPHS, NCNVC, NRADSH, NRADLH, TPREC,&
    & THEAT , TCLOD, TRDSW, TRDLW , TSRFC
!
    IF (MYPE == 0) THEN
!
        OPEN(UNIT=NHB, FORM='UNFORMATTED', FILE='CNST.file')
!
#ifdef DP_REAL
!
        READ(NHB) NFCSTX, NBCX , LISTX, DT, IDTADX, SIGMAX, KHLAX, KHHAX, KVLAX, KVHAX, KHL2X,    &
    &             KHH2X , KVL2X, KVH2X
!
        NFCST = NFCSTX
        NBC   = NBCX
        LIST  = LISTX
        IDTAD = IDTADX
        SIGMA = SIGMAX
        KHLA  = KHLAX
        KHHA  = KHHAX
        KVLA  = KVLAX
        KVHA  = KVHAX
        KHL2  = KHL2X
        KHH2  = KHH2X
        KVL2  = KVL2X
        KVH2  = KVH2X
!
#else
!
        READ(NHB) NFCST, NBC, LIST, DT, IDTAD, SIGMA, KHLA, KHHA, KVLA, KVHA, KHL2, KHH2, KVL2,   &
    &             KVH2
!
#endif
!
    END IF
!
    CALL MPI_BCAST  (NFCST, 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (NBC  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (LIST , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DT   , 1, MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (IDTAD, 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (SIGMA, 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER(                          MPI_COMM_COMP, IRTN)
!
    LIST = 6
!--------------- 
! DISTRIBUTE LMH
!--------------- 
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) ITEMPX
        ITEMP = ITEMPX
!
#else
!
        READ(NHB) ITEMP
!
#endif
!
        ILMH = ITEMP
    END IF
!
    CALL IDSTRB(ITEMP, LMH)
!---------------  
! DISTRIBUTE LMV
!---------------
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) ITEMPX
        ITEMP = ITEMPX
!
#else
!
        READ(NHB) ITEMP
!
#endif
!
    END IF
!
    CALL IDSTRB(ITEMP, LMV)
!----------------
! DISTRIBUTE HBM2
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, HBM2, 1, 1, 1)
!---------------------
! FILL HBM3 ON EACH PE
!---------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            HBM3(I,J) = 0.
        END DO
    END DO
!
    DO J=MYJS,MYJE
        JG = J + MY_JS_GLB - 1
!
        IF (JG >= 4 .AND. JG <= JM-3) THEN
            IHL = 2 - IHWG(JG)
            IHH = IM - 2
            DO I=MYIS,MYIE
                IG = I + MY_IS_GLB - 1
                IF (IG >= IHL .AND. IG <= IHH) HBM3(I,J) = 1.
            END DO
        END IF
!
    END DO
!---------------- 
! DISTRIBUTE VBM2
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, VBM2, 1, 1, 1)
!----------------
! DISTRIBUTE VBM3
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, VBM3, 1, 1, 1)
!-------------- 
! DISTRIBUTE SM
!-------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, SM, 1, 1, 1)
!---------------- 
! DISTRIBUTE SICE
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, SICE, 1, 1, 1)
!--------------- 
! DISTRIBUTE HTM
!---------------
    DO K=1,LM
        IF (MYPE == 0) THEN
            READ(NHB) TEMP1
        END IF
        CALL DSTRB(TEMP1, HTM, 1, LM, K)
    END DO
!---------------
! DISTRIBUTE VTM
!---------------
    DO K=1,LM
        IF (MYPE == 0) THEN
            READ(NHB) TEMP1
        END IF
        CALL DSTRB(TEMP1, VTM, 1, LM, K)
    END DO
!
    IF (MYPE == 0)THEN
        READ(NHB) DY , CPGFV, EN, ENT, R, PT, TDDAMP, F4D, F4Q, EF4T, DETA, RDETA, AETA, F4Q2,    &
    &             ETA, DFL  , EM, EMT
    END IF
!
    CALL MPI_BCAST  (DY      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (CPGFV   , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (EN      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (ENT     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (R       , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (PT      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (TDDAMP  , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (F4D     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (F4Q     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (EF4T    , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  ( DETA(1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDETA(1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  ( AETA(1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  ( F4Q2(1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (  ETA(1), LP1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (  DFL(1), LP1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (   EM(1), JAM, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (  EMT(1), JAM, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER(                            MPI_COMM_COMP, IRTN)
!--------------  
! DISTRIBUTE DX
!--------------  
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, DX, 1, 1, 1)
!----------------- 
! DISTRIBUTE WPDAR
!-----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, WPDAR, 1, 1, 1)
!-----------------
! DISTRIBUTE CPGFU
!-----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, CPGFU, 1, 1, 1)
!----------------
! DISTRIBUTE CURV
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, CURV, 1, 1, 1)
!--------------- 
! DISTRIBUTE FCP
!--------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, FCP, 1, 1, 1)
!---------------- 
! DISTRIBUTE FDIV
!---------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, FDIV, 1, 1, 1)
!--------------- 
! DISTRIBUTE FAD
!---------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, FAD, 1, 1, 1)
!------------- 
! DISTRIBUTE F
!------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, F, 1, 1, 1)
!----------------- 
! DISTRIBUTE DDMPU
!----------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, DDMPU, 1, 1, 1)
!----------------- 
! DISTRIBUTE DDMPV
!----------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, DDMPV, 1, 1, 1)
!--------------------
! DISTRIBUTE PT, GLAT
!--------------------
    IF (MYPE == 0) THEN
        READ(NHB) PT ,TEMP1
    END IF
!
    CALL DSTRB(TEMP1, GLAT, 1, 1, 1)
    CALL MPI_BCAST(PT , 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!---------------- 
! DISTRIBUTE GLON
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, GLON, 1, 1, 1)
!
    IF (MYPE == 0) THEN
        READ(NHB)PLQ, RDPQ, RDTHEQ, STHEQ, THE0Q
    END IF
!
    CALL MPI_BCAST  (PLQ     , 1   , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDPQ    , 1   , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDTHEQ  , 1   , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (STHEQ(1), ITBQ, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (THE0Q(1), ITBQ, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER(                             MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0) THEN
        READ(NHB) ROS, CS, DS, ROI, CI, DI, PL, THL, RDQ, RDTH, RDP, RDTHE, DETA, AETA, DFRLG,    &
    &             QS0, SQS, STHE, THE0
    END IF
!
    CALL MPI_BCAST  (ROS     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (CS      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DS      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (ROI     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (CI      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DI      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (PL      , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (THL     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDQ     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDTH    , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDP     , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (RDTHE   , 1  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DETA (1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (AETA (1), LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DFRLG(1), LP1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (  QS0(1), JTB, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (  SQS(1), JTB, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  ( STHE(1), ITB, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  ( THE0(1), ITB, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER(                            MPI_COMM_COMP, IRTN)
!------------------
! DISTRIBUTE MXSNAL
!------------------
    IF (MYPE == 0) THEN
        READ(NHB)TEMP1
    END IF
!
    CALL DSTRB(TEMP1, MXSNAL, 1, 1, 1)
!---------------- 
! DISTRIBUTE EPSR
!---------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, EPSR, 1, 1, 1)
!-------------- 
! DISTRIBUTE TG
!-------------- 
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, TG, 1, 1, 1)
!---------------- 
! DISTRIBUTE GFFC
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, GFFC, 1, 1, 1)
!--------------- 
! DISTRIBUTE SST
!---------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, SST, 1, 1, 1)
!------------------
! DISTRIBUTE ALBASE
!------------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, ALBASE, 1, 1, 1)
!---------------- 
! DISTRIBUTE HDAC
!----------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, HDAC, 1, 1, 1)
!-----------------
! DISTRIBUTE HDACV
!-----------------
    IF (MYPE == 0) THEN
        READ(NHB)TEMP1
    END IF
!
    CALL DSTRB(TEMP1, HDACV, 1, 1, 1)
!-----------------
! DISTRIBUTE TTBLQ
!-----------------
    IF (MYPE == 0) THEN
        READ(NHB) TTBLQ
    END IF
!
    CALL MPI_BCAST  (TTBLQ(1,1), ITBQ * JTBQ, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!
    CALL MPI_BARRIER(                                      MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) PTBL, TTBL, R  , PT  , TSPH, WBD  , SBD  , TLM0D, TPH0D, DLMD, DPHD, CMLD,      &
    &             DP30, X1P ,Y1P , IXMX, IYMX, DETA , AETA , ETA
        IXM = IXMX
        IYM = IYMX
!
#else
!
        READ(NHB) PTBL, TTBL, R  , PT , TSPH , WBD  , SBD, TLM0D, TPH0D, DLMD, DPHD, CMLD, DP30,  &
    &             X1P , Y1P , IXM, IYM, DETA , AETA , ETA
!
#endif
!
    END IF
!
    CALL MPI_BCAST  (PTBL(1,1), ITB*JTB, MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (TTBL(1,1), JTB*ITB, MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (R        , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (PT       , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (TSPH     , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (WBD      , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (SBD      , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (TLM0D    , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (TPH0D    , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DLMD     , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DPHD     , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (CMLD     , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DP30     , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (X1P      , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (Y1P      , 1      , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (IXM      , 1      , MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (IYM      , 1      , MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (DETA (1) , LM     , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (AETA (1) , LM     , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST  (ETA  (1) , LP1    , MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER(                                    MPI_COMM_COMP, IRTN)
!------------------
! DISTRIBUTE IVGTYP
!------------------
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) ITEMPX
!
        ITEMP = ITEMPX
!
#else
!
        READ(NHB) ITEMP
!
#endif
!
    END IF
!
    CALL IDSTRB(ITEMP, IVGTYP)
!------------------
! DISTRIBUTE ISLTYP
!------------------
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) ITEMPX
!
        ITEMP = ITEMPX
!
#else
!
        READ(NHB) ITEMP
!
#endif
!
    END IF
!
    CALL IDSTRB(ITEMP, ISLTYP)
!------------------
! DISTRIBUTE ISLOPE
!------------------
    IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!
        READ(NHB) ITEMPX
!
        ITEMP = ITEMPX
!
#else
!
        READ(NHB) ITEMP
!
#endif
!
    END IF
!
    CALL IDSTRB(ITEMP, ISLOPE)
!------------------
! DISTRIBUTE VEGFRC
!------------------
    IF (MYPE == 0) THEN
        READ(NHB) TEMP1
    END IF
!
    CALL DSTRB(TEMP1, VEGFRC, 1, 1, 1)
!------------------
! DISTRIBUTE SLDPTH
!------------------
    IF (MYPE == 0) THEN
        READ(NHB) SLDPTH
    END IF
!
    CALL MPI_BCAST(SLDPTH(1), NSOIL, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!------------------
! DISTRIBUTE RTDPTH
!------------------
    IF (MYPE == 0) THEN
        READ(NHB) RTDPTH
    END IF
!
    CALL MPI_BCAST(RTDPTH(1), NSOIL, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0) THEN
        DO J=1,JM
            DO I=1,IM
                ITEMP(I,J) = 0
            END DO
        END DO
!
        DO J=8,JM-7
            DO I=4+MOD(J+1,2),IM-4
!
                ITEMP(I,J) = 0
                LMHN = ILMH(I,J+1)
                LMHS = ILMH(I,J-1)
                LMHE = ILMH(I+MOD(J,2),J)
                LMHW = ILMH(I-1+MOD(J,2),J)
!
                IF (LMHE < LMHN .AND. LMHE < LMHW .AND. LMHE < LMHS) THEN
                    ITEMP(I,J) = 1
                ELSE IF (LMHE == LMHN .AND. LMHE < LMHW .AND. LMHE < LMHS) THEN
                    ITEMP(I,J) = 2
                ELSE IF (LMHN < LMHW  .AND. LMHN < LMHS .AND. LMHN < LMHE) THEN
                    ITEMP(I,J) = 3
                ELSE IF (LMHN == LMHW .AND. LMHN < LMHS .AND. LMHN < LMHE) THEN
                    ITEMP(I,J) = 4
                ELSE IF (LMHW < LMHS  .AND. LMHW < LMHE .AND. LMHW < LMHN) THEN
                    ITEMP(I,J) = 5
                ELSE IF (LMHW == LMHS .AND. LMHW < LMHE .AND. LMHW < LMHN) THEN
                    ITEMP(I,J) = 6
                ELSE IF (LMHS < LMHE  .AND. LMHS < LMHN .AND. LMHS < LMHW) THEN
                    ITEMP(I,J) = 7
                ELSE IF (LMHS == LMHE .AND. LMHS < LMHN .AND. LMHS < LMHW) THEN
                    ITEMP(I,J) = 8
                ELSE
                    ITEMP(I,J) = 0
                END IF
            END DO
        END DO
    END IF
!
    CALL IDSTRB(ITEMP, ISLD)

    RETURN
!
    END SUBROUTINE READ_NHB

    MODULE RDPARM
!>--------------------------------------------------------------------------------------------------
!> MODULE RDPARM
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : GFDLRD
!>              GOSSIP
!>              GRADFS
!>              MODULE_BANDTA
!>              MODULE_BDCOMB
!>              MODULE_CO2BD2
!>              MODULE_CO2BD3
!>              MODULE_CO2BD4
!>              MODULE_CO2BD5
!>              MODULE_CTLBLK
!>              MODULE_DYNAM
!>              MODULE_INPUT
!>              MODULE_MAPOT
!>              MODULE_PHYS
!>              MODULE_SCRTCH
!>              MODULE_SWRSAV
!>              MODULE_TABCOM
!>              MODULE_TBLTMP
!>              RADFS
!>              SWR93
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS.
!         
! NB, KO2 ARE SHORTWAVE PARAMETERS; OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      =  LM
    INTEGER(KIND=I4KIND), PARAMETER :: IMAX   =  IM
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163          
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   =  47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLY   =  15
!
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1    = L    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L    + 3
!
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L    - 3
!
    INTEGER(KIND=I4KIND), PARAMETER :: LL     =   2  * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL   + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL   + 3
!
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL   - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL   - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL   - 3
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M - 1
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1V   = LP1  * (1 + 2 * L / 2)
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1  * NBLY
!
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   =   3  *  L + 2
!
    INTEGER(KIND=I4KIND), PARAMETER :: NB     =  12
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
!
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  =   3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1 
!
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  =  56
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
!
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    =  12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1 
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!
    END MODULE RDPARM

    SUBROUTINE LOC2GLB(ARRL, ARRG)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE LOC2GLB
!>
!> SUBPROGRAM: LOC2GLB - REATE GLOBAL ARRAYS
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 97-10-28
!>
!> ABSTRACT:
!> LOC2GLB CREATES A SINGLE GLOBAL ARRAY FROM MANY LOCAL ONES
!>
!> PROGRAM HISTORY LOG:
!> 97-10-28  BLACK   - ORIGINATOR
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> ARRL - THE LOCAL ARRAY
!>
!> OUTPUT ARGUMENT LIST:
!> ARRG - THE GLOBAL ARRAYS
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT FILES:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : DIGFLT
!>
!> CALLS      : MPI_RECV
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(IN)          ::&
    & ARRL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & ARRX
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                               , INTENT(INOUT)       ::&
    & ARRG 
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NUMVAL  , I       , J       , IPE     , IRECV   , JKNT    , JGLB    , IKNT    , IGLB    ,   &
    & ISEND 
!
    NUMVAL = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
!
    IF (MYPE /= 0) THEN
        CALL MPI_SEND(ARRL, NUMVAL, MPI_REAL, 0, MYPE, MPI_COMM_COMP, ISEND)
    ELSE
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                ARRG(I + MY_IS_GLB - 1, J + MY_JS_GLB - 1) = ARRL(I,J)
            END DO
        END DO
!    
        DO IPE=1,NPES-1
!
            CALL MPI_RECV(ARRX, NUMVAL, MPI_REAL, IPE, IPE, MPI_COMM_COMP, ISTAT, IRECV)
!        
            JKNT = 0
!
            DO J=JS_LOC_TABLE(IPE),JE_LOC_TABLE(IPE)
                JGLB = JS_GLB_TABLE(IPE) + JKNT
                IKNT = 0
!
                DO I=IS_LOC_TABLE(IPE),IE_LOC_TABLE(IPE)
                    IGLB            = IS_GLB_TABLE(IPE) + IKNT
                    ARRG(IGLB,JGLB) = ARRX(I,J)
                    IKNT            = IKNT + 1
                END DO
!
                JKNT = JKNT + 1
            END DO
!        
        END DO
!    
    END IF
!
    RETURN
!
    END SUBROUTINE LOC2GLB

    SUBROUTINE E1E290(G1, G2, G3, G4, G5, EMISS, FXOE1, DTE1, FXOE2, DTE2, AVEPHI, TEMP, T)
!--------------------------------------------------------------------------------------------------
!> SUBROUTINE E1E290
!>
!> SUBPROGRAM: E1E290 - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> SUBROUTINE E1E290 COMPUTES THE EXCHANGE TERMS IN THE FLUX EQUATION FOR LONGWAVE RADIATION FOR ALL
!> TERMS EXCEPT THE EXCHANGE WITH THE TOP OF THE ATMOSPHERE.
!> THE METHOD IS A TABLE LOOKUP ON A PRE-COMPUTED E2 FUNCTION (DEFINED IN REF. (4)).
!> THE E1 FUNCTION  CALCULATIONS (FORMERLY DONE IN SUBROUTINE E1V88 COMPUTE THE FLUX RESULTING FROM
!> THE EXCHANGE OF PHOTONS BETWEEN A LAYER AND THE TOP OF THE ATMOSPHERE.
!> THE METHOD IS A TABLE LOOKUP ON A PRE-COMPUTED E1 FUNCTION.
!> CALCULATIONS ARE DONE IN TWO FREQUENCY RANGES:
!> 1)   0-560, 1200-2200 CM-1   FOR Q(APPROX)
!> 2) 160-560            CM-1   FOR Q(APPROX,CTS).
!> MOTIVATION FOR THESE CALCULATIONS IS IN REFERENCES (1) AND (4).
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> FXOE1  - 
!> FXOE2  - 
!> DTE1   - 
!> DTE2   - 
!> AVEPHI - 
!> TEMP   - 
!> T      - 
!>
!> OUTPUT ARGUMENT LIST:
!> G1     -
!> G2     - 
!> G3     - 
!> G4     - 
!> G5     - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> EMISS  - 
!>
!> USE MODULES: F77KINDS 
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : FST88
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
!
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
!
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS; 
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS SENT TO RADFS
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! 
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
!
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!
! COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE
! TABLE FOR USE IN THE LONGWAVE RADIATION PROGRAM:
! EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL
! TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  =  MASS DERIVATIVE OF TABLE1
! EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS
! DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
! IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88
! KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC.,IN FST88
! KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & TEMP    , T       , AVEPHI  
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LL3P)                                          ::&
    & IT1 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & FYO     ,                                                                                   &
    & DU      , WW1     ,  WW2    ,                                                               &
    & TMP3    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & EMISS
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & TMP5    , TMP9
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & IVAL
!------------------------------- 
! VARIABLES IN THE ARGUMENT LIST
!------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & FXOE1   , DTE1    ,                                                                         &
    & FXOE2   , DTE2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & G1      , G3      , G4
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(OUT)         ::&
    & G2      , G5
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K       , KP 
!--------------------------------------------------------------------------------------------------
! FIRST WE OBTAIN THE EMISSIVITIES AS A FUNCTION OF TEMPERATURE (INDEX FXO) AND WATER AMOUNT 
! (INDEX FYO). 
! THIS PART OF THE CODE THUS GENERATES THE E2 FUNCTION. THE FXO INDICES HAVE BEEN OBTAINED IN FST88
! FOR CONVENIENCE.
!
! THIS SUBROUTINE EVALUATES THE K=1 CASE ONLY
!
! THIS LOOP REPLACES LOOPS GOING FROM I=1,IMAX AND KP=2,LP1 
! PLUS THE SPECIAL CASE FOR THE LP1TH LAYER
!--------------------------------------------------------------------------------------------------
    DO 132 K=1,LP1
        DO 132 I=MYIS,MYIE
            TMP3 (I,K) = LOG10(AVEPHI(I,K)) + H16E1
            FYO  (I,K) = AINT(TMP3(I,K) * TEN)
            DU   (I,K) = TMP3(I,K) - HP1 * FYO(I,K)
            FYO  (I,K) = H28E1 * FYO(I,K)
            IVAL (I,K) = FYO(I,K) + FXOE2(I,K)
            EMISS(I,K) = T1(IVAL(I,K)) + DU(I,K) * T2(IVAL(I,K)) + DTE2(I,K) * T4(IVAL(I,K))
132 END DO
!--------------------------------------------------------------------------------------------------
! THE SPECIAL CASE EMISS(I,L) (LAYER KP) IS OBTAINED NOW BY AVERAGING THE VALUES FOR L AND LP1:
!--------------------------------------------------------------------------------------------------
    DO 134 I=MYIS,MYIE
        EMISS(I,L) = HAF * (EMISS(I,L) + EMISS(I,LP1))
134 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATIONS FOR THE KP=1 LAYER ARE NOT PERFORMED, AS THE RADIATION CODE ASSUMES THAT THE TOP 
! FLUX LAYER (ABOVE THE TOP DATA LEVEL) IS ISOTHERMAL, AND HENCE CONTRIBUTES NOTHING TO THE FLUXES 
! AT OTHER LEVELS.
!
! THE FOLLOWING IS THE CALCULATION FOR THE E1 FUNCTION, FORMERLY DONE IN SUBROUTINE E1V88. 
! THE MOVE TO E1E288 IS DUE TO THE SAVINGS IN OBTAINING INDEX VALUES (THE TEMP. INDICES HAVE BEEN 
! OBTAINED IN FST88, WHILE THE U-INDICES ARE OBTAINED IN THE E2 CALCS., WITH K=1).
!
! FOR TERMS INVOLVING TOP LAYER, DU IS NOT KNOWN; IN FACT, WE USE INDEX 2 TO REPERSENT INDEX 1 IN 
! PREV. CODE. THIS MEANS THAT THE IT1 INDEX 1 AND LLP1 HAS TO BE CALCULATED SEPARATELY. 
! THE INDEX LLP2 GIVES THE SAME VALUE AS 1; IT CAN BE OMITTED.
!--------------------------------------------------------------------------------------------------
    DO 208 I=MYIS,MYIE
        IT1(I,1) = FXOE1(I,1)
        WW1(I,1) = TEN - DTE1(I,1)
        WW2(I,1) = HP1
208 END DO
!
    DO 209 K=1,L
        DO 209 I=MYIS,MYIE
            IT1(I,K+1)     = FYO(I,K) + FXOE1(I,K+1)
            IT1(I,LP2+K-1) = FYO(I,K) + FXOE1(I,K)
            WW1(I,K+1)     = TEN - DTE1(I,K+1)
            WW2(I,K+1)     = HP1 - DU(I,K)
209 END DO
!
    DO 211 KP=1,L
        DO 211 I=MYIS,MYIE
            IT1(I,KP+LLP1) = FYO(I,KP) + FXOE1(I,1)
211 END DO
!------------------------------------------------------ 
! G3(I,1) HAS THE SAME VALUES AS G1 (AND DID ALL ALONG)
!------------------------------------------------------ 
    DO 230 I=MYIS,MYIE
        G1(I,1) = WW1(I,1) * WW2(I,1) * EM1V(IT1(I,1)) + WW2(I,1) * DTE1(I,1) * EM1V(IT1(I,1)+1)
        G3(I,1) =  G1(I,1)
230 END DO
!
    DO 240 K=1,L
        DO 240 I=MYIS,MYIE
            G1(I,K+1)  =  WW1(I,K+1) *  WW2(I,K+1)  *  EM1V(IT1(I,K+1))                           &
    &                  +  WW2(I,K+1) * DTE1(I,K+1)  *  EM1V(IT1(I,K+1) +  1)                      &
    &                  +  WW1(I,K+1) *   DU(I,K)    *  EM1V(IT1(I,K+1) + 28)                      &
    &                  + DTE1(I,K+1) *   DU(I,K)    *  EM1V(IT1(I,K+1) + 29)
!
            G2(I,K)   =   WW1(I,K)   *  WW2(I,K+1)  *  EM1V(IT1(I,K+LP2-1))                       &
    &                 +   WW2(I,K+1) * DTE1(I,K)    *  EM1V(IT1(I,K+LP2-1) +  1)                  &
    &                 +   WW1(I,K)   *   DU(I,K)    *  EM1V(IT1(I,K+LP2-1) + 28)                  &
    &                 +  DTE1(I,K)   *   DU(I,K)    *  EM1V(IT1(I,K+LP2-1) + 29)
240 END DO
!
    DO 241 KP=2,LP1
        DO 241 I=MYIS,MYIE
            G3(I,KP)  =   WW1(I,1)   *  WW2(I,KP)   *  EM1V(IT1(I,LL+KP))                         &
    &                 +   WW2(I,KP)  * DTE1(I,1)    *  EM1V(IT1(I,LL+KP) +  1)                    &
    &                 +   WW1(I,1)   *   DU(I,KP-1) *  EM1V(IT1(I,LL+KP) + 28)                    &
    &                 +  DTE1(I,1)   *   DU(I,KP-1) *  EM1V(IT1(I,LL+KP) + 29)
241 END DO
!
    DO 244 I=MYIS,MYIE
        G4(I,1) = WW1(I,1) * WW2(I,1) * EM1VW(IT1(I,1)) + WW2(I,1) * DTE1(I,1) * EM1VW(IT1(I,1)+1)
244 END DO
!
    DO 242 K=1,L
        DO 242 I=MYIS,MYIE
            G4(I,K+1) =   WW1(I,K+1) *  WW2(I,K+1)  *  EM1VW(IT1(I,K+1))                          &
    &                 +   WW2(I,K+1) * DTE1(I,K+1)  *  EM1VW(IT1(I,K+1) +  1)                     &
    &                 +   WW1(I,K+1) *   DU(I,K)    *  EM1VW(IT1(I,K+1) + 28)                     &
    &                 +  DTE1(I,K+1) *   DU(I,K)    *  EM1VW(IT1(I,K+1) + 29)
!
            G5(I,K)   =   WW1(I,K)   *  WW2(I,K+1)  *  EM1VW(IT1(I,K+LP2-1))                      &
    &                 +   WW2(I,K+1) * DTE1(I,K)    *  EM1VW(IT1(I,K+LP2-1) +  1)                 &
    &                 +   WW1(I,K)   *   DU(I,K)    *  EM1VW(IT1(I,K+LP2-1) + 28)                 &
    &                 +  DTE1(I,K)   *   DU(I,K)    *  EM1VW(IT1(I,K+LP2-1) + 29)
242 END DO
!
    RETURN
!
    END SUBROUTINE E1E290

    PROGRAM EBU
!>--------------------------------------------------------------------------------------------------
!> MAIN PROGRAM EBU
!>
!> MAIN PROGRAM: ETAFCST - EARLY ETA MODEL FORECAST DRIVER
!> PROGRAMMER: JANJIC
!> ORG: NP22
!> DATE: 99-01-20
!>
!> ABSTRACT: 
!> EBU CONTAINS THE PRIMARY RUNSTREAM FOR THE EARLY ETA FORECAST MODEL.  
!> AFTER AN INITIAL CALL TO SUBROUTINE INIT, CALLS ARE MADE TO SUBROUTINES WHICH COMPUTE THE VARIOUS
!> DYNAMICAL AND PHYSICAL PROCESSES IN THE MODEL. 
!> THE VARIABLE 'NTSD' IS THE FUNDAMENTAL TIMESTEP COUNTER AND THUS ITS VALUE DETERMINES WHEN THE 
!> SUBROUTINES ARE CALLED.
!> INFORMATION PERTAINING TO THE SCHEMES USED IN THE MODEL AS WELL AS ADDITIONAL REFERENCES MAY BE
!> FOUND IN "THE STEP-MOUNTAIN ETA  COORDINATE REGIONAL MODEL:  A DOCUMENTATION" (BLACK 1988; 
!> DEVELOPMENT DIVISION) AND "THE NEW NMC MESO-SCALE ETA MODEL: DESCRIPTION AND FORECAST EXAMPLES 
!> (BLACK 1994; WEATHER AND FORECASTING).
!>
!> PROGRAM HISTORY LOG:
!> 87-08-??  JANJIC, BLACK - ORIGINATOR          
!> 93-05-12  TREADON       - DOCBLOCK INSERTED
!> 93-10-25  BLACK         - DOCBLOCK UPDATED
!> 97-03-15  MESINGER      - SPLITTING MODIFIED, TO SEPARATE THE ADJUSTMENT AND THE ADVECTION STEP                        
!> 97-11-19  BLACK         - MODIFIED FOR DISTRIBUTED MEMORY
!> 98-10-20  BLACK         - DISTRIBUTED MEMORY FORM FOR CURRENT OPERATIONAL CODE
!> 00-02-25  TUCCILLO      - INCORPORATED ASYNCHRONOUS I/O SERVERS
!> 00-11-14  BLACK         - INCORPORATED JANJIC NONHYDROSTATIC OPTION
!> 00-11-27  BLACK         - INCORPORATED RESTART CAPABILITY
!> 18-01-15  LUCCI         - MODERNIZATION OF THE CODE, INCLUDING:
!>                           * F77 TO F90/F95
!>                           * INDENTATION & UNIFORMIZATION CODE
!>                           * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                           * DOCUMENTATION WITH DOXYGEN
!>                           * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: BOCOH
!>              BOCOV
!>              CHKOUT
!>              CLTEND
!>              CUCNVC
!>              DDAMP
!>              DIVHOA
!>              DIVHOAST
!>              EXCH
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HDIFF
!>              HDIFFS
!>              HZADV2
!>              INIT
!>              INITS
!>              MPPINIT
!>              PDNEW
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              QUILT
!>              RADTN
!>              RDTEMP
!>              TURBL
!>              VADZ
!>              VTADV
!>              W3TAGB
!>              W3TAGE
!> 
!> DRIVER     : -----
!>
!> CALLS      : BOCOH
!>              BOCOV
!>              CHKOUT
!>              CLTEND
!>              CUCNVC
!>              DDAMP
!>              DIVHOA
!>              DIVHOAST
!>              EPS
!>              EXCH
!>              GETENV
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              INIT
!>              INITS
!>              MPI_BARRIER
!>              MPI_FINALIZE
!>              MPI_SEND
!>              MPPINIT
!>              PDNEW 
!>              PDTEDT
!>              PGCOR 
!>              PRECPD
!>              QUILT
!>              RADTN
!>              RDTEMP
!>              SETUP_SERVERS
!>              TURBL
!>              VADZ
!>              VTADV
!>              W3TAGB
!>              W3TAGE
!>            
!>
!> UNIQUE:
!> INIT     - INITIALIZE VARIABLES AT START OF INTEGRATION
!> DIVHOA   - DIVERGENCE, AND HORIZONTAL PART OF THE OMEGA-ALPHA TERM                
!> PGCOR    - PRESSURE GRADIENT AND CORIOLIS FORCE
!> PDTE     - UPDATE SURFACE PRESSURE TENDENCY AND ETADOT
!> VTADV    - VERTICAL ADVECTION
!> HZADV    - HORIZONTAL ADVECTION OF T, U, V, AND TKE
!> HZADV2   - HORIZONTAL ADVECTION OF Q AND CLOUD WATER
!> DDAMP    - APPLY DIVERGENCE DAMPING
!> PDNEW    - UPDATE SURFACE PRESSURE
!> HDIFF    - LATERAL DIFFUSION
!> BOCOH    - UPDATE H POINTS ON THE BOUNDARIES
!> BOCOV    - UPDATE V POINTS ON THE BOUNDARIES
!> RADTN    - RADIATION DRIVER
!> RDTEMP   - APPLY TEMPERATURE TENDENCY DUE TO RADIATION
!> TURBL    - PERFORM THE VERTICAL TURBULENT EXCHANGE
!> SURFACE  - UPDATE SURFACE TEMPERATURE, MOISTURE, AND OTHER GROUND HYDROLOGY            
!> GSCOND   - CLOUD WATER/ICE PHYSICS PARAMETERIZATION (EDAS ONLY)
!> CUCNVC   - CONVECTIVE ADJUSTMENT FOR DEEP OR SHALLOW CONVECTION
!> PRECPD   - GRID SCALE PRECIPITATION (EDAS ONLY)
!> GSMDRIVE - GRID SCALE MICROPHYSICS DRIVER (FREE FORECAST ONLY)
!> ADJPPT   - ADJUST MODEL PRECIPITATION TO OBSERVATIONS
!> CLTEND   - UPDATE TEMPERATURE FROM (GRID- AND SUBGRID-SCALE) CLOUD PROCESSES
!> CHKOUT   - POST PROFILE DATA.  FOR INTERNAL POST, POSTS MODEL OUTPUT.  
!>            FOR EXTERNAL POST, WRITES TEMPORARY FILE CONTAINING ALL MODEL ARRAYS.
!>
!> EXIT STATES:
!> COND =   1 - NORMAL EXIT
!>--------------------------------------------------------------------------------------------------
!
!----------------------------------------------------------------------- 
!         LIMITED AREA ETA MODEL WITH STEP-MOUNTAIN TOPOGRAPHY         
!
! NOAA / NATIONAL CENTERS FOR ENVIRONMENTAL PREDICTION, CAMP SPRINGS, MD
!
!      GEOPHYSICAL FLUID DYNAMICS LABORATORY / NOAA, PRINCETON, NJ     
!
!     UNIVERSITY CORPORATION FOR ATMOSPHERIC RESEARCH, BOULDER, CO.
!                                 AND                                        
!     DEPARTMENT OF METEOROLOGY, UNIVERSITY OF BELGRADE, YUGOSLAVIA 
!----------------------------------------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
!
! REFERENCES FOR THE DYNAMICAL PART OF THE MODEL
!
! STEP-MOUNTAIN ETA COORDINATE: 
! F. MESINGER, 1983, IN RES. ACTIVITIES IN ATMOS. AND OCEANIC MODELING, REP. NO. 5, 
! WMO, GENEVA, 4.9-4.10.
!
! HORIZONTAL ADVECTION, CONTINUITY EQUATION: 
! Z.I. JANJIC, 1984, MWR, 112, NO.6, 1234-1245.
! 
! INTERNAL BOUNDARIES, OMEGA-ALPHA TERM, CODING, PERFORMANCE: 
! MESINGER ET AL., 1988, MWR, 116 NO.7, 1493-1518.
!
! N.B. FOR MORE DETAILS ON THESE TOPICS SEE ALSO: 
!
! 1.  MESINGER, F., AND Z.I. JANJIC, 1985: PROBLEMS AND NUMERICAL METHODS OF THE INCORPORATION OF 
!     MOUNTAINS IN ATMOSPHERIC MODELS.
!     LECTURES IN APPLIED MATHEMATICS, VOL 22, AMER. MATH. SOC.; ALSO, NUMERICAL METHODS FOR 
!     WEATHER PREDICTION, SEMINAR 1983, ECMWF, 103-157;
!     ALSO, SHORT AND MEDIUM-RANGE WEATHER PREDICTION RESEARCH PUBL. SER., NO. 8, 
!     WMO, GENEVA, 175-233.
!
! 2.  JANJIC, Z.I., AND F. MESINGER, 1983: FINITE-DIFFERENCE METHODS FOR THE SHALLOW WATER 
!     EQUATIONS ON VARIOUS HORIZONTAL GRIDS.
!     NUMERICAL METHODS FOR WEATHER PREDICTION, SEMINAR 1983, ECMWF,29-101.
!
! SOME  REFERENCES FOR THE PHYSICS PART OF THE MODEL
!
! JANJIC, Z.I., 1990: THE STEP-MOUNTAIN COORDINATE: 
! PHYSICAL PACKAGE.  MONTHLY WEATHER REVIEW, VOL. 118, NO. 7, 1429-1443.
! JANJIC, Z.I., 1994: THE STEP MOUNTAIN ETA COORDINATE:
! FURTHER DEVELOPMENTS OF THER CONVECTION, VISCOUS SUBLAYER, AND TURBULENCE CLOSURE SCHEMES. 
! MONTHLY WEATHER REVIEW,VOL. 122, 927-945.
!
! ALSO SEE REFERENCES IN PHYSICAL SUBROUTINES 
!
!--------------------------------------------------------------------------------------------------
!
! THIS VERSION OF THE PROGRAM IS WRITTEN IN STANDARD ANSI FORTRAN 90 
!
! PRINCIPAL PROGRAMMERS: 
!
! Z. JANJIC, UNIVERSITY OF BELGRADE, T. BLACK, NCEP 
!
! THE MODEL USES THE SEMI-STAGGERED E GRID IN ARAKAWA NOTATION.
! HORIZONTAL INDEXING IS TWO-DIMENSIONAL. 
!
! H(1,JM)  V(1,JM)  H(2,JM)  V(2,JM) ...... V(IM-1,JM)  H(IM,JM) 
!    .        .        .        .               .          .     
!    .        .        .        .               .          .     
!    .        .        .        .               .          .     
!    .        .        .        .               .          .     
!                                                                
! H(1,3)   V(1,3)   H(2,3)   V(2,3) ....... V(IM-1,3)   H(IM,3)
!
! V(1,2)   H(1,2)   V(2,2)   H(2,2) ....... H(IM-1,2)   V(IM,2) 
!                                                                 
! H(1,1)   V(1,1)   H(2,1)   V(2,1) ....... V(IM-1,1)   H(IM,1) 
!
!
!
! ARRAYS ARE DIMENSIONED (IM,JM). NOTE THAT A PHANTOM COLUMN OF POINTS MUST EXIST ALONG THE 
! EASTERN EDGE FOR THE ARRAYS TO BE COMPLETE.                                             
! 
! THE TOTAL NUMBER OF GRID POINTS IN THE HORIZONTAL EXCLUDING 
! THE PHANTOM COLUMN IS IMJM=IM*JM-JM/2.                      
! 
! AUXILIARY ARRAYS ARE USED TO LOCATE NEIGHBORING GRID POINTS WITH RESPECT TO A GIVEN GRID
! POINT. IHE(J) IS THE INCREMENT TO THE I INDEX NEEDED TO REFER TO THE V POINT EAST OF AN
! H POINT THUS IHE(J)=0 ON ODD ROWS AND =1 ON EVEN ROWS. 
! IHW(J)=IHE(J)-1 IS THE INCREMENT TO THE INDEX OF AN H POINT  TO REFER TO THE V POINT TO THE
! WEST OF THAT H POINT. THE ANALOG EXISTS FOR THE ARRAYS IVE(J) AND IVW(J).
!
! BOUNDARY MASKS AND TOPOGRAPHY MASKS ARE DEFINED FOR VECTOR PROCESSING. THE BOUNDARY MASKS 
! HBM2(K) AND VBM2(K) ARE EQUAL TO ONE EVERYWHERE EXCEPT AT THE TWO OUTERMOST ROWS WHERE THEY
! ARE EQUAL TO ZERO. THE BOUNDARY MASK VBM3(K) IS EQUAL TO ONE EVERYWHERE EXCEPT AT THE THREE 
! OUTERMOST ROWS WHERE IT IS EQUAL TO ZERO. THE TOPOGRAPHY MASKS (HTM(K,L) AND VTM(K,L)) ARE 
! SET TO ZERO UNDERNEATH THE TOPOGRAPHY AND TO ONE ELSWHERE. IN ADDITION, FOR TREATMENT OF 
! PHYSICAL PROCESSES, MAXIMUM VALUES OF THE VERTICAL INDEX ARE DEFINED AND STORED (LMH(K) AND 
! LMV(K).  
!
!--------------------------------------------------------------------------------------------------
! THE NUMBER OF QUILT SERVERS MUST AGREE WITH THE FOLLOWING RELATIONSHIP:
! 0 <=  NUMBER_QUILT_SERVERS <= JNPES 
! WHERE THE NUMBER_QUILT_SERVERS = ( NUMBER_OF MPI_TASKS - INPES*JNPES )
!
! PREFERABLY, THE NUMBER OF QUILT SERVERS DIVIDES EVENLY INTO JNPES
!
! JIM TUCCILLO - AUGUST 2000
!--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE NHYDRO
    USE NSOILTYPE
    USE OUTFIL
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TIMMING
    USE TOPO
    USE VRBLS
    USE UPDATE_FLDS
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & CLTEND_TEST
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & GSPREC
!
    NAMELIST /GSPRECNML/ GSPREC
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SLOPE  , LSST
!
    NAMELIST /SLOPENML/ SLOPE
!------------------------------------------------ 
! THE FOLLOWING ARE USED FOR TIMIMG PURPOSES ONLY
!------------------------------------------------ 
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                                        ::&
    &  BOCOH_TIM        ,  BOCOV_TIM        ,   CHKOUT_TIM      , CLTEND_TIM        ,             &
    & CUCNVC_TIM        ,  DDAMP_TIM        ,   DIVHOA_TIM      ,    EPS_TIM        ,             &
    &   GOSS_TIM        , GSCOND_TIM        , GSMDRIVE_TIM      ,   HADZ_TIM        ,             &
    &  HDIFF_TIM        ,  HZADV_TIM        ,   HZADV2_TIM      ,   INIT_TIM        ,             &
    &    MPP_TIM        ,  PDNEW_TIM        ,   PDTEDT_TIM      ,  PGCOR_TIM        ,             &
    & PPTADJ_TIM        , PRECPD_TIM        ,    RADTN_TIM      , RDTEMP_TIM        ,             &
    &  TURBL_TIM        ,   VADZ_TIM        ,    VTADV_TIM      ,   TOT2_TIM        ,             &
    &    TOT_TIM
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & BTIMX   , BTIM    , BBTIM   , PCT
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , IER     , IERR    , ICLTEND, K      , CALC_NVEG,CALC_SST  , NREC_SST_UP 
!
    CHARACTER(LEN=8)                                                                            ::&
    & ENVAR   , SRFILE
!--------------------------------------------------------------------------------------------------
! INITIALIZE MPI, SETUP I/O SERVER MECHANICS AND CHECK FOR WHETHER A SUFFICIENT NUMBER OF MPI TASKS
! HAVE BEEN INITIATED.
! IF INSUFFICIENT MPI TASK HAVE BEEN INITIATED THE CODE WILL STOP IN SETUP_SERVERS
!--------------------------------------------------------------------------------------------------
    CALL SETUP_SERVERS(INPES*JNPES  , MYPE          , NPES                , IQUILT_GROUP, INUMQ,  &
    &                  MPI_COMM_COMP, MPI_COMM_INTER, MPI_COMM_INTER_ARRAY)
!
    IF (MYPE == 0) THEN
        CALL W3TAGB('ETAFCST ',0097,0365,0060,'NP22   ')
    END IF
!-------------------------------------------------------------------------------- 
! AT THIS POINT NPES IS THE NUMBER OF MPI TASKS WORKING ON THE MODEL INTEGRATION.
! ALL OTHER TASKS ARE I/O SERVERS. AND AWAY WE GO !
!-------------------------------------------------------------------------------- 
    IF (MYPE >= NPES) THEN
!------------------------   
! FIRE UP THE I/O SERVERS
!------------------------   
        CALL QUILT
!    
    ELSE
!-------------------------------------------------- 
! THESE ARE THE TASKS THAT DO THE MODEL INTEGRATION
!-------------------------------------------------- 
           BOCOH_TIM = 0. 
           BOCOV_TIM = 0.
          CHKOUT_TIM = 0.        
          CLTEND_TIM = 0.        
          CUCNVC_TIM = 0.       
           DDAMP_TIM = 0.
          DIVHOA_TIM = 0.       
             EPS_TIM = 0. 
            EXCH_TIM = 0.
            GOSS_TIM = 0.
          GSCOND_TIM = 0.
        GSMDRIVE_TIM = 0.
            HADZ_TIM = 0.
           HDIFF_TIM = 0.
           HZADV_TIM = 0.
          HZADV2_TIM = 0.
            INIT_TIM = 0.
             MPP_TIM = 0.
             NHB_TIM = 0.
           PDNEW_TIM = 0.
          PDTEDT_TIM = 0.
           PGCOR_TIM = 0.
          PPTADJ_TIM = 0.
          PRECPD_TIM = 0.
           RADTN_TIM = 0.
          RDTEMP_TIM = 0.
             RES_TIM = 0.
          SURFCE_TIM = 0.
           TURBL_TIM = 0.
            VADZ_TIM = 0.
           VTADV_TIM = 0.
!------------------------------------------------------------- 
! INITIALIZE ALL QUANTITIES ASSOCIATED WITH GRID DECOMPOSITION
!------------------------------------------------------------- 
        BTIMX = TIMEF()
        BTIM  = TIMEF()
!
        CALL MPPINIT
!
        MPP_TIM = MPP_TIM + TIMEF() - BTIM
!----------------------------------------------- 
! INITIALIZE CONSTANTS AND VARIABLES 
! DISTRIBUTE THE VALUES TO THE VARIOUS NODES/PES
!----------------------------------------------- 
        IF (MYPE == 0) THEN
            WRITE(6,*) 'LENDO A QUANTIDADE DE TIPOS DE SOLO '
        END IF
    !
        OPEN(1, FILE='TYPSOLO', FORM='FORMATTED', STATUS='OLD')
        READ(1,110) NSOTYP
    110 FORMAT(I2)
        CLOSE(1)
!
        IF (MYPE == 0) THEN
            WRITE(6,*) 'NSOTY: ',NSOTYP
        END IF
!
        OPEN(UNIT=1, FILE='GSPREC.nml', STATUS='OLD')
        READ(1,GSPRECNML)
        CLOSE(1)
!              
        IF (MYPE == 0) THEN
            IF (GSPREC) THEN
                WRITE(6,*) 'UTILIZANDO: FERRIER'
            ELSE
                WRITE(6,*) 'UTILIZANDO: ZHAO'
            END IF
        END IF
!
        OPEN(UNIT=9, FILE="SLOPE.nml", STATUS="OLD")
        READ(9,SLOPENML)
        CLOSE(9)
!
        IF (MYPE == 0) WRITE(*,SLOPENML)
!
        BBTIM = TIMEF()
!
        IF (SLOPE) THEN
            CALL INITS
        ELSE
            CALL INIT
        END IF
!
        INIT_TIM = TIMEF() - BBTIM
!    
        BTIM = TIMEF()
!
        CALL GOSSIP
!
        GOSS_TIM = GOSS_TIM + TIMEF() - BTIM
!------------------------------------------- 
! INVOKE THE LYNCH DIGITAL FILTER IF DESIRED 
!------------------------------------------- 
!        DO NFLT=1,3
!           IF (.NOT. NEST .AND .NFLT .GT. 1 .AND. MYPE .EQ. 0) THEN
!              REWIND NBC
!              READ(NBC)
!              READ(NBC)BCHR
!    
!           END IF
!        CALL DIGFLT
!    
!       END DO
!
        CALL GETENV("TMMARK", ENVAR)
!
        IF (MYPE == 0) WRITE(0,*) "EBU FINDS THAT TMMARK =", ENVAR
!
        IF (ENVAR /= 'TM00') THEN
!
         10 FORMAT('SR.',A4)
!
        END IF
!
        CLTEND_TEST = .TRUE. 
!
        IF (NPHS /= NCNVC) THEN
            CLTEND_TEST = .FALSE. 
            IF (ENVAR /= 'TM00') THEN
                WRITE(0,"(A)") 'WARNING: RESULTS COULD BE IN ERROR !'
            END IF
        END IF
!-----------------------------------------
!READ OUT2RESTRT FILES WHEN RESTRT IS TRUE
!-----------------------------------------
        IF (RESTRT) THEN
	    PRINT*, "Entered READ_OUT2RESTRT, MYPE: ", MYPE
            CALL READ_OUT2RESTRT(12.0)
	ENDIF
!------------------------------------------------------- 
! SPECIAL CONSIDERATION WHEN NTSD=0 AT START OF FORECAST
!------------------------------------------------------- 
        IF (NTSD == 0) NTSD = 1
!-------------------------------------------------------- 
! CALLED AT BEGINNING EVERY TIME IN ORDER TO TEST CYCLING
!-------------------------------------------------------- 
!        IF (MOD(NTSD,NRADS) == 1 .OR. MOD(NTSD,NRADL) == 1) THEN
        IF (NTSD .EQ. 1 .OR. RESTRT) THEN
            BTIM = TIMEF()
!
            CALL RADTN
!
            RADTN_TIM = RADTN_TIM + TIMEF() - BTIM
        END IF
!------------------------ 
! GENERATE INITIAL OUTPUT 
!------------------------ 
        BTIM = TIMEF()
!
        CALL CHKOUT
!
        CHKOUT_TIM = CHKOUT_TIM   + TIMEF() - BTIM
!
        IF (NTSD == 1) NTSD = 0
!------------------------- 
! ENTRY INTO THE TIME LOOP 
!------------------------- 
    2000 CONTINUE
        NTSD = NTSD + 1
!
        IF (MYPE == 0) WRITE(0,2001) NTSD, (NTSD-1) * DT, (NTSD-1) * DT / 3600
   2001 FORMAT('EBU:  TIMESTEP NTSD=',I5,'  FCST TIME=',F7.0,' S',' AND ',F8.3,' H')
! GSM XC
! UPDATE  SST DATA 
!---------------------------------------
       LSST = .FALSE.
!
        IF (LSST) THEN
!
            CALC_SST = 86400 / DT
!
            IF ((RESTRT) .OR. (MOD(NTSD,CALC_SST) == 0)) THEN
                CALL FLDS_UPDATE_DRIVER('UPDATE          ','SST             ',CALC_SST)
            END IF
        END IF

!----------------------------
! CHOU 02-02-2008
! UPDATE MONTHLY VEG GREENESS
!----------------------------
!
!        CALC_NVEG = 86400 / DT
!
!        IF ((NTSD == 1) .OR. (RESTRT) .OR. (MOD(NTSD,CALC_NVEG) == 0)) THEN
!------------------------------
! UPDATE EVERY UPDATE EVERY 24H
!------------------------------
!                CALL FLDS_UPDATE_DRIVER('UPDATE          ','VGREEN          ')
!        END IF
!GSM XC
!--------------------------------------------------------------------------------------------- 
! START THE ADJUSTMENT STEP: INTEGRATE FORWARD THE CONTINUITY EQUATION (UPDATE THE MASS FIELD)
!--------------------------------------------------------------------------------------------- 
!
!------------------------------------------------------- 
! DIVERGENCE AND HORIZONTAL PART OF THE OMEGA-ALPHA TERM
!------------------------------------------------------- 
        IF (NTSD > 1)     CALL EXCH(T , LM, U , LM, V, LM, Q, LM, 2, 2) 
!
        IF (.NOT. HYDRO) THEN
            IF (NTSD > 1) CALL EXCH(DWDT, LM, PINT, LM+1, 5, 5)
        END IF
 !   
        BTIM = TIMEF()
!
        IF (SLOPE) THEN
            CALL DIVHOAST
        ELSE
            CALL DIVHOA
        END IF
!
        DIVHOA_TIM = DIVHOA_TIM + TIMEF() - BTIM  
!------------------------------------------------------- 
! PRESSURE TENDENCY, ETA/SIGMA DOT, VERTICAL OMEGA-ALPHA 
!------------------------------------------------------- 
        BTIM = TIMEF()
!
        CALL EXCH(PD, 1, DIV, LM, PINT, LM+1, 2, 2)
!
        EXCH_TIM = EXCH_TIM     + TIMEF() - BTIM
!   
        BTIM = TIMEF()
!
        CALL PDTEDT !CONTAINS CALL TO EXCH
!
        PDTEDT_TIM = PDTEDT_TIM + TIMEF() - BTIM
!-------------------------------------------------------
! DO VERTICAL ADVECTION WITHIN THE FIRST ADJUSTMENT STEP 
!-------------------------------------------------------
!        IF (MOD(NTSD-1,IDTAD) == 0) THEN
        IF (MOD(NTSD,IDTAD) == 1) THEN
            BTIM = TIMEF()
!
            CALL EXCH(ETADT,LM-1,1,1)
!
            EXCH_TIM = EXCH_TIM   + TIMEF() - BTIM
!        
            BTIM = TIMEF()
!
             CALL VTADV
!
             VTADV_TIM = VTADV_TIM + TIMEF() - BTIM
!        
            BTIM = TIMEF()
!
            CALL EXCH(T, LM, U, LM, V, LM, Q, LM, Q2, LM, 1, 1)
!
            EXCH_TIM  = EXCH_TIM  + TIMEF() - BTIM
        END IF
!----------------------------- 
! UPDATING PRESSURE DIFFERENCE 
!----------------------------- 
        BTIM = TIMEF()
!
        CALL PDNEW
!
        PDNEW_TIM = PDNEW_TIM + TIMEF() - BTIM
!----------------------------------------- 
! PDATING BOUNDARY VALUES AT HEIGHT POINTS 
!-----------------------------------------  
        BTIM = TIMEF()
!
        IF (MOD(NTSD,IDTAD) == 1) THEN
!
            CALL EXCH(T, LM, Q, LM, Q2, LM, 1, 1)
!
        END IF
!
        CALL EXCH(PD, 1, CWM, LM, 1, 1)
!
        EXCH_TIM  =  EXCH_TIM + TIMEF() - BTIM
!    
        BTIM = TIMEF()
!
        CALL BOCOH 
!
        BOCOH_TIM = BOCOH_TIM + TIMEF() - BTIM
!-----------------------------------------------------------------
! INTEGRATE BACKWARD THE MOMENTUM EQUATION (UPDATE THE WIND FIELD)
!-----------------------------------------------------------------
!
!------------------------------------------ 
!PRESSURE GRADIENT AND CORIOLIS FORCE TERMS
!------------------------------------------
        BTIM = TIMEF()
!
        CALL EXCH(PD, 1, T, LM, Q, LM, 2, 2)
!
        IF (.NOT. HYDRO) THEN
            CALL EXCH(PINT, LM+1, 5, 5)
        END IF
!    
        EXCH_TIM  = EXCH_TIM  + TIMEF() - BTIM
!    
        BTIM = TIMEF()
!
        CALL PGCOR
!
        PGCOR_TIM = PGCOR_TIM + TIMEF() - BTIM
!    
        BTIM = TIMEF()
!
        CALL EXCH(PDSL, 1, 5, 5)
!
        EXCH_TIM =  EXCH_TIM  + TIMEF() - BTIM
!-------------------  
! DIVERGENCE DAMPING 
!-------------------  
        IF (MOD(NTSD,NTDDMP) == 0) THEN
            BTIM = TIMEF()
!
            CALL EXCH(T, LM, U, LM, V, LM, DIV, LM, 1, 1)
!
            EXCH_TIM  = EXCH_TIM  + TIMEF() - BTIM    
            BTIM = TIMEF()
!
            CALL DDAMP
!
            DDAMP_TIM = DDAMP_TIM + TIMEF() - BTIM
        END IF
!-------------------------------------------- 
! UPDATING BOUNDARY VALUES AT VELOCITY POINTS 
!-------------------------------------------- 
        BTIM = TIMEF()
!
        CALL EXCH(U, LM, V, LM, 1, 1)
!
        EXCH_TIM  = EXCH_TIM  + TIMEF() - BTIM    
        BTIM = TIMEF()
!
        CALL BOCOV
!
        BOCOV_TIM = BOCOV_TIM + TIMEF() - BTIM
!-------------------------------------------------------------------------------------------------- 
! THE ADJUSTMENT STEP IS NOW DONE. MAKE THE REMAINING CALLS WHICH TRADITIONALLY (SO FAR) HAVE BEEN 
! DONE EVERY ADJUSTMENT STEP
!--------------------------------------------------------------------------------------------------
!
!-------------------------------------------- 
! APPLY TEMPERATURE TENDENCY DUE TO RADIATION 
!--------------------------------------------
        BTIM = TIMEF()
!
        CALL RDTEMP
!
        RDTEMP_TIM = RDTEMP_TIM + TIMEF() - BTIM
!------------------  
! LATERAL DIFFUSION 
!------------------ 
        BTIM = TIMEF()
!
        CALL EXCH(T , LM, U, LM, V, LM, Q, LM, 2, 2)
!
        CALL EXCH(Q2, LM, 1, 1)
!
        EXCH_TIM   = EXCH_TIM   + TIMEF() - BTIM
!    
        BTIM = TIMEF()
!
        IF (SLOPE) THEN
            CALL HDIFFS
        ELSE
            CALL HDIFF
        END IF
!
        HDIFF_TIM  = HDIFF_TIM  + TIMEF() - BTIM
!--------------------- 
! HORIZONTAL ADVECTION  
!---------------------  
!        IF (MOD(NTSD,IDTAD) == 0) THEN
        IF (MOD(NTSD,IDTAD) == 1) THEN
            BTIM = TIMEF()
!
            CALL EXCH(T , LM, U, LM, V, LM, 4, 4)
!
            CALL EXCH(Q2, LM, 5, 5)
!
            EXCH_TIM  = EXCH_TIM + TIMEF() - BTIM
!        
            BTIM = TIMEF()
!
            IF (SLOPE) THEN
                CALL HZADVS
!                CALL SLADVT
            ELSE
                CALL HZADV
!                CALL HZADV_LM1
            END IF
!
            HZADV_TIM = HZADV_TIM + TIMEF() - BTIM
!        
            BTIM = TIMEF()
!
            CALL EXCH(U, LM, V, LM, Q, LM, CWM, LM, 2, 2)
!
            EXCH_TIM = EXCH_TIM + TIMEF() - BTIM
!----------------------------------------        
! HORIZONTAL ADVECTION OF WATER SUBSTANCE
!----------------------------------------         
            BTIM = TIMEF()
!
            CALL HZADV2
!
            HZADV2_TIM = HZADV2_TIM + TIMEF() - BTIM
        END IF
!--------------------------------------------------------------------------------------------------
! IF THE TIME IS RIGHT, NOW DO VARIOUS PHYSICS CALLS
! (WARNING: TO AVOID ENDING THE INTEGRATION WITH PHYSICS CALLS WHICH HAVE NOT BEEN FOLLOWED BY 
! ADJUSTMENT STEPS, PHYSICS CALLS ARE OFFSET BY HALVES OF VARIOUS CALLING INTERVALS.  
! IT IS ASSUMED THAT THE CALLING INTERVALS, NPHS AND NCNVC, ARE DIVISIBLE BY IDTAD. 
! IF NOT, INTEGRATION WILL END WITH AN INCORRECT NUMBER OF CALLS HAVING BEEN MADE.
!--------------------------------------------------------------------------------------------------
!
!-------------------------------------- 
! TURBULENT PROCESSES AND PRECIPITATION 
!--------------------------------------
!        IF (MOD(NTSD-NPHS/2,NPHS) == 0) THEN
        IF (MOD(NTSD,NPHS) == 1) THEN
!
            IF (MYPE == 0) THEN
                WRITE(0,"(A)") 'EBU:  PHYSICS TIME STEP'
            END IF
!
            BTIM = TIMEF()
!
            CALL EXCH(PD, 1, UZ0, 1, VZ0, 1, T, LM, U, LM, V, LM, Q, LM, 1, 1)
!
            EXCH_TIM      = EXCH_TIM  + TIMEF() - BTIM
!        
            BTIM = TIMEF()
!
            CALL TURBL !CONTAINS CALLS TO EXCH
!
            TURBL_TIM = TURBL_TIM + TIMEF() - BTIM
!--------------------------------- 
! STORE ORIGINAL TEMPERATURE ARRAY
!--------------------------------- 
            IF (CLTEND_TEST) THEN
                BTIM = TIMEF()
                ICLTEND = -1
!
                CALL CLTEND(ICLTEND)
!
                CLTEND_TIM = CLTEND_TIM + TIMEF() - BTIM
            END IF
!
            IF (.NOT. GSPREC) THEN
                BTIM = TIMEF()
!
                CALL GSCOND
!
                GSCOND_TIM   = GSCOND_TIM + TIMEF() - BTIM
            END IF
!------------------------- 
! CONVECTIVE PRECIPITATION 
!------------------------- 
            BTIM = TIMEF()
!
            CALL CUCNVC
!
            CUCNVC_TIM   = CUCNVC_TIM + TIMEF() - BTIM
!-----------------------------------------------------------------------
! GRIDSCALE MICROPHYSICS (CONDENSATION AND PRECIPITATION; FORECAST ONLY)
!-----------------------------------------------------------------------
            IF (GSPREC) THEN
                BTIM = TIMEF()
!
                CALL GSMDRIVE
!
                GSMDRIVE_TIM = GSMDRIVE_TIM + TIMEF() - BTIM
!
            ELSE
!---------------------------- 
! GRIDSCALE ZHAO MICROPHYSICS
!---------------------------- 
                BTIM = TIMEF()
!
                CALL PRECPD
!
                PRECPD_TIM     = PRECPD_TIM   + TIMEF() - BTIM
            END IF
!---------------------------- 
! PRECIPIPTATION ASSIMILATION 
!----------------------------
!
!----------------------------------------------------- 
! CALCULATE TEMP TENDENCIES AND RESTORE ORIGINAL TEMPS 
!----------------------------------------------------- 
            IF (CLTEND_TEST) THEN
                BTIM    = TIMEF()
                ICLTEND = 0
!
                CALL CLTEND(ICLTEND)
!
                CLTEND_TIM = CLTEND_TIM + TIMEF() - BTIM
            END IF
!-------------------- 
! END PHYSICS IF LOOP
!-------------------- 
        END IF
!------------------------------------------------------------ 
! UPDATE TEMP TENDENCIES FROM CLOUD PROCESSES EVERT TIME STEP
!------------------------------------------------------------ 
        IF (CLTEND_TEST) THEN
            BTIM    = TIMEF()
            ICLTEND = 1
!
            CALL CLTEND(ICLTEND)
!
            CLTEND_TIM = CLTEND_TIM + TIMEF() - BTIM
        END IF  
!----------------------------- 
! VERTICAL ADVECTION OF HEIGHT 
!----------------------------- 
        BTIM = TIMEF()
!
        CALL VADZ
!
        VADZ_TIM = VADZ_TIM  + TIMEF() - BTIM
!------------------------------- 
! HORIZONTAL ADVECTION OF HEIGHT 
!------------------------------- 
        IF ( .NOT. HYDRO) THEN
            BTIM = TIMEF()
!
            CALL EXCH(U, LM  , V, LM, 1, 1)
!
            CALL EXCH(Z, LM+1, 2, 2)
!
            EXCH_TIM = EXCH_TIM  + TIMEF() - BTIM
        END IF
!    
        BTIM = TIMEF()
!
        CALL HADZ
!
        HADZ_TIM = HADZ_TIM + TIMEF() - BTIM
!--------------- 
! ADVECTION OF W 
!--------------- 
        IF (HYDRO) THEN
            BTIM = TIMEF()
!
            CALL EXCH(PDSL, 1   , 2, 2)
!
            CALL EXCH(PINT, LM+1, 3, 3)
!
            EXCH_TIM  = EXCH_TIM + TIMEF() - BTIM
        ELSE
            BTIM = TIMEF()
!
            CALL EXCH(PDSL, 1 , 2, 2)
!
            CALL EXCH(U   , LM, V, LM, DWDT, LM, PINT, LM+1, W, LM+1, 3, 3)
!
            EXCH_TIM = EXCH_TIM + TIMEF() - BTIM
        END IF
!    
        BTIM = TIMEF()
!
        CALL EPS
!
        EPS_TIM = EPS_TIM  + TIMEF() - BTIM
!
        IF (NTSD > NSTART+1) THEN
!---------- 
! RADIATION 
!---------- 
            IF (MOD(NTSD,NRADS) == 1 .OR. MOD(NTSD,NRADL) == 1) THEN
                BTIM = TIMEF()
!
                CALL RADTN
!
                RADTN_TIM = RADTN_TIM + TIMEF() - BTIM
!
            END IF
!------------------------------------------------------- 
! IS IT TIME FOR A CHECK POINT ON THE MODEL HISTORY FILE 
!------------------------------------------------------- 
            BTIM = TIMEF()
!
            CALL CHKOUT
!
            CHKOUT_TIM = CHKOUT_TIM + TIMEF() - BTIM
        END IF
!----------------------- 
! CLEAN UP AFTER RESTART 
!----------------------- 
        IF (RESTRT) THEN
            RESTRT = .FALSE. 
        END IF
!
        IF ( NTSD == 1 .OR. MOD((NTSD-1)*DT,3600) == 0) THEN
             IF (MYPE == 0) PRINT*, 'OUT2RESTRT CALLED, NTSD= ', NTSD, NTSD*DT/3600
	     CALL OUT2RESTRT(ITAG)
        ENDIF	
! 
        IF (NTSD < NTSTM) GOTO 2000
!------------------------ 
! EXIT FROM THE TIME LOOP     
!------------------------ 
        2005 CONTINUE
        TOT2_TIM = TIMEF() - BTIMX
        TOT_TIM  =    MPP_TIM +   INIT_TIM +   GOSS_TIM + RADTN_TIM    + CHKOUT_TIM + DIVHOA_TIM  &
    &            + PDTEDT_TIM +  VTADV_TIM +  PDNEW_TIM + BOCOH_TIM    +  PGCOR_TIM +  DDAMP_TIM  &
    &            +  BOCOV_TIM + RDTEMP_TIM +  HDIFF_TIM + HZADV_TIM    + HZADV2_TIM +  TURBL_TIM  &
    &            + GSCOND_TIM + CUCNVC_TIM +   EXCH_TIM + GSMDRIVE_TIM + CLTEND_TIM +   VADZ_TIM  &
    &            +   HADZ_TIM +    EPS_TIM + PRECPD_TIM
!    
        IF (MYPE == 0) THEN
            PCT =      MPP_TIM / TOT_TIM*1.E2
            WRITE(6,*)       ' MPP=',MPP_TIM*1.E-3,'    PCT=',PCT
            PCT =     INIT_TIM / TOT_TIM*1.E2
            WRITE(6,*)      ' INIT=',INIT_TIM*1.E-3,'   PCT=',PCT
            PCT =     GOSS_TIM / TOT_TIM*1.E2
            WRITE(6,*)      ' GOSS=',GOSS_TIM*1.E-3,'   PCT=',PCT
            PCT =    RADTN_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' RADTN=',RADTN_TIM*1.E-3,'  PCT=',PCT
            PCT =   CHKOUT_TIM / TOT_TIM*1.E2
            WRITE(6,*)    ' CHKOUT=',CHKOUT_TIM*1.E-3,' PCT=',PCT
            PCT =   DIVHOA_TIM / TOT_TIM*1.E2
            WRITE(6,*)    ' DIVHOA=',DIVHOA_TIM*1.E-3,' PCT=',PCT
            PCT =   PDTEDT_TIM / TOT_TIM*1.E2
            WRITE(6,*)  ' PDTEDT=',PDTEDT_TIM*1.E-3,'   PCT=',PCT
            PCT =    VTADV_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' VTADV=',VTADV_TIM*1.E-3,'  PCT=',PCT
            PCT =    PDNEW_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' PDNEW=',PDNEW_TIM*1.E-3,'  PCT=',PCT
            PCT =    BOCOH_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' BOCOH=',BOCOH_TIM*1.E-3,'  PCT=',PCT
            PCT =    PGCOR_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' PGCOR=',PGCOR_TIM*1.E-3,'  PCT=',PCT
            PCT =   PRECPD_TIM / TOT_TIM*1.E2
            WRITE(6,*)   ' PRECPD=',PRECPD_TIM*1.E-3,'  PCT=',PCT
            PCT =    DDAMP_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' DDAMP=',DDAMP_TIM*1.E-3,'  PCT=',PCT
            PCT =    BOCOV_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' BOCOV=',BOCOV_TIM*1.E-3,'  PCT=',PCT
            PCT =   RDTEMP_TIM / TOT_TIM*1.E2
            WRITE(6,*)    ' RDTEMP=',RDTEMP_TIM*1.E-3,' PCT=',PCT
            PCT =    HDIFF_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' HDIFF=',HDIFF_TIM*1.E-3,'  PCT=',PCT
            PCT =    HZADV_TIM / TOT_TIM*1.E2
            WRITE(6,*)     ' HZADV=',HZADV_TIM*1.E-3,'  PCT=',PCT
            PCT =   HZADV2_TIM / TOT_TIM*1.E2
            WRITE(6,*)    ' HZADV2=',HZADV2_TIM*1.E-3,' PCT=',PCT
            PCT =     VADZ_TIM / TOT2_TIM*1.E2
            WRITE(6,*)       ' VADZ=',VADZ_TIM*1.E-3,'  PCT=',PCT
            PCT =     HADZ_TIM / TOT2_TIM*1.E2
            WRITE(6,*)       ' HADZ=',HADZ_TIM*1.E-3,'  PCT=',PCT
            PCT =      EPS_TIM / TOT2_TIM*1.E2
            WRITE(6,*)         ' EPS=',EPS_TIM*1.E-3,'  PCT=',PCT
            PCT =    TURBL_TIM /  TOT_TIM*1.E2
            WRITE(6,*)     ' TURBL=',TURBL_TIM*1.E-3,'  PCT=',PCT
            PCT =   CUCNVC_TIM /  TOT_TIM*1.E2
            WRITE(6,*)    ' CUCNVC=',CUCNVC_TIM*1.E-3,' PCT=',PCT
            PCT = GSMDRIVE_TIM /  TOT_TIM*1.E2
            WRITE(6,*)' GSMDRIVE=',GSMDRIVE_TIM*1.E-3,' PCT=',PCT
            PCT =   CLTEND_TIM /  TOT_TIM*1.E2
            WRITE(6,*)    ' CLTEND=',CLTEND_TIM*1.E-3,' PCT=',PCT
            PCT =     EXCH_TIM /  TOT_TIM*1.E2
            WRITE(6,*)      ' EXCH=',EXCH_TIM*1.E-3,'   PCT=',PCT
!
            WRITE(6,*) ' TOTAL=', TOT_TIM*1.E-3
            WRITE(6,*)' TOTAL2=',TOT2_TIM*1.E-3
        END IF
!------------------------------------------------------------------
! WE MUST NOW SHUT DOWN THE I/O SERVERS
! THIS IS DONE BY SENDING A -999 TO MPI TASK 0 OF EACH SERVER GROUP
!------------------------------------------------------------------    
        IF (MYPE == 0) THEN
            DO I=1,IQUILT_GROUP
                CALL MPI_SEND(-999, 1, MPI_INTEGER, 0, 0, MPI_COMM_INTER_ARRAY(I), IER)
            END DO
        END IF
!---------------------------------------------------- 
!END IF ON TASKS FOR MODEL INTEGRATION VS I/O SERVING
!---------------------------------------------------- 
    END IF 
!
    CALL MPI_BARRIER(MPI_COMM_WORLD, IERR)
!
    IF (MYPE == 0) THEN
        CALL W3TAGE('ETAFCST ')
    END IF
!
    CALL MPI_FINALIZE(IERR)
!
    STOP
!
    END PROGRAM EBU

    SUBROUTINE GSMCONST(DTPH)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GSMCONST
!>
!> SUBPROGRAM: GSMCONST - INITIALIZE CONSTANTS AND LOOKUP TABLES FOR MICROPHYSICS
!> PROGRAMMER: FERRIER
!> ORG: W/NP22
!> DATE: 01-02-??
!>
!> ABSTRACT:
!> READS VARIOUS MICROPHYSICAL LOOKUP TABLES USED IN COLUMN_MICRO
!> LOOKUP TABLES WERE CREATED "OFFLINE" AND ARE READ IN DURING EXECUTION
!> CREATES LOOKUP TABLES FOR SATURATION VAPOR PRESSURE W/R/T WATER & ICE
!>
!> PROGRAM HISTORY LOG:
!> 01-02-??  FERRIER    - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> DTPH - PHYSICS TIME STEP (S)
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CMICRO_CONS
!>              CMY600
!>              F77KINDS
!>              IACCR_TABLES
!>              IMASS_TABLES 
!>              IRATE_TABLES
!>              IRIME_TABLES
!>              IVENT_TABLES
!>              MAPOT
!>              PARMETA
!>              RACCR_TABLES
!>              RMASS_TABLES
!>              RRATE_TABLES
!>              RVELR_TABLES
!>              RVENT_TABLES
!>              SDENS_TABLES
!> 
!> DRIVER     : GSMDRIVE
!>
!> CALLS      : GPVS
!>              MY_GROWTH_RATES
!>--------------------------------------------------------------------------------------------------
    USE CMICRO_CONS
    USE CMY600
    USE F77KINDS
    USE IACCR_TABLES
    USE IMASS_TABLES
    USE IRATE_TABLES
    USE IRIME_TABLES
    USE IVENT_TABLES
    USE MAPOT
    USE PARMETA
    USE RACCR_TABLES
    USE RMASS_TABLES
    USE RRATE_TABLES
    USE RVELR_TABLES
    USE RVENT_TABLES
    USE SDENS_TABLES
!
    IMPLICIT NONE
!-----------------------------------------------------
! PARAMETERS AND DATA STATEMENT FOR LOCAL CALCULATIONS
!-----------------------------------------------------
    REAL   (KIND=R4KIND), PARAMETER :: C1   =    1.      / 3.
    REAL   (KIND=R4KIND), PARAMETER :: DMR1 =     .1E-3    
    REAL   (KIND=R4KIND), PARAMETER :: DMR2 =     .2E-3    
    REAL   (KIND=R4KIND), PARAMETER :: DMR3 =     .32E-3   
    REAL   (KIND=R4KIND), PARAMETER :: N0R0 =    8.E6     
    REAL   (KIND=R4KIND), PARAMETER :: N0S0 =    4.E6     
    REAL   (KIND=R4KIND), PARAMETER :: RHOL = 1000.    
    REAL   (KIND=R4KIND), PARAMETER :: RHOS =  100.     
    REAL   (KIND=R4KIND), PARAMETER :: T0C  =  273.15   
    REAL   (KIND=R4KIND), PARAMETER :: XMR1 =    1.E6    * DMR1
    REAL   (KIND=R4KIND), PARAMETER :: XMR2 =    1.E6    * DMR2
    REAL   (KIND=R4KIND), PARAMETER :: XMR3 =    1.E6    * DMR3
!
    INTEGER(KIND=I4KIND), PARAMETER :: MDR1 = XMR1
    INTEGER(KIND=I4KIND), PARAMETER :: MDR2 = XMR2
    INTEGER(KIND=I4KIND), PARAMETER :: MDR3 = XMR3
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTPH  
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DX      , PI      , BBFR    , FPVS0   , XNCW
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I
!--------------------------------------------------------------------------------------
! 09/01/01:  ASSUME THE FOLLOWING FUNCTIONAL DEPENDENCE FOR 5 - 100 KM RESOLUTION:
! RHGRD=0.90 FOR DX=100 KM, 0.98 FOR DX=5 KM, WHERE RHGRD=0.90+0.08*[(100.-DX)/95.]**.5
!--------------------------------------------------------------------------------------
    DX    = 111. * (DPHD ** 2 + DLMD ** 2) ** .5 ! MODEL RESOLUTION AT EQUATOR (KM)
    DX    = MIN(100., MAX(5., DX) )
    RHGRD = 0.90 + .08 * ((100. - DX)/95.) ** .5
!--------------------------------------------------------------------- 
! CREATE LOOKUP TABLES FOR SATURATION VAPOR PRESSURE W/R/T WATER & ICE
!--------------------------------------------------------------------- 
    CALL GPVS
!------------------------------ 
! READ IN VARIOUS LOOKUP TABLES
!------------------------------
    OPEN (UNIT=1,FILE="ETA_MICRO_LOOKUP.dat",FORM="UNFORMATTED")
    READ(1) VENTR1
    READ(1) VENTR2
    READ(1) ACCRR
    READ(1) MASSR
    READ(1) VRAIN
    READ(1) RRATE
    READ(1) VENTI1
    READ(1) VENTI2
    READ(1) ACCRI
    READ(1) MASSI
    READ(1) VSNOWI
!
    VSNOWI = VSNOWI * 0.9
!
    READ(1) VEL_RF
!
    CLOSE (1)
!--------------------------------------------------------------------------------------------------
! CALCULATES COEFFICIENTS FOR GROWTH RATES OF ICE NUCLEATED IN WATER SATURATED CONDITIONS, SCALED 
! BY PHYSICS TIME STEP (LOOKUP TABLE)
!--------------------------------------------------------------------------------------------------
    CALL MY_GROWTH_RATES(DTPH)
!
    PI = ACOS(-1.)
!--------------------------------------------------------------------------------------------------
! CONSTANTS ASSOCIATED WITH BIGGS (1953) FREEZING OF RAIN, AS PARAMETERIZED FOLLOWING LIN ET AL. 
! (JCAM, 1983) AND REISNER ET AL. (1998, QJRMS).
!--------------------------------------------------------------------------------------------------
    ABFR = -  0.66
    BBFR =  100.
    CBFR =   20.   * PI * PI * BBFR * RHOL * 1.E-42
!--------------------------------------------------------------------------------------------------
! CIACW IS USED IN CALCULATING RIMING RATES THE ASSUMED EFFECTIVE COLLECTION EFFICIENCY OF CLOUD 
! WATER RIMED ONTO ICE IS =0.5 BELOW:
!--------------------------------------------------------------------------------------------------
    CIACW = DTPH * 0.25 * PI * 0.5 * (1.E5) ** C1
!--------------------------------------------------------------------------------------------------
! CIACR IS USED IN CALCULATING FREEZING OF RAIN COLLIDING WITH LARGE ICE THE ASSUMED COLLECTION 
! EFFICIENCY IS 1.0
!--------------------------------------------------------------------------------------------------
    CIACR = PI * DTPH
!--------------------------------------------------------------------------------------------------
! BASED ON RAIN LOOKUP TABLES FOR MEAN DIAMETERS FROM 0.05 TO 0.45 MM
! FOUR DIFFERENT FUNCTIONAL RELATIONSHIPS OF MEAN DROP DIAMETER AS A FUNCTION OF RAIN RATE (RR), 
! DERIVED BASED ON SIMPLE FITS TO MASS-WEIGHTED FALL SPEEDS OF RAIN AS FUNCTIONS OF MEAN DIAMETER 
! FROM THE LOOKUP TABLES.
!--------------------------------------------------------------------------------------------------
    RR_DRMIN  = N0R0 * RRATE(MDRMIN)     ! RR FOR MEAN DROP DIAMETER OF .05 MM
    RR_DR1    = N0R0 * RRATE(MDR1)       ! RR FOR MEAN DROP DIAMETER OF .10 MM
    RR_DR2    = N0R0 * RRATE(MDR2)       ! RR FOR MEAN DROP DIAMETER OF .20 MM
    RR_DR3    = N0R0 * RRATE(MDR3)       ! RR FOR MEAN DROP DIAMETER OF .32 MM
    RR_DRMAX  = N0R0 * RRATE(MDRMAX)     ! RR FOR MEAN DROP DIAMETER OF .45 MM
!
    RQR_DRMIN = N0R0 * MASSR(MDRMIN)     ! RAIN CONTENT FOR MEAN DROP DIAMETER OF .05 MM
    RQR_DR1   = N0R0 * MASSR(MDR1)       ! RAIN CONTENT FOR MEAN DROP DIAMETER OF .10 MM
    RQR_DR2   = N0R0 * MASSR(MDR2)       ! RAIN CONTENT FOR MEAN DROP DIAMETER OF .20 MM
    RQR_DR3   = N0R0 * MASSR(MDR3)       ! RAIN CONTENT FOR MEAN DROP DIAMETER OF .32 MM
    RQR_DRMAX = N0R0 * MASSR(MDRMAX)     ! RAIN CONTENT FOR MEAN DROP DIAMETER OF .45 MM
!
    C_N0R0 = PI * RHOL * N0R0
    CN0R0  = 1.E6 / C_N0R0 ** .25
!
    CN0R_DMRMIN = 1. / (PI * RHOL * DMRMIN ** 4)
    CN0R_DMRMAX = 1. / (PI * RHOL * DMRMAX ** 4)
!--------------------------------------------------------------- 
! CRACW IS USED IN CALCULATING COLLECTION OF CLOUD WATER BY RAIN 
! (AN ASSUMED COLLECTION EFFICIENCY OF 1.0)
!--------------------------------------------------------------- 
    CRACW = DTPH * 0.25 * PI * 1.0
!
    ESW0  = 1000.  *  FPVS0(T0C)     ! SATURATION VAPOR PRESSURE AT 0C
    RFMAX =    1.1 ** NRIME          ! MAXIMUM RIME FACTOR ALLOWED
!--------------------------------------- 
! CONSTANTS PASSED THROUGH ARGUMENT LIST 
!--------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
! IMPORTANT PARAMETERS FOR SELF COLLECTION (AUTOCONVERSION) OF CLOUD WATER TO RAIN.
!
! CRAUT IS PROPORTIONAL TO THE RATE THAT CLOUD WATER IS CONVERTED BY SELF COLLECTION TO RAIN 
! (AUTOCONVERSION RATE)
!--------------------------------------------------------------------------------------------------
    CRAUT = 1. -EXP(-1.E-3 * DTPH)
!--------------------------------------------------------------------------------------------------
! QAUT0 IS THE THRESHOLD CLOUD CONTENT FOR AUTOCONVERSION TO RAIN NEEDED FOR DROPLETS TO REACH A 
! DIAMETER OF 20 MICRONS (FOLLOWING MANTON AND COTTON, 1977; BANTA AND HANSON, 1987, JCAM).
! QAUT0=1.2567, 0.8378, OR 0.4189 G/M**3 FOR DROPLET NUMBER CONCENTRATIONS OF 300, 200, AND 
! 100 CM**-3, RESPECTIVELY
!--------------------------------------------------------------------------------------------------
    XNCW  = 200.E6                               ! 300 CM**-3 DROPLET CONCENTRATION
    QAUT0 = PI * RHOL * XNCW * (20.E-6) ** 3/6.
!--------------------------------------------------------------------------------------------------
! FOR CALCULATING SNOW OPTICAL DEPTHS BY CONSIDERING BULK DENSITY OF SNOW BASED ON EMAILS FROM 
! Q. FU (6/27-28/01), WHERE OPTICAL DEPTH (T) = 1.5*SWP/(REFF*DENS), SWP IS SNOW WATER PATH, REFF 
! IS EFFECTIVE RADIUS, AND DENS IS THE BULK DENSITY OF SNOW.
!
! SWP (KG/M**2)=(1.E-3 KG/G)*SWPRAD, SWPRAD IN G/M**2 USED IN RADIATION
! T = 1.5*1.E3*SWPRAD/(REFF*DENS)
!
! SEE DERIVATION FOR MASSI(INDEXS), NOTE EQUAL TO RHO*QSNOW/NSNOW
!
! SDENS=1.5E3/DENS, DENS=MASSI(INDEXS)/[PI*(1.E-6*INDEXS)**3]
!--------------------------------------------------------------------------------------------------
    DO I=MDIMIN,MDIMAX
        SDENS(I) = PI * 1.5E-15 * FLOAT(I*I*I) / MASSI(I)
    END DO
!
    RETURN
!
    END SUBROUTINE GSMCONST
!
!
!
!---------------------------------------------------------------- 
! SETS UP LOOKUP TABLE FOR CALCULATING INITIAL ICE CRYSTAL GROWTH 
!---------------------------------------------------------------- 
    SUBROUTINE MY_GROWTH_RATES(DTPH)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE MY_GROWTH_RATES
!>
!> SUBPROGRAM: MY_GROWTH_RATES - SETS UP LOOKUP TABLE FOR CALCULATING INITIAL ICE CRYSTAL GROWTH
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> BELOW ARE TABULATED VALUES FOR THE PREDICTED MASS OF ICE CRYSTALS AFTER 600 S OF GROWTH IN WATER 
!> SATURATED CONDITIONS, BASED ON CALCULATIONS FROM MILLER AND YOUNG (JAS, 1979). THESE VALUES ARE 
!> CRUDELY ESTIMATED FROM TABULATED CURVES AT 600 S FROM FIG. 6.9 OF YOUNG (1993). 
!> VALUES AT TEMPERATURES COLDER THAN -27C WERE ASSUMED TO BE INVARIANT WITH TEMPERATURE.
!> USED TO NORMALIZE MILLER & YOUNG (1979) CALCULATIONS OF ICE GROWTH OVER LARGE TIME STEPS USING 
!> THEIR TABULATED VALUES AT 600 S.
!> ASSUMES 3D GROWTH WITH TIME**1.5 FOLLOWING EQ. (6.3) IN YOUNG (1993).
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  FERRIER    - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> DTPH - PHYSICS TIME STEP (S)
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CMY600
!>              F77KINDS
!>  
!> DRIVER     : GSMCONST
!> 
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CMY600
    USE F77KINDS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), DIMENSION(MY_T1:MY_T2)                                                ::&
    & MY_600
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTPH
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DT_ICE
!
    DATA MY_600 /                                                                                 &
!------------------ 
!  - 1 TO  -5 DEG C   
!------------------
    & 5.5E-8 , 1.4E-7 , 2.8E-7, 6.E-7  , 3.3E-6 ,                                                 & 
!------------------ 
!  - 6 TO -10 DEG C   
!------------------
    & 2.E-6  , 9.E-7  , 8.8E-7, 8.2E-7 , 9.4E-7 ,                                                 & 
!------------------ 
!  -11 TO -15 DEG C   
!------------------
    & 1.2E-6 , 1.85E-6, 5.5E-6, 1.5E-5 , 1.7E-5 ,                                                 & 
!------------------ 
!  -16 TO -20 DEG C   
!------------------
    & 1.5E-5 , 1.E-5  , 3.4E-6, 1.85E-6, 1.35E-6,                                                 & 
!------------------ 
!  -21 TO -25 DEG C   
!------------------
    & 1.05E-6, 1.E-6  , 9.5E-7, 9.0E-7 , 9.5E-7 ,                                                 & 
!------------------ 
!  -26 TO -30 DEG C   
!------------------
    & 9.5E-7 , 9.E-7  , 9.E-7 , 9.E-7  , 9.E-7  ,                                                 & 
!------------------ 
!  -31 TO -35 DEG C   
!------------------
    & 9.E-7  , 9.E-7  , 9.E-7 , 9.E-7  , 9.E-7 /           
!
    DT_ICE    = (DTPH / 600.) ** 1.5
    MY_GROWTH = DT_ICE * MY_600
!
    RETURN
!
    END SUBROUTINE MY_GROWTH_RATES
!
!
!
!-------------------------------------------------------------------- 
! LOOKUP TABLES FOR THE SATURATION VAPOR PRESSURE W/R/T WATER AND ICE
!-------------------------------------------------------------------- 
    SUBROUTINE GPVS
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GPVS
!>
!> SUBPROGRAM: GPVS - COMPUTE SATURATION VAPOR PRESSURE TABLE
!> PROGRAMMER: N. PHILLIPS
!> ORG: W/NP2
!> DATE: 82-12-30
!>
!> ABSTRACT:
!> COMPUTE SATURATION VAPOR PRESSURE TABLE AS A FUNCTION OF TEMPERATURE FOR THE TABLE LOOKUP 
!> FUNCTION FPVS.
!> EXACT SATURATION VAPOR PRESSURES ARE CALCULATED IN SUBPROGRAM FPVSX.
!> THE CURRENT IMPLEMENTATION COMPUTES A TABLE WITH A LENGTH OF 7501 FOR TEMPERATURES RANGING FROM 
!> 180.0 TO 330.0 KELVIN.
!>
!> PROGRAM HISTORY LOG:
!> 91-05-07  IREDELL
!> 04-12-30  IREDELL - EXPAND TABLE
!> 06-02-19  HONG    - ICE EFFECT
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: COMPVS0
!>              COMPVS
!>              F77KINDS
!>  
!> DRIVER     : GSMCONST
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
    USE COMPVS0
    USE COMPVS
    USE F77KINDS
!
    IMPLICIT NONE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                                        ::&
    & XMIN    , XMAX    , XINC    , X       , T       , FPVSX   , FPVSX0  
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & JX      
!    
    XMIN = 180.0
    XMAX = 330.0
!
    XINC = (XMAX - XMIN) / (NX - 1)
!
    C1XPVS  = 1. - XMIN / XINC
    C2XPVS  = 1. / XINC
    C1XPVS0 = 1. - XMIN / XINC
    C2XPVS0 = 1. / XINC
!
    DO JX=1,NX
        X = XMIN + (JX - 1) * XINC
        T = X
!
         TBPVS(JX) =  FPVSX(T)
        TBPVS0(JX) = FPVSX0(T)
    END DO
!
    RETURN
!
    END SUBROUTINE GPVS
!
!
!
    FUNCTION FPVS(T)
!>--------------------------------------------------------------------------------------------------
!> FUNCTION FPVS
!>
!> SUBPROGRAM: FPVS - COMPUTE SATURATION VAPOR PRESSURE
!> PROGRAMMER: N. PHILLIPS
!> ORG: W/NP2
!> DATE: 82-12-30
!>
!> ABSTRACT: 
!> COMPUTE SATURATION VAPOR PRESSURE FROM THE TEMPERATURE.
!> A LINEAR INTERPOLATION IS DONE BETWEEN VALUES IN A LOOKUP TABLE COMPUTED IN GPVS. 
!> SEE DOCUMENTATION FOR FPVSX FOR DETAILS.
!> INPUT VALUES OUTSIDE TABLE RANGE ARE RESET TO TABLE EXTREMA.
!> THE INTERPOLATION ACCURACY IS ALMOST 6 DECIMAL PLACES.
!> ON THE CRAY, FPVS IS ABOUT 4 TIMES FASTER THAN EXACT CALCULATION.
!> THIS FUNCTION SHOULD BE EXPANDED INLINE IN THE CALLING ROUTINE.
!>
!> PROGRAM HISTORY LOG:
!> 91-05-07  IREDELL - MADE INTO INLINABLE FUNCTION
!> 94-12-30  IREDELL - EXPAND TABLE
!> 96-02-19  HONG    - ICE EFFECT
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> T    - REAL TEMPERATURE IN KELVIN
!>
!> OUTPUT ARGUMENT LIST:
!> FPVS - REAL SATURATION VAPOR PRESSURE IN KILOPASCALS (CB)
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: COMPVS
!>              F77KINDS
!>  
!> DRIVER     : GSMCONST
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE COMPVS
    USE F77KINDS
!
    IMPLICIT NONE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & T
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & FPVS    , XJ
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & JX
!
    XJ = MIN(MAX(C1XPVS + C2XPVS * T, 1.), FLOAT(NX))
    JX = MIN(XJ, NX - 1.)
!
    FPVS = TBPVS(JX) + (XJ - JX) * (TBPVS(JX + 1) - TBPVS(JX))
!
    RETURN
!
    END FUNCTION FPVS
!
!
!
    FUNCTION FPVS0(T)
!--------------------------------------------------------------------------------------------------
    USE COMPVS0
    USE F77KINDS
!
    IMPLICIT NONE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & T
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & FPVS0, XJ1
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & JX1
!
    XJ1 = MIN(MAX(C1XPVS0 + C2XPVS0 * T, 1.), FLOAT(NX))
    JX1 = MIN(XJ1, NX - 1.)
!
    FPVS0 = TBPVS0(JX1) + (XJ1 - JX1) * (TBPVS0(JX1 + 1) - TBPVS0(JX1))
!
    RETURN
!
    END FUNCTION FPVS0
!
!
!
    FUNCTION FPVSX(T)
!>--------------------------------------------------------------------------------------------------
!> FUNCTION FPVSX
!> 
!> SUBPROGRAM: FPVSX - COMPUTE SATURATION VAPOR PRESSURE
!> PROGRAMMER: N. PHILLIPS
!> ORG: W/NP2
!> DATE: 82-12-30
!>
!> ABSTRACT: EXACTLY COMPUTE SATURATION VAPOR PRESSURE FROM TEMPERATURE.
!> THE WATER MODEL ASSUMES A PERFECT GAS, CONSTANT SPECIFIC HEATS FOR GAS AND LIQUID, AND NEGLECTS 
!> THE VOLUME OF THE LIQUID.
!> THE MODEL DOES ACCOUNT FOR THE VARIATION OF THE LATENT HEAT OF CONDENSATION WITH TEMPERATURE. 
!> THE ICE OPTION IS NOT INCLUDED.
!> THE CLAUSIUS-CLAPEYRON EQUATION IS INTEGRATED FROM THE TRIPLE POINT TO GET THE FORMULA 
!> PVS = PSATK * (TR ** XA) * EXP(XB * (1. - TR))
!> WHERE TR IS TTP/T AND OTHER VALUES ARE PHYSICAL CONSTANTS THIS FUNCTION SHOULD BE EXPANDED INLINE
!> IN THE CALLING ROUTINE.
!> REFERENCE: EMANUEL (1994), 116 - 117.
!>
!> PROGRAM HISTORY LOG:
!> 91-05-07  IREDELL - MADE INTO INLINABLE FUNCTION
!> 94-12-30  IREDELL - EXACT COMPUTATION
!> 96-02-19  HONG    - ICE EFFECT
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> T     - REAL TEMPERATURE IN KELVIN
!>
!> OUTPUT ARGUMENT LIST:
!> FPVSX - REAL SATURATION VAPOR PRESSURE IN KILOPASCALS (CB)
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>  
!> DRIVER     : GSMCONST
!> 
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE 
!
    REAL   (KIND=R4KIND), PARAMETER :: CP    =   1.0046E+3
    REAL   (KIND=R4KIND), PARAMETER :: RD    = 287.04   
    REAL   (KIND=R4KIND), PARAMETER :: RV    =   4.6150E+2
    REAL   (KIND=R4KIND), PARAMETER :: TTP   =   2.7316E+2
    REAL   (KIND=R4KIND), PARAMETER :: HVAP  =   2.5000E+6
    REAL   (KIND=R4KIND), PARAMETER :: PSAT  =   6.1078E+2
    REAL   (KIND=R4KIND), PARAMETER :: CLIQ  =   4.1855E+3
    REAL   (KIND=R4KIND), PARAMETER :: CVAP  =   1.8460E+3
    REAL   (KIND=R4KIND), PARAMETER :: CICE  =   2.1060E+3
    REAL   (KIND=R4KIND), PARAMETER :: HSUB  =   2.8340E+6
!
    REAL   (KIND=R4KIND), PARAMETER :: PSATK = PSAT * 1.E-3
    REAL   (KIND=R4KIND), PARAMETER :: DLDT  = CVAP - CLIQ
    REAL   (KIND=R4KIND), PARAMETER :: XA    = - DLDT  / RV
    REAL   (KIND=R4KIND), PARAMETER :: XB    = XA  + HVAP / (RV*TTP)
    REAL   (KIND=R4KIND), PARAMETER :: DLDTI = CVAP - CICE
    REAL   (KIND=R4KIND), PARAMETER :: XAI   = - DLDTI / RV
    REAL   (KIND=R4KIND), PARAMETER :: XBI   = XAI + HSUB / (RV*TTP)
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & T
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & FPVSX   , TR
!
    TR = TTP / T
!
    IF (T >= TTP) THEN
        FPVSX = PSATK * (TR ** XA)  * EXP(XB  * (1. - TR))
    ELSE
        FPVSX = PSATK * (TR ** XAI) * EXP(XBI * (1. - TR))
    END IF
!
    RETURN
!
    END FUNCTION FPVSX
!
!
!
    FUNCTION FPVSX0(T)
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: CP    =   1.0046E+3
    REAL   (KIND=R4KIND), PARAMETER :: RD    = 287.04   
    REAL   (KIND=R4KIND), PARAMETER :: RV    =   4.6150E+2
    REAL   (KIND=R4KIND), PARAMETER :: TTP   =   2.7316E+2
    REAL   (KIND=R4KIND), PARAMETER :: HVAP  =   2.5000E+6
    REAL   (KIND=R4KIND), PARAMETER :: PSAT  =   6.1078E+2
    REAL   (KIND=R4KIND), PARAMETER :: CLIQ  =   4.1855E+3
    REAL   (KIND=R4KIND), PARAMETER :: CVAP  =   1.8460E+3
    REAL   (KIND=R4KIND), PARAMETER :: CICE  =   2.1060E+3
    REAL   (KIND=R4KIND), PARAMETER :: HSUB  =   2.8340E+6
!
   REAL   (KIND=R4KIND), PARAMETER :: PSATK  = PSAT  * 1.E-3
   REAL   (KIND=R4KIND), PARAMETER :: DLDT   = CVAP  - CLIQ
   REAL   (KIND=R4KIND), PARAMETER :: XA     = -DLDT / RV
   REAL   (KIND=R4KIND), PARAMETER :: XB     = XA    + HVAP / (RV * TTP)
   REAL   (KIND=R4KIND), PARAMETER :: DLDTI  = CVAP  - CICE
   REAL   (KIND=R4KIND), PARAMETER :: XAI    = -DLDT / RV
   REAL   (KIND=R4KIND), PARAMETER :: XBI    = XA    + HSUB / (RV * TTP)
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & T
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & FPVSX0  , TR 
!
    TR = TTP / T
    FPVSX0 = PSATK * (TR ** XA) * EXP(XB * (1. - TR))
!
    RETURN
!
    END FUNCTION FPVSX0

    SUBROUTINE DDAMP
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE DDAMP
!> 
!> SUBPROGRAM: DDAMP - DIVERGENCE DAMPING
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 94-03-08       
!>     
!> ABSTRACT:
!> DDAMP MODIFIES THE WIND COMPONENTS SO AS TO REDUCE THE HORIZONTAL DIVERGENCE.
!> A SWITCH PROVIDES THE OPTION OF ALSO MODIFYING THE TEMPERATURE FROM AN ENERGY VIEWPOINT.
!>     
!> PROGRAM HISTORY LOG:
!> 87-08-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>    
!> USE MODULES: CLDWTR
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!> 
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : ZERO2
!>--------------------------------------------------------------------------------------------------                 
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE GLB_TABLE
    USE INDX
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
#include "sp.h"
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & HEAT
! 
    REAL   (KIND=R4KIND), PARAMETER :: RFCP = .25 / 1004.6
!
    REAL   (KIND=R4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & RDPDX   , RDPDY   ,                                                                         &
    & UT      , VT      ,                                                                         &
    & CKE     , DPDE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K
!
    HEAT = .FALSE. 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO 100 J=MYJS1_P1,MYJE1_P1
        DO 100 I=MYIS_P1,MYIE_P1
            CKE(I,J) = 0.
            CONTINUE
100 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (CKE    , DPDE    , RDPDX   , RDPDY   , UT      , VT)
!
    DO 150 K=1,LM
!
        CALL ZERO2(CKE)
        CALL ZERO2(DPDE)
!
        DO 110 J=MYJS_P2,MYJE_P2
            DO 110 I=MYIS_P1,MYIE_P1
                DPDE(I,J)   = DETA(K)     * PDSL(I,J)
                 DIV(I,J,K) =  DIV(I,J,K) * HBM2(I,J)
                CONTINUE
    110 END DO
!
        DO 120 J=MYJS2,MYJE2
            DO 120 I=MYIS_P1,MYIE_P1
                RDPDX(I,J) = VTM(I,J,K) / (DPDE(I+IVW(J),J) + DPDE(I+IVE(J),J))
                RDPDY(I,J) = VTM(I,J,K) / (DPDE(I,J-1)      + DPDE(I,J+1))
                CONTINUE
    120 END DO
!
        DO 130 J=MYJS2,MYJE2
            DO 130 I=MYIS1_P1,MYIE1_P1
                 UT(I,J)   = U(I,J,K)
                 VT(I,J)   = V(I,J,K)
                  U(I,J,K) = U(I,J,K) + (DIV(I+IVE(J),J,K) - DIV(I+IVW(J),J,K))                   &
    &                      * RDPDX(I,J) * DDMPU(I,J)
!
                  V(I,J,K) = V(I,J,K) + (DIV(I,J+1,K)      - DIV(I,J-1,K))                        &
    &                      * RDPDY(I,J) * DDMPV(I,J)
!
                CKE(I,J)   = 0.5 * (U(I,J,K) *  U(I,J,K)                                          &
    &                      -       UT(I,J)   * UT(I,J)                                            &
    &                      +        V(I,J,K) *  V(I,J,K)                                          &
    &                      -       VT(I,J)   * VT(I,J))
                CONTINUE
    130 END DO
!
        IF (HEAT) THEN
            DO 140 J=MYJS2,MYJE2
                DO 140 I=MYIS_P1,MYIE_P1
                    T(I,J,K) = T(I,J,K) - RFCP * (CKE(I+IHE(J),J) + CKE(I,J+1)                    &
    &                        +                    CKE(I+IHW(J),J) + CKE(I,J-1))                   &
    &                        * HBM2(I,J)
                    CONTINUE
        140 END DO
        END IF
!
        CONTINUE
!
150 END DO
!
    RETURN
!
    END SUBROUTINE DDAMP

    SUBROUTINE ZERO2(ARRAY)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE ZERO2
!>
!> SUBROUTINE: ZERO2 - ZERO OUT 2-D ARRAYS
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 96-03-28
!>
!> ABSTRACT:
!> SET THE VALUES OF THE ARTIFICIAL EXTERNAL (OUT-OF-BOUNDS) EDGES TO ZERO
!>
!> PROGRAM HISTORY LOG:
!> 96-03-28  BLACK      - ORIGINATOR
!> 97-06-??  MEYS       - MODIFIED FOR DISTRIBUTED MEMORY
!> 99-07-06  BLACK      - FULL ARRAY RATHER THAN JUST EDGES
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> ARRAY - THE DUMMY ARRAY NAME
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : CUCNVC
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              HDIFF
!>              HDIFFS
!>              HZADAV
!>              HZADAV_LM1
!>              HZADVS
!>              INIT
!>              INITS
!>              PDTEDT
!>              PGCOR
!>              RADTN
!>              SURFCE
!>              TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARRAY
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J 
!
    DO J=JDIM1,JDIM2
        DO I=IDIM1,IDIM2
            ARRAY(I,J) = 0.
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE ZERO2

    SUBROUTINE VDIFQ(LMHK, KTM, DTQ2, Q2, EL, Z)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VDIFQ
!>
!> SUBPROGRAM: VDIFQ - VERTICAL DIFFUSION
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LMHK  - MASS POINT MODEL SURFACE (LOWEST MODEL HEIGHT)
!> KTM   -
!> DTQ2  - PHYSICS TINE STEP
!> EL    - 
!> Z     - INTERFACE HEIGHT
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> Q2    - TURBULENT KINETIC ENERGY
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1  = LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM1  = LM - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2  = LM - 2
!
    REAL   (KIND=R4KIND), PARAMETER :: ESQ  = 0.20
    REAL   (KIND=R4KIND), PARAMETER :: ELZ0 = 0.
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(INOUT)       ::&
    & Q2
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                  , INTENT(IN)          ::&
    & EL
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                  , INTENT(IN)          ::&
    & Z
!
    REAL   (KIND=R4KIND), DIMENSION(LM2)                                                        ::&
    & CM      , CR      , RSQ2    , AKQ     , DTOZ    
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LMHK    , KTM  
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTQ2 
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LMHM    , LMHP    , L       , KT      , IVI     , LMH2
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTDIF   , CF      , DTOZS   , AKQS    
!
    DTDIF = DTQ2 / FLOAT(KTM)
    LMHM  = LMHK - 1
    LMH2  = LMHK - 2
    LMHP  = LMHK + 1
!
    DO 300 KT=1,KTM
!
        DO 100 L=1,LMH2
            DTOZ(L) = (DTDIF + DTDIF) / (Z(L) - Z(L+2))
             AKQ(L) = SQRT((Q2(L) + Q2(L+1))*0.5) * (EL(L)+EL(L+1)) * 0.5 * ESQ / (Z(L+1)-Z(L+2))
              CR(L) = -DTOZ(L) * AKQ(L)
    100 END DO
!    
          CM(1) = DTOZ(1) * AKQ(1) + 1.
        RSQ2(1) =   Q2(1)
!
        DO 110 L=2,LMH2
              CF      = -DTOZ(L)   * AKQ(L-1) / CM(L-1)
              CM(L) = -  CR(L-1) * CF + (AKQ(L-1) + AKQ(L)) * DTOZ(L) + 1.
            RSQ2(L) = -RSQ2(L-1) * CF + Q2(L)
    110 END DO
!
        DTOZS = (DTDIF + DTDIF) / (Z(LMHM) - Z(LMHP))
        AKQS  = SQRT((Q2(LMHM) + Q2(LMHK))*0.5) * (EL(LMHM)+ELZ0) * 0.5 * ESQ / (Z(LMHK)-Z(LMHP))
!    
        CF    = -DTOZS * AKQ(LMH2) / CM(LMH2)
!
        Q2(LMHM) = (DTOZS * AKQS * Q2(LMHK) - RSQ2(LMH2) * CF+Q2(LMHM)) / ((AKQ(LMH2) + AKQS)     & 
    &            *  DTOZS - CR(LMH2) * CF+1.)
!    
        DO 120 IVI=1,LMH2
            L     = LMHM - IVI
            Q2(L) = (-CR(L) * Q2(L+1) + RSQ2(L)) / CM(L)
    120 END DO
!
300 END DO
!
    RETURN
!
    END SUBROUTINE VDIFQ

    SUBROUTINE INITS
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE INITS
!>
!> SUBPROGRAM: INITS - INITIALIZE VARIABLE FOR MODEL RUN
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> INIT READS IN PRIMARY AND AUXILIARY VARIABLES AND CONSTANTS AND SETS INITIAL VALUES FOR OTHERS.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC  - ORIGINATOR
!> 92-10-27  DEAVEN  - CHANGED READS OF NHB, NFC, AND NBC TO ACCOMODATE SHORTENED RECORD LENGTHS
!> 95-03-27  BLACK   - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-10-31  BLACK   - ADDED NAMELIST BCEXDATA FOR THE NESTS
!> 98-06-10  ROGERS  - MADE Y2K COMPLIANT BY REPLACING CALL TO W3FI13 TO W3DOXDAT
!> 98-09-04  PYLE    - CHANGED TO NOT RE-INITIALIZE TSHLTR AND QSHLTR IF RESTART=TRUE
!> 98-10-21  BLACK   - CHANGES FOR DISTRIBUTED MEMORY
!> 98-11-17  BLACK   - ADDED CODE TO LOCATE THE INNER DOMAIN BOUNDARIES ON THE RELEVANT PEs
!> 00-08-??  BLACK   - MODIFIED FOR RESTART CAPABILITY
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY 
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT FILES:
!> NFC - THE INITIAL VALUES OF SFC PRESSURE, T, Q, U, AND V
!> NHB - A LARGE VARIETY OF ARRAY AND SCALAR CONSTANTS
!> NBC - THE BOUNDARY CONDITIONS AND TENDENCIES
!>
!>                         OR
!>
!> RESTRT - A RESTART FILE WITH ALL NECESSARY QUANTITIES
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: ACMCLD
!>              ACMCLH 
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CMICRO_START
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              CUINIT
!>              CUPARM
!>              C_TADJ
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PPTASM
!>              PVRBLS
!>              RD1TIM
!>              SOIL
!>              TEMPCOM
!>              TEMPV
!>              TIMMING
!>              TOPO
!>              VRBLS
!>              Z0EFFT
!>
!> DRIVER     : EBU
!>
!> CALLS      : DSTRB
!>              GRADFS
!>              MPI_BARRIER
!>              MPI_BCAST
!>              MPI_FINALIZE
!>              O3CLIM
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SOLARD
!>              ZENITH
!>              ZERO2
!>              ZERO3  
!-------------------------------------------------------------------------------------------------- 
    USE ACMCLD
    USE ACMCLH 
    USE ACMPRE 
    USE ACMRDL 
    USE ACMRDS 
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CMICRO_START
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE CUINIT
    USE CUPARM
    USE C_TADJ
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PPTASM
    USE PVRBLS
    USE RD1TIM
    USE SLOPES
    USE SOIL
    USE TEMPCOM
    USE TEMPV
    USE TIMMING
    USE TOPO
    USE UPDATE_FLDS
    USE VRBLS
    USE Z0EFFT
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), PARAMETER :: CM1    = 2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2    =    4.9283
    REAL   (KIND=R4KIND), PARAMETER :: CM3    =   23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS    =    0.622 
    REAL   (KIND=R4KIND), PARAMETER :: PI2    = 2. * 3.14159265
    REAL   (KIND=R4KIND), PARAMETER :: RLAG   =   14.8125
    REAL   (KIND=R4KIND), PARAMETER :: Q2INI  =     .50 
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2  =    0.2
    REAL   (KIND=R4KIND), PARAMETER :: EPSWET =    0.0 
    REAL   (KIND=R4KIND), PARAMETER :: Z0LAND =     .10
    REAL   (KIND=R4KIND), PARAMETER :: Z0SEA  =     .001
    REAL   (KIND=R4KIND), PARAMETER :: FCM    =     .00001 
    REAL   (KIND=R4KIND), PARAMETER :: DTR    =    0.1745329E-1
    REAL   (KIND=R4KIND), PARAMETER :: A1     =  610.78
    REAL   (KIND=R4KIND), PARAMETER :: WA     =     .10
    REAL   (KIND=R4KIND), PARAMETER :: WG     =    1.0 - WA
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JMP1   = JM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMT    = 2  * IM - 1
    INTEGER(KIND=I4KIND), PARAMETER :: NSTAT  = 1000
!------------------  
! DECLARE VARIABLES
!------------------  
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUNB    , EXBC    , INSIDEH , INSIDEV
!
    CHARACTER(32)                                                                               ::&
    & LABEL
!
    CHARACTER(40)                                                                               ::&
    & CONTRL  , FILALL  , FILMST  , FILTMP  , FILTKE  , FILUNV  , FILCLD  , FILRAD  , FILSFC
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & PHALF
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & NPEBND
!--------------------------------------------------------------------------------------------------
! NOTE: THE DIMENSION OF THE FOLLOWING ARRAYS IS ARBITRARILY CHOSEN TO EXCEED ANY NUMBER OF 
! BOUNDARY POINTS THAT MIGHT EXIST IN ANY INNER DOMAIN
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(1500)                                                       ::&
    &  HLATI  , HLONI   , VLATI   , VLONI   , THLONI  , THLATI  , TVLONI  , TVLATI
!
    REAL   (KIND=R4KIND), DIMENSION(NSTAT)                                                      ::&
    & TSLAT   , TSLON
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDATB
!
    INTEGER(KIND=I4KIND), DIMENSION(8)                                                          ::&
    & INIDAT  , IBCDAT
!
#ifdef DP_REAL
    LOGICAL(KIND=L8KIND)                                                                        ::&
    & RUNBX
!
    INTEGER(KIND=I8KIND), DIMENSION(3)                                                          ::&
    & IDATBX
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & IHRSTBX 
#endif                
!------------------------------------------ 
! THE FOLLOWING IS FOR TIMIMG PURPOSES ONLY
!------------------------------------------
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NFILE   , IUNWGT  , NMAP    , NRADSH  , NRADLH  , J       , KNT     , I       , N       ,   &
    & NHB     , NHIBU   , LFCSTD  , K       , IERR    , KBI     , KBI2    , LRECBC  , IHRSTB  ,   &
    & IRTN    , ISTART  , NREC    , LLMH    , NS      , KCCO2   , LMHK    , LMVK      
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & PLOMD   , PMDHI   , PHITP   , P400    , PLBTM   , TSTART  , TEND    , TCP     , BTIM    ,   &
    & TBOCO   , BCHR    , TERM1   , PM1     , APEM1   , TSFCK   , PSFCK   , CLOGES  , ESE     ,   &
    & PSUM    , SLPM    , PDIF    , PSS     , TIME    , DAYI    , HOUR    , ADDL    , RANG    ,   &
    & RSIN1   , RCOS1   , RCOS2   , ULM     , VLM     , TLM     , QLM     , PLM     , APELM   ,   &
    & APELMNW , EXNERR  , THLM    , DPLM    , DZLM    , FAC1    , FAC2  
!
    DATA PLOMD/64200./, PMDHI/35000./, PHITP/15000./, P400/40000./, PLBTM/105000./
!
    DATA NFILE/14/, IUNWGT/40/
!------------------------------------------------------ 
! FLAG FOR INITIALIZING CONVECTIVE CLOUDS FOR RADIATION
!------------------------------------------------------
!-------------------
! DECLARE NAMELISTS.
!-------------------
    NAMELIST /FCSTDATA/                                                                                                            &
    & TSTART  , TEND    , TCP     , RESTRT  , SINGLRST, SUBPOST , NMAP    , TSHDE   , SPL     , NPHS    , NCNVC   , NRADSH  ,      &
    & NRADLH  , NTDDMP  , TPREC   , THEAT   , TCLOD   , TRDSW   , TRDLW   , TSRFC   , NEST    , HYDRO   , SPLINE
!----------------- 
! START INIT HERE.
!----------------- 
!
!------------------------------------------- 
! CALCULATE THE I-INDEX EAST-WEST INCREMENTS
!------------------------------------------- 
    DO J=1,JM
        IHEG(J) = MOD(J+1,2)
        IHWG(J) = IHEG(J) - 1
        IVEG(J) = MOD(J  ,2)
        IVWG(J) = IVEG(J) - 1
    END DO
!------------------------------------------- 
! CALCULATE THE INDIRECT I INDICES FOR RADTN
!------------------------------------------- 
    KNT = 0
!
    DO I=1,IM
        KNT        = KNT + 1
        IRADG(KNT) = I
    END DO
!
    DO I=1,IM-1
        KNT        = KNT + 1
        IRADG(KNT) = IM + 2 + I
    END DO
!--------------------------------  
! ZERO OUT LOCALLY INDEXED ARRAYS
!-------------------------------- 
    CALL ZERO2(PDSL)
    CALL ZERO3(T     ,LM  )
    CALL ZERO3(Q     ,LM  )
    CALL ZERO3(U     ,LM  )
    CALL ZERO3(V     ,LM  )
    CALL ZERO2(RES)
    CALL ZERO3(RTOP  ,LM  )
    CALL ZERO3(OMGALF,LM  )
    CALL ZERO3(DIV   ,LM  )
    CALL ZERO3(ETADT ,LM-1)
    CALL ZERO3(HTM   ,LM  )
    CALL ZERO3(VTM   ,LM  )
    CALL ZERO2(HBM2)
    CALL ZERO2(AKMS)
    CALL ZERO2(UZ0)
    CALL ZERO2(VZ0)
    CALL ZERO2(FAD)
!------------------ 
! READ Z0 EFFECTIVE
!------------------
    OPEN(UNIT=22, FILE='ZEFF', FORM='UNFORMATTED')
!
    DO N=1,4
        IF (MYPE == 0) THEN
            READ(22) TEMP1
        END IF
!
        CALL DSTRB(TEMP1, ZEFFIJ, 1, 4, N)
!
    END DO
!------------------------------------------------ 
! READ "CONSTANT" DATA FROM UNIT CONNECTED TO NHB
!------------------------------------------------
    NHB = 12
    LSL = LSM
    BTIM = TIMEF()
!
    CALL READ_NHB(NHB)
!
!    CALL FLDS_UPDATE_DRIVER('READ            ','SST             ',0,31)
!
!    CALL FLDS_UPDATE_DRIVER('READ            ','VGREEN          ')
!
  NHB_TIM = TIMEF() - BTIM
!
    NHIBU = 12
    IF (MYPE == 0) WRITE(LIST,*)'INIT:  READ CONSTANTS FILE'
!---------------------------------------------------------------------------------------
! READ NAMELIST FCSTDATA WHICH CONTROLS TIMESTEPS, ACCUMULATION PERIODS, STANDARD OUTPUT
!---------------------------------------------------------------------------------------
    RESTRT = .FALSE. 
    LFCSTD = 11
    OPEN(LFCSTD, FILE='FCSTDATA.meso', STATUS='OLD')
    REWIND LFCSTD
    READ(LFCSTD, FCSTDATA)
!
    IF (MYPE == 0) THEN
        WRITE(6,*) 'HYDRO='  , HYDRO
        WRITE(6,*) 'SPLINE=' , SPLINE
    END IF
!
    IF (MYPE == 0) THEN
        WRITE(LIST,*)'INIT:  READ NAMELIST FCSTDATA - LISTED BELOW'
        WRITE(LIST,*)'  TSTART,TEND  :  ',TSTART,TEND
        WRITE(LIST,*)'  TCP          :  ',TCP
        WRITE(LIST,*)'  RESTRT       :  ',RESTRT
        WRITE(LIST,*)'  HYDRO        :  ',HYDRO
        WRITE(LIST,*)'  SINGLRST     :  ',SINGLRST
        WRITE(LIST,*)'  SUBPOST      :  ',SUBPOST
        WRITE(LIST,*)'  NMAP,NPHS    :  ',NMAP,NPHS
        WRITE(LIST,*)'  NCNVC        :  ',NCNVC
        WRITE(LIST,*)'  NRADSH,NRADLH:  ',NRADSH,NRADLH
        WRITE(LIST,*)'  NTDDMP       :  ',NTDDMP
        WRITE(LIST,*)'  TPREC,THEAT  :  ',TPREC,THEAT
        WRITE(LIST,*)'  TCLOD,TRDSW  :  ',TCLOD,TRDSW
        WRITE(LIST,*)'  TRDLW,TSRFC  :  ',TRDLW,TSRFC
        WRITE(LIST,*)'  TSHDE (POSTED FORECAST HOURS) BELOW:  '
        WRITE(LIST,75) (TSHDE(K),K=1,NMAP)
        WRITE(LIST,*)'  SPL (POSTED PRESSURE LEVELS) BELOW: '
        WRITE(LIST,80) (SPL(K),K=1,LSM)
!
        75 FORMAT(14(F4.1,1X))
        80 FORMAT( 8(F8.1,1X))
!
    END IF
!------------------------------------- 
! SET TIME STEPPING RELATED CONSTANTS.
!-------------------------------------
    FIRST  = .TRUE. 
    NSTART = INT(TSTART * TSPH + 0.5)
    NTSTM  = INT(TEND   * TSPH + 0.5) + 1
    NCP    = INT(TCP    * TSPH + 0.5)
    NPREC  = INT(TPREC  * TSPH + 0.5)
    NHEAT  = INT(THEAT  * TSPH + 0.5)
    NCLOD  = INT(TCLOD  * TSPH + 0.5)
    NRDSW  = INT(TRDSW  * TSPH + 0.5)
    NRDLW  = INT(TRDLW  * TSPH + 0.5)
    NSRFC  = INT(TSRFC  * TSPH + 0.5)
!
    IF (MYPE == 0) THEN
        WRITE(0,*)' NTSTM=',NTSTM,' TSPH=',TSPH,' DT=',DT
    END IF
!------------------------------------------------
! SET VARIOUS PHYSICS PACKAGE TIMESTEP VARIABLES.
!------------------------------------------------
    NRADS = NINT(TSPH) * NRADSH
    NRADL = NINT(TSPH) * NRADLH
    DTQ2  = NPHS * DT
    TDTQ2 = DTQ2 + DTQ2
    DTD   = 0.5  * DTQ2
    TDTD  = DTD  + DTD
    KTM   = INT(DTQ2 / DTD + 0.5)
!
    IF (MYPE == 0) THEN
        WRITE(LIST,*)' '
        WRITE(LIST,*)'SET TIME STEPPING CONSTANTS'
        WRITE(LIST,*)' FIRST             :  ',FIRST
        WRITE(LIST,*)' NSTART,NSTSM,NCP  :  ',NSTART, NTSTM, NCP
        WRITE(LIST,*)' NTDDMP,NPREC,NHEAT:  ',NTDDMP, NPREC, NHEAT
        WRITE(LIST,*)' NCLOD,NRDSW,NRDLW :  ',NCLOD , NRDSW, NRDLW
        WRITE(LIST,*)' NSRFC             :  ',NSRFC
        WRITE(LIST,*)' NRADS,NRADL,KTM   :  ',NRADS , NRADL, KTM
        WRITE(LIST,*)' DTQ2,TDTQ2        :  ',DTQ2  , TDTQ2
        WRITE(LIST,*)' DTD,TDTD          :  ',DTD   , TDTD
        WRITE(LIST,*)' '
    END IF
!-------------------------------------- 
! COMPUTE DERIVED MAP OUTPUT CONSTANTS.
!--------------------------------------    
    DO K = 1,LSL
        ALSL(K) = LOG(SPL(K))
    END DO
    DO I=1,NMAP
        ISHDE(I) = INT(TSHDE(I) * TSPH + 0.5) + 1
    END DO
!--------------------------------------
! SET UP ARRAY IRAD (INDICES FOR RADTN)
!--------------------------------------
    DO I=MYIS,MYIE
        IRAD(I) = IRADG(I+MY_IS_GLB-1) - MY_IS_GLB + 1
    END DO
!-----------------------------------------
! READ INITIAL CONDITIONS OR RESTART FILE.
!-----------------------------------------
    BTIM = TIMEF()
!
    IF (SINGLRST) THEN
        CALL READ_RESTRT
    ELSE
        CALL READ_RESTRT2
    END IF
!
    RES_TIM = TIMEF() - BTIM
!--------------------------------------------------------------------------------------------------
! IF NOT RUNNING THE MODEL, PRINT DATE OF INITIAL CONDITIONS JUST READ AND STOP. 
! OTHERWISE, CONTINUE.
!--------------------------------------------------------------------------------------------------
    IF (RUN) GOTO 190
!
    IF (MYPE == 0) THEN
        WRITE(LIST,165) IHRST, IDAT
        WRITE(LIST,166)
!
        CALL MPI_FINALIZE(IERR)
!
        STOP 2
        165 FORMAT('0*** ',I2,' GMT ',2(I2,'/'),I4,' ***')
        166 FORMAT('0F*** NO INITIAL CONDITIONS. RUN TERMINATED.')
    END IF
!--------------------------------------------------------------------------------------------------
! IF THE TIMESTEP COUNTER (NTSD) EXCEEDS THE "STOP MODEL" T TIMESTEP,CONTINUE, STOP EXECUTION. 
! OTHERWISE, CONTINUE.
!--------------------------------------------------------------------------------------------------
    190 IF (NTSD >= NTSTM) THEN
        IF (MYPE == 0) THEN
            WRITE(LIST,165) IHRST, IDAT
            WRITE(LIST,195)
            195 FORMAT('0F*** FORECAST ALREADY DONE. RUN TERMINATED.')
!
            CALL MPI_FINALIZE(IERR)
            STOP 3
        END IF
    END IF
!-------------------------- 
! READ BOUNDARY CONDITIONS.
!-------------------------- 
    IF (MYPE == 0) THEN
        OPEN(UNIT=NBC, FORM='UNFORMATTED', FILE='BNDY.file')
!
        IF (NEST) THEN
            KBI    = 2 * IM + JM - 3
            KBI2   = KBI - 4
            LRECBC = 4 * (1 + (1 + 6 * LM) * KBI * 2 + (KBI + KBI2) * (LM+1))
!
            OPEN(UNIT=NBC, ACCESS='DIRECT', RECL=LRECBC)
        END IF
!    
        IF ( .NOT. NEST) REWIND NBC
!   
#ifdef DP_REAL
!
        IF (NEST) THEN
            READ(NBC,REC=1) RUNBX, IDATBX, IHRSTBX, TBOCO
        ELSE
            READ(NBC) RUNBX, IDATBX, IHRSTBX, TBOCO
        END IF
!    
        RUNB   = RUNBX
        IDATB  = IDATBX
        IHRSTB = IHRSTBX
!
#else
!
        IF (NEST) THEN
            READ(NBC,REC=1) RUNB, IDATB, IHRSTB, TBOCO
        ELSE
            WRITE(6,*) 'READING FROM NBC HERE'
            READ(NBC) RUNB, IDATB, IHRSTB, TBOCO
            WRITE(6,*) 'PAST FROM NBC HERE'
            WRITE(6,*) 'IDATB: ' , IDATB
            WRITE(6,*) 'IHRSTB: ', IHRSTB
        END IF
!
#endif
!
    END IF
!
    CALL MPI_BCAST(RUNB  , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST(IDATB , 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST(IHRSTB, 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BCAST(TBOCO , 1, MPI_REAL   , 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER                         (MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0 .AND. .NOT. NEST) THEN
        ISTART = NINT(TSTART)
!    
        READ(NBC) BCHR
    205 READ(NBC)
        READ(NBC)
        READ(NBC)
        READ(NBC)
        READ(NBC)
        READ(NBC)
        READ(NBC)
!    
        IF (ISTART == NINT(BCHR)) THEN
            IF(ISTART > 0) READ(NBC) BCHR
            GO TO 215
        ELSE
            READ(NBC) BCHR
        END IF
!    
        IF (ISTART >= NINT(BCHR)) GOTO 205
    END IF
!
    IF (MYPE == 0 .AND. NEST) THEN
        ISTART = NINT(TSTART)
        NREC   = 1
!    
    210 NREC = NREC + 1
        READ(NBC,REC=NREC) BCHR
    
        IF (ISTART == NINT(BCHR)) THEN
            IF (ISTART > 0) READ(NBC, REC=NREC+1) BCHR
            GOTO 215
        ELSE
            GOTO 210
        END IF
!
    END IF
!
    215 CONTINUE
!
    CALL MPI_BCAST(BCHR, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_BARRIER                    (MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0) WRITE(LIST,*)'  READ UNIT NBC=', NBC
!------------------------------------------------- 
! COMPUTE THE 1ST TIME FOR BOUNDARY CONDITION READ
!-------------------------------------------------
    NBOCO = NINT(BCHR * TSPH)
!
    IF (NTSD == 0) THEN
        IF (MYPE == 0 .AND. .NOT. NEST) THEN
            BACKSPACE NBC
            BACKSPACE NBC
            BACKSPACE NBC
            BACKSPACE NBC
            BACKSPACE NBC
            BACKSPACE NBC
            BACKSPACE NBC
            WRITE(LIST,*)'  BACKSPACE UNIT NBC=', NBC
        END IF
    END IF
!---------------------------------------- 
! SET ARRAYS CONTROLLING POST PROCESSING.
!---------------------------------------- 
    IF (MYPE == 0) THEN
        WRITE(LIST,*)'INIT:  READ IOUT,NSHDE,NTSD=', IOUT, NSHDE, NTSD
    END IF
!
    DO I=1,NMAP
        IOUT = I
        IF (ISHDE(I) >= NTSD) GOTO 220
    END DO
!
220 NSHDE = ISHDE(IOUT)
!
    IF (MYPE == 0) THEN
        WRITE(LIST,*)'INIT:  SET IOUT,NSHDE =', IOUT, NSHDE,' FOR ISHDE,NTSD=', ISHDE(IOUT), NTSD
    END IF
!-----------------------------------------------------------------
!  INITIALIZE PHYSICS VARIABLES IF STARTING THIS RUN FROM SCRATCH.
!-----------------------------------------------------------------
    IF (NEST) THEN
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
!
                LLMH=LMH(I,J)
!
                IF (T(I,J,LLMH) == 0.) THEN
                    T(I,J,LLMH) = T(I,J,LLMH-1)
                END IF
!            
                TERM1       = -0.068283 / T(I,J,LLMH)
                PSHLTR(I,J) = (PD(I,J) + PT) * EXP(TERM1)
            END DO
        END DO
    END IF
!
    IF ( .NOT. RESTRT) THEN
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                LLMH        = LMH(I,J)
                  PDSL(I,J) = PD(I,J) * RES(I,J)
                  PREC(I,J) =   0.
                ACPREC(I,J) =   0.
                CUPREC(I,J) =   0.
                    Z0(I,J) = SM(I,J) * Z0SEA + (1. - SM(I,J)) * (FIS(I,J) * FCM + Z0LAND)
                    QS(I,J) =   0.
                  AKMS(I,J) =   0.
                  AKHS(I,J) =   0.
                  TWBS(I,J) =   0.
                  QWBS(I,J) =   0.
                CLDEFI(I,J) =   1.
                  HTOP(I,J) = 100.
                  HBOT(I,J) =   0.
!--------------------------------------------------------------------------------------------------------
! AT THIS POINT, WE MUST CALCULATE THE INITIAL POTENTIAL TEMPERATURE OF THE SURFACE AND OF THE SUBGROUND.
! EXTRAPOLATE DOWN FOR INITIAL SURFACE POTENTIAL TEMPERATURE. ALSO DO THE SHELTER PRESSURE.
!--------------------------------------------------------------------------------------------------------
                PM1      = PDSL(I,J) * AETA(LLMH) + PT
                APEM1    = (1.E5 / PM1) ** CAPA
                THS(I,J) = T(I,J,LLMH) * (1. + 0.608 * Q(I,J,LLMH)) * APEM1
                TSFCK    = T(I,J,LLMH) * (1. + 0.608 * Q(I,J,LLMH))
                PSFCK    = PD(I,J) + PT
!            
                IF (SM(I,J) < 0.5) THEN
                     QS(I,J) = PQ0 / PSFCK * EXP(A2 * (TSFCK - A3) / (TSFCK - A4))
                ELSE IF(SM(I,J) > 0.5) THEN
                    THS(I,J) = SST(I,J) * (1.E5 / (PD(I,J) + PT)) ** CAPA
                END IF
!            
                TERM1       = -0.068283 / T(I,J,LLMH)
                PSHLTR(I,J) = (PD(I,J) + PT) * EXP(TERM1)
!            
                USTAR(I,J) = 0.1
                 THZ0(I,J) = THS(I,J)
                  QZ0(I,J) =  QS(I,J)
                  UZ0(I,J) = 0.
                  VZ0(I,J) = 0.
!
            END DO
        END DO
!------------------------   
! INITIALIZE CLOUD FIELDS
!------------------------     
        DO K=1,LM
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    CWM(I,J,K) = 0.
                END DO
            END DO
        END DO
!---------------------------------------     
! INITIALIZE ACCUMULATOR ARRAYS TO ZERO.
!---------------------------------------      
        ARDSW  = 0.0
        ARDLW  = 0.0
        ASRFC  = 0.0
        AVRAIN = 0.0
        AVCNVC = 0.0
!    
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                ACFRCV(I,J) = 0.
                NCFRCV(I,J) = 0
                ACFRST(I,J) = 0.
                NCFRST(I,J) = 0
                ACSNOW(I,J) = 0.
                ACSNOM(I,J) = 0.
                SSROFF(I,J) = 0.
                BGROFF(I,J) = 0.
                 ALWIN(I,J) = 0.
                ALWOUT(I,J) = 0.
                ALWTOA(I,J) = 0.
                 ASWIN(I,J) = 0.
                ASWOUT(I,J) = 0.
                ASWTOA(I,J) = 0.
                SFCSHX(I,J) = 0.
                SFCLHX(I,J) = 0.
                SUBSHX(I,J) = 0.
                SNOPCX(I,J) = 0.
                SFCUVX(I,J) = 0.
                SFCEVP(I,J) = 0.
                POTEVP(I,J) = 0.
                POTFLX(I,J) = 0.
            END DO
        END DO
!--------------------------------------------------------      
! INITIALIZE SATURATION SPECIFIC HUMIDITY OVER THE WATER.
!--------------------------------------------------------      
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                IF (SM(I,J) > 0.5) THEN
                    CLOGES  = -CM1 / SST(I,J) - CM2 * ALOG10(SST(I,J)) + CM3
                    ESE     =  10. ** (CLOGES + 2.)
                    QS(I,J) =  SM(I,J) * EPS * ESE / (PD(I,J) + PT - ESE * (1. - EPS))
                END IF
            END DO
        END DO
!---------------------------------------------------------------------------------------------------------------------------      
! PAD GROUND WETNESS IF IT IS TOO SMALL.
!     
! DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
! DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
!    WET(I,J)=AMAX1(WET(I,J),EPSWET)
! END DO
! EN DDO
!    
! INITIALIZE TURBULENT KINETIC ENERGY (TKE) TO A SMALL VALUE (EPSQ2) ABOVE GROUND.  
! SET TKE TO ZERO IN THE THE LOWEST MODEL LAYER.  IN THE LOWEST TWO ATMOSPHERIC ETA LAYERS SET TKE TO A SMALL VALUE (Q2INI).
!---------------------------------------------------------------------------------------------------------------------------    
        DO K=1,LM1
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    Q2(I,J,K) = HTM(I,J,K+1) * HBM2(I,J) * EPSQ2
                END DO
            END DO
        END DO
!    
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                Q2(I,J,LM)     = 0.
                LLMH           =  LMH(I,J)
                Q2(I,J,LLMH-2) = HBM2(I,J) * Q2INI
                Q2(I,J,LLMH-1) = HBM2(I,J) * Q2INI
            END DO
        END DO
!-------------------------------------------------------    
! PAD ABOVE GROUND SPECIFIC HUMIDITY IF IT IS TOO SMALL.
! INITIALIZE LATENT HEATING ACCUMULATION ARRAYS.
!-------------------------------------------------------     
        DO K=1,LM
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    IF (Q(I,J,K) < EPSQ) Q(I,J,K) = EPSQ * HTM(I,J,K)
                    TRAIN(I,J,K) = 0.
                    TCUCN(I,J,K) = 0.
                END DO
            END DO
        END DO
!-------------------------------------------     
! END OF SCRATCH START INITIALIZATION BLOCK.
!-------------------------------------------     
        IF (MYPE == 0) THEN
            WRITE(LIST,*)'INIT:  INITIALIZED ARRAYS FOR CLEAN START'
        END IF
    END IF
!---------------------------------------------------------------------------  
! RESTART INITIALIZING. CHECK TO SEE IF WE NEED TO ZERO ACCUMULATION ARRAYS.
!--------------------------------------------------------------------------- 
    IF (RESTRT) THEN
!---------------------------     
! AVERAGE CLOUD AMOUNT ARRAY
!---------------------------    
        IF (NSTART == 0) THEN
            IF (MYPE == 0) WRITE(LIST,*)'  ZERO AVG CLD AMT ARRAY'
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    ACFRCV(I,J) = 0.
                    NCFRCV(I,J) = 0
                    ACFRST(I,J) = 0.
                    NCFRST(I,J) = 0
                END DO
            END DO
        END IF
!-------------------------------------------------
! GRID-SCALE AND CONVECTIVE LATENT HEATING ARRAYS.
 !-------------------------------------------------   
        IF (NSTART == 0) THEN
            IF(MYPE == 0)THEN
                WRITE(LIST,*)'  ZERO ACCUM LATENT HEATING ARRAYS'
            END IF
!        
            AVRAIN = 0.
            AVCNVC = 0.
!
            DO K=1,LM
                DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                    DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                        TRAIN(I,J,K) = 0.
                        TCUCN(I,J,K) = 0.
                    END DO
                END DO
            END DO
        END IF
!---------------------------------------------- 
! TOTAL AND CONVECTIVE PRECIPITATION ARRAYS.
! TOTAL SNOW AND SNOW MELT ARRAYS.
! STORM SURFACE AND BASE GROUND RUN OFF ARRAYS.
!----------------------------------------------     
        IF (NSTART == 0) THEN
            IF (MYPE == 0) WRITE(LIST,*)'  ZERO ACCUM PRECIP ARRAYS'
!
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    ACPREC(I,J) = 0.
                    CUPREC(I,J) = 0.
                    ACSNOW(I,J) = 0.
                    ACSNOM(I,J) = 0.
                    SSROFF(I,J) = 0.
                    BGROFF(I,J) = 0.
                END DO
            END DO
        END IF
!----------------------------     
! LONG WAVE RADIATION ARRAYS.
!----------------------------     
        IF (NSTART == 0) THEN
            IF(MYPE == 0) WRITE(LIST,*)'  ZERO ACCUM LW RADTN ARRAYS'
!
            ARDLW = 0.
!
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                     ALWIN(I,J) = 0.
                    ALWOUT(I,J) = 0.
                    ALWTOA(I,J) = 0.
                END DO
            END DO
        END IF
!-----------------------------     
! SHORT WAVE RADIATION ARRAYS.
!-----------------------------     
        IF (NSTART == 0) THEN
            IF (MYPE == 0) WRITE(LIST,*)'  ZERO ACCUM SW RADTN ARRAYS'
!
            ARDSW = 0.
!
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    ASWIN(I,J)  = 0.
                    ASWOUT(I,J) = 0.
                    ASWTOA(I,J) = 0.
                END DO
            END DO
        END IF
!----------------------------------------------     
! SURFACE SENSIBLE AND LATENT HEAT FLUX ARRAYS.
!----------------------------------------------      
        IF (NSTART == 0) THEN
!
            IF(MYPE == 0) WRITE(LIST,*)'  ZERO ACCUM SFC FLUX ARRAYS'
!
            ASRFC = 0.
!
            DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
                DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                    SFCSHX(I,J) = 0.
                    SFCLHX(I,J) = 0.
                    SUBSHX(I,J) = 0.
                    SNOPCX(I,J) = 0.
                    SFCUVX(I,J) = 0.
                    SFCEVP(I,J) = 0.
                    POTEVP(I,J) = 0.
                    POTFLX(I,J) = 0.
                END DO
             END DO
        END IF
!------------------------------------------------      
! ENDIF FOR RESTART FILE ACCUMULATION ZERO BLOCK.
!------------------------------------------------     
        IF (MYPE == 0) THEN
            WRITE(LIST,*)'INIT:  INITIALIZED ARRAYS FOR RESTART START'
        END IF
    END IF
!---------------------------  
! INITIALIZE CLOUD CONSTANTS
!--------------------------- 
    DO 350 J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
        DO 350 I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
            U00(I,J) = .95
350 END DO
!----------------------------------------------------------------------------------------------  
! FLAG FOR INITIALIZING ARRAYS, LOOKUP TABLES, AND CONSTANTS USED IN MICROPHYSICS AND RADIATION
!---------------------------------------------------------------------------------------------- 
    MICRO_START = .TRUE. 
!------------------------------------------------------------
! FLAG FOR INITIALIZING CONVECTIVE CLOUD ARRAYS FOR RADIATION
!------------------------------------------------------------
    CURAD= .FALSE. 
!
    DO 355 K=1,2*LM
        IF (K >= LM-10 .AND. K <= LM) THEN
            UL(K) = 0.1 * FLOAT(K-LM+10)
        ELSE
            UL(K) = 0.
        END IF
355 END DO
!---------------------------------------- 
! SET INDEX ARRAYS FOR UPSTREAM ADVECTION
!---------------------------------------- 
    KNT = 0
!
    DO J=3,5
        KNT       = KNT + 1
        IHLA(KNT) = 2
        IHHA(KNT) = IM - 1 - MOD(J+1,2)
        IVLA(KNT) = 2
        IVHA(KNT) = IM - 1 - MOD(J  ,2)
         JRA(KNT) = J
    END DO
!
    DO J=JM-4,JM-2
        KNT       = KNT + 1
        IHLA(KNT) = 2
        IHHA(KNT) = IM - 1 - MOD(J+1,2)
        IVLA(KNT) = 2
        IVHA(KNT) = IM - 1 - MOD(J  ,2)
         JRA(KNT) = J
    END DO
!
    DO J=6,JM-5
        KNT       = KNT + 1
        IHLA(KNT) = 2
        IHHA(KNT) = 2 + MOD(J  ,2)
        IVLA(KNT) = 2
        IVHA(KNT) = 2 + MOD(J+1,2)
         JRA(KNT) = J
    END DO
!
    DO J=6,JM-5
        KNT       = KNT + 1
        IHLA(KNT) = IM - 2
        IHHA(KNT) = IM - 2 + MOD(J  ,2)
        IVLA(KNT) = IM - 2
        IVHA(KNT) = IM - 2 + MOD(J+1,2)
         JRA(KNT) = J
    END DO
!------------------------------------------------- 
! SET ZERO-VALUE FOR SOME OUTPUT DIAGNOSTIC ARRAYS
!------------------------------------------------- 
    IF (NSTART == 0)THEN
!    
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                PCTSNO(I,J) = -999.0
                IF (SM(I,J) < 0.5) THEN
                    IF (SICE(I,J) > 0.5) THEN
!-------------                     
! SEA-ICE CASE
!-------------                     
                        SMSTAV(I,J) = 1.0
                        SMSTOT(I,J) = 1.0
                        SSROFF(I,J) = 0.0
                        BGROFF(I,J) = 0.0
                           CMC(I,J) = 0.0
!
                        DO NS=1,NSOIL
                             SMC(I,J,NS) = 1.0
                            SH2O(I,J,NS) = 1.0
                        END DO
!
                    END IF
!
                ELSE
!-----------                  
! WATER CASE
!-----------                
                    SMSTAV(I,J) =   1.0
                    SMSTOT(I,J) =   1.0
                    SSROFF(I,J) =   0.0
                    BGROFF(I,J) =   0.0
                    SOILTB(I,J) = 273.16
                    GRNFLX(I,J) =   0.
                    SUBSHX(I,J) =   0.0
                    ACSNOW(I,J) =   0.0
                    ACSNOM(I,J) =   0.0
                    SNOPCX(I,J) =   0.0
                       CMC(I,J) =   0.0
                       SNO(I,J) =   0.0
!
                    DO NS=1,NSOIL
                         SMC(I,J,NS) =   1.0
                        SH2O(I,J,NS) =   1.0
                         STC(I,J,NS) = 273.16
                    END DO
                END IF
!            
            END DO
        END DO
!    
        APHTIM = 0.0
        ARATIM = 0.0
        ACUTIM = 0.0    
    END IF
!-----------------------------------------------------------------------------------------------------------------------
! INITIALIZE RADTN VARIABLES
! CALCULATE THE NUMBER OF STEPS AT EACH POINT.
! THE ARRAY 'LVL' WILL COORDINATE VERTICAL LOCATIONS BETWEEN THE LIFTED WORKING ARRAYS AND THE FUNDAMENTAL MODEL ARRAYS.
! LVL HOLDS THE HEIGHT (IN MODEL LAYERS) OF THE TOPOGRAPHY AT EACH GRID POINT.
!-----------------------------------------------------------------------------------------------------------------------
    DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
        DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
            LVL(I,J) = LM-LMH(I,J)
        END DO
    END DO
!------------------------------------------------------------------------
! DETERMINE MODEL LAYER LIMITS FOR HIGH(3), MIDDLE(2), AND LOW(1) CLOUDS. 
! ALSO FIND MODEL LAYER THAT IS JUST BELOW (HEIGHT-WISE) 400 MB. (K400)
!------------------------------------------------------------------------
    K400 = 0
    PSUM = PT
    SLPM = 101325.
    PDIF = SLPM - PT
!
    DO K=1,LM
        PSUM = PSUM + DETA(K) * PDIF
        IF (LTOP(3) == 0) THEN
             IF  (PSUM > PHITP) LTOP(3) = K
        ELSE IF (LTOP(2) == 0) THEN
             IF  (PSUM > PMDHI) LTOP(2) = K
        ELSE IF (K400 == 0) THEN
             IF  (PSUM > P400)  K400    = K
        ELSE IF (LTOP(1) == 0) THEN
             IF  (PSUM > PLOMD) LTOP(1) = K
        END IF
    END DO
!---------------------------------------------------- 
! CALL GRADFS ONCE TO CALC. CONSTANTS AND GET O3 DATA
!---------------------------------------------------- 
    KCCO2 = 0
!------------------------------------------------------------ 
! CALCULATE THE MIDLAYER PRESSURES IN THE STANDARD ATMOSPHERE
!------------------------------------------------------------ 
    PSS  = 101325.
    PDIF = PSS - PT

    DO K=1,LM1
        PHALF(K+1) = AETA(K) * PDIF + PT
    END DO
!
    PHALF(1)   = 0.
    PHALF(LP1) = PSS
!
    CALL GRADFS(PHALF, KCCO2, NFILE)
!------------------------------------------------------------ 
! CALL SOLARD TO CALCULATE NON-DIMENSIONAL SUN-EARTH DISTANCE
!------------------------------------------------------------ 
    IF (MYPE == 0) CALL SOLARD(RAD1)
    CALL MPI_BCAST(RAD1, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!------------------------------------------------------------------------------ 
! CALL ZENITH SIMPLY TO GET THE DAY OF THE YEAR FOR THE SETUP OF THE OZONE DATA
!------------------------------------------------------------------------------
    TIME = (NTSD - 1) * DT
!
    CALL ZENITH(TIME, DAYI, HOUR)
! 
    ADDL = 0.
!
    IF (MOD(IDAT(3),4) == 0) ADDL = 1.
!
    RANG  = PI2 * (DAYI - RLAG) / (365.25 + ADDL)
    RSIN1 = SIN(RANG)
    RCOS1 = COS(RANG)
    RCOS2 = COS(2. * RANG)
!
    CALL O3CLIM(MYPE)
!------------------------------------------------- 
! SOME INITIAL VALUES RELATED TO TURBULENCE SCHEME
!------------------------------------------------- 
    DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
        DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
!------------------------------------------------        
! TRY A SIMPLE LINEAR INTERP TO GET 2/10 M VALUES
!------------------------------------------------        
            PDSL(I,J) = PD(I,J) * RES(I,J)
!
            LMHK = LMH(I,J)
            LMVK = LMV(I,J)
!
            ULM = U(I,J,LMVK)
            VLM = V(I,J,LMVK)
            TLM = T(I,J,LMHK)
            QLM = Q(I,J,LMHK)
!
            PLM=PDSL(I,J) * AETA(LMHK) + PT
            APELM   = (1.0E5 / PLM)         ** CAPA
            APELMNW = (1.0E5 / PSHLTR(I,J)) ** CAPA
            EXNERR  = (PSHLTR(I,J) * 1.E-5) ** CAPA
!
            THLM = TLM * APELM
            DPLM = PDSL(I,J) * DETA(LMHK) * 0.5
            DZLM = 287.04 * DPLM * TLM * (1. + 0.608 * QLM) / (9.801 * PLM)
            FAC1 = 10. / DZLM
            FAC2 = (DZLM - 10.) / DZLM
!
            IF (DZLM <= 10.) THEN
                FAC1 = 1.
                FAC2 = 0.
            END IF
!        
            IF ( .NOT. RESTRT) THEN
                TH10(I,J) = FAC2 * THS(I,J) + FAC1 * THLM
                 Q10(I,J) = FAC2 *  QS(I,J) + FAC1 * QLM
                 U10(I,J) = ULM
                 V10(I,J) = VLM
            END IF
!        
            FAC1 = 2. / DZLM
            FAC2 = (DZLM - 2.) / DZLM
!
            IF (DZLM <= 2.) THEN
                FAC1 = 1.
                FAC2 = 0.
            END IF
!        
            IF ( .NOT. RESTRT .OR. NEST) THEN
                TSHLTR(I,J) = 0.1 * THS(I,J) + 0.9 * THLM
                QSHLTR(I,J) = QLM
            END IF
!--------- 
! SM V100M
!---------
            FAC1 =         100.  / DZLM
            FAC2 = (DZLM - 100.) / DZLM
!
            IF (DZLM <= 100.) THEN
                FAC1 = 1.
                FAC2 = 0.
            END IF
!                  
            IF ( .NOT. RESTRT) THEN
                TH100(I,J) = FAC2 * THS(I,J) + FAC1 * THLM
                 Q100(I,J) = FAC2 *  QS(I,J) + FAC1 * QLM
                 U100(I,J) = ULM
                 V100(I,J) = VLM
            END IF
!---------
! SM V100M
!---------
!
!----------------------------------------------------------------------------------------
! NEED TO CONVERT TO THETA IF IS THE RESTART CASE AS CHKOUT.F WILL CONVERT TO TEMPERATURE
!----------------------------------------------------------------------------------------
            IF (RESTRT) THEN
                TSHLTR(I,J) = TSHLTR(I,J) * APELMNW
            END IF
        END DO
    END DO
!------------------------------------- 
! INITIALIZE NONHYDROSTATIC QUANTITIES
!------------------------------------- 
    DO K=1,LM
!    
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                DWDT(I,J,K) = 1.
            END DO
        END DO
    END DO
!
    IF (SIGMA) THEN
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                PDSL(I,J) = PD(I,J)
            END DO
        END DO
    ELSE
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                PDSL(I,J) = RES(I,J) * PD(I,J)
            END DO
        END DO
    END IF
!
    DO K=1,LP1
!    
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                PINT(I,J,K) = PDSL(I,J) * ETA(K) + PT
                   Z(I,J,K) = PINT(I,J,K)
            END DO
        END DO
!
    END DO
!------------------------------------ 
! SLOPE DIRECTION IDENTIFICATION LOOP 
!------------------------------------
    CALL EXCH(ISLD, 1, 5, 5)
    CALL EXCH(LMV , 1, 5, 5)
!
    DO K=1,LM
        DO J=JDIM1,JDIM2
            DO I=IDIM1,IDIM2
                VTMS(I,J,K) = 0
            END DO
        END DO
    END DO
!
    DO J=JDIM1,JDIM2
        DO I=IDIM1,IDIM2
            IF (ISLD(I,J) > 0) THEN
                VTMS(I,J,LMV(I,J)+1) = 1
            END IF
        END DO
    END DO
!------------------------ 
! END OF SUBROUTINE INIT.
!------------------------ 
    IF (MYPE == 0) THEN
        WRITE(LIST,*) 'INIT:  EXIT INIT AND START MODEL INTEGRATION'
        WRITE(LIST,*) ' '
    END IF
!
    RETURN
!
    END SUBROUTINE INITS

    SUBROUTINE RADFS(QS    , PP    , PPI   , QQH2O , TT    , O3QO3 , TSFC  , SLMSK , ALBEDO,      &
    &                XLAT  , CAMT  , ITYP  , KTOP  , KBTM  , NCLDS , EMCLD , RRCL  , TTCL  ,      &
    &                COSZRO, TAUDAR, IBEG  , KO3   , KALB  , SLMRF , SLYMRF, ITIMSW, ITIMLW,      &
    &                JD    , R1    , GMT   , SWH   , HLW   , FLWUP , FSWUP , FSWDN , FSWDNS,      &
    &                FSWUPS, FLWDNS, FLWUPS) 
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE RADFS
!>
!> SUBROUTINE: RADFS - RADIATION
!> PROGRAMMER:  Y.H AND K.A.C
!> ORG: ?????
!> DATE: 93-??-??
!> 
!> ABSTRACT:
!> THE INTERNAL DRIVE FOR GFDL RADIATION
!> THIS SUBROUTINE WAS FROM Y.H AND K.A.C (1993) AND MODIFIED BY Q. ZHAO FOR USE IN THE ETA MODEL 
!> 93-11-18
!>
!> UPDATE: THIS SUBROUTINE WAS MODIFIED TO USE CLOUD FRACTION ON EACH MODEL LAYER. 
!> QINGYUN ZHAO 95-3-22
!>
!> UPDATE: R1 HAS BEEN ADDED TO THE INPUTS FROM RADTN TO COMPUTE THE VARIATION OF SOLAR CONSTANT 
!>         AT THE TOP OF ATMOSPHERE WITH JULIAN DAY IN A YEAR. 
!>         QINGYUN ZHAO 96-7-23 
!>
!> PROGRAM HISTORY LOG:
!> 93-??-??  Y.H AND K.A.C    - ORIGINATOR
!> 18-01-15  LUCCI            - MODERNIZATION OF THE CODE, INCLUDING:
!>                              * F77 TO F90/F95
!>                              * INDENTATION & UNIFORMIZATION CODE
!>                              * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                              * DOCUMENTATION WITH DOXYGEN
!>                              * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> IX IS THE LENGTH OF A ROW IN THE DOMAIN
!>
!> QS(IX)          - THE SURFACE PRESSURE (PA)
!> PP(IX,L)        - THE MIDLAYER PRESSURES (PA)  (L IS THE VERT. DIMEN.)
!> PPI(IX,LP1)     - THE INTERFACE PRESSURES (PA)
!> QQH2O(IX,L)     - THE MIDLAYER WATER VAPOR MIXING RATIO (KG/KG)
!> TT(IX,L)        - THE MIDLAYER TEMPERATURE (K)
!> O3QO3(IX,L)     - THE MIDLAYER OZONE MIXING RATIO
!> TSFC(IX)        - THE SKIN TEMP. (K); NEGATIVE OVER WATER
!> SLMSK(IX)       - THE SEA MASK (LAND = 0, SEA = 1)
!> ALBEDO(IX)      - THE SURFACE ALBEDO (EXPRESSED AS A FRACTION)
!> XLAT(IX)        - THE GEODETIC LATITUDES OF EACH COLUMN IN DEGREES (N.H.> 0)
!>
!> THE FOLLOWING ARE CLOUD INFORMATION FOR EACH CLOUD LAYER
!>                 - LAYER = 1 - SURFACE
!>                 - LAYER = 2 - FIRST LAYER ABOVE GROUND, AND SO ON
!> CAMT(IX,LP1)    - CLOUD FRACTION OF EACH CLOUD LAYER
!> ITYP(IX,LP1)    - CLOUD TYPE = 1 - STRATIFORM, TYPE = 2 - CONVECTIVE
!> KTOP(IX,LP1)    - HEIGHT OF CLOUD TOP OF EACH CLOUD LAYER (IN ETA LEVEL)
!> KBTM(IX,LP1)    - BOTTOM OF EACH CLOUD LAYER
!> NCLDS(IX)       - NUMBER OF CLOUD LAYERS
!> EMCLD(IX,LP1)   - CLOUD EMISSIVITY
!> RRCL(IX,NB,LP1) - CLOUD REFLECTTANCES FOR SW SPECTRAL BANDS
!> TTCL(IX,NB,LP1) - CLOUD TRANSMITANCES FOR SW SPECTRAL BANDS
!>
!> THE ABOVE ARE CLOUD INFORMATION FOR EACH CLOUD LAYER
!> COSZRO(IX)      - THE COSINE OF THE SOLAR ZENITH ANGLE
!> TAUDAR          - = 1.0
!> IBEG            - = 1
!> KO3             - = 1 (READ IN THE QZONE DATA)
!> KALB            - = 0
!> SLMRF(LP1)      - THE INTERFACES ETA (LP1 = L + 1)
!> SLYMRF(L)       - THE MIDLAYER ETA
!> ITIMSW          - = 1 / 0 (SHORTWAVE CALC. ARE DESIRED/NOT DESIRED)
!> ITIMLW          - = 1 / 0 (LONGWAVE CALC. ARE DESIRED/NOT DESIRED)
!>
!> THE FOLLOWING ARE ADDITIONAL FOR ETA MODEL
!>
!> (JD, R1, GMT)
!>
!> JD  - JULIAN DAY IN A YEAR
!> R1  - THE NON-DIMENSIONAL SUN-EARTH DISTANCE
!> GMT - HOUR
!>
!> OUTPUT ARGUMENT LIST:
!> SWH    - ATMOSPHERIC SHORTWAVE HEATING RATES IN K/S. SWH IS A REAL ARRAY DIMENSIONED (NCOL X LM).
!> HLW    - ATMOSPHERIC LONGWAVE HEATING RATES IN K/S. HLW IS A REAL ARRAY DIMENSIONED (NCOL X LM).
!> FLWUP  - UPWARD LONGWAVE FLUX AT TOP OF THE ATMOSPHERE IN W/M**2. 
!>          FLWUP IS A REAL ARRAY DIMENSIONED (NCOL).
!> FSWUP  - UPWARD SHORTWAVE FLUX AT TOP OF THE ATMOSPHERE IN W/M**2. 
!>          FSWUP IS A REAL ARRAY DIMENSIONED (NCOL).
!> FSWDN  - DOWNWARD SHORTWAVE FLUX AT TOP OF THE ATMOSPHERE IN W/M**2. 
!>          FSWDN IS A REAL ARRAY DIMENSIONED (NCOL).
!> FSWDNS - DOWNWARD SHORTWAVE FLUX AT THE SURFACE IN W/M**2. 
!>          FSWDNS IS A REAL ARRAY DIMENSIONED (NCOL).
!> FSWUPS - UPWARD SHORTWAVE FLUX AT THE SURFACE IN W/M**2. 
!>          FSWUPS IS A REAL ARRAY DIMENSIONED (NCOL).
!> FLWDNS - DOWNWARD LONGWAVE FLUX AT THE SURFACE IN W/M**2. 
!>          FLWDNS IS A REAL ARRAY DIMENSIONED (NCOL).
!> FLWUPS - UPWARD LONGWAVE FLUX AT THE SURFACE IN W/M**2. 
!>          FLWUPS IS A REAL ARRAY DIMENSIONED (NCOL).
!>
!> USE MODULES: ASTSAV
!>              CO2DTA
!>              F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              RDFSAV
!>              RDPARM
!>              RNDDTA
!>              SAVMEM
!>              SSALB
!>              SWRSAV
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : RADTN
!>
!> CALLS      : CLO89
!>              LWR88
!>              SWR93
!>--------------------------------------------------------------------------------------------------
    USE ASTSAV
    USE CO2DTA
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE RDFSAV
    USE RDPARM
    USE RNDDTA
    USE SAVMEM
    USE SSALB
    USE SWRSAV
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! GENERALIZED FOR PLUG-COMPATIBILITY - ORIGINAL CODE WAS CLEANED-UP GFDL CODE. K. CAMPANA MAR 89 
! EXAMPLE FOR MRF: 
! KO3    = 0  AND O3QO3 = DUMMY ARRAY. (GFDL CLIMO O3 USED)    
! KEMIS  = 0  AND HI CLD EMIS COMPUTED HERE (CEMIS=DUMMY INPUT) 
! KALB   = 0  AND SFC ALBEDO OVER OPEN WATER COMPUTED BELOW...  
! KCCO2  = 0, CO2 OBTAINED FROM BLOCK DATA = 1, CO2 COMPUTED IN HERE - NOT AVAILABLE YET 
! SLMRF  = INTERFACE (LEVELS) SIGMA    
! SLYMRF = LAYER SIGMA UPDATED FOR YUTAI HOU SIB SW RADIATION. KAC 06 MAR 92 
!          OCEAN ALBEDO FOR BEAM SET TO BULK SFCALB, SINCE COSINE ZENITH ANGLE EFFECTS ALREADY 
!          THERE (REF:PAYNE) 
! SLMSK = 0. 
! SNOW ICE ALBEDO FOR BEAM NOT ENHANCED VIA COSINE ZENITH ANGLE EITHER CAUSE VALU ALREADY HIGH 
! (WE SEE POLAR COOLING IF WE DO BEAM CALCULATION). KAC 17 MAR 92 
! ALBEDO GE .5 UPDATED TO OBTAIN CLEAR SKY FLUXES "ON THE FLY" FOR CLOUD FORCING DIAGNOSTICS 
! ELSEWHERE KAC 07 AUG 92 
! SEE ##CLR LINES. RADFS, LWR88, FST88, SPA88 UPDATED FOR USE NEW CLD SCHEME YH  DEC 92  
! INPUT CLD MAY BE AS ORIGINAL IN 3 DOMAIN (CLD, MTOP, MBOT) OR IN A VERTICAL ARRAY OF 18 MDL 
! LAYERS (CLDARY) IEMIS = 0 USE THE ORG. 
! CLD EMIS SCHEME = 1 USE TEMP DEP. 
! CLD EMIS SCHEME UPDATED TO COMPUTE CLD LAYER REFLECTTANCE AND TRANSMITTANCE
! INPUT CLD EMISSIVITY AND OPTICAL THICKNESS 'EMIS0, TAUC0' YH FEB 93         
!--------------------------------------------------------------------------------------------------
!--------------------------------  
! INPUT FROM FROM CALLING PROGRAM 
!-------------------------------- 
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                , INTENT (IN)                   ::&
    & NCLDS
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & ALVBR   , ALNBR   , ALVDR   , ALNDR
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                , INTENT (IN)                   ::&
    & QS      , ALBEDO  , XLAT    ,  TSFC   , SLMSK   , COSZRO  , TAUDAR  
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)             , INTENT (IN)                   ::&
    & PP      , QQH2O   , TT      , O3QO3    
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)           , INTENT (IN)                   ::&
    & ITYP    , KBTM     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)           , INTENT (IN)                   ::&
    & PPI     , CAMT    , EMCLD
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)           , INTENT (IN)                   ::&
    & KTOP
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, NB, LP1)       , INTENT (INOUT)                ::&
    & RRCL    , TTCL  
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                        , INTENT (IN)                   ::&
    & SLMRF
!
    REAL   (KIND=R4KIND), DIMENSION(L)                          , INTENT (IN)                   ::&
    & SLYMRF
!-------------------------- 
! OUTPUT TO CALLING PROGRAM 
!-------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)             , INTENT (OUT)                  ::&
    & SWH     , HLW    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                , INTENT (OUT)                  ::&
    & FSWUP   , FSWUPS  , FSWDN   , FSWDNS  , FLWUP   , FLWUPS  , FLWDNS
!------------------------------------------------
! DOWNWARD SW FLUXES FOR THE SIB PARAMETERIZATION
!------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & GDFVBR  , GDFNBR  , GDFVDR  , GDFNDR
!-------------------------------------------------------
! ARRAYS NEEDED BY SWR91SIB..FOR CLEAR SKY DATA(EG.FSWL) 
!-------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & FSWL    , HSWL    , UFL     , DFL
!------------------------------------------------- 
! ARRAYS NEEDED BY CLO88, LWR88, SWR89 OR SWR91SIB 
!------------------------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & EQCMT   , PRESS   , TEMP    , FSW     , HSW     , UF      , DF
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                                      ::&
    & CLDFAC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                                             ::&
    & RH2O    , QO3     , HEATRA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & GRNFLX  , GRDFLX  , TOPFLX  , COSZEN  , TAUDA
!----------------------- 
! ADD PRESSURE INTERFACE
!----------------------- 
!-----------------------------------  
! VECTOR TEMPORARIES FOR CLOUD CALC. 
!----------------------------------- 
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & JJROW
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & DO3V    , DO3VP   , TTHAN
!-------------------------------------------------------------------------------------------------- 
! SEASONAL CLIMATOLOGIES OF O3 (OBTAINED FROM A PREVIOUSLY RUN CODE WHICH INTERPOLATES O3 TO USER 
! VERTICAL COORDINATE).
! DEFINED AS 5 DEG LAT MEANS N. P. -> S. P.
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & ALVB    , ALNB    , ALVD    , ALND    , GDFVB   , GDFNB   , GDFVD   , GDFND   , SFCALB
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & MTOPSW  , MBTMSW
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & XAMT  
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & IBEG    , KO3     , KALB    , ITIMSW  , ITIMLW  , JD
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , IR      , K       , IQ      , JX      , N     
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & R1      , GMT     
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & YEAR    , RLAG    , TPI     , PI      , SC      , SSOLAR  , DATE    ,   &
    & RANG    , TH2     , ZEN     , DZEN    , ALB01   , ALB02   , ALBD0   , ALVD1   , ALND1   ,   &
    & RRVCO2  , RRCO2    
!----------- 
! BEGIN HERE
!-----------
!
!----------------------------- 
! NOTE: XLAT IS IN DEGREE HERE
!----------------------------- 
    YEAR = 365.25
    RLAG = 14.8125
    TPI  = 6.283185308
    PI   = 3.1415927
    SC   = 2.
    SOLC = SC / (R1 * R1)
!--------------------------------------------------------------------------------------------------
! SPECIAL NOTE: THE SOLAR CONSTANT IS REDUCED EXTRA 3 PERCENT TO ACCOUNT FOR THE LACK OF AEROSOLS 
! IN THE SHORTWAVE RADIATION
!               PARAMETERIZATION. Q. ZHAO 96-7-23
!--------------------------------------------------------------------------------------------------
    SSOLAR = SOLC * HP98
    SSOLAR = SSOLAR * 0.93
    DATE   = JD + GMT / 24.0
    RANG   = TPI * (DATE - RLAG) / YEAR
    RSIN1  = SIN(RANG)
    RCOS1  = COS(RANG)
    RCOS2  = COS(2.0 * RANG)
!
    DO 40 I=MYIS,MYIE
        IR  = I + IBEG - 1
        TH2 = HP2 * XLAT(IR)
        JJROW(I) = Q19001 - TH2
        TTHAN(I) = (19 - JJROW(I)) - TH2
!--------------------------------------------------------------------------------------------------
! NOTE THAT THE NMC VARIABLES ARE IN MKS (THUS PRESSURE IS IN CENTIBARS) WHILE ALL GFDL VARIABLES 
! ARE IN CGS UNITS
!--------------------------------------------------------------------------------------------------
        SFCALB(I) = ALBEDO(IR)
!--------------------------------------------------------------------------------------- 
! NOW PUT SFC TEMP, PRESSURES, ZENITH ANGLE INTO SW COMMON BLOCK. ZHAO
! NOTE: ALL PRESSURES INPUT FROM THE ETA MODEL ARE IN PA THE UNIT FOR PRESS IS MICRO BAR
! SURFACE TEMPERATURE ARE NEGATIVE OVER OCEANS IN THE ETA MODEL. ZHAO
!--------------------------------------------------------------------------------------- 
        PRESS(I,LP1) = QS(IR) * 10.0
        TEMP (I,LP1) = ABS(TSFC(IR))
!
        COSZEN(I) = COSZRO(IR)
        TAUDA (I) = TAUDAR(IR)
 40 END DO
!--------------------------------------------------------------------------------------------------
! ALL GFDL VARIABLES HAVE K=1 AT THE TOP OF THE ATMOSPHERE. NMC ETA MODEL HAS THE SAME STRUCTURE. 
! ZHAO
!--------------------------------------------------------------------------------------------------
    DO 50 K=1,L
        DO 50 I=MYIS,MYIE
            IR = I + IBEG - 1
!---------------------------------------------
! NOW PUT TEMP,PRESSURES, INTO SW COMMON BLOCK 
!---------------------------------------------
            TEMP (I,K) =        TT(IR,K)
            PRESS(I,K) = 10.0 * PP(IR,K)
!----------------------------------------------
! STORE LYR MOISTURE AND ADD TO SW COMMON BLOCK
!----------------------------------------------
            RH2O(I,K) = QQH2O(IR,K)
!
            IF (RH2O(I,K) < H3M6) RH2O(I,K) = H3M6
 50 END DO
!
    IF (KO3 == 0) GOTO 65
!
    DO 60 K=1,L
        DO 60 I=MYIS,MYIE
            QO3(I,K) = O3QO3(I+IBEG-1,K)
 60 END DO
!
 65 CONTINUE
!
    IF (KALB > 0) GOTO 110
!------------------------------------------------------------------------------------------------
! THE FOLLOWING CODE GETS ALBEDO FROM PAYNE,1972 TABLES IF 1) OPEN SEA POINT (SLMSK=1); 2) KALB=0
!------------------------------------------------------------------------------------------------
    IQ = INT(TWENTY * HP537 + ONE)
!
    DO 105 I=MYIS,MYIE
        IF (COSZEN(I) > 0.0 .AND. SLMSK(I+IBEG-1) > 0.5) THEN
            ZEN = DEGRAD * ACOS(MAX(COSZEN(I),0.0))
!
            IF (ZEN >= H74E1)                   JX = INT(HAF    * (HNINETY - ZEN) + ONE  )
            IF (ZEN < H74E1 .AND. ZEN >= FIFTY) JX = INT(QUARTR * (H74E1   - ZEN) + HNINE)
            IF (ZEN < FIFTY)                    JX = INT(HP1    * (FIFTY   - ZEN) + H15E1)
            DZEN = -(ZEN - ZA(JX)) / DZA(JX)
!
            ALB01 = ALBD(IQ  ,JX)   + DZEN * (ALBD(IQ  ,JX+1) - ALBD(IQ  ,JX))
            ALB02 = ALBD(IQ+1,JX)   + DZEN * (ALBD(IQ+1,JX+1) - ALBD(IQ+1,JX))
!
            SFCALB(I) = ALB01 + TWENTY * (ALB02 - ALB01) * (HP537 - TRN(IQ))
        END IF
105 END DO
!
110 CONTINUE
!
    IF (KO3 > 0) GOTO 135
!----------------------------------------------------------------------------------------
! COMPUTE CLIMATOLOGICAL ZONAL MEAN OZONE, SEASONAL AND SPATIAL INTERPOLATION DONE BELOW.
!----------------------------------------------------------------------------------------
    DO 130 K=1,L
        DO 125 I=MYIS,MYIE
            DO3V (I) = DDUO3N(JJROW(I),K) + RSIN1 * DDO3N2(JJROW(I),K)     + RCOS1                &
    &                * DDO3N3(JJROW(I),K) + RCOS2 * DDO3N4(JJROW(I),K)
!
            DO3VP(I) = DDUO3N(JJROW(I)+1,K) + RSIN1 * DDO3N2(JJROW(I)+1,K) + RCOS1                &
    &                * DDO3N3(JJROW(I)+1,K) + RCOS2 * DDO3N4(JJROW(I)+1,K)
!------------------------------------------------------------------------------------------------
! NOW LATITUDINAL INTERPOLATION, AND CONVERT O3 INTO MASS MIXING RATIO(ORIGINAL DATA MPY BY 1.E4)
!------------------------------------------------------------------------------------------------
            QO3(I,K) = H1M4 * (DO3V(I) + TTHAN(I) * (DO3VP(I) - DO3V(I)))
    125 END DO
130 END DO
!
135 CONTINUE
!
    DO 195 I=MYIS,MYIE
!----------------------------------- 
! VISIBLE AND NEAR IR DIFFUSE ALBEDO
!----------------------------------- 
        ALVD(I) = SFCALB(I)
        ALND(I) = SFCALB(I)
!--------------------------------------- 
! VISIBLE AND NEAR IR DIRECT BEAM ALBEDO
!--------------------------------------- 
        ALVB(I) = SFCALB(I)
        ALNB(I) = SFCALB(I)
!--------------------------------------------------------------------------------------------------- 
! VISIBLE AND NEAR IR DIRECT BEAM ALBEDO,IF NOT OCEAN NOR SNOW FUNCTION OF COSINE SOLAR ZENITH ANGLE
!--------------------------------------------------------------------------------------------------- 
        IF (SLMSK(I+IBEG-1) < 0.5) THEN
            IF (SFCALB(I) <= 0.5) THEN
                ALBD0 = -18.0 * (0.5 - ACOS(COSZEN(I)) / PI)
                ALBD0 = EXP(ALBD0)
                ALVD1 = (ALVD(I) - 0.054313) / 0.945687
                ALND1 = (ALND(I) - 0.054313) / 0.945687
                ALVB(I) = ALVD1 + (1.0 - ALVD1) * ALBD0
                ALNB(I) = ALND1 + (1.0 - ALND1) * ALBD0
            END IF
        END IF
195 END DO
!-------------------------------- 
! SURFACE VALUES OF RRCL AND TTCL
!--------------------------------
    DO 200 N=1,2
        DO 200 I=MYIS,MYIE
            RRCL(I,N,1) = ALVD(I)
            TTCL(I,N,1) = ZERO
200 END DO
!
    DO 220 N=3,NB
        DO 220 I=MYIS,MYIE
            RRCL(I,N,1) = ALND(I)
            TTCL(I,N,1) = ZERO
220 END DO
!--------------------- 
! END OF CLOUD SECTION 
!--------------------- 
!
!--------------------------------------------------------------------------------------------------
! THE FOLLOWING CODE CONVERTS RRVCO2,THE VOLUME MIXING RATIO OF CO2 INTO RRCO2,THE MASS MIXING 
! RATIO.
!--------------------------------------------------------------------------------------------------
    RRVCO2 = RCO2
    RRCO2  = RRVCO2 * RATCO2MW
!
    250 IF (ITIMLW == 0) GOTO 300
!-------------------- 
! LONG WAVE RADIATION 
!-------------------- 
!
!-------------------------------------------
! ACCOUNT FOR REDUCED EMISSIVITY OF ANY CLDS
!-------------------------------------------
    DO 240 K=1,LP1
        DO 240 I=MYIS,MYIE
            EQCMT(I,K) = CAMT(I,K) * EMCLD(I,K)
240 END DO
!----------------------------------- 
! GET CLD FACTOR FOR LW CALCULATIONS
!----------------------------------- 
    CALL CLO89(CLDFAC, EQCMT, NCLDS, KBTM, KTOP)
!--------------------  
! LONG WAVE RADIATION
!-------------------- 
    CALL LWR88(HEATRA, GRNFLX, TOPFLX, PRESS, TEMP, RH2O, QO3, CLDFAC, EQCMT, NCLDS, KTOP, KBTM)
!
    DO 280 I=MYIS,MYIE
        IR = I + IBEG - 1
        FLWUP(IR) = TOPFLX(I) * .001E0
        GRNFLX(I) = Q14330 * (HSIGMA * TEMP(I,LP1) ** 4 - GRNFLX(I))
!----------------------------------------------------------------
! GET LW FLUX DOWN AND UP AT GROUND(WATTS/M**2) - GRNFLX=LW DOWN.
!----------------------------------------------------------------
        FLWDNS(IR) = GRNFLX(I) / (1.43306E-06 * 1000.E0)
        FLWUPS(IR) = HSIGMA * .001E0  * TEMP(I,LP1) ** 4
280 END DO
!--------------------------------- 
! CONVERT HEATING RATES TO DEG/SEC
!--------------------------------- 
    DO 290 K=1,L
        DO 290 I=MYIS,MYIE
            HLW(I+IBEG-1,K) = HEATRA(I,K) * DAYSEC
290 END DO
!
300 CONTINUE
!
    IF (ITIMSW == 0) GOTO 350
!
    CALL SWR93(FSW   , HSW   , UF    , DF    , FSWL  , HSWL  , UFL   , DFL   , PRESS  , COSZEN,   &
    &          TAUDA , RH2O  , RRCO2 , SSOLAR, QO3   , NCLDS , KTOP  , KBTM  , CAMT   , RRCL  ,   &
    &          TTCL  , ALVB  , ALNB  , ALVD  , ALND  , GDFVB , GDFNB , GDFVD , GDFND)
!----------------------------  
! GET SW FLUXES IN WATTS/M**2
!---------------------------- 
    DO 320 I=MYIS,MYIE
        IR = I + IBEG - 1
        FSWUP (IR) = UF(I,1)   * 1.E-3
        FSWDN (IR) = DF(I,1)   * 1.E-3
        FSWUPS(IR) = UF(I,LP1) * 1.E-3
!------------------------------------------------- 
! COUPLE W/M2 DIFF, IF FSWDNS(IR)=DF(I,LP1)*1.#E-3
!------------------------------------------------- 
        FSWDNS(IR) = (GDFVB(I) + GDFNB(I) + GDFVD(I) + GDFND(I)) * 1.E-3
!------------------------------------------------------------------------- 
! DOWNWARD SFC FLUX FOR THE SIB PARAMETERATION VISIBLE AND NEAR IR DIFFUSE
!------------------------------------------------------------------------- 
        GDFVDR(IR) = GDFVD(I) * 1.E-3
        GDFNDR(IR) = GDFND(I) * 1.E-3
!--------------------------------  
! VISIBLE AND NEAR IR DIRECT BEAM
!--------------------------------  
        GDFVBR(IR) = GDFVB(I) * 1.E-3
        GDFNBR(IR) = GDFNB(I) * 1.E-3
320 END DO
!--------------------------------- 
! CONVERT HEATING RATES TO DEG/SEC
!--------------------------------- 
    DO 330 K=1,L
        DO 330 I=MYIS,MYIE
            SWH(I+IBEG-1,K) = HSW(I,K) * DAYSEC
330 END DO
!
350 CONTINUE
!
    RETURN
!
    1000 FORMAT(1H ,' YOU ARE CALLING GFDL RADIATION CODE FOR',I5,' PTS','AND',I4,                &
    &               ' LYRS,WITH KDAPRX,KO3,KCZ,KEMIS,KALB = ',5I2)
!
    END SUBROUTINE RADFS

    SUBROUTINE E290(EMISSB, EMISS, AVEPHI, KLEN, FXOE2, DTE2)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE E290
!>
!> SUBPROGRAM: E290 - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> SUBROUTINE E290 COMPUTES THE EXCHANGE TERMS IN THE FLUX EQUATION FOR LONGWAVE RADIATION FOR ALL 
!> TERMS EXCEPT THE EXCHANGE WITH THE TOP OF THE ATMOSPHERE. THE METHOD IS A TABLE LOOKUP ON A PRE-
!> COMPUTED E2 FUNCTION (DEFINED IN REF. (4)).
!> CALCULATIONS ARE DONE IN THE FREQUENCY RANGE:
!> 1) 0-560, 1200-2200 CM-1   FOR Q(APPROX)
!> MOTIVATION FOR THESE CALCULATIONS IS IN REFERENCES (1) AND (4).
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> AVEPHI -
!> KLEN   - 
!> FXOE2  - 
!> DTE2   -  
!>
!> OUTPUT ARGUMENT LIST:
!> EMISSB - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> EMISS  -
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!> 
!> DRIVER     : FST88
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION                 
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS SENT TO RADFS
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION            
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
! COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE
! TABLE FOR USE IN THE LONGWAVE RADIATION PROGRAM:
! EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND  1200-2200 CM-1 INTERVALS     
! EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL       
! TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS   
! TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  =  MASS DERIVATIVE OF TABLE1
! EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS            
! SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS            
! DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
! IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88         
! KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88             
! KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & EMISSB     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & EMISS
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & AVEPHI
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & IVAL    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & DT      , FYO     , DU
!---------------------------------------- 
! TMP3 MAY BE EQUIVALENCED TO DT IN VTEMP
!---------------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & TMP3
!------------------------------- 
! VARIABLES IN THE ARGUMENT LIST
!------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & FXOE2   , DTE2
!
    EQUIVALENCE (TMP3,DT)
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & KLEN 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K     		 
!--------------------------------------------------------------------------------------------------
! FIRST WE OBTAIN THE EMISSIVITIES AS A FUNCTION OF TEMPERATURE (INDEX FXO) AND WATER AMOUNT 
! (INDEX FYO). THIS PART OF THE CODE THUS GENERATES THE E2 FUNCTION.
!
! CALCULATIONS FOR VARYING KP (FROM KP=K+1 TO LP1, INCLUDING SPECIAL CASE: RESULTS ARE IN EMISS
!--------------------------------------------------------------------------------------------------
    DO 132 K=1,LP2-KLEN
        DO 132 I=MYIS,MYIE
            TMP3(I,K) = LOG10(AVEPHI(I,KLEN+K-1)) + H16E1
            FYO (I,K) = AINT(TMP3(I,K)  * TEN)
            DU  (I,K) = TMP3(I,K) - HP1 * FYO(I,K)
            FYO (I,K) = H28E1           * FYO(I,K)
            IVAL(I,K) =  FYO(I,K) +       FXOE2(I,KLEN+K-1)
            EMISS(I,KLEN+K-1) = T1(IVAL(I,K)) + DU(I,K)                                           &
    &                         * T2(IVAL(I,K)) + DTE2(I,KLEN+K-1)                                  &
    &                         * T4(IVAL(I,K))
132 END DO
!---------------------------------------------------------------------------------------------- 
! THE SPECIAL CASE EMISS(I,L) (LAYER KP) IS OBTAINED NOW BY AVERAGING THE VALUES FOR L AND LP1:
!---------------------------------------------------------------------------------------------- 
    DO 134 I=MYIS,MYIE
        EMISS(I,L) = HAF * (EMISS(I,L) + EMISS(I,LP1))
134 END DO
!------------------------------------------------------- 
! NOTE THAT EMISS(I,LP1) IS NOT USEFUL AFTER THIS POINT.
!------------------------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
! CALCULATIONS FOR KP=KLEN AND VARYING K; RESULTS ARE IN EMISSB.
! IN THIS CASE, THE TEMPERATURE INDEX IS UNCHANGED, ALWAYS BEING FXO(I,KLEN-1); THE WATER INDEX 
! CHANGES, BUT IS SYMMETRICAL WITH THAT FOR THE VARYING KP CASE.
! NOTE THAT THE SPECIAL CASE IS NOT INVOLVED HERE. (FIXED LEVEL) K VARIES FROM (KLEN+1) TO LP1; 
! RESULTS ARE IN EMISSB(I,(KLEN) TO L)
!--------------------------------------------------------------------------------------------------
    DO 142 K=1,LP1-KLEN
        DO 142 I=MYIS,MYIE
              DT(I,K) = DTE2(I,KLEN-1)
            IVAL(I,K) = FYO(I,K) + FXOE2(I,KLEN-1)
142 END DO
!
    DO 234 K=1,LP1-KLEN
        DO 234 I=MYIS,MYIE
            EMISSB(I,KLEN+K-1) = T1(IVAL(I,K)) + DU(I,K)                                          &
    &                          * T2(IVAL(I,K)) + DT(I,K)                                          &
    &                          * T4(IVAL(I,K))
234 END DO
!
    RETURN
!
    END SUBROUTINE E290

    MODULE PVRBLS
!>--------------------------------------------------------------------------------------------------
!> MODULE PVRBLS
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              CHKOUT
!>              CUCNVC
!>              DDAMP
!>              DIGFLT
!>              EBU
!>              EPS
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDTE
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              SURFCE
!>              TURBL
!>              TWR
!>              VTADV
!>              VTADVF
!>              WRTRST
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IDIM1, IDIM2, JDIM1, JDIM2, LM
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & Z0      , USTAR   ,                                                                         &
    & UZ0     , VZ0     ,                                                                         &
    & THZ0    , QZ0     ,                                                                         &
    & THS     , QS      ,                                                                         &
    & AKMS    , AKHS    ,                                                                         &
    & RF      ,                                                                                   &
    & TWBS    , QWBS    ,                                                                         &
    & SNO     , SI      ,                                                                         &
    & CLDEFI  ,                                                                                   &
    & PREC    , ACPREC  ,                                                                         &
    & ACCLIQ  , CUPREC  ,                                                                         &
    & TH100   , Q100    ,                                                                         &
    & U100    , V100    ,                                                                         &
    & TH10    , Q10     ,                                                                         &
    & U10     , V10     ,                                                                         &
    & TSHLTR  , QSHLTR  ,                                                                         &
    & TSHLTR1 ,                                                                                   &
    & PSHLTR  ,                                                                                   &
    & XMOMFLUX,                                                                                   &
    & YMOMFLUX,                                                                                   &
    & AKM10   , AKM10V
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & Q2
!
    END MODULE PVRBLS

    SUBROUTINE UPDATE(A)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE UPDATE
!>
!> SUBROUTINE: UPDATE - EXCHANGE TWO HALO ROWS
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-06
!>
!> ABSTRACT:
!> EXCHANGE TWO HALO ROWS
!>
!> PROGRAM HISTORY LOG:
!> 00-01-06  TUCCILLO - ORIGINAL
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> A - ARRAY TO HAVE HALOS EXCHANGED
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> A - ARRAY TO HAVE HALOS EXCHANGE
!>
!> OUTPUT FILES:
!> STDOUT  - RUN TIME STANDARD OUT.
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!>
!> CALLS      : MPI_SENDRECV
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                    , INTENT(INOUT)       ::&
    & A
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & STATUS
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IERR
!
    IF (NUM_PROCS == 1) RETURN
!
    CALL MPI_SENDRECV(A(1,JEND_I-1), 2*IM                    , MPI_REAL                         , & 
    &    IUP                       , 1                       , A(1,JSTA_I-2)                    , &
    &    2*IM                      , MPI_REAL                , IDN                              , &
    &    1                         , MPI_COMM_COMP           , STATUS                           , &
    &    IERR)
!
    CALL MPI_SENDRECV(A(1,JSTA_I  ), 2*IM                    , MPI_REAL                         , &
    &    IDN                       , 1                       , A(1,JEND_I+1)                    , &
    &    2*IM                      , MPI_REAL                , IUP                              , &
    &    1                         , MPI_COMM_COMP           , STATUS                           , &
    &    IERR)
!
    END SUBROUTINE UPDATE

    SUBROUTINE OZON2D(LK, POZN, XLAT, RSIN1, RCOS1, RCOS2, QO3)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE OZON2D
!>
!> SUBROUTINE: OZON2D - COMPUTE OZONE IN MODEL COLUMNS
!> PROGRAMMER: KATZ/CAMPANA
!> ORG: W/NP22
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> OZON2D COMPUTES THE OZONE MIXING RATIO IN EACH GRID BOX OF COLUMNS WITHIN THE MODEL DOMAIN
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  KATZ/KC    - ORIGINATOR
!> 96-07-26  BLACK      - MODIFIED FOR ETA MODEL
!> 98-10-28  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LK    - NUMBER OF LAYERS IN COLUMNS
!> POZM  - ?????
!> XLAT  - GEODETIC LATITUDE OF GRID COLUMNS IN DEGREES
!> RSIN1 - INFORMATION RELATING TO POSITION OF EARTH IN ITS ORBIT
!> RCOS1 - INFORMATION RELATING TO POSITION OF EARTH IN ITS ORBIT
!> RCOS2 - INFORMATION RELATING TO POSITION OF EARTH IN ITS ORBIT
!>
!> OUTPUT ARGUMENT LIST:
!> QO3   - OZONE MIXING RATIO AT MIDLAYERS OF MODEL COLUMNS
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              SEASO3
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : RADTN
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE SEASO3
    USE TEMPCOM
    USE TOPO
! 
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND), PARAMETER :: NLP1  = NL + 1
!
    REAL   (KIND=R4KIND), PARAMETER :: RTD   = 57.2957795
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LK)                      , INTENT(INOUT)       ::&
    & QO3     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LK)                      , INTENT(IN)          ::&
    & POZN                 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & XLAT   
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & TTHAN
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, NL)                                            ::&
    & QO3O3 
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & JJROW 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & RSIN1   , RCOS1   , RCOS2
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TH2     , DO3V    , DO3VP   , APLO    , APHI
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LK
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K       , NUMITR  , ILOG    , NHALF   , IT  
!
    DO I=MYIS,MYIE
        TH2      = 0.2 * XLAT(I)
        JJROW(I) = 19.001 - TH2
        TTHAN(I) = (19 - JJROW(I)) - TH2
    END DO
!----------------------------------------------- 
! SEASONAL AND SPATIAL INTERPOLATION DONE BELOW.
!----------------------------------------------- 
    DO K=1,NL
        DO I=MYIS,MYIE
            DO3V  = XDUO3N(JJROW(I)  ,K) + RSIN1 * XDO3N2(JJROW(I)  ,K)                           &
    &             +                        RCOS1 * XDO3N3(JJROW(I)  ,K)                           &
    &             +                        RCOS2 * XDO3N4(JJROW(I)  ,K)
!
            DO3VP = XDUO3N(JJROW(I)+1,K) + RSIN1 * XDO3N2(JJROW(I)+1,K)                           &
    &             +                        RCOS1 * XDO3N3(JJROW(I)+1,K)                           &
    &             +                        RCOS2 * XDO3N4(JJROW(I)+1,K)
!--------------------------------------------------------------------------------------------        
! NOW LATITUDINAL INTERPOLATION AND CONVERT O3 INTO MASS MIXING RATIO (ORIG DATA MPY BY 1.E4)
!--------------------------------------------------------------------------------------------         
            QO3O3(I,K) = 1.E-4 * (DO3V + TTHAN(I) * (DO3VP - DO3V))
        END DO
    END DO
!----------------------------------------------------------- 
! VERTICAL INTERPOLATION FOR EACH GRIDPOINT (LINEAR IN LN P)
!----------------------------------------------------------- 
    NUMITR = 0
    ILOG   = NL
 20 CONTINUE
    ILOG = (ILOG + 1) / 2
!
    IF (ILOG == 1) GOTO 25
    NUMITR = NUMITR + 1
    GOTO 20
 25 CONTINUE
!
    DO 60 K=1,LK
!    
        NHALF = (NL + 1) / 2
!
        DO I=MYIS,MYIE
            JJROW(I) = NHALF
        END DO
!    
        DO 40 IT=1,NUMITR
            NHALF = (NHALF + 1) / 2
            DO I=MYIS,MYIE
                IF (POZN(I,K) < PRGFDL(JJROW(I)-1)) THEN
                    JJROW(I) = JJROW(I) - NHALF
                ELSE IF(POZN(I,K) >= PRGFDL(JJROW(I))) THEN
                    JJROW(I) = JJROW(I) + NHALF
                END IF
!
                JJROW(I) = MIN(JJROW(I), NL)
                JJROW(I) = MAX(JJROW(I), 2 )
            END DO
     40 END DO
!    
        DO 50 I=MYIS,MYIE
            IF (POZN(I,K) < PRGFDL(1)) THEN
                QO3(I,K) = QO3O3(I,1 )
            ELSE IF(POZN(I,K) > PRGFDL(NL)) THEN
                QO3(I,K) = QO3O3(I,NL)
            ELSE
                APLO = ALOG(PRGFDL(JJROW(I)-1))
                APHI = ALOG(PRGFDL(JJROW(I)  ))
!
                QO3(I,K) =  QO3O3(I,JJROW(I)       )                                              &
    &                    + (ALOG(POZN(I,K))  - APHI)                                              &
    &                    /       (APLO       - APHI)                                              &
    &                    * (QO3O3(I,JJROW(I) -   1 ) - QO3O3(I,JJROW(I)       ))
            END IF
     50 END DO
!    
 60 END DO
!
    RETURN
!
    END SUBROUTINE OZON2D

    SUBROUTINE DIVHOAST
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE DIVHOAST
!>
!> SUBPROGRAM: DIVHOA - DIVERGENCE / HORIZONTAL OMEGA-ALPHA
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-10-28
!>
!> ABSTRACT:
!> DIVHOA COMPUTES THE DIVERGENCE INCLUDING THE MODIFICATION PREVENTING GRAVITY WAVE GRID SEPARATION
!> AND CALCULATES THE HORIZONTAL PART OF THE OMEGA-ALPHA TERM (THE PART PROPORTIONAL TO THE 
!> ADVECTION OF MASS ALONG ETA / SIGMA SURFACES).
!>
!> MODIFIED TO INCLUDE DIVERGENCE RESULTING FROM SLOPING STEPS ("S": DIVHOAST)
!> EXPANDED TO ALSO SLANTWISE T ADVECTION ("T": DIVHOAST), ALONG WITH APPROPRIATE OMEGA-ALPHA
!> CHANGES TO THE ADVECTED T.
!>
!> WARNING: THIS MAKES SUBROUTINE SLADVT REDUNDANT (NEEDS TO BE COMENTED OUT OR REMOVED).
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC             - ORIGINATOR
!> 95-03-25  BLACK              - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-29  BLACK              - ADDED EXTERNAL EDGE
!> 97-03-17  MESINGER           - SPLIT FROM PFDHT
!> 98-10-30  BLACK              - MODIFIED FOR DISTRIBUTED MEMORY
!> 00-10-20  BLACK              - INCORPORATED PRESSURE GRADIENT METHOD FROM MESO MODEL
!> 06-04-04  MESINGER AND JOVIC - ADDED DIVERGENCE CALCULATION DUE TO SLOPES
!> 06-05-??  MESINGER, AT CPTEC - EXPANDED TO INCLUDE SLANTWISE T ADV.
!> 06-06-??  MESINGER AND JOVIC - REVISED OMEGA-ALPHA DUE TO SLOPES
!> 18-01-15  LUCCI              - MODERNIZATION OF THE CODE, INCLUDING:
!>                                * F77 TO F90/F95
!>                                * INDENTATION & UNIFORMIZATION CODE
!>                                * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                                * DOCUMENTATION WITH DOXYGEN
!>                                * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              SLOPES
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>  
!> DRIVER     : EBU  
!>
!> CALLS      : ZERO2               
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE SLOPES
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: RFCP = 1.E0 / (4.E0 * 1004.6E0) 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM+1)                             ::&
    & PINTLG

    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    &  FIM    ,                                                                                   &
    &  FILO   , RDPD    ,                                                                         &
    &  ADPDX  , RDPDX   ,                                                                         &
    &  ADPDY  , RDPDY   ,                                                                         &
    &  ADPDNE , ADPDSE  ,                                                                         &
    &  PEW    , PNS     ,                                                                         &
    &  PCEW   , PCNS    ,                                                                         &
    &  DPFEW  , DPFNS   ,                                                                         &
    &  FNS    , TNS     ,                                                                         &
    &  HM     , VM      ,                                                                         &
    &  EDIV   , DIVL  
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    &   DPDE  ,                                                                                   &
    &   APEL  , PCXC    ,                                                                         &
    &   ALP1  ,                                                                                   &
    &   DFDZ  ,                                                                                   &
    &   UDY   , VDX     ,                                                                         &
    &   TEW   , FEW     ,                                                                         &
    &   TNE   , TSE     ,                                                                         &
    &   FNE   , FSE     ,                                                                         &
    &   PNE   , PSE     ,                                                                         &
    &   CNE   , CSE     ,                                                                         &
    &   PPNE  , PPSE    ,                                                                         &
    &   PCNE  , PCSE    ,                                                                         &
    &   DIVS  , DPDEP1  ,                                                                         &
    &   ATC   , ATCP1 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ALP1P   , ALP1X   , DFI     , RDPDS   , FIUPK   , ALP1PL  , ALP2P   , ALP2PL  , DPNEK   ,   &
    & DPSEK   , DCNEK   , DCSEK   , PVNEK   , PVSEK   , TOASL   , OAADP1  , TFSTR   , FSTR    ,   &
    & STSEP1  , STNE    , STSE    , STNEM1  , STEW    , STNS    , WDEP    , DPT     , WDUTD   ,   &
    & WARR
!
    CALL ZERO2(ALP1)
    CALL ZERO2(DPDE)
    CALL ZERO2(APEL)
    CALL ZERO2(PCXC)
    CALL ZERO2(DFDZ)
    CALL ZERO2(UDY)
    CALL ZERO2(VDX)
    CALL ZERO2(TEW)
    CALL ZERO2(FEW)
    CALL ZERO2(TNE)
    CALL ZERO2(TSE)
    CALL ZERO2(FNE)
    CALL ZERO2(FSE)
    CALL ZERO2(PNE)
    CALL ZERO2(PSE)
    CALL ZERO2(CNE)
    CALL ZERO2(CSE)
    CALL ZERO2(PPNE)
    CALL ZERO2(PPSE)
    CALL ZERO2(PCNE)
    CALL ZERO2(PCSE)
!------------------------- 
! PREPARATORY CALCULATIONS 
!------------------------- 
    IF (SIGMA) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 50 J=MYJS_P5,MYJE_P5
            DO 50 I=MYIS_P5,MYIE_P5
                FILO(I,J) = FIS(I,J)
                PDSL(I,J) =  PD(I,J)
     50 END DO
!
    ELSE
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO 100 J=MYJS_P5,MYJE_P5
            DO 100 I=MYIS_P5,MYIE_P5
                FILO(I,J) = 0.0
                PDSL(I,J) = RES(I,J) * PD(I,J)
    100 END DO
!
    END IF
!
    IF (HYDRO) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    PINTLG(I,J,K) = ALOG(ETA(K) * PDSL(I,J) + PT)
                END DO
            END DO
        END DO
!
    ELSE
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO K=1,LM+1
            DO J=MYJS_P5,MYJE_P5
                DO I=MYIS_P5,MYIE_P5
                    PINTLG(I,J,K) = ALOG(PINT(I,J,K))
                END DO
            END DO
        END DO
!
    END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO K=1,LM
        DO J=MYJS_P4,MYJE_P4
            DO I=MYIS_P4,MYIE_P4
                OMGALF(I,J,K) = 0.
                   DIV(I,J,K) = 0.
            END DO
        END DO
    END DO
!
    DO J=MYJS_P4,MYJE_P4
        DO I=MYIS_P4,MYIE_P4
            DIVS(I,J) = 0.
!--------------------------------------------------------------------------------------------------
! DIVERGENCE TO SAVE IS NEEDED TO COLLECT CONTRIBUTIONS TO DIV DUE TO SLOPES AT H POINTS OF THE 
! LAYER BEING PROCESSED (L).
! THEY CAN BE ADDED ONLY ONCE THE CODE MOVES ONE LAYER UP.
! THE REASON IS THAT THE COLLECTION IS DONE FOR POINTS ALSO SIDEWAYS OF THE H POINT THAT THE CODE
! IS PROCESSING, SO THAT IF ADDED IMMEDIATELLY THESE WOULD BE LOST WHEN THE CODE VISITS THESE 
! SIDEWAYS LOCATED POINTS, AND PUTS THE DIVERGENCE "CORRECTION"INTO DIV (LOOP 270)
!
! ACCUMULATED T CHANGES AT L AND AT L+1
!--------------------------------------------------------------------------------------------------
              ATC(I,J) = 0.0
            ATCP1(I,J) = 0.0
        END DO
    END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1X)
!
    DO J=MYJS_P5,MYJE_P5
        DO I=MYIS_P5,MYIE_P5
            ALP1X     = PINTLG(I,J,LM+1)
            ALP1(I,J) = ALP1X
        END DO
    END DO
!------------------------------- 
! MAIN VERTICAL INTEGRATION LOOP  
!------------------------------- 
    DO 400 K=LM,1,-1
!--------------------------- 
! INTEGRATE THE GEOPOTENTIAL
!--------------------------- 
        FIM = 0.  
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1P  , DFI     , FIUPK   , RDPDS)
!
        DO 125 J=MYJS_P5,MYJE_P5
            DO 125 I=MYIS_P5,MYIE_P5
!            
                ALP1P = PINTLG(I,J,K)
!            
                DFI = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1(I,J) - ALP1P) / DWDT(I,J,K)
!           
                RDPDS       = 1. / (DETA(K) * PDSL(I,J))
                RTOP(I,J,K) = RDPDS * DFI
                FIUPK       = FILO(I,J) + DFI
                 FIM(I,J)   = FILO(I,J) + FIUPK
                IF (ABS(FIM(I,J)) <= 5.E+10) THEN
!
                ELSE
!
                    WRITE(6,*) 'BAD FIM ', MYPE,I, J, K, LMH(I,J),FIM(I,J), FILO(I,J), DFI
                    WRITE(6,*) 'Q,T,ALP1,ALP1P,DWDT: ',   Q(I,J,K), T(I,J,K), ALP1(I,J), ALP1P,   &
    &                                                  DWDT(I,J,K)
                    STOP
!
                END IF
!            
                FILO(I,J) = (FIUPK - DFL(K)) * HTM(I,J,K) + DFL(K)
                ALP1(I,J) = ALP1P
    125 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ALP1P  , ALP1PL  , ALP2P   , ALP2PL  , DFI)
!
        DO 205 J=MYJS_P5,MYJE_P5
            DO 205 I=MYIS_P5,MYIE_P5
                HM(I,J) = HTM(I,J,K) * HBM2(I,J)
                VM(I,J) = VTM(I,J,K) * VBM2(I,J)
!            
                ALP1P  = PINTLG(I,J,K)
                ALP1PL = PINTLG(I,J,K+1)
                ALP2P  = ALP1P  * ALP1P
                ALP2PL = ALP1PL * ALP1PL
!            
                DFI       = (Q(I,J,K) * 0.608 + 1.) * T(I,J,K) * R * (ALP1PL-ALP1P) / DWDT(I,J,K)
                DFDZ(I,J) = DFI * DWDT(I,J,K) / (ALP2PL - ALP2P)
                APEL(I,J) = (ALP2PL + ALP2P) * 0.5
    205 END DO
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO 210 J=MYJS_P4,MYJE_P4
            DO 210 I=MYIS_P4,MYIE_P4
                DPDE(I,J) = DETA(K) * PDSL(I,J)
                DIVL(I,J) = 0.
                EDIV(I,J) = 0.
    210 END DO
!    
        IF (K < LM) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
            DO 211 J=MYJS_P4,MYJE_P4
                DO 211 I=MYIS_P4,MYIE_P4
                    DPDEP1(I,J) = DETA(K+1) * PDSL(I,J)
        211 END DO
!
        END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 215 J=MYJS_P1,MYJE_P1
            DO 215 I=MYIS_P1,MYIE_P1
                RDPD(I,J) = 1. / DPDE(I,J)
    215 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 220 J=MYJS1_P3,MYJE1_P3
            DO 220 I=MYIS_P3,MYIE_P3
                ADPDX(I,J) = DPDE(I+IVW(J),J  ) + DPDE(I+IVE(J),J  )
                ADPDY(I,J) = DPDE(I       ,J-1) + DPDE(I       ,J+1)
                RDPDX(I,J) = 1. / ADPDX(I,J)
                RDPDY(I,J) = 1. / ADPDY(I,J)
    220 END DO
!--------------------------------------------------   
! DIAGONAL CONTRIBUTIONS TO PRESSURE GRADIENT FORCE 
!--------------------------------------------------    
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 240 J=MYJS_P4,MYJE_P4
            DO 240 I=MYIS_P4,MYIE_P4
                ADPDNE(I,J) =  DPDE(I+IHE(J),J+1)   + DPDE(I,J)
                   PNE(I,J) =  (FIM(I+IHE(J),J+1)   -  FIM(I,J))                                  &
    &                       * (DWDT(I+IHE(J),J+1,K) + DWDT(I,J,K))
!
                IF (ABS(PNE(I,J)) <= 5.E10) THEN
                ELSE
                    WRITE(6,*) 'CRAZY PNE ', I, J, PNE(I,J)
                    WRITE(6,*) 'PIECES', I+IHE(J), J+1, FIM(I+IHE(J),J+1)
                END IF
!
                PPNE(I,J) = PNE(I,J) * ADPDNE(I,J)
                 CNE(I,J) =      (DFDZ(I+IHE(J),J+1) + DFDZ(I,J))                                 &
    &                     * 2. * (APEL(I+IHE(J),J+1) - APEL(I,J))
                PCNE(I,J) = CNE(I,J) * ADPDNE(I,J)
    240 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 250 J=MYJS1_P4,MYJE_P4
            DO 250 I=MYIS_P4,MYIE1_P4
                ADPDSE(I,J) =  DPDE(I+IHE(J),J-1)   + DPDE(I,J)
                   PSE(I,J) =  (FIM(I+IHE(J),J-1)   -  FIM(I,J))                                  &
    &                       * (DWDT(I+IHE(J),J-1,K) + DWDT(I,J,K))
!
                  PPSE(I,J) = PSE(I,J) * ADPDSE(I,J)
                   CSE(I,J) =      (DFDZ(I+IHE(J),J-1) + DFDZ(I,J))                               &
    &                       * 2. * (APEL(I+IHE(J),J-1) - APEL(I,J))
                  PCSE(I,J) = CSE(I,J) * ADPDSE(I,J)
    250 END DO
!---------------------------------    
! CONTINUITY EQUATION MODIFICATION
!-------------------------------
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO 260 J=MYJS1_P1,MYJE1_P1
            DO 260 I=MYIS_P1,MYIE_P1
                PCXC(I,J) = VBM3(I,J) * VTM(I,J,K)                                                &
    &                     * (PNE(I+IVW(J),J) + CNE(I+IVW(J),J  ) +  PSE(I+IVW(J),J  )             &
    &                     +  CSE(I+IVW(J),J) - PNE(I       ,J-1) -  CNE(I       ,J-1)             &
    &                     -                    PSE(I       ,J+1) -  CSE(I       ,J+1))
    260 END DO
!
        DO 270 J=MYJS2,MYJE2
            DO 270 I=MYIS1,MYIE1
                DIV(I,J,K) = DETA(K) * WPDAR(I,J) * (PCXC(I+IHE(J),J) - PCXC(I,J+1)               &
    &                      +                         PCXC(I+IHW(J),J) - PCXC(I,J-1))
    270 END DO
!---------------------------------------    
! LAT AND LONG PRESSURE FORCE COMPONENTS
!---------------------------------------
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (DCNEK  , DCSEK   , DPNEK   , DPSEK)
!
        DO 280 J=MYJS1_P3,MYJE1_P3
            DO 280 I=MYIS_P3,MYIE_P3
                DPNEK     = PNE(I+IVW(J),J) +   PNE(I,J-1)
                DPSEK     = PSE(I+IVW(J),J) +   PSE(I,J+1)
                PEW(I,J)  = DPNEK + DPSEK
                PNS(I,J)  = DPNEK - DPSEK
                DCNEK     = CNE(I+IVW(J),J) +   CNE(I,J-1)
                DCSEK     = CSE(I+IVW(J),J) +   CSE(I,J+1)
                PCEW(I,J) = (DCNEK + DCSEK) * ADPDX(I,J)
                PCNS(I,J) = (DCNEK - DCSEK) * ADPDY(I,J)
    280 END DO
!-----------------------------------------------    
! LAT AND  LON FLUXES AND OMEGA-ALPHA COMPONENTS
!-----------------------------------------------
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 310 J=MYJS1_P3,MYJE1_P3
            DO 310 I=MYIS_P3,MYIE_P3
                UDY(I,J) = DY       *     U(I,J,K)
                FEW(I,J) = UDY(I,J) * ADPDX(I,J)
                TEW(I,J) = UDY(I,J) *  PCEW(I,J)
                VDX(I,J) =  DX(I,J) *     V(I,J,K)
                FNS(I,J) = VDX(I,J) * ADPDY(I,J)
                TNS(I,J) = VDX(I,J) *  PCNS(I,J)
    310 END DO
!---------------------------------------------    
! DIAGONAL FLUXES AND DIAGONALLY AVERAGED WIND 
!---------------------------------------------    
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (PVNEK)
!
        DO 320 J=MYJS1_P2,MYJE2_P2
            DO 320 I=MYIS_P2,MYIE1_P2
                PVNEK    = (UDY(I+IHE(J),J) + VDX(I+IHE(J),J)) + (UDY(I,J+1) + VDX(I,J+1))
                FNE(I,J) = PVNEK * ADPDNE(I,J)
                TNE(I,J) = PVNEK *   PCNE(I,J) * 2.
    320 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (PVSEK)
!
        DO 330 J=MYJS2_P2,MYJE1_P2
            DO 330 I=MYIS_P2,MYIE1_P2
                PVSEK    = (UDY(I+IHE(J),J) - VDX(I+IHE(J),J)) + (UDY(I,J-1) - VDX(I,J-1))
                FSE(I,J) = PVSEK * ADPDSE(I,J)
                TSE(I,J) = PVSEK *   PCSE(I,J) * 2.
    330 END DO
!
        IF (K < LM-1) THEN
            DO 335 J=MYJS2_P2,MYJE2_P2
                DO 335 I=MYIS1_P2,MYIE1_P2
                      DIV(I,J,K+1) = DIV(I,J,K+1) +  DIVS(I,J)
                     DIVS(I,J)     = 0.0
                        T(I,J,K+2) =   T(I,J,K+2) + ATCP1(I,J)
                    ATCP1(I,J)     = ATC(I,J)
                      ATC(I,J)     = 0.0
        335 END DO
        END IF
!-----------------------------------------------    
! HORIZONTAL PART OF OMEGA-ALPHA AND DIVERGENCE 
!-----------------------------------------------
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 340 J=MYJS2_P1,MYJE2_P1
            DO 340 I=MYIS1_P1,MYIE1_P1
                OMGALF(I,J,K) = (TEW(I+IHE(J),J  ) + TEW(I+IHW(J),J  )                            &
    &                         +  TNS(I       ,J+1) + TNS(I       ,J-1)                            &
    &                         +  TNE(I       ,J  ) + TNE(I+IHW(J),J-1)                            &
    &                         +  TSE(I       ,J  ) + TSE(I+IHW(J),J+1))                           & 
    &                         * RDPD(I,J) * FCP(I,J) * HM(I,J)
!
                IF (K < 3) THEN
                      T(I,J,K) = OMGALF(I,J,K) +      T(I,J,K)
                ELSE IF (K < LM) THEN
                    ATC(I,J)   =    ATC(I,J)   + OMGALF(I,J,K)
                END IF
!            
                IF (K < LM) THEN 
                   IF (HTM(I,J,K+1) * HBM2(I,J) > 0) THEN
!--------------------------------------------------------------------------------------------------
! THE T POINT BELOW IS IN THE ATMOSPHERE. SHOULD IT RECEIVE OMEGA-ALPHA CONTRIBUTIONS FROM FLUXES 
! OF LAYER L ?
!
! CHECK EACH OF THE FOUR SURROUNDING V POINTS IF THEY ARE THE POINTS JUST ABOVE THE SLOPE
!--------------------------------------------------------------------------------------------------
                    TOASL = 0.0
!
                    IF (VTMS(I+IHE(J),J,K+1) == 1) THEN
                        IF (ISLD(I+IHE(J),J) == 1)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHE(J),J)
!
                        IF (ISLD(I+IHE(J),J) == 8)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHE(J),J) + 0.25 * TSE(I,J)
!
                        IF (ISLD(I+IHE(J),J) == 2)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHE(J),J) + 0.25 * TNE(I,J)
                    END IF
!
                    IF (VTMS(I,J+1,K+1) == 1) THEN
                        IF (ISLD(I,J+1) == 3)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J+1)
!
                        IF (ISLD(I,J+1) == 2)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J+1) + 0.25 * TNE(I       ,J  )
!
                        IF (ISLD(I,J+1) == 4)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J+1) + 0.25 * TSE(I+IHW(J),J+1)
                    END IF
!
                    IF (VTMS(I+IHW(J),J,K+1) == 1) THEN
                        IF (ISLD(I+IHW(J),J) == 5)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHW(J),J)
!
                        IF (ISLD(I+IHW(J),J) == 4)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHW(J),J) + 0.25 * TSE(I+IHW(J),J+1)
                        IF (ISLD(I+IHW(J),J) == 6)                                                &
    &                       TOASL = TOASL + 0.50 * TEW(I+IHW(J),J) + 0.25 * TNE(I+IHW(J),J-1)
                    END IF
!
                    IF (VTMS(I,J-1,K+1) == 1) THEN
                        IF (ISLD(I,J-1) == 7)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J-1)
!
                        IF (ISLD(I,J-1) == 6)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J-1) + 0.25 * TNE(I+IHW(J),J-1)
!
                        IF (ISLD(I,J-1) == 8)                                                     &
    &                       TOASL = TOASL + 0.50 * TNS(I,J-1) + 0.25 * TSE(I       ,J  )
                    END IF
!
                    OAADP1          = TOASL * DETA(K+1) / DETA(K) * RDPD(I,J) * FCP(I,J)
                    OMGALF(I,J,K+1) = OMGALF(I,J,K+1) + OAADP1
!
                    IF (K < 3) THEN
                            T(I,J,K+1) =     T(I,J,K+1) + OAADP1
                    ELSE IF (K == LM-1) THEN
                        ATCP1(I,J)     = ATCP1(I,J)     + OMGALF(I,J,K+1)
                    ELSE
                        ATCP1(I,J)     = ATCP1(I,J)     + OAADP1
                    END IF
!                
                END IF
                END IF
!            
                EDIV(I,J) = ((FEW(I+IHE(J),J) + FNS(I,J+1) + FNE(I,J)                             &
    &                     +                                  FSE(I,J))                            &
    &                     -  (FEW(I+IHW(J),J) + FNS(I,J-1) + FNE(I+IHW(J),J-1)                    &
    &                     +                                  FSE(I+IHW(J),J+1)))                  &
    &                     *   FDIV(I,J)
!
                DIVL(I,J) =   EDIV(I,J) * HBM2(I,J)
!--------------------------------------------------------------------------------------------------
! SLANTWISE MASS AND T ADVECTION, WITH T INCREMENT TO ACCOUNT FOR THE OMEGA-ALPHA IMPACT, T CHANGE 
! DUE TO MOVEMENT TO A DIFFERENT P
!--------------------------------------------------------------------------------------------------
                IF (K < LM ) THEN
                IF (K == LMV(I+IHE(J),J) .AND. ISLD(I+IHE(J),J) > 0) THEN
!
                    TFSTR = 0.5 * DETA(K+1) / DETA(K) * FDIV(I,J) * HM(I,J)
                    FSTR  = 0.5 * TFSTR
!
                    STSEP1 = FSTR  * FSE(I+IHE(J),J+1)
                    STNE   = FSTR  * FNE(I       ,J  )
                    STSE   = FSTR  * FSE(I       ,J  )
                    STNEM1 = FSTR  * FNE(I+IHE(J),J-1)
                    STEW   = TFSTR * FEW(I+IHE(J),J  )
                    STNS   = TFSTR * FNS(I+IHE(J),J  )
!
                    IF  (ISLD(I+IHE(J),J) == 1) THEN
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) + STSEP1
                        DIVS(I+1,J)            = DIVS(I+1,J)            - STSEP1
!
                        WDEP = ABS(STSEP1) * DT
!
                        DPT =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I+1,J,K))                          &
    &                       * (DPDEP1(I+IHE(J),J+1)     + DPDE(I+1,J))                            &
    &                       *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STSEP1) * (T(I+IHE(J),J+1,K+1) - DPT              &
    &                         -                            T(I+1,J,K))
!
                        IF ( STSEP1 > 0.0) THEN
                            WARR = DPDE(I+1,J)
                            ATC(I+1,J)          = ATC(I+1,J)          + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) = ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) + STNEM1
                        DIVS(I+1,J)            = DIVS(I+1,J)            - STNEM1
!
                        WDEP  = ABS(STNEM1) * DT
                        DPT   =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I+1,J,K))                        &
    &                         * (DPDEP1(I+IHE(J),J-1)     + DPDE(I+1,J))                          &
    &                         *  RFCP
                        WDUTD = WDEP * SIGN(1.0,STNEM1) * (T(I+IHE(J),J-1,K+1) - DPT              &
    &                         -                            T(I+1,J,K))
!
                        IF (STNEM1 > 0.0) THEN
                            WARR                = DPDE(I+1,J)
                            ATC(I+1,J)          =  ATC(I+1,J)          + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I,J,K+1) =  DIV(I,J,K+1) + STEW !BLUE
                        DIVS(I+1,J)   = DIVS(I+1,J)   - STEW !BLUE
!
                        WDEP  = ABS(STEW) * DT
                        DPT   =   (RTOP(I,J,K+1) + RTOP(I+1,J,K))                                 & 
    &                         * (DPDEP1(I,J)     + DPDE(I+1,J))                                   &
    &                         *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STEW) * (T(I,J,K+1) - DPT                         &
    &                         -                          T(I+1,J,K))
!
                        IF (STEW > 0.0) THEN
                            WARR         = DPDE(I+1,J)
                              ATC(I+1,J) =  ATC(I+1,J) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR         = DPDEP1(I,J)
                            ATCP1(I  ,J) =  ATCP1(I,J) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 2) THEN
                         DIV(I,J,K+1)      =   DIV(I,J,K+1)      + STNE
                        DIVS(I+IHE(J),J+1) =  DIVS(I+IHE(J),J+1) - STNE
!
                        WDEP = ABS(STNE) * DT
                        DPT  =   (RTOP(I,J,K+1) + RTOP(I+IHE(J),J+1,K))                           &
    &                        * (DPDEP1(I,J)     + DPDE(I+IHE(J),J+1))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNE) * (T(I,J,K+1) - DPT                         &
    &                         -                          T(I+IHE(J),J+1,K))
!
                        IF (STNE > 0.0) THEN
                            WARR              = DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1) =  ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I,J) 
                            ATCP1(I,J)        =  ATCP1(I,J)        + WDUTD / (WARR+WDEP)
                        END IF
!                       		   
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) + STNEM1
                        DIVS(I+1,J)            = DIVS(I+1,J)            - STNEM1
!
                        WDEP = ABS(STNEM1) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I+1,J,K))                         &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I+1,J))                           &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNEM1) * (T(I+IHE(J),J-1,K+1) - DPT              &
    &                         -                            T(I+1,J,K))
!
                        IF (STNEM1 > 0.0) THEN
                            WARR                = DPDE(I+1,J)
                            ATC(I+1,J)          =  ATC(I+1,J)          + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I,J,K+1)   =  DIV(I,J,K+1)   + STEW !BLUE         
                        DIVS(I+1,J)     = DIVS(I+1,J)     - STEW !BLUE
!
                        WDEP = ABS(STEW) * DT
                        DPT  =   (RTOP(I,J,K+1) + RTOP(I+1,J,K))                                  &
    &                        * (DPDEP1(I,J)     + DPDE(I+1,J))                                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STEW) * (T(I,J,K+1) - DPT                         &
    &                         -                          T(I+1,J,K))
!
                        IF (STEW > 0.0) THEN
                            WARR       = DPDE(I+1,J)
                            ATC(I+1,J) =  ATC(I+1,J) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR       = DPDEP1(I,J)
                            ATCP1(I,J) =  ATCP1(I,J) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) + STNS !YELLOW
                        DIVS(I+IHE(J),J+1)     = DIVS(I+IHE(J),J+1)     - STNS !YELLOW
!
                        WDEP = ABS(STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I+IHE(J),J+1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I+IHE(J),J+1))                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNS) * (T(I+IHE(J),J-1,K+1) - DPT                &
    &                         -                          T(I+IHE(J),J+1,K))
!
                        IF (STNS > 0.0) THEN
                            WARR                =   DPDE(I+IHE(J),J+1)
                              ATC(I+IHE(J),J+1) =    ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 3) THEN
                         DIV(I+1,J,K+1)    =  DIV(I+1,J,K+1)    - STSEP1
                        DIVS(I+IHE(J),J+1) = DIVS(I+IHE(J),J+1) + STSEP1
!
                        WDEP = ABS(-STSEP1) * DT
                        DPT  =   (RTOP(I+1,J,K+1) + RTOP(I+IHE(J),J+1,K))                         &
    &                        * (DPDEP1(I+1,J)     + DPDE(I+IHE(J),J+1))                           &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STSEP1) * (T(I+1,J,K+1)       - DPT              &
    &                         -                             T(I+IHE(J),J+1,K))
!
                        IF (-STSEP1 > 0.0) THEN
                            WARR              =   DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1) =    ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I+1,J)
                            ATCP1(I+1,J)      =  ATCP1(I+1,J)        + WDUTD / (WARR+WDEP)
                        END IF
!                        		   
                        DIV(I,J,K+1)       = DIV(I,J,K+1)       + STNE
                        DIVS(I+IHE(J),J+1) = DIVS(I+IHE(J),J+1) - STNE
!
                        WDEP = ABS(STNE) * DT
                        DPT  = (RTOP(I,J,K+1) + RTOP(I+IHE(J),J+1,K))                             &
    &                        * (DPDEP1(I,J)   + DPDE(I+IHE(J),J+1))                               &
    &                        * RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNE) * (T(I,J,K+1)       - DPT                   &
    &                         -                        T(I+IHE(J),J+1,K))
!
                        IF (STNE > 0.0) THEN
                            WARR              = DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1) =  ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I,J)
                            ATCP1(I,J)        =  ATCP1(I,J)        + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) + STNS !YELLOW
                        DIVS(I+IHE(J),J+1)     = DIVS(I+IHE(J),J+1)     - STNS !YELLOW
!
                        WDEP = ABS(STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I+IHE(J),J+1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I+IHE(J),J+1))                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNS) * (T(I+IHE(J),J-1,K+1) - DPT                &
    &                         -                          T(I+IHE(J),J+1,K))
!
                        IF (STNS > 0.0) THEN
                            WARR                =   DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1)   =    ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 4) THEN
                         DIV(I+1,J,K+1)    =  DIV(I+1,J,K+1)    - STSEP1
                        DIVS(I+IHE(J),J+1) = DIVS(I+IHE(J),J+1) + STSEP1
!
                        WDEP = ABS(-STSEP1) * DT
                        DPT  =   (RTOP(I+1,J,K+1) + RTOP(I+IHE(J),J+1,K))                         &
    &                        * (DPDEP1(I+1,J)     + DPDE(I+IHE(J),J+1))                           &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STSEP1) * (T(I+1,J,K+1)       - DPT              &
    &                         -                             T(I+IHE(J),J+1,K))
                        IF (-STSEP1 > 0.0) THEN
                            WARR              =   DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1) =    ATC(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I+1,J)
                            ATCP1(I+1,J)      =  ATCP1(I+1,J)        + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) - STSE
                        DIVS(I,J)              = DIVS(I,J)              + STSE
                        WDEP = ABS(-STSE) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I,J,K))                           &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I,J))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STSE) * (T(I+IHE(J),J-1,K+1) - DPT               &
    &                         -                           T(I,J,K))
!
                        IF (-STSE > 0.0) THEN
                            WARR                = DPDE(I,J)
                            ATC(I,J)            =  ATC(I,J)            + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                        DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) + STNS !YELLOW
                        DIVS(I+IHE(J),J+1)    = DIVS(I+IHE(J),J+1)     - STNS !YELLOW
!
                        WDEP = ABS(STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I+IHE(J),J+1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I+IHE(J),J+1))                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STNS) * (T(I+IHE(J),J-1,K+1) - DPT                &
    &                         -                          T(I+IHE(J),J+1,K))
!
                        IF (STNS > 0.0) THEN
                            WARR              = DPDE(I+IHE(J),J+1)
                            ATC(I+IHE(J),J+1) =  ATC(I+IHE(J),J+1)     + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                        DIV(I+1,J,K+1) =  DIV(I+1,J,K+1) - STEW !GREEN
                        DIVS(I,J)      = DIVS(I,J)       + STEW !GREEN
!
                        WDEP  = ABS(-STEW) * DT
                        DPT   =   (RTOP(I+1,J,K+1) + RTOP(I,J,K))                                 &
    &                         * (DPDEP1(I+1,J)     + DPDE(I,J))                                   &
    &                         *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STEW) * (T(I+1,J,K+1) - DPT                      &
    &                         -                           T(I  ,J,K  ))
!
                        IF (-STEW > 0.0) THEN
                            WARR     = DPDE(I,J)
                            ATC(I,J) =  ATC(I,J)         + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR         = DPDEP1(I+1,J)
                            ATCP1(I+1,J) =  ATCP1(I+1,J) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 5) THEN
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) - STNE
                        DIVS(I,J)              = DIVS(I,J)              + STNE
!
                        WDEP = ABS(-STNE) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I,J,K))                           &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I,J))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNE) * (T(I+IHE(J),J+1,K+1) - DPT               &
    &                         -                           T(I       ,J  ,K  ))
!
                        IF (-STNE > 0.0) THEN
                            WARR                = DPDE(I,J)
                            ATC(I,J)            =  ATC(I,J)            + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J-1,K+1) =  DIV(I+IHE(J),J-1,K+1) - STSE
                        DIVS(I,J)              = DIVS(I,J)              + STSE
!
                        WDEP = ABS(-STSE) * DT
                        DPT  =   (RTOP(I+IHE(J),J-1,K+1) + RTOP(I,J,K))                           &
    &                        * (DPDEP1(I+IHE(J),J-1)     + DPDE(I,J))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STSE) * (T(I+IHE(J),J-1,K+1) - DPT               &
    &                         -                           T(I       ,J  ,K  ))
!  
                        IF (-STSE > 0.0) THEN
                            WARR                = DPDE(I,J)
                            ATC(I,J)            =  ATC(I,J)            + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J-1)
                            ATCP1(I+IHE(J),J-1) =  ATCP1(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+1,J,K+1) =  DIV(I+1,J,K+1) - STEW !GREEN
                        DIVS(I,J)       = DIVS(I,J)       + STEW !GREEN
!
                        WDEP = ABS(-STEW) * DT
                        DPT  =   (RTOP(I+1,J,K+1) + RTOP(I,J,K))                                  &
    &                        * (DPDEP1(I+1,J)     + DPDE(I,J))                                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STEW) * (T(I+1,J,K+1) - DPT                      &
    &                         -                           T(I,J,K))
!
                        IF (-STEW > 0.0) THEN
                            WARR         = DPDE(I,J)
                            ATC(I,J)     =  ATC(I,J)     + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR         = DPDEP1(I+1,J)
                            ATCP1(I+1,J) =  ATCP1(I+1,J) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 6) THEN
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) - STNE
                        DIVS(I,J)              = DIVS(I,J)              + STNE
!
                        WDEP = ABS(-STNE) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I,J,K))                           &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I,J))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNE) * (T(I+IHE(J),J+1,K+1) - DPT               &
    &                         -                           T(I,J,K))
!
                        IF (-STNE > 0.0) THEN
                            WARR                = DPDE(I,J)
                            ATC(I,J)            =  ATC(I,J)            + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+1,J,K+1)    =  DIV(I+1,J,K+1)    - STNEM1
                        DIVS(I+IHE(J),J-1) = DIVS(I+IHE(J),J-1) + STNEM1
!
                        WDEP = ABS(-STNEM1) * DT
!
                        DPT =   (RTOP(I+1,J,K+1) + RTOP(I+IHE(J),J-1,K))                          &
    &                       * (DPDEP1(I+1,J)     + DPDE(I+IHE(J),J-1))                            &
    &                       *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNEM1) * (T(I+1,J,K+1)       - DPT              &
    &                         -                             T(I+IHE(J),J-1,K))
!
                        IF (-STNEM1 > 0.0) THEN
                            WARR              = DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1) =  ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I+1,J)
                            ATCP1(I+1,J)      =  ATCP1(I+1,J)      + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+1,J,K+1) =  DIV(I+1,J,K+1) - STEW !GREEN
                        DIVS(I,J)       = DIVS(I,J)       + STEW !GREEN
!
                        WDEP = ABS(-STEW) * DT
                        DPT =   (RTOP(I+1,J,K+1) + RTOP(I,J,K))                                   &
    &                       * (DPDEP1(I+1,J)     + DPDE(I,J))                                     &
    &                       *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STEW) * (T(I+1,J,K+1) - DPT                      &
    &                         -                           T(I,J,K))
!
                        IF (-STEW > 0.0) THEN
                            WARR         =   DPDE(I,J)
                            ATC(I,J)     =    ATC(I,J)   + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR         = DPDEP1(I+1,J)
                            ATCP1(I+1,J) =  ATCP1(I+1,J) + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) - STNS !PINK
                        DIVS(I+IHE(J),J-1)     = DIVS(I+IHE(J),J-1)     + STNS !PINK
!
                        WDEP = ABS(-STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I+IHE(J),J-1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I+IHE(J),J-1))                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNS) * (T(I+IHE(J),J+1,K+1) - DPT               &
    &                         -                           T(I+IHE(J),J-1,K))
!
                        IF (-STNS > 0.0) THEN
                            WARR                =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1)   =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 7) THEN
                         DIV(I,J,K+1)      =  DIV(I,J,K+1)      + STSE
                        DIVS(I+IHE(J),J-1) = DIVS(I+IHE(J),J-1) - STSE
!
                        WDEP = ABS(STSE) * DT
                        DPT  =   (RTOP(I,J,K+1) + RTOP(I+IHE(J),J-1,K))                           &
    &                        * (DPDEP1(I,J)     + DPDE(I+IHE(J),J-1))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STSE) * (T(I,J,K+1) - DPT                         &
    &                         -                          T(I+IHE(J),J-1,K))
!
                        IF (STSE > 0.0) THEN
                            WARR              =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1) =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I,J)
                            ATCP1(I,J)        =  ATCP1(I,J)          + WDUTD / (WARR+WDEP)
                        END IF
!
                        DIV(I+1,J,K+1)     = DIV(I+1,J,K+1)     - STNEM1
                        DIVS(I+IHE(J),J-1) = DIVS(I+IHE(J),J-1) + STNEM1
!
                        WDEP = ABS(-STNEM1) * DT
                        DPT  =   (RTOP(I+1,J,K+1) + RTOP(I+IHE(J),J-1,K))                         &
    &                        * (DPDEP1(I+1,J)     + DPDE(I+IHE(J),J-1))                           &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNEM1) * (T(I+1     ,J  ,K+1)       - DPT       &
    &                         -                             T(I+IHE(J),J-1,K  ))
!
                        IF (-STNEM1 > 0.0) THEN
                            WARR              =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1) =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I+1,J)
                            ATCP1(I+1,J)      =  ATCP1(I+1,J)        + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) - STNS !PINK
                        DIVS(I+IHE(J),J-1)     = DIVS(I+IHE(J),J-1)     + STNS !PINK
!
                        WDEP = ABS(-STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I+IHE(J),J-1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I+IHE(J),J-1))                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNS) * (T(I+IHE(J),J+1,K+1) - DPT               &
    &                         -                           T(I+IHE(J),J-1,K  ))
!
                        IF (-STNS > 0.0) THEN
                            WARR                =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1)   =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!
                    ELSE IF (ISLD(I+IHE(J),J) == 8) THEN
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) + STSEP1
                        DIVS(I+1,J)            = DIVS(I+1,J)            - STSEP1
!
                        WDEP = ABS( STSEP1) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I+1,J,K))                         &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I+1,J))                           &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STSEP1) * (T(I+IHE(J),J+1,K+1) - DPT              &
    &                         -                            T(I+1     ,J  ,K  ))
!
                        IF ( STSEP1 > 0.0) THEN
                            WARR                =   DPDE(I+1,J)
                            ATC(I+1,J)          =    ATC(I+1,J)        + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
!                        		   
                         DIV(I,J,K+1)      =  DIV(I,J,K+1)      + STSE
                        DIVS(I+IHE(J),J-1) = DIVS(I+IHE(J),J-1) - STSE
!
                        WDEP = ABS(STSE) * DT
                        DPT  =   (RTOP(I,J,K+1) + RTOP(I+IHE(J),J-1,K))                           &
    &                        * (DPDEP1(I,J)     + DPDE(I+IHE(J),J-1))                             &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STSE) * (T(I,J,K+1) - DPT                         &
    &                         -                          T(I+IHE(J),J-1,K))
!
                        IF (STSE > 0.0) THEN
                            WARR              =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1) =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR              = DPDEP1(I,J)
                            ATCP1(I,J)        =  ATCP1(I,J)          +WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I,J,K+1) =  DIV(I,J,K+1) + STEW !BLUE
                        DIVS(I+1,J)   = DIVS(I+1,J)   - STEW !BLUE
!
                        WDEP = ABS(STEW) * DT
                        DPT  =   (RTOP(I,J,K+1) + RTOP(I+1,J,K))                                  &
    &                        * (DPDEP1(I,J)     + DPDE(I+1,J))                                    &
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,STEW) * (T(I  ,J,K+1) - DPT                       &
    &                         -                          T(I+1,J,K  ))
!
                        IF (STEW > 0.0) THEN
                            WARR       =   DPDE(I+1,J)
                            ATC(I+1,J) =    ATC(I+1,J) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR       = DPDEP1(I,J)
                            ATCP1(I,J) =  ATCP1(I,J)   + WDUTD / (WARR+WDEP)
                        END IF
!
                         DIV(I+IHE(J),J+1,K+1) =  DIV(I+IHE(J),J+1,K+1) - STNS !PINK
                        DIVS(I+IHE(J),J-1)     = DIVS(I+IHE(J),J-1)     + STNS !PINK
!
                        WDEP = ABS(-STNS) * DT
                        DPT  =   (RTOP(I+IHE(J),J+1,K+1) + RTOP(I+IHE(J),J-1,K))                  &
    &                        * (DPDEP1(I+IHE(J),J+1)     + DPDE(I+IHE(J),J-1))                    & 
    &                        *  RFCP
!
                        WDUTD = WDEP * SIGN(1.0,-STNS) * (T(I+IHE(J),J+1,K+1) - DPT               &
    &                         -                           T(I+IHE(J),J-1,K))
!
                        IF (-STNS > 0.0) THEN
                            WARR                =   DPDE(I+IHE(J),J-1)
                            ATC(I+IHE(J),J-1)   =    ATC(I+IHE(J),J-1) + WDUTD / (WARR+WDEP)
                        ELSE
                            WARR                = DPDEP1(I+IHE(J),J+1)
                            ATCP1(I+IHE(J),J+1) =  ATCP1(I+IHE(J),J+1) + WDUTD / (WARR+WDEP)
                        END IF
                    END IF
!-------
! K < LM
!-------
                END IF
                END IF 
!            
    340 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO 390 J=MYJS,MYJE
            DO 390 I=MYIS,MYIE
                DIV(I,J,K) = (DIV(I,J,K) + DIVL(I,J)) * HM(I,J)
    390 END DO
!
400 END DO
!
    RETURN
!
    END SUBROUTINE DIVHOAST

    SUBROUTINE SLPSIG (PD, FIS, SM, TSIG, QSIG, CWMSIG, HBM2, U00, SPL, LSL, UL, DETA, PT, PSLP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SLPSIG
!> 
!> SUBROUTINE: SLPSIG - SLP REDUCTION
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 99-04-22
!>
!> ABSTRACT:
!> THIS ROUTINE COMPUTES THE SEA LEVEL PRESSURE REDUCTION USING EITHER THE MESINGER
!> RELAXATION METHOD OR THE STANDARD NCEP REDUCTION FOR SIGMA COORDINATES.
!> A BY-PRODUCT IS THE SET OF VALUES FOR THE UNDERGROUND TEMPERATURES ON THE SPECIFIED 
!> PRESSURE LEVELS.
!>
!> PROGRAM HISTORY LOG:
!> 99-09-23  T BLACK  - REWRITTEN FROM ROUTINE SLP (ETA COORDINATES)
!> 00-08-17  H CHUANG - MODIFIED THE ROUTINE TO BE INCLUDED IN THE QUILT INSTEAD OF POST
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> PD     - SFC PRESSURE MINUS PTOP
!> FIS    - SURFACE GEOPOTENTIAL
!> SM     -
!> TSIG   - 
!> QSIG   -
!> CWMSIG -
!> HBM2   -
!> U00    -
!> SPL    -
!> LSL    -
!> UL     - 
!> DETA   -
!> PT     - TOP PRESSURE OF DOMAIN
!>
!> OUTPUT ARGUMENT LIST:
!> PSLP - THE FINAL REDUCED SEA LEVEL PRESSURE ARRAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : QUILT
!>
!> CALLS      : MPI_ALLREDUCE
!>              UPDATE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LMP1   = LM  + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1    = LSM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM  * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: IM_JM  = IM  * JM
    INTEGER(KIND=I4KIND), PARAMETER :: JM2    = JM  - 2
    INTEGER(KIND=I4KIND), PARAMETER :: NFILL  = 8
    INTEGER(KIND=I4KIND), PARAMETER :: NRLX1  = 500 
    INTEGER(KIND=I4KIND), PARAMETER :: NRLX2  = 100
    INTEGER(KIND=I4KIND), PARAMETER :: KSLPD  = 1 
!
    REAL   (KIND=R4KIND), PARAMETER :: OVERRC = 1.5      
    REAL   (KIND=R4KIND), PARAMETER :: AD05   = OVERRC * 0.05
    REAL   (KIND=R4KIND), PARAMETER :: CFT0   = OVERRC - 1.
    REAL   (KIND=R4KIND), PARAMETER :: RD     = 287.04
    REAL   (KIND=R4KIND), PARAMETER :: ROG    = RD / 9.8  
    REAL   (KIND=R4KIND), PARAMETER :: PQ0    = 379.90516  
    REAL   (KIND=R4KIND), PARAMETER :: A2     =  17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3     = 273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4     =  35.86
    REAL   (KIND=R4KIND), PARAMETER :: GAMMA  =   6.5E-3
    REAL   (KIND=R4KIND), PARAMETER :: RGAMOG = GAMMA * ROG
    REAL   (KIND=R4KIND), PARAMETER :: H1M12  = 1.E-12
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LSL
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & PT
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                    , INTENT(IN)          ::&
    & PD      , FIS     , SM      , HBM2    , U00
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                                          ::& 
    & HTM2D   , TG       
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LSM)                                     ::& 
    & HTM
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LSL)                                     ::&
    & T       , Q       , FI
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LM)                , INTENT(IN)          ::&
    & TSIG    , QSIG    , CWMSIG 
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LM)                                      ::&
    & IW
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LMP1)                                    ::& 
    & ALPINT  , ZINT    , PINT
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & IWU     , IWL
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                    , INTENT(INOUT)       ::&
    & PSLP
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                                          ::& 
    & TTV     , SLPX    , P1
!
    REAL   (KIND=R4KIND), DIMENSION(LSM)                                  , INTENT(IN)          ::&
    & SPL
!
    REAL   (KIND=R4KIND), DIMENSION(LSM)                                                        ::&
    & SPLI
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::&
    & DETA
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & RDETA   , AETA    , F4Q2  
!
    REAL   (KIND=R4KIND), DIMENSION(LMP1)                                                       ::&
    & ETA     , DFL     
!
    REAL   (KIND=R4KIND), DIMENSION(2 * LM)                               , INTENT(IN)          ::&
    & UL
!  
    REAL   (KIND=R4KIND), DIMENSION(7, 7)                                                       ::&
    & TEMPT  
!
    INTEGER(KIND=I4KIND), DIMENSION(LSM)                                                        ::&
    & KMNTM
!
    INTEGER(KIND=I4KIND), DIMENSION(IMJM, LSM)                                                  ::&
    & IMNT    , JMNT  
!
    INTEGER(KIND=I4KIND), DIMENSION(IM, MY_JSD:MY_JED)                                          ::&
    & LMH     , NL1X
!
    INTEGER(KIND=I4KIND), DIMENSION(IM_JM)                                                      ::&
    & IHOLD   , JHOLD
!
    INTEGER(KIND=I4KIND), DIMENSION(JM)                                                         ::&
    & IHE     , IHW     , IVE     , IVW
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SIGMA   , STDRD   
!
    LOGICAL(KIND=L4KIND), DIMENSION(IM, MY_JSD:MY_JED)                                          ::&
    & DONE
!
    STDRD = .FALSE. 
!------------------------------------------- 
! CALCULATE THE I-INDEX EAST-WEST INCREMENTS
!------------------------------------------- 
    PRINT*,'IN SLPSIG'
!
    DO J=1,JM
        IHE(J) = MOD(J+1, 2)
        IHW(J) = IHE(J) - 1
        IVE(J) = MOD(J  , 2)
        IVW(J) = IVE(J) - 1
    END DO
!--------------------------------------------------------- 
! INITIALIZE ARRAYS. LOAD SLP ARRAY WITH SURFACE PRESSURE.
!--------------------------------------------------------- 
!
!$omp parallel do
!
    DO J=JSTA_I,JEND_I
        DO I=1,IM
            PSLP(I,J) = PD(I,J) + PT
             TTV(I,J) = 0.
             LMH(I,J) = 0
        END DO
    END DO
!--------------------- 
! COMPUTE ETA AND AETA
!--------------------- 
    ETA(1) = 0.0
!
    DO L=2,LM+1
        IF (L == 2) WRITE(6,*) 'L, DETA(L-1), ETA(L-1): ',L, DETA(L-1), ETA(L-1)
        ETA(L) = ETA(L-1) + DETA(L-1)
    END DO
!
    DO L=1,LM
        AETA(L) = 0.5 * (ETA(L) + ETA(L+1))
    END DO
!---------------------------------------------------------------------------------------- 
! CALCULATE SEA LEVEL PRESSURE FOR PROFILES (AND POSSIBLY FOR POSTING BY POST PROCESSOR).
! "STDRD" REFERS TO THE "STANDARD" SLP REDUCTION SCHEME.
!----------------------------------------------------------------------------------------
    IF (STDRD) GOTO 400
!--------------------------------------------------------------------------------------------------
! CREATE A 3-D "HEIGHT MASK" FOR THE SPECIFIED PRESSURE LEVELS (1 => ABOVE GROUND) AND A 2-D
! INDICATOR ARRAY THAT SAYS WHICH PRESSURE LEVEL IS THE LOWEST ONE ABOVE THE GROUND
!--------------------------------------------------------------------------------------------------
    DO 100 L=1,LSM
        SPLL = SPL(L)
!    
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                PSFC = PD(I,J) + PT
                PCHK = PSFC
                IF (NFILL > 0) THEN
                    DO LL=1,NFILL
                        PCHK = PCHK - DETA(LM+1-LL) * PD(I,J)
                    END DO
                END IF
!
                IF (SM(I,J) > 0.5 .AND. FIS(I,J) < 10.) PCHK = PSFC
!
                IF (SPLL < PCHK) THEN
                    HTM(I,J,L) = 1.
                ELSE
                    HTM(I,J,L) = 0.
                    IF (L > 1 .AND. HTM(I,J,L-1) > 0.5) LMH(I,J) = L-1
                END IF
!            
                IF (L == LSM .AND. HTM(I,J,L) > 0.5)    LMH(I,J) = LSM
            END DO
        END DO
!    
100 END DO
!--------------------------------------------------- 
!  INTERPOLATE T AND Q FROM SIGMA TO PRESSURE LEVELS
!--------------------------------------------------- 
!
!--------------------------------------------------------------------------------------------------
! VALUES OF T ON THE OUTPUT PRESSURE LEVELS ABOVE GROUND MUST BE KNOWN BEFORE THEY CAN BE FILLED 
! IN BELOW GROUND IN THE ROUTINE WHICH COMPUTES THE MESINGER SEA LEVEL PRESSURE. THEREFORE DO
! ALL INTERPOLATION ABOVE GROUND NOW.
!--------------------------------------------------------------------------------------------------
!
!----------------------- 
! DEFINE ALPINT AND PINT
!-----------------------
    DO L=1,LMP1
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                  PINT(I,J,L) =     PD(I,J) * ETA(L) + PT
                ALPINT(I,J,L) = LOG(PD(I,J) * ETA(L) + PT)
            END DO
        END DO
    END DO
!------------- 
! COMPUTE ZINT
!-------------
!
!$omp parallel do 
!
    DO J=JSTA_I,JEND_I
        DO I=1,IM
            ZINT(I,J,LMP1) = FIS(I,J) / 9.8
        END DO
    END DO
!------------------------------------ 
! COMPUTE VALUES FROM THE SURFACE UP.
!------------------------------------ 
    DO L=LM,1,-1
!
!$omp parallel do 
!
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                ZINT(I,J,L) =    ZINT(I,J,L+1) +   TSIG(I,J,L) * (QSIG(I,J,L) * .608 + 1.) * RD &
    &                       * (ALPINT(I,J,L+1) - ALPINT(I,J,L)) / 9.8
            END DO
        END DO
    END DO
!
    IF (I == 10 .AND. J == 86) THEN
        PRINT*,'WRITING SAMPLE INPUT HEIGHT, T'
        DO L=1,LMP1
            PRINT*,'I,J,L,P,T,ZINT = ', I, J, L, PINT(I,J,L), TSIG(I,J,L), ZINT(I,J,L)
        END DO
    END IF
!--------------------------------
!  SET UP UTIM FOR THIS TIME STEP
!--------------------------------
    UTIM   = 1.
    CLIMIT = 1.E-20
!
    DO 75 L=1,LM
        IF (L == 1) THEN
!
!$omp parallel do
!
            DO J=JSTA_I,JEND_I
                DO I=1,IM
                    IW(I,J,L) = 0.
                END DO
            END DO
!
            GOTO 75
!
        END IF
!
!$omp parallel do                                                                                 
!$omp private (CWMKL    , FIQ     , HH      , LML     , PP      , QI      , QKL     , QW      ,   &
!$omp          TKL      , TMT0    , TMT15   , U00KL   ) 
!                                                                                                             
        DO 70 J=JSTA_I,JEND_I
            DO 70 I=1,IM
                LML   = LM - LM
                HH    = 1 * HBM2(I,J)
!
                TKL   =   TSIG(I,J,L)
                QKL   =   QSIG(I,J,L)
                CWMKL = CWMSIG(I,J,L)
!
                TMT0  = (TKL - 273.16)   * HH
                TMT15 = AMIN1(TMT0,-15.) * HH
!
                PP    = PD(I,J) * AETA(L) + PT
                QW    = HH * PQ0 / PP * EXP(HH * A2 * (TKL-A3) / (TKL-A4))
                QI    = QW * (1. + 0.01 * AMIN1(TMT0,0.))
                U00KL = U00(I,J) + UL(L + LML) * (0.95 - U00(I,J)) * UTIM
!            
                IF (TMT0 < -15.0) THEN
                    FIQ = QKL - U00KL * QI
                    IF (FIQ > 0. .OR. CWMKL > CLIMIT) THEN
                        IW(I,J,L) = 1.
                    ELSE
                        IW(I,J,L) = 0.
                    END IF
                END IF
!            
                IF (TMT0 >= 0.0) IW(I,J,L) = 0.
!
                IF (TMT0 < 0.0 .AND. TMT0 >= -15.0) THEN
                    IW(I,J,L) = 0.
                    IF (IW(I,J,L-1) == 1. .AND. CWMKL > CLIMIT) IW(I,J,L) = 1.
                END IF
!            
     70 END DO
 75 END DO
!
    DO 228 LP=1,LSL
        ALSL  = LOG(SPL(LP))
        NHOLD = 0
!    
        DO 125 J=JSTA_I,JEND_I
            DO 125 I=1,IM
!            
                 T(I,J,LP) = -1.E6
                 Q(I,J,LP) = -1.E6
                FI(I,J,LP) = -1.E6
!------------------------------------------------------------------------------------------------------            
! LOCATE VERTICAL INDEX OF MODEL INTERFACE JUST BELOW THE PRESSURE LEVEL TO WHICH WE ARE INTERPOLATING.
!------------------------------------------------------------------------------------------------------              
                DO 115 L=2,LM+1
                    IF (ALPINT(I,J,L) >= ALSL) THEN
                        NL1X(I,J) = L
                        NHOLD = NHOLD + 1
                        IHOLD(NHOLD) = I
                        JHOLD(NHOLD) = J
                        GOTO 125
                    ELSE IF(ALPINT(I,J,LMP1) < ALSL) THEN
                        NL1X(I,J) = LMP1
                        NHOLD = NHOLD + 1
                        IHOLD(NHOLD) = I
                        JHOLD(NHOLD) = J
                        GOTO 125
                    END IF
            115 END DO
!            
    125 END DO
!
        IF (NHOLD == 0) GOTO 228
!    
        TRF = 2. * ALSL
!--------------------------------------------------------------------------------------------------  
! NL1X WAS SET BASED ON INTERFACE PRESSURE VALUES. HOWEVER, WE ARE READY TO INTERPOLATE VALUES FROM
! MIDLAYER LOCATIONS SO ADJUST NL1X UP ONE LAYER IF NEEDED SO THAT THE INDEX OF THE MIDLAYER
! LOCATION IS IMMEDIATELY BELOW THE PRESSURE LEVEL TO WHICH INTERPOLATION IS BEING DONE.
!--------------------------------------------------------------------------------------------------
!
!$omp parallel do                                                                                 &  
!$omp private (AHF      , AHFO    , AHFQ    , AHFQ2   , AHFQC   , AHFQI   , AI      , B       ,   &
!$omp          BI       , BOM     , BQ      , BQ2     , BQC     , BQC_2   , BQI_2   , BQI     ,   &
!$omp          FAC      , GMIW    , GMIW_2  , IWL     , IWU     , LMP1    , PL      , PNL1    ,   &
!$omp          PU       , Q2A     , Q2B     , QABV    , QI      , QINT    , QL      , QSAT    ,   &
!$omp          QU       , QW      , RHU     , TABV    , TBLO    , TL      , TMT0    , TMT15   ,   &
!$omp          TU       , TVRABV  , TVRBLO  , TVRL    , TVRU    , ZL      , ZU      )
!
        DO 220 NN=1,NHOLD
            I = IHOLD(NN)
            J = JHOLD(NN)
            DIFU = ALSL - ALPINT(I,J,NL1X(I,J)-1)
            DIFL =        ALPINT(I,J,NL1X(I,J)  ) - ALSL
!
            IF (DIFU < DIFL) NL1X(I,J) = NL1X(I,J) - 1
!
            PNL1 = PINT(I,J,NL1X(I,J))
!--------------------------------------------------------------------------------------------------
! VERTICAL INTERPOLATION OF GEOPOTENTIAL, TEMPERATURE, SPECIFIC HUMIDITY, CLOUD WATER/ICE, AND TKE.
!--------------------------------------------------------------------------------------------------
!
!---------------------------------------------------- 
! EXTRAPOLATE ABOVE THE TOPMOST MIDLAYER OF THE MODEL
!----------------------------------------------------        
            IF (NL1X(I,J) == 1) THEN
                PU = PINT(I,J,2)
                ZU = ZINT(I,J,2)
                TU = 0.5 * (TSIG(I,J,1) + TSIG(I,J,2))
                QU = 0.5 * (QSIG(I,J,1) + QSIG(I,J,2))
!            
                  IWU = 0.5 * (IW(I,J,1) + IW(I,J,2))
                 TMT0 = TU - 273.16
                TMT15 = AMIN1(TMT0,-15.)
                AI = 0.008855
                BI = 1.
!
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!
                  QW = PQ0 / PU * EXP(A2 * (TU-A3) / (TU-A4))
                  QI = QW * (BI + AI * AMIN1(TMT0,0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15+15.))
!
                IF (TMT0 < -15.) THEN
                    QSAT = QI
                ELSE IF(TMT0 >= 0.) THEN
                    QSAT = QINT
                ELSE
                    IF (IWU > 0.) THEN
                        QSAT = QI
                    ELSE
                        QSAT = QINT
                    END IF
                END IF
!-------------------------------------------------------            
! USE RH FOR LIQUID WATER NO MATTER WHAT.
! DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
!------------------------------------------------------- 
                QSAT = QW
!            
                RHU = QU / QSAT
!            
                IF (RHU > 1.) THEN
                    RHU = 1.
                     QU = RHU * QSAT
                END IF
!            
                IF (RHU < 0.01) THEN
                    RHU = 0.01
                     QU = RHU * QSAT
                END IF
!            
                  TVRU = TU     * (1. + 0.608 * QU)
                TVRABV = TVRU   * (SPL(LP) / PU) ** RGAMOG
                  TABV = TVRABV / (1. + 0.608 * QU)
!            
                 TMT0 = TABV - 273.16
                TMT15 = AMIN1(TMT0,-15.)
                   AI = 0.008855
                   BI = 1.
!
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!
                  QW = PQ0 / SPL(LP) * EXP(A2 * (TABV-A3) / (TABV-A4))
                  QI = QW * (BI + AI * AMIN1(TMT0,0.))
                QINT = QW *(1. - 0.00032 * TMT15 * (TMT15+15.))
!
                IF (TMT0 < -15.) THEN
                    QSAT = QI
                ELSE IF (TMT0 >= 0.) THEN
                    QSAT = QINT
                ELSE
                    IF (IWU > 0.) THEN
                        QSAT = QI
                    ELSE
                        QSAT = QINT
                    END IF
                END IF
!-------------------------------------------------------             
! USE RH FOR LIQUID WATER NO MATTER WHAT.
! DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
!------------------------------------------------------- 
                QSAT = QW         
                QABV = RHU * QSAT
                QABV = AMAX1(1.E-12,QABV)
                   B = TABV
                  BQ = QABV
                GMIW = IW(I,J,1)
                 AHF = 0.
                AHFQ = 0.
                 FAC = 0.
!            
            ELSE IF (NL1X(I,J) == LMP1) THEN
!----------------------------------------------------------------- 
! EXTRAPOLATE BELOW LOWEST MODEL MIDLAYER (BUT STILL ABOVE GROUND)
!----------------------------------------------------------------- 
                PL  = PINT(I,J,LM-1)
                ZL  = ZINT(I,J,LM-1)
!
                TL  = 0.5  * (TSIG(I,J,LM-2) + TSIG(I,J,LM-1))
                QL  = 0.5  * (QSIG(I,J,LM-2) + QSIG(I,J,LM-1))
!
                IWL = 0.5 *    (IW(I,J,LM-2) +   IW(I,J,LM-1))
!
                 TMT0 = TL - 273.16
                TMT15 = AMIN1(TMT0,-15.)
                   AI = 0.008855
                   BI = 1.
!
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!
                  QW = PQ0 / PL * EXP(A2 * (TL-A3) / (TL-A4))
                  QI = QW * (BI + AI * AMIN1(TMT0,0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15+15.))
!
                IF (TMT0 < -15.) THEN
                    QSAT = QI
                ELSE IF (TMT0 >= 0.) THEN
                    QSAT = QINT
                ELSE
                    IF (IWL > 0.) THEN
                        QSAT = QI
                    ELSE
                        QSAT = QINT
                    END IF
                END IF
!-------------------------------------------------------             
! USE RH FOR LIQUID WATER NO MATTER WHAT.
! DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
!-------------------------------------------------------
                QSAT = QW        
                RHL  = QL / QSAT
!            
                IF (RHL > 1.) THEN
                    RHL = 1.
                     QL = RHL * QSAT
                END IF
!            
                IF (RHL < 0.01) THEN
                    RHL = 0.01
                     QL = RHL * QSAT
                END IF
!            
                  TVRL = TL     * (1. + 0.608 * QL)
                TVRBLO = TVRL   * (SPL(LP) / PL) ** RGAMOG
                  TBLO = TVRBLO / (1. + 0.608 * QL)
!            
                 TMT0 = TBLO - 273.16
                TMT15 = AMIN1(TMT0,-15.)
                   AI = 0.008855
                   BI = 1.
!
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!
                  QW = PQ0 / SPL(LP) * EXP(A2 * (TBLO-A3) / (TBLO-A4))
                  QI = QW * (BI + AI * AMIN1(TMT0,0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15+15.))
!
                IF (TMT0 < -15.) THEN
                    QSAT = QI
                ELSE IF (TMT0 >= 0.) THEN
                    QSAT = QINT
                ELSE
                    IF (IWL > 0.) THEN
                        QSAT = QI
                    ELSE
                        QSAT = QINT
                    END IF
                END IF
!------------------------------------------------------- 
! USE RH FOR LIQUID WATER NO MATTER WHAT.
! DELETE THE FOLLOWING LINE TO SWITCH BACK TO RH FOR ICE
!------------------------------------------------------- 
                QSAT = QW           
                QBLO = RHL*QSAT
                QBLO = AMAX1(1.E-12,QBLO)
                   B = TBLO
                  BQ = QBLO
                 AHF = 0.
                AHFQ = 0.
                 FAC = 0.
            ELSE
!---------------------------------------------------- 
! INTERPOLATION BETWEEN NORMAL LOWER AND UPPER BOUNDS
!----------------------------------------------------
                   B = TSIG(I,J,NL1X(I,J))
                  BQ = QSIG(I,J,NL1X(I,J))
!
                 FAC = 2. * ALOG(PT + PD(I,J) * AETA(NL1X(I,J)))
!
                 AHF = (B - TSIG(I,J,NL1X(I,J)-1)) / (ALPINT(I,J,NL1X(I,J)+1)                     &
    &                -    ALPINT(I,J,NL1X(I,J)-1))
!
                AHFQ = (BQ - QSIG(I,J,NL1X(I,J) - 1)) / (ALPINT(I,J,NL1X(I,J) + 1)                &
    &                -     ALPINT(I,J,NL1X(I,J) - 1))
            END IF
!        
             T(I,J,LP) = B + AHF *   (TRF - FAC)
             Q(I,J,LP) = BQ + AHFQ * (TRF - FAC)
             Q(I,J,LP) = AMAX1(Q(I,J,LP),H1M12)
            FI(I,J,LP) = (PNL1 - SPL(LP)) / (SPL(LP) + PNL1)                                      &
    &                  * ((ALSL + ALPINT(I,J,NL1X(I,J)) -  FAC) * AHF + B)                        &
    &                  * RD * 2. + ZINT(I,J,NL1X(I,J)) * 9.8
!        
            IF (I == 86 .AND. J == 10) THEN
                PRINT*,'LP,NL1X,T,Q,FI= ', LP, NL1X(I,J), T(I,J,LP), Q(I,J,LP), FI(I,J,LP)
            END IF
    220 END DO
!
228 END DO
!--------------------------------------------------------------------------------------------------
! WE REACH THIS LINE IF WE WANT THE MESINGER ETA SLP REDUCTION BASED ON RELAXATION TEMPERATURES. 
! THE FIRST STEP IS TO FIND THE HIGHEST LAYER CONTAINING MOUNTAINS.
!--------------------------------------------------------------------------------------------------
    DO 230 L=LSM,1,-1
!    
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                IF (HTM(I,J,L) < 0.5) GOTO 230
            END DO
        END DO
!    
        LHMNT = L+1
!
        GOTO 235
!
230 END DO
!
235 CONTINUE
!
    CALL MPI_ALLREDUCE(LHMNT, LXXX, 1, MPI_INTEGER, MPI_MIN,MPI_COMM_COMP, IERR)
!
    LHMNT = LXXX
!
    IF (LHMNT == LP1) THEN
        GOTO 430
    END IF
!--------------------------------------------------------
! NOW GATHER THE ADDRESSES OF ALL THE UNDERGROUND POINTS.
!--------------------------------------------------------
!
!$omp parallel do                                                                                 & 
!$omp private (KMN, KOUNT)
!
    DO 250 L=LHMNT,LSM
        KMN = 0
        KMNTM(L) = 0
        KOUNT = 0
!
        DO 240 J=JSTA_IM2,JEND_IM2
            DO 240 I=2,IM-1
                KOUNT = KOUNT+1
                IMNT(KOUNT,L) = 0
                JMNT(KOUNT,L) = 0
!
                IF (HTM(I,J,L) > 0.5) GOTO 240
!
                KMN = KMN+1
                IMNT(KMN,L) = I
                JMNT(KMN,L) = J
    240 END DO
        KMNTM(L) = KMN
250 END DO
!--------------------------------------------------------------------
! AS THE FIRST GUESS, SET THE UNDERGROUND TEMPERATURES EQUAL TO 0.0C.
!--------------------------------------------------------------------
    KMM = KMNTM(LSM)
!
!$omp parallel do                                                                                 & 
!$omp private (I        , J       , LAMP1), SHARED (T)
!
    DO 260 KM=1,KMM
        I = IMNT(KM,LSM)
        J = JMNT(KM,LSM)
        LMAP1 = LMH(I,J) + 1
        DO 260 L=LMAP1,LSM
            T(I,J,L) = 273.15
260 END DO
!-----------------------------------------------------------------------------------------
! CREATE A TEMPORARY TV ARRAY, AND FOLLOW BY SEQUENTIAL OVERRELAXATION, DOING NRLX PASSES.
!-----------------------------------------------------------------------------------------
    NRLX = NRLX1
!
!$omp parallel do                                                                                 & 
!$omp private (I        , J       , TINIT   , TTV)
!
    DO 300 L=LHMNT,LSM
!    
        DO 270 J=JSTA_I,JEND_I
            DO 270 I=1,IM
                  TTV(I,J) =   T(I,J,L)
                HTM2D(I,J) = HTM(I,J,L)
270 END DO
!--------------------------------------------------------------------------------------------------    
! FOR GRID BOXES NEXT TO MOUNTAINS, COMPUTE TV TO USE AS BOUNDARY CONDITIONS FOR THE RELAXATION
! UNDERGROUND
!--------------------------------------------------------------------------------------------------     
        CALL UPDATE(HTM2D)
!
        DO J=JSTA_IM2,JEND_IM2
            DO I=2,IM-1
                IF (HTM2D(I,J) > 0.5 .AND. HTM2D(I+IHW(J),J-1) * HTM2D(I+IHE(J),J-1) *            &
    &                                      HTM2D(I+IHW(J),J+1) * HTM2D(I+IHE(J),J+1) *            &
    &                                      HTM2D(I-1     ,J  ) * HTM2D(I+1     ,J  ) *            &
    &                                      HTM2D(I       ,J-2) * HTM2D(I       ,J+2) < 0.5) THEN 
                    TTV(I,J) = T(I,J,L) * (1. + 0.608 * Q(I,J,L))
                END IF
            END DO
        END DO
!
        KMM = KMNTM(L)
!
        DO 285 N=1,NRLX
            CALL UPDATE(TTV)
!
            DO 280 KM=1,KMM
                I = IMNT(KM,L)
                J = JMNT(KM,L)
                TINIT = TTV(I,J)
                TTV(I,J) = AD05 * (4. * (TTV(I+IHW(J),J-1) + TTV(I+IHE(J),J-1)                    &
    &                    +               TTV(I+IHW(J),J+1) + TTV(I+IHE(J),J+1))                   &
    &                    +               TTV(I-1     ,J  ) + TTV(I+1     ,J  )                    &
    &                    +               TTV(I       ,J-2) + TTV(I       ,J+2))                   &
    &                    - CFT0 *        TTV(I       ,J  )
!
                IF (KMM == 1 .AND. N == 500) THEN
                    PRINT*,'L,N,TTV NEIGHBOR', L, N, TTV(I+IHW(J),J-1), TTV(I+IHE(J),J-1),        &
    &                                                TTV(I+IHW(J),J+1), TTV(I+IHE(J),J+1),        &
    &                                                TTV(I-1     ,J  ), TTV(I+1     ,J  ),        &
    &                                                TTV(I       ,J-2), TTV(I       ,J+2),        &
    &                                                TTV(I       ,J  )
                END IF
!
        280 END DO
!        
    285 END DO
!
        DO 290 KM=1,KMM
            I = IMNT(KM,L)
            J = JMNT(KM,L)
            T(I,J,L) = TTV(I,J)
    290 END DO
!
300 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE THE SEA LEVEL PRESSURE AS PER THE NEW SCHEME.
! INTEGRATE THE HYDROSTATIC EQUATION DOWNWARD FROM THE GROUND THROUGH EACH OUTPUT PRESSURE LEVEL 
! (WHERE TV IS NOW KNOWN) TO FIND GZ AT THE NEXT MIDPOINT BETWEEN PRESSURE LEVELS. WHEN GZ=0 
! IS REACHED, SOLVE FOR THE PRESSURE.
!--------------------------------------------------------------------------------------------------
!
!----------------------------------------------------------- 
! COUNT THE POINTS WHERE SLP IS DONE BELOW EACH OUTPUT LEVEL
!-----------------------------------------------------------
    KOUNT = 0
    DO J=JSTA_I,JEND_I
        DO I=1,IM
              P1(I,J) = SPL(LMH(I,J))
            DONE(I,J) = .FALSE. 
            IF (FIS(I,J) < 10.) THEN
                PSLP(I,J) = PD(I,J) + PT
                DONE(I,J) = .TRUE. 
                KOUNT = KOUNT+1
            END IF
        END DO
    END DO
!
    KMM = KMNTM(LSM)
!
!$omp parallel do                                                                                 & 
!$omp private (GZ1      , GZ2     , I       , J       , LMAP1   , P1      , P2), SHARED (PSLP)
!
    DO 320 KM=1,KMM
        I = IMNT(KM,LSM)
        J = JMNT(KM,LSM)
!
        LMHIJ = LMH(I,J)
!
        GZ1   =  FI(I,J,LMHIJ)
!
        P1(I,J) = SPL(LMHIJ)
!    
        LMAP1 = LMHIJ + 1
        DO L=LMAP1,LSM
            P2 = SPL(L)
            TLYR = 0.5 * (T(I,J,L) + T(I,J,L-1))
            GZ2 = GZ1 + RD * TLYR * ALOG(P1(I,J) / P2)
            FI(I,J,L) = GZ2
            IF (GZ2 <= 0.) THEN
                PSLP(I,J) = P1(I,J) / EXP(-GZ1 / (RD * T(I,J,L-1)))
                DONE(I,J) = .TRUE. 
                KOUNT = KOUNT + 1
                GO TO 320
            END IF
            P1(I,J) = P2
            GZ1 = GZ2
        END DO
320 END DO
!--------------------------------------------------------------------------------------------------
! WHEN SEA LEVEL IS BELOW THE LOWEST OUTPUT PRESSURE LEVEL, SOLVE THE HYDROSTATIC EQUATION BY
! CHOOSING A TEMPERATURE AT THE MIDPOINT OF THE LAYER BETWEEN THAT LOWEST PRESSURE LEVEL AND THE
! GROUND BY EXTRAPOLATING DOWNWARD FROM T ON THE LOWEST PRESSURE LEVEL USING THE DT/DFI BETWEEN 
! THE LOWEST PRESSURE LEVEL AND THE ONE ABOVE IT.
!--------------------------------------------------------------------------------------------------
    TOTAL = (IM-2) * (JM-4)
!
    DO 340 LP=LSM,1,-1
        IF (KOUNT == TOTAL) GO TO 350
        DO 330 J=JSTA_I,JEND_I
            DO 330 I=1,IM
                IF (FI(I,J,LP) < 0. .OR. DONE(I,J)) GO TO 330
                SLOPE = (T(I,J,LP) - T(I,J,LP-1)) / (FI(I,J,LP) - FI(I,J,LP-1))
!
                TLYR = T(I,J,LP) - 0.5 * FI(I,J,LP) * SLOPE
                PSLP(I,J) = P1(I,J) / EXP(-FI(I,J,LP) / (RD * TLYR))
                DONE(I,J)= .TRUE. 
                KOUNT = KOUNT + 1
    330 END DO
340 END DO
!
350 CONTINUE
!
    PRINT*, 'DONE WITH MESINGER SLP REDUCTION'
!-------------------------- 
! SKIP THE STANDARD SCHEME.
!-------------------------- 
    GOTO 430
!-------------------------------------------------------------------------
! IF YOU WANT THE "STANDARD" ETA/SIGMA REDUCTION THIS IS WHERE IT IS DONE.
!-------------------------------------------------------------------------
400 CONTINUE
!
    DO 410 J=JSTA_I,JEND_I
        DO 410 I=1,IM
            IF (FIS(I,J) >= 1.) THEN
                  LMA = LM
                ALPP1 = ALOG(PD(I,J) + PT)
                 SLOP = 0.0065 * ROG * TSIG(I,J,LM)
!
                IF (SLOP < 0.50) THEN
                    SLPP = ALPP1 + FIS(I,J) / (RD * TSIG(I,J,LMA))
                ELSE
                     TTT = -(ALOG(PD(I,J) + PT) + ALPP1) * SLOP * 0.50 + TSIG(I,J,LMA)
                    SLPP = (-TTT + SQRT(TTT * TTT + 2. * SLOP * (FIS(I,J) / RD                    &
    &                    + ( TTT + 0.50 * SLOP * ALPP1) * ALPP1))) / SLOP
                END IF
                PSLP(I,J) = EXP(SLPP)
            END IF
410 END DO
!--------------------------------------------------------------------------------------------------
! AT THIS POINT WE HAVE A SEA LEVEL PRESSURE FIELD BY EITHER METHOD. 5-POINT AVERAGE THE FIELD ON 
! THE E-GRID.
!--------------------------------------------------------------------------------------------------
430 CONTINUE
!--------------------------------------- 
! EXTRAPOLATE VALUES TO THE OUTER 2 ROWS
!---------------------------------------
    PRINT*, 'ME IN SLPSIGC= ', ME
!
    IF (ME == 0) THEN
        IF ((JEND_I-JSTA_I) < 5) THEN
            PRINT*, 'HERE!'
            DO J=1,2
                IEND = IM - 1 - MOD(J+1,2)
                DO I=2,IEND
                    PSLP(I,J) = PSLP(I,3)
                END DO
            END DO
        ELSE
            DO J=1,2
                IEND = IM - 1 - MOD(J+1,2)
                DO I=2,IEND
                    PSLP(I,J) = 1.5 * PSLP(I,J+2) - 0.5 * PSLP(I,J+4)
                END DO
            END DO
        END IF
    END IF
!
    IF (ME == (NUM_PROCS-1)) THEN
        IF ((JEND_I-JSTA_I) < 5) THEN
            DO J=JM-1,JM
                IEND = IM - 1 - MOD(J+1,2)
                DO I=2,IEND
                    PSLP(I,J) = PSLP(I,IM-2)
                END DO
            END DO
        ELSE
            DO J=JM-1,JM
                IEND = IM - 1 - MOD(J+1,2)
                DO I=2,IEND
                    PSLP(I,J) = 1.5 * PSLP(I,J-2) - 0.5 * PSLP(I,J-4)
                END DO
            END DO
        END IF
    END IF
!
    DO J=JSTA_I,JEND_I
        PSLP(1,J) = 1.5 * PSLP(2,J)   - 0.5 * PSLP(3,J)
    END DO
!
    DO J=JSTA_I,JEND_I
        I = IM - MOD(J+1,2)
        PSLP(I,J) = 1.5 * PSLP(I-1,J) - 0.5 * PSLP(I-2,J)
    END DO
!
    PRINT*, 'PSLP BEFORE SMOOTHING'
!
!$omp parallel do 
!
    DO 440 J=JSTA_I,JEND_I
        DO 440 I=1,IM
            SLPX(I,J) = PSLP(I,J)
440 END DO
!
    DO 480 KS=1,KSLPD
!    
        CALL UPDATE(PSLP)
!
!$omp parallel do                                                                                 &
!$omp private (IHH2)
!
        DO 460 J=JSTA_IM2,JEND_IM2
            IHH2 = IM - 1 - MOD(J+1,2)
            DO 460 I=2,IHH2
!--------------------------------------------------------
! EXTRA AVERAGING UNDER MOUNTAINS TAKEN OUT, FM, MARCH 96
!--------------------------------------------------------            
                SLPX(I,J) = 0.125 * (PSLP(I+IHW(J),J-1) + PSLP(I+IHE(J),J-1)                      &
    &                     +          PSLP(I+IHW(J),J+1) + PSLP(I+IHE(J),J+1)                      &
    &                     + 4. *     PSLP(I       ,J  ))
    460 END DO
!
!$omp paralle do   
!  
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                PSLP(I,J) = SLPX(I,J)
            END DO
        END DO
!
        PRINT*,'SAMPLE PSLP', IM/2, JSTA_I, JEND_I, PSLP(IM/2,JSTA_I), PSLP(IM/2,JEND_I)
!    
480 END DO
!
    WRITE(6,*) 'LEAVING SLPSIG'
!
    RETURN
!
    END SUBROUTINE SLPSIG

!-------------------------------------------------------------
! SET PRIMARY GRID DIMENSIONS AND PRESSURE OUTPUT LEVELS
      INTEGER,PARAMETER:: IM=IMIN,JM=JMIN,LM=LMIN,LSM=LSMIN
!-------------------------------------------------------------
! SET THE NUMBER OF PEs IN THE I-DIRECTION AND J-DIRECTION
      INTEGER,PARAMETER:: INPES=IPCIN,JNPES=JPCIN
!-------------------------------------------------------------
      INTEGER,PARAMETER:: IGSTL=-5,IGSTR=5
      INTEGER,PARAMETER:: JGSTL=-5,JGSTR=5
      INTEGER,PARAMETER:: ITAIL=IM-(INPES*(IM/INPES))
      INTEGER,PARAMETER:: JTAIL=JM-(JNPES*(JM/JNPES))

      INTEGER,PARAMETER:: IDIM1=IGSTL,IDIM2=IM/INPES+IGSTR+1
      INTEGER,PARAMETER:: JDIM1=JGSTL,JDIM2=JM/JNPES+JGSTR+1

    MODULE ACMCLD
!>--------------------------------------------------------------------------------------------------
!> MODULE ACMCLD
!>
!> USE MODULES: F77KINDS
!>              PARMETA       
!> 
!> DRIVER     : CHKOUT
!>              GOSSIP
!>              INIT
!>              INITS
!>              RADTN
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>-------------------------------------------------------------------------------------------------- 
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NCLOD
!                                                                     
    REAL   (KIND=R4KIND)                                                                        ::&
    & TCLOD
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & NCFRCV  , NCFRST
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & ACFRCV  , ACFRST
!
    END MODULE ACMCLD

    SUBROUTINE CLTEND(ICLTEND)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE CLTEND
!>
!> SUBPROGRAM: CLTEND - TEMPERATURE CHANGE BY CLOUD PROCESSES
!> PROGRAMMER: FERRIER 
!> ORG: W/NP22
!> DATE: 01-09-26
!>     
!> ABSTRACT: 
!> CLTEND GRADUALLY UPDATES TEMPERATURE TENDENCIES FROM CONVECTION GRID-SCALE MICROPHYSICS AND 
!> PRECIPITATION ASSIMILATION.    
!>
!> PROGRAM HISTORY LOG:
!> 01-09-26  ?????    - ORIGINATOR            
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> ICLTEND - FLAG SET TO -1 PRIOR TO PHYSICS CALLS, 0 AFTER PHYSICS CALLS, AND 1 FOR UPDATING 
!>           TEMPERATURES EVERY TIME STEP
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>     
!> USE MODULES: CTLBLK
!>              C_TADJ
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------                
    USE CTLBLK
    USE C_TADJ
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
!    REAL   (KIND=R4KIND), SAVE, DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                         ::&
!    & T_OLD
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & ICLTEND
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DELTPH
!
    IF (ICLTEND < 0) THEN
!--------------------------------------------------------------
! SAVE OLD TEMPERATURE ARRAY BEFORE CUCNVC, GSMDRIVE AND ADJPPT
!--------------------------------------------------------------
        DO K=1,LM
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    T_OLD(I,J,K) = T(I,J,K)
                END DO
            END DO
        END DO
    ELSE IF (ICLTEND == 0) THEN
!------------------------------------------------------------------
! CALCULATE TEMPERATURE TENDENCIES FROM CUCNVC, GSMDRIVE AND ADJPPT 
!------------------------------------------------------------------
        DELTPH = 1. / FLOAT(NPHS)
        DO K=1,LM
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    T_ADJ(I,J,K) =   HTM(I,J,K) * HBM2(I,J) * DELTPH * (T(I,J,K) - T_OLD(I,J,K))
                        T(I,J,K) = T_OLD(I,J,K)
                END DO
            END DO
        END DO
    ELSE
!--------------------------------------------------------------------------------------------------
! GRADUALLY UPDATE TEMPERATURE FROM CUCNVC, GSMDRIVE AND ADJPPT IN SMALL INCREMENTS EVERY DYNAMICS 
! TIME STEP
!--------------------------------------------------------------------------------------------------
        DO K=1,LM
            DO J=MYJS2,MYJE2
                DO I=MYIS,MYIE
                    T(I,J,K) = T(I,J,K) + T_ADJ(I,J,K)
                END DO
            END DO
        END DO
    END IF 
!
    RETURN
!
    END SUBROUTINE CLTEND

    MODULE PARM_TBL
!>--------------------------------------------------------------------------------------------------
!> MODULE PARM_TBL
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : CHKOUT
!>              CUCNVC
!>              DIGFLT
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE     
!>              HDIFF
!>              HDIFFS
!>              INIT
!>              INITS
!>              NEWFLT
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SURFCE
!>              WRTRST
!>              ZENITH
!>--------------------------------------------------------------------------------------------------  
    USE F77KINDS
! 
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND), PARAMETER :: ITB  =  76
    INTEGER(KIND=I4KIND), PARAMETER :: JTB  = 134
    INTEGER(KIND=I4KIND), PARAMETER :: ITBQ = 152
    INTEGER(KIND=I4KIND), PARAMETER :: JTBQ = 440
!
    END MODULE PARM_TBL

    SUBROUTINE OUT2RESTRT(ITAG)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE OUT2RESTRT
!>
!> SUBPROGRAM: OUT2RESTRT - 
!>
!> DRIVER     : CHKOUT
!>              
!>
!>--------------------------------------------------------------------------------------------------
    USE ABCI        !andre check
    USE ACMCLD      !andre check
    USE ACMCLH      !andre check
    USE ACMPRE      !andre check
    USE ACMRDL      !andre check
    USE ACMRDS      !andre check
    USE ACMSFC      !andre check
    USE ASTSAV      !andre check
    USE BANDTA      !andre check
    USE BDCOMB      !andre check
    USE BDWIDE      !andre check
    USE BOCO        !andre check
    USE BUFFER      !andre check
    USE C_FRACN     !andre check
    USE CLDWTR      !andre check
    USE CMICRO_CONS !andre check
    USE CMICRO_START!andre check
    USE CMICRO_STATS!andre check
    USE CMY600      !andre check  
    USE CNVCLD      !andre check
    USE CO2BD2      !andre check
    USE CO2BD3      !andre check
    USE CO2BD4      !andre check
    USE CO2BD5      !andre check
    USE COMPVS0     !andre check    
    USE COMPVS      !andre check
    USE CONTIN      !andre check   
    USE C_TADJ      !andre check    
    USE CTLBLK      !andre check
    USE CUINIT      !andre check
    USE DIUCON      !andre check
    USE DYNAM       !andre check
    USE MODULE EXCH_BUF_REAL!andre check
    USE GLB_TABLE   !andre check
    USE HCON
    USE IACCR_TABLES!andre check
    USE IMASS_TABLES!andre check
    USE INDX        !andre check
    USE INPUT       !andre check
    USE IRATE_TABLES!andre check
    USE IRIME_TABLES!andre check
    USE IVENT_TABLES!andre check
    USE LOOPS       !andre check
    USE MAPOT       !andre check
    USE MAPPINGS    !andre check
    USE MASKS       !andre check
    USE MOMENTO     !andre check
    USE MPPCOM
    USE NHYDRO      !andre check
    USE NSOILTYPE   !andre check
    USE OPTIONS     !andre check
    USE OUTFIL      !andre check  
    USE PHYCON      !andre check 
    USE PHYS        !andre check 
    USE PPTASM      !andre check
    USE PRFHLD      !andre check
    USE PVRBLS      !andre check
    USE RACCR_TABLES!andre check
    USE RD1TIM      !andre check
    USE RDFSAV      !andre check
    USE RITE        !andre check
    USE RMASS_TABLES!andre check
    USE RRATE_TABLES!andre check   
    USE RVELR_TABLES!andre check   
    USE RVENT_TABLES!andre check
    USE SAVEMEM     !andre check
    USE SCRTCH      !andre check
    USE SDENS_TABLES!andre check
    USE SEASO3      !andre check
    USE SLOPES      !andre check
    USE SOIL        !andre check
    USE SSALB       !andre check
    USE SWRSAV      !andre check
    USE TABCOM
    USE TEMPV       !andre check
    USE TOPO        !andre check
    USE VRBLS       !andre check
    USE UPDT
    USE Z0EFFT      !andre check 
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITAG,  LISTOUT 
!
!
!
!
    CHARACTER(LEN=6)                                                                            ::&
    & C_NHRS     
!   
    CHARACTER(LEN=4)                                                                            ::&
    & C_MYPE     
!   
    CHARACTER(LEN=150)                                                                          ::&
    & OUTFILE 
!
!
    WRITE(C_NHRS,'(I6.6)') ITAG  
!
    WRITE(C_MYPE,'(I4.4)') MYPE
!            
    OUTFILE = "OUT2RESTRT/OUT2RESTRT_"//C_MYPE//"."//C_NHRS
!
    LISTOUT=1001
!
    OPEN (UNIT=LISTOUT, FILE= TRIM(OUTFILE), FORM = 'UNFORMATTED')
!
!MODULE_ABCI
         WRITE(LISTOUT) NSOLD
         WRITE(LISTOUT) AI
	 WRITE(LISTOUT) BI
!MODULE ACMCLD
	 WRITE(LISTOUT) NCLOD    
	 WRITE(LISTOUT) TCLOD      
	 WRITE(LISTOUT) NCFRCV
	 WRITE(LISTOUT) NCFRST
	 WRITE(LISTOUT) ACFRCV
	 WRITE(LISTOUT) ACFRST  
!MODULE_ACMCLH 
         WRITE(LISTOUT) NHEAT
         WRITE(LISTOUT) THEAT
         WRITE(LISTOUT) AVRAIN
         WRITE(LISTOUT) AVCNVC
         WRITE(LISTOUT) ARATIM
         WRITE(LISTOUT) ACUTIM
         WRITE(LISTOUT) TRAIN
         WRITE(LISTOUT) TCUCN 
!MODULE_ACMPRE
	 WRITE(LISTOUT) TPREC
         WRITE(LISTOUT) ACSNOW
         WRITE(LISTOUT) ACSNOM 
         WRITE(LISTOUT) SSROFF
         WRITE(LISTOUT) BGROFF 
!MODULE_ACMRDL
	 WRITE(LISTOUT) NRDLW
	 WRITE(LISTOUT) ARDLW
	 WRITE(LISTOUT) TRDLW
         WRITE(LISTOUT) RLWIN
         WRITE(LISTOUT) RLWOUT 
         WRITE(LISTOUT) RLWTOA 
         WRITE(LISTOUT) ALWIN
         WRITE(LISTOUT) ALWOUT
         WRITE(LISTOUT) ALWTOA 
         WRITE(LISTOUT) RLWTT 
!MODULE_ACMRDS
	 WRITE(LISTOUT) NRDSW 
	 WRITE(LISTOUT) ARDSW
	 WRITE(LISTOUT) TRDSW
         WRITE(LISTOUT) RSWIN 
         WRITE(LISTOUT) RSWOUT
         WRITE(LISTOUT) RSWTOA
         WRITE(LISTOUT) ASWIN
         WRITE(LISTOUT) ASWOUT
         WRITE(LISTOUT) ASWTOA
         WRITE(LISTOUT) RSWTT
!MODULE_ACMSFC
	 WRITE(LISTOUT) NSRFC
	 WRITE(LISTOUT) ASRFC
	 WRITE(LISTOUT) TSRFC
	 WRITE(LISTOUT) APHTIM
	 WRITE(LISTOUT) SFCSHX
	 WRITE(LISTOUT) SFCLHX  								     &
	 WRITE(LISTOUT) SUBSHX 
	 WRITE(LISTOUT) SNOPCX  								     &
	 WRITE(LISTOUT) SFCUVX 
	 WRITE(LISTOUT) SFCEVP  								     &
	 WRITE(LISTOUT) POTEVP  
	 WRITE(LISTOUT) POTFLX
!MODULE_ASTSAV
	 WRITE(LISTOUT) SOLC    
	 WRITE(LISTOUT) RSIN1
	 WRITE(LISTOUT) RCOS1
	 WRITE(LISTOUT) RCOS2
!MODULE_BANDTA
         WRITE(LISTOUT) ARNDM
	 WRITE(LISTOUT) BRNDM  
	 WRITE(LISTOUT) BETAD   
	 WRITE(LISTOUT) AP     
	 WRITE(LISTOUT) BP      
	 WRITE(LISTOUT) ATP    
	 WRITE(LISTOUT) BTP    
	 WRITE(LISTOUT) BANDLO
	 WRITE(LISTOUT) BANDHI
         WRITE(LISTOUT) AO3RND  
	 WRITE(LISTOUT) BO3RND
	 WRITE(LISTOUT) AB15
         WRITE(LISTOUT) ARNDM1
	 WRITE(LISTOUT) ARNDM2  							
         WRITE(LISTOUT) BRNDM1  
         WRITE(LISTOUT) BRNDM2  							
         WRITE(LISTOUT) AP1    
         WRITE(LISTOUT) AP2     							
         WRITE(LISTOUT) BP1    
         WRITE(LISTOUT) BP2     							
         WRITE(LISTOUT) ATP1   
         WRITE(LISTOUT) ATP2    							
         WRITE(LISTOUT) BTP1   
         WRITE(LISTOUT) BTP2    							
         WRITE(LISTOUT) BETAD1  
         WRITE(LISTOUT) BETAD2  							
         WRITE(LISTOUT) BANDL1  
         WRITE(LISTOUT) BANDL2  							
         WRITE(LISTOUT) BANDH1 
         WRITE(LISTOUT) BANDH2   
         WRITE(LISTOUT) ARNDM3  							
         WRITE(LISTOUT) BRNDM3  							
         WRITE(LISTOUT) AP3     							
         WRITE(LISTOUT) BP3     							
         WRITE(LISTOUT) ATP3    							
         WRITE(LISTOUT) BTP3    							
         WRITE(LISTOUT) BETAD3  							
         WRITE(LISTOUT) BANDL3  							
         WRITE(LISTOUT) BANDH3
!MODULE_BDCOMB
         WRITE(LISTOUT) IBAND
         WRITE(LISTOUT) ACOMB
         WRITE(LISTOUT) BCOMB
         WRITE(LISTOUT) BETACM
         WRITE(LISTOUT) APCM
         WRITE(LISTOUT), BPCM
         WRITE(LISTOUT) ATPCM
         WRITE(LISTOUT) BTPCM
         WRITE(LISTOUT) BDLOCM
         WRITE(LISTOUT) BDHICM
         WRITE(LISTOUT) AB15CM
         WRITE(LISTOUT) AO3CM 
         WRITE(LISTOUT) BO3CM
         WRITE(LISTOUT) BETINC
!MODULE_BDWIDE
         WRITE(LISTOUT) AWIDE  
         WRITE(LISTOUT) BWIDE  
         WRITE(LISTOUT) BETAWD 
         WRITE(LISTOUT) APWD   
         WRITE(LISTOUT) BPWD   
         WRITE(LISTOUT) ATPWD  
         WRITE(LISTOUT) BTPWD  
         WRITE(LISTOUT) BDLOWD 
         WRITE(LISTOUT) BDHIWD 
         WRITE(LISTOUT) BETINW 
         WRITE(LISTOUT) AB15WD 
         WRITE(LISTOUT) SKO2D  
         WRITE(LISTOUT) SKC1R	
         WRITE(LISTOUT) SKO3R
!MODULE_BOCO	 
	 WRITE(LISTOUT) PDB
	 WRITE(LISTOUT) TB
	 WRITE(LISTOUT) QB
	 WRITE(LISTOUT) UB
	 WRITE(LISTOUT) VB
	 WRITE(LISTOUT) Q2B
	 WRITE(LISTOUT) CWMB     
!MODULE_BUFFER
	 WRITE(LISTOUT) IP
	 WRITE(LISTOUT) BUF
!MODULE_C_FRACN
	 WRITE(LISTOUT) F_ICE	   									  
	 WRITE(LISTOUT) F_RAIN     									  
	 WRITE(LISTOUT) F_RIMEF
!MODULE_CLDWTR
	 WRITE(LISTOUT) CWM
	 WRITE(LISTOUT) LC
	 WRITE(LISTOUT) U00
	 WRITE(LISTOUT) SR
	 WRITE(LISTOUT) UL
!MODULE_CMICRO_CONS
	 WRITE(LISTOUT)	ABFR		  
	 WRITE(LISTOUT)	CBFR	
	 WRITE(LISTOUT) CIACW 
	 WRITE(LISTOUT)	CIACR	      
	 WRITE(LISTOUT) C_N0R0
	 WRITE(LISTOUT)	CN0R0	      
	 WRITE(LISTOUT) CN0R_DMRMIN
	 WRITE(LISTOUT)	CN0R_DMRMAX   
	 WRITE(LISTOUT) CRACW 
	 WRITE(LISTOUT)	CRAUT	      
	 WRITE(LISTOUT) ESW0  
	 WRITE(LISTOUT)	QAUT0	
	 WRITE(LISTOUT)	RFMAX	
	 WRITE(LISTOUT)	RHGRD	      
	 WRITE(LISTOUT) RQR_DR1
	 WRITE(LISTOUT)	RQR_DR2 
	 WRITE(LISTOUT)	RQR_DR3 
	 WRITE(LISTOUT)	RQR_DRMIN
	 WRITE(LISTOUT)	RQR_DRMAX
	 WRITE(LISTOUT) RR_DR1
	 WRITE(LISTOUT)	RR_DR2  
	 WRITE(LISTOUT)	RR_DR3  
	 WRITE(LISTOUT)	RR_DRMIN	  
	 WRITE(LISTOUT)	RR_DRMAX
!MODULE_CMICRO_START
         WRITE(LISTOUT)	CMICRO_START
!MODULE_CMICRO_STATS
         WRITE(LISTOUT)	NSTATS
         WRITE(LISTOUT)	QMAX
         WRITE(LISTOUT)	QTOT
!MODULE_CMY600
         WRITE(LISTOUT)	MY_GROWTH
!MODULE_CNVCLD
         WRITE(LISTOUT)	CUPPT
	 WRITE(LISTOUT) CFRACL  
	 WRITE(LISTOUT) CFRACM 
	 WRITE(LISTOUT) CFRACH
!MODULE_CO2BD2
	 WRITE(LISTOUT)CO231
	 WRITE(LISTOUT)CO238
	 WRITE(LISTOUT)CDT31
	 WRITE(LISTOUT)CDT38
	 WRITE(LISTOUT)C2D31
	 WRITE(LISTOUT)C2D38
!MODULE_CO2BD3
	 WRITE(LISTOUT)CO251
	 WRITE(LISTOUT)CO258
	 WRITE(LISTOUT)CDT51
	 WRITE(LISTOUT)CDT58
	 WRITE(LISTOUT)C2D51
	 WRITE(LISTOUT)C2D58
	 WRITE(LISTOUT)CO2M51
	 WRITE(LISTOUT)CO2M58
	 WRITE(LISTOUT)CDTM51
	 WRITE(LISTOUT)CDTM58
	 WRITE(LISTOUT)C2DM51
	 WRITE(LISTOUT)C2DM58 
	 WRITE(LISTOUT)STEMP
	 WRITE(LISTOUT)GTEMP
!MODULE_CO2BD4
	 WRITE(LISTOUT) CO271
	 WRITE(LISTOUT) CO278
	 WRITE(LISTOUT) CDT71
	 WRITE(LISTOUT) CDT78
 	 WRITE(LISTOUT) C2D71
 	 WRITE(LISTOUT) C2D78
!MODULE_CO2BD5
         WRITE(LISTOUT) CO211
	 WRITE(LISTOUT) CO218
!MODULE_COMPVS0
         WRITE(LISTOUT) C1XPVS0
         WRITE(LISTOUT) C2XPVS0
         WRITE(LISTOUT) TBPVS0
!MODULE_COMPVS
         WRITE(LISTOUT) C1XPVS
         WRITE(LISTOUT) C2XPVS
         WRITE(LISTOUT) TBPVS
!MODULE_CONTIN
	 WRITE(LISTOUT) PDSL
         WRITE(LISTOUT) PDSLO
	 WRITE(LISTOUT) PSDT
	 WRITE(LISTOUT) RTOP
	 WRITE(LISTOUT) OMGALF
	 WRITE(LISTOUT) DIV
	 WRITE(LISTOUT) ETADT
!MODULE_C_TADJ
 	 WRITE(LISTOUT) T_ADJ
	 WRITE(LISTOUT) T_OLD
!MODULE_CTLBLK
 	 WRITE(LISTOUT) RUN 
 	 WRITE(LISTOUT) FIRST   
 	 WRITE(LISTOUT) RESTRT  
 	 WRITE(LISTOUT) SIGMA   
 	 WRITE(LISTOUT) NEST    
 	 WRITE(LISTOUT) SINGLRST
 	 WRITE(LISTOUT) SUBPOST
 	 WRITE(LISTOUT) IHRST   
 	 WRITE(LISTOUT) NFCST   
 	 WRITE(LISTOUT) NBC     
 	 WRITE(LISTOUT) LIST    
 	 WRITE(LISTOUT) IOUT    
 	 WRITE(LISTOUT) NTSD    
 	 WRITE(LISTOUT) NTSTM   
 	 WRITE(LISTOUT) NSTART  
 	 WRITE(LISTOUT) NTDDMP  
 	 WRITE(LISTOUT) NPREC	
 	 WRITE(LISTOUT) IDTAD	
 	 WRITE(LISTOUT) NBOCO	
 	 WRITE(LISTOUT) NSHDE	
 	 WRITE(LISTOUT) NCP	
 	 WRITE(LISTOUT) NPHS	
 	 WRITE(LISTOUT) NCNVC	
 	 WRITE(LISTOUT) NRADS	
 	 WRITE(LISTOUT) NRADL 
 	 WRITE(LISTOUT) IDAT
 	 WRITE(LISTOUT) DT
!MODULE_CUINIT
         WRITE(LISTOUT) CURAD
!MODULE_CUPARM, 
!         ONLY PARAMETER
!MODULE_DIUCON
         WRITE(LISTOUT) SEASON
         WRITE(LISTOUT) XXXX
         WRITE(LISTOUT) JDNMC
         WRITE(LISTOUT) FCSTDA
         WRITE(LISTOUT) FJDNMC
         WRITE(LISTOUT) TSLAG
         WRITE(LISTOUT) RLAG
         WRITE(LISTOUT) TIMIN
         WRITE(LISTOUT) TPI 
         WRITE(LISTOUT) HPI   
         WRITE(LISTOUT) YEAR
         WRITE(LISTOUT) DAY    
         WRITE(LISTOUT) DHR
         WRITE(LISTOUT) JTIME
         WRITE(LISTOUT) DAZ
!MODULE_DYNAM
         WRITE(LISTOUT) PT
         WRITE(LISTOUT) R      
         WRITE(LISTOUT) DY
         WRITE(LISTOUT) CPGFV
         WRITE(LISTOUT) EN
         WRITE(LISTOUT) ENT   
         WRITE(LISTOUT) F4D
         WRITE(LISTOUT) F4Q   
         WRITE(LISTOUT) EF4T  
         WRITE(LISTOUT) AETA
         WRITE(LISTOUT) DETA  
         WRITE(LISTOUT) RDETA
         WRITE(LISTOUT) F4Q2  
         WRITE(LISTOUT) ETA   
         WRITE(LISTOUT) DFL
         WRITE(LISTOUT) EM 
         WRITE(LISTOUT) EMT
         WRITE(LISTOUT) DX  
         WRITE(LISTOUT) WPDAR 
         WRITE(LISTOUT) CPGFU
         WRITE(LISTOUT) CURV  
         WRITE(LISTOUT) FCP   
         WRITE(LISTOUT) FDIV  
         WRITE(LISTOUT) F     
         WRITE(LISTOUT) DDMPU 
         WRITE(LISTOUT) DDMPV 
         WRITE(LISTOUT) FAD
!MODULE_EXCH_BUF_REAL
         WRITE(LISTOUT) BUF0
         WRITE(LISTOUT) BUF1
         WRITE(LISTOUT) BUF2
         WRITE(LISTOUT) BUF3
!MODULE_GLB_TABLE
         WRITE(LISTOUT) IS_GLB_TABLE
         WRITE(LISTOUT) IE_GLB_TABLE    
         WRITE(LISTOUT) JS_GLB_TABLE
         WRITE(LISTOUT) JE_GLB_TABLE
!MODULE_HCON
!MODULE_IACCR_TABLES
         WRITE(LISTOUT) ACCRI
!MODULE_IMASS_TABLES
         WRITE(LISTOUT) MASSI
!MODULE_INDX
!         WRITE(LISTOUT)IHE
!         WRITE(LISTOUT)IVE
!         WRITE(LISTOUT)IHW
!         WRITE(LISTOUT)IHW
!         WRITE(LISTOUT)IRAD
!         WRITE(LISTOUT)IHEG
!         WRITE(LISTOUT)IVEG
!         WRITE(LISTOUT)IHWG
!         WRITE(LISTOUT)IVWG
!         WRITE(LISTOUT)IRADG
!MODULE_INPUT
         WRITE(LISTOUT) ICH     
         WRITE(LISTOUT) ICM     
         WRITE(LISTOUT) ICT     
         WRITE(LISTOUT) ICB
         WRITE(LISTOUT) CH      
         WRITE(LISTOUT) CM      
         WRITE(LISTOUT) CL      
         WRITE(LISTOUT) EMCH    
         WRITE(LISTOUT) EMCM    
         WRITE(LISTOUT) EMCL
         WRITE(LISTOUT) RR      
         WRITE(LISTOUT) QQO3
         WRITE(LISTOUT) DTEMP   
         WRITE(LISTOUT) PPRESS 
!MODULE_IRATE_TABLES
         WRITE(LISTOUT) VSNOWI
!MODULE_IRIME_TABLES
         WRITE(LISTOUT) VEL_RF
!MODULE_IVENT_TABLES	 
         WRITE(LISTOUT) VENTI1
         WRITE(LISTOUT) VENTI2	 
!MODULE_LOOPS	 
	 WRITE(LISTOUT) IHLA
	 WRITE(LISTOUT) IHHA
	 WRITE(LISTOUT) IVLA
	 WRITE(LISTOUT) IVHA
	 WRITE(LISTOUT) JRA	 
	 WRITE(LISTOUT) LMH
	 WRITE(LISTOUT) LMV
!MODULE MAPOT
         WRITE(LISTOUT) LSL
         WRITE(LISTOUT) IXM
	 WRITE(LISTOUT) IYM
         WRITE(LISTOUT) ISHDE
         WRITE(LISTOUT) TSPH
         WRITE(LISTOUT) WBD
         WRITE(LISTOUT) SBD
         WRITE(LISTOUT) TLM0D
         WRITE(LISTOUT) TPH0D
         WRITE(LISTOUT) DLMD
	 WRITE(LISTOUT) DPHD
         WRITE(LISTOUT) CMLD
         WRITE(LISTOUT) DP30
         WRITE(LISTOUT) X1P
         WRITE(LISTOUT) Y1P
         WRITE(LISTOUT) DISLP
         WRITE(LISTOUT) Z0SLP
 	 WRITE(LISTOUT) SPL		 
	 WRITE(LISTOUT) ALSL 
	 WRITE(LISTOUT) TSHDE
	 WRITE(LISTOUT) ERLAM0 
	 WRITE(LISTOUT) CPHI0	 	 
	 WRITE(LISTOUT) SPHI0
!MODULE_MAPPINGS
	 WRITE(LISTOUT) G2LI    
	 WRITE(LISTOUT) L2GI
	 WRITE(LISTOUT) G2LJ
	 WRITE(LISTOUT) L2GJ
!MODULE_MASKS
	 WRITE(LISTOUT) VBM2    
	 WRITE(LISTOUT) VBM3    
	 WRITE(LISTOUT) SM      
	 WRITE(LISTOUT) SICE    
	 WRITE(LISTOUT) HBM2    
	 WRITE(LISTOUT) HBM3
	 WRITE(LISTOUT) HTM     
	 WRITE(LISTOUT) VTM
!MODULE_MOMENTO
	 WRITE(LISTOUT) UMFLX
	 WRITE(LISTOUT) VMFLX  
	 WRITE(LISTOUT) AKMS10
!MODULE_MPPCOM
         !colocar depois
!MODULE_NHYDRO
 	 WRITE(LISTOUT) HYDRO
 	 WRITE(LISTOUT) SPLINE	 
 	 WRITE(LISTOUT) DWDT
 	 WRITE(LISTOUT) PDWDT
 	 WRITE(LISTOUT) PINT	 
 	 WRITE(LISTOUT) W
 	 WRITE(LISTOUT) Z
!MODULE_NSOILTYPE
 	 WRITE(LISTOUT) NSOTYP
!MODULE_OPTIONS
 	 WRITE(LISTOUT) SPVAL
 	 WRITE(LISTOUT) IBESSL
 	 WRITE(LISTOUT) KSB     
 	 WRITE(LISTOUT) IOFFS   
 	 WRITE(LISTOUT) IFLAG   
 	 WRITE(LISTOUT) SATDEL
!MODULE_OUTFIL
 	 WRITE(LISTOUT) RSTFIL
 	 WRITE(LISTOUT) ITAG   
 	 WRITE(LISTOUT) LRSTRT
!MODULE_PHYCON
 	 WRITE(LISTOUT) AMOLWT  
 	 WRITE(LISTOUT) CSUBP   
 	 WRITE(LISTOUT) DIFFCTR 
 	 WRITE(LISTOUT) G       
 	 WRITE(LISTOUT) GRAVDR  
 	 WRITE(LISTOUT) O3DIFCTR
 	 WRITE(LISTOUT) P0      
 	 WRITE(LISTOUT) P0XZP2  
 	 WRITE(LISTOUT) P0XZP8  
 	 WRITE(LISTOUT) P0X2    
 	 WRITE(LISTOUT) RADCON  
 	 WRITE(LISTOUT) RGAS    
 	 WRITE(LISTOUT) RGASSP  
 	 WRITE(LISTOUT) SECPDA  
 	 WRITE(LISTOUT) RATCO2MW
 	 WRITE(LISTOUT) RATH2OMW                                                                       
 	 WRITE(LISTOUT) RADCON1                                                                        
 	 WRITE(LISTOUT) GINV    
 	 WRITE(LISTOUT) P0INV   
 	 WRITE(LISTOUT) GP0INV
!MODULE_PHYS
 	 WRITE(LISTOUT) KTM
 	 WRITE(LISTOUT) DTQ2    
 	 WRITE(LISTOUT) TDTQ2   
 	 WRITE(LISTOUT) DTD     
 	 WRITE(LISTOUT) TDTD    		   
 	 WRITE(LISTOUT) ROS     
 	 WRITE(LISTOUT) CS      
 	 WRITE(LISTOUT) DS      
 	 WRITE(LISTOUT) ROI     
 	 WRITE(LISTOUT) CI      
 	 WRITE(LISTOUT) DI      		   
 	 WRITE(LISTOUT) PL      
 	 WRITE(LISTOUT) THL     
 	 WRITE(LISTOUT) RDQ     
 	 WRITE(LISTOUT) RDTH    
 	 WRITE(LISTOUT) RDP     
 	 WRITE(LISTOUT) RDTHE   		   
 	 WRITE(LISTOUT) PLQ     
 	 WRITE(LISTOUT) RDPQ    
 	 WRITE(LISTOUT) RDTHEQ
 	 WRITE(LISTOUT) DFRLG
 	 WRITE(LISTOUT) QS0     
 	 WRITE(LISTOUT) SQS
 	 WRITE(LISTOUT) THE0    
 	 WRITE(LISTOUT) STHE
 	 WRITE(LISTOUT) THE0Q   
 	 WRITE(LISTOUT) STHEQ
 	 WRITE(LISTOUT) MXSNAL  
 	 WRITE(LISTOUT) EPSR	    				 
 	 WRITE(LISTOUT) RADIN
 	 WRITE(LISTOUT) RADOT	    				 
 	 WRITE(LISTOUT) GLAT
 	 WRITE(LISTOUT) GLON	    				 
 	 WRITE(LISTOUT) CZEN	    				 
 	 WRITE(LISTOUT) HTOP
 	 WRITE(LISTOUT) HBOT	    				 
 	 WRITE(LISTOUT) CNVTOP 
 	 WRITE(LISTOUT) CNVBOT      				 
 	 WRITE(LISTOUT) TG
 	 WRITE(LISTOUT) GFFC	    				 
 	 WRITE(LISTOUT) SST
 	 WRITE(LISTOUT) ALBASE      				 
 	 WRITE(LISTOUT) ALBEDO      				 
 	 WRITE(LISTOUT) HDAC
 	 WRITE(LISTOUT) HDACV	    				 
 	 WRITE(LISTOUT) CZMEAN 
 	 WRITE(LISTOUT) SIGT4
 	 WRITE(LISTOUT) PTBL
 	 WRITE(LISTOUT) TTBL
 	 WRITE(LISTOUT) TTBLQ
!MODULE_PPTASM
 	 WRITE(LISTOUT) MTSTPE  
 	 WRITE(LISTOUT) ITSTLOC 
 	 WRITE(LISTOUT) JTSTLOC 
 	 WRITE(LISTOUT) PHOUR   								     
 	 WRITE(LISTOUT) APREC
 	 WRITE(LISTOUT) TLATCU  								     
 	 WRITE(LISTOUT) TLATGS
 	 WRITE(LISTOUT) PPTDAT
!MODULE_PRFHLD
 	 WRITE(LISTOUT) TLMIN  
 	 WRITE(LISTOUT) TLMAX 
!MODULE_PVRBLS  
 	 WRITE(LISTOUT) Z0
 	 WRITE(LISTOUT) USTAR
 	 WRITE(LISTOUT) UZ0 
 	 WRITE(LISTOUT) VZ0 
 	 WRITE(LISTOUT) THZ0   
 	 WRITE(LISTOUT) QZ0   
 	 WRITE(LISTOUT) THS
 	 WRITE(LISTOUT) QS
 	 WRITE(LISTOUT) AKMS 
 	 WRITE(LISTOUT) AKHS 
 	 WRITE(LISTOUT) RF
 	 WRITE(LISTOUT) TWBS 
 	 WRITE(LISTOUT) QWBS 
 	 WRITE(LISTOUT) SNO 
 	 WRITE(LISTOUT) SI
 	 WRITE(LISTOUT) CLDEFI 
 	 WRITE(LISTOUT) PREC
 	 WRITE(LISTOUT) ACPREC    
 	 WRITE(LISTOUT) ACCLIQ
 	 WRITE(LISTOUT) CUPREC
 	 WRITE(LISTOUT) TH100
 	 WRITE(LISTOUT) Q100
 	 WRITE(LISTOUT) U100
 	 WRITE(LISTOUT) V100
 	 WRITE(LISTOUT) TH10    
 	 WRITE(LISTOUT) Q10     
 	 WRITE(LISTOUT) U10
 	 WRITE(LISTOUT) V10
 	 WRITE(LISTOUT) TSHLTR
 	 WRITE(LISTOUT) TSHLTR1
 	 WRITE(LISTOUT) QSHLTR
 	 WRITE(LISTOUT) PSHLTR    
 	 WRITE(LISTOUT) XMOMFLUX
 	 WRITE(LISTOUT) YMOMFLUX
         WRITE(LISTOUT) Q2   
!MODULE_RACCR_TABLES    
         WRITE(LISTOUT) ACCRR
!MODULE_RD1TIM
         WRITE(LISTOUT) K400
         WRITE(LISTOUT) RAD1
         WRITE(LISTOUT) CTHK
         WRITE(LISTOUT) TAUCV
         WRITE(LISTOUT) PTOPC
         WRITE(LISTOUT) LTOP
         WRITE(LISTOUT) LVL
!MODULE_RDFSAV
         WRITE(LISTOUT) EMISP   
         WRITE(LISTOUT) EMIST   
         WRITE(LISTOUT) XLATT   
         WRITE(LISTOUT) XLATP   
         WRITE(LISTOUT) Q19001  
         WRITE(LISTOUT) HP98    
         WRITE(LISTOUT) H3M6    
         WRITE(LISTOUT) HP75    
         WRITE(LISTOUT) H6M2    
         WRITE(LISTOUT) HP537   
         WRITE(LISTOUT) H74E1   
         WRITE(LISTOUT) H15E1   
         WRITE(LISTOUT) Q14330  
         WRITE(LISTOUT) HP2     
         WRITE(LISTOUT) TWENTY  
         WRITE(LISTOUT) HNINE   
         WRITE(LISTOUT) DEGRAD  
         WRITE(LISTOUT) HSIGMA 
         WRITE(LISTOUT) DAYSEC  
         WRITE(LISTOUT) RCO2
         WRITE(LISTOUT) CAO3SW  
         WRITE(LISTOUT) CAH2SW  
         WRITE(LISTOUT) CBSW
!MODULE_RITE
         WRITE(LISTOUT) BETA    
         WRITE(LISTOUT) DRIP    
         WRITE(LISTOUT) EC      
         WRITE(LISTOUT) EDIR    
         WRITE(LISTOUT) ETT     
         WRITE(LISTOUT) FLX1    
         WRITE(LISTOUT) FLX2    
         WRITE(LISTOUT) FLX3    
         WRITE(LISTOUT) RUNOF   
         WRITE(LISTOUT) DEW     
         WRITE(LISTOUT) RIB     
         WRITE(LISTOUT) RUNOFF3
!MODULE_RMASS_TABLES
         WRITE(LISTOUT) MASSR
!MODULE_RRATE_TABLES
         WRITE(LISTOUT) RRATE
!MODULE_RVELR_TABLES
         WRITE(LISTOUT) VRAIN
!MODULE_RVENT_TABLES
         WRITE(LISTOUT) VENTR1
         WRITE(LISTOUT) VENTR2
!MODULE_SAVEMEM
         WRITE(LISTOUT) DDUO3N
         WRITE(LISTOUT) DDO3N2  
         WRITE(LISTOUT) DDO3N3  
         WRITE(LISTOUT) DDO3N4
         WRITE(LISTOUT) RAD1    
         WRITE(LISTOUT) RAD2    
         WRITE(LISTOUT) RAD3    
         WRITE(LISTOUT) RAD4
!MODULE_SCRTCH
         WRITE(LISTOUT) SUM    
	 WRITE(LISTOUT) PERTSM 
	 WRITE(LISTOUT) SUM3   
	 WRITE(LISTOUT) SUMWDE
         WRITE(LISTOUT) SRCWD
         WRITE(LISTOUT) SRC1NB 
         WRITE(LISTOUT) DBDTNB
         WRITE(LISTOUT) ZMASS  
	 WRITE(LISTOUT) ZROOT
         WRITE(LISTOUT) SC     
         WRITE(LISTOUT) DSC    
         WRITE(LISTOUT) XTEMV
         WRITE(LISTOUT) TFOUR
         WRITE(LISTOUT) FORTCU
         WRITE(LISTOUT) X     
         WRITE(LISTOUT) X1
         WRITE(LISTOUT) SRCS 
         WRITE(LISTOUT) SUM4 
         WRITE(LISTOUT) SUM6
         WRITE(LISTOUT) SUM7	
	 WRITE(LISTOUT) SUM8	
	 WRITE(LISTOUT) SUM4WD  
	 WRITE(LISTOUT) R1  	 
         WRITE(LISTOUT) R2	
         WRITE(LISTOUT) S2	
         WRITE(LISTOUT) T3   
         WRITE(LISTOUT) R1WD
	 WRITE(LISTOUT) X2	
         WRITE(LISTOUT) EXPO	
         WRITE(LISTOUT) FAC
         WRITE(LISTOUT) CNUSB	
         WRITE(LISTOUT) DNUSB
         WRITE(LISTOUT) ALFANB  
         WRITE(LISTOUT) AROTNB
         WRITE(LISTOUT) ANB	
         WRITE(LISTOUT) BNB	
         WRITE(LISTOUT) CENTNB  
         WRITE(LISTOUT) DELNB	
         WRITE(LISTOUT) BETANB
!MODULE_SDENS_TABLES
         WRITE(LISTOUT) SDENS
!MODULE_SEASO3
	 WRITE(LISTOUT) XDUO3N
	 WRITE(LISTOUT) XDO3N2
	 WRITE(LISTOUT) XDO3N3
	 WRITE(LISTOUT) XDO3N4
	 WRITE(LISTOUT) PRGFDL
	 WRITE(LISTOUT) O3O3
	 WRITE(LISTOUT) XRAD1
	 WRITE(LISTOUT) XRAD2
	 WRITE(LISTOUT) XRAD3
	 WRITE(LISTOUT) XRAD4
!MODULE_SLOPES
         WRITE(LISTOUT) ISLD
         WRITE(LISTOUT) VTMS 
!MODULE_SOIL	  
         WRITE(LISTOUT) IVGTYP 
         WRITE(LISTOUT) ISLTYP 
	 WRITE(LISTOUT) ISLOPE
         WRITE(LISTOUT) SOILTB
         WRITE(LISTOUT) SFCEXC
	 WRITE(LISTOUT) SMSTAV
	 WRITE(LISTOUT) SMSTOT
         WRITE(LISTOUT) GRNFLX 
         WRITE(LISTOUT) PCTSNO
         WRITE(LISTOUT) VEGFRC 
         WRITE(LISTOUT) CMC
	 WRITE(LISTOUT) CTC
	 WRITE(LISTOUT) SH2O
	 WRITE(LISTOUT) SLDPTH
	 WRITE(LISTOUT) RTDPTH	 
!MODULE_SSALB	 
	 WRITE(LISTOUT) ZA
	 WRITE(LISTOUT) TRN
	 WRITE(LISTOUT) DZA
	 WRITE(LISTOUT) ALBD
	 WRITE(LISTOUT) ALB1
	 WRITE(LISTOUT) ALB2
	 WRITE(LISTOUT) ALB3	 
!MODULE_SWRSAV 
	 WRITE(LISTOUT) ABCFF
	 WRITE(LISTOUT) PWTS
	 WRITE(LISTOUT) CFCO2  
	 WRITE(LISTOUT) CFO3   
	 WRITE(LISTOUT) REFLO3 
	 WRITE(LISTOUT) RRAYAV
!MODULE_TABCOM
         !colocar depois
!MODULE_TEMPV
         WRITE(LISTOUT) P0
         WRITE(LISTOUT) T0
	 WRITE(LISTOUT) Q0
!MODULE_TOPO
         WRITE(LISTOUT) TEMP2X
         WRITE(LISTOUT) TTVG
	 WRITE(LISTOUT) HTMG
!MODULE_VRBLS
         WRITE(LISTOUT) PD
         WRITE(LISTOUT) FIS
         WRITE(LISTOUT) RES
         WRITE(LISTOUT) T
         WRITE(LISTOUT) U
         WRITE(LISTOUT) V
         WRITE(LISTOUT) Q
!MODULE_UPDT
         !colocar depois
!MODULE_Z0EFFT
	 WRITE(LISTOUT) ZEFFIJ
!
	 CLOSE(LISTOUT)
	 
	 IF (MYPE == 0) THEN
            WRITE(*,*) ' OU2RESTRT: END OF WRITING'
            WRITE(*,*) ' '
         END IF
   
    END SUBROUTINE OUT2RESTRT

    SUBROUTINE CUCNVC
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE CUCNVC
!>
!> SUBPROGRAM: CUCNVC - CONVECTIVE PRECIPITATION PARAMETERIZATION
!> PROGRAMMER: JANJIC
!> ORG: W/NP2 
!> DATE: 93-11-02
!>
!> ABSTRACT:
!> CUCNVC CALCULATES THE SUB-GRID SCALE CONVECTION INCLUDING DEEP AND SHALLOW CONVECTIVE CLOUDS 
!> FOLLOWING THE SCHEME DESCRIBED BY JANJIC (1994) BUT WITH SIGNIFICANT MODIFICATIONS.
!> IN ADDITION, THE LATENT HEAT RELEASE AND MOISTURE CHANGE DUE TO PRECIPITATING AND NON -
!> PRECIPITATING CLOUDS ARE COMPUTED.
!>
!> PROGRAM HISTORY LOG:
!> 87-09-??  JANJIC     - ORIGINATOR
!> 90-11-21  JANJIC     - TWO SETS OF DSP PROFILES (FAST AND SLOW) REPLACE THE ORIGINAL ONE SET
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-11-02  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLH
!>              CNVCLD
!>              CTLBLK
!>              CUPARM
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PPTASM
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>  
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : TTBLEX
!>              ZERO2
!>-------------------------------------------------------------------------------------------------- 
!
!-----------------------------------------------------------------------------------------
! REFERENCES:                                                 
!
! JANJIC, Z.I., 1994:  THE STEP-MOUNTAIN ETA COORDINATE MODEL:
! FURTHER DEVELOPMENTS OF THE CONVECTION, VISCOUS SUBLAYER AND TURBULENCE CLOSURE SCHEMES.  
! MONTHLY WEATHER REVIEW, VOL. 122, 927-945.
!-----------------------------------------------------------------------------------------
!
!-----------------------------------------------------------------------
! WARNING: THIS SUBROUTINE WILL NOT WORK IF (LM .LT. 12);
! MUST BE CALLED IN THE SAME STEP WITH PROFQ2 BECAUSE PROFQ DEFINES APE;
!-----------------------------------------------------------------------
    USE ACMCLH
    USE CNVCLD
    USE CTLBLK
    USE CUPARM
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PPTASM
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & UNIS    , UNIL    , OCT90
!
    NAMELIST /CUPARMDATA/                                                                         &
    & STABS   , STABD   , STABFC  , DTTOP   ,                                                     &
    & RHF     , EPSUP   , EPSDN   , EPSTH   ,                                                     &
    & PBM     , PQM     , PNO     , PONE    , PSH     ,                                           &
    & PFRZ    , PSHU    ,                                                                         &
    & UNIS    , UNIL    , OCT90   ,                                                                &
    & FSS     , EFIMN   , EFMNT   , FCC     ,                                                     &
    & DSPBFL  , DSP0FL  , DSPTFL  , FSL     ,                                                     &
    & DSPBFS  , DSP0FS  , DSPTFS  ,                                                               &
    & TREL    , EPSNTP  , EFIFC   ,                                                               &
    & DSPC    , EPSP    ,                                                                         &
    & STEFI
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
!
!------------------------------
! INSTABILITY FOR TOO LARGE LSH
!------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 0
    INTEGER(KIND=I4KIND), PARAMETER :: NROW  = 0
!--------------------------------------------------------------
! INSTABILITY FOR TOO LARGE LSH
!
! LP1=LM+1,LM1=LM-1,LNO=1,LSH=LM/3-1,LSHU=LM/2-1,LQM=LM/5,KBM=3
! LP1=LM+1,LM1=LM-1,LNO=1,LSH=LM/3  ,LSHU=LM/2-1,LQM=LM/5,KBM=3
! LP1=LM+1,LM1=LM-1,LNO=3,LSH=LM/3  ,LSHU=LM/2-1,LQM=LM/5,KBM=3
! LP1=LM+1,LM1=LM-1,LNO=2,LSH=LM/3-1,LSHU=LM/2-1,LQM=LM/5,KBM=3
! LP1=LM+1,LM1=LM-1,LNO=2,LSH=LM/3-2,LSHU=LM/2-1,LQM=LM/5,KBM=3
!--------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM     = IM    * JM    - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM_LOC = IDIM2 * JDIM2
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & TREFK   , QREFK   , PK      , APEK    , TK      ,                                           &
    & THSK    , PSK     , APESK   , QK      , THERK   ,                                           &
    & THVREF  , THEVRF  , THVMOD  , DIFT    , DIFQ    ,                                           &
    & QSATK   , FPK
!
    INTEGER(KIND=I4KIND), DIMENSION(LM)                                                         ::&
    & NTOPD   , NBOTD   , NTOPS   , NBOTS   ,                                                     &
    & NDPTHD  , NDPTHS
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & LTOP    , LBOT    ,                                                                         &
    & IPTB    , ITHTB
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PTOP    , PBOT    ,                                                                         &
    & PDSL    , APEBT   ,                                                                         &
    & TBT     , Q2BT    ,                                                                         &
    & QQ      , PP      ,                                                                         &
    & PSP     , THBT    ,                                                                         &
    & THESP   , P       ,                                                                         &
    & BTH     , STH     ,                                                                         &
    & T00     , T10     ,                                                                         &
    & T01     , T11     ,                                                                         &
    & WF1     , WF2     ,                                                                         &
    & WF3     , WF4     ,                                                                         &
    & PRECOL
!
    INTEGER(KIND=I4KIND), DIMENSION(IMJM_LOC)                                                   ::&
    &  IBUOY  , JBUOY   ,                                                                         &
    &  IDEEP  , JDEEP   ,                                                                         &
    &  ISHAL  , JSHAL   ,                                                                         &
    &  ILRES  , JLRES   ,                                                                         &
    &  IHRES  , JHRES
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & APE     ,                                                                                   &
    & TREF    ,                                                                                   &
    & TMOD    ,                                                                                   &
    & QMOD
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DSPB    , DSP0    ,                                                                         &
    & DSPT    ,                                                                                   &
    & TL      ,   QL    ,                                                                         &
    & TNE     ,  TSE    ,                                                                         &
    & QNE     ,  QSE
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & STABS   , STABD   , STABFC  , DTTOP   , RHF     , EPSUP   , EPSDN   , EPSTH   , PBM     ,   &
    & PSHU    , FSS     , EFIMN   , EFMNT   , FCC     , DSPBFL  , DSP0FL  , DSPTFL  , FSL     ,   &
    & DSPBFS  , DSP0FS  , DSPTFS  , TREL    , PQM     , PNO     , PONE    , PFRZ    , PSH     ,   &
    & EPSNTP  , EFIFC   , DSPC    , EPSP    ,                                                     &
    & STEFI   , FCB     , DSPBSL  , DSP0SL  ,                                                     &
    & DSPTSL  , DSPBSS  , DSP0SS  , DSPTSS  ,                                                     &
    & AVGEFI  , SLOPBL  , SLOP0L  , SLOPTL  ,                                                     &
    & SLOPBS  , SLOP0S  , SLOPTS  , SLOPE   ,                                                     &
    & A23M4L  , ELOCP   , CPRLG   , RCP     ,                                                     &
    & DTCNVC  , RDTCNVC , TAUK    , APESTS  , PKL     ,                                           &
    & PSFCK   , QBT     , TTHBT   , TTH     , QQ1     , BQS00K  ,                                 &
    & SQS00K  , BQS10K  , SQS10K  , BQ      , SQ      , TQ      , PP1     , P00K    ,             &
    & P10K    , P01K    , P11K    , TPSP    ,                                                     &
    & APESP   , TTHES   , AETAL   , PRESK   , EFI     , SMK     , RSMK    ,                       &
    & PSHNEW  , PSFCIJ  , DEPMIN  , DEPTH   ,                                                     &
    & DSPBK   , DSP0K   , DSPTK   , TKL     , QKL     , APEKL   , PKB     , PKT     ,             &
    & PK0     , TREFKX  , THERKX  , APEKXX  ,                                                     &
    & THERKY  , APEKXY  , STABDL  , RDP0T   ,                                                     &
    & DTHEM   , DEPWL   , DSP     , SUMDP   , SUMDE   , HCORR   , TSKL    , DHDT    ,             &
    & THSKL   , DENTPY  , AVRGT   , PRECK   , DIFTL   , DIFQL   , AVRGTL  , PBTK    ,             &
    & PTPK    , RHH     , RHMAX   , RHL     , DRHDP   , DRHEAT  , FEFI    , PZ0     ,             &
    & THVMKL  , THTPK   , TTHK    , QQK     , BQK     , SQK     , TQK     , PPK     ,             &
    & PART1   , PART2   , PART3   , DPMIX   , SMIX    , PKXXXX  , SUMDT   , RDPSUM  ,             &
    & TCORR   , PKXXXY  , TRFKL   , PSUM    , QSUM    , POTSUM  , QOTSUM  , OTSUM   ,             &
    & DST     , FPTK    , DPKL    , RTBAR   , ROTSUM  , DSTQ    , DEN     , DQREF   ,             &
    & QRFTP   , QRFKL   , QNEW    , DTDETA  , CUTOP   , CUBOT
! 
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , KB      , NDSTN   , NDSTP   , LLMH    ,                       &
    & LMHK    , IQTB    , IQ      , IT      , NSHAL   , NEGDS   , NSMUD   ,                       &
    & LMHIJ   , KNUML   , KNUMH   , KROW    , KS      ,                                           &
    & KOUNT   , KHDEEP  , N       , LTPK    , ITTB    , ITTBK   ,                                 &
    & LBTK    , LB      , LTP1    , LBM1    ,                                                     &
    & L0      , L0M1    , ITER    , LCOR    ,                                                     &
    & LQM     , LTSH    , LSHU    , LTP2    ,                                                     &
    & NDEEP   , NDEPTH  , NNEG    , KHSHAL  
!
    OPEN(11,FILE='CUPARMDATA.dat',STATUS='OLD')
    REWIND 11
    READ(11,CUPARMDATA)
    CLOSE(11)
!
    FCB = 1. - FCC
    DSPBSL = DSPBFL * FSL
    DSP0SL = DSP0FL * FSL
    DSPTSL = DSPTFL * FSL
    DSPBSS = DSPBFS * FSS
    DSP0SS = DSP0FS * FSS
    DSPTSS = DSPTFS * FSS
!
    AVGEFI = (EFIMN + 1.) * .5
!
    SLOPBL = (DSPBFL-DSPBSL) / (1.-EFIMN)
    SLOP0L = (DSP0FL-DSP0SL) / (1.-EFIMN)
    SLOPTL = (DSPTFL-DSPTSL) / (1.-EFIMN)
    SLOPBS = (DSPBFS-DSPBSS) / (1.-EFIMN)
    SLOP0S = (DSP0FS-DSP0SS) / (1.-EFIMN)
    SLOPTS = (DSPTFS-DSPTSS) / (1.-EFIMN)
!
    SLOPE  = (1. - EFMNT) / (1. - EFIMN)
    A23M4L = A2 * (A3 - A4) * ELWV
    ELOCP  = ELIVW / CP
    CPRLG  = CP / (ROW * G * ELWV)
    RCP    = 1. / CP
!
    CALL ZERO2(DSP0)
    CALL ZERO2(DSPB)
    CALL ZERO2(DSPT)
    CALL ZERO2(PSP)
!
    AVCNVC  = AVCNVC + 1.
    ACUTIM  = ACUTIM + 1.
    DTCNVC  = NCNVC * DT
    RDTCNVC = 1. / DTCNVC
    TAUK    = DTCNVC / TREL
!----------------------------------------------
! POSSIBLE FUTURE CHANGE FOR SHALLOW CONVECTION
! TAUKSC=DTCNVC/(5.*TREL)
!----------------------------------------------
!
!------------
! DIAGNOSTICS
!------------
    DO K=1,LM
         NTOPD(K) = 0
         NBOTD(K) = 0
         NTOPS(K) = 0
         NBOTS(K) = 0
        NDPTHS(K) = 0
        NDPTHD(K) = 0
    END DO
!------------
!PREPARATIONS
!------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO 120 J=MYJS,MYJE
        DO 120 I=MYIS,MYIE
              LBOT(I,J) = LMH(I,J)
             THESP(I,J) = 0.
             PDSL (I,J) = RES(I,J) * PD(I,J)
            PRECOL(I,J) = 0.
            TREF(I,J,1) = T(I,J,1)
120 END DO
!---------------------------------------
! PADDING SPECIFIC HUMIDITY IF TOO SMALL
! RESTORE APE TO SCRATCH ARRAY
!---------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (APESTS)
!
    DO 130 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                APESTS     = PDSL(I,J) * AETA(K) + PT
                APE(I,J,K) = (1.E5 / APESTS) ** CAPA
                IF (Q(I,J,K) < EPSQ) Q(I,J,K) = HTM(I,J,K) * EPSQ
            END DO
        END DO
130 END DO
!----------------------------------
! SEARCH FOR MAXIMUM BUOYANCY LEVEL
!----------------------------------
    DO 170 KB=1,LM
!---------------------------------------
! TRIAL MAXIMUM BUOYANCY LEVEL VARIABLES
!---------------------------------------
!
!------- 
! OPENMP
!------- 
!$omp parallel do
!$omp private (APESP    , BQ      , BQS00K  , BQS10K  , IQ      , IT      , ITTB    , ITTBK   ,   &
!$omp          IQTB     , LMHK    , P00K    , P01K    , P10K    , P11K    , PKL     , PP1     ,   &
!$omp          PSFCK    , QBT     , QQ1     , SQ      , SQS00K  , SQS10K  , TPSP    , TQ      ,   &
!$omp          TTH      , TTHBT   , TTHES)
!
        DO 155 J=MYJS2,MYJE2
            DO 150 I=MYIS1,MYIE1
!            
                PKL   = AETA(KB)   * PDSL(I,J) + PT
                LMHK  = LMH(I,J)
                PSFCK = AETA(LMHK) * PDSL(I,J) + PT
!--------------------------------------------------------------------------------------------------
! NOW SEARCHING OVER A SCALED DEPTH IN FINDING THE PARCEL WITH THE MAX THETA-E INSTEAD OF THE OLD 
! 130 MB
!--------------------------------------------------------------------------------------------------
                IF (KB <= LMHK .AND. PKL >= 0.80*PSFCK) THEN
                    QBT   = Q(I,J,KB)
                    TTHBT = T(I,J,KB) * APE(I,J,KB)
                    TTH   = (TTHBT-THL) * RDTH
                    QQ1   = TTH - AINT(TTH)
                    ITTB  = INT(TTH) + 1
!---------------------------------
! KEEPING INDICES WITHIN THE TABLE
!---------------------------------
                    IF (ITTB < 1) THEN
                        ITTB = 1
                        QQ1 = 0.
                    END IF
!
                    IF (ITTB >= JTB) THEN
                        ITTB = JTB - 1
                        QQ1 = 0.
                    END IF
!
                    CONTINUE
!-------------------------------------------
! BASE AND SCALING FACTOR FOR SPEC. HUMIDITY
!-------------------------------------------
                    ITTBK  = ITTB
                    BQS00K = QS0(ITTBK)
                    SQS00K = SQS(ITTBK)
                    BQS10K = QS0(ITTBK+1)
                    SQS10K = SQS(ITTBK+1)
!---------------------------------------
! SCALING SPEC. HUMIDITY AND TABLE INDEX
!---------------------------------------
                    BQ  = (BQS10K-BQS00K) * QQ1 + BQS00K
                    SQ  = (SQS10K-SQS00K) * QQ1 + SQS00K
                    TQ  = (QBT-BQ) / SQ * RDQ
                    PP1 = TQ - AINT(TQ)
                    IQTB = INT(TQ) + 1
!---------------------------------
! KEEPING INDICES WITHIN THE TABLE
!---------------------------------
                    IF (IQTB < 1) THEN
                        IQTB = 1
                        PP1 = 0.
                    END IF
!
                    IF (IQTB >= ITB) THEN
                        IQTB = ITB - 1 
                        PP1 = 0.
                    END IF
!---------------------------------------------------
! SATURATION PRESSURE AT FOUR SURROUNDING TABLE PTS.
!---------------------------------------------------
                    IQ = IQTB
                    IT = ITTB
                    P00K = PTBL(IQ  ,IT  )
                    P10K = PTBL(IQ+1,IT  )
                    P01K = PTBL(IQ  ,IT+1)
                    P11K = PTBL(IQ+1,IT+1)
!-----------------------------------------
! SATURATION POINT VARIABLES AT THE BOTTOM
!-----------------------------------------
                    TPSP  = P00K + (P10K-P00K) * PP1 + (P01K-P00K) * QQ1 + (P00K-P10K-P01K+P11K)  &
    &                     * PP1 * QQ1
                    APESP = (1.E5/TPSP) ** CAPA
                    TTHES = TTHBT * EXP(ELOCP * QBT * APESP / TTHBT)
!---------------------------
! CHECK FOR MAXIMUM BUOYANCY
!---------------------------
                    IF (TTHES > THESP(I,J)) THEN
                          PSP(I,J) = TPSP
                         THBT(I,J) = TTHBT
                        THESP(I,J) = TTHES
                    END IF
!
                END IF
!
        150 END DO
    155 END DO
170 END DO
!------------------------------------------------
! CHOOSE CLOUD BASE AS MODEL LEVEL JUST BELOW PSP
!------------------------------------------------
    DO 240 K=1,LM1
        AETAL = AETA(K)
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
                P(I,J) = PDSL(I,J) * AETAL + PT
                IF (P(I,J) < PSP(I,J) .AND. P(I,J) >= PQM) LBOT(I,J) = K + 1
            END DO
        END DO
!  
240 END DO
!--------------------------------------------------------------
! WARNING: LBOT MUST NOT BE GT LMH(I,J)-1 IN SHALLOW CONVECTION
! MAKE SURE CLOUD BASE IS AT LEAST PONE ABOVE THE SURFACE
!--------------------------------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (LMHIJ  , PSFCK)
!
    DO 250 J=MYJS2,MYJE2
        DO 250 I=MYIS,MYIE
            LMHIJ = LMH(I,J)
            PBOT(I,J) = AETA(LBOT(I,J)) * PDSL(I,J) + PT
            PSFCK     = AETA(LMHIJ)     * PDSL(I,J) + PT
            IF (PBOT(I,J) >= PSFCK-PONE .OR. LBOT(I,J) >= LMHIJ) THEN
!            
                DO K=1,LMHIJ-1
                    P(I,J) = AETA(K) * PDSL(I,J) + PT
                    IF (P(I,J) < PSFCK-PONE) LBOT(I,J) = K
                END DO
!            
                PBOT(I,J) = AETA(LBOT(I,J)) * PDSL(I,J) + PT
            END IF
250 END DO
!----------------------   
! CLOUD TOP COMPUTATION
!----------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            LTOP(I,J) = LBOT(I,J)
            PTOP(I,J) = PBOT(I,J)
        END DO
    END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (IHRES    , ILRES   , IPTB    , ITHTB   , JHRES   , JLRES   , KNUMH   , KNUML   ,   &
!$omp          PP       , PRESK   , QQ      )
!
    DO 290 K=LM,1,-1
!------------------------------------    
! SCALING PRESSURE AND TT TABLE INDEX
!------------------------------------
        KNUML = 0
        KNUMH = 0
!    
        DO 270 J=MYJS2,MYJE2
            DO 270 I=MYIS1,MYIE1
                PRESK = PDSL(I,J) * AETA(K) + PT
                IF (PRESK < PLQ) THEN
                    KNUML = KNUML + 1
                    ILRES(KNUML) = I
                    JLRES(KNUML) = J
                ELSE
                    KNUMH = KNUMH + 1
                    IHRES(KNUMH) = I
                    JHRES(KNUMH) = J
                END IF
    270 END DO
!---------------------------------------------------------------
! COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE<PL
!---------------------------------------------------------------
        IF (KNUML > 0) THEN
            CALL TTBLEX(TREF(IDIM1,JDIM1,K)                                                       &
    &        ,          TTBL, ITB, JTB, KNUML, ILRES, JLRES, PDSL                                 &
    &        ,          AETA(K)                                                                   &
    &        ,          HTM(IDIM1,JDIM1,K)                                                        &
    &        ,          PT, PL                                                                    &
    &        ,          QQ(IDIM1,JDIM1), PP(IDIM1,JDIM1)                                          &
    &        ,          RDP, THE0, STHE, RDTHE                                                    &
    &        ,          THESP(IDIM1,JDIM1), IPTB(IDIM1,JDIM1)                                     &
    &        ,          ITHTB(IDIM1,JDIM1))
        END IF
!---------------------------------------------------------------
! COMPUTE PARCEL TEMPERATURE ALONG MOIST ADIABAT FOR PRESSURE>PL
!---------------------------------------------------------------
        IF (KNUMH > 0) THEN
            CALL TTBLEX(TREF(IDIM1,JDIM1,K)                                                       &
    &       ,           TTBLQ             , ITBQ             , JTBQ , KNUMH                       &
    &       ,           IHRES             , JHRES            , PDSL                               & 
    &       ,           AETA(K)                                                                   &
    &       ,           HTM(IDIM1,JDIM1,K)                                                        &
    &       ,           PT                , PLQ                                                   &
    &       ,              QQ(IDIM1,JDIM1),   PP(IDIM1,JDIM1)                                     &
    &       ,           RDPQ              , THE0Q            , STHEQ, RDTHEQ                      &
    &       ,           THESP(IDIM1,JDIM1), IPTB(IDIM1,JDIM1)                                     &
    &       ,           ITHTB(IDIM1,JDIM1))
        END IF
290 END DO
!---------------    
! BUOYANCY CHECK
!---------------
    DO 295 K=LM,1,-1
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO J=MYJS2,MYJE2
            DO I=MYIS1,MYIE1
                IF (TREF(I,J,K) > T(I,J,K)-DTTOP) LTOP(I,J) = K
            END DO
        END DO
!
295 END DO
!-------------------
! CLOUD TOP PRESSURE
!-------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS2,MYJE2
        DO I=MYIS1,MYIE1
            PTOP(I,J) = AETA(LTOP(I,J)) * PDSL(I,J) + PT
        END DO
    END DO
!----------------------------------
! DEFINE AND SMOOTH DSPS AND CLDEFI
! UNIFIED OR SEPARATE LAND/SEA CONV 
!----------------------------------
    IF (UNIS) THEN
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (EFI)
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                EFI = CLDEFI(I,J)
                DSPB(I,J) = (EFI-EFIMN) * SLOPBS + DSPBSS
                DSP0(I,J) = (EFI-EFIMN) * SLOP0S + DSP0SS
                DSPT(I,J) = (EFI-EFIMN) * SLOPTS + DSPTSS
            END DO
        END DO
!
    ELSE IF ( .NOT. UNIL) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (EFI)
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                EFI=CLDEFI(I,J)
                DSPB(I,J) = ((EFI-EFIMN)*SLOPBS+DSPBSS) * SM(I,J) + ((EFI-EFIMN)*SLOPBL+DSPBSL)   &
    &                     * (1.-SM(I,J))
!
                DSP0(I,J) = ((EFI-EFIMN)*SLOP0S+DSP0SS) * SM(I,J) + ((EFI-EFIMN)*SLOP0L+DSP0SL)   &
    &                     * (1.-SM(I,J))
!
                DSPT(I,J) = ((EFI-EFIMN)*SLOPTS+DSPTSS) * SM(I,J) + ((EFI-EFIMN)*SLOPTL+DSPTSL)   &
    &                     * (1.-SM(I,J)) 
           END DO
        END DO
!
    ELSE
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (EFI)
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                EFI=CLDEFI(I,J)
                DSPB(I,J) = ((EFI-EFIMN) * SLOPBL + DSPBSL)
                DSP0(I,J) = ((EFI-EFIMN) * SLOP0L + DSP0SL)
                DSPT(I,J) = ((EFI-EFIMN) * SLOPTL + DSPTSL)
            END DO
        END DO
!
    END IF
!------------------------------------------------
! EXTENDING SEA STRUCTURES INLAND ALONG COASTLINE
!------------------------------------------------
    IF (NROW > 0 .AND. .NOT. UNIS .AND. .NOT. UNIL) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                WF1(I,J) = 0.
                WF2(I,J) = 0.
                WF3(I,J) = 0.
                WF4(I,J) = 0.
            END DO
        END DO
!    
        KROW = NROW
!    
        DO 350 KOUNT=1,KROW
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
            DO 345 J=MYJS2,MYJE2
                DO 345 I=MYIS1,MYIE1
                    WF1(I,J) =   (DSPB(I+IHW(J),J-1) +   DSPB(I+IHE(J),J-1)                       &
    &                        +    DSPB(I+IHW(J),J+1) +   DSPB(I+IHE(J),J+1)                       &
    &                        +    4. * DSPB(I,J)) * HBM2(I,J)   * 0.125
!
                    WF2(I,J) =   (DSP0(I+IHW(J),J-1) +   DSP0(I+IHE(J),J-1)                       &
    &                        +    DSP0(I+IHW(J),J+1) +   DSP0(I+IHE(J),J+1)                       &
    &                        +    4. * DSP0(I,J)) * HBM2(I,J)   * 0.125
!
                    WF3(I,J) =   (DSPT(I+IHW(J),J-1) +   DSPT(I+IHE(J),J-1)                       &
    &                        +    DSPT(I+IHW(J),J+1) +   DSPT(I+IHE(J),J+1)                       &
    &                        +    4. * DSPT(I,J)) * HBM2(I,J)   * 0.125
!
                    WF4(I,J) = (CLDEFI(I+IHW(J),J-1) + CLDEFI(I+IHE(J),J-1)                       &
    &                        +  CLDEFI(I+IHW(J),J+1) + CLDEFI(I+IHE(J),J+1)                       &
    &                        +    4. * CLDEFI(I,J)) * HBM2(I,J) * 0.125
        345 END DO
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (RSMK   , SMK)
!
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    SMK = SM(I,J)
                    RSMK = 1. - SMK
                      DSPB(I,J) =   DSPB(I,J) * SMK + WF1(I,J) * RSMK
                      DSP0(I,J) =   DSP0(I,J) * SMK + WF2(I,J) * RSMK
                      DSPT(I,J) =   DSPT(I,J) * SMK + WF3(I,J) * RSMK
                    CLDEFI(I,J) = CLDEFI(I,J) * SMK + WF4(I,J) * RSMK
                END DO
            END DO
!        
    350 END DO
!
    END IF
!-----------------------------------------------
! NITIALIZE CHANGES OF T AND Q DUE TO CONVECTION
!-----------------------------------------------
!
!------- 
! OPENMP
!-------  
!
!$omp parallel do
!
    DO 360 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TMOD(I,J,K) = 0.
                QMOD(I,J,K) = 0.
            END DO
        END DO
360 END DO
!-------------------------------------------
! CLEAN UP AND GATHER DEEP CONVECTION POINTS 
!-------------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
     DO 380 J=MYJS2,MYJE2
        DO 380 I=MYIS1,MYIE1
            IF (LTOP(I,J) >= LBOT(I,J)) THEN
                LBOT(I,J) = 0
                LTOP(I,J) = LBOT(I,J)
                PTOP(I,J) = PBOT(I,J)
            END IF
!
            IF (HBM2(I,J) < 0.90) THEN
                LBOT(I,J) = 0
                LTOP(I,J) = LBOT(I,J)
                PTOP(I,J) = PBOT(I,J)
            END IF
!
            IF (PTOP(I,J) > PBOT(I,J)-PNO .OR. LTOP(I,J) > LBOT(I,J)-2)                           &
    &           CLDEFI(I,J) = AVGEFI * SM(I,J) + STEFI * (1.-SM(I,J))

!
     380 END DO
!
    KHDEEP = 0
    PSHNEW = 20000.
!
    DO J=MYJS2,MYJE2
        DO I=MYIS1,MYIE1
            PSFCIJ = PD(I,J) + PT
!--------------------------------------------------------------------------------------------------
! DEPTH OF CLOUD REQUIRED TO MAKE THE POINT A DEEP CONVECTION POINT IS NOW A SCALED VALUE OF THE 
! PSFC INSTEAD OF 290 MB EVERYWHERE
!--------------------------------------------------------------------------------------------------
            DEPMIN = PSHNEW * PSFCIJ * 1.E-5
            DEPTH  = PBOT(I,J) - PTOP(I,J)
!
            IF (DEPTH >= DEPMIN) THEN
                KHDEEP = KHDEEP + 1
                IDEEP(KHDEEP) = I
                JDEEP(KHDEEP) = J
            END IF
        END DO
    END DO
!------------------------------------
! HORIZONTAL LOOP FOR DEEP CONVECTION
!------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (APEK     , APEKL   , APEKXX  , APEKXY  , APESK   , AVRGT   , AVTGTL  , DENTPY  ,   &
!$omp          DEPMIN   , DEPTH   , DEPWL   , DHDT    , DIFQ    , DIFQL   , DIFT    , DIFTL   ,   &
!$omp          DRHEAT   , DRHDP   , DSP     , DSP0K   , DSPBK   , DSPTK   , DTHEM   , EFI     ,   &
!$omp          FEFI     , HCORR   , I       , J       , L0      , L0M1    , LB      , LBM1    ,   &
!$omp          LBTK     , LCOR    , LQM     , LSHU    , LTP1    , LTP2    , LTPK    , LTSH    ,   &
!$omp          PBTK     , PK      , PK0     , PKB     , PKL     , PKT     , PRECK   , PSFCIJ  ,   &
!$omp          PSK      , PTHRS   , PTPK    , QK      , QKL     , QREFK   , QSATK   , RDP0T   ,   &
!$omp          RHH      , RHL     , RHMAX   , SUMDE   , SUMDP   , THERK   , THERKX  , THERKY  ,   &
!$omp          THSK     , THSKL   , TK      , TKL     , TREFK   , TREFKX  , TSKL    )
!
    DO 600 N=1,KHDEEP
!
        I = IDEEP(N)
        J = JDEEP(N)
        PSFCIJ = PD(I,J) + PT
        LTPK = LTOP(I,J)
        LBTK = LBOT(I,J)
!---------------
!DEEP CONVECTION
!---------------
        LB    = LBTK
        EFI   = CLDEFI(I,J)
        DSPBK =   DSPB(I,J)
        DSP0K =   DSP0(I,J)
        DSPTK =   DSPT(I,J)
!--------------------------------------------------------------------------------------------------
! INITIALIZE VARIABLES IN THE CONVECTIVE COLUMN 
!
! ONE SHOULD NOTE THAT THE VALUES ASSIGNED TO THE ARRAY TREFK IN THE 410 LOOP ARE REALLY ONLY 
! RELEVANT IN ANCHORING THE REFERENCE TEMPERATURE PROFILE AT LEVEL LB.
! WHEN BUILDING THE REFERENCE PROFILE FROM CLOUD BASE, THEN ASSIGNING THE AMBIENT TEMPERATURE TO 
! TREFK IS ACCEPTABLE.
! HOWEVER, WHEN BUILDING THE REFERENCE PROFILE FROM SOME OTHER LEVEL (SUCH AS ONE LEVEL ABOVE THE 
! GROUND), THEN TREFK SHOULD BE FILLED WITH THE TEMPERATURES IN TREF(I,J,L) WHICH ARE THE 
! TEMPERATURES OF THE MOIST ADIABAT THROUGH CLOUD BASE.
! BY THE TIME THE LINE NUMBERED 450 HAS BEEN REACHED, TREFK ACTUALLY DOES HOLD THE REFERENCE 
! TEMPERATURE PROFILE.
!--------------------------------------------------------------------------------------------------
        DO 410 K=1,LM
             DIFT(K) =  0.
             DIFQ(K) =  0.
            TKL      =    T(I,J,K)
               TK(K) =  TKL
            TREFK(K) =  TKL
            QKL      =    Q(I,J,K)
               QK(K) =  QKL
            QREFK(K) =  QKL
            PKL      =  AETA(K) * PDSL(I,J) + PT
               PK(K) =  PKL
              PSK(K) =  PKL
            APEKL    =  APE(I,J,K)
             APEK(K) = APEKL
            THERK(K) = TREF(I,J,K) * APEKL
    410 END DO
!----------------------------------------------
! DEEP CONVECTION REFERENCE TEMPERATURE PROFILE
!----------------------------------------------
        LTP1 = LTPK + 1
        LBM1 = LB   - 1
        PKB  = PK(LB)
        PKT  = PK(LTPK)
!---------------------------------------------------
! TEMPERATURE REFERENCE PROFILE BELOW FREEZING LEVEL
!---------------------------------------------------
        L0     = LB
        PK0    =    PK(LB)
        TREFKX = TREFK(LB)
        THERKX = THERK(LB)
        APEKXX =  APEK(LB)
        THERKY = THERK(LBM1)
        APEKXY =  APEK(LBM1)
!    
        DO 420 K=LBM1,LTPK,-1
            IF (T(I,J,K+1) < TFRZ) GOTO 430
            STABDL   = STABD
            TREFKX   = ((THERKY-THERKX) * STABDL + TREFKX * APEKXX) / APEKXY
            TREFK(K) = TREFKX
            APEKXX   = APEKXY
            THERKX   = THERKY
            APEKXY   =  APEK(K-1)
            THERKY   = THERK(K-1)
            L0       = K
            PK0      = PK(L0)
    420 END DO
!-----------------------------------------
! FREEZING LEVEL AT OR ABOVE THE CLOUD TOP
!-----------------------------------------       
        L0M1 = L0 - 1
!
        GOTO 450
!---------------------------------------------------
! TEMPERATURE REFERENCE PROFILE ABOVE FREEZING LEVEL 
!---------------------------------------------------
        430 L0M1 = L0 - 1
        RDP0T = 1. / (PK0 - PKT)
        DTHEM = THERK(L0) - TREFK(L0) * APEK(L0)
!    
        DO K=LTPK,L0M1
            TREFK(K) = (THERK(K) - (PK(K) - PKT) * DTHEM * RDP0T) / APEK(K)
        END DO
!-------------------------------------------
! DEEP CONVECTION REFERENCE HUMIDITY PROFILE 
!-------------------------------------------
!
!------------------------------------------------------------------------------------------------
! REFERENCE PROFILE HAD BEEN TOO DRY IN THE CASE WHERE THE CLOUD BASE WAS CLOSE TO FREEZING LEVEL 
!------------------------------------------------------------------------------------------------
        450 DEPTH = PFRZ * PSFCIJ * 1.E-5
        DEPWL = PKB - PK0
!
        DO 460 K=LTPK,LB
!-------------------------------
! SATURATION PRESSURE DIFFERENCE
!-------------------------------
            IF (DEPWL >= DEPTH) THEN
                IF (K < L0) THEN
                    DSP = ((PK0 - PK(K)) * DSPTK + (PK(K) - PKT) * DSP0K) / (PK0 - PKT)
                ELSE
                    DSP = ((PKB - PK(K)) * DSP0K + (PK(K) - PK0) * DSPBK) / (PKB - PK0)
                END IF
            ELSE
                DSP = DSP0K
                IF (K < L0) DSP = ((PK0 - PK(K)) * DSPTK + (PK(K) - PKT) * DSP0K) / (PK0 - PKT)
            END IF
!-----------------
! HUMIDITY PROFILE
!-----------------
            IF (PK(K) > PQM) THEN
                  PSK(K) = PK(K) + DSP
                APESK(K) = (1.E5 / PSK(K)) ** CAPA
                 THSK(K) = TREFK(K) * APEK(K)
                QREFK(K) = PQ0 / PSK(K) * EXP(A2 * (THSK(K) - A3 * APESK(K))                      &
    &                    /                         (THSK(K) - A4 * APESK(K)))
            ELSE
                QREFK(K) = Q(I,J,K)
            END IF
    460 END DO
!-------------------------------
! ENTHALPY CONSERVATION INTEGRAL
!-------------------------------
        DO 520 ITER=1,2
!
            SUMDE = 0.
            SUMDP = 0.
!        
            DO K=LTPK,LB
                SUMDE = ((TK(K) - TREFK(K)) * CP + (QK(K) - QREFK(K)) * ELWV) * DETA(K) + SUMDE
                SUMDP = SUMDP   +  DETA(K)
            END DO
!        
            HCORR = SUMDE / (SUMDP - DETA(LTPK))
            LCOR  = LTPK + 1
!--------- 
! FIND LQM 
!---------
            DO K=1,LB
                IF (PK(K) <= PQM) LQM = K
            END DO
!-----------------------------------
! ABOVE LQM CORRECT TEMPERATURE ONLY
!-----------------------------------
            IF (LCOR <= LQM) THEN
                DO K=LCOR,LQM
                    TREFK(K) = TREFK(K) + HCORR * RCP
                END DO
                LCOR = LQM + 1
            END IF
!------------------------------------------------
! BELOW LQM CORRECT BOTH TEMPERATURE AND MOISTURE
!------------------------------------------------
            DO 510 K=LCOR,LB
                TSKL     = TREFK(K) * APEK(K) / APESK(K)
                DHDT     = QREFK(K) * A23M4L  / (TSKL-A4) ** 2 + CP
                TREFK(K) = HCORR / DHDT + TREFK(K)
                THSKL    = TREFK(K) * APEK(K)
                QREFK(K) = PQ0 / PSK(K) * EXP(A2 * (THSKL - A3 * APESK(K))                        &
    &                    /                         (THSKL - A4 * APESK(K)))
        510 END DO
!
    520 END DO
!-----------------------------------
! HEATING, MOISTENING, PRECIPITATION
!-----------------------------------
        DENTPY = 0.
        AVRGT  = 0.
        PRECK  = 0.
!    
        DO 530 K=LTPK,LB
            TKL     = TK(K)
            DIFTL   = (TREFK(K) - TKL  ) * TAUK
            DIFQL   = (QREFK(K) - QK(K)) * TAUK
            AVRGTL  = (TKL + TKL + DIFTL)
            DENTPY  = (DIFTL * CP + DIFQL * ELWV) * DETA(K) / AVRGTL + DENTPY
            AVRGT   = AVRGTL * DETA(K) + AVRGT
            PRECK   = DETA(K) * DIFTL + PRECK
            DIFT(K) = DIFTL
            DIFQ(K) = DIFQL
   530 END DO
!    
        DENTPY = DENTPY + DENTPY
        AVRGT  = AVRGT / (SUMDP + SUMDP)
!-------------------------------------
! SWAP IF ENTROPY AND/OR PRECIP .LT. 0
!-------------------------------------
        IF (DENTPY < EPSNTP .OR. PRECK < 0.) THEN
            IF (OCT90) THEN
                CLDEFI(I,J) = EFIMN
            ELSE
                CLDEFI(I,J) = EFIMN * SM(I,J) + STEFI * (1. - SM(I,J))
            END IF
!-----------------------------         
! SEARCH FOR SHALLOW CLOUD TOP
!-----------------------------
            LBTK = LBOT(I,J)
            LTSH = LBTK
            LBM1 = LBTK - 1
            PBTK = PK(LBTK)
!----------------------------------
! USE NEW THRESHOLD FOR CLOUD DEPTH
!----------------------------------
            PSFCIJ = PD(I,J) + PT
            DEPMIN = PSHNEW * PSFCIJ * 1.E-5
            PTPK   = PBTK - DEPMIN
!-------------------------------------------
! CLOUD TOP IS THE LEVEL JUST BELOW PBTK-PSH
!-------------------------------------------
            DO K=1,LM
                IF (PK(K) <= PTPK) LTPK = K + 1
            END DO
            PTPK=PK(LTPK)
!-----------------------------------------------
! HIGHEST LEVEL ALLOWED IS LEVEL JUST BELOW PSHU
!-----------------------------------------------
            IF (PTPK <= PSHU) THEN
                DO K=1,LM
                    IF (PK(K) <= PSHU) LSHU = K + 1
                END DO
                LTPK = LSHU
                PTPK = PK(LTPK)
            END IF
!        
            LTP1 = LTPK + 1
            LTP2 = LTPK + 2
!
            DO K=LTPK,LBTK
                QSATK(K) = PQ0 / PK(K) * EXP(A2 * (TK(K) - A3) / (TK(K) - A4))
            END DO
!
            RHH = QK(LTPK) / QSATK(LTPK)
            RHMAX = 0.
!        
            DO 570 K=LTP1,LBM1
                RHL = QK(K) / QSATK(K)
                DRHDP = (RHH-RHL) / (PK(K-1) - PK(K))
                IF (DRHDP > RHMAX) THEN
                    LTSH  = K - 1
                    RHMAX = DRHDP
                END IF
                RHH = RHL
        570 END DO
!        
            LTOP(I,J) = LTSH
!----------------------------------------
! CLOUD MUST BE AT LEAST TWO LAYERS THICK
!----------------------------------------
            IF (LBOT(I,J)-LTOP(I,J) < 2) LTOP(I,J) = LBOT(I,J) - 2
!        
            PTOP(I,J) = PK(LTOP(I,J))
            GOTO 600
!
        END IF
!--------------------------
! DEEP CONVECTION OTHERWISE
!--------------------------
        DRHEAT = (PRECK * SM(I,J) + AMAX1(EPSP,PRECK) * (1. - SM(I,J))) * CP / AVRGT
        EFI    = EFIFC * DENTPY / DRHEAT
!-----------------------------------
! UNIFIED OR SEPARATE LAND/SEA CONV.
!-----------------------------------
        IF (OCT90) THEN
            IF (UNIS) THEN
                EFI = CLDEFI(I,J) * FCB + EFI * FCC
            ELSE IF ( .NOT. UNIL) THEN
                EFI = (CLDEFI(I,J) * FCB + EFI * FCC) * SM(I,J) + 1. - SM(I,J)
            ELSE
                EFI = 1.
            END IF
        ELSE
            EFI = CLDEFI(I,J) * FCB + EFI * FCC
        END IF

!    
        IF(EFI > 1.   )    EFI = 1.
        IF(EFI < EFIMN)    EFI = EFIMN
        IF(PRECK == 0.)    EFI = 1.
!
        CLDEFI(I,J) = EFI
   
!    
        
        FEFI  = EFMNT + SLOPE * (EFI - EFIMN)
        FEFI  = 2. - FEFI
        PRECK = PRECK * FEFI
!-----------------------------------------------    
! UPDATE PRECIPITATION, TEMPERATURE AND MOISTURE
!-----------------------------------------------   
        PRECOL(I,J) = PDSL(I,J) * PRECK * CPRLG
        PREC  (I,J) = PDSL(I,J) * PRECK * CPRLG + PREC  (I,J)
        CUPREC(I,J) = PDSL(I,J) * PRECK * CPRLG + CUPREC(I,J)
        ACPREC(I,J) = PDSL(I,J) * PRECK * CPRLG + ACPREC(I,J)
         CUPPT(I,J) = PDSL(I,J) * PRECK * CPRLG + CUPPT (I,J)
!    
        DO K=LTPK,LB
              TMOD(I,J,K) = DIFT(K) * FEFI
              QMOD(I,J,K) = DIFQ(K) * FEFI
            TLATCU(I,J,K) = DIFT(K) * FEFI
       END DO

!-----------------------
! END OF DEEP CONVECTION
!-----------------------
    600 END DO
!

    NDEEP = 0
!
    DO 620 J=MYJS2,MYJE2
        DO 620 I=MYIS,MYIE
            LTPK = LTOP(I,J)
            LBTK = LBOT(I,J)
            LB   =  LMH(I,J) - 1
            PSFCIJ = PD(I,J) + PT
            DEPMIN = PSHNEW * PSFCIJ * 1.E-5
!
            IF (PTOP(I,J) < PBOT(I,J)-DEPMIN) THEN
                NDEEP = NDEEP + 1
                NDEPTH = LB - LTPK
                NTOPD (LTPK  ) = NTOPD (LTPK  ) + 1
                NBOTD (LB    ) = NBOTD (LB    ) + 1
                NDPTHD(NDEPTH) = NDPTHD(NDEPTH) + 1
            END IF
620 END DO
!
    NNEG = KHDEEP - NDEEP
!--------------------------------- 
! GATHER SHALLOW CONVECTION POINTS
!---------------------------------
    KHSHAL = 0
    NDSTN  = 0
    NDSTP  = 0
!
    DO 630 J=MYJS2,MYJE2
        DO 630 I=MYIS,MYIE
            IF (PTOP(I,J) > PBOT(I,J)-PNO .OR. LTOP(I,J) > LBOT(I,J)-2) GOTO 630
            PSFCIJ = PD(I,J) + PT
            DEPMIN = PSHNEW * PSFCIJ * 1.E-5
!
            IF (PTOP(I,J)+1. >= PBOT(I,J)-DEPMIN) THEN
                KHSHAL = KHSHAL + 1
                ISHAL(KHSHAL) = I
                JSHAL(KHSHAL) = J
            END IF
!
630 END DO
!----------------------------------------
! HORIZONTAL LOOP FOR SHALLOW CONVECTION
!----------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (APEK     , APEKL   , APEKXX  , APEKXY  , BQK     , BQS00K  , BQS10K  , DEN     ,   &
!$omp          DENTPY   , DPKL    , DPMIX   , DQREF   , DST     , DSTQ    , DTDETA  , FPK     ,   &
!$omp          FPTK     , I       , IQ      , IT      , J       , LBM1    , LBTK    , LTP1    ,   &
!$omp          LTPK     , OTSUM   , PART1   , PART2   , PART3   , PK      , PKL     , PKXXXX  ,   &
!$omp          PKXXXY   , POTSUM  , PPK     , PSUM    , PTPK    , PZ0     , QK      , QKL     ,   &
!$omp          QNEW     , QOTSUM  , QQK     , QREFK   , QRFKL   , QRFTP   , QSATK   , QSUM    ,   &
!$omp          RDPSUM   , RTBAR   , SMIX    , SQK     , SQS00K  , SQS10K  , SUMDP   , SUMDT   ,   &
!$omp          TCORR    , THVMKL  , THVREF  , TK      , TKL     , TQK     , TREFK   , TREFKX  ,   &
!$omp          TRFKL    , TTHK)
!
    DO 800 N=1,KHSHAL
!
        I = ISHAL(N)
        J = JSHAL(N)
!------------------- 
! SHALLOW CONVECTION
!------------------- 
        PZ0  =  PD(I,J) + PT
        LLMH = LMH(I,J)
!    
        DO 650 K=1,LLMH
            TKL      = T(I,J,K)
            TK   (K) = TKL
            TREFK(K) = TKL
            QKL      = Q(I,J,K)
            QK   (K) = QKL
            QREFK(K) = QKL
            PKL      = AETA(K) * PDSL(I,J) + PT
            PK   (K) = PKL
            QSATK(K) = PQ0 / PK(K) * EXP(A2 * (TK(K) - A3) / (TK(K) - A4))
            APEKL    = APE(I,J,K)
!-----------------------------
! CHOOSE THE PRESSURE FUNCTION
!
! FPK  (K) =ALOG(PKL)
! FPK  (K) =PKL
! FPK  (K) =-1./PKL
!-----------------------------
            APEK (K)  = APEKL
            THVMKL    = TKL * APEKL * (QKL * 0.608 + 1.)
            THVREF(K) = THVMKL
        650 END DO
!------------------ 
! SHALLOW CLOUD TOP
!------------------ 
        LBTK = LBOT(I,J)
        LBM1 = LBTK - 1
        PTPK = PTOP(I,J)
        LTP1 = LTOP(I,J)
        LTPK = LTOP(I,J) - 1
!
        IF (PTOP(I,J) > PBOT(I,J)-PNO .OR. LTOP(I,J) > LBOT(I,J)-2) THEN
            LBOT(I,J) = 0
            LTOP(I,J) = LBOT(I,J)
            PTOP(I,J) = PBOT(I,J)
            GOTO 800
        END IF
!-----------------------------------------------------
! SCALING POTENTIAL TEMPERATURE AND TABLE INDEX AT TOP
!-----------------------------------------------------
        THTPK = T(I,J,LTPK) * APE(I,J,LTPK)
!    
        TTHK = (THTPK - THL) * RDTH
        QQK  = TTHK - AINT(TTHK)
        IT   = INT(TTHK) + 1
!
        IF (IT < 1) THEN
            IT  = 1
            QQK = 0.
        END IF
!
        IF (IT >= JTB) THEN
            IT  = JTB - 1
            QQK = 0.
        END IF
!--------------------------------------------------
! BASE AND SCALING FACTOR FOR SPEC. HUMIDITY AT TOP
!--------------------------------------------------
        BQS00K = QS0(IT)
        SQS00K = SQS(IT)
        BQS10K = QS0(IT+1)
        SQS10K = SQS(IT+1)
!----------------------------------------------
! SCALING SPEC. HUMIDITY AND TABLE INDEX AT TOP
!----------------------------------------------
        BQK = (BQS10K - BQS00K) * QQK + BQS00K
        SQK = (SQS10K - SQS00K) * QQK + SQS00K
!
        TQK = (Q(I,J,LTPK) - BQK) / SQK * RDQ
!    
        PPK = TQK - AINT(TQK)
        IQ = INT(TQK) + 1
!
        IF (IQ < 1) THEN
            IQ  = 1
            PPK = 0.
        END IF
!
        IF (IQ >= ITB) THEN
            IQ  = ITB - 1
            PPK = 0.
        END IF
!------------------------------------
! CLOUD TOP SATURATION POINT PRESSURE
!------------------------------------
        PART1 = (PTBL(IQ+1,IT) - PTBL(IQ  ,IT)) * PPK
        PART2 = (PTBL(IQ,IT+1) - PTBL(IQ  ,IT)) * QQK
        PART3 = (PTBL(IQ,IT  ) - PTBL(IQ+1,IT) - PTBL(IQ,IT+1) + PTBL(IQ+1,IT+1)) * PPK * QQK
        PTPK  =  PTBL(IQ,IT  ) + PART1 + PART2 + PART3
!
        DPMIX = PTPK - PSP(I,J)
        IF (ABS(DPMIX) < 3000.) DPMIX = -3000.
!-------------------------- 
! TEMPERATURE PROFILE SLOPE
!-------------------------- 
        SMIX = (THTPK - THBT(I,J)) / DPMIX * STABS
!    
        TREFKX = TREFK(LBTK+1)
        PKXXXX =    PK(LBTK+1)
        PKXXXY =    PK(LBTK)
        APEKXX =  APEK(LBTK+1)
        APEKXY =  APEK(LBTK)
!    
        DO 670 K=LBTK,LTP1,-1
            TREFKX   = ((PKXXXY - PKXXXX) * SMIX + TREFKX * APEKXX) / APEKXY
            TREFK(K) = TREFKX
            APEKXX   = APEKXY
            PKXXXX   = PKXXXY
            APEKXY   = APEK(K-1)
            PKXXXY   =   PK(K-1)
    670 END DO
!-----------------------------------------
! TEMPERATURE REFERENCE PROFILE CORRECTION 
!-----------------------------------------
        SUMDT = 0.
        SUMDP = 0.
!    
        DO K=LTP1,LBTK
            SUMDT = (TK(K) - TREFK(K)) * DETA(K) + SUMDT
            SUMDP = SUMDP + DETA(K)
        END DO
!    
        RDPSUM = 1. / SUMDP
        FPK(LBTK) = TREFK(LBTK)
!    
        TCORR=SUMDT*RDPSUM
!    
        DO K=LTP1,LBTK
            TRFKL    = TREFK(K)+TCORR
            TREFK(K) = TRFKL
            FPK  (K) = TRFKL
        END DO
!--------------------------- 
! HUMIDITY PROFILE EQUATIONS
!---------------------------
        PSUM   = 0.
        QSUM   = 0.
        POTSUM = 0.
        QOTSUM = 0.
        OTSUM  = 0.
        DST    = 0.
        FPTK   = FPK(LTP1)
!    
        DO 700 K=LTP1,LBTK
            DPKL   = FPK(K) - FPTK
            PSUM   = DPKL  * DETA(K) + PSUM
            QSUM   = QK(K) * DETA(K) + QSUM
            RTBAR  = 2. / (TREFK(K) + TK(K))
            OTSUM  = DETA(K) * RTBAR + OTSUM
            POTSUM = DPKL   * RTBAR * DETA(K) + POTSUM
            QOTSUM = QK(K)  * RTBAR * DETA(K) + QOTSUM
            DST    = (TREFK(K) - TK(K)) * RTBAR * DETA(K) + DST
    700 END DO
!    
        PSUM   = PSUM * RDPSUM
        QSUM   = QSUM * RDPSUM
        ROTSUM = 1. / OTSUM
        POTSUM = POTSUM * ROTSUM
        QOTSUM = QOTSUM * ROTSUM
        DST    = DST    * ROTSUM * CP / ELWV
!------------------------------- 
! ENSURE POSITIVE ENTROPY CHANGE 
!-------------------------------
        IF (DST > 0.) THEN
            LBOT(I,J) = 0
            LTOP(I,J) = LBOT(I,J)
            PTOP(I,J) = PBOT(I,J)
            GOTO 800       
        ELSE
            DSTQ = DST * EPSDN
        END IF
!-------------------------------- 
! CHECK FOR ISOTHERMAL ATMOSPHERE
!--------------------------------
        DEN = POTSUM - PSUM
!    
        IF (-DEN/PSUM < 5.E-5) THEN
            LBOT(I,J) = 0
            LTOP(I,J) = LBOT(I,J)
            PTOP(I,J) = PBOT(I,J)
            GOTO 800
!----------------------------------------        
! SLOPE OF THE REFERENCE HUMIDITY PROFILE
!----------------------------------------
        ELSE
            DQREF = (QOTSUM-DSTQ-QSUM) / DEN
        END IF
!--------------------------------------- 
! HUMIDITY DOES NOT INCREASE WITH HEIGHT
!---------------------------------------
        IF (DQREF < 0.) THEN
            LBOT(I,J) = 0
            LTOP(I,J) = LBOT(I,J)
            PTOP(I,J) = PBOT(I,J)
            GOTO 800
        END IF
!--------------------------
! HUMIDITY AT THE CLOUD TOP
!--------------------------
        QRFTP = QSUM - DQREF * PSUM
!----------------- 
! HUMIDITY PROFILE
!-----------------
        DO 720 K=LTP1,LBTK
            QRFKL = (FPK(K) - FPTK) * DQREF + QRFTP
!------------------------------------------
! SUPERSATURATION OR NEGATIVE Q NOT ALLOWED
!-------------------------------------------    
            QNEW = (QRFKL - QK(K)) * TAUK + QK(K)
!
            IF (QNEW > QSATK(K)*STRESH .OR. QNEW < 0.) THEN
                LBOT(I,J) = 0
                LTOP(I,J) = LBOT(I,J)
                PTOP(I,J) = PBOT(I,J)
                GOTO 800
            END IF
!
            THVREF(K) = TREFK(K) * APEK(K) * (QRFKL * 0.608 + 1.)
             QREFK(K) = QRFKL
    720 END DO
!-----------------------------------------------
! ELIMINATE IMPOSSIBLE SLOPES (BETTS, DTHETA/DQ)
!----------------------------------------------- 
        DO 730 K=LTP1,LBTK
            DTDETA = (THVREF(K-1) - THVREF(K)) / (AETA(K) - AETA(K-1))
            IF (DTDETA < EPSTH) THEN
                LBOT(I,J) = 0
                LTOP(I,J) = LBOT(I,J)
                PTOP(I,J) = PBOT(I,J)
                GOTO 800
            END IF
    730 END DO
!-------------------- 
! DIAGNOSTICS 
!
! IF (DST.GT.0.) THEN
! NDSTP = NDSTP + 1
! ELSE
! NDSTN = NDSTN + 1
! END IF
!--------------------
        DENTPY = 0.
!    
        DO K=LTP1,LBTK
            DENTPY = ((TREFK(K) - TK(K)) * CP + (QREFK(K) - QK(K)) * ELWV)                        &
    &              / (TK(K) + TREFK(K)) * DETA(K) + DENTPY
        END DO
!--------------------------------------    
! RELAXATION TOWARDS REFERENCE PROFILES 
!--------------------------------------

        DO 750 K=LTP1,LBTK
            TMOD(I,J,K) = (TREFK(K) - TK(K)) * TAUK
            QMOD(I,J,K) = (QREFK(K) - QK(K)) * TAUK
    750 END DO       
!-------------------------- 
! END OF SHALLOW CONVECTION
!-------------------------- 
800 END DO
!------------
! DIAGNOSTICS
!------------
    NSHAL = 0
!
    DO 820 J=MYJS2,MYJE2
        DO 820 I=MYIS,MYIE
            LTPK = LTOP(I,J)
            LBTK = LBOT(I,J)
            PTPK = PTOP(I,J)
            PBTK = PBOT(I,J)
!
            IF (PTPK > PBTK-PNO .OR. LTPK > LBTK-2) GOTO 820
            PSFCIJ = PD(I,J) + PT
            DEPMIN = PSHNEW * PSFCIJ * 1.E-5
!
            IF (PTPK >= PBTK-DEPMIN) THEN
                NSHAL          = NSHAL + 1
                NTOPS(LTPK)    = NTOPS(LTPK) + 1
                NBOTS(LBTK)    = NBOTS(LBTK) + 1
                NDEPTH         = LBTK - LTPK
                NDPTHS(NDEPTH) = NDPTHS(NDEPTH) + 1
            END IF
!
820 END DO
!
    NEGDS = KHSHAL - NSHAL
!---------------------------------------------
! SMOOTHING TEMPERATURE & HUMIDITY CORRECTIONS
!---------------------------------------------
    IF (KSMUD == 0) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!    
        DO 900 K=1,LM
!-----------------------------------------
! UPDATE THE FUNDAMENTAL PROGNOSTIC ARRAYS
!-----------------------------------------
            DO 830 J=MYJS,MYJE
                DO 830 I=MYIS,MYIE
                    T(I,J,K) = T(I,J,K) + TMOD(I,J,K)
                    Q(I,J,K) = Q(I,J,K) + QMOD(I,J,K)
!---------------------------------------------------------------------------------------------------------------
! ACCUMULATE LATENT HEATING DUE TO CONVECTION.
! SCALE BY THE RECIPROCAL OF THE PERIOD AT WHICH THIS ROUTINE IS CALLED. THIS PERIOD IS THE CONVECTION TIMESTEP.
!---------------------------------------------------------------------------------------------------------------
                    TCUCN(I,J,K) = TCUCN(I,J,K) + TMOD(I,J,K) * RDTCNVC

       830 END DO
 
    900 END DO 
  
!
    ELSE
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (QL     , QNE     , QSE     , TL      , TNE     , TSE)
!    
        DO 910 K=1,LM
!        
            CALL ZERO2(QL)
            CALL ZERO2(QNE)
            CALL ZERO2(QSE)
            CALL ZERO2(TL)
            CALL ZERO2(TNE)
            CALL ZERO2(TSE)
!
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    TL(I,J) = TMOD(I,J,K)
                    QL(I,J) = QMOD(I,J,K)
                END DO
            END DO
!
            NSMUD = KSMUD
!
            DO 870 KS=1,NSMUD
!
                DO J=MYJS,MYJE1
                    DO I=MYIS,MYIE
                        TNE(I,J) = (TL(I+IHE(J),J+1) - TL(I,J)) * HTM(I,J,K) * HTM(I+IHE(J),J+1,K)
                        QNE(I,J) = (QL(I+IHE(J),J+1) - QL(I,J)) * HTM(I,J,K) * HTM(I+IHE(J),J+1,K)
                    END DO
                END DO
!
                DO J=MYJS1,MYJE
                    DO I=MYIS,MYIE
                        TSE(I,J) = (TL(I+IHE(J),J-1) - TL(I,J)) * HTM(I+IHE(J),J-1,K) * HTM(I,J,K)
                        QSE(I,J) = (QL(I+IHE(J),J-1) - QL(I,J)) * HTM(I+IHE(J),J-1,K) * HTM(I,J,K)
                    END DO
                END DO
!
                DO J=MYJS2,MYJE2
                    DO I=MYIS,MYIE
                        TL(I,J) = (TNE(I,J) - TNE(I+IHW(J),J-1) + TSE(I,J) - TSE(I+IHW(J),J+1))   &
    &                           * HBM2(I,J) * 0.125 + TL(I,J)
                        QL(I,J) = (QNE(I,J) - QNE(I+IHW(J),J-1) + QSE(I,J) - QSE(I+IHW(J),J+1))   &
    &                           * HBM2(I,J) * 0.125 + QL(I,J)
                    END DO
                END DO
!
        870 END DO
!-----------------------------------------
! UPDATE THE FUNDAMENTAL PROGNOSTIC ARRAYS
!-----------------------------------------
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    T(I,J,K) = T(I,J,K) + TL(I,J)
                    Q(I,J,K) = Q(I,J,K) + QL(I,J)
                END DO
            END DO
!---------------------------------------------------------------------------------------------------------------
! ACCUMULATE LATENT HEATING DUE TO CONVECTION.
! SCALE BY THE RECIPROCAL OF THE PERIOD AT WHICH THIS ROUTINE IS CALLED. THIS PERIOD IS THE CONVECTION TIMESTEP.
!---------------------------------------------------------------------------------------------------------------
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    TCUCN(I,J,K) = TCUCN(I,J,K) + TL(I,J) * RDTCNVC
                END DO
            END DO
!        
    910 END DO
!    
    END IF
!----------------------------------------
! SAVE CLOUD TOP AND BOTTOM FOR RADIATION
!----------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            IF (LTOP(I,J) > 0 .AND. LTOP(I,J) < LBOT(I,J)) THEN
!
                CUTOP = FLOAT(LTOP(I,J))
                CUBOT = FLOAT(LBOT(I,J))
!
                  HTOP(I,J) = MIN(CUTOP,  HTOP(I,J))
                  HBOT(I,J) = MAX(CUBOT,  HBOT(I,J))
                CNVTOP(I,J) = MIN(CUTOP,CNVTOP(I,J))
                CNVBOT(I,J) = MAX(CUBOT,CNVBOT(I,J))
            END IF
        END DO
    END DO
!---------------------------------------------------------------------------------------------------------------------
! DIAGNOSTICS
!
! WRITE(LIST,950) NTSD, NSHAL, NDEEP, NNEG, NEGDS, NDSTN, NDSTP
!
! DO 940 L=1,LM
!    WRITE(LIST,952) L
!    WRITE(LIST,954) NBOTS(L), NTOPS(L), NDPTHS(L), NBOTD(L), NTOPD(L), NDPTHD(L)
! 940 CONTINUE
!
! 950 FORMAT(' NTSD=',I3,I8,' SHALLOW, ',I4,' DEEP, ',I4,' NEG., ',I4,' NEG. SHALL.,',I4,' DST.LT.0, ',I4,' DST.GT.0')
! 952 FORMAT(' LAYER (FROM TOP),',I2)
! 954 FORMAT('     NBOTS=',I4,'     NTOPS=',I4,'     NDPTHS=',I4,'     NBOTD=',I4,'     NTOPD=',I4,'     NDPTHD=',I4)
!---------------------------------------------------------------------------------------------------------------------
    RETURN
!
    END SUBROUTINE CUCNVC

    SUBROUTINE BOCOV
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE BOCOV
!>   
!> SUBPROGRAM: BOCOV - UPDATE WIND POINTS ON BOUNDARY
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 94-03-08
!>     
!> ABSTRACT:
!> U AND V COMPONENTS OF THE WIND ARE UPDATED ON THE DOMAIN BOUNDARY BY APPLYING THE PRE-COMPUTED 
!> TENDENCIES AT EACH TIME STEP. 
!> AN EXTRAPOLATION FROM INSIDE THE DOMAIN IS USED FOR THE COMPONENT TANGENTIAL TO THE BOUNDARY IF 
!> THE NORMAL COMPONENT IS OUTWARD.
!>     
!> PROGRAM HISTORY LOG:
!> 87-??-??  MESINGER   - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!> 
!> USE MODULES: BOCO
!>              CTLBLK
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS   
!>    
!> DRIVER     : DIGFLT
!>              EBU
!>              NEWFLT
!>
!> CALLS      : ------
!>--------------------------------------------------------------------------------------------------
    USE BOCO
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: D06666 = .06666666
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM * JM - JM / 2
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IIM     , JJM     , JL      , N       , I       , II      , J       , JJ
!
#include "sp.h"
!----------------------------------------------------
! TIME INTERPOLATION OF U AND V AT THE OUTER BOUNDARY
!----------------------------------------------------
    IIM = IM - MY_IS_GLB + 1
    JJM = JM - MY_JS_GLB + 1
!
    DO 115 JL=1,LM
!
        N = 1
        DO 111 I=1,IM-1
            UB(N,JL,1) = UB(N,JL,1) + UB(N,JL,2) * DT
            VB(N,JL,1) = VB(N,JL,1) + VB(N,JL,2) * DT
            IF (MY_JS_GLB == 1 .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                II = I - MY_IS_GLB + 1
                U(II,1,JL) = UB(N,JL,1)
                V(II,1,JL) = VB(N,JL,1)
            END IF
            N = N + 1
            CONTINUE
    111 END DO
!
        DO 112 I=1,IM-1
            UB(N,JL,1)=UB(N,JL,1)+UB(N,JL,2)*DT
            VB(N,JL,1)=VB(N,JL,1)+VB(N,JL,2)*DT
            IF (MY_JE_GLB == JM .AND. I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                II = I - MY_IS_GLB + 1
                U(II,JJM,JL) = UB(N,JL,1)
                V(II,JJM,JL) = VB(N,JL,1)
            END IF
            N = N + 1
            CONTINUE
    112 END DO
!
        DO 113 J=2,JM-1,2
            UB(N,JL,1) = UB(N,JL,1) + UB(N,JL,2) * DT
            VB(N,JL,1) = VB(N,JL,1) + VB(N,JL,2) * DT
            IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                U(1,JJ,JL) = UB(N,JL,1)
                V(1,JJ,JL) = VB(N,JL,1)
            END IF
            N = N + 1
            CONTINUE
    113 END DO
!
        DO 114 J=2,JM-1,2
            UB(N,JL,1) = UB(N,JL,1) + UB(N,JL,2) * DT
            VB(N,JL,1) = VB(N,JL,1) + VB(N,JL,2) * DT
            IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JJ = J - MY_JS_GLB + 1
                U(IIM,JJ,JL) = UB(N,JL,1)
                V(IIM,JJ,JL) = VB(N,JL,1)
            END IF
            N = N + 1
            CONTINUE
    114 END DO
        CONTINUE
!
115 END DO
!-------------------------------------------------------
! EXTRAPOLATION OF TANGENTIAL VELOCITY AT OUTFLOW POINTS
!-------------------------------------------------------
    DO 125 JL=1,LM
!
        IF (IBROW == 1) THEN
            DO 121 I=MYIS1_P1,MYIE2_P1
                IF (V(I,1,JL) < 0.) U(I,1,JL) = (VTM(I,5,JL) + 1.) * U(I,3,JL)                    &
    &                                         -  VTM(I,5,JL)       * U(I,5,JL)
                CONTINUE
        121 END DO
        END IF
!
        IF (ITROW == 1) THEN
            DO 122 I=MYIS1_P1,MYIE2_P1
                IF (V(I,JJM,JL) > 0.) U(I,JJM,JL) = (VTM(I,JJM-4,JL) + 1.) * U(I,JJM-2,JL)        &
    &                                             -  VTM(I,JJM-4,JL)       * U(I,JJM-4,JL)                         
                CONTINUE
        122 END DO
        END IF
!
        DO 123 J=4,JM-3,2
            IF (ILCOL == 1) THEN
                IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    IF (U(1,JJ,JL) < 0.) V(1,JJ,JL) = (VTM(3,JJ,JL) + 1.) * V(2,JJ,JL)            & 
    &                                               -  VTM(3,JJ,JL)       * V(3,JJ,JL)
                END IF
            END IF
            CONTINUE
    123 END DO
!
        DO 124 J=4,JM-3,2
            IF (IRCOL == 1) THEN
                IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    IF (U(IIM,JJ,JL) > 0.)  V(IIM,JJ,JL) = (VTM(IIM-2,JJ,JL)+1.) * V(IIM-1,JJ,JL) &
    &                                                    -  VTM(IIM-2,JJ,JL)     * V(IIM-2,JJ,JL)
                END IF
            END IF
            CONTINUE
    124 END DO
        CONTINUE
!
125 END DO
!-----------------------------------------------------
! SPACE INTERPOLATION OF U AND V AT THE INNER BOUNDARY
!-----------------------------------------------------
    DO 140 JL=1,LM
!
        IF (IBROW == 1 .AND. ILCOL == 1) THEN
            U(2,2,JL) = D06666 * (4. * (U(1,1,JL) + U(2,1,JL) + U(2,3,JL))                        &
    &                 +                 U(1,2,JL) + U(1,4,JL) + U(2,4,JL))
!
            V(2,2,JL) = D06666 * (4. * (V(1,1,JL) + V(2,1,JL) + V(2,3,JL))                        &
    &                 +                 V(1,2,JL) + V(1,4,JL) + V(2,4,JL))
        END IF
!
        IF (IBROW == 1 .AND. IRCOL == 1) THEN
            U(IIM-1,2,JL) = D06666 * (4. * (U(IIM-2,1,JL) + U(IIM-1,1,JL) + U(IIM-2,3,JL))        &
    &                     +                 U(IIM  ,2,JL) + U(IIM  ,4,JL) + U(IIM-1,4,JL))
!
            V(IIM-1,2,JL) = D06666 * (4. * (V(IIM-2,1,JL) + V(IIM-1,1,JL) + V(IIM-2,3,JL))        &
    &                     +                 V(IIM  ,2,JL) + V(IIM  ,4,JL) + V(IIM-1,4,JL))
        END IF
!
        IF (ITROW == 1 .AND. ILCOL == 1) THEN
            U(2,JJM-1,JL) = D06666 * (4. * (U(1,JJM  ,JL) + U(2,JJM  ,JL) + U(2,JJM-2,JL))        &
    &                     +                 U(1,JJM-1,JL) + U(1,JJM-3,JL) + U(2,JJM-3,JL))
!
            V(2,JJM-1,JL) = D06666 * (4. * (V(1,JJM  ,JL) + V(2,JJM  ,JL) + V(2,JJM-2,JL))        &
    &                     +                 V(1,JJM-1,JL) + V(1,JJM-3,JL) + V(2,JJM-3,JL))
        END IF
!
        IF (ITROW == 1 .AND. IRCOL == 1) THEN
            U(IIM-1,JJM-1,JL) = D06666 * (4. * (U(IIM-2,JJM  ,JL)  + U(IIM-1,JJM  ,JL)            &
    &                         +                 U(IIM-2,JJM-2,JL)) + U(IIM,JJM-1  ,JL)            &
    &                         +                 U(IIM,JJM-3  ,JL)  + U(IIM-1,JJM-3,JL))
!
            V(IIM-1,JJM-1,JL) = D06666 * (4. * (V(IIM-2,JJM  ,JL)  + V(IIM-1,JJM  ,JL)            &
    &                         +                 V(IIM-2,JJM-2,JL)) + V(IIM,JJM-1  ,JL)            &
    &                         +                 V(IIM  ,JJM-3,JL)  + V(IIM-1,JJM-3,JL))
        END IF
!-----------------------------------------------------
! SPACE INTERPOLATION OF U AND V AT THE INNER BOUNDARY
!-----------------------------------------------------
        IF (IBROW == 1) THEN
            DO 131 I=MYIS2,MYIE2
                U(I,2,JL) = (U(I-1,1,JL) + U(I,1,JL) + U(I-1,3,JL) + U(I,3,JL)) * 0.25
                V(I,2,JL) = (V(I-1,1,JL) + V(I,1,JL) + V(I-1,3,JL) + V(I,3,JL)) * 0.25
                CONTINUE
        131 END DO
        END IF
!
        IF (ITROW == 1) THEN
            DO 132 I=MYIS2,MYIE2
                U(I,JJM-1,JL) = (U(I-1,JJM-2,JL) + U(I,JJM-2,JL)                                  &
    &                         +  U(I-1,JJM  ,JL) + U(I,JJM  ,JL)) * 0.25
!
                V(I,JJM-1,JL) = (V(I-1,JJM-2,JL) + V(I,JJM-2,JL)                                  &
    &                         +  V(I-1,JJM  ,JL) + V(I,JJM  ,JL)) * 0.25
                CONTINUE
        132 END DO
        END IF
!
        DO 133 J=3,JM-2,2
            IF (ILCOL == 1) THEN
                IF (MY_IS_GLB == 1 .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    U(1,JJ,JL) = (U(1,JJ-1,JL) + U(2,JJ-1,JL) + U(1,JJ+1,JL) + U(2,JJ+1,JL)) * 0.25
                    V(1,JJ,JL) = (V(1,JJ-1,JL) + V(2,JJ-1,JL) + V(1,JJ+1,JL) + V(2,JJ+1,JL)) * 0.25
                END IF
            END IF
            CONTINUE
    133 END DO
!
        IF (IRCOL == 1) THEN
            DO 134 J=3,JM-2,2
                IF (MY_IE_GLB == IM .AND. J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                    JJ = J - MY_JS_GLB + 1
                    U(IIM-1,JJ,JL) = 0.25 * (U(IIM-1,JJ-1,JL) + U(IIM,JJ-1,JL)                    &
    &                              +         U(IIM-1,JJ+1,JL) + U(IIM,JJ+1,JL))
!
                    V(IIM-1,JJ,JL) = 0.25 * (V(IIM-1,JJ-1,JL) + V(IIM,JJ-1,JL)                    &
    &                              +         V(IIM-1,JJ+1,JL) + V(IIM,JJ+1,JL))
                END IF
                CONTINUE
        134 END DO
        END IF
!
        CONTINUE
140 END DO
!
    RETURN
!
    END SUBROUTINE BOCOV

    SUBROUTINE DSTRB(ARRG, ARRL, LG, LL, L1)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE DSTRB
!>
!> SUBPROGRAM: DSTRB - DISTRIBUTE GLOBAL ARRAY TO LOCAL ARRAYS
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 97-08-29
!>
!> ABSTRACT:
!> DSTRB DISTRIBUTES THE ELEMENTS OF REAL GLOBAL ARRAY ARRG TO THE REAL LOCAL ARRAYS ARRL.  
!> LG IS THE VERTICAL DIMENSION OF THE  GLOBAL ARRAY.
!> LL IS THE VERTICAL DIMENSION OF THE LOCAL ARRAY.
!> L1 IS THE SPECIFIC LEVEL OF ARRL THAT IS BEING FILLED DURING THIS CALL 
!> (PERTINENT WHEN LG=1 AND LL>1).
!>
!> PROGRAM HISTORY LOG:
!> 97-08-29  BLACK      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> ARRG - GLOBAL ARRAY
!> LG   - VERTICAL DIMENSION OF GLOBAL ARRAY
!> LL   - VERTICAL DIMENSION OF LOCAL ARRAY
!> L1   - VERTICAL LEVEL OF ARRL BEING FILLED IN THIS CALL (USED ONLY WHEN LG=1 AND LL>1,
!>        I.E. WHEN THE GLOBAL ARRAY IS ACTUALLY JUST ONE LEVEL OF A MULTI_LEVEL ARRAY)
!>
!> OUTPUT ARGUMENT LIST:
!> ARRL - LOCAL ARRAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>  
!> DRIVER     : DIGFLT
!>              INIT
!>              INITS
!>              READ_NHB
!>
!> CALLS      : MPI_BARRIER
!>              MPI_RECV 
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
!
!--------------------------------------- 
! DISTRIBUTE ARRAYS FROM GLOBAL TO LOCAL
!--------------------------------------- 
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM, LG)                           , INTENT(IN)          ::&
    & ARRG
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LL)         , INTENT(INOUT)       ::&
    & ARRL
!
    REAL   (KIND=R4KIND), DIMENSION(IM*JM*LG)                                                 ::&
    & ARRX
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL      , LG      , L1 
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IGLB    , JGLB    , LOCI    , LOCJ    , I       , J       , L       , IPE     , KNT     ,   &
    & ISEND   , NUMVALS , IRECV   , IRTN    
!---------------------------------------------------------------------------------------
! PE0 FILLS ITS OWN LOCAL DOMAIN THEN PARCELS OUT ALL THE OTHER PIECES TO THE OTHER PEs.
!---------------------------------------------------------------------------------------
    IF (MYPE == 0) THEN
 !   
        IF (LG == 1 ) THEN
            DO JGLB=JS_GLB_TABLE(0),JE_GLB_TABLE(0)
                LOCJ = G2LJ(JGLB)
                DO IGLB=IS_GLB_TABLE(0),IE_GLB_TABLE(0)
                    LOCI = G2LI(IGLB)
                    ARRL(LOCI,LOCJ,L1) = ARRG(IGLB,JGLB,1)
                END DO
            END DO
 !       
        ELSE
 !       
            DO L=1,LG
                DO JGLB=JS_GLB_TABLE(0),JE_GLB_TABLE(0)
                    LOCJ = G2LJ(JGLB)
                    DO IGLB=IS_GLB_TABLE(0),IE_GLB_TABLE(0)
                        LOCI = G2LI(IGLB)
                        ARRL(LOCI,LOCJ,L) = ARRG(IGLB,JGLB,L)
                    END DO
                END DO
            END DO
        END IF
!    
        DO IPE=1,NPES-1
            KNT = 0
!        
            DO L=1,LG
                DO JGLB=JS_GLB_TABLE(IPE),JE_GLB_TABLE(IPE)
                    DO IGLB=IS_GLB_TABLE(IPE),IE_GLB_TABLE(IPE)
                        KNT = KNT + 1
                        ARRX(KNT) = ARRG(IGLB,JGLB,L)
                    END DO
                END DO
            END DO
 !       
            CALL MPI_SEND(ARRX, KNT, MPI_REAL, IPE, IPE, MPI_COMM_COMP, ISEND)
        END DO
!----------------------------------------------------------------------------
! ALL OTHER PEs RECEIVE THEIR PIECE FROM PE0 AND THEN FILL THEIR LOCAL ARRAY.
!----------------------------------------------------------------------------
    ELSE
        NUMVALS = (IE_GLB_TABLE(MYPE) - IS_GLB_TABLE(MYPE)+1)                                     &
    &           * (JE_GLB_TABLE(MYPE) - JS_GLB_TABLE(MYPE)+1)                                     &
    &           * LG
!
        CALL MPI_RECV(ARRX, NUMVALS, MPI_REAL, 0, MYPE, MPI_COMM_COMP, ISTAT, IRECV)
!    
        KNT = 0
        IF (LG == 1) THEN
            DO J=MY_JS_LOC,MY_JE_LOC
                DO I=MY_IS_LOC,MY_IE_LOC
                    KNT = KNT + 1
                    ARRL(I,J,L1) = ARRX(KNT)
                END DO
            END DO     
        ELSE
            DO L=1,LG
                DO J=MY_JS_LOC,MY_JE_LOC
                    DO I=MY_IS_LOC,MY_IE_LOC
                        KNT = KNT + 1
                        ARRL(I,J,L) = ARRX(KNT)
                    END DO
                END DO
            END DO
        END IF
 !   
    END IF
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!
    RETURN
!
    END SUBROUTINE DSTRB

    MODULE OPTIONS
!>--------------------------------------------------------------------------------------------------
!> MODULE OPTIONS
!>
!> ABSTRACT:
!> MODULE OPTIONS CONTAINS USER OPTIONS
!> SPVAL : FLAG FOR MISSING DATA ON OUTPUT GRID. THIS CAN ARISE IF OUTPUT GRID EXTENDS BEYOND THE 
!>         FILLED E-GRID.
!>
!> IBESSL: SWITCH FOR TYPE OF HORIZONTAL INTERPOLATION FROM FILLED E-GRID TO OUTPUT GRID.
!>         -1 = 4-POINT LINEAR INTERPOLATION SCHEME WITH GRADIENT CORRECTION. THIS OPTION IS NOT 
!>         AVAILABLE
!>         0 =  4-POINT LINEAR INTERPOLATION SCHEME
!>         1 = 16-POINT BESSEL INTERPOLATION SCHEME. THIS OPTION IS NOT AVAILABLE.
!>
!> KSB   : SQUARE ROOT OF THE NUMBER OF SUB-BOXES WHICH SUBROUTINE CETLIH USES. SUBROUTINE CETLIH 
!>         INTERPOLATES A H-POINT ETA GRID FIELD TO AN OUTPUT GRID CONSERVING THE AREA INTEGRAL OF 
!>         THE E-GRID FIELD.  
!>         WHEN INTERPOLATING PRECIP AMOUNT TO A COARSER RESOLUTION GRID, KSB = 3 IS A GOOD CHOICE.  
!>         IF INTERPOLATING TO A FINER RESOLUTION GRID, KSB = 8 IS A GOOD CHOICE.
!>
!> IOFFS : PLUS/MINUS NUMBER OF POINTS ABOUT SOUTHWEST CORNER OUTPUT GRID POINT OVER WHICH CETLIH4.F
!>	   SEARCHES THE CLOSEST OUTPUT GRID POINT TO EACH SUB-BOX. WHEN INTERPOLATING TO A COARSER 
!>         RESOLUTION GRID, IOFFS=2 OR 3 IS A GOOD CHOICE.
!>         IF INTERPOLATING TO A FINER RESOLUTION GRID, IOFFS = 5 OR 6 IS A GOOD CHOICE.
!>
!> IFLAG : CONTROLS OUTPUT FROM FILLV
!>	   IFLAG = 0 -> TAKE WHAT INTERPOLATION GIVES
!>	   IFLAG = 1 -> TRUNCATE OUTPUT AT ZERO
!>	   IFLAG = 2 -> TRUNCATE AT A VERY SMALL
!>
!> POSITIVE NUMBER (EPS)
!>
!> SATDEL: FRACTIONAL VARIATION OF SATURATION. SUBROUTINE NLYLI (N-LAYER LIFTED INDEX) LIFTS A 
!>         MODIFIED PARCEL.
!>         PARCEL SPECIFIC HUMIDITY IS MODIFIED ACCORDING TO THE FORMULA QMOD = (1+SATDEL) * QGIVEN.
!>         THE NGM USES SATDEL = 0.05
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : SURFCE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & SPVAL   , IBESSL  , KSB     , IOFFS   , IFLAG   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & SATDEL
!
    DATA SPVAL  / 99999      /
    DATA IBESSL /     0      /
    DATA KSB    /     3      /
    DATA IOFFS  /     2      /
    DATA IFLAG  /     0      /
    DATA SATDEL /     0.05   /
!
    END MODULE OPTIONS

    SUBROUTINE PDTEDT
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PDTEDT
!>
!> SUBROUTINE: PDTEDT - SURFACE PRESSURE TENDENCY CALC
!> PROGRAMMER: JANJIC
!> ORG: W/NMC2
!> DATE: 96-07-??
!>
!> ABSTRACT:
!> PDTEDT VERTICALLY INTEGRATES THE MASS FLUX DIVERGENCE TO OBTAIN THE SURFACE PRESSURE TENDENCY AND
!> ETADOT ON THE LAYER INTERFACES.
!> THEN IT UPDATES THE HYDROSTATIC SURFACE PRESSURE, THE NONHYDROSTATIC PRESSURE, AND ADDS THE LOCAL
!> TIME DERIVATIVE AND VERTICAL ADVECTION OF NONHYDROSTATIC PRESSURE CONTRIBUTION TO THE OMEGA-ALPHA 
!> TERM OF THE THERMODYNAMIC EQUATION. 
!> ALSO, THE OMEGA-ALPHA TERM IS COMPUTED FOR DIAGNOSTICS.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-05-??  JANJIC     - ADDED NONHYDROSTATIC EFFECTS & MERGED THE PREVIOUS SUBROUTINES PDTE AND 
!>                        PDNEW
!> 00-01-03  BLACK      - DISTRIBUTED MEMORY AND THREADS
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              EXCHM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              TEMPCOM
!>              TIMMING
!>              TOPO
!>              VRBLS     
!>
!> DRIVER     : DIGFLT
!>              EBU
!>
!> CALLS      : EXCH
!>              ZERO2
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE TEMPCOM
    USE TIMMING
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: ITRMX = 0
!
    REAL   (KIND=R4KIND), PARAMETER :: WC    =  2. / 3.
    REAL   (KIND=R4KIND), PARAMETER :: RWCQ  = (1. - WC) * 0.25
    REAL   (KIND=R4KIND), PARAMETER :: RWC   =  1. / WC
!
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 7
    INTEGER(KIND=I4KIND), PARAMETER :: LNSDT = 7
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PRET    , RPSL    ,                                                                         &
    & FNE     , FSE     ,                                                                         &
    & HBMS    ,                                                                                   &
    & TTB     ,                                                                                   &
    & APDT    , PPDT    ,                                                                         &
    & TPM
!------------------------------------------------ 
! THE FOLLOWING ARE USED FOR TIMIMG PURPOSES ONLY
!------------------------------------------------ 
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       ,                                                               &
    & IX      , JX      ,                                                                         &
    & KS      ,                                                                                   &
    & NSMUD   ,                                                                                   &
    & JHL     , JHH     ,                                                                         &
    & IHL     , IHH
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DWDTP   , TPMP    , TTAL    , RHS     , ETADTL  , BTIM
!
    CALL ZERO2(PDSLO)
!------------------------------------------------
! COMPUTATION OF PRESSURE TENDENCY & PREPARATIONS 
!------------------------------------------------
    DO 100 K=2,LM
!
!$omp parallel do  
!  
        DO J=MYJS_P2,MYJE_P2
            DO I=MYIS_P2,MYIE_P2
                DIV(I,J,K) = DIV(I,J,K-1) + DIV(I,J,K)
            END DO
        END DO
!    
100 END DO
!
!$omp parallel do  
!  
    DO J=MYJS_P2,MYJE_P2
        DO I=MYIS_P2,MYIE_P2
             PSDT(I,J) = -DIV(I,J,LM)
             APDT(I,J) = PSDT(I,J)
             PPDT(I,J) = PSDT(I,J)
            PDSLO(I,J) = PDSL(I,J)
             RPSL(I,J) = 1. / PDSL(I,J)
        END DO
    END DO
!
!$omp parallel do  
! 
    DO J=MYJS_P2,MYJE_P2
        DO I=MYIS_P2,MYIE_P2
            PRET(I,J) = PSDT(I,J) * RES(I,J)
            PDSL(I,J) =   PD(I,J) * RES(I,J)
!        
            PINT(I,J,1) = PT
!        
            TPM(I,J) = PT + PINT(I,J,2)
            TTB(I,J) = 0.
        END DO
    END DO
!--------------------- 
! COMPUTATION OF ETADT 
!--------------------- 
!
!$omp parallel do  
!  
    DO 300 K=1,LM1
!   
        DO J=MYJS_P2,MYJE_P2
            DO I=MYIS_P2,MYIE_P2
                ETADT(I,J,K) = - (PRET(I,J)     *  ETA(K+1) +  DIV(I,J,K))                        &
    &                        *     HTM(I,J,K+1) * HBM2(I,J) * RPSL(I,J)
            END DO
        END DO
300 END DO
!---------------------------------------------- 
! KINETIC ENERGY GENERATION TERMS IN T EQUATION 
!---------------------------------------------- 
!
!$omp parallel do private (DWDTP  , RHS     , TPMP    , TTAL)
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            DWDTP = DWDT(I,J,1)
            TPMP  = PINT(I,J,2) + PINT(I,J,3)
!
            TTAL = 0.
!        
            RHS = -DIV(I,J,1) * RTOP(I,J,1) * HTM(I,J,1) * DWDTP * EF4T
!
            OMGALF(I,J,1) = OMGALF(I,J,1) + RHS
                 T(I,J,1) = (TTAL * RDETA(1) + RHS) * HBM2(I,J) + T(I,J,1)
              PINT(I,J,2) = PRET(I,J) * (ETA(1) + ETA(2)) * DWDTP * DT + TPM(I,J) - PINT(I,J,1)
!        
            TPM(I,J) = TPMP
            TTB(I,J) = TTAL
        END DO
    END DO
!
    DO 410 K=2,LM1
!
!$omp parallel do private (DWDTP  , RHS     , TPMP    , TTAL) 
! 
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                DWDTP = DWDT(I,J,K  )
                TPMP  = PINT(I,J,K+1) + PINT(I,J,K+2)
!
                TTAL = 0.
!           
                RHS = -(DIV(I,J,K-1) + DIV(I,J,K)) * RTOP(I,J,K) * HTM(I,J,K) * DWDTP * EF4T
!
                OMGALF(I,J,K  ) =  OMGALF(I,J,K) + RHS
                     T(I,J,K  ) = ((TTAL + TTB(I,J)) * RDETA(L) + RHS) * HBM2(I,J) + T(I,J,K)
                  PINT(I,J,K+1) = PRET(I,J) * (ETA(K) + ETA(K+1)) * DWDTP * DT + TPM(I,J)         &
    &                           - PINT(I,J,K)
            
                TPM(I,J) = TPMP
                TTB(I,J) = TTAL
            END DO
        END DO
    
    410 END DO
!
!$omp parallel do private (DWDTP  , RHS)
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            DWDTP = DWDT(I,J,LM)
!        
            RHS = -(DIV(I,J,LM1) + DIV(I,J,LM)) * RTOP(I,J,LM) * HTM(I,J,LM) * DWDTP * EF4T
!
            OMGALF(I,J,LM  ) = OMGALF(I,J,LM) + RHS
                 T(I,J,LM  ) = (TTB(I,J) * RDETA(LM) + RHS) * HBM2(I,J) + T(I,J,LM)
              PINT(I,J,LM+1) = PRET(I,J) * (ETA(LM) + ETA(LM+1)) * DWDTP * DT + TPM(I,J)          &
    &                        - PINT(I,J,LM)
        END DO
    END DO
!--------------------------------------- 
! REGENERATE THE UNINTEGRATED DIVERGENCE 
!--------------------------------------- 
    DO 425 K=LM,2,-1
!
!$omp parallel do
!
        DO J=MYJS,MYJE2
            DO I=MYIS,MYIE
                DIV(I,J,K) = DIV(I,J,K) - DIV(I,J,K-1)
            END DO
        END DO
!   
425 END DO
!--------------------------------------------- 
! SMOOTHING VERTICAL VELOCITY ALONG BOUNDARIES 
!--------------------------------------------- 
    IF (.NOT. HYDRO .AND. KSMUD > 0) THEN
!
        NSMUD = KSMUD
!
!$omp parallel do
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                HBMS(I,J) = HBM2(I,J)
            END DO
        END DO
!    
        JHL = LNSDT
        JHH = JM - JHL + 1
!    
        DO J=JHL,JHH
            IF (J >= MY_JS_GLB .AND. J <= MY_JE_GLB) THEN
                IHL = JHL / 2   + 1
                IHH = IM  - IHL + MOD(J,2)
!            
                DO I=IHL,IHH
                    IF (I >= MY_IS_GLB .AND. I <= MY_IE_GLB) THEN
                        IX = I - MY_IS_GLB + 1
                        JX = J - MY_JS_GLB + 1
                        HBMS(IX,JX) = 0.
                    END IF
                END DO
!            
            END IF
        END DO
!
        DO KS=1,NSMUD
!
!$omp parallel do (ETADTL         , FNE     , FSE)
!
            DO 450 K=1,LM-1
!            
                DO J=MYJS_P1,MYJE1_P1
                    DO I=MYIS_P1,MYIE1_P1
                        FNE(I,J) = (ETADT(I+IHE(J),J+1,K  ) - ETADT(I       ,J  ,K  ))            &
    &                            *    HTM(I       ,J  ,K+1) *   HTM(I+IHE(J),J+1,K+1)
                    END DO
                END DO
!            
                DO J=MYJS1_P1,MYJE_P1
                    DO I=MYIS_P1,MYIE1_P1
                        FSE(I,J) = (ETADT(I+IHE(J),J-1,K  ) - ETADT(I       ,J  ,K  ))            &
    &                            *    HTM(I+IHE(J),J-1,K+1) *   HTM(I       ,J  ,K+1)
                    END DO
                END DO
!            
                DO J=MYJS2,MYJE2
                    DO I=MYIS1,MYIE1
                        ETADTL = (FNE(I,J) - FNE(I+IHW(J),J-1)  +  FSE(I,J)                       &
    &                          -             FSE(I+IHW(J),J+1)) * HBM2(I,J)
!
                        ETADT(I,J,K) = ETADTL * HBMS(I,J) * 0.125 + ETADT(I,J,K)
                    END DO
                END DO
!            
        450 END DO
!        
            BTIM = TIMEF()
!
            CALL EXCH(ETADT, LM-1, 2, 2)
!
            EXCH_TIM = EXCH_TIM + TIMEF() - BTIM
!
        END DO
!
    END IF
! 
    RETURN
!
    END SUBROUTINE PDTEDT

    SUBROUTINE HADZ
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE HADZ
!> 
!> SUBPROGRAM: HADZ - HORIZONTAL ADVECTION OF HEIGHT
!> PROGRAMMER: JANJIC 
!> ORG: W/NP22
!> DATE: 96-05-??
!>
!> ABSTRACT:
!> HADZ CALCULATES DIAGNOSTICALLY THE CONTRIBUTION OF THE HORIZONTAL ADVECTION OF HEIGHT
!>
!> PROGRAM HISTORY LOG:
!> 96-05-??  JANJIC  - ORIGINATOR
!> 00-01-04  BLACK   - DISTRIBUTED MEMORY AND THREADS
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS 
!>
!> DRIVER     : EBU
!>
!> CALLS      : -----           
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: NTSHY = 2
!
    REAL   (KIND=R4KIND), PARAMETER :: G     = 9.8

!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & HBMS    , DPDE    ,                                                                         &
    & UDY     , VDX     ,                                                                         &
    & UNED    , USED    ,                                                                         &
    & ZEW     , ZNS     ,                                                                         &
    & ZNE     , ZSE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , IX      , JX      , IVH     , IVL     , IHH     , IHL                          
!
    IF (NTSD <= NTSHY .OR. HYDRO) THEN
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
        DO K=1,LM
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    W(I,J,K) = 0.
                END DO
            END DO
        END DO
!
        RETURN
!
    END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
!$omp private (DPDE     , IHH     , IHL     , IVH     , IVL     , IX      , JX      , UDY     ,   &
!$omp          UNED     , USED    , VDX     , ZEW     , ZNE     , ZNS     , ZSE     )
!
    DO 200 K=1,LM
!
        DO J=MYJS_P3,MYJE_P3
            DO I=MYIS_P3,MYIE_P3
                DPDE(I,J) = PDSL(I,J) * DETA(K)
            END DO
        END DO
!------------------------------------------------- 
! MASS FLUXES AND MASS POINTS ADVECTION COMPONENTS 
!------------------------------------------------- 
        DO 125 J=2,JM-1
            IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                JX  = J  - MY_JS_GLB + 1
                IVL = 2  - MOD(J,2)
                IVH = IM - 1 
!            
                DO 120 I=IVL,IVH
                    IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                        IX = I - MY_IS_GLB + 1
                        UDY(IX,JX)  =   U(IX,JX,K) * DY
                        ZEW(IX,JX)  = UDY(IX,JX)   * (DPDE(IX + IVW(JX), JX)                      &
    &                               +                DPDE(IX + IVE(JX), JX))                      &
    &                               *                  (Z(IX + IVE(JX), JX,K)                     &
    &                               -                   Z(IX + IVW(JX), JX,K))
!
                        VDX(IX,JX)  =   V(IX,JX,K) *    DX(IX,JX)
                        ZNS(IX,JX)  = VDX(IX,JX)   * (DPDE(IX,JX-1)   + DPDE(IX,JX+1))            &
    &                                              *    (Z(IX,JX+1,K) -    Z(IX,JX-1,K))
                        UNED(IX,JX) = UDY(IX,JX)   +   VDX(IX,JX)
                        USED(IX,JX) = UDY(IX,JX)   -   VDX(IX,JX)
                    END IF
            120 END DO
!
            END IF
    125 END DO
!--------------------------------------------- 
! DIAGONAL FLUXES AND DIAGONALLY AVERAGED WIND 
!--------------------------------------------- 
        DO 145 J=2,JM-2
            IF (J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JX  = J  - MY_JS_GLB + 1
                IHL = 2  -             MOD(J+1,2)
                IHH = IM - 2         + MOD(J  ,2)
!            
                DO 140 I=IHL,IHH
                    IF (I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                        IX = I - MY_IS_GLB + 1
!
                        ZNE(IX,JX) = (UNED(IX + IHE(JX), JX  )                                    &
    &                              +  UNED(IX          , JX+1))                                   &
    &                              * (DPDE(IX          , JX  )                                    &
    &                              +  DPDE(IX + IHE(JX), JX+1))                                   &
    &                              *    (Z(IX + IHE(JX), JX+1, K)                                 &
    &                              -     Z(IX          , JX  , K))
                    END IF
            140 END DO
!
            END IF
    145 END DO
!    
        DO 165 J=3,JM-1
            IF (J >= MY_JS_GLB-JBPAD1 .AND. J <= MY_JE_GLB+JTPAD1) THEN
                JX  = J  - MY_JS_GLB + 1
                IHL = 2  -             MOD(J+1, 2)
                IHH = IM - 2         + MOD(J  , 2)
!            
                DO 160 I=IHL,IHH
                    IF (I >= MY_IS_GLB-ILPAD1 .AND. I <= MY_IE_GLB+IRPAD1) THEN
                        IX = I - MY_IS_GLB + 1
!
                        ZSE(IX,JX) = (USED(IX + IHE(JX), JX  )                                    &
    &                              +  USED(IX          , JX-1))                                   &
    &                              * (DPDE(IX          , JX  )                                    &
    &                              +  DPDE(IX + IHE(JX), JX-1))                                   &
    &                              *    (Z(IX + IHE(JX), JX-1, K)                                 &
    &                              -     Z(IX          , JX  , K))
                    END IF 
            160 END DO
!
            END IF
    165 END DO
!--------------- 
! ADVECTION OF Z 
!--------------- 
        DO 175 J=3,JM-2
            IF (J >= MY_JS_GLB .AND. J <= MY_JE_GLB) THEN
                JX  = J - MY_JS_GLB + 1
                IHL = 2
                IHH = IM - 2 + MOD(J,2)
!            
                DO 170 I=IHL,IHH
                    IF (I >= MY_IS_GLB .AND. I <= MY_IE_GLB) THEN
                        IX = I - MY_IS_GLB + 1
!
                        W(IX,JX,K) = -(ZEW(IX + IHW(JX), JX)   + ZEW(IX + IHE(JX), JX  )          &
    &                              +   ZNS(IX          , JX-1) + ZNS(IX          , JX+1)          &
    &                              +   ZNE(IX + IHW(JX), JX-1) + ZNE(IX          , JX  )          &
    &                              +   ZSE(IX          , JX  ) + ZSE(IX + IHW(JX), JX+1))         &
    &                              *   FAD(IX          , JX  )                                    &
    &                              *   HTM(IX,JX,K) * HBM2(IX,JX) / (DPDE(IX,JX) * DT)            &
    &                              +     W(IX,JX,K)
                    END IF
            170 END DO
!
            END IF
    175 END DO
!
200 END DO
!
    RETURN
!
    END SUBROUTINE HADZ

    SUBROUTINE SGETMO(A, NHRZ1, NHRZ2, LM1, ACOL_T, LM2)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SGETMO
!>
!> SUBROUTINE: ????? - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ????? - ORIGINATOR
!> 18-01-15  LUCCI - MODERNIZATION OF THE CODE, INCLUDING:
!>                   * F77 TO F90/F95
!>                   * INDENTATION & UNIFORMIZATION CODE
!>                   * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                   * DOCUMENTATION WITH DOXYGEN
!>                   * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> A      - 
!> LM1    -
!> LM2    - 
!> NHRZ1  -
!> NHRZ2  -  
!>
!> OUTPUT ARGUMENT LIST:
!> ACOL_T - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : GSCOND
!>              PRECPD
!>              TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), DIMENSION(NHRZ1, LM1)                 , INTENT(IN)                    ::&
    & A
!
    REAL   (KIND=R4KIND), DIMENSION(LM1, NHRZ1)                 , INTENT(INOUT)                 ::&
    & ACOL_T
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                        , INTENT(IN)                    ::&
    & LM1     , LM2     , NHRZ1   , NHRZ2
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & L       , N
!
    DO N=1,NHRZ1
        DO L=1,LM1
            ACOL_T(L,N) = A(N,L)
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE SGETMO 

    SUBROUTINE RDTEMP
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE RDTEMP
!>
!> SUBROUTINE: RDTEMP - RADIATIVE TEMPERATURE CHANGE
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 93-12-29
!>
!> ABSTRACT:
!> RDTEMP APPLIES THE TEMPERATURE TENDENCIES DUE TO RADIATION AT ALL LAYERS AT EACH ADJUSTMENT TIME
!> STEP
!>
!> PROGRAM HISTORY LOG:
!> 87-09-??  BLACK      - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMRDL
!>              ACMRDS
!>              CTLBLK
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : ZENITH              
!>--------------------------------------------------------------------------------------------------
    USE ACMRDL
    USE ACMRDS
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & FACTR
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K  
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TIMES   , DAYI    , HOUR    , TTNDKL 
!---------------------------------------- 
!  GET CURRENT VALUE OF COS(ZENITH ANGLE)
!----------------------------------------
    TIMES = (NTSD-1) * DT
!
    CALL ZENITH(TIMES, DAYI, HOUR)
!
!$omp parallel do 
!
    DO 50 J=MYJS,MYJE
        DO 50 I=MYIS,MYIE
            IF (CZMEAN(I,J) > 0.) THEN
                FACTR(I,J) = CZEN(I,J) / CZMEAN(I,J)
            ELSE
                FACTR(I,J) = 0.
            END IF
 50 END DO
!
!$omp parallel do private (TTNDKL)
!
    DO 100 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TTNDKL = RSWTT(I,J,K) * FACTR(I,J) + RLWTT(I,J,K)
                T(I,J,K) = T(I,J,K) + TTNDKL * DT * HTM(I,J,K) * HBM2(I,J)
                IF (MYPE == 4 .AND. I == 16 .AND. J == 11 .AND. K >= 30) THEN
                END IF
                633 FORMAT('K,TNEW,INCR,SW,LW: ',I2,1X,F8.3,1X,F8.5,1X,E12.6,1X,E12.6)
            END DO
        END DO
100 END DO
!
    RETURN
!
    END SUBROUTINE RDTEMP

    MODULE ACMRDS
!>--------------------------------------------------------------------------------------------------
!> MODULE ACMRDL
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : CHKOUT
!>              GOSSIP
!>              INIT
!>              INITS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SURFCE 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NRDSW
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ARDSW   , TRDSW 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & RSWIN   , RSWOUT  , RSWTOA  ,                                                               &
    & ASWIN   , ASWOUT  , ASWTOA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & RSWTT
!
    END MODULE ACMRDS

    SUBROUTINE RADTN
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE RADTN
!>
!> SUBROUTINE: RADTN - THE OUTER RADIATION DRIVER
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 93-12-??
!>
!> ABSTRACT:
!> RADTN PRIMARILY SERVES TO SET UP THE ARRAYS NEEDED AS INPUT FOR RADFS (THE INNER RADIATION 
!> DRIVER). GROUPS OF MODEL COLUMNS ARE SENT TO RADFS BUT FIRST THEY ARE "LIFTED" SO THAT THE LOWEST
!> LAYER ABOVE THE GROUND HAS A VERTICAL INDEX VALUE OF LM NOT LMH.
!> THIS ROUTINE IS CALLED AS OFTEN AS DESIRED (EVERY 1 TO 2 HOURS) FOR BOTH THE SHORT AND LONGWAVE 
!> EFFECTS. THE RESULTING TEMPERATURE TENDENCIES, TOTAL DOWNWARD AND SHORTWAVE UPWARD FLUXES ARE 
!> COLLECTED.
!> THE INITIAL GROUND POTENTIAL TEMPERATURE IS ALSO COMPUTED HERE AND IS SIMPLY AN ADIABATIC 
!> EXTRAPOLATION FROM THE LOWEST MID- LAYER VALUE ABOVE THE GROUND.
!>
!> PROGRAM HISTORY LOG:
!> 87-09-??  BLACK      - ORIGINATOR
!> 92-10-??  BALDWIN    - VARIOUS CLOUD EFFECTS WERE INCLUDED WHICH WERE ALREADY IN THE MRF
!> 93-11-??  ZHAO       - TIED TO UPDATED GFDL RADIATION SCHEME USING MODEL-PREDICTED CLOUD
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-04-13  BLACK      - PARALLELIZED THE LARGE LOOP STEPPING THROUGH THE DOMAIN THAT CALLS RADFS
!> 95-10-10  ZHAO       - I) THE CALCULATION OF CLOUD FRACTION WAS CHANGED TO USE BOTH CLOUD 
!>                        WATER/ICE MIXING RATIO AND RELATIVE HUMIDITY (RANDALL, 1994);
!>                        II) THE CLOUD INPUTS WERE CHANGED TO USE CLOUD FRACTION IN EACH MODEL 
!>                        LAYER AFTER Y.T. HOU (1995).
!> 96-06-03  ZHAO       - SNOW ALBEDO IS CHANGED ACCORDING TO SUGGESTIONS FROM KEN MITCHELL AND FEI
!>                        CHEN
!> 96-07-23  ZHAO       - ADD CALL TO SOLARD TO CALCULATE THE NON-DIMENSIONAL SUN-EARTH DISTANCE RAD1 
!>                        WHICH WILL BE USED IN RADFS TO COMPUTE SOLAR CONSTANT SOLC ON EACH DAY
!> 96-07-26  BLACK      - ADDED OZONE COMPUTATIONS
!> 97-05-19  ZHAO       - DIAGNOSTIC CLOUDS (LOW, MIDDLE, AND HIGH) ARE MODIFIED TO USE THE MAXIMUM
!>                        OF CONVECTIVE AND STRATIFORM. THIS WILL REPLACE THE PREVIOUS SCHEME WHICH
!>                        USES ONLY CONVECTIVE CLOUDS AT CONVECTIVE POINTS. THIS WILL AFFECT
!>                        CFRACL, CFRACM, CFRACH, AND WILL AFFECT THE TOTAL CLOUD FRACTION 
!>                        CALCULATION IN THE POST PROCESSORS.
!> 98-??-??  TUCCILLO   - ADDED PARALLELISM FOR CLASS VIII
!> 98-10-27  BLACK      - PARALLELISM INTO NEWEST VERSION
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> NOTE: CONVECTIVE CLOUDS ARE ADDED IN THIS SUBROUTINE FOR USE IN THE ETA MODEL IN WHICH 
!>       MODEL-PREDICTED CLOUDS ARE NOT USED IN THE CONVECTIVE PRECIPITATION PROCESSES. 
!>       FOR USE WITH THE VERSION OF THE ETA MODEL IN WHICH THE MODEL-PREDICTED CLOUDS ARE LINKED
!>       INTO THE MODEL'S CONVECTIVE PRECIPITATION PROCESSES, JUST SET: 
!>       CNCLD = .FALSE. 
!>       QINGYUN ZHAO  94-9-12
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLD
!>              ACMRDL
!>              ACMRDS
!>              CLDWTR
!>              CNVCLD
!>              CTLBLK
!>              CUINIT
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM 
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS     
!>              PVRBLS     
!>              RD1TIM
!>              SOIL
!>              SWRSAV
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : OZON2D
!>              RADFS
!>              ZENITH
!>              ZERO2
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMRDL
    USE ACMRDS
    USE CLDWTR
    USE CNVCLD
    USE CTLBLK
    USE CUINIT
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE RD1TIM
    USE SOIL
    USE SWRSAV
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), PARAMETER :: CAPA  =  0.28589641
    REAL   (KIND=R4KIND), PARAMETER :: RTD   = 57.2957795
    REAL   (KIND=R4KIND), PARAMETER :: WA    =   .10
    REAL   (KIND=R4KIND), PARAMETER :: WG    =  1. - WA
!
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 0
!------ 
! CLOUD 
!------
    REAL   (KIND=R4KIND), PARAMETER :: A1    = 610.78
    REAL   (KIND=R4KIND), PARAMETER :: A2    =  17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3    = 273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4    =  35.86
    REAL   (KIND=R4KIND), PARAMETER :: PQ0   = 379.90516
!------ 
! CLOUD 
!------
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2

    REAL   (KIND=R4KIND), PARAMETER :: SLPM   =     1.01325E5
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ1  =     1.E-5 
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =     2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: EPSO3  =     1.E-10
    REAL   (KIND=R4KIND), PARAMETER :: HPINC  =     1.E1
    REAL   (KIND=R4KIND), PARAMETER :: CLDRH0 =     0.80 
    REAL   (KIND=R4KIND), PARAMETER :: TRESH  =     1.00
    REAL   (KIND=R4KIND), PARAMETER :: RNRM   =     1. / (TRESH - CLDRH0)
    REAL   (KIND=R4KIND), PARAMETER :: CLDRH2 =     0.90
    REAL   (KIND=R4KIND), PARAMETER :: TRESH2 =     1.00
    REAL   (KIND=R4KIND), PARAMETER :: RNRM2  =     1. / (TRESH2 - CLDRH2)
    REAL   (KIND=R4KIND), PARAMETER :: CLAPSE =    -0.0005  
    REAL   (KIND=R4KIND), PARAMETER :: CLPSE  =    -0.0006 
    REAL   (KIND=R4KIND), PARAMETER :: DCLPS  =    -0.0001
    REAL   (KIND=R4KIND), PARAMETER :: CM1    =  2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2    =     4.9283
    REAL   (KIND=R4KIND), PARAMETER :: CM3    =    23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS    =     0.622
    REAL   (KIND=R4KIND), PARAMETER :: PBOT   = 10000.0
    REAL   (KIND=R4KIND), PARAMETER :: STBOL  =     5.67E-8
    REAL   (KIND=R4KIND), PARAMETER :: PI2    =     2. * 3.14159265
    REAL   (KIND=R4KIND), PARAMETER :: RLAG   =    14.8125
    REAL   (KIND=R4KIND), PARAMETER :: US     =     1.
    REAL   (KIND=R4KIND), PARAMETER :: CLIMIT =     1.0E-20
!
    INTEGER(KIND=I4KIND), PARAMETER :: K15 = SELECTED_REAL_KIND(15)
    REAL(K15)                                                                                   ::&
    & PROD    , DDX     , EEX
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & CALL1   , SHORT   , LONG    , BITX    , BITY    , BITZ    , BITW    , BIT1    , BIT2    ,   &
    & BITC    , BITS    , BITCP1  , BITSP1
!
    LOGICAL(KIND=L4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & BCLD    ,  BTEMP1
!----------- 
! CONVECTION
!----------- 
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & CNCLD
!----------- 
! CONVECTION
!-----------
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & ICVB    , ICVT     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & PSFC    , TSKN    , ALBDO   , XLAT    , COSZ    , SLMSK   ,  CV     , SV      , FLWUP   ,   &
    & FSWDN   , FSWUP   , FSWDNS  , FSWUPS  , FLWDNS  , FLWUPS
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & TENDK
!
    REAL   (KIND=R4KIND), DIMENSION(0:LM)                                                       ::&
    & CLDAMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, 3)                                             ::&
    & CLDCFR
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, 3)                                             ::&
    & MBOT    , MTOP
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & CLDF
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LM)                                            ::&
    & TENDS   , TENDL   , PMID    , TMID    , QMID    , THMID   , OZN     , POZN    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PDSL    , FNE     , FSE     , TL      , PBOTL   , PTOPL   , PBOTM   , PTOPM   , PBOTH   ,   &
    & PTOPH   , TOT 
!
    REAL   (KIND=R4KIND), DIMENSION(9)                                                          ::&
    & CC      , PPT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & CSTR    , TAUC    , CVB     , CVT     , TAUDAR
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & PINT    , EMIS
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & PHALF
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & CAMT 
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & NCLDS   , KCLD
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & ITYP    , KTOP    , KBTM
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, NB, LP1)                                       ::&
    & RRCL    , TTCL
!------ 
! CLOUD 
!------
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LM)                                            ::&
    & IW      
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LM)                                            ::&
    & CCR     , CSMID   , WMID    , HMID    ,CCMID
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & BMID    , UMID 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NFILE   , I       , J       , NTSPH   , NRADPP  , ITIMSW  , ITIMLW  , JD      , II      ,   &
    & K       , IR      , N       , LML     , LVLIJ   , KNTLYR  , LL2     , IWKL    , LBASE   ,   &
    & L400    , LTROP   , NMOD    , NC      , NLVL    , MALVL   , LLTOP   , LLBOT   , KBT1    ,   &
    & KBT2    , KTH1    , KTH2    , KTOP1   , NBAND   , NCLD    , NKTP    , NBTM    , KS 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & PLOMD   , PMDHI   , PHITP   , P400    , PLBTM   , UTIM    , CLSTP   , TIME    , DAYI    ,   &
    & HOUR    , ADDL    , RANG    , RCOS1   , RSIN1   , RCOS2   , EXNER   , TIMES   , APES    ,   &
    & HH      , TKL     , QKL     , CWMKL   , TMT0    , TMT15   , AI      , BI      , PP      ,   &
    & QW      , QI      , QINT    , U00KL   , FIQ     , FIW     , QC      , RQKL    , ARG     ,   &
    & CCR_DUM , DDP     , DTHDP   , CLPFIL  , PMOD    , CC1     , CC2     , P1      , P2      ,   &
    & CLDMAX  , CL1     , CL2     , CR1     , DCPL    , QSUM    , PRS1    , PRS2    , DELP    ,   &
    & TCLD    , DD      , EE      , FF      , AA      , BB      , GG      , DENOM   , FCTRA   ,   &
    & FCTRB   , PDSLIJ  , CFRAVG  , DPCL
!------ 
! CLOUD 
!------
    DATA PLOMD /64200./, PMDHI /35000./, PHITP /15000./, P400 /40000./, PLBTM /105000./
    DATA NFILE /14/
    DATA CC /0.  , 0.1, 0.2 , 0.3, 0.4, 0.5,  0.6,  0.7,  0.8/
    DATA PPT /.14,  .31, .70, 1.6, 3.4, 7.7, 17. , 38. , 85. /
!
    UTIM  = 1.
    CNCLD = .TRUE. 
!-------------------------------------------------
! ASSIGN THE PRESSURES FOR CLOUD DOMAIN BOUNDARIES
!-------------------------------------------------
    PTOPC(1) = PLBTM
    PTOPC(2) = PLOMD
    PTOPC(3) = PMDHI
    PTOPC(4) = PHITP
!------------------------------- 
! FIND THE 'SEA LEVEL PRESSURE'.
!------------------------------- 
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDSL(I,J) = RES(I,J) * PD(I,J)
        END DO
    END DO
!------------------------------------------------------------------
! THE FOLLOWING CODE IS EXECUTED EACH TIME THE RADIATION IS CALLED.
!------------------------------------------------------------------
!
!-----------  
! CONVECTION 
!-----------  
!--------------------------------------------------------------------------------------------------  
! NRADPP IS THE NUMBER OF TIME STEPS TO ACCUMULATE CONVECTIVE PRECIP FOR RADIATION
! NOTE: THIS WILL NOT WORK IF NRADS AND NRADL ARE DIFFERENT UNLESS THEY ARE INTEGER MULTIPLES OF 
!       EACH OTHER CLSTP IS THE NUMBER OF HOURS OF THE ACCUMULATION PERIOD
!-------------------------------------------------------------------------------------------------- 
    NTSPH  = NINT(3600. / DT)
    NRADPP = MIN(NRADS,NRADL)
    CLSTP  = 1.0 * NRADPP / NTSPH
!-----------  
! CONVECTION 
!-----------  
!
!-----------------------------------------------------------------     
! STATE WHETHER THE SHORT OR LONGWAVE COMPUTATIONS ARE TO BE DONE.
!-----------------------------------------------------------------
    SHORT = .FALSE. 
    LONG  = .FALSE. 
!
    IF (MOD(NTSD,NRADS) == 1) SHORT = .TRUE. 
    IF (MOD(NTSD,NRADL) == 1) LONG  = .TRUE. 
!
    IF (MYPE == 0) THEN
        IF (SHORT) THEN
            WRITE(0,"(a)") 'RADTN: CALCULATE SHORTWAVE'
            WRITE(6,"(a)") 'RADTN: CALCULATE SHORTWAVE'
        END IF
        IF (LONG) THEN
            WRITE(0,"(a)") 'RADTN: CALCULATE LONGWAVE'
            WRITE(6,"(a)") 'RADTN: CALCULATE LONGWAVE'
        END IF
    END IF
!
    ITIMSW = 0
    ITIMLW = 0
!
    IF (SHORT) ITIMSW=1
    IF (LONG)  ITIMLW=1
!--------------------------------------------- 
! FLAG FOR RESETTING CUPPT,HTOP,HBOT IN CHKOUT
!--------------------------------------------- 
    IF (MOD(NTSD,NRADPP) == 1) CURAD = .TRUE. 
!-------------------------------------------------------------------------------------------------- 
! FIND THE MEAN COSINE OF THE SOLAR ZENITH ANGLE BETWEEN THE CURRENT TIME AND THE NEXT TIME 
! RADIATION IS CALLED. 
! ONLY AVERAGE IF THE SUN IS ABOVE THE HORIZON.
!-------------------------------------------------------------------------------------------------- 
    TIME = (NTSD-1) * DT
!
    CALL ZENITH(TIME, DAYI, HOUR)
!
    JD = INT(DAYI + 0.50)
    ADDL = 0.
!
    IF (MOD(IDAT(3),4) == 0) ADDL = 1.
!
    RANG  = PI2 * (DAYI - RLAG) / (365.25 + ADDL)
    RSIN1 = SIN(RANG)
    RCOS1 = COS(RANG)
    RCOS2 = COS(2. * RANG)
!
    IF (SHORT) THEN
!
!$omp parallel do private (I      , J)
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                CZMEAN(I,J) = 0.
                TOT   (I,J) = 0.
            END DO
        END DO
!    
        DO II=0,NRADS,NPHS
            TIMES = (NTSD-1) * DT + II * DT
!
            CALL ZENITH(TIMES,DAYI,HOUR)
!
!$omp parallel do private (I      , J)
!
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    IF (CZEN(I,J) > 0.) THEN
                        CZMEAN(I,J) = CZMEAN(I,J) + CZEN(I,J)
                        TOT   (I,J) = TOT(I,J) + 1.
                    END IF
                END DO
            END DO
        END DO
!
!$omp parallel do private (I      , J)
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                IF(TOT(I,J) > 0.) CZMEAN(I,J) = CZMEAN(I,J) / TOT(I,J)
            END DO
        END DO
    END IF
!
!$omp parallel do
!$omp private (AA       , ALBDO   , APES    , BB      , BCLD    , BIT1    , BIT2    , BITC    ,   &
!$omp          BITCP1   , BITS    , BITSP1  , BITW    , BITX    , BITY    , BITZ    , BMID    ,   &
!$omp          BTEMP1   , CAMT    , CC1     , CC2     , CCMID   , CCR     , CFRAVG  , CL1     ,   &
!$omp          CL2      , CLDAMT  , CLDCFR  , CLDMAX  , CLPFIL  , COSZ    , CR1     , CSMID   ,   &
!$omp          CSTR     , CV      , CWMKL   , DD      , DDP     , DELP    , DENOM   , DPCL    ,   &
!$omp          DTHDP    , EE      , EMIS    , EXNER   , FCTRA   , FCTRB   , FF      , FIQ     ,   &
!$omp          FIW      , FLWDNS  , FLWUP   , FLWUPS  , FSWDN   , FSWDNS  , FSWUP   , FSWUPS  ,   &
!$omp          GG       , HH      , HMID    , I       , ICVB    , ICVT    , IR      , ITYP    ,   &
!$omp          IW       , IWKL    , J       , KBT1    , KBT2    , KBTM    , KCLD    , KNTLYR  ,   &
!$omp          KTH1     , KTH2    , KTOP    , KTOP1   , K       , L400    , LBASE   , LIN     ,   &
!$omp          LL2      , LLBOT   , LLTOP   , LML     , LTROP   , LVLIJ   , MALVL   , MBOT    ,   &
!$omp          MTOP     , N       , NBAND   , NBTM    , NC      , NCLD    , NCLDS   , NKTP    ,   &
!$omp          NLVL     , NMOD    , OZN     , P1      , P2      , PDSLIJ  , PINT    , PMID    ,   &
!$omp          PMOD     , POZN    , PP      , PRS1    , PRS2    , PSFC    , QC      , QI      ,   &
!$omp          QINT     , QKL     , QMID    , QSUM    , QW      , RQKL    , RRCL    , SLMSK   ,   &
!$omp          SNOFAC   , SV      , TAUC    , TAUDAR  , TCLD    , TENDL   , TENDS   , THMID   ,   &
!$omp          TKL      , TMID    , TMT0    , TMT15   , TSKN    , TTCL    , U00KL   , UMID    ,   &
!$omp          WMID     , XLAT    )
!
!-------------------------------------------------------------
! THIS IS THE BEGINNING OF THE PRIMARY LOOP THROUGH THE DOMAIN
!-------------------------------------------------------------
!
    DO 700 J=MYJS,MYJE
!
        DO 125 K=1,LM
            DO I=MYIS,MYIE
                IR = IRAD(I)
                TMID (I,K) = T(I,J,1)
                QMID (I,K) = EPSQ
                CSMID(I,K) = 0.
                WMID (I,K) = 0.
                CCMID(I,K) = 0.
                IW   (I,K) = 0.
                CCR  (I,K) = 0.
                HMID (I,K) = 0.
                OZN  (I,K) = EPSO3
                TENDS(I,K) = 0.
                TENDL(I,K) = 0.
            END DO
    125 END DO
!    
        DO 140 N=1,3
            DO I=MYIS,MYIE
                CLDCFR(I,N) = 0.
                MTOP  (I,N) = 0
                MBOT  (I,N) = 0
            END DO
    140 END DO
!--------------------------------------------------------------------------------------------
! FILL IN WORKING ARRAYS WHERE VALUES AT L=LM ARE THOSE THAT ARE ACTUALLY AT ETA LEVEL L=LMH.
!--------------------------------------------------------------------------------------------
        DO 200 I=MYIS,MYIE
            IR      = IRAD(I)
            LML     = LMH (I,J)
            LVLIJ   = LVL (I,J)
            BMID(I) = HBM2(I,J)
            UMID(I) = U00 (I,J)
!        
            DO K=1,LML
                 PMID(I,K+LVLIJ)   = AETA(K)   * PDSL(I,J) + PT
                 PINT(I,K+LVLIJ+1) = ETA(K+1)  * PDSL(I,J) + PT
                EXNER              = (1.E5 / PMID(I,K+LVLIJ)) ** CAPA
                 TMID(I,K+LVLIJ)   =   T(I,J,K)
                THMID(I,K+LVLIJ)   =   T(I,J,K) * EXNER
                 QMID(I,K+LVLIJ)   =   Q(I,J,K)
                 WMID(I,K+LVLIJ)   = CWM(I,J,K)
                 HMID(I,K+LVLIJ)   = HTM(I,J,K)
            END DO
!--------------------------------------------------------------- 
! FILL IN ARTIFICIAL VALUES ABOVE THE TOP OF THE DOMAIN.
! PRESSURE DEPTHS OF THESE LAYERS IS 1 HPA.
! TEMPERATURES ABOVE ARE ALREADY ISOTHERMAL WITH (TRUE) LAYER 1.
!---------------------------------------------------------------
            IF (LVLIJ > 0) THEN
                KNTLYR = 0
!            
                DO K=LVLIJ,1,-1
                    KNTLYR       = KNTLYR + 1
                    PMID (I,K  ) = PT - REAL(2 * KNTLYR - 1) * 0.5 * HPINC
                    PINT (I,K+1) = PMID(I,K) + 0.5 * HPINC
                    EXNER        = (1.E5 / PMID(I,K)) ** CAPA
                    THMID(I,K  ) = TMID(I,K) * EXNER
                END DO
            END IF
!        
            IF (LVLIJ == 0) THEN
                PINT(I,1)=PT
            ELSE
                PINT(I,1) = PMID(I,1) - 0.5 * HPINC
            END IF
    200 END DO
!--------------------------------------------------------------------------------------------------
! FILL IN THE SURFACE PRESSURE, SKIN TEMPERATURE, GEODETIC LATITUDE, ZENITH ANGLE, SEA MASK, AND 
! ALBEDO. THE SKIN TEMPERATURE IS NEGATIVE OVER WATER.
!--------------------------------------------------------------------------------------------------
        DO 250 I=MYIS,MYIE
             PSFC(I)  =  PD(I,J) + PT
            APES      = (PSFC(I) * 1.E-5) ** CAPA
             TSKN(I)  = THS(I,J) * APES * (1. - 2. * SM(I,J))
            SLMSK(I)  =  SM(I,J)
! -------------------------------------------------------------------- 
! TURN OFF SNOW ALBEDO CALCULATION SINCE IT IS NOW CALCULATED IN SFLX.
! -------------------------------------------------------------------- 
            ALBDO(I) = ALBEDO(I,J)
!        
             XLAT(I) =   GLAT(I,J) * RTD
             COSZ(I) = CZMEAN(I,J)
    250 END DO
! ------------------------ 
! STRATIFORM CLOUD SECTION 
! ------------------------ 
!
! ------------------------------------------------------------------------------------------------- 
! CALCULATE STRATIFORM CLOUD COVERAGE AT EACH MODEL GRID POINT WHICH WILL BE USED IN THE MODEL 
! RADIATION PARAMETERIZATION SCHEME.
! ------------------------------------------------------------------------------------------------- 
!
! ---------------  
! QW, QI AND QINT 
! --------------- 
        DO 280 I=MYIS,MYIE
            LML   = LMH(I,J)
            LVLIJ = LVL(I,J)
!        
            DO 275 K=1,LML
                LL2   = K + LVLIJ
                HH    = HMID(I,LL2) * BMID(I)
                TKL   = TMID(I,LL2)
                QKL   = QMID(I,LL2)
                CWMKL = WMID(I,LL2)
                TMT0  = (TKL - 273.16)   * HH
                TMT15 = AMIN1(TMT0,-15.) * HH
                AI    = 0.008855
                BI    = 1.
!            
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!            
                PP   = PMID(I,LL2)
                QW   = HH * PQ0 / PP * EXP(HH * A2 * (TKL - A3) / (TKL - A4))
                QI   = QW * (BI + AI * AMIN1(TMT0, 0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15 + 15.))
!
                IF (TMT0 <= -40.) QINT = QI
! ----------------------  
! ICE-WATER ID NUMBER IW 
! ---------------------- 
                U00KL = UMID(I) + UL(K) * (0.95 - UMID(I)) * UTIM
                IF (TMT0 < -15.0) THEN
                    FIQ = QKL - U00KL * QI
                    IF (FIQ > 0. .OR. CWMKL > CLIMIT) THEN
                        IW(I,LL2) = 1
                    ELSE
                        IW(I,LL2) = 0
                    END IF
                END IF
!            
                IF (TMT0 >= 0.) THEN
                    IW(I,LL2) = 0
                END IF
!           
                IF (TMT0 < 0.0 .AND. TMT0 >= -15.0) THEN
                    IW(I,LL2) = 0
                    IF (IW(I,LL2-1) == 1 .AND. CWMKL > CLIMIT) IW(I,LL2) = 1
                END IF
!           
                IWKL = IW(I,LL2)
! --------------------------------             
! THE SATURATION SPECIFIC HUMIDITY 
! --------------------------------             
                FIW = FLOAT(IWKL)
                QC  = (1. - FIW) * QINT + FIW * QI
! ---------------------              
! THE RELATIVE HUMIDITY 
! ---------------------             
                IF (QC <= EPSQ1 .OR. QKL <= EPSQ1) THEN
                    RQKL = 0.
                ELSE
                    RQKL = QKL / QC
                END IF
! ---------------------             
! CLOUD COVER RATIO CCR 
! ---------------------             
                IF (RQKL >= 0.9999) THEN
                    CCR(I,LL2) = AMIN1(US,RQKL) 
! ------------------------------------------------------------------------------------------------- 
! FERRIER, 6/17/02: EMERGENCY CHANGE TO ELIMINATE VERY SMALL CLOUD AMOUNTS (SOON TO BE REPLACED BY 
!                   CORRECTIONS FROM ETAZ PARALLEL)
! -------------------------------------------------------------------------------------------------               
                ELSE IF (CWMKL > 1.E-7) THEN
                    ARG     = -1000. * CWMKL / (US - RQKL)
                    ARG     = AMAX1(ARG,-25.)
                    CCR_DUM = RQKL * (1. - EXP(ARG))
                    IF (CCR_DUM > .01) CCR(I,LL2) = CCR_DUM
                END IF
!
                CSMID(I,LL2) = AMIN1(US, CCR(I,LL2))
!
        275 END DO
    280 END DO
! ------------------------------------------------------------------------------------------------
! NOW CHECK THE CLOUDS PRODUCED ABOVE TO MAKE SURE THEY ARE GOOD ENOUGH FOR RADIATION CALCULATIONS
! ------------------------------------------------------------------------------------------------
!
! ---------------------------------- 
! NO STRATIFORM CLOUDS FOR THIS TYPE
! ---------------------------------- 
        DO 350 I=MYIS,MYIE
!        
            LML   = LMH(I,J)
            LVLIJ = LVL(I,J)
! --------------------------------------------------- 
! ZERO OUT CLDAMT IF LAND AND BELOW PBOT ABOVE GROUND
! --------------------------------------------------- 
            IF (SM(I,J) < 0.5) THEN
                DO K=1,LML
                    LL2 = LML - K + 1 + LVLIJ
                    DDP = PSFC(I) - PMID(I,LL2)
!
                    IF (DDP >= PBOT) GOTO 290
                    CSMID(I,LL2) = 0.
                END DO
!
                290 CONTINUE
            END IF
! -------------------------------------------------------------------------------------------------  
! CHECK FOR OCEAN STRATUS (LOW CLOUD) LOOK ONLY OVER OCEAN AND ONLY IF AN INVERSION 
! (DTHDP.LE.-0.05) IS PRESENT WITH AT LEAST 2 CLOUD FREE LAYERS ABOVE IT
! ------------------------------------------------------------------------------------------------- 
            IF (SM(I,J) > 0.5) THEN
! ----------------------            
! FIND BASE OF INVERSION
! ----------------------              
                LBASE = LM
!
                DO K=1,LML-1
                    LL2   = LML - K + 1 + LVLIJ
                    DTHDP = (THMID(I,LL2-1) - THMID(I,LL2)) / (PMID(I,LL2-1) - PMID(I,LL2))
!
                    IF (DTHDP <= CLAPSE) THEN
                        LBASE = LL2
                        GOTO 300
                    END IF
                END DO
!
            300 CONTINUE
! --------------------------------------             
! CHECK 2 LAYERS ABOVE LBASE FOR DRYNESS
! --------------------------------------             
                IF (CSMID(I,LBASE-1) <= 0. .AND. CSMID(I,LBASE-2) <= 0. .AND. LBASE < LM) THEN
                    IF (DTHDP > CLPSE) THEN
                        CLPFIL = 1. - ((CLPSE - DTHDP) / DCLPS)
                    ELSE
                        CLPFIL = 1.
                    END IF
!                
                    DO K=1,LML
                        LL2 = LML - K + 1 + LVLIJ
                        DDP = PSFC(I) - PMID(I,LL2)
!
                        IF (DDP >= PBOT) GO TO 310
                        CSMID(I,LL2) = CSMID(I,LL2) * CLPFIL
                    END DO
!
            310 CONTINUE
! -------------------------------------------------------------------------------------------------                  
! IF NO INVERSION OR IF CLDS EXIST IN EITHER OF THE 2 LAYERS ABOVE INVERSION, ZERO OUT CLOUD BELOW 
! PBOT
! -------------------------------------------------------------------------------------------------                
                ELSE
                    DO K=1,LML
                        LL2  = LML - K + 1 + LVLIJ
                        DDP = PSFC(I) - PMID(I,LL2)
!
                        IF (DDP >= PBOT) GOTO 320
!
                        CSMID(I,LL2) = 0.
                    END DO
!
                320 CONTINUE
!                
                END IF
!
            END IF
! ---------------------------------------  
! REMOVE HIGH CLOUDS ABOVE THE TROPOPAUSE
! --------------------------------------- 
            L400 = LM
            DO K=1,LML
                LL2 = LML - K + 1 + LVLIJ
                IF (PMID(I,LL2) <= 40000.0) THEN
                    L400 = LL2
                    GOTO 330
                END IF
            END DO
!
        330 CONTINUE
!        
            LTROP = LM
            DO LL2=L400,2,-1
                DTHDP = (THMID(I,LL2-1) - THMID(I,LL2)) / (PMID(I,LL2-1) - PMID(I,LL2))
!            
                IF (DTHDP < -0.0025 .OR. QMID(I,LL2) <= EPSQ1) THEN
                    LTROP = LL2
                    GOTO 340
                END IF
            END DO
!
        340 IF (LTROP < LM) THEN
                DO LL2=LTROP,1,-1
                    CSMID(I,LL2) = 0.
                END DO
            END IF
350 END DO
!--------------------------------  
! END OF STRATIFORM CLOUD SECTION
!--------------------------------
!
!----------- 
! CONVECTION 
!-----------
!
!--------------------------------------------------------------------------------------------------
! CONVECTIVE CLOUD SECTION
!
! THIS PART WAS MODIFIED TO COMPUTE CONVECTIVE CLOUDS AT EACH MODEL LAYER BASED ON CONVECTIVE 
! PRECIPITATION RATES. 
! CURRENTLY, CLOUDS ARE SET TO 0.75*CV(I) BELOW 400MB AND 0.90*CV(I) ABOVE 400MB TO ACCOUNT FOR 
! CIRRUS CAP Q.ZHAO   95-3-22
!
! NON-PRECIPITATING CLOUD FRACTION OF 20 PERCENT IS ADDED AT AT POINTS WHERE THE SHALLOW AND DEEP 
! CONVECTIONS ACCUR.
! Q. ZHAO  97-5-2
!   
!COMPUTE THE CONVECTIVE CLOUD COVER FOR RADIATION
!--------------------------------------------------------------------------------------------------    
        IF (CNCLD) THEN
!
            DO 375 I=MYIS,MYIE
                IF (HBOT(I,J) - HTOP(I,J) > 1.0) THEN
                    SV(I) = 0.0
                ELSE
                    SV(I) = 0.0
                END IF
!            
                PMOD = CUPPT(I,J) * 24.0 * 1000.0 / CLSTP
                NMOD = 0
!            
                DO NC=1,9
                    IF (PMOD > PPT(NC)) NMOD = NC
                END DO
!---------------------------------------------------            
! CLOUD TOPS AND BOTTOMS COME FROM CUCNVC
! ADD LVL TO BE CONSISTENT WITH OTHER WORKING ARRAYS
!---------------------------------------------------              
                IF (NMOD == 0) THEN
                    CV(I) = 0.
                ELSE IF (NMOD == 9) THEN
                    CV(I) = CC(9)
                ELSE
                    CC1 = CC(NMOD  )
                    CC2 = CC(NMOD+1)
!
                    P1 = PPT(NMOD  )
                    P2 = PPT(NMOD+1)
!
                    CV(I) = CC1 + (CC2 - CC1) * (PMOD - P1) / (P2 - P1)
                END IF
!            
                CV(I) = AMAX1(SV(I), CV(I))
                CV(I) = AMIN1(1.0,   CV(I))
!            
                IF (CV(I) == 0.0) THEN
                    ICVT(I) = 0
                    ICVB(I) = 0
                ELSE
                    ICVT(I) = INT(HTOP(I,J) + 0.50) + LVL(I,J)
                    ICVB(I) = INT(HBOT(I,J) + 0.50) + LVL(I,J)
                END IF
        375 END DO
!---------------------------------   
! MAKE SURE CLOUDS ARE DEEP ENOUGH
!--------------------------------- 
            DO I=MYIS,MYIE
                BCLD  (I) = CV(I) > 0. .AND. (ICVB(I) - ICVT(I)) >= 1
                BTEMP1(I) = BCLD(I)
            END DO
!---------------------------------- 
! COMPUTE CONVECTIVE CLOUD FRACTION
!---------------------------------- 
            DO 390 I=MYIS,MYIE
                IF (BCLD(I)) THEN
                    LML   = LMH(I,J)
                    LVLIJ = LVL(I,J)
!                
                    DO K=1,LML
                        LL2 = K + LVLIJ
                        IF (LL2 > ICVB(I) .OR. LL2 < ICVT(I)) THEN
                            CCMID(I,LL2) = 0.
                        ELSE
                            CCMID(I,LL2) = CV(I)
                        END IF
                        CCMID(I,LL2) = AMIN1(1.0, CCMID(I,LL2))
                    END DO
                END IF
        390 END DO
!---------------------------------------- 
! REMOVE HIGH CLOUDS ABOVE THE TROPOPAUSE
!---------------------------------------- 
            L400 = LM
!
            DO 425 I=MYIS,MYIE
                LML   = LMH(I,J)
                LVLIJ = LVL(I,J)
!            
                DO K = 1, LML
                    LL2 = LML - K + 1 + LVLIJ
                    IF (PMID(I,LL2) <= 40000.0) THEN
                        L400 = LL2
                        GOTO 400
                    END IF
                END DO
!
            400 CONTINUE
!            
                LTROP = LM
!
                DO LL2=L400,2,-1
                    DTHDP = (THMID(I,LL2-1) - THMID(I,LL2)) / (PMID(I,LL2-1) - PMID(I,LL2))
                    IF (DTHDP < -0.0025 .OR. QMID(I,LL2) <= EPSQ1) THEN
                        LTROP = LL2
                        GOTO 410
                    END IF
                END DO
!
            410 IF (LTROP < LM) THEN
                    DO LL2=LTROP,1,-1
                        CCMID(I,LL2) = 0.
                    END DO
                END IF
        425 END DO
!
    END IF
!-----------  
! CONVECTION 
!-----------    
!
!--------------------------------
! END OF CONVECTIVE CLOUD SECTION 
!--------------------------------
!
!--------------------------------------------------------------------------------------------------
! DETERMINE THE FRACTIONAL CLOUD COVERAGE FOR HIGH, MID AND LOW OF CLOUDS FROM THE CLOUD COVERAGE 
! AT EACH LEVEL
!
! NOTE: THIS IS FOR DIAGNOSTICS ONLY 
!--------------------------------------------------------------------------------------------------
        DO 500 I=MYIS,MYIE
!        
            CSTR(I) = 0.0
!        
            DO K=0,LM
                CLDAMT(K) = 0.
            END DO
!---------------------------         
! NOW GOES LOW, MIDDLE, HIGH
!---------------------------          
            DO 480 NLVL=1,3
                CLDMAX = 0.
                MALVL  = LM
                LLTOP  = LTOP(NLVL) + LVL(I,J)
!--------------------------------------------------------------------------------------------------  
! GO TO THE NEXT CLOUD LAYER IF THE TOP OF THE CLOUD-TYPE IN QUESTION IS BELOW GROUND OR IS IN THE 
! LOWEST LAYER ABOVE GROUND.
!-------------------------------------------------------------------------------------------------- 
                IF (LLTOP >= LM) GOTO 480
!            
                IF (NLVL > 1) THEN
                    LLBOT = LTOP(NLVL-1) - 1 + LVL(I,J)
                    LLBOT = MIN(LLBOT, LM1)
                ELSE
                    LLBOT = LM1
                END IF
!            
                DO 435 K=LLTOP,LLBOT
                    CLDAMT(K) = AMAX1(CSMID(I,K), CCMID(I,K))
                    IF (CLDAMT(K) > CLDMAX) THEN
                        MALVL  = K
                        CLDMAX = CLDAMT(K)
                    END IF
            435 END DO
!-------------------------------------------------------------------------------------------------- 
! NOW, CALCULATE THE TOTAL CLOUD FRACTION IN THIS PRESSURE DOMAIN USING THE METHOD DEVELOPED BY 
! Y.H., K.A.C. AND A.K. (NOV., 1992).
! IN THIS METHOD, IT IS ASSUMED THAT SEPERATED CLOUD LAYERS ARE RADOMLY OVERLAPPED AND ADJACENT 
! CLOUD LAYERS ARE MAXIMUM OVERLAPPED.
! VERTICAL LOCATION OF EACH TYPE OF CLOUD IS DETERMINED BY THE THICKEST CONTINUING CLOUD LAYERS 
! IN THE DOMAIN.
!--------------------------------------------------------------------------------------------------
                CL1  = 0.0
                CL2  = 0.0
                KBT1 = LLBOT
                KBT2 = LLBOT
                KTH1 = 0
                KTH2 = 0
!            
                DO 450 LL2=LLTOP,LLBOT
                    K = LLBOT - LL2 + LLTOP
                    BIT1 = .FALSE. 
                    CR1 = CLDAMT(K)
                    BITX = (PINT(I,K) >= PTOPC(NLVL+1)) .AND. (PINT(I,K) < PTOPC(NLVL)) .AND.     &
    &                      (CLDAMT(K) > 0.0)
                    BIT1 = BIT1 .OR. BITX
!
                    IF (.NOT. BIT1) GOTO 450
!-------------------------------------------------------------------------------------------------- 
! BITY=T: FIRST CLOUD LAYER; BITZ=T:CONSECUTIVE CLOUD LAYER
! NOTE:  WE ASSUME THAT THE THICKNESS OF EACH CLOUD LAYER IN THE DOMAIN IS LESS THAN 200 MB TO 
! AVOID TOO MUCH COOLING OR HEATING. 
! SO WE SET CTHK(NLVL)=200*E2. BUT THIS LIMIT MAY WORK WELL FOR CONVECTIVE CLOUDS. MODIFICATION 
! MAY BE NEEDED IN THE FUTURE.
!--------------------------------------------------------------------------------------------------
                    BITY = BITX .AND. (KTH2 <= 0)
                    BITZ = BITX .AND. (KTH2 >  0)
!                
                    IF (BITY) THEN
                        KBT2 = K
                        KTH2 = 1
                    END IF
!                
                    IF (BITZ) THEN
                        KTOP1 = KBT2 - KTH2 + 1
                        DPCL  = PMID(I,KBT2) - PMID(I,KTOP1)
                        IF (DPCL < CTHK(NLVL)) THEN
                            KTH2 = KTH2 + 1
                        ELSE
                            KBT2 = KBT2 - 1
                        END IF
                    END IF
!
                    IF (BITX) CL2 = AMAX1(CL2, CR1)
!--------------------------------------------------------------------------------- 
! AT THE DOMAIN BOUNDARY OR SEPARATED CLD LAYERS, RANDOM OVERLAP.
! CHOOSE THE THICKEST OR THE LARGEST FRACTION AMT AS THE CLD LAYER IN THAT DOMAIN.
!--------------------------------------------------------------------------------- 
                    BIT2 = .FALSE. 
                    BITY = BITX .AND. (CLDAMT(K-1) <= 0.0 .OR. PINT(I,K-1) < PTOPC(NLVL+1))
                    BITZ = BITY .AND. CL1 > 0.0
                    BITW = BITY .AND. CL1 <= 0.0
                    BIT2 = BIT2 .OR.  BITY
!
                    IF (.NOT. BIT2) GOTO 450
!                
                    IF (BITZ) THEN
                        KBT1 = INT((CL1 * KBT1 + CL2 * KBT2) / (CL1 + CL2))
                        KTH1 = INT((CL1 * KTH1 + CL2 * KTH2) / (CL1 + CL2)) + 1
!
                        CL1 = CL1 + CL2 - CL1 * CL2
                    END IF
!                
                    IF (BITW) THEN
                        KBT1 = KBT2
                        KTH1 = KTH2
                        CL1  = CL2
                    END IF
!                
                    IF (BITY) THEN
                        KBT2 = LLBOT
                        KTH2 = 0
                        CL2  = 0.0
                    END IF
!
            450 END DO
!
                CLDCFR(I,NLVL) = AMIN1(1.0, CL1)
                MTOP  (I,NLVL) = MIN(KBT1, KBT1 - KTH1 + 1)
                MBOT  (I,NLVL) = KBT1
!
        480 END DO
!
    500 END DO
!-------------------------------- 
! SET THE UN-NEEDED TAUDAR TO ONE
!-------------------------------- 
        DO I=MYIS,MYIE
            TAUDAR(I) = 1.0
        END DO
!--------------------------------------------------------------------------------------------------  
! NOW, CALCULATE THE CLOUD RADIATIVE PROPERTIES AFTER DAVIS (1982), HARSHVARDHAN ET AL (1987)
! AND Y.H., K.A.C. AND A.K. (1993).
!    
! UPDATE: THE FOLLOWING PARTS ARE MODIFIED, AFTER Y.T.H. (1994), TO CALCULATE THE RADIATIVE 
!         PROPERTIES OF CLOUDS ON EACH MODEL LAYER BOTH CONVECTIVE AND STRATIFORM CLOUDS ARE 
!         USED IN THIS CALCULATIONS.
!   
! QINGYUN ZHAO   95-3-22
!--------------------------------------------------------------------------------------------------
!   
!--------------------------------- 
! INITIALIZE ARRAYS FOR USES LATER
!--------------------------------- 
        DO 600 I=MYIS,MYIE
            LML   = LMH(I,J)
            LVLIJ = LVL(I,J)
!------------------------------------------------------------------------------------------------
! NOTE: LAYER=1 IS THE SURFACE, AND LAYER=2 IS THE FIRST CLOUD LAYER ABOVE THE SURFACE AND SO ON.
!------------------------------------------------------------------------------------------------
            EMIS(I,1) = 1.0
            KTOP(I,1) = LP1
            KBTM(I,1) = LP1
            CAMT(I,1) = 1.0
            ITYP(I,1) = 0
            KCLD(I)   = 2
!        
            DO NBAND=1,NB
                RRCL(I,NBAND,1) = 0.0
                TTCL(I,NBAND,1) = 1.0
            END DO
!        
            DO 510 K=2,LP1
                ITYP(I,K) = 0
                CAMT(I,K) = 0.0
                KTOP(I,K) = 1
                KBTM(I,K) = 1
                EMIS(I,K) = 0.0
!            
                DO NBAND=1,NB
                    RRCL(I,NBAND,K) = 0.0
                    TTCL(I,NBAND,K) = 1.0
                END DO
!
        510 END DO
!--------------------------------------------------------------------------------------------------
! NOW CALCULATE THE AMOUNT, TOP, BOTTOM AND TYPE OF EACH CLOUD LAYER
! CLOUD TYPE=1: STRATIFORM CLOUD
!       TYPE=2: CONVECTIVE CLOUD
! WHEN BOTH CONVECTIVE AND STRATIFORM CLOUDS EXIST AT THE SAME POINT, SELECT CONVECTIVE CLOUD 
! (TYPE=2), IN OTHER WORDS, CONVECTIVE CLOUDS HAVE THE HIGHER PRIORITY THAN STRATIFORM CLOUDS.
! CLOUD LAYERS ARE SEPARATED BY:
! 1. NO-CLOUD LAYER
! 2. DIFFERENT CLOUD TYPE
! NOTE: THERE IS ONLY ONE CONVECTIVE CLOUD LAYER IN ONE COLUMN.
! KTOP AND KBTM ARE THE TOP AND BOTTOM OF EACH CLOUD LAYER IN TERMS O ETA MODEL LEVEL.
!--------------------------------------------------------------------------------------------------
            DO 540 K=2,LML
                LL2 = LML - K+1 + LVLIJ
                BITC   = CCMID(I,LL2) > 0.1
                BITS   = CSMID(I,LL2) > 0.1
                BITCP1 = CCMID(I,LL2+1) > 0.1
                BITSP1 = CSMID(I,LL2+1) > 0.1
                BIT1   = BITS .OR. BITC
!
                IF (BIT1) THEN
!
                    IF (ITYP(I,KCLD(I)) == 0) THEN
                        CAMT(I,KCLD(I)) = CSMID(I,LL2)
                        ITYP(I,KCLD(I)) = 1
                        KBTM(I,KCLD(I)) = LL2
!                    
                        IF (BITC) THEN
                            CAMT(I,KCLD(I)) = CCMID(I,LL2)
                            ITYP(I,KCLD(I)) = 2
                        END IF
                    ELSE
                        IF (BITC) THEN
                            IF (BITCP1) THEN
                                CAMT(I,KCLD(I)) = AMAX1(CAMT(I, KCLD(I)), CCMID(I,LL2))
                            ELSE
                                KCLD(I)           = KCLD(I) + 1
                                CAMT(I,KCLD(I))   = CCMID(I,LL2)
                                ITYP(I,KCLD(I))   = 2
                                KTOP(I,KCLD(I)-1) = LL2 + 1
                                KBTM(I,KCLD(I))   = LL2
                            END IF
                        ELSE
                            IF (BITCP1) THEN
                                KCLD(I)           = KCLD(I) + 1
                                CAMT(I,KCLD(I))   = CSMID(I,LL2)
                                ITYP(I,KCLD(I))   = 1
                                KTOP(I,KCLD(I)-1) = LL2 + 1
                                KBTM(I,KCLD(I))   = LL2
                            ELSE
                                CAMT(I,KCLD(I)) = AMAX1(CAMT(I, KCLD(I)), CSMID(I,LL2))
                            END IF
                        END IF
                    END IF
!
                ELSE
!
                    IF (BITCP1 .OR. BITSP1) THEN
                        KCLD(I)           = KCLD(I) + 1
                        KTOP(I,KCLD(I)-1) = LL2 + 1
                        ITYP(I,KCLD(I)  ) = 0
                        CAMT(I,KCLD(I)  ) = 0.0
                    END IF
!
                END IF
!
        540 END DO
!-----------------------------------------------------------------------------------
! THE REAL NUMBER OF CLOUD LAYERS IS (THE FIRST IS THE GROUNG; THE LAST IS THE SKY):
!-----------------------------------------------------------------------------------
            NCLDS(I) =  KCLD(I) - 2
            NCLD     = NCLDS(I)
!----------------------------------------- 
! NOW CALCULATE CLOUD RADIATIVE PROPERTIES
!----------------------------------------- 
            IF (NCLD >= 1) THEN
!-------------------------------------------------------------- 
! NOTE: THE FOLLOWING CALCULATIONS, THE UNIT FOR PRESSURE IS MB 
!-------------------------------------------------------------- 
                DO 580 NC=2,NCLD+1
!                
                    TAUC(I) = 0.0
                    QSUM    = 0.0
                    NKTP    = LP1
                    NBTM    = 0
                    BITX    = CAMT(I,NC) > 0.1
                    NKTP    = MIN(NKTP, KTOP(I,NC))
                    NBTM    = MAX(NBTM, KBTM(I,NC))
!                
                    DO 560 LL2=NKTP,NBTM
                        IF (LL2 >= KTOP(I,NC) .AND. LL2 <= KBTM(I,NC) .AND. BITX) THEN
                            PRS1 = PINT(I,LL2)   * 0.01
                            PRS2 = PINT(I,LL2+1) * 0.01
                            DELP = PRS2 - PRS1
                            TCLD = TMID(I,LL2) - 273.16
                            QSUM = QSUM  + QMID(I,LL2) * DELP                                     &
    &                            * (PRS1 + PRS2) / (120.1612 * SQRT(TMID(I,LL2)))
!-------------------------------------------------------------- 
! FOR CONVECTIVE CLOUD OR STARTIFORM CLOUD WITH TOP ABOVE 500MB
!-------------------------------------------------------------- 
                            IF (ITYP(I,NC) == 2 .OR. PINT(I,KTOP(I,NC)) <= PTOPC(3)) THEN
                                IF (TCLD <= -10.0) THEN
                                    TAUC(I) = TAUC(I) + DELP                                      &
    &                                       * AMAX1(0.1E-3, 2.0E-6 * (TCLD + 82.5) ** 2)
                                ELSE
                                    TAUC(I) = TAUC(I) + DELP * AMIN1(0.08, 6.949E-3 * TCLD + 0.1)
                                END IF
                            ELSE
!----------------------------------  
! FOR LOW AND MID STRATIFORM CLOUDS
!----------------------------------
                                IF (TCLD <= -20.0) THEN
                                    TAUC(I) = TAUC(I) + DELP                                      &
    &                                       * AMAX1(0.1E-3, 2.56E-5 * (TCLD + 82.5) ** 2)
                                ELSE
                                    TAUC(I) = TAUC(I) + DELP * 0.1
                                END IF
                            END IF
                        END IF
!
                560 END DO
!                
                    IF (BITX) EMIS(I,NC) = 1.0 - EXP(-0.75 * TAUC(I))
!
                    IF (QSUM >= EPSQ1) THEN
                        DO 570 NBAND=1,NB
                            IF (BITX) THEN
                                PROD = ABCFF(NBAND) * QSUM
                                DDX  = TAUC(I) / (TAUC(I) + PROD)
                                EEX  = 1.0 - DDX
                                IF (ABS(EEX) >= 1.E-8) THEN
                                    DD = DDX
                                    EE = EEX
                                    FF = 1.0 - DD * 0.85
                                    AA = MIN(50.0,SQRT(3.0 * EE * FF) * TAUC(I))
                                    AA = EXP(-AA)
                                    BB = FF / EE
                                    GG = SQRT(BB)
                                    DD = (GG + 1.0) * (GG + 1.0) - (GG - 1.0)                     &
    &                                  * (GG - 1.0) * AA * AA
                                    RRCL(I,NBAND,NC) =   MAX(0.1E-5, (BB-1.0) * (1.0-AA*AA)/DD)
                                    TTCL(I,NBAND,NC) = AMAX1(0.1E-5, 4.0 * GG * AA/DD)
                                END IF
                            END IF
                    570 END DO
                    END IF
!
            580 END DO
!            
            END IF
!        
    600 END DO
!--------------------------- 
! COMPUTE OZONE AT MIDLAYERS 
!--------------------------- 
!
!-------------------------------------------------------------------------------------------------- 
! MODIFY PRESSURES SO THAT THE ENTIRE COLUMN OF OZONE (TO 0 MB) IS INCLUDED IN THE MODEL COLUMN 
! EVEN WHEN PT > 0 MB
!-------------------------------------------------------------------------------------------------- 
        DO K=1,LM
            DO I=MYIS,MYIE
                DENOM     = 1. / (PINT(I,LP1) - PINT(I,1))
                FCTRA     =              PINT(I,LP1) * DENOM
                FCTRB     = -PINT(I,1) * PINT(I,LP1) * DENOM
                POZN(I,K) =  PMID(I,K) * FCTRA + FCTRB
            END DO
        END DO
!    
        CALL OZON2D(LM, POZN, XLAT, RSIN1, RCOS1, RCOS2, OZN)
!----------------------------------------------------------  
! NOW THE VARIABLES REQUIRED BY RADFS HAVE BEEN CALCULATED.
!----------------------------------------------------------
!
!------------------------------- 
! CALL THE GFDL RADIATION DRIVER
!------------------------------- 
        CALL RADFS (PSFC , PMID , PINT , QMID , TMID , OZN   , TSKN  , SLMSK , ALBDO, XLAT  ,     &
    &               CAMT , ITYP , KTOP , KBTM , NCLDS, EMIS  , RRCL  , TTCL  , COSZ , TAUDAR,     &
    &               1    , 1    , 0    , ETA  , AETA , ITIMSW, ITIMLW, JD    , RAD1 , HOUR  ,     &
    &               TENDS, TENDL, FLWUP, FSWUP, FSWDN, FSWDNS, FSWUPS, FLWDNS, FLWUPS)
!
        DO 650 I=MYIS,MYIE
            PDSLIJ      = PDSL  (I,J)
            PMOD        = CUPPT (I,J) * 24.0 * 1000.0 / CLSTP
            CFRACL(I,J) = CLDCFR(I,1)
            CFRACM(I,J) = CLDCFR(I,2)
            CFRACH(I,J) = CLDCFR(I,3)
!--------------------------------------------------------------------------------------------------        
! ARRAYS ACFRST AND ACFRCV ACCUMULATE AVERAGE STRATIFORM AND CONVECTIVE CLOUD FRACTIONS, 
! RESPECTIVELY.  
! THIS INFORMATION IS PASSED TO THE POST PROCESSOR VIA COMMON BLOCK ACMCLD.
!--------------------------------------------------------------------------------------------------         
            CFRAVG = AMAX1(CFRACL(I,J),AMAX1(CFRACM(I,J),CFRACH(I,J)))
!---------------------------------------------------------
! PREVENT DOUBLE-COUNTING STATISTICS WHEN RESTARTING MODEL
!---------------------------------------------------------        
            IF (NTSD == 1 .OR. NTSD > NSTART+1) THEN
                IF (CNCLD) THEN
                    IF (PMOD <= PPT(1)) THEN
                        ACFRST(I,J) = ACFRST(I,J) + CFRAVG
                        NCFRST(I,J) = NCFRST(I,J) + 1
                    ELSE
                        ACFRCV(I,J) = ACFRCV(I,J) + CFRAVG
                        NCFRCV(I,J) = NCFRCV(I,J) + 1
                    END IF
                ELSE
                    ACFRST(I,J) = ACFRST(I,J) + CFRAVG
                    NCFRST(I,J) = NCFRST(I,J) + 1
                END IF
            END IF
    650 END DO
!--------------------------------------------------------------------------------------------------
! COLLECT ATMOSPHERIC TEMPERATURE TENDENCIES DUE TO RADIATION.
! ALSO COLLECT THE TOTAL SW AND INCOMING LW RADIATION (W/M**2) AND CONVERT TO FORM NEEDED FOR 
! PREDICTION OF THS IN SURFCE.
!--------------------------------------------------------------------------------------------------
        DO 660 I=MYIS,MYIE
            DO K=1,LM
                LL2 = LVL(I,J) + K
                IF (SHORT) RSWTT(I,J,K) = TENDS(I,LL2)
                IF (LONG)  RLWTT(I,J,K) = TENDL(I,LL2)
                IF (LL2 == LM) GOTO 660
            END DO
    660 END DO
!---------------------------------------------------------
! SUM THE LW INCOMING AND SW RADIATION (W/M**2) FOR RADIN.
!---------------------------------------------------------
        DO 675 I=MYIS,MYIE
            IF (LONG) THEN
                SIGT4(I,J) = STBOL * TMID(I,LM) * TMID(I,LM) * TMID(I,LM) * TMID(I,LM)
            END IF
!--------------------------------------------------------------------------------------------------        
! ACCUMULATE VARIOUS LW AND SW RADIATIVE FLUXES FOR POST PROCESSOR. PASSED VIA COMMON ACMRDL AND
! ACMRDS.
!--------------------------------------------------------------------------------------------------        
            IF (LONG) THEN
                RLWIN (I,J) = FLWDNS(I)
                RLWOUT(I,J) = FLWUPS(I)
                RLWTOA(I,J) = FLWUP (I)
            END IF
!
            IF (SHORT) THEN
                RSWIN (I,J) = FSWDNS(I)
                RSWOUT(I,J) = FSWUPS(I)
                RSWTOA(I,J) = FSWUP (I)
            END IF
!
    675 END DO
!--------------------------------- 
! THIS ROW IS FINISHED. GO TO NEXT
!---------------------------------
700 END DO
!------------------------------------------------
! CALLS TO RADIATION THIS TIME STEP ARE COMPLETE.
!------------------------------------------------
!
!----------------------------------------------- 
! HORIZONTAL SMOOTHING OF TEMPERATURE TENDENCIES
!----------------------------------------------- 
    IF (SHORT) THEN
        DO 800 K=1,LM
            CALL ZERO2(TL )
            CALL ZERO2(FNE)
            CALL ZERO2(FSE)
!        
            IF (KSMUD >= 1) THEN
                DO 750 KS=1,KSMUD
!                
                    DO J=MYJS,MYJE
                        DO I=MYIS,MYIE
                            TL(I,J) = RSWTT(I,J,K) * HTM(I,J,K)
                        END DO
                    END DO
!
                    DO J=MYJS,MYJE
                        DO I=MYIS,MYIE
                            FNE(I,J) = (TL(I+IHE(J),J+1) - TL(I,J)) * HTM(I       ,J  ,K)         &
    &                                *                                HTM(I+IHE(J),J+1,K)
                        END DO
                    END DO
!                
                    DO J=MYJS1,MYJE
                        DO I=MYIS,MYIE
                            FSE(I,J) = (TL(I+IHE(J),J-1) - TL(I,J)) * HTM(I+IHE(J),J-1,K)         &
    &                                *                                HTM(I       ,J  ,K)
                        END DO
                    END DO
!                
                    DO J=MYJS2,MYJE2
                        DO I=MYIS,MYIE
                            TL(I,J) = (FNE(I,J)  - FNE(I+IHW(J),J-1)                              &
    &                               +  FSE(I,J)  - FSE(I+IHW(J),J+1))                             &
    &                               * HBM2(I,J)  * 0.125 + TL(I,J)
                        END DO
                    END DO
!                
                    DO J=MYJS,MYJE
                        DO I=MYIS,MYIE
                            RSWTT(I,J,K) = TL(I,J) 
                        END DO
                    END DO
!                
            750 END DO
            END IF
!        
    800 END DO
    END IF
!
    IF (LONG) THEN
!    
        DO 900 K=1,LM
            CALL ZERO2(TL )
            CALL ZERO2(FNE)
            CALL ZERO2(FSE)
!
            IF (KSMUD >= 1) THEN
                DO 850 KS=1,KSMUD
!                
                    DO J=MYJS,MYJE
                        DO I=MYIS,MYIE
                            TL(I,J) = RLWTT(I,J,K) * HTM(I,J,K)
                        END DO
                    END DO
!                
                    DO J=MYJS,MYJE1
                        DO I=MYIS,MYIE
                            FNE(I,J) = (TL(I+IHE(J),J+1)   -  TL(I       ,J  ))                   &
    &                                * HTM(I       ,J  ,K) * HTM(I+IHE(J),J+1,K)
                        END DO
                    END DO
!                
                    DO J=MYJS1,MYJE
                        DO I=MYIS,MYIE
                            FSE(I,J) = (TL(I+IHE(J),J-1)   -  TL(I,J))                            &
    &                                * HTM(I+IHE(J),J-1,K) * HTM(I,J,K)
                        END DO
                    END DO
!                
                    DO J=MYJS2,MYJE2
                        DO I=MYIS,MYIE
                            TL(I,J) = (FNE(I,J) - FNE(I+IHW(J),J-1)                               &
    &                               +  FSE(I,J) - FSE(I+IHW(J),J+1))                              &
    &                               * HBM2(I,J) * 0.125 + TL(I,J)
                        END DO
                    END DO
!                
                    DO J=MYJS,MYJE
                        DO I=MYIS,MYIE
                            RLWTT(I,J,K) = TL(I,J)
                        END DO
                    END DO
!                
            850 END DO
            END IF
!
    900 END DO
    END IF
!
    RETURN
!
    END SUBROUTINE RADTN

    MODULE PARMETA
!>--------------------------------------------------------------------------------------------------
!> MODULE PARMETA
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : BOCO
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLO89
!>              CLTEND
!>              COLLECT
!>              CONRAD
!>              CUCNVC
!>              DDAMP
!>              DIFCOF
!>              DIGFLT
!>              DIST
!>              DIVHOA
!>              DIVHOAST
!>              DSTRB
!>              E1E290
!>              E290
!>              E2SPEC
!>              E3V88
!>              EBU
!>              EPS
!>              FILT25
!>              FST88
!>              GFDLRD
!>              GOSSIP
!>              GRADFS
!>              GSCOND
!>              GSMCOLUMN
!>              GSMCONST
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              IDSTRB
!>              INIT
!>              INITS
!>              LOC2GLB
!>              LWR88
!>              MIXLEN
!>              MODULE_ACMCLD
!>              MODULE_ACMCLH
!>              MODULE_ACMPRE
!>              MODULE_ACMRDL
!>              MODULE_ACMRDS
!>              MODULE_ACMSFC
!>              MODULE_BOCO
!>              MODULE_C_FRACN
!>              MODULE_CLDWTR
!>              MODULE_CNVCLD
!>              MODULE_CONTIN
!>              MODULE_C_TADJ
!>              MODULE_CTLBLK
!>              MODULE_DYNAM0
!>              MODULE_EXCHM
!>              MODULE_GLB_TABLE
!>              MODULE_INDX
!>              MODULE_LOOPS
!>              MODULE_MAPOT2
!>              MODULE_MAPPINGS
!>              MODULE_MASKS
!>              MODULE_MPPCOM
!>              MODULE_NHYDRO
!>              MODULE_PHYS0
!>              MODULE_PHYS2
!>              MODULE_PPTASM
!>              MODULE_PRFHLD
!>              MODULE_PVRBLS
!>              MODULE_RD1TIM
!>              MODULE_RDPARM
!>              MODULE_SAVMEM
!>              MODULE_SLOPES
!>              MODULE_SOIL
!>              MODULE_TEMPCOM
!>              MODULE_TEMPV
!>              MODULE_TOPO
!>              MODULE_VRBLS
!>              MODULE_Z0EFFT
!>              MPI_FIRST
!>              MPPINIT
!>              NEWFLT
!>              O3INT
!>              OZON2D
!>              PDNEW
!>              PDTEDT
!>              PDTE
!>              PGCOR
!>              PRECPD
!>              PRODQ2
!>              QUILT
!>              RADFS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SFCDIF
!>              SFCDIF_BHS
!>              SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!>              SPA88
!>              SURFCE
!>              SWR93
!>              TABLE
!>              TTBLEX
!>              TURBL
!>              TWR
!>              UPDATE
!>              VADZ
!>              VDIFH
!>              VDIFQ
!>              VDIFV
!>              VTADV
!>              VTADVF
!>              VWR
!>              ZENITH
!>              ZERO2
!>              ZERO3
!>              ZERO3_T
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!------------------------------------------------------- 
! SET PRIMARY GRID DIMENSIONS AND PRESSURE OUTPUT LEVELS
!------------------------------------------------------- 
    INTEGER(KIND=I4KIND), PARAMETER :: IM    = 79
    INTEGER(KIND=I4KIND), PARAMETER :: JM    = 129
    INTEGER(KIND=I4KIND), PARAMETER :: LM    = 38
    INTEGER(KIND=I4KIND), PARAMETER :: LSM   = 22
!---------------------------------------------------------  
! SET THE NUMBER OF PEs IN THE I-DIRECTION AND J-DIRECTION
!--------------------------------------------------------- 
    INTEGER(KIND=I4KIND), PARAMETER :: INPES =   2
    INTEGER(KIND=I4KIND), PARAMETER :: JNPES =   3
!
    INTEGER(KIND=I4KIND), PARAMETER :: IGSTL =  -5
    INTEGER(KIND=I4KIND), PARAMETER :: IGSTR =   5
!
    INTEGER(KIND=I4KIND), PARAMETER :: JGSTL =  -5
    INTEGER(KIND=I4KIND), PARAMETER :: JGSTR =   5
!
    INTEGER(KIND=I4KIND), PARAMETER :: ITAIL = IM - (INPES * (IM / INPES))
    INTEGER(KIND=I4KIND), PARAMETER :: JTAIL = JM - (JNPES * (JM / JNPES))
!
    INTEGER(KIND=I4KIND), PARAMETER :: IDIM1 = IGSTL
    INTEGER(KIND=I4KIND), PARAMETER :: IDIM2 = IM / INPES + IGSTR + 1
!
    INTEGER(KIND=I4KIND), PARAMETER :: JDIM1 = JGSTL
    INTEGER(KIND=I4KIND), PARAMETER :: JDIM2 = JM / JNPES + JGSTR + 1
!
    END MODULE PARMETA

    FUNCTION TIMEF()
!>--------------------------------------------------------------------------------------------------
!> FUNCTION TIMEF
!>
!> FUNCTION: TIMEF - DESIGNED TO DUPLICATE TIMEF
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT:
!> DESIGNED TO DUPLICATE TIMEF
!>
!> PROGRAM HISTORY LOG:
!> 99-12-??  M. PYLE     - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : CHKOUT
!>              EBU
!>              INIT
!>              INITS
!>              PDTEDT
!>              QUILT
!>              TURBL
!>-------------------------------------------------------------------------------------------------- 
    USE F77KINDS
!
    REAL   (KIND=R4KIND), DIMENSION(2)                                                          ::&
    & ET
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!
    TIMEF = ETIME(ET)
    TIMEF = TIMEF * 1.E3
!
    END FUNCTION TIMEF

    SUBROUTINE READ_SST12M
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_SST
!>
!> SUBROUTINE: READ_SST- ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLH
!>              ACMCLD
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
    USE ACMCLH
    USE ACMCLD
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    INCLUDE "mpif.h"
!
!------------------
! DECLARE VARIABLES
!-------------------
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    REAL   (KIND=R4KIND), DIMENSION(:, :, :), ALLOCATABLE                                       ::&
    & SST_UP
!
#ifdef DP_REAL
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & NSST_UP  , ISST_UP , N     
#endif

    NSST_UP = 19
    ISST_UP = 90

!-------------------------------------------------
! ADAPTADO PARA A LEITURA DO ARQUIVO DE SST DIARIA 
!-------------------------------------------------  
    OPEN(1, FORM='UNFORMATTED', ACCESS='SEQUENTIAL',STATUS='OLD') 
!---------------
! DISTRIBUTE SST_UP
!---------------
    DO N=1,NSST_UP
      IF (MYPE == 0) THEN
        write(6,*)N,NSST_UP
        READ(ISST_UP) TEMP1
      END IF
      CALL DSTRB(TEMP1, SST_UP, 1, 1, N)
    END DO
!
    OPEN(8, FORM='FORMATTED', FILE='TEMPO_INIT_SST.txt')
!
    READ(8,*) INITSST
!------------------------------
! END OF SUBROUTINE READ_SST    
!------------------------------
    RETURN
!
    END SUBROUTINE READ_SST

    MODULE F77KINDS
!>--------------------------------------------------------------------------------------------------
!> MODULE F77KINDS
!>
!> USE MODULES: ----- 
!>        
!> DRIVER: ALL SUBROUTINES AND MODULES
!>--------------------------------------------------------------------------------------------------
    IMPLICIT NONE
!
    SAVE
!
    INTEGER, PARAMETER :: I1KIND  =  1  ! INTEGER*1	  
    INTEGER, PARAMETER :: I2KIND  =  2  ! INTEGER*2
    INTEGER, PARAMETER :: I4KIND  =  4  ! INTEGER*4
    INTEGER, PARAMETER :: I8KIND  =  8  ! INTEGER*8
!
    INTEGER, PARAMETER :: L1KIND  =  1  ! LOGICAl*1
    INTEGER, PARAMETER :: L4KIND  =  4  ! LOGICAL*4
    INTEGER, PARAMETER :: L8KIND  =  8  ! LOGICAL*8
!
    INTEGER, PARAMETER :: R4KIND  =  4  ! REAL*4
    INTEGER, PARAMETER :: R8KIND  =  8  ! REAL*8
!
    INTEGER, PARAMETER :: CX8KIND =  8  ! COMPLEX*8
    INTEGER, PARAMETER :: CX16KIND=  16 ! COMPLEX*16
!
  END MODULE F77KINDS

    SUBROUTINE GSCOND
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GSCOND
!> 
!> SUBPROGRAM: GSCOND - GRID SCALE CONDENSATION AND EVAPORATION
!> PROGRAMMER: ZHAO
!> ORG: W/NP22
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> GSCOND COMPUTES THE GRID SCALE EVAPORATION AND CONDENSATION
!>
!> PROGRAM HISTORY LOG:
!> 94-??-??  ZHAO       - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-11-02  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: ACMCLH
!>              CLDWTR
!>              CTLBLK 
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              TEMPCOM
!>              TEMPV
!>              TOPO
!>              VRBLS
!> 
!> DRIVER     : EBU
!>              NEWFLT 
!> 
!> CALLS      : SGETMO        
!>--------------------------------------------------------------------------------------------------
    USE ACMCLH
    USE CLDWTR
    USE CTLBLK
    USE DYNAM    , ONLY: AETA, PT
    USE F77KINDS
    USE GLB_TABLE
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE TEMPCOM
    USE TEMPV
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: A1    =  610.78
    REAL   (KIND=R4KIND), PARAMETER :: A2    =   17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3    =  273.16 
    REAL   (KIND=R4KIND), PARAMETER :: A4    =   35.86
    REAL   (KIND=R4KIND), PARAMETER :: PQ0   =  379.90516
    REAL   (KIND=R4KIND), PARAMETER :: TRESH =     .95    
    REAL   (KIND=R4KIND), PARAMETER :: CP    = 1004.6 
    REAL   (KIND=R4KIND), PARAMETER :: ELWV  =    2.50E6
    REAL   (KIND=R4KIND), PARAMETER :: ELIV  =    2.834E6
    REAL   (KIND=R4KIND), PARAMETER :: ROW   =    1.E3
    REAL   (KIND=R4KIND), PARAMETER :: G     =    9.8 
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ  =    2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: DLDT  = 2274.0
    REAL   (KIND=R4KIND), PARAMETER :: TM10  =  263.16
    REAL   (KIND=R4KIND), PARAMETER :: R     =  287.04
    REAL   (KIND=R4KIND), PARAMETER :: CPR   = CP * R
    REAL   (KIND=R4KIND), PARAMETER :: RCPR  = 1. / CPR
!
    REAL   (KIND=R4KIND), PARAMETER :: ARCP  = A2  * (A3-A4) / CP
    REAL   (KIND=R4KIND), PARAMETER :: RCP   = 1.  / CP
    REAL   (KIND=R4KIND), PARAMETER :: PQ0C  = PQ0 * TRESH
    REAL   (KIND=R4KIND), PARAMETER :: RROG  = 1.  / (ROW*G)
!
    INTEGER(KIND=R4KIND), PARAMETER :: IMJM  = IM  * JM - JM / 2
    INTEGER(KIND=R4KIND), PARAMETER :: LTOP  = 1
    INTEGER(KIND=R4KIND), PARAMETER :: LBOT  = LM
    INTEGER(KIND=R4KIND), PARAMETER :: LDA   = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & NOZ
!
    INTEGER(KIND=I4KIND), DIMENSION(LM)                                                         ::&
    & IW 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PDSL
!
    REAL   (KIND=R4KIND), DIMENSION(LM, IDIM1:IDIM2, JDIM1:JDIM2)                               ::&
    & T_T     , T0_T    , Q_T     , Q0_T    , TRAIN_T , CWM_T   , HTM_T
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & MR      , KE      , INIT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTPH    , RDTPH   , TWODT   , RTWODT  , C0      , C1      , C2      , US      , EPS     ,   &
    & CCLIMIT , UTIM    , HBM2IJ  , U00IJ   , P0IJ    , RESIJ   , PDSLIJ  , TKL     , QKL     ,   &
    & CWMKL   , COND    , CLIMIT  , E0      , HH      , TMT0    , TMT15   , AI      , BI      ,   &
    & QW      , QI      , QINT    , U00KL   , FI      , THH     , PP      , PP0     , AT      ,   &
    & AQ      , AP      , FIW     , ELV     , QC      , RQKL    , CCR     , RQKLL   , CCRKL   ,   &
    & EC      , US00    , CCRKL1  , AA      , AB      , AC      , AD      , AE      , AF      ,   &
    & AG      , CONDK   , QTEMP   , RQTMP   , CONE0
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , LMHIJ   , IWKL    , LML        
#include "sp.h"
!------------------------- 
! PREPARATORY CALCULATIONS 
!------------------------- 
    DTPH    = NPHS * DT
    RDTPH   =   1. / DTPH
    TWODT   = DTPH
    RTWODT  =   1. / TWODT
    C0      =   1.5E-4
    C1      = 300.
    C2      =   0.5
    MR      =   3.0E-4
    KE      =   2.0E-5
    US      =   1.
    EPS     =   0.622
    CCLIMIT =   1.0E-3
    CLIMIT  =   1.0E-20
!-----------------------------------------------
! PADDING SPECIFIC HUMIDITY AND CWM IF TOO SMALL 
!-----------------------------------------------
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO 30 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                IF (Q(I,J,K) < EPSQ)       Q(I,J,K) =   EPSQ*HTM(I,J,K)
                IF (CWM(I,J,K) < CLIMIT) CWM(I,J,K) = CLIMIT*HTM(I,J,K)
            END DO
        END DO
 30 END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            PDSL(I,J) = RES(I,J) * PD(I,J)
        END DO
    END DO
!
    IW(1) = 0
    UTIM  = 1.
!------------------------------------------------
! BEGINNING OF GRID-SCALE CONDENSATION/EVAP. LOOP 
!------------------------------------------------
!
!----------------- 
! TRANSPOSE ARRAYS
!----------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(T    , LDA, LDA, LM, T_T     , LM)
    CALL SGETMO(Q    , LDA, LDA, LM, Q_T     , LM)
    CALL SGETMO(HTM  , LDA, LDA, LM, HTM_T   , LM)
    CALL SGETMO(CWM  , LDA, LDA, LM, CWM_T   , LM)
!
!$omp section
!
    CALL SGETMO(T0   , LDA, LDA, LM, T0_T    , LM)
    CALL SGETMO(Q0   , LDA, LDA, LM, Q0_T    , LM)
    CALL SGETMO(TRAIN, LDA, LDA, LM, TRAIN_T , LM)
!
!$omp end parallel sections
!
!---------------- 
! QW, QI AND QINT 
!---------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (AA       , AB      , AC      , AD      , AE      , AF      , AG      , AI      ,   &
!$omp          AP       , AQ      , AT      , BI      , CCR     , CCRKL   , CCRKL1  , COND    ,   &
!$omp          CONDK    , CONE0   , CWMKL   , E0      , EC      , ELV     , FI      , FIW     ,   &
!$omp          HBM2IJ   , HH      , IWKL    , LMHIJ   , LML     , P0IJ    , PDSLIJ  , PP      ,   &
!$omp          PP0      , QC      , QI      , QINT    , QKL     , QTEMP   , QW      , RESIJ   ,   &
!$omp          RQKL     , RQKLL   , RQTMP   , THH     , TKL     , TMT0    , TMT15   , U00IJ   ,   &
!$omp          U00KL    , US00    )
!$omp firstprivate (IW)
!
    IF (MYPE == 1) THEN
        PRINT*,'MYIS, MYIE, MYJS2, MYJE2=', MYIS, MYIE, MYJS2, MYJE2
    END IF
!
    DO 100 J=MYJS2,MYJE2
        DO 100 I=MYIS,MYIE        
            LMHIJ  =  LMH(I,J)
            HBM2IJ = HBM2(I,J)
            U00IJ  =  U00(I,J)
            P0IJ   =   P0(I,J)
            RESIJ  =  RES(I,J)
            PDSLIJ = PDSL(I,J)
!
            DO 90 K=2,LM            
                TKL   =   T_T(K,I,J)
                QKL   =   Q_T(K,I,J)
                CWMKL = CWM_T(K,I,J)
!            
                COND  = 0.
                E0    = 0.
                LML   = LM-LMHIJ
                HH    = HTM_T(K,I,J)     * HBM2IJ
                TMT0  = (TKL-273.16)     * HH
                TMT15 = AMIN1(TMT0,-15.) * HH
                AI    = 0.008855
                BI    = 1.
!            
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!            
                QW   = HH * PQ0 / (PDSLIJ * AETA(K) + PT) * EXP(HH*A2 * (T(I,J,K) - A3)           &
    &                /                                                  (T(I,J,K) - A4))
!
                QI   = QW * (BI + AI * AMIN1(TMT0,0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15 + 15.))
!
                IF (TMT0 <= -40.) QINT = QI
!----------------------- 
! ICE-WATER ID NUMBER IW 
!----------------------- 
                IF (TMT0 < -15.) THEN
                    U00KL = U00IJ    + UL(K+LML) * (0.95-U00IJ) * UTIM
                    FI    = Q(I,J,K) - U00KL     * QI
                    IF (FI > 0. .OR. CWMKL > CLIMIT) THEN
                        IW(K) = 1
                    ELSE
                        IW(K) = 0
                    END IF
                END IF
!            
                IF (TMT0 >= 0.) THEN
                    IW(K) = 0
                END IF
!            
                IF (TMT0 < 0.0 .AND. TMT0 >= -15.) THEN
                    IW(K) = 0
                    IF (IW(K-1) == 1 .AND. CWMKL > CLIMIT) IW(K) = 1
                END IF
!-------------------------------------------------------
! CONDENSATION AND EVAPORATION OF CLOUD AT, AQ AND DP/DT 
!-------------------------------------------------------
                THH   = TWODT  * HH
                PP    = PDSLIJ *            AETA(K) + PT
                PP0   = P0IJ   * RESIJ    * AETA(K) + PT
                AT    = (TKL-T0_T(K,I,J)) * RTWODT
                AQ    = (QKL-Q0_T(K,I,J)) * RTWODT
                AP    = (PP-PP0)          * RTWODT
                IWKL  = IW(K)
                U00KL = U00IJ + UL(K+LML) * (0.95-U00IJ) * UTIM
!-------------------------------- 
! THE SATUATION SPECIFIC HUMIDITY 
!-------------------------------- 
                FIW = FLOAT(IWKL)
                ELV = (1.-FIW) * ELWV + FIW * ELIV
                QC  = (1.-FIW) * QINT + FIW * QI
!---------------------- 
! THE RELATIVE HUMIDITY 
!---------------------- 
                IF (QC <= 0.) THEN
                    RQKL = 0.
                ELSE
                    RQKL = QKL / QC
                END IF
!---------------------- 
! CLOUD COVER RATIO CCR 
!---------------------- 
                IF (RQKL <= U00KL) THEN
                    CCR   = 0.
                ELSE
                    RQKLL = AMIN1(US,RQKL)
                    CCR   = 1. -SQRT((US-RQKLL) / (US-U00KL))
                END IF
!----------------------------------------------------
! CORRECT CCR IF IT IS TOO SMALL IN LARGE CWM REGIONS 
!---------------------------------------------------- 
                IF (CCR >= 0.01 .AND. CCR <= 0.2 .AND. CWMKL >= 0.2E-3) THEN
                    CCR   = AMIN1(1.,CWMKL*1.E3)
                END IF
!            
                CCRKL = CCR
!-------------------------------------------------------
! GIVE UP THIS POINT  IF NO CLOUD NOR CONDENSATION EXIST 
!-------------------------------------------------------
                IF (CCRKL <= CCLIMIT .AND. CWMKL <= CLIMIT) GOTO 90
!--------------------------- 
! EVAPORATION OF CLOUD WATER 
!---------------------------
                EC = 0.
!
                IF (CCRKL <= CCLIMIT .AND. CWMKL > CLIMIT) THEN
                    EC = QC * (U00KL-RQKL) * RTWODT
                    E0 = AMAX1(EC,0.0)
                    E0 = AMIN1(CWMKL*RTWODT,E0) * HH
                    E0 = AMAX1(0.,E0)
                END IF
!---------------------- 
! CONDENSATION OF CLOUD 
!---------------------- 
                IF (CCRKL <= 0.20 .OR. QC <= EPSQ) THEN
                    COND = 0.
                    GOTO 80
                END IF
!------------------------------------------------------
! THE EQS. FOR COND. HAS BEEN REORGANIZED TO REDUCE CPU 
!------------------------------------------------------
                US00   = US - U00KL
                CCRKL1 = 1. - CCRKL
!
                AA     = EPS     * ELV    * PP    * QKL
                AB     = CCRKL   * CCRKL1 * QC    * US00
                AC     = AB      + 0.5    * CWMKL
                AD     = AB      * CCRKL1
                AE     = CPR     * TKL    * TKL
                AF     = AE      * PP
                AG     = AA      * ELV
                AI     = CP      * AA
!
                COND   = (AC - AD) * (AF * AQ - AI * AT + AE * QKL * AP) / (AC * (AF + AG))
!---------------------------------------------- 
! CHECK AND CORRECT IF OVER CONDENSATION OCCURS 
!----------------------------------------------
                CONDK = (QKL - U00KL * QC * 0.1) * RTWODT
!
                IF (COND > CONDK) THEN
                    COND = CONDK
                END IF
!------------------------------------------------
! CHECK AND CORRECT IF SUPERSATUATION IS TOO HIGH 
!------------------------------------------------ 
                QTEMP = QKL - AMAX1(0.,(COND-E0)) * THH
                RQTMP = QTEMP / QC
!
                IF (RQTMP >= 1.10) THEN
                    COND = (QKL-1.10*QC) * RTWODT
                END IF
!
                IF (COND < 0.) THEN
                    COND = 0.
                END IF
!----------------------- 
! UPDATE OF T, Q AND CWM 
!----------------------- 
             80 CONTINUE
!
                IF (MYPE == 1 .AND. I == 25 .AND. J == 31 .AND. K == 31) THEN
                    PRINT*,'COND, E0=', COND, E0
                END IF
!
                CONE0 = COND - E0
!
                CWM_T(K,I,J) = CONE0 * THH + CWMKL         
!--------------------------------------------------------------------------------------------------
! ACCUMULATE LATENT HEATING DUE TO GRID-SCALE PRECIP/EVAP. SCALE BY THE RECIPROCAL OF THE PERIOD AT
! WHICH THIS ROUTINE IS CALLED.
! THIS PERIOD IS THE PHYSICS TIMESTEP.
!--------------------------------------------------------------------------------------------------
                    T_T(K,I,J) =  ELV   * RCP * CONE0 * THH + TKL
                TRAIN_T(K,I,J) =  ELV   * RCP * CONE0 * THH * RDTPH + TRAIN_T(K,I,J)
                    Q_T(K,I,J) = -CONE0 * THH + QKL
!
                IF (CWM_T(K,I,J) <= 0.) CWM_T(K,I,J) = 0.
         90 END DO
100 END DO
!------------------------------ 
! SAVE T, Q AND P FOR THIS STEP 
!------------------------------ 
!
!--------------------------------- 
! TRANSPOSE BACK THE NEEDED ARRAYS
!--------------------------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(T_T    , LM, LM, LDA, T    , LDA)
    CALL SGETMO(Q_T    , LM, LM, LDA, Q    , LDA)
!
!$omp section
!
    CALL SGETMO(TRAIN_T, LM, LM, LDA, TRAIN, LDA)
    CALL SGETMO(CWM_T  , LM, LM, LDA, CWM  , LDA)
!
!$omp end parallel sections
!
!$omp parallel do
!
    DO 125 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                Q0(I,J,K) = Q(I,J,K)
                T0(I,J,K) = T(I,J,K)
            END DO
        END DO
125 END DO
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            P0(I,J) = PD(I,J)
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE GSCOND

    MODULE SOIL
!>--------------------------------------------------------------------------------------------------
!> MODULE SOIL
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>              PARMSOIL
!>
!> DRIVER     : CHKOUT
!>              EXIT
!>              GOSSIP
!>              INIT
!>              INITS
!>              RADTN
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SURFCE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IDIM1, IDIM2, JDIM1, JDIM2
    USE PARMSOIL, ONLY : NSOIL 
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & IVGTYP  , ISLTYP  ,                                                                         &
    & ISLOPE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & SOILTB  , SFCEXC  ,                                                                         &
    & SMSTAV  , SMSTOT  ,                                                                         &
    & GRNFLX  , PCTSNO  ,                                                                         &
    & VEGFRC  , CMC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, NSOIL)                            ::&
    & SMC     ,                                                                                   &
    & STC     ,                                                                                   &
    & SH2O
!
    REAL   (KIND=R4KIND), DIMENSION(NSOIL)                                                      ::&
    & SLDPTH  , RTDPTH
!
    END MODULE SOIL

    SUBROUTINE SLP(NHB, PD, RES, FIS, T, Q, NTSD, NEST, PSLP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SLP
!> 
!> SUBROUTINE: SLP - SLP REDUCTION
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 99-04-22
!>
!> ABSTRACT:
!> THIS ROUTINE COMPUTES THE SEA LEVEL PRESSURE REDUCTION USING EITHER THE MESINGER RELAXATION 
!> METHOD OR THE STANDARD NCEP REDUCTION.
!>
!> PROGRAM HISTORY LOG:
!> 99-04-22  T BLACK      - ORIGINATOR
!> 00-01-10  JIM TUCCILLO - MPI VERSION
!> 00-11-02  T BLACK      - SLP FOR NEST BOUNDARIES
!> 18-01-15  LUCCI        - MODERNIZATION OF THE CODE, INCLUDING:
!>                          * F77 TO F90/F95
!>                          * INDENTATION & UNIFORMIZATION CODE
!>                          * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                          * DOCUMENTATION WITH DOXYGEN
!>                          * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NHB  - UNIT NUMBER FOR READING THE NHB FILE
!> PD   - SFC PRESSURE MINUS PTOP
!> RES  - RECIPROCAL OF ETA AT THE GROUND
!> FIS  - SURFACE GEOPOTENTIAL
!> NTSD - THE TIMESTEP
!> NEST - IF A NESTED RUN THEN NEST IS .TRUE.
!>
!> OUTPUT ARGUMENT LIST:
!> PSLP - THE FINAL REDUCED SEA LEVEL PRESSURE ARRAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> T    - TEMPERATURE
!> Q    - SPECIFIC HUMIDITY
!> 
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : QUILT
!>
!> CALLS      : MPI_ALLREDUCE
!>              MPI_BCAST
!>              UPDATE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1    = LM  + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM  * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JM2    = JM  - 2
    INTEGER(KIND=I4KIND), PARAMETER :: KBI    = 2   * IM + JM - 3
    INTEGER(KIND=I4KIND), PARAMETER :: KBI2   = KBI - 4
    INTEGER(KIND=I4KIND), PARAMETER :: NRLX1  = 500
    INTEGER(KIND=I4KIND), PARAMETER :: NRLX2  = 100
    INTEGER(KIND=I4KIND), PARAMETER :: KSLPD  = 1
!
    REAL   (KIND=R4KIND), PARAMETER :: OVERRC = 1.50
    REAL   (KIND=R4KIND), PARAMETER :: AD05   = OVERRC * 0.05
    REAL   (KIND=R4KIND), PARAMETER :: CFT0   = OVERRC - 1.
    REAL   (KIND=R4KIND), PARAMETER :: ROG    = 287.04 / 9.8
!
    REAL   (KIND=R4KIND), ALLOCATABLE       , DIMENSION(:,:,:)                                  ::&
    & HTM

    REAL   (KIND=R4KIND)                    , DIMENSION(IM, MY_JSD:MY_JED)                      ::&
    & TTV     , PDSL1   , PBI     , SLPX
!
    REAL   (KIND=R4KIND)                    , DIMENSION(LM)                                     ::&
    & DETA    , RDETA   , AETA    , F4Q2    
!
    REAL   (KIND=R4KIND)                    , DIMENSION(LP1)                                    ::&
    & ETA     , DFL
!
    REAL   (KIND=R4KIND)                    , DIMENSION(KBI,LM)                                 ::&
    & TSLPB
!
    REAL   (KIND=R4KIND)                    , DIMENSION(KBI2,LM)                                ::& 
    & TSLPB2  
!
    REAL   (KIND=R4KIND)                    , DIMENSION(KBI)                                    ::&
    & PSLPB
!
    REAL   (KIND=R4KIND)                    , DIMENSION(KBI2)                                   ::&
    & PSLPB2
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & KMNTM
!
    INTEGER(KIND=I4KIND)                    , DIMENSION(IM, JM)                                 ::&
    & LMH
!
    INTEGER(KIND=I4KIND)                    , DIMENSION(IMJM)                                   ::&
    & IMNT    , JMNT
!
    INTEGER(KIND=I4KIND)                    , DIMENSION(JM)                                     ::&
    & IHE     , IHW     , IVE     , IVW
!
    LOGICAL(KIND=L4KIND)                                                       , INTENT(IN)     ::&
    & NEST
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SIGMA   , STDRD   ,NO_REDUCE, EXBC
!
    REAL   (KIND=R4KIND)                    , DIMENSION(IM, MY_JSD:MY_JED)     , INTENT(IN)     ::&
    & PD      , RES     , FIS
!
    REAL   (KIND=R4KIND)                    , DIMENSION(IM, MY_JSD:MY_JED)     , INTENT(INOUT)    ::&
    & PSLP
!
    REAL   (KIND=R4KIND)                    , DIMENSION(IM, MY_JSD:MY_JED,LM)  , INTENT(INOUT)  ::&
    & T       , Q
!
    REAL   (KIND=R4KIND)                    , DIMENSION(IM, JM)                                 ::&
    & DUM
!
    REAL   (KIND=R4KIND)                    , DIMENSION(2 * KBI * (6 * LM + 1))                 ::&
    & BCDUM
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LFRST
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                       , INTENT(IN)     ::&
    & NHB     , NTSD    
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NFCST   , NBC     , I       , J       , L       , LREC    , LXXX    , LHMNT   , IERR    ,   &
    & LMV     , IDTAD   , LIST    , LL      , LMAP1   , LRECBC  , NREC    , IRTN    , NRLX    ,   &
    & KMN     , LMST    , LI      , N       , KMM     , KM      , LMA     , KS      , IHH2    
! 
    REAL   (KIND=R4KIND)                                                                        ::&
    & DT      , DY      , CPGFV   , EN      , ENT     , R       , PT      , TDDAMP  , F4D     ,   &
    & F4Q     , EF4T    , TGSS    , BCHR    , PBIN    , TRTV    , PHTI    , DPOSP   , PRBIN   ,   &
    & PRTIN   , ALPP1   , SLOP    , SLPP    , TTT     , PTIN    , PHBI 
!
    DATA LFRST /.TRUE./
!
    SAVE
!
    IF (LFRST) THEN
        LFRST = .FALSE. 
!------------------------------------------------- 
! READ IN THE ARRAYS AND CONSTANTS THAT ARE NEEDED
!-------------------------------------------------
        REWIND NHB
!    
        READ(NHB) NFCST, NBC, LIST, DT, IDTAD, SIGMA
        READ(NHB) LMH
        READ(NHB) LMV
        READ(NHB)
        READ(NHB)
        READ(NHB)
        READ(NHB)
        READ(NHB)
!    
        STDRD     = .FALSE. 
        NO_REDUCE = .FALSE. 
!
        IF (SIGMA) STDRD = .TRUE. 
!-------------------------------------------------------- 
! FIND THE MOST ELEVATED GLOBAL LAYER WHERE THERE IS LAND
!--------------------------------------------------------    
        DO L=1,LM
            READ(NHB) ((DUM(I,J),I=1,IM),J=1,JM)
!        
            DO J=JSTA_I,JEND_I
                DO I=1,IM
                    IF (DUM(I,J) < 0.5) GOTO 666
                END DO
            END DO
!------------------------------------------         
! IF WE GET TO HERE, WE HAVE ALL ATMOSPHERE
!------------------------------------------        
            GOTO 667
!
        666 CONTINUE
!----------------------------------------------        
! IF WE GET HERE, WE HAVE FOUND A NON_ATM POINT
!----------------------------------------------        
            LHMNT = L
!
            GOTO 668
!
        667 CONTINUE
!
        END DO
!    
        LHMNT = LM+1
!
    668 CONTINUE
!    
        CALL MPI_ALLREDUCE(LHMNT, LXXX, 1, MPI_INTEGER, MPI_MIN, MPI_COMM_COMP, IERR)
!
        LREC = MIN(LHMNT,LM)
        DO I=1,LREC-LXXX+1
            BACKSPACE NHB
        END DO
!    
        LHMNT = LXXX
!
        ALLOCATE(HTM(IM, MY_JSD:MY_JED, LHMNT:LM))
!    
        DO L=LHMNT,LM
            READ(NHB) ((DUM(I,J),I=1,IM),J=1,JM)
            DO J=MY_JSD,MY_JED
                DO I=1,IM
                    HTM(I,J,L) = DUM(I,J)
                END DO
            END DO
        END DO
!    
    669 CONTINUE
    
        DO L=1,LM
            READ(NHB)
        END DO
!    
        READ(NHB) DY , CPGFV, EN, ENT, R, PT, TDDAMP, F4D, F4Q, EF4T, DETA, RDETA, AETA, F4Q2,    &
    &             ETA, DFL
!---------------------- 
! END OF LFRST IF BLOCK
!---------------------- 
    END IF 
!------------------------------------------- 
! CALCULATE THE I-INDEX EAST-WEST INCREMENTS
!------------------------------------------- 
    DO J=1,JM
        IHE(J) = MOD(J+1,2)
        IHW(J) = IHE(J) - 1
        IVE(J) = MOD(J  ,2)
        IVW(J) = IVE(J) - 1
    END DO
!---------------------------------------------------------- 
! INITIALIZE ARRAYS.  LOAD SLP ARRAY WITH SURFACE PRESSURE.
!---------------------------------------------------------- 
    DO J=JSTA_I,JEND_I
        DO I=1,IM
            PSLP(I,J) = 0.
             TTV(I,J) = 0.
        END DO
    END DO
!
    DO 110 J=JSTA_I,JEND_I
        DO 110 I=1,IM
            PDSL1(I,J) =  RES(I,J) * PD(I,J)
             PSLP(I,J) =   PD(I,J) + PT
             PBI (I,J) = PSLP(I,J)
110 END DO
!---------------------------------------------------------------------------------------- 
! CALCULATE SEA LEVEL PRESSURE FOR PROFILES (AND POSSIBLY FOR POSTING BY POST PROCESSOR).
!
! "STDRD" REFERS TO THE "STANDARD" SLP REDUCTION SCHEME.
! THIS IS THE ONLY SCHEME AT PRESENT AVAILABLE FOR A SIGMA=.TRUE. ETA MODEL RUN.
!---------------------------------------------------------------------------------------- 
220 IF (LHMNT == LP1) THEN
        NO_REDUCE = .TRUE. 
    END IF
!
    IF (NO_REDUCE) GOTO 430
!
    IF (STDRD)     GOTO 400
!
    LL = LM
!
    DO J=JSTA_IM2,JEND_IM2
        DO I=2,IM-1
            IF (HTM(I,J,LL) <= 0.5) THEN
                TGSS  = FIS(I,J) / (R * ALOG((PDSL1(I,J) + PT) / (PD(I,J) + PT)))
                LMAP1 = LMH(I,J) + 1
!            
                DO 260 L=LMAP1,LM
                    T(I,J,L) = TGSS
            260 END DO
!           
            END IF
        END DO
    END DO
!--------------------------------------------------------------------------------------------------
! IF THIS IS A NESTED RUN, READ IN THE PARENT TEMPERATURE VALUES (INTERPOLATED THE NEST VERTICAL
! DISTRIBUTION) FOR THE SLP RELAXATION PROCEDURE.
!--------------------------------------------------------------------------------------------------
    IF (NEST) THEN
        IF (ME == 0) THEN
            LRECBC = 4 * (1 + (1 + 6 * LM) * KBI * 2 + (KBI + KBI2) * (LM + 1))
!
            OPEN(UNIT=NBC, ACCESS='DIRECT', RECL=LRECBC)
        
            NREC = NINT((NTSD-1) * DT / 3600.) + 2
!
            READ(NBC,REC=NREC) BCHR, BCDUM, TSLPB, TSLPB2, PSLPB, PSLPB2
!
            CLOSE(NBC)
        END IF
!    
        CALL MPI_BCAST(TSLPB , KBI*LM , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(TSLPB2, KBI2*LM, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(PSLPB , KBI    , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(PSLPB2, KBI2   , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!    
    END IF
!-----------------------------------------------------------------------------------------
! CREATE A TEMPORARY TV ARRAY, AND FOLLOW BY SEQUENTIAL OVERRELAXATION, DOING NRLX PASSES.
!-----------------------------------------------------------------------------------------
    NRLX = NRLX1
!
    DO 300 L=LHMNT,LM
!
          KMN = 0
        KMNTM = 0
!    
        DO 240 J=JSTA_IM2,JEND_IM2
            DO 240 I=2,IM-1
                IF (HTM(I,J,L) > 0.5) GOTO 240
                KMN = KMN+1
                IMNT(KMN) = I
                JMNT(KMN) = J
    240 END DO
!    
        KMNTM = KMN
!    
        DO 270 J=JSTA_I,JEND_I
            DO 270 I=1,IM
                TTV(I,J) = T(I,J,L)
    270 END DO  
!--------------------------------------------------------------------------------------------------
! FOR GRID BOXES NEXT TO MOUNTAINS REPLACE TTV BY AN "EQUIVALENT" TV, ONE WHICH CORRESPONDS TO THE
! CHANGE IN P BETWEEN REFERENCE INTERFACE GEOPOTENTIALS, INSTEAD OF BETWEEN LAYER INTERFACES
!--------------------------------------------------------------------------------------------------   
        DO J=JSTA_IM2,JEND_IM2
            DO I=2,IM-1
!
                IF (HTM(I,J,L) > 0.5 .AND.                                                        &
    &               HTM(I+IHW(J),J-1,L) * HTM(I+IHE(J),J-1,L) *                                   &
    &               HTM(I+IHW(J),J+1,L) * HTM(I+IHE(J),J+1,L) *                                   &
    &               HTM(I-1     ,J  ,L) * HTM(I+1     ,J  ,L) *                                   &
    &               HTM(I       ,J-2,L) * HTM(I       ,J+2,L) < 0.5) THEN
                    LMST = LMH(I,J)
!-------------------------------------------------------------
! FIND P AT THE REFERENCE INTERFACE GEOPOTENTIAL AT THE BOTTOM
!-------------------------------------------------------------
                    PBIN = PT + PD(I,J)
                    PHBI = DFL(LMST+1)
!                
                    DO LI=LMST,1,-1
                        PTIN = PBIN - DETA(LI) * PD(I,J) * RES(I,J)
                        TRTV = 2. * R * T(I,J,LI) * (1. + 0.608 * Q(I,J,LI))
                        PHTI = PHBI + TRTV * (PBIN - PTIN) / (PBIN + PTIN)
!
                        IF (PHTI >= DFL(L+1)) GO TO 273
!
                        PBIN = PTIN
                        PHBI = PHTI
                    END DO
!                
                273 DPOSP = (PHTI - DFL(L+1)) / TRTV
                    PRBIN = (1. + DPOSP) / (1. - DPOSP) * PTIN
!---------------------------------------------------------- 
! FIND P AT THE REFERENCE INTERFACE GEOPOTENTIAL AT THE TOP
!---------------------------------------------------------- 
                    PBIN = PT + PD(I,J)
                    PHBI = DFL(LMST+1)
!                
                    DO LI=LMST,1,-1
                        PTIN = PBIN - DETA(LI) * PD(I,J) * RES(I,J)
                        TRTV = 2. * R * T(I,J,LI) * (1. + 0.608 * Q(I,J,LI))
                        PHTI = PHBI + TRTV * (PBIN - PTIN) / (PBIN + PTIN)
!
                        IF (PHTI >= DFL(L)) GO TO 275
!
                        PBIN = PTIN
                        PHBI = PHTI
                    END DO
!                
                275 DPOSP = (PHTI - DFL(L)) / TRTV
                    PRTIN = (1. + DPOSP) / (1. - DPOSP) * PTIN
!                
                    TTV(I,J) = (DFL(L) - DFL(L+1)) / (2. * R) * (PRBIN + PRTIN) / (PRBIN - PRTIN)
                END IF
!
            END DO
        END DO
!--------------------------------------------------------------------------------------------------
! FOR POINTS IN THE OUTER TWO BOUNDARY ROWS THAT ARE NEXT TO MOUNTAINS, SET TTVS EQUAL TO THE 
! TEMPERATURES DERIVED EARLIER FROM THE PARENT GRIDS SLP AND SET PSLP EQUAL TO THE PARENTS SLP.
!--------------------------------------------------------------------------------------------------
        IF (NEST) THEN
!--------------------------------             
! FIRST DO THE OUTER BOUNDARY ROW
!--------------------------------        
            N = 1
!        
            DO I=1,IM
!            
                IF (JSTA_I == 1) THEN ! SOUTHERN EDGE
                    IF (HTM(I,3,L) < 0.5) THEN
                        TTV(I,1) = TSLPB(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(I,1)=PSLPB(N)
                END IF
                N = N + 1
            END DO
!        
            DO I=1,IM
!            
                IF (JEND_I == JM) THEN ! NORTHERN EDGE
                    IF (HTM(I,JM-2,L) < 0.5) THEN
                        TTV(I,JM) = TSLPB(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(I,JM) = PSLPB(N)
                END IF
                N = N + 1
            END DO
!        
            DO J=3,JM-2,2 ! WESTERN EDGE
!            
                IF (J >= JSTA_I .AND. J <= JEND_I) THEN
                    IF (HTM(3,J,L) < 0.5) THEN
                        TTV(1,J) = TSLPB(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(1,J) = PSLPB(N)
                END IF
                N = N + 1
            END DO
!        
            DO J=3,JM-2,2 ! EASTERN EDGE
!            
                IF (J >= JSTA_I .AND. J <= JEND_I) THEN
                    IF (HTM(IM-2,J,L) < 0.5) THEN
                        TTV(IM,J) = TSLPB(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(IM,J) = PSLPB(N)
                END IF
                N = N + 1
            END DO
!------------------------------------------        
! NOW DO THE INNER 2ND (INNER) BOUNDARY ROW
!------------------------------------------        
            N = 1
            DO I=1,IM-1 ! 1ST ROW FROM SOUTHERN EDGE
!            
                IF (JSTA_I == 1) THEN
                    IF (HTM(I,3,L) < 0.5 .OR. HTM(I+1,3,L) < 0.5) THEN
                        TTV(I,2) = TSLPB2(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(I,2) = PSLPB2(N)
                END IF
                N = N + 1
            END DO
!--------------------------- 
! 1ST ROW FROM NORTHERN EDGE
!--------------------------- 
            DO I=1,IM-1 
!            
                IF (JEND_I == JM) THEN
                    IF (HTM(I,JM-2,L) < 0.5 .OR. HTM(I+1,JM-2,L) < 0.5) THEN
                        TTV(I,JM-1) = TSLPB2(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(I,JM-1) = PSLPB2(N)
                END IF
                N = N + 1
            END DO
!-------------------------- 
! 1ST ROW FROM WESTERN EDGE
!-------------------------- 
            DO J=4,JM-3,2 
!    
                IF (J >= JSTA_I .AND. J <= JEND_I) THEN
                    IF (HTM(2,J-1,L) < 0.5 .OR. HTM(2,J+1,L) < 0.5) THEN
                        TTV(1,J) = TSLPB2(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(1,J) = PSLPB2(N)
                END IF
                N = N + 1
            END DO
!--------------------------
! 1ST ROW FROM EASTERN EDGE
!--------------------------
            DO J=4,JM-3,2 
!            
                IF (J >= JSTA_I .AND. J <= JEND_I) THEN
                    IF (HTM(IM-1,J-1,L) < 0.5 .OR. HTM(IM-1,J+1,L) < 0.5) THEN
                        TTV(IM-1,J) = TSLPB2(N,L)
                    END IF
!                
                    IF (L == LM) PSLP(IM-1,J) = PSLPB2(N)
                END IF
                N = N + 1
            END DO
!------------------ 
! END OF NEST BLOCK
!------------------ 
        END IF 
!
        KMM = KMNTM
!---------------------------- 
! HERE IS THE RELAXATION LOOP
!---------------------------- 
        DO 285 N=1,NRLX
!        
            CALL UPDATE(TTV) ! EXCHANGE HALOES
!        
            DO 280 KM=1,KMM
                I = IMNT(KM)
                J = JMNT(KM)
                TTV(I,J) = AD05 * (4. * (TTV(I+IHW(J),J-1) + TTV(I+IHE(J),J-1)                    &
    &                    +               TTV(I+IHW(J),J+1) + TTV(I+IHE(J),J+1))                   &
    &                    +               TTV(I-1     ,J  ) + TTV(I+1     ,J  )                    &
    &                    +               TTV(I       ,J-2) + TTV(I       ,J+2))                   &
    &                    -               CFT0              * TTV(I       ,J  )
        280 END DO
!        
    285 END DO
!
        DO 290 KM=1,KMM
            I = IMNT(KM)
            J = JMNT(KM)
            T(I,J,L) = TTV(I,J)
    290 END DO
!
300 END DO
!-----------------------------------------------------------------
! CALCULATE THE SEA LEVEL PRESSURE AS PER THE NEW SCHEME.
!
! VALUES FOR IMNT AND JMNT ARE FOR LAYER LM - THIS IS WHAT WE WANT
!-----------------------------------------------------------------
    KMM = KMNTM
!
    DO 320 KM=1,KMM
        I = IMNT(KM)
        J = JMNT(KM)
        LMAP1 = LMH(I,J) + 1
        PBIN = PT + PD(I,J)
!    
        DO L=LMAP1,LM
            PTIN = PBIN
            DPOSP = (DFL(L) - DFL(L+1)) / (2. * R * T(I,J,L))
            PBIN = (1. + DPOSP) / (1. - DPOSP) * PTIN
        END DO
!    
        PSLP(I,J) = PBIN
320 END DO
!-------------------------- 
! SKIP THE STANDARD SCHEME.
!--------------------------
    GOTO 430
!-------------------------------------------------------------------------
! IF YOU WANT THE "STANDARD" ETA/SIGMA REDUCTION THIS IS WHERE IT IS DONE.
!-------------------------------------------------------------------------
400 CONTINUE
!
    DO 410 J=JSTA_I,JEND_I
        DO 410 I=1,IM
            IF (FIS(I,J) >= 1.) THEN
                LMA   = LMH(I,J)
                ALPP1 = ALOG(PDSL1(I,J) * ETA(LMA+1) + PT)
                SLOP  = 0.0065 * ROG * T(I,J,LMA)
!
                IF (SLOP < 0.50) THEN
                    SLPP = ALPP1 + FIS(I,J) / (R * T(I,J,LMA))
                ELSE
                    TTT = -(ALOG(PDSL1(I,J) * ETA(LMA) + PT) + ALPP1) * SLOP * 0.50 + T(I,J,LMA)
                    SLPP = (-TTT+SQRT(TTT*TTT + 2. * SLOP * (FIS(I,J) / R                         &
    &                    + (TTT + 0.50 * SLOP * ALPP1) * ALPP1))) / SLOP
                END IF
                PSLP(I,J) = EXP(SLPP)
            END IF
410 END DO
!--------------------------------------------------------------------------------------------------
! AT THIS POINT WE HAVE A SEA LEVEL PRESSURE FIELD BY EITHER METHOD. 5-POINT AVERAGE THE FIELD ON
! THE E-GRID.
!--------------------------------------------------------------------------------------------------
430 CONTINUE
!
    DO 440 J=JSTA_I,JEND_I
        DO 440 I=1,IM
            SLPX(I,J) = PSLP(I,J)
440 END DO
!
    DO 480 KS=1,KSLPD
!---------------- 
! EXCHANGE HALOES
!---------------- 
        CALL UPDATE(PSLP)
!    
        DO 460 J=JSTA_IM2,JEND_IM2
            IHH2 = IM-1 - MOD(J+1,2)
            DO 460 I=2,IHH2
!--------------------------------------------------------            
! EXTRA AVERAGING UNDER MOUNTAINS TAKEN OUT, FM, MARCH 96
!--------------------------------------------------------              
                SLPX(I,J) = 0.125 * (PSLP(I+IHW(J),J-1) + PSLP(I+IHE(J),J-1)                      &
    &                     +          PSLP(I+IHW(J),J+1) + PSLP(I+IHE(J),J+1)                      &
    &                     + 4.    *  PSLP(I       , J ))
    460 END DO
!    
        DO J=JSTA_I,JEND_I
            DO I=1,IM
                PSLP(I,J) = SLPX(I,J)
            END DO
        END DO
!    
480 END DO
!
    END SUBROUTINE SLP

    SUBROUTINE E2SPEC(EMISS, AVEPHI, FXOSP, DTSP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE E2SPEC
!>
!> SUBPROGRAM: E2SPEC - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> SUBROUTINE E2SPEC COMPUTES THE EXCHANGE TERMS IN THE FLUX EQUATION FOR LONGWAVE RADIATION FOR 2 
!> TERMS USED FOR NEARBY LAYER COMPUTATIONS. THE METHOD IS A TABLE LOOKUP ON A PRE-COMPUTED E2 
!> FUNCTION (DEFINED IN REF. (4)).
!> CALCULATIONS ARE DONE IN THE FREQUENCY RANGE:
!> 0-560, 1200-2200 CM-1
!> MOTIVATION FOR THESE CALCULATIONS IS IN REFERENCES (1) AND (4).
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> AVEPHI -
!> FXOSP  - 
!> DTSP   - 
!>
!> OUTPUT ARGUMENT LIST:
!> EMISS  - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : FST88
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
!
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION                    
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS; 
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!--------------------------------------------------------------------------------------------------                   
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS SENT TO RADFS
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! 
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION                   
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS; 
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!
! COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE
! TABLE FOR USE IN THE LONGWAVE RADIATION PROGRAM:
! EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS                  
! EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL                  
! TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS             
! TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  =  MASS DERIVATIVE OF TABLE1
! EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS              
! SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS               
! DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
! IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88              
! KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88             
! KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & EMISS
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & AVEPHI 
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & IVAL 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & FYO     , DU      , TMP3 
!------------------------------- 
! VARIABLES IN THE ARGUMENT LIST
!------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, 2)                       , INTENT(IN)          ::&
    & FXOSP   , DTSP
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K   
!--------------------------------------------------------------------------------------------------
! FIRST WE OBTAIN THE EMISSIVITIES AS A FUNCTION OF TEMPERATURE (INDEX FXO) AND WATER AMOUNT 
! (INDEX FYO). THIS PART OF THE CODE THUS GENERATES THE E2 FUNCTION.
!--------------------------------------------------------------------------------------------------
    DO 132 K=1,2
        DO 132 I=MYIS,MYIE
            TMP3 (I,K) = LOG10(AVEPHI(I,K)) + H16E1
            FYO  (I,K) = AINT(TMP3(I,K)  * TEN)
            DU   (I,K) = TMP3(I,K) - HP1 * FYO(I,K)
            IVAL (I,K) = H28E1 * FYO(I,K) + FXOSP(I,K)
            EMISS(I,K) = T1(IVAL(I,K)) + DU(I,K) * T2(IVAL(I,K)) + DTSP(I,K) * T4(IVAL(I,K))
132 END DO
!
    RETURN
!
    END SUBROUTINE E2SPEC

    SUBROUTINE SSTSTP(SSTUPSTEP) 
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SSTSTP
!>
!> SUBPROGRAM: SSTSTP - ?????
!> PROGRAMMER: ?????   
!> ORG:????? 
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> 93-10-28  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> SSTUPSTEP - 
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>              LOOPS
!>              MASKS
!>              PARMETA
!>              PARM_TBL   
!>              PHYS
!>              UPDT
!>
!> DRIVER     : EBU
!>
!> CALLS      : GETDATE
!>--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE F77KINDS
    USE LOOPS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL   
    USE PHYS
    USE UPDT
!							   
    INTEGER(KIND=I4KIND), PARAMETER :: LA = 13   
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: LTOP = 1
    INTEGER(KIND=I4KIND), PARAMETER :: LBOT = LM
    INTEGER(KIND=I4KIND), PARAMETER :: LSCRCH = 4 * LM + 1 + LA +1
    INTEGER(KIND=I4KIND), PARAMETER :: L1 = LA +     LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: L2 = LA + 2 * LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: L3 = LA + 3 * LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: L4 = LA + 4 * LM + 1   
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & SSTUPSTEP  
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & MA      , MB      , IMES    , IMES2   , QTMON   , DAYTWOMON         , NMESSST , NANOSST 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & YDAY    , ADD     , FA      , FB
!					   
    INTEGER(KIND=I4KIND), DIMENSION(12)                                                         ::&
    & MONL
!       					   
    IYR  = IDAT(3)
    IMO  = IDAT(1)
    IDY  = IDAT(2)
!-----------------
! CHOU DT EH 90SEG
!-----------------
    IUTC = NTSD * DT / 3600     
!    
    CALL GETDATE(IYR, IMO, IDY, IUTC, YR, MON, DAY, UTC)
!       
    DATA MONL /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/   
!       
    ANL = 365
!       
    IF (MOD(YR,4) == 0) THEN 
        MONL(2) = 29 
        ANL     = 366
    END IF
!------------------------------------       
! NUMERO DE PASSOS DE TEMPO DE UM MES
!------------------------------------
    NMESSST = MONL(MON) * (86400 / DT)  
!------------------------------------
! NUMERO DE PASSOS DE TEMPO EM UM ANO
!------------------------------------
    NANOSST = ANL * (86400 / DT)        							   
!	   
    YDAY = DAY   
    MA   = MON - 1
!
    IF (MA < 1) MA = 12
!
    IF ((YDAY >= (1.0 + FLOAT(MONL(MON)) / 2.0))) MA = MON  
!
    MB = MA + 1 
!       
    IF (MA <  1) MA = 12   
    IF (MB > 12) MB =  1
!       
    IF (NTSD == 1) THEN    
        IMES  = INITSST
        IMES2 = IMES + 1
    ELSE
        QTMON     = ((YR - IYR) * 12 + MON) - 1
        IMES      = QTMON + INITSST
        DAYTWOMON = (MONL(MB) / 2) + 1
!
       IF (MA == MON) IMES = IMES + 1
       IMES2 = IMES + 1  
!
    END IF  
!
    ADD = FLOAT(MONL(MA)) / 2.0 - 1.0
!
    IF (MA == MON) ADD = -ADD - 2.0   
!
    FB = 2.0 * (YDAY + ADD) / FLOAT(MONL(MA) + MONL(MB))   
    FA = 1.0 - FB
!
    print*,"IMES_IMES2", NTSD,MYPE,DAY,IMES,IMES2
    SST = FA * SSTM(:,:,IMES) + FB * SSTM(:,:,IMES2)
!									   
    RETURN  
! 
    END SUBROUTINE SSTSTP

    SUBROUTINE CONRAD(NFILE)
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE CONRAD 
!>
!> SUBROUTINE: CONRAD - READ CO2 TRANSMISSION DATA FROM UNIT(NFILE) FOR NEW VERTICAL COORDINATE 
!>                      TESTS THESE ARRAYS USED TO BE IN BLOCK DATA.     
!> PROGRAMMER: K.CAMPANA
!> ORG: ?????
!> DATE: 90-03-??
!>
!> ABSTRACT:
!> CO2 DATA TABLES FOR USER'S VERTICAL COORDINATE.
!>
!> THE FOLLOWING COMMON BLOCKS CONTAIN PRETABULATED CO2 TRANSMISSION FUNCTIONS, EVALUATED USING THE
!> METHODS OF FELS AND SCHWARZKOPF (1981) AND SCHWARZKOPF AND FELS (1985).
!> THE 2-DIMENSIONAL ARRAYS ARE CO2 TRANSMISSION FUNCTIONS AND THEIR DERIVATIVES FROM 109-LEVEL 
!> LINE-BY-LINE CALCULATIONS MADE USING THE 1982 MCCLATCHY TAPE (12511 LINES), CONSOLIDATED, 
!> INTERPOLATED TO THE NMC MRF VERTICAL COORDINATTE, AND RE-CONSOLIDATED TO A 200 CM-1 BANDWIDTH. 
!> THE INTERPOLATION METHOD IS DESCRIBED IN SCHWARZKOPF AND FELS (J.G.R., 1985).
!>
!> THE 1-DIM ARRAYS ARE CO2 TRANSMISSION FUNCTIONS AND THEIR DERIVATIVES FOR TAU(I,I+1), I=1, L, 
!> WHERE THE VALUES ARE NOT OBTAINED BY QUADRATURE,BUT ARE THE ACTUAL TRANSMISSIVITIES, ETC, 
!> BETWEEN A PAIR OF PRESSURES.
!> THESE USED ONLY FOR NEARBY LAYER CALCULATIONS INCLUDING QH2O.
!>
!> THE WEIGHTING FUNCTION GTEMP = P(K) ** 0.2 * (1. + P(K) / 30000.) ** 0.8 / 1013250.,
!> WHERE P(K) = PRESSURE, NMC MRF(NEW) L18 DATA LEVELS FOR PSTAR = 1013250.
!>
!> STEMP IS US STANDARD ATMOSPHERES, 1976, AT DATA PRESSURE LEVELS USING NMC MRF SIGMAS, 
!> WHERE PSTAR = 1013.25 MB (PTZ PROGRAM)
!>
!> MODULE CO2BD3 CONTAINS CO2 TRANSMISSION FUNCTIONS AND TEMPERATURE AND PRESSURE DERIVATIVES FOR 
!> THE 560-800 CM-1 BAND. 
!> ALSO INCLUDED ARE THE STANDARD TEMPERATURES AND THE WEIGHTING FUNCTION. THESE DATA ARE IN BLOCK
!> DATA BD3:
!>
!> CO251  - TRANSMISSION FCTNS FOR T0 (STD. PROFILE) WITH P(SFC)=1013.25 MB
!> CO258  - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE)WITH P(SFC)= 810 MB
!> CDT51  - FIRST TEMPERATURE DERIVATIVE OF CO251
!> CDT58  - FIRST TEMPERATURE DERIVATIVE OF CO258
!> C2D51  - SECOND TEMPERATURE DERIVATIVE OF CO251
!> C2D58  - SECOND TEMPERATURE DERIVATIVE OF CO251
!> CO2M51 - TRANSMISSION FCTNS FOR T0 FOR ADJACENT PRESSURE LEVELS, WITH NO PRESSURE QUADRATURE. 
!>          USED FOR NEARBY LAYER COMPUTATIONS. P(SFC)=1013.25 MB
!> CO2M58 - SAME AS CO2M51,WITH P(SFC)= 810 MB
!> CDTM51 - FIRST TEMPERATURE DERIVATIVE OF CO2M51
!> CDTM58 - FIRST TEMPERATURE DERIVATIVE OF CO2M58
!> C2DM51 - SECOND TEMPERATURE DERIVATIVE OF CO2M51
!> C2DM58 - SECOND TEMPERATURE DERIVATIVE OF CO2M58
!> STEMP  - STANDARD TEMPERATURES FOR MODEL PRESSURE LEVEL STRUCTURE WITH P(SFC)=1013.25 MB
!> GTEMP  - WEIGHTING FUNCTION FOR MODEL PRESSURE LEVEL STRUCTURE WITH P(SFC)=1013.25 MB.
!>
!> THE FOLLOWING ARE STILL IN BLOCK DATA
!>
!> B0 - TEMP. COEFFICIENT USED FOR CO2 TRANS. FCTN. CORRECTION FOR T(K). (SEE REF. 4 AND BD3)
!> B1 - TEMP. COEFFICIENT, USED ALONG WITH B0
!> B2 - TEMP. COEFFICIENT, USED ALONG WITH B0
!> B3 - TEMP. COEFFICIENT, USED ALONG WITH B0
!>
!> PROGRAM HISTORY LOG:
!> 00-01-20  K.CAMPANA - ORIGINATOR
!> 18-01-15  LUCCI     - MODERNIZATION OF THE CODE, INCLUDING:
!>                       * F77 TO F90/F95
!>                       * INDENTATION & UNIFORMIZATION CODE
!>                       * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                       * DOCUMENTATION WITH DOXYGEN
!>                       * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NFILE - 
!>
!> OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: CO2DTA
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : GRADFS
!>
!> CALLS      : MPI_BCAST
!>              TABLE
!>-------------------------------------------------------------------------------------------------- 
    USE CO2DTA
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IX   = 2 * IM - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KX   = LM
    INTEGER(KIND=I4KIND), PARAMETER :: KP   = KX + 1  
    INTEGER(KIND=I4KIND), PARAMETER :: LP12 = LP1 * LP1
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND), DIMENSION(LP1, 2)                                                     ::&
    & SGTMP
!
    REAL   (KIND=R4KIND), DIMENSION(L, 6)                                                       ::&
    & CO21D
!
    REAL   (KIND=R4KIND), DIMENSION(LP1, LP1, 6)                                                ::&
    & CO22D
!
    REAL   (KIND=R4KIND), DIMENSION(LP1, 6)                                                     ::&
    & CO21D3  , CO21D7
!
    REAL   (KIND=R4KIND), DIMENSION(LP12)                                                       ::&
    & DATA2   
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & RSZE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & RSIZE   , KK      , I       , IRTN    , N       , I1      , I2      , K       , J
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & NFILE
!---------------------------------------------------
! THE ABOVE NOT USED IN CURRENT VERSION OF RADIATION
!
! BEGIN HERE TO GET CONSTANTS FOR RADIATION PACKAGE
!--------------------------------------------------- 
    OPEN(UNIT=NFILE,FORM='UNFORMATTED',FILE='CO2.dat')
!
    REWIND NFILE
!---------------------------------------------------------------------- 
! READ IN PRE-COMPUTED CO2 TRANSMISSION DATA AND CONVERT TO CYBER WORDS
!---------------------------------------------------------------------- 
    RSZE(1) = LP1
    RSZE(2) = L
    RSZE(3) = LP1 * LP1
!
    RSIZE = RSZE(1)
    DO 10 KK=1,2
        IF (MYPE == 0) READ(NFILE) (SGTMP(I,KK),I=1,RSIZE)
        CALL MPI_BCAST(SGTMP(1,KK), RSIZE, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
 10 END DO
!
    RSIZE = RSZE(2)
    DO 15 KK=1,6
        IF (MYPE == 0) READ(NFILE) (CO21D(I,KK),I=1,RSIZE)
        CALL MPI_BCAST(CO21D(1,KK), RSIZE, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
 15 END DO
!
    RSIZE = RSZE(3)
    DO 20 KK=1,6
        IF (MYPE == 0) READ(NFILE) (DATA2(I),I=1,RSIZE)
        CALL MPI_BCAST(DATA2(1), RSIZE, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
 !   
        N = 0
        DO 5673 I1=1,LP1
            DO 5673 I2=1,LP1
                N = N + 1
                CO22D(I1,I2,KK) = DATA2(N)
   5673 END DO
 20 END DO
!
    RSIZE = RSZE(1)
    DO 25 KK=1,6
        IF (MYPE == 0) READ(NFILE) (CO21D3(I,KK),I=1,RSIZE)
        CALL MPI_BCAST(CO21D3(1,KK), RSIZE, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
 25 END DO
!
    DO 30 KK=1,6
        IF (MYPE == 0) READ(NFILE) (CO21D7(I,KK),I=1,RSIZE)
        CALL MPI_BCAST(CO21D7(1,KK), RSIZE, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
 30 END DO
!
    REWIND NFILE
!
    DO 35 K=1,LP1
        STEMP(K) = SGTMP(K,1)
        GTEMP(K) = SGTMP(K,2)
 35 END DO
!
    DO 40 K=1,L
        CDTM51(K) = CO21D(K,1)
        CO2M51(K) = CO21D(K,2)
        C2DM51(K) = CO21D(K,3)
        CDTM58(K) = CO21D(K,4)
        CO2M58(K) = CO21D(K,5)
        C2DM58(K) = CO21D(K,6)
 40 END DO
!
    DO 45 J=1,LP1
        DO 45 I=1,LP1
            CDT51(I,J) = CO22D(I,J,1)
            CO251(I,J) = CO22D(I,J,2)
            C2D51(I,J) = CO22D(I,J,3)
            CDT58(I,J) = CO22D(I,J,4)
            CO258(I,J) = CO22D(I,J,5)
            C2D58(I,J) = CO22D(I,J,6)
 45 END DO
!   
    DO 50 K=1,LP1
        CDT31(K) = CO21D3(K,1)
        CO231(K) = CO21D3(K,2)
        C2D31(K) = CO21D3(K,3)
        CDT38(K) = CO21D3(K,4)
        CO238(K) = CO21D3(K,5)
        C2D38(K) = CO21D3(K,6)
 50 END DO
!
    DO 55 K=1,LP1
        CDT71(K) = CO21D7(K,1)
        CO271(K) = CO21D7(K,2)
        C2D71(K) = CO21D7(K,3)
        CDT78(K) = CO21D7(K,4)
        CO278(K) = CO21D7(K,5)
        C2D78(K) = CO21D7(K,6)
 55 END DO
!
    IF (MYPE == 0) PRINT 66, NFILE
 66 FORMAT(1H ,'----READ CO2 TRANSMISSION FUNCTIONS FROM UNIT ',I2)
!-------------------------------
! DEFINE TABLES FOR LW RADIATION
!-------------------------------
    CALL TABLE
!
    RETURN
!
    END SUBROUTINE CONRAD

    MODULE CONTIN
!>--------------------------------------------------------------------------------------------------
!> MODULE CONTIN
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : CHKOUT
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              EBU
!>              EPS
!>              GOSSIP
!>              HADZ
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              VADZ
!>              VTADV
!>              VTADVF
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IDIM1, IDIM2, JDIM1, JDIM2, LM
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PDSL    , PDSLO   , PSDT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM  )                             ::&
    & RTOP    , OMGALF  , DIV
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM-1)                             ::&
    & ETADT
! 
    END MODULE CONTIN

    SUBROUTINE HDIFF
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE HDIFF
!>
!> SUBPROGRAM: HDIFF - HORIZONTAL DIFFUSION
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-11-17
!>
!> ABSTRACT:
!> HDIFF CALCULATES THE CONTRIBUTION OF THE HORIZONTAL DIFFUSION TO THE TENDENCIES OF TEMPERATURE,
!> SPECIFIC HUMIDITY, WIND COMPONENTS AND TURBULENT KINETIC ENERGY AND THEN UPDATES THOSE VARIABLES.
!> A SECOND-ORDER NONLINEAR SCHEME SIMILAR TO SMAGORINSKYS IS USED WHERE THE DIFFUSION COEFFICIENT 
!> IS A FUNCTION OF THE DEFORMATION FIELD AND OF THE TURBULENT KINETIC ENERGY.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-28  BLACK      - ADDED EXTERNAL EDGE
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : ZERO2
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: DEFC  =  8.0
    REAL   (KIND=R4KIND), PARAMETER :: DEFM  = 32.0
    REAL   (KIND=R4KIND), PARAMETER :: SCQ2  = 50.0
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2 =  0.2
    REAL   (KIND=R4KIND), PARAMETER :: FCDIF =  1.0
    REAL   (KIND=R4KIND), PARAMETER :: RFCP  =   .25 / 1004.6
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD = 1
    INTEGER(KIND=I4KIND), PARAMETER :: JAMD  = (JAM * 2 - 10) * 3
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SECOND  , HEAT    , STTDF
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & Q2L     , UT      ,                                                                         &
    & HKNE    , HKSE    ,                                                                         &
    & VKNE    , VKSE    ,                                                                         &
    & HMASK   , HMSKL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & TNE     , TSE     ,                                                                         &
    & QNE     , QSE     ,                                                                         &
    & Q2NE    , Q2SE    ,                                                                         &
    & UNE     , USE     ,                                                                         &
    & VNE     , VSE     ,                                                                         &
    & TDIF    , QDIF    ,                                                                         &
    & UDIF    , VDIF    ,                                                                         &
    & Q2DIF   ,                                                                                   &
    & DEF     , CKE  
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LUL     , I       , J       , K       , KS
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DH1     , DH2     , DH3     , DH4     , DHM     , DEFTK   , DEFSK   , UTK     , VTK      
!-------------------------------------------------------------------
! DIFFUSING Q2 AT GROUND LEVEL DOESNT MATTER, USTAR2 IS RECALCULATED
!-------------------------------------------------------------------
    SECOND = .TRUE. 
    HEAT   = .FALSE. 
    LUL    = UL(1)
!
    DO J=MYJS_P1,MYJE_P2
        DO I=MYIS_P2,MYIE_P2
            HMASK(I,J) = 1.
            HMSKL(I,J) = 1.
        END DO
    END DO
!
    IF (SIGMA) THEN
        DO 100 J=MYJS2_P1,MYJE2_P1
!        
            DO I=MYIS1_P1,MYIE1_P1
                DH1 = ABS(FIS(I+IHW(J), J-1) - FIS(I,J))
                DH2 = ABS(FIS(I+IHE(J), J-1) - FIS(I,J))
                DH3 = ABS(FIS(I+IHW(J), J+1) - FIS(I,J))
                DH4 = ABS(FIS(I+IHE(J), J+1) - FIS(I,J))
!            
                DHM = AMAX1(DH1, DH2, DH3, DH4) / DY
!            
                IF (DHM > 0.100) THEN
                    HMASK(I,J) = 0.
                    HMSKL(I,J) = 0.
                END IF 
            END DO
!        
    100 END DO
    END IF
!
    DO 600 KS=1,KSMUD
!------------------------------- 
! MAIN VERTICAL INTEGRATION LOOP 
!------------------------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (CKE      , DEF     , DEFSK   , DEFTK   , HKNE    , HKSE    , HMSKL   , Q2DIF   ,   &
!$omp          Q2L      , Q2NE    , Q2SE    , QDIF    , QNE     , QSE     , TDIF    , TNE     ,   &
!$omp          TSE      , UDIF    , UNE     , USE     , UTK     , VDIF    , VKNE    , VKSE    ,   &
!$omp          VNE      , VSE     , VTK     )
!
        DO 500 K=1,LM
!
            CALL ZERO2(DEF)
            CALL ZERO2(Q2NE)
            CALL ZERO2(Q2SE)
            CALL ZERO2(QNE)
            CALL ZERO2(QSE)
            CALL ZERO2(TNE)
            CALL ZERO2(TSE)
            CALL ZERO2(UNE)
            CALL ZERO2(USE)
            CALL ZERO2(VSE)
            CALL ZERO2(VNE)
            CALL ZERO2(VSE)
            CALL ZERO2(TDIF)
            CALL ZERO2(QDIF)
            CALL ZERO2(UDIF)
            CALL ZERO2(VDIF)
            CALL ZERO2(Q2DIF)
!
            DO 210 J=MYJS_P1,MYJE_P1
                DO 210 I=MYIS_P1,MYIE_P1
                    Q2L(I,J) = AMAX1(Q2(I,J,K),EPSQ2)
        210 END DO
!------------- 
! DEFORMATIONS 
!------------- 
            DO 220 J=MYJS1_P1,MYJE1_P1
                DO 220 I=MYIS_P1,MYIE1_P1
!                
                    IF (K < LUL) THEN
                        HMSKL(I,J) = HMASK(I,J)
                    ELSE
                        HMSKL(I,J) = HMASK(I,J)
                    END IF
!                
                    DEFTK = U(I+IHE(J),J  ,K) - U(I+IHW(J),J  ,K)                                 &
    &                     - V(I       ,J+1,K) + V(I       ,J-1,K)
!
                    DEFSK = U(I       ,J+1,K) - U(I       ,J-1,K)                                 &
    &                     + V(I+IHE(J),J  ,K) - V(I+IHW(J),J  ,K)
!
                    DEF(I,J) = DEFTK * DEFTK + DEFSK * DEFSK
                    DEF(I,J) = SQRT(DEF(I,J) + DEF(I,J)) * HBM2(I,J)
                    DEF(I,J) = AMAX1(DEF(I,J),DEFC)
                    DEF(I,J) = DEF(I,J) * HMSKL(I,J)
        220 END DO
!-------------------------------- 
! T, Q, Q2 DIAGONAL CONTRIBUTIONS 
!-------------------------------- 
            DO 250 J=MYJS_P1,MYJE1_P1
                DO 250 I=MYIS_P1,MYIE1_P1
                    HKNE(I,J) =  (DEF(I,J)   +   DEF(I+IHE(J),J+1))                               &
    &                         *   HTM(I,J,K) *   HTM(I+IHE(J),J+1,K)                              &
    &                         * HMSKL(I,J)   * HMSKL(I+IHE(J),J+1)
!
                    TNE (I,J) = (T (I+IHE(J),J+1,K) - T (I,J,K)) * HKNE(I,J)
                    QNE (I,J) = (Q (I+IHE(J),J+1,K) - Q (I,J,K)) * HKNE(I,J)
                    Q2NE(I,J) = (Q2(I+IHE(J),J+1,K) - Q2(I,J,K)) * HKNE(I,J)
        250 END DO
!        
            DO 260 J=MYJS1_P1,MYJE_P1
                DO 260 I=MYIS_P1,MYIE1_P1
                    HKSE(I,J) =  (DEF(I+IHE(J),J-1)   +   DEF(I,J))                               &
    &                         *   HTM(I+IHE(J),J-1,K) *   HTM(I,J,K)                              &
    &                         * HMSKL(I+IHE(J),J-1)   * HMSKL(I,J)
!
                    TSE (I,J) = (T (I+IHE(J),J-1,K) - T (I,J,K)) * HKSE(I,J)
                    QSE (I,J) = (Q (I+IHE(J),J-1,K) - Q (I,J,K)) * HKSE(I,J)
                    Q2SE(I,J) = (Q2(I+IHE(J),J-1,K) - Q2(I,J,K)) * HKSE(I,J)
        260 END DO
!
            DO 270 J=MYJS1,MYJE1
                DO 270 I=MYIS1,MYIE
                    TDIF (I,J) = (TNE (I,J) - TNE (I+IHW(J),J-1)                                  &
    &                          +  TSE (I,J) - TSE (I+IHW(J),J+1))                                 &
    &                          *  HDAC(I,J)
!
                    QDIF (I,J) = (QNE (I,J) - QNE (I+IHW(J),J-1)                                  &
    &                          +  QSE (I,J) - QSE (I+IHW(J),J+1))                                 &
    &                          *  HDAC(I,J) * FCDIF
!
                    Q2DIF(I,J) = (Q2NE(I,J) - Q2NE(I+IHW(J),J-1)                                  &
    &                          +  Q2SE(I,J) - Q2SE(I+IHW(J),J+1))                                 &
    &                          *  HDAC(I,J)
        270 END DO
!--------------------- 
! 2-ND ORDER DIFFUSION
 !-------------------- 
            IF (SECOND) THEN
                DO 280 J=MYJS2,MYJE2
                    DO 280 I=MYIS1,MYIE1
                        T(I,J,K) = T(I,J,K) + TDIF(I,J)
                        Q(I,J,K) = Q(I,J,K) + QDIF(I,J)
            280 END DO
!
                IF (K /= LM) THEN
                    DO 290 J=MYJS2,MYJE2
                        DO 290 I=MYIS1,MYIE1
                            Q2(I,J,K) = Q2(I,J,K) + Q2DIF(I,J) * HTM(I,J,K+1)
                290 END DO
                END IF
!            
                GOTO 360
            END IF
!---------------------------------- 
! 4-TH ORDER DIAGONAL CONTRIBUTIONS
!---------------------------------- 
            DO 310 J=MYJS,MYJE1
                DO 310 I=MYIS,MYIE1
                    TNE (I,J) = (TDIF (I+IHE(J),J+1) - TDIF (I,J)) * HKNE(I,J)
                    QNE (I,J) = (QDIF (I+IHE(J),J+1) - QDIF (I,J)) * HKNE(I,J)
                    Q2NE(I,J) = (Q2DIF(I+IHE(J),J+1) - Q2DIF(I,J)) * HKNE(I,J)
        310 END DO
!        
            DO 320 J=MYJS1,MYJE
                DO 320 I=MYIS,MYIE1
                    TSE (I,J) = (TDIF (I+IHE(J),J-1) - TDIF (I,J)) * HKSE(I,J)
                    QSE (I,J) = (QDIF (I+IHE(J),J-1) - QDIF (I,J)) * HKSE(I,J)
                    Q2SE(I,J) = (Q2DIF(I+IHE(J),J-1) - Q2DIF(I,J)) * HKSE(I,J)
        320 END DO
!
            DO 330 J=MYJS2,MYJE2
                DO 330 I=MYIS1,MYIE1
                    T(I,J,K) = T(I,J,K) - (TNE (I,J) - TNE(I+IHW(J),J-1)                          &
    &                        +             TSE (I,J) - TSE(I+IHW(J),J+1))                         &
    &                        *             HDAC(I,J)
!
                    Q(I,J,K) = Q(I,J,K) - (QNE (I,J) - QNE(I+IHW(J),J-1)                          &
    &                        +             QSE (I,J) - QSE (I+IHW(J),J+1))                        &
    &                        *             HDAC(I,J) * FCDIF
        330 END DO
!
            IF (K /= LM) THEN
                DO 340 J=MYJS2,MYJE2
                    DO 340 I=MYIS1,MYIE1
                        Q2(I,J,K) = Q2(I,J,K) - (Q2NE(I,J) - Q2NE(I+IHW(J),J-1)                   &
    &                             +              Q2SE(I,J) - Q2SE(I+IHW(J),J+1))                  &
    &                             * HDAC(I,J) * HTM(I,J,K+1)
            340 END DO
            END IF
!----------------------------- 
! U, V, DIAGONAL CONTRIBUTIONS
!----------------------------- 
        360 DO 410 J=MYJS_P1,MYJE1_P1
            DO 410 I=MYIS_P1,MYIE1_P1
                VKNE(I,J) =  (DEF(I+IVE(J),J) +   DEF(I,J+1))                                     &
    &                     *   VTM(I,J,K)      *   VTM(I+IVE(J),J+1,K)                             &
    &                     * HMASK(I+IVE(J),J) * HMASK(I,J+1)
!
                UNE(I,J)  = (U(I+IVE(J),J+1,K) - U(I,J,K)) * VKNE(I,J)
                VNE(I,J)  = (V(I+IVE(J),J+1,K) - V(I,J,K)) * VKNE(I,J)
        410 END DO
!        
            DO 420 J=MYJS1_P1,MYJE_P1
                DO 420 I=MYIS_P1,MYIE1_P1
                    VKSE(I,J) =  (DEF(I,J-1)          +   DEF(I+IVE(J),J))                        &
    &                         *   VTM(I+IVE(J),J-1,K) *   VTM(I,J,K)                              &
    &                         * HMASK(I,J-1)          * HMASK(I+IVE(J),J)
!
                    USE(I,J) = (U(I+IVE(J),J-1,K) - U(I,J,K)) * VKSE(I,J)
                    VSE(I,J) = (V(I+IVE(J),J-1,K) - V(I,J,K)) * VKSE(I,J)
        420 END DO
!
            DO 430 J=MYJS1,MYJE1
                DO 430 I=MYIS,MYIE1
                    UDIF(I,J) =  (UNE(I,J) - UNE(I+IVW(J),J-1)                                    &
    &                         +   USE(I,J) - USE(I+IVW(J),J+1))                                   &
    &                         * HDACV(I,J)
!
                    VDIF(I,J) =  (VNE(I,J) - VNE(I+IVW(J),J-1)                                    &
    &                         +   VSE(I,J) - VSE(I+IVW(J),J+1))                                   &
    &                         * HDACV(I,J)
        430 END DO
!--------------------- 
! 2-ND ORDER DIFFUSION
!--------------------- 
            IF (SECOND) THEN
                DO 440 J=MYJS2,MYJE2
                    DO 440 I=MYIS1,MYIE1
                        U(I,J,K) = U(I,J,K) + UDIF(I,J)
                        V(I,J,K) = V(I,J,K) + VDIF(I,J)
            440 END DO
            ELSE
!---------------------------------- 
! 4-TH ORDER DIAGONAL CONTRIBUTIONS 
!---------------------------------- 
                DO 450 J=MYJS,MYJE1
                    DO 450 I=MYIS,MYIE1
                        UNE(I,J) = (UDIF(I+IVE(J),J+1) - UDIF(I,J)) * VKNE(I,J)
                        VNE(I,J) = (VDIF(I+IVE(J),J+1) - VDIF(I,J)) * VKNE(I,J)
            450 END DO
!            
                DO 460 J=MYJS1,MYJE
                    DO 460 I=MYIS,MYIE1
                        USE(I,J) = (UDIF(I+IVE(J),J-1) - UDIF(I,J)) * VKSE(I,J)
                        VSE(I,J) = (VDIF(I+IVE(J),J-1) - VDIF(I,J)) * VKSE(I,J)
            460 END DO
!
                DO 470 J=MYJS2,MYJE2
                    DO 470 I=MYIS1,MYIE1
                        UTK = U(I,J,K)
                        VTK = V(I,J,K)
                        U(I,J,K) = U(I,J,K) - (UNE(I,J) - UNE(I+IVW(J),J-1)                       &
    &                            +             USE(I,J) - USE(I+IVW(J),J+1))                      &
    &                            *           HDACV(I,J)
!
                        V(I,J,K) = V(I,J,K) - (VNE(I,J) - VNE(I+IVW(J),J-1)                       &
    &                            +             VSE(I,J) - VSE(I+IVW(J),J+1))                      &
    &                            *           HDACV(I,J)
!
                        CKE(I,J) = 0.5 * (U(I,J,K) * U(I,J,K) - UTK * UTK                         &
    &                            +        V(I,J,K) * V(I,J,K) - VTK * VTK)
            470 END DO
!
                IF (HEAT) THEN
                    DO 480 J=MYJS2,MYJE2
                        DO 480 I=MYIS1,MYIE1
                            T(I,J,K) = -RFCP * (CKE(I+IHE(J),J) + CKE(I,J+1)                      &
    &                                +          CKE(I+IHW(J),J) + CKE(I,J-1))                     &
    &                                * HBM2(I,J) + T(I,J,K)
                480 END DO
                END IF
!            
            END IF
!
    500 END DO
!
600 END DO
!
    RETURN
!
    END SUBROUTINE HDIFF

    SUBROUTINE E3V88(EMV, TV, AV)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE E3V88
!>
!> SUBPROGRAM: E3V88 - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> SUBROUTINE E3V88 COMPUTES NEARBY LAYER TRANSMISSIVITIES FOR H2O USING A TABLE LOOKUP OF THE PRE-
!> COMPUTED E3 FUNCTION (DESCRIBED IN REF. (4)).
!> 
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> TV  - 
!> AV  -
!>
!> OUTPUT ARGUMENT LIST:
!> EM3 -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!>  
!> DRIVER     : FST88
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS 
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION              
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION  
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLW   = 163
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS SENT TO RADFS
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL 
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION                    
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION               
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!
! COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE
! TABLE FOR USE IN THE LONGWAVE RADIATION PROGRAM:
! EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS                    
! EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL               
! TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS            
! TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  =  MASS DERIVATIVE OF TABLE1 
! EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS               
! SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS               
! DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
! IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88             
! KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88                  
! KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & IT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&  
    & WW1     , DT      ,                                                                         &
    & WW2     , DU
!------------------------------------------------------ 
! THE FOLLOWING ARRAYS ARE EQUIVALENCED TO VTEMP ARRAYS
!------------------------------------------------------ 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & FXO     , FYO     , TMP3
!-------------------------------------- 
! DIMENSIONS OF ARRAYS IN ARGUMENT LIST
!--------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                    , INTENT(INOUT)       ::& 
    & EMV
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                    , INTENT(IN)          ::& 
    & TV      , AV
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K 
!
    EQUIVALENCE (FXO,WW1), (FYO,WW2), (IT,TMP3)
!-------------------------------------------------------------------------
! THE FOLLOWING LOOP REPLACES A DOUBLE LOOP OVER I (1-IMAX) AND K (1-LLP1)
!-------------------------------------------------------------------------
    DO 203 K=1,LLP1
        DO 203 I=MYIS,MYIE
            FXO (I,K) = AINT(TV(I,K)    * HP1)
            TMP3(I,K) = LOG10(AV(I,K))  + H16E1
            DT  (I,K) = TV(I,K)   - TEN * FXO(I,K)
            FYO (I,K) = AINT(TMP3(I,K)  * TEN)
            DU  (I,K) = TMP3(I,K) - HP1 * FYO(I,K)
!--------------------------------------------------------------------------------------------------
! OBTAIN INDEX FOR TABLE LOOKUP; THIS VALUE WILL HAVE TO BE DECREMENTED BY 9 TO ACCOUNT FOR TABLE 
! TEMPS STARTING AT 100K.
!--------------------------------------------------------------------------------------------------
            IT (I,K) = FXO(I,K) + FYO(I,K) * H28E1
            WW1(I,K) = TEN - DT(I,K)
            WW2(I,K) = HP1 - DU(I,K)
            EMV(I,K) = WW1(I,K) * WW2(I,K) * EM3V(IT(I,K) -  9)                                   &
            &        + WW2(I,K) *  DT(I,K) * EM3V(IT(I,K) -  8)                                   &
            &        + WW1(I,K) *  DU(I,K) * EM3V(IT(I,K) + 19)                                   &
            &        +  DT(I,K) *  DU(I,K) * EM3V(IT(I,K) + 20)
203 END DO
!
    RETURN
!
    END SUBROUTINE E3V88

    MODULE EXCHM
!--------------------------------------------------------------------------------------------------
    CONTAINS
!
    SUBROUTINE EXCH0(ARR1, LL1, IHALO, JHALO)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE EXCH0
!>
!> SUBPROGRAM: EXCH0 - FUNDAMENTAL EXCHANGE ROUTINES
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 97-06-25
!>
!> ABSTRACT:
!> SUBROUTINE EXCH0 IS USED TO EXCHANGE HALOS BETWEEN PROCESSORS
!>
!>  CURRENTLY SUPPORTED INTERFACES
!>
!> 0, 00, 01, 011, 0001111, 1, 11, 111, 1111, 11111, 111111
!>
!> WHERE 0 REFERS TO A 2-D ARRAY AND 1 REFERS TO A 3-D ARRAY
!>
!> PROGRAM HISTORY LOG:
!> 97-05-??  MEYS       - ORIGINATOR
!> 97-06-25  BLACK      - CONVERTED FROM SHMEM TO MPI
!> 98-??-??  TUCCILLO   - REMOVED EXPLICIT EXCHANGES OF CORNERS
!> 98-??-??  TUCCILLO   - REWROTE TO USE NON_BLOCKING MPI ROUTINES
!> 99-??-??  BLACK      - ADDED VARIABLE HALO SIZES
!> 00-03-10  TUCCILLO   - CHANGED TO USE MODULE PROCDURES FOR INCREASED MESSAGE SIZES AND A UNIFORM
!>                        INTERFACE FOR ALL CALLS
!> 01-02-25  TUCCILLO   - SOME PERFORMANCE IMPROVEMENTS
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LL1  - THE VERTICAL DIMENSION OF ARR
!> IHALO - THE NUMBER OF POINTS IN THE X DIRECTION TO EXCHANGE IN THE HALO
!> JHALO - THE NUMBER OF POINTS IN THE Y DIRECTION TO EXCHANGE IN THE HALO
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> ARR1 - THE ARRAY TO BE EXCHANGED
!>
!> USE MODULES: EXCH_BUF_REAL
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : MPI_IRECV
!>              MPI_ISEND
!>              MPI_WAIT
!>--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    SAVE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , ISEND   , IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 

    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!-------------------
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!--------------  
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,MYJE-J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,MYJS+J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1),ISTAT,IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!--------- 
!EAST/WEST
!--------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 

    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE+1
        IEND = MYIE+IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH1(ARR1, LL1, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 

    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!--------------
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 

    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 

    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH01(ARR1, LL1, ARR2, LL2, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,MYJE-J)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,MYJS+J)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!----------  
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------  
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO -1 
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,J)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS-IHALO
        IEND = MYIS-1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1),ISTAT,IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH00(ARR1, LL1, ARR2, LL2, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
! 
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR2
!
    ITYPE = MPI_REAL
!------------  
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,MYJE-J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR2(I,MYJE-J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,MYJS+J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR2(I,MYJS+J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
    END IF

!-----------------
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!----------  
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR2(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   =  0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR2(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS-1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,J) = BUF0(IC)
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,J) = BUF1(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH11(ARR1, LL1, ARR2, LL2, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------
!
!-------------------
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF

    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!----------
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!--------------------------------------------------------------------
! RECEIVE FROM EAST
!--------------------------------------------------------------------
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!----------------
! STORE FROM EAST
!----------------
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH111(ARR1, LL1, ARR2, LL2, ARR3, LL3, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NEBPE
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR3
!
    ITYPE = MPI_REAL
!------------ ARR1
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJS-J-1,K) = BUF1(IC)
                END DO 
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF

    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        NEBPE = MY_NEB(4)
        IBEG  = MYIS
        IEND  = MYIS + IHALO - 1
        IC    = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO 
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS-1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH1111(ARR1, LL1, ARR2, LL2, ARR3, LL3, ARR4, LL4, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
! 
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , LL4     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NEBPE
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR4
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO 
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!-------------------------
! STORE RESULTS FROM SOUTH
!-------------------------
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        NEBPE = MY_NEB(2)
        IBEG  = MYIE - IHALO + 1
        IEND  = MYIE
        IC    = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH11111(ARR1, LL1, ARR2, LL2, ARR3, LL3, ARR4, LL4, ARR5, LL5, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , LL4     , LL5     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR4
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR5
!
    ITYPE = MPI_REAL
!------------  
! NORTH/SOUTH
!------------
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!-------------------
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2),ISTAT,IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE,MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH111111(ARR1, LL1, ARR2, LL2, ARR3, LL3,                                        &
    &                     ARR4, LL4, ARR5, LL5, ARR6, LL6, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , LL4     , LL5     , LL6     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR4
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR5
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR6
!
    ITYPE = MPI_REAL
!------------
! NORTH/SOUTH
!------------
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR6(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR6(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR6(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1 
        IC   = 0
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR1(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR6(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE ,MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO K=1,LL1
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR1(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH011(ARR1, LL1, ARR2, LL2, ARR3, LL3, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR3
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,MYJE-J)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE,MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,MYJS+J)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------
! SEND TO EAST
!-------------
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,J)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR2(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR3(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2),ISTAT,IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL2
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR2(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL3
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR3(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE IEXCH(ARR1, LL1, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_INTEGER
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       , I       , ISEND   , IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    ITYPE = MPI_INTEGER
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------- 
! RECEIVE FROM SOUTH
!-------------------
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!--------------
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC)=ARR1(I,MYJE-J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC)=ARR1(I,MYJS+J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE,MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!----------
!
!------------------ 
! RECEIVE FROM WEST
!------------------
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!-------------
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC)=ARR1(I,J)
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 

    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1),ISTAT,IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
    END IF
!----------------  
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
!
    SUBROUTINE EXCH0001111(ARR1, LL1, ARR2, LL2, ARR3, LL3,                                       &
    &                      ARR4, LL4, ARR5, LL5, ARR6, LL6, ARR7, LL7, IHALO, JHALO)
!--------------------------------------------------------------------------------------------------
    USE EXCH_BUF_REAL
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!---------------------------------------
! LOCAL VARIABLE CAUSED BY IMPLICIT NONE
!---------------------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL1     , LL2     , LL3     , LL4     , LL5     , LL6     , LL7
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & IHALO   , JHALO
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITYPE   , IRECV   , IBEG    , IEND    , IC      , J       ,  I      , K       , ISEND   ,   &
    & IERR
!------------------------
! STANDARD LOCAL VARIABLE 
!------------------------
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & IHANDLE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)             , INTENT(INOUT)       ::&
    & ARR3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR4
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR5
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR6
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, *)          , INTENT(INOUT)       ::&
    & ARR7
!
    ITYPE = MPI_REAL
!------------ 
! NORTH/SOUTH
!------------ 
!
!------------------- 
! RECEIVE FROM NORTH
!------------------- 

    IF(MY_NEB(1) >= 0)THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(1),                                          &
    &                                         MY_NEB(1), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM SOUTH
!------------------- 
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(3),                                          &
    &                                         MY_NEB(3), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!-------------- 
! SEND TO NORTH
!-------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,MYJE-J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR2(I,MYJE-J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR3(I,MYJE-J)
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR6(I,MYJE-J,K)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR7(I,MYJE-J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(1), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!-------------- 
! SEND TO SOUTH
!-------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,MYJS+J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR2(I,MYJS+J)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR3(I,MYJS+J)
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR6(I,MYJS+J,K)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR7(I,MYJS+J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(3), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!------------------------- 
! STORE RESULTS FROM SOUTH
!------------------------- 
    IF (MY_NEB(3) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR3(I,MYJS-J-1) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR7(I,MYJS-J-1,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!----------------- 
! STORE FROM NORTH
!----------------- 
    IF (MY_NEB(1) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,MYJE+J+1) = BUF0(IC)
            END DO
        ENDDO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
        DO J=0,JHALO-1
            DO I=IBEG,IEND
                IC = IC + 1
                ARR3(I,MYJE+J+1) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL4
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=0,JHALO-1
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR7(I,MYJE+J+1,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(1) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(3) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!---------- 
! EAST/WEST
!---------- 
!
!------------------ 
! RECEIVE FROM WEST
!------------------ 

    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_IRECV(BUF0, IBUFEXCH, ITYPE, MY_NEB(4),                                          &
    &                                         MY_NEB(4), MPI_COMM_COMP, IHANDLE(1), IRECV)
    END IF
!------------------ 
! RECEIVE FROM EAST
!------------------ 
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_IRECV(BUF1, IBUFEXCH, ITYPE, MY_NEB(2),                                          &
    &                                         MY_NEB(2), MPI_COMM_COMP, IHANDLE(2), IRECV)
    END IF
!------------- 
! SEND TO EAST
!------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE - IHALO + 1
        IEND = MYIE
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR1(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR2(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF2(IC) = ARR3(I,J)
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR6(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF2(IC) = ARR7(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF2, IC, ITYPE, MY_NEB(2), MYPE, MPI_COMM_COMP, IHANDLE(3), ISEND)
    END IF
!------------- 
! SEND TO WEST
!------------- 

    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS
        IEND = MYIS + IHALO - 1
        IC   = 0
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR1(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR2(I,J)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                BUF3(IC) = ARR3(I,J)
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR4(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR5(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR6(I,J,K)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    BUF3(IC) = ARR7(I,J,K)
                END DO
            END DO
        END DO
        CALL MPI_ISEND(BUF3, IC, ITYPE, MY_NEB(4), MYPE, MPI_COMM_COMP, IHANDLE(4), ISEND)
    END IF
!---------------- 
! STORE FROM WEST
!---------------- 
    IF (MY_NEB(4) >= 0) THEN
        IBEG = MYIS - IHALO
        IEND = MYIS - 1
        IC   = 0
        CALL MPI_WAIT(IHANDLE(1), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF0(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,J) = BUF0(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR3(I,J) = BUF0(IC)
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR7(I,J,K) = BUF0(IC)
                END DO
            END DO
        END DO
    END IF
!---------------- 
! STORE FROM EAST
!---------------- 
    IF (MY_NEB(2) >= 0) THEN
        IBEG = MYIE + 1
        IEND = MYIE + IHALO
        IC   = 0
        CALL MPI_WAIT(IHANDLE(2), ISTAT, IERR)
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR1(I,J) = BUF1(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR2(I,J) = BUF1(IC)
            END DO
        END DO
        DO J=MYJS-JHALO,MYJE+JHALO
            DO I=IBEG,IEND
                IC = IC + 1
                ARR3(I,J) = BUF1(IC)
            END DO
        END DO
        DO K=1,LL4
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR4(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL5
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR5(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL6
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR6(I,J,K)=BUF1(IC)
                END DO
            END DO
        END DO
        DO K=1,LL7
            DO J=MYJS-JHALO,MYJE+JHALO
                DO I=IBEG,IEND
                    IC = IC + 1
                    ARR7(I,J,K) = BUF1(IC)
                END DO
            END DO
        END DO
    END IF
!
    IF (MY_NEB(4) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(4), ISTAT, IERR)
    END IF
!
    IF (MY_NEB(2) >= 0) THEN
        CALL MPI_WAIT(IHANDLE(3), ISTAT, IERR)
    END IF
!
    END SUBROUTINE
!
    END MODULE

    SUBROUTINE VDIFV(LMVK, KTM, DTQ2, UZ0, VZ0, AKMS, U, V, AKM, Z)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VDIFV
!>
!> SUBPROGRAM: VDIFV - VERTICAL DIFFUSION
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LMVK  - MASS POINT MODEL SURFACE (LOWEST MODEL HEIGHT)
!> KTM   - 
!> DTQ2  - PHYSICS TINE STEP
!> UZ0   -
!> VZ0   -
!> AKMS  - SURFACE COEF. FOR U AND V DIVIDED BY DELTA Z
!> AKM   - SURFACE EXCHANGE COEF. FOR U AND V
!> Z     - INTERFACE HEIGHT
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> U     - U AT H POINT (TRANSPOSED)
!> V     - V AT H POINT (TRANSPOSED)
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
! 
    INTEGER(KIND=I4KIND), PARAMETER :: LP1 = LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM1 = LM - 1
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(INOUT)       ::&
    & U       ,  V
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                  , INTENT(IN)          ::&
    & AKM
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::&
    & CM      , CR      , RSU     , RSV     , DTOZ
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                  , INTENT(IN)          ::&
    & Z
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LMVK    , KTM     
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LMVM    , LMVP    , KT      , L       , IVI
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTQ2    , UZ0     , VZ0     , AKMS
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTDIF   , DTOZS   , AKMH    , RCMVB   , DTOZAK  , RCML    , DTOZL   , CF
!
    DTDIF = DTQ2 / FLOAT(KTM)
    LMVM = LMVK - 1
    LMVP = LMVK + 1
!
    DO 300 KT=1,KTM
!
        DO 100 L=1,LMVM
            DTOZ(L) = DTDIF / (Z(L) - Z(L+1))
              CR(L) = -DTOZ(L) * AKM(L)
    100 END DO
!    
         CM(1) = DTOZ(1) * AKM(1) + 1.
        RSU(1) =    U(1)
        RSV(1) =    V(1)
!
        DO 110 L=2,LMVM
            DTOZL  = DTOZ(L)
            CF     = -DTOZL * AKM(L-1) / CM(L-1)
             CM(L) = - CR(L-1) * CF + (AKM(L-1) + AKM(L)) * DTOZL + 1.
            RSU(L) = -RSU(L-1) * CF + U(L)
            RSV(L) = -RSV(L-1) * CF + V(L)
    110 END DO
!
        DTOZS = DTDIF / (Z(LMVK) - Z(LMVP))
        AKMH  = AKM(LMVM)
!    
        CF     = -DTOZS * AKMH / CM(LMVM)
        RCMVB  = 1. / ((AKMH + AKMS) * DTOZS - CR(LMVM) * CF + 1.)
        DTOZAK = DTOZS * AKMS
!
        U(LMVK) = (DTOZAK * UZ0 - RSU(LMVM) * CF + U(LMVK)) * RCMVB
        V(LMVK) = (DTOZAK * VZ0 - RSV(LMVM) * CF + V(LMVK)) * RCMVB
!
        DO 120 IVI=1,LMVM
            L    = LMVK - IVI
            RCML = 1. / CM(L)
            U(L) = (-CR(L) * U(L+1) + RSU(L)) * RCML
            V(L) = (-CR(L) * V(L+1) + RSV(L)) * RCML
    120 END DO
!
300 END DO
!
    RETURN
!
    END SUBROUTINE VDIFV

    SUBROUTINE FST88(HEATRA, GRNFLX, TOPFLX, QH2O  , PRESS  , P     , DELP  , DELP2 , TEMP  ,     &
    &                T     , CLDFAC, NCLDS , KTOP  , KBTM   , CAMT  , CO21  , CO2NBL, CO2SP1,     &
    &                CO2SP2, VAR1  , VAR2  , VAR3  , VAR4   , CNTVAL, TOTO3 , TPHIO3, TOTPHI,     &
    &                TOTVO2, EMX1  , EMX2  , EMPL)
!>--------------------------------------------------------------------------------------------------  
!> SUBROUTINE FST88
!> 
!> SUBPROGRAM: FST88 - IS THE MAIN COMPUTATION MODULE OF THE LONG-WAVE RADIATION CODE. 
!>
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> IN IT ALL "EMISSIVITY" CALCULATIONS, INCLUDING CALLS TO TABLE LOOKUP SUBROUTINES. 
!> ALSO, AFTER CALLING SUBROUTINE "SPA88", FINAL COMBINED HEATING RATES AND GROUND FLUX ARE OBTAINED
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????  - ORIGINATOR
!> 18-01-15  LUCCI  - MODERNIZATION OF THE CODE, INCLUDING:
!>                    * F77 TO F90/F95
!>                    * INDENTATION & UNIFORMIZATION CODE
!>                    * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                    * DOCUMENTATION WITH DOXYGEN
!>                    * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> QH2O   -
!> PRESS  -
!> P      -
!> DELP   -
!> DELP2  -
!> TEMP   -
!> T      -
!> CLDFAC - 
!> NCLDS  - 
!> KTOP   -
!> KBTM   -
!> CAMT   -
!> CO21   -
!> CO2NBL -
!> CO2SP1 -
!> CO2SP2 -
!> VAR1   -
!> VAR2   -
!> VAR3   -
!> VAR4   -
!> CNTVAL -
!> TOTO3  -
!> TPHIO3 -
!> TOTPHI -
!> TOTVO2 - 
!> EMX1   -
!> EMX2   -
!> EMPL   - H2O AMOUNT,INPUT FOR E3 CALCULATION IN E3V88 (COMPUTED IN LWR88; STORED IN KDACOM.H)
!>
!> OUTPUT ARGUMENT LIST:
!> HEATRA -
!> GRNFLX -
!> TOPFLX -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> 
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              RNDDTA
!>              TABCOM
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : LWR88
!>
!> CALLS      : E1E290
!>              E290
!>              SPA88
!>              E3V88
!>              E2SPEC
!>--------------------------------------------------------------------------------------------------
!
!--------------------------------------------------------------------------------------------------
! PASSED VARIABLES:
! IN E3V88:
! EMD     =  E3 FUNCTION FOR H2O LINES (0-560,1200-2200 CM-1) COMPUTED IN E3V88
! TPL     =  TEMPERATURE INPUT FOR E3 CALCULATION IN E3V88
!
! IN E1E288:
! E1CTS1  =  E1 FUNCTION FOR THE (I+1)TH LEVEL USING THE TEMPERATURE OF THE ITH DATA LEVEL, 
!            COMPUTED OVER THE FREQUENCY RANGE 0-560, 1200-2200 CM-1. (E1CTS1-E1CTW1) IS USED IN 
!            OBTAINING THE FLUX AT THE TOP IN THE 0-160,1200-2200 CM-1 RANGE (FLX1E1).
! E1CTS2  =  E1 FUNCTION FOR THE ITH LEVEL, USING THE TEMP. OF THE ITH DATA LEVEL,COMPUTED OVER THE
!            FREQUENCY RANGE 0-560, 1200-2200 CM-1. (E1CTS2-E1CTW2) IS ALSO USED IN OBTAINING THE 
!            FLUX AT THE TOP IN THE 0-160, 1200-2200 CM-1 RANGE.
! E1FLX   =  E1 FCTN. FOR THE ITH LEVEL,USING THE TEMPERATURE AT THE TOP OF THE ATMOSPHERE. 
!            COMPUTED OVER THE FREQUENCY RANGE 0-560, 1200-2200 CM-1. USED FOR Q(APPROX) TERM. 
!            (IN COMMON BLOCK TFCOM)
! E1CTW1  =  LIKE E1CTS1, BUT COMPUTED OVER THE 160-560 CM-1 RANGE AND USED FOR 
!            Q(APPROX,CTS) CALCULATION
! E1CTW2  =  LIKE E1CTS2, BUT COMPUTED OVER THE 160-560 CM-1 RANGE AND USED FOR 
!            Q(APPROX,CTS) CALCULATION
! FXO     =  TEMPERATURE INDEX USED FOR E1 FUNCTION AND ALSO USED FOR SOURCE FUNCTION CALC. 
!            IN FST88
! DT      =  TEMP. DIFF.BETWEEN MODEL TEMPS. AND TEMPS. AT TABULAR VALUES OF E1 AND SOURCE FCTNS.
!            USED IN FST88 AND IN E1 FUNCTION CALC.
! FXOE2   =  TEMPERATURE INDEX USED FOR E2 FUNCTION
! DTE2    =  TEMP. DIFF. BETWEEN MODEL TEMP. AND TEMPS. AT TABULAR VALUES OF E2 FUNCTION.
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE RNDDTA
    USE TABCOM
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!---------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS;
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!---------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!--------------------------------------------------------------------------------------------------
! COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE TABLE FOR USE IN THE LONGWAVE
! RADIATION PROGRAM:
! EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL
! TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  =  MASS DERIVATIVE OF TABLE1
! EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS
! DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
! IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88
! KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88
! KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & NCLDS 
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & ITOP    , IBOT    , INDTC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & EMX1    , EMX2 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & GXCTS   , FLX1E1  , DELPTC  , PTOP    , PBOT    , FTOP    , FBOT    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(INOUT)       ::&
    & GRNFLX  , TOPFLX 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, 2)                                             ::&
    & EMSPEC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(INOUT)       ::&
    & HEATRA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(IN)          ::&
    & CO2NBL  , VAR1    , VAR2    , VAR3    , VAR4     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                                             ::&
    & TO3SPC  , CTS     , EXCTS   , CTSO3       
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(IN)          ::&
    & DELP    , DELP2   
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & KTOP    , KBTM     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & QH2O    , PRESS   , P       , TEMP    , T       ,  CAMT   , CO2SP1  , CO2SP2  ,             &
    & CNTVAL  , TOTO3   , TPHIO3  , TOTPHI  , TOTVO2      
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & AVEPHI  , EMISS   , EMISSB  , AVPHO3  , TO31D   , CONT1D  , AVMO3   ,  OVER1D  ,            &
    & E1FLX   , CO2SP   , TO3SP   , OSS     , CSS     , SS1     , SS2     , TC       ,            &
    & DTC     , CSOUR   , AVVO2   , HEATEM
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                    , INTENT(IN)          ::&
    & EMPL    
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & C       , C2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                , INTENT(IN)          ::&
    & CLDFAC   
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                , INTENT(INOUT)       ::&
    & CO21
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, NBLY)                                     ::&
    & SORC
!------------------------------------------------------ 
! DIMENSION OF VARIABLES EQUIVALENCED TO THOSE IN VTEMP
!------------------------------------------------------
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & IXO
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & VTMP3   , DSORC   , FAC1    , DELPR1  , DELPR2  , EMISDG  , CONTDG  , TO3DG   ,             &
    & FLXNET  , VSUM1   , FLXTHK  , Z1             
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & ALP     , CSUB    , CSUB2
!------------------------------------------------------------------------------------ 
! DIMENSION OF VARIABLES PASSED TO OTHER SUBROUTINES (AND NOT FOUND IN COMMON BLOCKS)
!------------------------------------------------------------------------------------ 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                                             ::&
    & E1CTS2  , E1CTW2
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & E1CTS1  , E1CTW1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & EMD     , TPL
!-------------------------------------------------------------------------------------------------- 
! IT IS POSSIBLE TO EQUIVALENCE EMD,TPL TO THE ABOVE VARIABLES, AS THEY GET CALLED AT DIFFERENT 
! TIMES
!-------------------------------------------------------------------------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2,LP1)                                            ::&
    & FXO     , DT      , FXOE2   , DTE2                                
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2,2)                                              ::&
    & FXOSP   , DTSP
!----------------------------- 
! DIMENSION OF LOCAL VARIABLES
!----------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2,L)                                              ::&
    & RLOG
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2,LP1)                                            ::&
    & FLX     , TOTEVV  , CNTTAU
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K       , KP      , KLEN    , KK      , ICNT    , KCLDS   , KMIN    , KMAX    ,   &
    & J1      , J3   
!
    EQUIVALENCE (ALP,C,CSUB), (CSUB2,C2)
    EQUIVALENCE (FAC1, DSORC, OVER1D, DELPR2, FLXNET)
    EQUIVALENCE (DELPR1, HEATEM)
    EQUIVALENCE (IXO, AVVO2, FLXTHK, TO3DG)
    EQUIVALENCE (Z1, AVMO3, CONTDG)
    EQUIVALENCE (EMISDG, VSUM1, AVPHO3)
    EQUIVALENCE (EMD(IDIM1,1), E1CTS1(IDIM1,1)), (EMD(IDIM1,LP2), E1CTS2(IDIM1,1))
    EQUIVALENCE (TPL(IDIM1,1), E1CTW1(IDIM1,1)), (TPL(IDIM1,LP2), E1CTW2(IDIM1,1))
!------------------------------------------------------------------------------- 
! FIRST SECTION IS TABLE LOOKUP FOR SOURCE FUNCTION AND DERIVATIVE (B AND DB/DT)
! ALSO,THE NLTE CO2 SOURCE FUNCTION IS OBTAINED
!
! IN CALCS. BELOW, DECREMENTING THE INDEX BY 9 
! ACCOUNTS FOR THE TABLES BEGINNING AT T=100K.
! AT T=100K.
!------------------------------------------------------------------------------- 
    DO 101 K=1,LP1
        DO 101 I=MYIS,MYIE
!-----------------------------  
! TEMP. INDICES FOR E1, SOURCE
!-----------------------------  
            VTMP3(I,K) = AINT(TEMP(I,K) * HP1)
              FXO(I,K) =     VTMP3(I,K) - 9.
               DT(I,K) =      TEMP(I,K) - TEN * VTMP3(I,K)
!--------------------------------------------  
! INTEGER INDEX FOR SOURCE (USED IMMEDIATELY)
!-------------------------------------------- 
            IXO(I,K) = FXO(I,K)
101 END DO
!
    DO 103 k=1,L
        DO 103 I=MYIS,MYIE
!----------------------------------------------------------------  
! TEMP. INDICES FOR E2 (KP=1 LAYER NOT USED IN FLUX CALCULATIONS)
!---------------------------------------------------------------- 
            VTMP3(I,K) = AINT(T(I,K+1) * HP1)
            FXOE2(I,K) =  VTMP3(I,K)   - 9.
             DTE2(I,K) =      T(I,K+1) - TEN * VTMP3(I,K)
103 END DO
!----------------------------------------------------------  
! SPECIAL CASE TO HANDLE KP=LP1 LAYER AND SPECIAL E2 CALCS.
!---------------------------------------------------------- 
    DO 105 I=MYIS,MYIE
        FXOE2(I,LP1) =   FXO(I,L)
         DTE2(I,LP1) =    DT(I,L)
        FXOSP(I,1)   = FXOE2(I,LM1)
        FXOSP(I,2)   =   FXO(I,LM1)
         DTSP(I,1)   =  DTE2(I,LM1)
         DTSP(I,2)   =    DT(I,LM1)
105 END DO
!------------------------------------ 
! SOURCE FUNCTION FOR COMBINED BAND 1
!------------------------------------  
    DO 411 I=MYIS,MYIE
        DO 411 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),1)
            DSORC(I,K) =  DSRCE(IXO(I,K),1)
411 END DO
!
    DO 412 K=1,LP1
        DO 412 I=MYIS,MYIE
            SORC(I,K,1)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
412 END DO
!------------------------------------  
! SOURCE FUNCTION FOR COMBINED BAND 2
!------------------------------------ 
    DO 421 I=MYIS,MYIE
        DO 421 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),2)
            DSORC(I,K) =  DSRCE(IXO(I,K),2)
421 END DO
!
    DO 212 K=1,LP1
        DO 212 I=MYIS,MYIE
            SORC(I,K,2)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
212 END DO
!------------------------------------  
! SOURCE FUNCTION FOR COMBINED BAND 3
!------------------------------------  
    DO 314 I=MYIS,MYIE
        DO 314 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),3)
            DSORC(I,K) =  DSRCE(IXO(I,K),3)
314 END DO
!
    DO 312 K=1,LP1
        DO 312 I=MYIS,MYIE
            SORC(I,K,3)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
312 END DO
!------------------------------------ 
! SOURCE FUNCTION FOR COMBINED BAND 4
!------------------------------------ 
    DO 444 I=MYIS,MYIE
        DO 444 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),4)
            DSORC(I,K) =  DSRCE(IXO(I,K),4)
444 END DO
!
    DO 442 K=1,LP1
        DO 442 I=MYIS,MYIE
            SORC(I,K,4)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
442 END DO
!------------------------------------  
! SOURCE FUNCTION FOR COMBINED BAND 5
!------------------------------------ 
    DO 514 I=MYIS,MYIE
        DO 514 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),5)
            DSORC(I,K) =  DSRCE(IXO(I,K),5)
514 END DO
!
    DO 512 K=1,LP1
        DO 512 I=MYIS,MYIE
            SORC(I,K,5)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
512 END DO
!------------------------------------  
! SOURCE FUNCTION FOR COMBINED BAND 6
!------------------------------------  
    DO 614 I=MYIS,MYIE
        DO 614 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),6)
            DSORC(I,K) =  DSRCE(IXO(I,K),6)
614 END DO
!
    DO 612 K=1,LP1
        DO 612 I=MYIS,MYIE
            SORC(I,K,6)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
612 END DO
!------------------------------------
! SOURCE FUNCTION FOR COMBINED BAND 7
!------------------------------------
    DO 714 I=MYIS,MYIE
        DO 714 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),7)
            DSORC(I,K) =  DSRCE(IXO(I,K),7)
714 END DO
!
    DO 712 K=1,LP1
        DO 712 I=MYIS,MYIE
            SORC(I,K,7)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
712 END DO
!------------------------------------
! SOURCE FUNCTION FOR COMBINED BAND 8
!------------------------------------
    DO 814 I=MYIS,MYIE
        DO 814 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),8)
            DSORC(I,K) =  DSRCE(IXO(I,K),8)
    814 END DO
!
    DO 812 K=1,LP1
        DO 812 I=MYIS,MYIE
            SORC(I,K,8)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
812 END DO
!------------------------------------------
! SOURCE FUNCTION FOR BAND 9 (560-670 CM-1)
!------------------------------------------
    DO 914 I=MYIS,MYIE
        DO 914 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),9)
            DSORC(I,K) =  DSRCE(IXO(I,K),9)
914 END DO
!
    DO 912 K=1,LP1
        DO 912 I=MYIS,MYIE
            SORC(I,K,9)  = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
912 END DO
!-------------------------------------------
! SOURCE FUNCTION FOR BAND 10 (670-800 CM-1)
!-------------------------------------------
    DO 518 I=MYIS,MYIE
        DO 518 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),10)
            DSORC(I,K) =  DSRCE(IXO(I,K),10)
518 END DO
!
    DO 516 K=1,LP1
        DO 516 I=MYIS,MYIE
            SORC(I,K,10) = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
516 END DO
!-------------------------------------------
! SOURCE FUNCTION FOR BAND 11 (800-900 CM-1)
!-------------------------------------------
    DO 628 I=MYIS,MYIE
        DO 628 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),11)
            DSORC(I,K) =  DSRCE(IXO(I,K),11)
628 END DO
!
    DO 626 K=1,LP1
        DO 626 I=MYIS,MYIE
            SORC(I,K,11) = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
626 END DO
!-------------------------------------------
! SOURCE FUNCTION FOR BAND 12 (900-990 CM-1)
!-------------------------------------------
    DO 528 I=MYIS,MYIE
        DO 528 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),12)
            DSORC(I,K) =  DSRCE(IXO(I,K),12)
    528 END DO
!
    DO 526 K=1,LP1
        DO 526 I=MYIS,MYIE
            SORC(I,K,12) = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
    526 END DO
!--------------------------------------------
! SOURCE FUNCTION FOR BAND 13 (990-1070 CM-1)
!--------------------------------------------
    DO 428 I=MYIS,MYIE
        DO 428 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),13)
            DSORC(I,K) =  DSRCE(IXO(I,K),13)
    428 END DO
!
    DO 426 K=1,LP1
        DO 426 I=MYIS,MYIE
            SORC(I,K,13) = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
426 END DO
!---------------------------------------------
! SOURCE FUNCTION FOR BAND 14 (1070-1200 CM-1)
!---------------------------------------------
    DO 328 I=MYIS,MYIE
        DO 328 K=1,LP1
            VTMP3(I,K) = SOURCE(IXO(I,K),14)
            DSORC(I,K) =  DSRCE(IXO(I,K),14)
328 END DO
!
    DO 326 K=1,LP1
        DO 326 I=MYIS,MYIE
            SORC(I,K,14) = VTMP3(I,K) + DT(I,K) * DSORC(I,K)
326 END DO
!---------------------------------------------------------------------------------------
! THE FOLLOWING SUBROUTINE OBTAINS NLTE SOURCE FUNCTION FOR CO2
!
! CALL NLTE
!
! OBTAIN SPECIAL SOURCE FUNCTIONS FOR THE 15 UM BAND (CSOUR) AND THE WINDOW REGION (SS1)
!---------------------------------------------------------------------------------------
    DO 131 K=1,LP1
        DO 131 I=MYIS,MYIE
            SS1(I,K) = SORC(I,K,11) + SORC(I,K,12) + SORC(I,K,14)
131 END DO
!
    DO 143 K=1,LP1
        DO 143 I=MYIS,MYIE
            CSOUR(I,K) = SORC(I,K,9) + SORC(I,K,10)
143 END DO
!--------------------------------------------------------------------------- 
! COMPUTE TEMP 4 (TC) AND VERTICAL TEMPERATURE DIFFERENCES (OSS,CSS,SS2,DTC) 
! ALL THESE WILL BE USED LATER IN FLUX COMPUTATIONS.
!---------------------------------------------------------------------------
    DO 901 K=1,LP1
        DO 901 I=MYIS,MYIE
            TC(I,K) = (TEMP(I,K)*TEMP(I,K)) ** 2
901 END DO
!
    DO 903 K=1,L
        DO 903 I=MYIS,MYIE
            OSS(I,K+1) =  SORC(I,K+1,13) -  SORC(I,K,13)
            CSS(I,K+1) = CSOUR(I,K+1)    - CSOUR(I,K)
            DTC(I,K+1) =    TC(I,K+1)    -    TC(I,K)
            SS2(I,K+1) =   SS1(I,K+1)    -   SS1(I,K)
903 END DO
!--------------------------------------------------------------------------------------------------
! THE FOLLOWIMG IS A DRASTIC REWRITE OF THE RADIATION CODE TO (LARGELY) ELIMINATE THREE-DIMENSIONAL
! ARRAYS.
! THE CODE WORKS ON THE FOLLOWING PRINCIPLES:
!
! LET K = FIXED FLUX LEVEL,
!    KP = VARYING FLUX LEVELTHEN FLUX(K)=SUM OVER KP: (DELTAB(KP)*TAU(KP,K)) OVER ALL KPS, FROM 1 
!         TO LP1.
!
! WE CAN BREAK DOWN THE CALCULATIONS FOR ALL KS AS FOLLOWS:
!
! FOR ALL KS K=1 TO LP1:
! FLUX(K)=SUM OVER KP: (DELTAB(KP)*TAU(KP,K))
! (1) OVER ALL KPS, FROM K+1 TO LP1 AND FOR KP FROM K+1 TO LP1: FLUX(KP) = DELTAB(K)*TAU(K,KP)              
! (2) NOW IF TAU(K,KP)=TAU(KP,K) (SYMMETRICAL ARRAYS)
!      WE CAN COMPUTE A 1-DIMENSIONAL ARRAY TAU1D(KP) FROM K+1 TO LP1, EACH TIME K IS INCREMENTED.
! EQUATIONS (1) AND (2) THEN BECOME:
!
! TAU1D(KP) = (VALUES FOR TAU(KP,K) AT THE PARTICULAR K)
! FLUX(K) = SUM OVER KP : (DELTAB(KP)*TAU1D(KP))   (3)
! FLUX(KP) = DELTAB(K)*TAU1D(KP)                   (4)
!
! THE TERMS FOR TAU (K,K) AND OTHER SPECIAL TERMS (FOR NEARBY LAYERS) MUST, OF COURSE, BE HANDLED
! SEPARATELY, AND WITH CARE.
!
! COMPUTE "UPPER TRIANGLE" TRANSMISSION FUNCTIONS FOR THE 9.6 UM BAND (TO3SP) AND THE 15 UM BAND 
! (OVER1D). ALSO, THE STAGE 1...COMPUTE O3 ,OVER TRANSMISSION FCTNS AND AVEPHI
!
! DO K=1 CALCULATION (FROM FLUX LAYER KK TO THE TOP) SEPARATELY AS VECTORIZATION IS IMPROVED,AND 
! OZONE CTS TRANSMISSIVITY MAY BE EXTRACTED HERE.
!--------------------------------------------------------------------------------------------------
    DO 121 K=1,L
        DO 121 I=MYIS,MYIE
            AVEPHI(I,K) = TOTPHI(I,K+1)
121 END DO
!--------------------------------------------------------------------------------------------------
! IN ORDER TO PROPERLY EVALUATE EMISS INTEGRATED OVER THE (LP1) LAYER, A SPECIAL EVALUATION OF 
! EMISS IS DONE THIS REQUIRES A SPECIAL COMPUTATION OF AVEPHI, AND IT IS STORED IN THE 
! (OTHERWISE VACANT) LP1TH POSITION
!--------------------------------------------------------------------------------------------------
    DO 803 I=MYIS,MYIE
        AVEPHI(I,LP1) = AVEPHI(I,LM1) + EMX1(I)
803 END DO
!----------------------- 
! COMPUTE FLUXES FOR K=1
!----------------------- 
    CALL E1E290(E1CTS1, E1CTS2, E1FLX , E1CTW1, E1CTW2, EMISS, FXO, DT,                           &
    &           FXOE2 , DTE2  , AVEPHI, TEMP  , T)
!
    DO 302 K=1,L
        DO 302 I=MYIS,MYIE
              FAC1(I,K) = BO3RND(2)       * TPHIO3(I,K+1) / TOTO3(I,K+1)
            TO3SPC(I,K) = HAF*(FAC1(I,K)  * (SQRT(ONE + (FOUR * AO3RND(2) * TOTO3(I,K+1))         &
    &                   /      FAC1(I,K)) - ONE))
!--------------------------------------------------------------------------------------------------
! FOR K=1, TO3SP IS USED INSTEAD OF TO31D (THEY ARE EQUAL IN THIS CASE); TO3SP IS PASSED TO SPA90, 
! WHILE TO31D IS A WORK-ARRAY.
!--------------------------------------------------------------------------------------------------
             TO3SP(I,K) = EXP(HM1EZ * (            TO3SPC(I,K)    + SKO3R * TOTVO2(I,K+1)))
            OVER1D(I,K) = EXP(HM1EZ * (SQRT(AB15WD*TOTPHI(I,K+1)) + SKC1R * TOTVO2(I,K+1)))
!--------------------------------------------------------------------------------------------------
! BECAUSE ALL CONTINUUM TRANSMISSIVITIES ARE OBTAINED FROM THE 2-D QUANTITY CNTTAU 
! (AND ITS RECIPROCAL TOTEVV) WE STORE BOTH OF THESE HERE. FOR K=1, CONT1D EQUALS CNTTAU
!--------------------------------------------------------------------------------------------------
            CNTTAU(I,K) = EXP(HM1EZ * TOTVO2(I,K+1))
            TOTEVV(I,K) = 1. / CNTTAU(I,K)
302 END DO
!
    DO 722 K=1,L
        DO 722 I=MYIS,MYIE
            CO2SP(I,K+1)  = OVER1D(I,K)     *   CO21(I,1,K+1)
722 END DO
!
    DO 723 K=1,L
        DO 723 I=MYIS,MYIE
            CO21(I,K+1,1) =   CO21(I,K+1,1) * OVER1D(I,K)
723 END DO
!------------------------------------------------------ 
! RLOG IS THE NBL AMOUNT FOR THE 15 UM BAND CALCULATION
!------------------------------------------------------ 
    DO 724 I=MYIS,MYIE
        RLOG(I,1) = OVER1D(I,1) * CO2NBL(I,1)
724 END DO
!-------------------------------------------------------------------------------------------------- 
! THE TERMS WHEN KP=1 FOR ALL K ARE THE PHOTON EXCHANGE WITH THE TOP OF THE ATMOSPHERE, AND ARE 
! OBTAINED DIFFERENTLY THAN THE  OTHER CALCULATIONS
!--------------------------------------------------------------------------------------------------
    DO 305 K=2,LP1
        DO 305 I=MYIS,MYIE
            FLX(I,K) = (TC(I,1) * E1FLX(I,K)   +   SS1(I,1) * CNTTAU(I,K-1)  +   SORC(I,1,13)     &
    &                *            TO3SP(I,K-1) + CSOUR(I,1) *  CO2SP(I,K))   * CLDFAC(I,1,K)
305 END DO
!
    DO 307 I=MYIS,MYIE
        FLX(I,1)     =  TC(I,1) * E1FLX(I,1)   +   SS1(I,1) +   SORC(I,1,13) + CSOUR(I,1)
307 END DO
!------------------------ 
! THE KP TERMS FOR K=1...
!------------------------ 
    DO 303 KP=2,LP1
        DO 303 I=MYIS,MYIE
            FLX(I,1) = FLX(I,1)  + (OSS(I,KP)   * TO3SP(I,KP-1) +   SS2(I,KP)    * CNTTAU(I,KP-1) &
    &                + CSS(I,KP) * CO21(I,KP,1) +   DTC(I,KP)   * EMISS(I,KP-1)) * CLDFAC(I,KP,1)
303 END DO
!-------------------------------------------------------------------------------------------------- 
! SUBROUTINE SPA88 IS CALLED TO OBTAIN EXACT CTS FOR WATER CO2 AND O3, AND APPROXIMATE CTS CO2 AND
! O3 CALCULATIONS.
!--------------------------------------------------------------------------------------------------
    CALL SPA88(EXCTS, CTSO3 , GXCTS, SORC  , CSOUR , CLDFAC, TEMP, PRESS, VAR1, VAR2, P, DELP,    &
    &          DELP2, TOTVO2, TO3SP, TO3SPC, CO2SP1, CO2SP2, CO2SP)
!-------------------------------------------------------------------------------------------------- 
! THIS SECTION COMPUTES THE EMISSIVITY CTS HEATING RATES FOR 2 EMISSIVITY BANDS: THE 0-160,
! 1200 -2200 CM-1 BAND AND THE 800-990, 1070-1200 CM-1 BAND. 
! THE REMAINING CTS COMTRIBUTIONS ARE CONTAINED IN CTSO3, COMPUTED IN SPA88.
!--------------------------------------------------------------------------------------------------
    DO 998 I=MYIS,MYIE
        VTMP3(I,1) = 1.
998 END DO
!
    DO 999 K=1,L
        DO 999 I=MYIS,MYIE
            VTMP3(I,K+1) = CNTTAU(I,K) * CLDFAC(I,K+1,1)
999 END DO
!
    DO 997 K=1,L
        DO 997 I=MYIS,MYIE
              CTS(I,K)   = RADCON * DELP(I,K) * (TC(I,K) * (E1CTW2(I,K)   * CLDFAC(I,K+1,1)       &
    &                    -                                  E1CTW1(I,K)   * CLDFAC(I,K,1))        &
    &                    +                      SS1(I,K) *  (VTMP3(I,K+1) -  VTMP3(I,K)))
997 END DO
!
    DO 996 K=1,L
        DO 996 I=MYIS,MYIE
            VTMP3(I,K)   = TC(I,K)   * (CLDFAC(I,K,1)   * (E1CTS1(I,K) -   E1CTW1(I,K))           &
    &                    -              CLDFAC(I,K+1,1) * (E1CTS2(I,K) -   E1CTW2(I,K)))
996 END DO
!
    DO 995 I=MYIS,MYIE
        FLX1E1(I)        = TC(I,LP1) *  CLDFAC(I,LP1,1) * (E1CTS1(I,LP1) - E1CTW1(I,LP1))
995 END DO
!
    DO 994 K=1,L
        DO 993 I=MYIS,MYIE
            FLX1E1(I)    = FLX1E1(I) + VTMP3(I,K)
    993 END DO
994 END DO
!--------------------------------------------------------------------------------------------------
! NOW REPEAT FLUX CALCULATIONS FOR THE K=2...LM1 CASES.
! CALCULATIONS FOR FLUX LEVEL L AND LP1 ARE DONE SEPARATELY, AS ALL EMISSIVITY AND CO2 CALCULATIONS
! ARE SPECIAL CASES OR NEARBY LAYERS.
!--------------------------------------------------------------------------------------------------
    DO 321 K=2,LM1
        KLEN = K
!    
        DO 3218 KK=1,LP1-K
            DO 3218 I=MYIS,MYIE
                AVEPHI(I,KK+K-1) = TOTPHI(I,KK+K) - TOTPHI(I,K)
   3218 END DO
!
        DO 1803 I=MYIS,MYIE
            AVEPHI(I,LP1)        = AVEPHI(I,LM1)  + EMX1(I)
   1803 END DO
!--------------------------------------------------------------------------------------------------
! COMPUTE EMISSIVITY FLUXES (E2) FOR THIS CASE. NOTE THAT WE HAVE OMITTED THE NEARBY LATER CASE 
! (EMISS(I,K,K)) AS WELL AS ALL CASES WITH K=L OR LP1.
! BUT THESE CASES HAVE ALWAYS BEEN HANDLED AS SPECIAL CASES, SO WE MAY AS WELL COMPUTE THEIR FLUXES 
! SEPARASTELY.
!--------------------------------------------------------------------------------------------------   
        CALL E290(EMISSB, EMISS, AVEPHI, KLEN, FXOE2, DTE2)
!
        DO 322 KK=1,LP1-K
            DO 322 I=MYIS,MYIE
                 AVMO3(I,KK+K-1) =  TOTO3(I,KK+K)   -  TOTO3(I,K)
                AVPHO3(I,KK+K-1) = TPHIO3(I,KK+K)   - TPHIO3(I,K)
                 AVVO2(I,KK+K-1) = TOTVO2(I,KK+K)   - TOTVO2(I,K)
                CONT1D(I,KK+K-1) = CNTTAU(I,KK+K-1) * TOTEVV(I,K-1)
    322 END DO
!    
        DO 3221 KK=1,LP1-K
            DO 3221 I=MYIS,MYIE
                  FAC1(I,K+KK-1) = BO3RND(2) * AVPHO3(I,K+KK-1)  / AVMO3(I,K+KK-1)
                 VTMP3(I,K+KK-1) = HAF * (FAC1(I,K+KK-1)                                          &
    &                            * (SQRT(ONE + (FOUR * AO3RND(2) * AVMO3(I,K+KK-1))               &
    &                            /  FAC1(I,K+KK-1)) - ONE))
!
                 TO31D(I,K+KK-1) = EXP(HM1EZ * (VTMP3(I,K+KK-1) + SKO3R * AVVO2(I,K+KK-1)))
                OVER1D(I,K+KK-1) = EXP(HM1EZ * (            SQRT(AB15WD * AVEPHI(I,K+KK-1))       &
    &                            +                                SKC1R * AVVO2(I,K+KK-1)))
!
                  CO21(I,K+KK,K) = OVER1D(I,K+KK-1) * CO21(I,K+KK,K)
   3221 END DO
!
        DO 3223 KP=K+1,LP1
            DO 3223 I=MYIS,MYIE
                CO21(I,K,KP) = OVER1D(I,KP-1) * CO21(I,K,KP)
   3223 END DO
!------------------------------------------------------ 
! RLOG IS THE NBL AMOUNT FOR THE 15 UM BAND CALCULATION
!------------------------------------------------------ 
        DO 1804 I=MYIS,MYIE
            RLOG(I,K) = OVER1D(I,K) * CO2NBL(I,K)
   1804 END DO
!-------------------------------- 
! THE KP TERMS FOR ARBIRRARY K...
!-------------------------------- 
        DO 3423 KP=K+1,LP1
            DO 3423 I=MYIS,MYIE
                FLX(I,K) =   FLX(I,K) + (OSS(I,KP) *  TO31D(I,KP-1)                               &
    &                    +               SS2(I,KP) * CONT1D(I,KP-1)                               &
    &                    +               CSS(I,KP) *   CO21(I,KP,K)                               &
    &                    +               DTC(I,KP) *  EMISS(I,KP-1))                              &
    &                    *                           CLDFAC(I,KP,K)
   3423 END DO
!
        DO 3425 KP=K+1,LP1
            DO 3425 I=MYIS,MYIE
                FLX(I,KP) = FLX(I,KP) + (OSS(I,K)    *  TO31D(I,KP-1)                             &
    &                     +              SS2(I,K)    * CONT1D(I,KP-1)                             &
    &                     +              CSS(I,K)    *   CO21(I,K,KP)                             &
    &                     +              DTC(I,K)    * EMISSB(I,KP-1))                            &
    &                     *                            CLDFAC(I,K,KP)
   3425 END DO
!
321 END DO
!--------------------------------------------------------------------------------------------------
! NOW DO K=L CASE. SINCE THE KP LOOP IS LENGTH 1, MANY SIMPLIFICATIONS OCCUR.
! ALSO, THE CO2 QUANTITIES (AS WELL AS THE EMISS QUANTITIES) ARE COMPUTED IN THE NBL SEDCTION; 
! THEREFORE, WE WANT ONLY OVER, TO3 AND CONT1D (OVER(I,L),TO31D(I,L) AND CONT1D(I,L) ACCORDING TO 
! THE NOTATION. THUS NO CALL IS MADE TO THE E290 SUBROUTINE.
! THE THIRD SECTION CALCULATES BOUNDARY LAYER AND NEARBY LAYER CORRECTIONS TO THE TRANSMISSION 
! FUNCTIONS OBTAINED ABOVE. METHODS ARE GIVEN IN REF. (4). 
! THE FOLLOWING RATIOS ARE USED IN VARIOUS NBL CALCULATIONS:
!
! THE REMAINING CALCULATIONS ARE FOR :
! 1) THE (K,K) TERMS, K=2,LM1;
! 2) THE (L,L) TERM
! 3) THE (L,LP1) TERM
! 4) THE (LP1,L) TERM
! 5) THE (LP1,LP1) TERM.
! EACH IS UNIQUELY HANDLED; DIFFERENT FLUX TERMS ARE COMPUTED DIFFERENTLY
!
! FOURTH SECTION OBTAINS WATER TRANSMISSION FUNCTIONS USED IN Q(APPROX) CALCULATIONS AND ALSO 
! MAKES NBL CORRECTIONS:
! 1) EMISS (I,J) IS THE TRANSMISSION FUNCTION MATRIX OBTAINED BY CALLING SUBROUTINE E1E288;
! 2) "NEARBY LAYER" CORRECTIONS (EMISS(I,I)) ARE OBTAINED USING SUBROUTINE E3V88;
! 3) SPECIAL VALUES AT THE SURFACE (EMISS(L,LP1),EMISS(LP1,L), EMISS(LP1,LP1)) ARE CALCULATED.
!
! OBTAIN ARGUMENTS FOR E1E288 AND E3V88:
!--------------------------------------------------------------------------------------------------
    DO 821 I=MYIS,MYIE
        TPL(I,1)    =                   TEMP(I,L)
        TPL(I,LP1)  = HAF * (T(I,LP1) + TEMP(I,L))
        TPL(I,LLP1) = HAF * (T(I,L)   + TEMP(I,L))
821 END DO
!
    DO 823 K=2,L
        DO 823 I=MYIS,MYIE
            TPL(I,K)   = T(I,K)
            TPL(I,K+L) = T(I,K)
823 END DO
!--------------------------------------------------------------------------------------------------
! E2 FUNCTIONS ARE REQUIRED IN THE NBL CALCULATIONS FOR 2 CASES, DENOTED (IN OLD CODE) AS (L,LP1) 
! AND (LP1,LP1)
!--------------------------------------------------------------------------------------------------
    DO 833 I=MYIS,MYIE
        AVEPHI(I,1) = VAR2(I,L)
        AVEPHI(I,2) = VAR2(I,L) + EMPL(I,L)
833 END DO
!
    CALL E2SPEC(EMISS, AVEPHI, FXOSP, DTSP)
!---------------------------------------- 
! CALL E3V88 FOR NBL H2O TRANSMISSIVITIES
!---------------------------------------- 
    CALL E3V88(EMD, TPL, EMPL)
!-------------------------------------------------------------------------------------------------- 
! COMPUTE NEARBY LAYER AND SPECIAL-CASE TRANSMISSIVITIES FOR EMISS USING METHODS FOR H2O GIVEN IN
! REF. (4)
!--------------------------------------------------------------------------------------------------
    DO 851 K=2,L
        DO 851 I=MYIS,MYIE
            EMISDG(I,K) = EMD(I,K+L) + EMD(I,K)
851 END DO
!-------------------------------------------------------------------  
! NOTE THAT EMX1/2 (PRESSURE SCALED PATHS) ARE NOW COMPUTED IN LWR88
!-------------------------------------------------------------------  
    DO 861 I=MYIS,MYIE
        EMSPEC(I,1)   = (EMD(I,1)   * EMPL(I,1)                                                   &
    &                 -  EMD(I,LP1) * EMPL(I,LP1))                                                &
    &                 / EMX1(I)                                                                   &
    &                 + QUARTR      * (EMISS(I,1) + EMISS(I,2))
!
        EMISDG(I,LP1) = TWO *  EMD(I,LP1)
        EMSPEC(I,2)   = TWO * (EMD(I,1)    * EMPL(I,1)                                            &
    &                 -        EMD(I,LLP1) * EMPL(I,LLP1))                                        &
    &                 / EMX2(I)
861 END DO
!
    DO 331 I=MYIS,MYIE
          FAC1(I,L) = BO3RND(2) * VAR4(I,L) / VAR3(I,L)
         VTMP3(I,L) = HAF * (FAC1(I,L)                                                            &
    &               * (SQRT(ONE + (FOUR * AO3RND(2) * VAR3(I,L)) / FAC1(I,L)) - ONE))
!
         TO31D(I,L) = EXP(HM1EZ   * (              VTMP3(I,L)  + SKO3R * CNTVAL(I,L)))
        OVER1D(I,L) = EXP(HM1EZ   * (SQRT(AB15WD *  VAR2(I,L)) + SKC1R * CNTVAL(I,L)))
        CONT1D(I,L) = CNTTAU(I,L) * TOTEVV(I,LM1)
          RLOG(I,L) = OVER1D(I,L) * CO2NBL(I,L)
331 END DO
!
    DO 618 K=1,L
        DO 618 I=MYIS,MYIE
            RLOG(I,K) = LOG(RLOG(I,K))
618 END DO
!
    DO 601 K=1,LM1
        DO 601 I=MYIS,MYIE
            DELPR1(I,K+1)     =         DELP(I,K+1)  * (PRESS(I,K+1) -     P(I,K+1))
               ALP(I,LP1+K-1) = -SQRT(DELPR1(I,K+1)) *   RLOG(I,K+1)
601 END DO
!
    DO 603 K=1,L
        DO 603 I=MYIS,MYIE
            DELPR2(I,K+1) = DELP(I,K) * (P(I,K+1)  - PRESS(I,K))
               ALP(I,K)   =   -SQRT(DELPR2(I,K+1)) *  RLOG(I,K)
603 END DO
!
    DO 625 I=MYIS,MYIE
        ALP(I,LL)   = -RLOG(I,L)
        ALP(I,LLP1) = -RLOG(I,L) * SQRT(DELP(I,L)    *     (P(I,LP1) - PRESS(I,LM1)))
625 END DO
!--------------------------------------------------------------------------------------------------
! THE FIRST COMPUTATION IS FOR THE 15 UM BAND,WITH THE FOR THE COMBINED H2O AND CO2 TRANSMISSION
! FUNCTION.
! 
! PERFORM NBL COMPUTATIONS FOR THE 15 UM BAND THE STATEMENT FUNCTION SF IN PREV. VERSIONS IS NOW 
! EXPLICITLY EVALUATED.
!-------------------------------------------------------------------------------------------------- 
    DO 631 K=1,LLP1
        DO 631 I=MYIS,MYIE
            C(I,K) = ALP(I,K) * (HMP66667 + ALP(I,K) * (QUARTR+ALP(I,K) * HM6666M2))
631 END DO
!
    DO 641 I=MYIS,MYIE
        CO21(I,LP1,LP1) = ONE + C(I,L)
        CO21(I,LP1,L)   = ONE + (DELP2(I,L)   *     C(I,LL)    - (PRESS(I,L)                      &
    &                   -            P(I,L))  *     C(I,LLM1))                                    &
    &                   /           (P(I,LP1) - PRESS(I,L))
!
        CO21(I,L,LP1)   = ONE + ((P(I,LP1) - PRESS(I,LM1)) * C(I,LLP1)                            &
    &                   -        (P(I,LP1) - PRESS(I,L))   * C(I,L))                              &
    &                   /    (PRESS(I,L)   - PRESS(I,LM1))
641 END DO
!
    DO 643 K=2,L
        DO 643 I=MYIS,MYIE
            CO21(I,K,K) = ONE + HAF * (C(I,LM1+K) + C(I,K-1))
643 END DO
!-------------------------------------------------------------------------------------------------- 
! COMPUTE NEARBY-LAYER TRANSMISSIVITIES FOR THE O3 BAND AND FOR THE ONE-BAND CONTINUUM BAND 
! (TO3 AND EMISS2). 
! THE SF2 FUNCTION IS USED. THE METHOD IS THE SAME AS DESCRIBED FOR CO2 IN REF (4).
!--------------------------------------------------------------------------------------------------
    DO 651 K=1,LM1
        DO 651 I=MYIS,MYIE
            CSUB(I,K+1)     = CNTVAL(I,K+1) * DELPR1(I,K+1)
            CSUB(I,LP1+K-1) = CNTVAL(I,K)   * DELPR2(I,K+1)
651 END DO
!---------------------------------------------------------------  
! THE SF2 FUNCTION IN PREV. VERSIONS IS NOW EXPLICITLY EVALUATED
!---------------------------------------------------------------  
    DO 655 K=1,LLM2
        DO 655 I=MYIS,MYIE
            CSUB2(I,K+1) = SKO3R       *  CSUB(I,K+1)
                C(I,K+1) = CSUB(I,K+1) * (HMP5        + CSUB(I,K+1)                               &
    &                    * (HP166666   -  CSUB(I,K+1) * H41666M2))
!
               C2(I,K+1) = CSUB2(I,K+1) * (HMP5       + CSUB2(I,K+1)                              &
    &                    * (HP166666   - CSUB2(I,K+1) * H41666M2))
655 END DO
!
    DO 661 I=MYIS,MYIE
        CONTDG(I,LP1) = 1. +  C(I,LLM1)
         TO3DG(I,LP1) = 1. + C2(I,LLM1)
661 END DO
!
    DO 663 K=2,L
        DO 663 I=MYIS,MYIE
            CONTDG(I,K) = ONE + HAF * ( C(I,K) +  C(I,LM1+K))
             TO3DG(I,K) = ONE + HAF * (C2(I,K) + C2(I,LM1+K))
663 END DO
!-------------------------------------------- 
! NOW OBTAIN FLUXES FOR THE DIAGONAL TERMS...
!--------------------------------------------  
    DO 871 K=2,LP1
        DO 871 I=MYIS,MYIE
            FLX(I,K) =    FLX(I,K) + (DTC(I,K) * EMISDG(I,K) + SS2(I,K)                           &
    &                * CONTDG(I,K) +  OSS(I,K) *  TO3DG(I,K) + CSS(I,K)                           &
    &                *   CO21(I,K,K))                                                             &
    &                * CLDFAC(I,K,K)
871 END DO
!----------------------------------  
! FOR THE TWO OFF-DIAGONAL TERMS...
!---------------------------------- 
    DO 873 I=MYIS,MYIE
        FLX(I,L)   =    FLX(I,L)  + (CSS(I,LP1) *  CO21(I,LP1,L) + DTC(I,LP1)                     &
    &              * EMSPEC(I,2)  +  OSS(I,LP1) * TO31D(I,L)     + SS2(I,LP1)                     &
    &              * CONT1D(I,L))                                                                 &
    &              * CLDFAC(I,LP1,L)
!
        FLX(I,LP1) =    FLX(I,LP1) + (CSS(I,L)  * CO21(I,L,LP1)  + OSS(I,L)                       &
    &              *  TO31D(I,L)   + SS2(I,L)   * CONT1D(I,L)    + DTC(I,L)                       &
    &              * EMSPEC(I,1))                                                                 &
    &              * CLDFAC(I,L,LP1)
873 END DO
!----------------------------------------------------------------------------------------------- 
! FINAL SECTION OBTAINS EMISSIVITY HEATING RATES, TOTAL HEATING RATES AND THE FLUX AT THE GROUND
!
! CALCULATE THE EMISSIVITY HEATING RATES
!----------------------------------------------------------------------------------------------- 
    DO 115 K=1,L
        DO 115 I=MYIS,MYIE
            HEATEM(I,K) = RADCON * (FLX(I,K+1) - FLX(I,K)) * DELP(I,K)
115 END DO
!----------------------------------  
! CALCULATE THE TOTAL HEATING RATES
!----------------------------------  
    DO 116 K=1,L
        DO 116 I=MYIS,MYIE
            HEATRA(I,K) = HEATEM(I,K) - CTS(I,K) - CTSO3(I,K) + EXCTS(I,K)
116 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE THE FLUX AT EACH FLUX LEVEL USING THE FLUX AT THE TOP (FLX1E1+GXCTS) AND THE INTEGRAL 
! OF THE HEATING RATES (VSUM1)
!--------------------------------------------------------------------------------------------------
    DO 111 K=1,L
        DO 111 I=MYIS,MYIE
            VSUM1(I,K) = HEATRA(I,K) * DELP2(I,K) * RADCON1
111 END DO
!
    DO 112 I=MYIS,MYIE
        TOPFLX(I)   = FLX1E1(I) + GXCTS(I)
        FLXNET(I,1) = TOPFLX(I)
112 END DO
!--------------------------------------------------------------------------------------------- 
! ONLY THE SURFACE VALUE OF FLUX (GRNFLX) IS NEEDED UNLESS THE THICK CLOUD SECTION IS INVOKED.
!--------------------------------------------------------------------------------------------- 
    DO 113 K=2,LP1
        DO 113 I=MYIS,MYIE
            FLXNET(I,K) = FLXNET(I,K-1) + VSUM1(I,K-1)
113 END DO
!
    DO 114 I=MYIS,MYIE
        GRNFLX(I) = FLXNET(I,LP1)
114 END DO
!-------------------------------------------------------------------------------------------------- 
! THIS IS THE THICK CLOUD SECTION.OPTIONALLY, IF THICK CLOUD FLUXES ARE TO BE "CONVECTIVELY 
! ADJUSTED", IE, DF/DP IS CONSTANT, FOR CLOUDY PART OF GRID POINT, THE FOLLOWING CODE IS EXECUTED.
! FIRST,COUNT THE NUMBER OF CLOUDS ALONG THE LAT. ROW. SKIP THE ENTIRE THICK CLOUD COMPUTATION OF 
! THERE ARE NO CLOUDS.
!--------------------------------------------------------------------------------------------------
    ICNT = 0
!
    DO 117 I=MYIS,MYIE
        ICNT = ICNT + NCLDS(I)
117 END DO
!
    IF (ICNT == 0) GO TO 6999
!------------------------------------------------------ 
! FIND THE MAXIMUM NUMBER OF CLOUDS IN THE LATITUDE ROW
!------------------------------------------------------  
    KCLDS=NCLDS(1)
    DO 118 I=MYIS,MYIE
        KCLDS = MAX(NCLDS(I),KCLDS)
118 END DO
!-------------------------------------------------------------------------------------------------- 
! OBTAIN THE PRESSURES AND FLUXES OF THE TOP AND BOTTOM OF THE NC'TH CLOUD (IT IS ASSUMED THAT ALL 
! KTOP AND KBTM'S HAVE BEEN DEFINED!).
!--------------------------------------------------------------------------------------------------
    DO 119 KK=1,KCLDS
        KMIN = LP1
        KMAX = 0
        DO 120 I=MYIS,MYIE
            J1 = KTOP(I,KK+1)
            J3 = KBTM(I,KK+1)
            IF (J3 > J1) THEN
                PTOP(I) =      P(I,J1)
                PBOT(I) =      P(I,J3+1)
                FTOP(I) = FLXNET(I,J1)
                FBOT(I) = FLXNET(I,J3+1)
!--------------------------------------------   
! OBTAIN THE "FLUX DERIVATIVE" DF/DP (DELPTC)
!--------------------------------------------  
                DELPTC(I) = (FTOP(I) - FBOT(I)) / (PTOP(I) - PBOT(I))
                KMIN = MIN(KMIN,J1)
                KMAX = MAX(KMAX,J3)
            END IF
    120 END DO
!
        KMIN = KMIN + 1
!------------------------------------------------------------------------   
! CALCULATE THE TOT. FLUX CHG. FROM THE TOP OF THE CLOUD, FOR ALL LEVELS.
!------------------------------------------------------------------------  
        DO 123 K=KMIN,KMAX
            DO 122 I=MYIS,MYIE
                IF (KTOP(I,KK+1) < K .AND. K <= KBTM(I,KK+1)) THEN
                    Z1(I,K)     = (P(I,K) - PTOP(I)) * DELPTC(I) + FTOP(I)
                    FLXNET(I,K) = Z1(I,K)
                END IF
        122 END DO
    123 END DO
119 END DO
!-------------------------------------------------------------------------------------------------- 
! USING THIS FLUX CHG. IN THE CLOUDY PART OF THE GRID BOX, OBTAIN THE NEW FLUXES, WEIGHTING THE 
! CLEAR AND CLOUDY FLUXES:AGAIN, ONLY THE FLUXES IN THICK-CLOUD LEVELS WILL EVENTUALLY BE USED.
!--------------------------------------------------------------------------------------------------
    6001 CONTINUE
    6999 CONTINUE
!-----------------------------------------------------------------------------
! HE FINAL STEP IS TO RECOMPUTE THE HEATING RATES BASED ON THE REVISED FLUXES:
!-----------------------------------------------------------------------------
    DO 124 K=1,L
        DO 124 I=MYIS,MYIE
            HEATRA(I,K) = RADCON * (FLXNET(I,K+1) - FLXNET(I,K)) * DELP(I,K)
124 END DO
!----------------------------------- 
! THE THICK CLOUD SECTION ENDS HERE.
!----------------------------------- 
    RETURN
!
    END SUBROUTINE FST88

    MODULE BDWIDE
!>--------------------------------------------------------------------------------------------------
!> MODULE BDWIDE
!>
!> ABSTRACT:
!> MODULE BDWIDE CONTAINS RANDOM BAND PARAMETERS FOR SPECIFIC WIDE BANDS.  
!> AT PRESENT, THE INFORMATION CONSISTS OF: 
!> 1) RANDOM MODEL PARAMETERS FOR THE 15 UM BAND,560-800 CM-1; 
!> 2) THE CONTINUUM COEFFICIENT FOR THE 800-990,1070-1200 CM-1 BAND SPECIFICALLY:
!>
!> AWIDE       - RANDOM "A" PARAMETER FOR  BAND
!> BWIDE       - RANDOM "B" PARAMETER FOR  BAND
!> BETAWD      - CONTINUUM COEFFICIENTS FOR BAND
!> APWD ,BPWD  - CAPPHI COEFFICIENTS FOR  BAND
!> ATPWD,BTPWD - CAPPSI COEFFICIENTS FOR BAND
!> BDLOWD      - LOWEST FREQUENCY IN EACH  FREQ  BAND
!> BDHIWD      - HIGHEST FREQUENCY IN EACH FREQ  BAND
!> AB15WD      - THE PRODUCT ARNDM*BRNDM FOR THE ONE BAND REPRESENTING THE 15 UM BAND COMPLEX OF CO2
!> BETINW      - CONT.COEFFICIENT FOR A SPECIFIED WIDE FREQ. BAND (800-990 AND 1070-1200 CM-1).
!> SKO2D       - 1. / BETINW, USED IN SPA88 FOR CONT. COEFFS
!> SKC1R       - BETAWD/BETINW, USED FOR CONT. COEFF. FOR 15 UM BAND IN FST88
!> SKO3R       - RATIO OF CONT. COEFF. FOR 9.9 UM BAND TO BETINW USED FOR 9.6 UM CONT COEFF IN FST88
!>
!> DATA FOR AWIDE, BWIDE, APWD, BPWD, ATPWD, BTPWD, AO3WD, BO3WD ARE OBTAINED BY USING THE AFGL 1982 
!> CATALOG.
!> CONTINUUM COEFFICIENTS ARE FROM ROBERTS 1976.
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : RNDDTA
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & AWIDE   , BWIDE   ,                                                                         &
    & BETAWD  , APWD    , BPWD    , ATPWD   , BTPWD   , BDLOWD  , BDHIWD  ,                       &
    & BETINW  ,                                                                                   &
    & AB15WD  , SKO2D   ,                                                                         &
    & SKC1R   , SKO3R
!------------
! FROM GFDLRD
!------------
    DATA AWIDE  /                                                                                 &
    &  0.309801E+01 /
!
    DATA BWIDE  /                                                                                 &
    &  0.495357E-01 /
!
    DATA BETAWD /                                                                                 &
    &  0.347839E+02 /
!
    DATA APWD   /                                                                                 &
    &  0.177115E-01 /
!
    DATA BPWD   /                                                                                 &
    & -0.545226E-04 /
!
    DATA ATPWD  /                                                                                 &
    &  0.187967E-01 /
!
    DATA BTPWD  /                                                                                 &
    & -0.567449E-04 /
!
    DATA BDLOWD /                                                                                 &
    &  0.560000E+03 /
!
    DATA BDHIWD /                                                                                 &
    &  0.800000E+03 /
!
    DATA BETINW /                                                                                 &
    &  0.766811E+01 /
!
    END MODULE BDWIDE

    SUBROUTINE PRECPD
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PRECPD
!>
!> SUBROUTINE: PRECPD - LARGE SCALE PRECIPITATION
!> PROGRAMMER: ZHAO
!> ORG: W/NP22
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> PRECPD COMPUTES THE GRID SCALE PRECIPITATION.
!>
!> PROGRAM HISTORY LOG:
!> 94-??-??  ZHAO       - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 96-03-29  BLACK      - REMOVED SCRCH COMMON
!> 96-07-18  ZHAO       - NEW WMIN CALCULATION
!> 06-09-25  BALDWIN    - NEW SR CALCULATION
!> 98-11-02  BLACK      - MODIFICATION FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: ACMCLH 
!>              CLDWTR
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PPTASM
!>              PVRBLS
!>              TEMPCOM
!>              TOPO     
!>              VRBLS     
!>
!> DRIVER     : EBU
!>              NEWFLT   
!>
!> CALLS      : SGETMO           
!>--------------------------------------------------------------------------------------------------
    USE ACMCLH
    USE CLDWTR
    USE CTLBLK
    USE DYNAM    , ONLY: DETA, AETA, PT
    USE F77KINDS
    USE GLB_TABLE
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PPTASM
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: A1    =  610.78
    REAL   (KIND=R4KIND), PARAMETER :: A2    =   17.2693882
    REAL   (KIND=R4KIND), PARAMETER :: A3    =  273.16  
    REAL   (KIND=R4KIND), PARAMETER :: A4    =   35.86
    REAL   (KIND=R4KIND), PARAMETER :: PQ0   =  379.90516
    REAL   (KIND=R4KIND), PARAMETER :: TRESH =     .95
    REAL   (KIND=R4KIND), PARAMETER :: R     =  287.04 
    REAL   (KIND=R4KIND), PARAMETER :: C0    =    0.15 
    REAL   (KIND=R4KIND), PARAMETER :: CP    = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: ELWV  =    2.50E6 
    REAL   (KIND=R4KIND), PARAMETER :: ELIV  =    2.834E6 
    REAL   (KIND=R4KIND), PARAMETER :: ROW   =    1.E3 
    REAL   (KIND=R4KIND), PARAMETER :: G     =    9.8    
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ  =    2.E-12  
    REAL   (KIND=R4KIND), PARAMETER :: DLDT  = 2274.0
    REAL   (KIND=R4KIND), PARAMETER :: ELIW  = ELIV - ELWV 
!
    REAL   (KIND=R4KIND), PARAMETER :: ARCP  = A2  * (A3 - A4) / CP
    REAL   (KIND=R4KIND), PARAMETER :: RCP   = 1.  / CP
    REAL   (KIND=R4KIND), PARAMETER :: PQ0C  = PQ0 * TRESH
    REAL   (KIND=R4KIND), PARAMETER :: RROG  = 1.  / (ROW * G)
    REAL   (KIND=R4KIND), PARAMETER :: RROW  = 1.  / ROW
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: LTOP = 1
    INTEGER(KIND=I4KIND), PARAMETER :: LBOT = LM
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM_LOC = IDIM2 * JDIM2
    INTEGER(KIND=I4KIND), PARAMETER :: LDA      = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & NOZ
!
    INTEGER(KIND=I4KIND), DIMENSION(IMJM_LOC)                                                   ::&
    & IPREC   , JPREC
!
    REAL   (KIND=R4KIND), DIMENSION(LM,IDIM1:IDIM2, JDIM1:JDIM2)                                ::&
    &     T_T ,    Q_T  ,                                                                         &
    & TRAIN_T ,  HTM_T  ,                                                                         &
    &   CWM_T , TLAT_T
!
    REAL   (KIND=R4KIND), DIMENSION(IMJM_LOC)                                                   ::&
    & PRECRL1 , PRECSL1   
!
    INTEGER(KIND=I4KIND), DIMENSION(IMJM_LOC)                                                   ::&
    & IWL1
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & KE      , INIT    , MI0
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , N       , NPRE    , LML     , IWL     , IWK 

    REAL   (KIND=R4KIND)                                                                        ::&  
    & DTPH    , RDTPH   , TWODT   , RTWODT  , US      , EPS     , CCLIMIT , CWS     , CSM1    ,   &
    & CRS1    , CRS2    , CR      , AA2     , UTIM    , TTEMP   , WFIX    , WMIN    , HBM2K   ,   &
    & PDSL    , CLIMIT  , CONSTA  , U00IJ   , DETAL   , ULL     , AETAL   , PRECRL  , PRECSL  ,   &
    & PRAUT   , PSAUT   , PRACW   , PSACI   , ERR     , ERS     , PSM     , PSM1    , PSM2    ,   &
    & PPR     , PPS     , CPDR    , HH      , PID     , CONDE   , RCONDE  , TT      , QQ      ,   &
    & WW      , HTMK    , TTLAT   , U00KL   , WMINK   , PRECRK  , PRECSK  , TK      , QK      ,   &
    & TMT0    , TMT15   , AI      , BI      , QW      , QI      , QINT    , FI      , FIW     ,   &
    & QC      , RQ      , CCR     , RQKLL   , CWMK    , EXPF    , AA1     , AMAXCM  , TMT0K   ,   &
    & U00KLT  , AMAXRQ  , HHT     , QTEMP   , TMT0T   , TMT15T  , QWT     , QIT     , QINTT   ,   &
    & QCT     , RQT     , RQTT    , ERK     , RPRS    , ERRT    , ERST    , AMAXPS  , PRECRS  ,   &
    & PRECSS  , TOTPPT

!------------------------- 
! PREPARATORY CALCULATIONS 
!------------------------- 
    DTPH    = NPHS * DT
    RDTPH   = 1. / DTPH
    TWODT   = DTPH
    RTWODT  = 1. / TWODT
    KE      = 2.0E-5
    US      = 1.
    EPS     = 0.622E0
    CCLIMIT = 1.0E-3
    CLIMIT  = 1.0E-20
    CWS     = 0.025
    CSM1    = 5.00000E-8
    CRS1    = 5.00000E-6
    CRS2    = 6.66600E-10
    CR      = 5.0E-4
    MI0     = 5.0E-4
    AA2     = 1.25E-3
!
    AVRAIN = AVRAIN + 1.
    ARATIM = ARATIM + 1
!---------------------------------------- 
! PADDING CLOUD MIXING RATIO IF TOO SMALL
!----------------------------------------
!
!$omp parallel do
!
    DO 20 K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                CWM(I,J,K) = CWM(I,J,K) * HTM(I,J,K) * HBM2(I,J)
!
                IF (CWM(I,J,K) < 0.) CWM(I,J,K) = 0.
!---------------------------------------                  
! PADDING SPECIFIC HUMIDITY IF TOO SMALL
!---------------------------------------
                IF (Q(I,J,K) < EPSQ) Q(I,J,K) = EPSQ * HTM(I,J,K)
            END DO
        END DO
 20 END DO
!
    UTIM = 1.
!
!$omp parallel do 
!
    DO N=1,IMJM_LOC
           IWL1(N) = 0
        PRECRL1(N) = 0.
        PRECSL1(N) = 0.
    END DO
!----------------------------------------------
! CHOOSE THE COLUMNS WHERE PREC CAN BE PRODUCED
!----------------------------------------------
    NPRE = 0
!
    DO 35 J=MYJS2,MYJE2
        DO 35 I=MYIS,MYIE
!        
            DO K=2,LM
                TTEMP = 0.025  * (T(I,J,K) - 273.16)
                WFIX  = 0.9814 * EXP(0.01873 * K)
                WMIN  = 0.1E-3 * EXP(TTEMP) * WFIX
!
                IF (CWM(I,J,K) > WMIN) GOTO 33
!
            END DO
!        
            GOTO 35
!
         33 NPRE = NPRE + 1
!
            IPREC(NPRE) = I
            JPREC(NPRE) = J
 35 END DO
!----------------- 
! TRANSPOSE ARRAYS
!-----------------
!
!$omp parallel sections
!
!$omp section
!
    CALL SGETMO(T     , LDA, LDA, LM, T_T    ,LM)
!
!$omp section
!
    CALL SGETMO(Q     , LDA, LDA, LM, Q_T    ,LM)
!
!$omp section
!
    CALL SGETMO(CWM   , LDA, LDA, LM, CWM_T  ,LM)
!
!$omp section
!
    CALL SGETMO(HTM   , LDA, LDA, LM, HTM_T  ,LM)
!
!$omp section
!
    CALL SGETMO(TRAIN , LDA, LDA, LM, TRAIN_T,LM)
!
!$omp section
!
    CALL SGETMO(TLATGS, LDA, LDA, LM, TLAT_T ,LM)
!
!$omp end parallel sections
!
!-------------------------------------- 
! BEGINING OF PRECIPITATION CALCULATION 
!-------------------------------------- 
!
!-------------------------------------------- 
! LOOP OVER ALL POSSIBLE PRECIPITATION POINTS
!-------------------------------------------- 
!
!$omp parallel do
!$omp private (AAI      , AETAL   , AI      , AMAXCM  , AMAXPS  , AMAXRQ  , BI      , CCR     ,   &
!$omp          CONDE    , CONSTA  , CPDR    , CS      , CWMK    , DETAL   , ERK     , ERR     ,   &
!$omp          ERRT     , ERS     , ERST    , EXPF    , FI      , FIW     , HBM2K   , HH      ,   &
!$omp          HTMK     , I       , IWL     , J       , LML     , MI0     , PDSL    , PID     ,   &
!$omp          PPR      , PPS     , PRACW   , PRAUT   , PRECRK  , PRECRL  , PRECSK  , PRECSL  ,   &
!$omp          PRECSS   , PSACI   , PSAUT   , PSM     , PSM1    , PSM2    , QC      , QCT     ,   &
!$omp          QI       , QINT    , QINTT   , QIT     , QK      , QQ      , QTEMP   , QW      ,   &
!$omp          QWT      , RCONDE  , RPRS    , RQ      , RQKLL   , RQT     , RQTT    , TK      ,   &
!$omp          TMT0     , TMT0K   , TMT0T   , TMT15   , TMT15T  , TOTPPT  , TT      , TTEMP   ,   &
!$omp          TTLAT    , U00IJ   , U00KL   , U00KLT  , ULL     , WFIX    , WMINK   , WW      )
!
    DO 300 N=1,NPRE
!    
        I = IPREC(N)
        J = JPREC(N)
!
        HBM2K  = HBM2(I,J)
        PDSL   =  RES(I,J) * PD(I,J)
!
        CONSTA = PDSL / G * TWODT
        LML    = LM - LMH(I,J)
        U00IJ  = U00(I,J)
!    
        DO 180 K=2,LM
!        
            DETAL = DETA(K)
            ULL   =   UL(K)
            AETAL = AETA(K)
!
            WFIX = 0.9814 * EXP(0.01873 * K)
!        
            PRECRL = 0.
            PRECSL = 0.
            PRAUT  = 0.
            PSAUT  = 0.
            PRACW  = 0.
            PSACI  = 0.
            ERR    = 0.
            ERS    = 0.
            PSM    = 0.
            PSM1   = 0.
            PSM2   = 0.
            PPR    = 0.
            PPS    = 0.
            CPDR   = 0.
            HH     = 0.
            PID    = 0.
            IWL    = 0.
            CONDE  = 0.
            RCONDE = 0.
!
            TT    =    T_T(K,I,J)
            QQ    =    Q_T(K,I,J)
            WW    =  CWM_T(K,I,J)
            HTMK  =  HTM_T(K,I,J)
            TTLAT = TLAT_T(K,I,J)
!
            U00KL = U00IJ  + UL(K + LML) * (0.95 - U00IJ) * UTIM
            TTEMP = 0.025  * (TT - 273.16)
            WMINK = 0.1E-3 * EXP(TTEMP)  * WFIX
!------------------------------------------------------ 
! CHOOSE THE POINTS WHERE PRECIPITATION CAN BE PRODUCED 
!------------------------------------------------------ 
            PRECRK = AMAX1(0., PRECRL1(N))
            PRECSK = AMAX1(0., PRECSL1(N))
!
            HH = HTMK * HBM2K
!
            IF (WW < WMINK .AND. (PRECRK+PRECSK) == 0.) THEN
                PID = 0.
            ELSE
                PID = HH
            END IF
!---------------- 
! QW, QI AND QINT
!----------------
            IF (PID == 1.) THEN
                CONDE  = CONSTA * DETAL
                RCONDE = 1. / CONDE
                TK     = TT
                QK     = QQ
                TMT0   = (TK - 273.16)     * HH
                TMT15  = AMIN1(TMT0, -15.) * HH
                AI     = 0.008855
                BI     = 1.
!
                IF (TMT0 < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!            
                QW   = HH *  PQ0 / (PDSL * AETAL + PT) * EXP(HH * A2 * (TK - A3) / (TK - A4))
                QI   = QW * (BI  + AI * AMIN1(TMT0, 0.))
                QINT = QW * (1. - 0.00032 * TMT15 * (TMT15 + 15.))
!
                IF (TMT0 <= -40.) QINT = QI
!-----------------------
! ICE-WATER ID NUMBER IW 
!-----------------------
                IF (TMT0 < -15.) THEN
                    FI = QK - U00KL * QI
                    IF (FI > 0. .OR. WW > CLIMIT) THEN
                        IWL = 1
                    ELSE
                        IWL = 0
                    END IF
                END IF
!            
                IF (TMT0 < 0.0 .AND. TMT0 >= -15.0) THEN
                    IWL = 0
                    IF (IWL1(N) == 1 .AND. WW > CLIMIT) IWL = 1
                END IF
!            
                IF (TMT0 >= 0.) THEN
                    IWL = 0
                END IF
!--------------------------------
! THE SATUATION SPECIFIC HUMIDITY 
!--------------------------------
                FIW = FLOAT(IWL)
                QC  = (1. - FIW) * QINT + FIW * QI
!---------------------- 
! THE RELATIVE HUMIDITY 
!---------------------- 
                IF (QC <= 0.) THEN
                    RQ = 1.E-10
                ELSE
                    RQ = QK / QC
                END IF
!---------------------- 
! CLOUD COVER RATIO CCR
!---------------------- 
                IF (RQ <= U00KL) THEN
                    CCR = 0.
                ELSE
                    RQKLL = AMIN1(US, RQ)
                    CCR   = 1. - SQRT((US - RQKLL) / (US - U00KL))
                END IF
!---------------------------------------------------- 
! CORRECT CCR IF IT IS TOO SMALL IN LARGE CWM REGIONS
!---------------------------------------------------- 
                IF (CCR >= 0.01 .AND. CCR <= 0.2 .AND. WW >= 0.2E-3) THEN
                    CCR = AMIN1(1., WW * 1.0E3)
                END IF
            END IF
!
         60 CONTINUE
!------------------------------- 
! PRECIPITATION PRODUCTION RATES 
!       AUTO-CONVERT RATES 
!------------------------------- 
            IF (PID == 1.) THEN
                IWK  = IWL
                CWMK = AMAX1(0., WW - CLIMIT)
                MI0  = WMINK
!            
                IF (IWK == 1) THEN
                    EXPF  = EXP(0.025 * TMT0)
                    AA1   = 1.E-3 * EXPF
                    PSAUT = AA1 * AMAX1(0., CWMK - MI0)
                    CPDR  = -PSAUT * TWODT
!
                    IF (-CPDR >= CWMK) THEN
                        CPDR  = -CWMK
                        PSAUT = -CPDR * RTWODT
                    END IF
                ELSE
                    AMAXCM = AMAX1(0., CWMK - MI0)
                    PRAUT  = C0 * AMAXCM * AMAXCM
                    CPDR   = -PRAUT * TWODT
!
                    IF (-CPDR >= CWMK) THEN
                        CPDR  = -CWMK
                        PRAUT = -CPDR * RTWODT
                    END IF
                END IF
                PPR = PRAUT * CONDE
                PPS = PSAUT * CONDE
            END IF
!        
            IF (PID == 1.) THEN
                WW = CPDR * HH + WW
!
                PRECRL = PRECRL1(N) + PPR * HH
                PRECSL = PRECSL1(N) + PPS * HH
            END IF
!----------- 
! ACCRETIONS 
!-----------  
            IF (PID == 1.) THEN
                IWK  = IWL
                CWMK = WW
!
                PRECRK = AMAX1(0., PRECRL1(N))
                PRECSK = AMAX1(0., PRECSL1(N))
!
                IF (IWK == 1) THEN
                    EXPF  = EXP(0.025 * TMT0)
                    CS    = AA2    * EXPF
                    PSACI = CS     * AMAX1(0., CWMK) * PRECSK
                    CPDR  = -PSACI * TWODT
!
                    IF (-CPDR >= CWMK) THEN
                        CPDR  = -CWMK
                        PSACI = -CPDR * RTWODT
                    END IF
                ELSE
                    PRACW = CR     * AMAX1(0., CWMK) * (PRECRK + PRECSK)
                    CPDR  = -PRACW * TWODT
!
                    IF (-CPDR >= CWMK) THEN
                        CPDR  = -CWMK
                        PRACW = -CPDR * RTWODT
                    END IF
                END IF
                PPR = PRACW * CONDE
                PPS = PSACI * CONDE
            END IF
!        
            IF (PID == 1.) THEN
                WW = CPDR * HH + WW
                PRECRL = PRECRL + PPR * HH
                PRECSL = PRECSL + PPS * HH
            END IF
!------------------------------------------  
! EVAPORATION/CONDENSATION OF PRECIPITATION 
! ERR AND ERS POSITIVE--EVAPORATION
! ERR AND ERS NEGTIVE---CONDENSATION
!------------------------------------------
            IF (PID == 1.0) THEN
                QK    = QQ
                TMT0K = TMT0
!
                IF (TMT0K < -30.) TMT0K = -30.
                PRECRK = AMAX1(0., PRECRL)
                PRECSK = AMAX1(0., PRECSL)
!------------------------------------------------------------ 
! INCREASE THE EVAPORATION/CONDENSATION FOR STRONG/LIGHT PREC
!------------------------------------------------------------ 
                U00KLT = U00KL
                AMAXRQ = AMAX1(0., U00KL - RQ)
                ERR    = KE * AMAXRQ * PRECRK ** 0.5
!            
                IF (TMT0 >= 0.) THEN
                    ERS = 0.
                ELSE
                    ERS = (CRS1 + CRS2 * TMT0K) * AMAXRQ * PRECSK / U00KLT
                END IF
!            
                IF (ERR + ERS <= 1.E-20) GO TO 125
!------------------------------------  
! CORRECT IF OVER-EVAPO./COND. OCCURS
!------------------------------------ 
                HHT   = HH * TWODT
                TTEMP = TT - RCP * (ELWV * ERR + ELIV * ERS) * HHT
                QTEMP = QQ + HHT * (       ERR        + ERS)
!
                TMT0T = (TTEMP - 273.16) * HH
!
                IF (TMT0T < -30.) TMT0T = -30.
!
                TMT15T = AMIN1(TMT0T, -15.) * HH
                AI = 0.008855
                BI = 1.
!            
                IF (TMT0T < -20.) THEN
                    AI = 0.007225
                    BI = 0.9674
                END IF
!            
                QWT = HH  * PQ0 / (PDSL * AETAL + PT) * EXP(HH * A2 * (TTEMP - A3) / (TTEMP - A4))
                QIT = QWT * (BI + AI * AMIN1(TMT0T, 0.))
                QINTT=QWT * (1. - 0.00032 * TMT15T * (TMT15T + 15.))
!
                IF (TMT0T <= -40.) QINTT = QIT
                FIW = FLOAT(IWL)
                QCT = (1. - FIW) * QINTT + FIW * QIT
!            
                IF (QCT <= 1.E-10) THEN
                     RQT = 1.E-10
                    RQTT = 1.E-10
                ELSE
                    RQT  = QTEMP / QCT
                    RQTT = QQ    / QCT
                END IF
!            
                IF (RQT <= U00KL) GO TO 125
!            
                ERK  = (U00KL - RQTT) * QCT * RTWODT
                RPRS = ERK / (PRECRK + PRECSK)
!
                ERRT =PRECRK  * RPRS
                ERST = PRECSK * RPRS
!
                ERR = AMAX1(0., 0.5 * (ERR + ERRT))
                ERS = AMAX1(0., 0.5 * (ERS + ERST))
!            
            125 CONTINUE
!            
                PPR = -ERR * CONDE
                PPS = -ERS * CONDE
!            
                IF (-PPR >= PRECRK) THEN
                    PPR = -PRECRK
                    ERR = -PPR * RCONDE
                END IF
!            
                IF (-PPS >= PRECSK) THEN
                    PPS = -PRECSK
                    ERS = -PPS * RCONDE
                END IF
!            
            END IF
!        
            IF (PID == 1.) THEN
                PRECRL = PRECRL + PPR * HH
                PRECSL = PRECSL + PPS * HH
            END IF
!-------------------- 
! MELTING OF THE SNOW 
!-------------------- 
            IF (PID == 1.) THEN
                CWMK   = WW
                AMAXPS = AMAX1(0., PRECSL)
!            
                IF (TMT0 > 0.) THEN
                    PSM1 = CSM1 * TMT0 * TMT0 * AMAXPS
                    PSM2 = CWS  * CR   * CWMK * AMAXPS
                    PSM  = PSM1 + PSM2
                ELSE
                    PSM1 = 0.
                    PSM2 = 0.
                    PSM  = 0.
                END IF
!            
                PPR =  PSM * CONDE
                PPS = -PSM * CONDE
!            
                IF (-PPS >= AMAXPS) THEN
                    PPS  = -AMAXPS
                    PPR  =  AMAXPS
!
                    PSM1 = -PPS * RCONDE
                    PSM2 = 0.
                    PSM  = PSM1
                END IF
!            
            END IF
!        
            IF (PID == 1.) THEN
                PRECRL = PRECRL + PPR * HH
                PRECSL = PRECSL + PPS * HH
            END IF
!--------------- 
! UPDATE T AND Q 
!---------------
            IF (PID == 1.) THEN
                HHT= HH * TWODT
                TT = -RCP * (ELWV * ERR + ELIV * ERS + ELIW * PSM1) * HHT + TT
                QQ = (ERR + ERS) * HHT + QQ
!
                TTLAT = -RCP  * (ELWV  * ERR + ELIV * ERS + ELIW * PSM1 - ELWV * (PRAUT + PRACW)    &
    &                 -  ELIV * (PSAUT + PSACI))    * HHT + TTLAT
            END IF
!        
            IF (HH == 1.) THEN
                   IWL1(N) = IWL
                PRECRL1(N) = PRECRL
                PRECSL1(N) = PRECSL
            END IF
!--------------------------------------------------------------------------------------------------        
! ACCUMULATE LATENT HEATING DUE TO GRID-SCALE PRECIP/EVAP. SCALE BY THE RECIPROCAL OF THE PERIOD AT
! WHICH THIS ROUTINE IS CALLED.
! THIS PERIOD IS THE PHYSICS TIMESTEP.
!-------------------------------------------------------------------------------------------------- 
            TRAIN_T(K,I,J) = TRAIN_T(K,I,J) + (TT-T_T(K,I,J)) * RDTPH
                T_T(K,I,J) = TT
                Q_T(K,I,J) = QQ
              CWM_T(K,I,J) = WW
             TLAT_T(K,I,J) = TTLAT
    180 END DO
!------------------------- 
! THE PRECIPITATION ON SFC 
!------------------------- 
        PRECRS = PRECRL1(N) * RROW
        PRECSS = PRECSL1(N) * RROW
!    
         APREC(I,J) = PRECRS + PRECSS
          PREC(I,J) =   PREC(I,J) + PRECRS + PRECSS
        ACPREC(I,J) = ACPREC(I,J) + APREC(I,J)
!-------------------------------------------- 
! THE SNOW AND RAIN RATIO OF SFC PREC 
! SR IS THE RATIO OF SNOW TO THE TOTAL PRECIP 
! IF TOTAL PRECIP IS ZERO, SR IS ZERO- 
!-------------------------------------------- 
        TOTPPT = PRECRS + PRECSS
        IF (TOTPPT > 1.E-8) THEN
            SR(I,J) = PRECSS / TOTPPT
        ELSE
            SR(I,J) = 0.
        END IF
!
300 END DO
!--------------- 
! TRANSPOSE BACK
!--------------- 
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(T_T    , LM, LM, LDA, T     , LDA)
!
!$omp section 
!
    CALL SGETMO(Q_T    , LM, LM, LDA, Q     , LDA)
!
!$omp section
!
    CALL SGETMO(CWM_T  , LM, LM, LDA, CWM   , LDA)
!
!$omp section
!
    CALL SGETMO(TRAIN_T, LM, LM, LDA, TRAIN , LDA)
!
!$omp section
!
    CALL SGETMO(TLAT_T , LM, LM, LDA, TLATGS, LDA)
!
!$omp end parallel sections
!
    RETURN
!
    END SUBROUTINE PRECPD

    SUBROUTINE ZENITH(TIMES, DAYI, HOUR)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE ZENITH
!>
!> SUBPROGRAM: ZENITH - COMPUTE THE SOLAR ZENITH ANGLE
!> PROGRAMMER: BLACK   
!> ORG: W/NMC2 
!> DATE: 93-10-28
!>
!> ABSTRACT:
!> ZENITH CALCULATES THE COSINE OF THE SOLAR ZENITH ANGLES AT EACH POINT FOR USE IN SWRAD
!>
!> PROGRAM HISTORY LOG:
!> 93-10-28  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> TIMES  - THE FORECAST TIME IN SECONDS
!>
!> OUTPUT ARGUMENT LIST:
!> DAYI   - THE DAY OF THE YEAR
!> HOUR   - THE HOUR OF THE DAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : INIT
!>              INITS
!>              RADTN
!>              RDTEMP
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: D00    =    0.0E0 
    REAL   (KIND=R4KIND), PARAMETER :: D5     =    0.5E0
    REAL   (KIND=R4KIND), PARAMETER :: H15    =   15.E0 
    REAL   (KIND=R4KIND), PARAMETER :: H24    =   24.E0 
    REAL   (KIND=R4KIND), PARAMETER :: H3600  = 3600.E0
    REAL   (KIND=R4KIND), PARAMETER :: CSID2  =    6.570982E-2
    REAL   (KIND=R4KIND), PARAMETER :: CSID3  =    1.002738E0
    REAL   (KIND=R4KIND), PARAMETER :: CLON2  =    9.856474E-1
    REAL   (KIND=R4KIND), PARAMETER :: PI     =    3.1415926 
    REAL   (KIND=R4KIND), PARAMETER :: PI2    =    2.    * PI
    REAL   (KIND=R4KIND), PARAMETER :: PIH    =    0.5   * PI
    REAL   (KIND=R4KIND), PARAMETER :: DEG2RD =    1.745329E-2
    REAL   (KIND=R4KIND), PARAMETER :: OBLIQ  =   23.440 * DEG2RD
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LDA    = LM +  9 
    INTEGER(KIND=I4KIND), PARAMETER :: LA     =      13
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM * JM - JM  / 2 
    INTEGER(KIND=I4KIND), PARAMETER :: JAM    = 6  +  2 * (JM - 10)
    INTEGER(KIND=I4KIND), PARAMETER :: LSCRCH = 4  * LM + 1 + LA + 1
    INTEGER(KIND=I4KIND), PARAMETER :: L1     = LA +  1
    INTEGER(KIND=I4KIND), PARAMETER :: L2     = LA + LM + 1 
    INTEGER(KIND=I4KIND), PARAMETER :: L3     = LA +  2 * LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: L4     = LA +  3 * LM + 1
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & TIMES
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)       ::&
    & DAYI
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)       ::&
    & HOUR
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LEAP
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IYR     , INDX    , I       , J       , KMNTH   , KNT
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LL1     , LL2
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & CSID1   , CLON1   , DAY     , SLON    , DEC     , RA      , SIDTIM  , HRANG   , SINALT  ,   &
    & HRLCL
!
    REAL   (KIND=R4KIND), DIMENSION(50)                                                         ::&
    & CSIDX   , CLONX
!
    INTEGER(KIND=I4KIND), DIMENSION(12)                                                         ::&
    & MONTH
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & N       , K       , NSOLAR
!
    DATA MONTH /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30,31/
    SAVE MONTH
!-------------------------------------------------------------------------------------------------- 
! READ ANNUAL VALUES OF THE GREENWICH MEAN SIDEREAL TIME FOR 0000 UTC DECEMBER 31 AND OF THE 
! GEOMETRIC MEAN CELESTIAL LONGITUDE OF THE SUN FOR 0000 TDT DECEMBER 31
!-------------------------------------------------------------------------------------------------- 
    NSOLAR = 19
    OPEN (NSOLAR, FILE='./SOLAR', FORM='FORMATTED', STATUS='OLD')
!
    LL2 = 0
    DO N=1,10
        LL1 = LL2 + 1
        LL2 = LL1 + 4
        READ(NSOLAR,25) (CSIDX(K), K=LL1,LL2)
        25 FORMAT(5F9.6)
    END DO
!
    ll2 = 0
!
    DO N=1,10
        LL1 = LL2 + 1
        LL2 = LL1 + 4
        READ(NSOLAR,30) (CLONX(K), K=LL1,LL2)
        30 FORMAT(5F11.6)
    END DO
!
    CLOSE(NSOLAR)
!
    IYR   = IDAT(3) - 1900
    INDX  = IYR     -   85
    CSID1 = CSIDX(INDX)
    CLON1 = CLONX(INDX)
    DAY   = D00
    LEAP  = .FALSE. 
!
    IF (MOD(IDAT(3),4) == 0) THEN
        MONTH(2) = 29
        LEAP     = .TRUE. 
    END IF
!
    IF (IDAT(1) > 1) THEN
        KMNTH = IDAT(1) - 1
        DO  KNT=1,KMNTH
            DAY = DAY + REAL(MONTH(KNT))
        END DO
    END IF
!-----------------------------------------------------------------------------------
! CALCULATE EXACT NUMBER OF DAYS FROM BEGINNING OF YEAR TO FORECAST TIME OF INTEREST
!-----------------------------------------------------------------------------------
    DAY  = DAY + REAL(IDAT(2) - 1) + (REAL(IHRST)+ TIMES/H3600) / H24
    DAYI = REAL(INT(DAY) + 1)
    HOUR = (DAY - DAYI) * H24 + H24
!------------------------------------------------------------------------------------
! FIND CELESTIAL LONGITUDE OF THE SUN THEN THE SOLAR DECLINATION AND RIGHT ASCENSION.
!------------------------------------------------------------------------------------
    SLON = (CLON1 + CLON2 * DAY) * DEG2RD
!
    IF (SLON > PI2) SLON = SLON - PI2
!
    DEC = ASIN(SIN(SLON) * SIN(OBLIQ))
    RA  = ACOS(COS(SLON) / COS(DEC))
!
    IF (SLON > PI) RA = PI2 - RA
!------------------------------------------------------------------
! FIND THE GREENWICH SIDEREAL TIME THEN THE LOCAL SOLAR HOUR ANGLE.
!------------------------------------------------------------------
    SIDTIM = CSID1  + CSID2 * DAYI + CSID3 * HOUR
    SIDTIM = SIDTIM * H15   * DEG2RD
!
    IF (SIDTIM < D00) SIDTIM = SIDTIM + PI2
    IF (SIDTIM > PI2) SIDTIM = SIDTIM - PI2
!
    HRANG = SIDTIM - RA
!
    DO 100 J=MYJS,MYJE
        DO 100 I=MYIS,MYIE
            HRLCL = HRANG - GLON(I,J)
!--------------------------------------------------------------------------------------------------
! THE ZENITH ANGLE IS THE COMPLEMENT OF THE ALTITUDE THUS THE COSINE OF THE ZENITH ANGLE EQUALS THE
! SINE OF THE ALTITUDE.
!--------------------------------------------------------------------------------------------------
            SINALT = SIN(DEC) * SIN(GLAT(I,J)) + COS(DEC) * COS(HRLCL) * COS(GLAT(I,J))
!
            IF (SINALT < D00) SINALT = D00
!
            CZEN(I,J) = SINALT
!
100 END DO
!-------------------------------------------------------------------------------------------------- 
! IF THE FORECAST IS IN A DIFFERENT YEAR THAN THE START TIME, RESET DAYI TO THE PROPER DAY OF THE 
! NEW YEAR (IT MUST NOT BE RESET BEFORE THE SOLAR ZENITH ANGLE IS COMPUTED).
!-------------------------------------------------------------------------------------------------- 
    IF (DAYI > 365.) THEN
        IF (.NOT. LEAP) THEN
            DAYI = DAYI - 365.
        ELSE IF (LEAP .AND. DAYI > 366.) THEN
            DAYI = DAYI - 366.
        END IF
    END IF
!
    RETURN
!
    END SUBROUTINE ZENITH

    SUBROUTINE SETUP_SERVERS(NPES_MOD     , MYPE          , NPES                ,                 &
    &                        IQUILT_GROUP , INUMQ         ,                                       &
    &                        MPI_COMM_COMP, MPI_COMM_INTER, MPI_COMM_INTER_ARRAY)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SETUP_SERVERS
!> 
!> SUBROUTINE: SETUP_SERVERS - SETUP I/O SERVERS
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-03-20
!>
!> ABSTRACT:
!> SETUP I/O SERVERS
!>
!> PROGRAM HISTORY LOG:
!> 00-03-11  TUCCILLO - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NPES_MOD - NUMBER OF MPI TASKS FOR MODEL INTEGRATION FROM INPES AND JNPES THIS IS THE NUMBER
!>            OF MPI TASKS THE EXECUTABLE HAS BEEN BUILT FOR.
!>            NPES, RETURNED FROM MPI_COMM_SIZE, MUST BE AT LEAST THIS SIZE OTHERWISE THE
!>            INTEGRATION CANNOT PROCEED. THE DIFFERENCE BETWEEN NPES_MOD AND NPES IS THE NUMBER
!>            OF MPI TASKS THAT ARE AVAILABLE FOR I/O SERVING. THIS CAN BE ZERO, IN WHICH CASE 
!>            CHKOUT WILL WRITE A DIRECT ACCESS FILE THAT CAN BE SEPARTELY "QUILTED".
!>            IN ORDER TO SKIP THE SEPARATE QUILTING STEP, MAKE SURE THAT THE NUMBER OF MPI TASKS 
!>            THAT THE CODE IS INITIATED WITH IS AT LEAST ONE GREATER THAN NPES_MOD.
!>
!> OUTPUT ARGUMENT LIST:
!> MYPE                 - MY RANK
!> IQUILT_GROUP         - NUMBER OF I/O SERVER GROUPS
!> INUMQ                - ARRAY THAT HOLDS THE NUMBER OF SERVERS IN EACH GROUP
!> NPES                 - NUMBER OF MPI TASKS FOR MODEL INTEGRATION
!> MPI_COMM_COMP        - THE NEW INTRACOMMUNICATOR FOR ALL TASKS
!> MPI_COMM_INTER       - THE INTERCOMMUNICATOR FOR THE I/O SERVERS
!> MPI_COMM_INTER_ARRAY - THE ARRAY OF INTERCOMMUNICATORS FOR THE INTEGRATION TASKS
!>
!> INPUT FILES:  NONE
!>
!> OUTPUT FILES:
!> NONE BUT THE CODE DOES ATTEMPT TO READ THE ENVIRONMENT VARIABLE "SERVER_GROUPS".
!> THIS IS THE NUMBER OF INDEPENDENT GROUPS OF SERVER TASKS.
!> THE DEFAULT IS ONE AND SHOULD BE OK FOR MOST APPLICATIONS OF THE ETA CODE.
!> IF ONE SET OF I/O SERVERS CAN NOT COMPLETE BEFORE THE NEXT OUPUT TIME THEN ADDITIONAL I/O SERVER
!> GROUPS WOULD BE USEFUL.
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : EBU
!> 
!> CALLS      : GETENV
!>              MPI_ABORT
!>              MPI_BARRIER
!>              MPI_COMM_CREATE
!>              MPI_COMM_DUP
!>              MPI_COMM_GROUP
!>              MPI_COMM_RANK
!>              MPI_COMM_SIZE
!>              MPI_COMM_SPLIT
!>              MPI_GROUP_CREATE
!>              MPI_GROUP_EXCL
!>              MPI_GROUP_FREE
!>              MPI_INIT   
!>              MPI_INTERCOMM_CREATE    
!>              PARA_RANGE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    INCLUDE 'mpif.h'
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & COMDUP
!
    INTEGER(KIND=I4KIND), DIMENSION(:), ALLOCATABLE                                             ::&
    & IRANK
!
    INTEGER(KIND=I4KIND), DIMENSION(*)                                    , INTENT(INOUT)       ::& 
    & MPI_COMM_INTER_ARRAY        , INUMQ
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & YES
!
    CHARACTER(4)                                                                                ::&
    & GET
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & NPES_MOD
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(INOUT)       ::&
    & MYPE    , NPES    , IQUILT_GROUP      , MPI_COMM_COMP     , MPI_COMM_INTER     
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IERR    , IQSERVER, I       , ISTAQ   , IENDQ   , ICOLOR  , ISTAXX  , IENDXX  , IRLR    ,   &
    & ICC     , ISS     , JJ      , ISSL    , KK      , IWORLD  , IGROUP  , IGROUP_X,             &
    & IWORLD_MINUS      , IXX
!---------------------------------------------------
! INITIALIZE MPI
! RETRIEVE THE NUMBER OF TOTAL MPI TASKS AND MY RANK
!---------------------------------------------------
    CALL MPI_INIT(IERR)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, MYPE, IERR)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, NPES, IERR)
!--------------------------------------------------------------------------------------------------
! AT THIS POINT NPES IS THE TOTAL NUMBER OF MPI TASKS. 
! WE WILL RESET THIS AT THE END OF THE SUBROUTINE TO THE NUMBER OF MPI TASKS
! THAT ARE WORKING ON THE MODEL INTGRATION.
!
! FIRST, HOWEVER, WE NEED TO MAKE SURE THAT A SUFFICIENT NUMBER OF MPI TASKS HAVE BEEN INITIATED. 
! IF NOT, WE WILL STOP.
!--------------------------------------------------------------------------------------------------
    IF (NPES < NPES_MOD) THEN
        PRINT *, ' *******************************************************'
        PRINT *, ' *******************************************************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *
        PRINT *, '                      STOPPING NOW                      '
        PRINT *, '      THERE ARE INSUFFICIENT MPI TASKS TO CONTINUE      '
        PRINT *, '      YOU MUST SPECIFY AT LEAST ',NPES_MOD,' TASKS      '
        PRINT *, '                      STOPPING NOW                      '
        PRINT *
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' ******************** MAJOR PROBLEM ********************'
        PRINT *, ' *******************************************************'
        PRINT *, ' *******************************************************'
!
        CALL MPI_ABORT(MPI_COMM_WORLD, 1, IERR)
!
    END IF
!-----------------------------------------------------------------------------------
! OK, WE HAVE A SUFFICIENT NUMBER OF MPI TASKS TO CONTINUE
!
! HOW MANY GROUPS OF SERVERS ? THE DEFAULT IS 1 GROUP
! THE ENVIRONMENT VARIABLE, SERVER_GROUPS, CAN BE USED TO SPECIFY MORE SERVER GROUPS
!-----------------------------------------------------------------------------------
    GET = '1'
!
    CALL GETENV('SERVER_GROUPS', GET)
    READ(GET,FMT='(I4)') IQUILT_GROUP
!
    IQUILT_GROUP = MAX(IQUILT_GROUP, 1)
!------------------------------------------------------------------ 
! ERROR CHECK NUMBER OF GROUPS - THE MAXIMUM IS 100 - THIS IS A LOT
!------------------------------------------------------------------ 
    IF (IQUILT_GROUP > 100) THEN
        PRINT *, ' ***** IQUILT_GROUP IS GREATER THAN 100'
        PRINT *, ' ***** DO YOU REALLY WANT THIS ?'
        PRINT *, ' ***** IF SO THEN INCREASE SIZE IN MPP.H'
        PRINT *, ' ***** ALSO, CHANGE IF CHECK IN SETUP_SERVERS'
        PRINT *, ' ***** RESETTING THE NUMBER OF SERVER GROUPS TO 100'
        PRINT *, ' ***** WE ARE CONTINUING ....   '
        IQUILT_GROUP = 100
    END IF
!
    IF (MYPE == 0) THEN
        PRINT *, ' WE WILL TRY TO RUN WITH ',IQUILT_GROUP,' SERVER GROUPS'
    END IF
!--------------------------------------------------------------------------------------------------  
! COMPUTE THE NUMBER OF SERVERS PER GROUP
! ALL MPI TASKS BEYOND NPES_MOD WILL BE SERVERS
! IF THE NUMBER OF SERVERS IS NOT EQUALLY DIVISIBLE BY THE NUMBER OF GROUPS OF SERVERS THEN SOME
! GROUPS MAY HAVE MORE SERVERS THEN 
! OTHERS - THIS IS FINE
! NOTE THAT WE REQUIRE AT LEAST ONE SERVER PER GROUP
! WE MAY NEED TO REDUCE THE NUMBER OF SERVER GROUPS IF IT EXCEEDS THE NUMBER OF SERVERS
!--------------------------------------------------------------------------------------------------
    IQSERVER = NPES - NPES_MOD
!
    IF (IQSERVER == 0) THEN
        IF (MYPE == 0) THEN
            PRINT *, ' YOU SPECIFIED 0 I/O SERVERS '
            PRINT *, ' CHKOUT WILL WRITE A FILE'
        END IF
!
        IQUILT_GROUP = 0
    END IF
!
    IF (IQUILT_GROUP > IQSERVER)  THEN
        IQUILT_GROUP = IQSERVER
        PRINT *, ' NOT ENOUGH SERVERS'
        PRINT *, ' WE NEED TO REDUCE THE NUMB OF SERVER GROUPS'
        PRINT *, ' NUMB OF SERVER GROUPS IS ', IQUILT_GROUP
    END IF
!
    DO I = 0, IQUILT_GROUP - 1
        CALL PARA_RANGE(1, IQSERVER, IQUILT_GROUP, I, ISTAQ, IENDQ)
!
        INUMQ(I+1) = IENDQ - ISTAQ + 1
        IF (MYPE == 0) PRINT *, ' I, INUMQ = ',I+1, INUMQ(I+1)
    END DO
!------------------------------------------------------------------------------- 
! SETUP THE "COLOR" FOR MPI_COMM_SPLIT
! THOSE TASKS WHICH WILL DO MODEL INTEGRATION WILL BE COLOR 0
! THE SERVER TASKS WILL HAVE THE COLOR OF THE GROUP NUMBER THAT THEY WILL BELONG
!-------------------------------------------------------------------------------
    IF (MYPE < NPES_MOD) THEN
        ICOLOR = 0
    ELSE
        ISTAXX = NPES_MOD
        DO I=1,IQUILT_GROUP
            IENDXX = ISTAXX + INUMQ(I) - 1
            IF (MYPE >= ISTAXX .AND. MYPE <= IENDXX) THEN
                ICOLOR = I
            END IF
            ISTAXX = IENDXX + 1
        END DO
    END IF
!--------------------------------------------------------------------------------------------------
! SPLIT THE COMMUNICATOR - THE NEW INTRACOMMUNICATOR FOR ALL TASKS IS MPI_COMM_COMP. 
! MPI_COMM_WORLD IS STILL AVAILABLE BUT IT DOES REFER TO ALL THE MPI TASKS ( MODEL INTEGRATION AND
! I/O SERVING )
!--------------------------------------------------------------------------------------------------
    CALL MPI_COMM_DUP(MPI_COMM_WORLD, COMDUP, IERR)
    CALL MPI_COMM_SPLIT(COMDUP, ICOLOR, MYPE, MPI_COMM_COMP, IERR)
!--------------------------------------------------------------------------------------------------
! AT THIS POINT WE HAVE A NEW COMMUNICATOR, MPI_COMM_COMP, THAT CAN BE USED BY THE FORECASTS TASKS 
! AND THE I/O SERVER TASKS FOR THEIR INTERNAL COMMUNICATIONS. ONTO THE INTERCOMMUNICATORS ...
!
! NOW WE MUST CREATE THE INTERCOMMUNICATORS FOR USE BETWEEN THE MPI TASKS DOING THE MODEL
! INTEGRATION AND THE MPI TASKS FOR EACH SERVER GROUP. THE FIRST STEP IS TO EXCLUDE THE TASKS THAT
! DONT BELONG. WE WILL DO THIS FOR EACH SERVER GROUP BY EXCLUDING THE TASKS FROM ALL OF THE OTHER
! SERVER GROUPS.
!--------------------------------------------------------------------------------------------------
    ALLOCATE (IRANK(IQSERVER))
    IXX = NPES_MOD
    DO I=1,IQUILT_GROUP
        YES = .TRUE. 
        IF (MYPE < NPES_MOD) THEN
            IRLR = IXX
        ELSE
            IRLR = 0
        END IF
!
        ICC = 0
        ISS = NPES_MOD
!---------------------------------------------------------- 
! THIS IS THE FIRST POSSIBLE TASK ID THAT COULD BE EXCLUDED
!----------------------------------------------------------
        DO JJ=1,IQUILT_GROUP
            IF (JJ /= I) THEN
                ISSL = ISS
                DO KK=1,INUMQ(JJ)
                    ICC        = ICC + 1
                    IRANK(ICC) = ISSL
                    IF (MYPE == ISSL) YES = .FALSE. 
                    ISSL = ISSL + 1 
                END DO
            END IF
            ISS = ISS + INUMQ(JJ)
        END DO
!--------------------------------------------------------------------------------------------------    
! AT THIS POINT WE HAVE AN ARRAY, IRANK, WITH TASK IDS TO EXCLUDE THERE ARE ICC OF THEM.
! CREATE A NEW GROUP WITH THE TASKS FROM THE OTHER SERVER GROUPS EXCLUDED AND THEN CREATE A NEW 
! COMMUNICATOR ( IWORLD_MINUS ) THAT CONTAINS ONLY THE MPI TASKS DOING THE MODEL INTEGRATION AND 
! THE TASKS THAT BLONG TO THE SERVER GROUP WE ARE CONSIDERING.
!--------------------------------------------------------------------------------------------------     
        IWORLD = MPI_COMM_WORLD
!
        CALL MPI_COMM_GROUP (IWORLD, IGROUP, IERR)
        CALL MPI_GROUP_EXCL (IGROUP, ICC     ,IRANK        , IGROUP_X, IERR)
        CALL MPI_COMM_CREATE(IWORLD, IGROUP_X, IWORLD_MINUS, IERR)
        CALL MPI_GROUP_FREE (IGROUP  , IERR)
        CALL MPI_GROUP_FREE (IGROUP_X, IERR)
!--------------------------------------------------------------------------------------------------     
! AT THIS POINT WE HAVE A COMMUNICATOR THAT EXCLUDES THE TASKS WE DONT WANT.
! CREATE AN INTERCOMMUNICATOR FOR USE BETWEEN THE MPI TASKS DOING THE MODEL INTEGRATION AND THE I/O
! SERVER GROUP WE ARE CONSIDERING. THIS PROCESS IS A COLLECTIVE ROUTINE SO IT CAN ONLY BE DONE BY
! THE TASKS THAT HAVE NOT BEEN EXCLUDED. SAVE THIS NEW COMMUNICATOR IN MPI_COMM_INTER FOR USE BY 
! THE TASKS THAT BELONG TO THE SERVER GROUP THAT WE ARE CONSIDERING. 
! THE TASKS THAT ARE PERFORMING THE MODEL INTEGRATION WILL REFERENCE MPI_COMM_INTER_ARRAY() SINCE 
! WE WILL NEED TO SELECT WHICH 
! SERVER GROUP WE WISH TO COMMUNICATE WITH.
!--------------------------------------------------------------------------------------------------   
        IF (YES) THEN
            CALL MPI_INTERCOMM_CREATE                                                             &
    &                     (MPI_COMM_COMP, 0, IWORLD_MINUS, IRLR, 0, MPI_COMM_INTER_ARRAY(I), IERR)
!
            MPI_COMM_INTER = MPI_COMM_INTER_ARRAY(I)
        END IF
!    
        CALL MPI_BARRIER(MPI_COMM_WORLD, IERR)
!------------------------------------------------- 
! END DO FOR LOOP OVER THE NUMBER OF SERVER GROUPS
!-------------------------------------------------
    END DO 
!--------------------------------------------------------------------
! NPES IS REALLY THE NUMBER OF TASKS WORKING ON THE MODEL INTEGRATION
!--------------------------------------------------------------------
    NPES = NPES - IQSERVER
!
    IF (MYPE == 0) THEN
        PRINT *, ' THE MODEL INTEGRATION IS USING ',NPES,' MPI TASK'
        PRINT *, ' THERE ARE ',IQSERVER,' I/O SERVERS'
    END IF
!
    DEALLOCATE (IRANK)
!
    END SUBROUTINE SETUP_SERVERS

    SUBROUTINE LWR88(HEATRA, GRNFLX, TOPFLX, PRESS, TEMP, RH2O, QO3, CLDFAC, CAMT, NCLDS,         &
    &                KTOP  , KBTM)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE LWR88
!>
!> SUBPROGRAM: LWR88 - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> SUBROUTINE LWR88 COMPUTES TEMPERATURE-CORRECTED CO2 TRANSMISSION FUNCTIONS AND ALSO COMPUTES THE 
!> PRESSURE GRID AND LAYER OPTICAL PATHS.
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????   - ORIGINATOR
!> 18-01-15  LUCCI   - MODERNIZATION OF THE CODE, INCLUDING:
!>                     * F77 TO F90/F95
!>                     * INDENTATION & UNIFORMIZATION CODE
!>                     * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                     * DOCUMENTATION WITH DOXYGEN
!>                     * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> PRESS  - 
!> TEMP   - 
!> RH2O   -
!> QO3    - 
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> HEATRA -
!> GRNFLX - 
!> TOPFLX - 
!> CLDFAC - 
!>
!> INPUT FILES:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CO2DTA
!>              F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              RNDDTA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : RADFS
!>
!> CALLS      : FST88
!>--------------------------------------------------------------------------------------------------
    USE CO2DTA
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE RNDDTA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!--------------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. NB,KO2 ARE SHORTWAVE PARAMETERS; 
!           OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!--------------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: NBLX   = 47
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     + 2 
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     = 2     * L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    + 3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    - 2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    - 3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   * LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  - 1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1V   = LP1   * (1 + 2 * L / 2)
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   = 3     * L  + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  = 3
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2 + 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2 - 1
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & PRESS   , TEMP
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(IN)          ::&
    & RH2O    , QO3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & CAMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                , INTENT(INOUT)       ::&
    & CLDFAC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1, LP1)                                      ::&
    & CO21
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & NCLDS
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & KTOP    , KBTM
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(INOUT)       ::&
    & HEATRA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                                             ::&
    & DELP2   , QH2O    , DELP    , CO2NBL  , VAR1    , VAR2    , VAR3    , VAR4    , VSUM4   ,   &
    & CO2MR   , CO2MD   , CO2M2D  , VV      
!  
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(INOUT)       ::&
    & GRNFLX  , TOPFLX
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & EMX1    , EMX2    , VSUM1   , VSUM2   , A1      , A2 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & T       , P       , CO2SP1  , CO2SP2  , CNTVAL  , TOTO3   , TPHIO3  , TOTPHI  , TOTVO2  ,   &
    & CO2R    , DIFT    , CO2R1   , DCO2D1  , D2CD21  , D2CD22  , CO2R2   , DCO2D2  , TDAV    ,   &
    & TSTDAV  , VSUM3   , DCO2DT  , D2CDT2  , TEXPSL  , TLSQU   
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP1)                                          ::&
    & EMPL
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , K       , KP 
!
    EQUIVALENCE (VSUM3, TLSQU, TEXPSL)
    EQUIVALENCE (VV   , VSUM4)
!----------------------------------------------------------------------------------- 
! COMPUTE FLUX PRESSURES (P) AND DIFFERENCES (DELP2,DELP)
! COMPUTE FLUX LEVEL TEMPERATURES (T) AND CONTINUUM TEMPERATURE CORRECTIONS (TEXPSL)
!-----------------------------------------------------------------------------------
    DO 103 K=2,L
        DO 103 I=MYIS,MYIE
            P(I,K) = HAF * (PRESS(I,K-1) + PRESS(I,K))
            T(I,K) = HAF * ( TEMP(I,K-1) +  TEMP(I,K))
103 END DO
!
    DO 105 I=MYIS,MYIE
        P(I,1  ) = ZERO
        P(I,LP1) = PRESS(I,LP1)
        T(I,1  ) =  TEMP(I,1  )
        T(I,LP1) =  TEMP(I,LP1)
105 END DO
!
    DO 107 K=1,L
        DO 107 I=MYIS,MYIE
            DELP2(I,K) = P(I,K+1) -      P(I,K)
             DELP(I,K) = ONE      /  DELP2(I,K)
107 END DO
!----------------------------------------------------------------------- 
! COMPUTE ARGUMENT FOR CONT.TEMP.COEFF. (THIS IS 1800.(1./TEMP-1./296.))
!-----------------------------------------------------------------------
    DO 125 K=1,LP1
        DO 125 I=MYIS,MYIE
            TEXPSL(I,K) = H18E3 / TEMP(I,K) - H6P08108
            TEXPSL(I,K) = EXP(TEXPSL(I,K))
125 END DO
!--------------------------------------------------------------------------------------------------
! COMPUTE OPTICAL PATHS FOR H2O AND O3, USING THE DIFFUSIVITY APPROXIMATION FOR THE ANGULAR 
! INTEGRATION (1.66).
! OBTAIN THE UNWEIGHTED VALUES(VAR1,VAR3) AND THE WEIGHTED VALUES(VAR2,VAR4).
! THE QUANTITIES H3M4(.0003) AND H3M3(.003) APPEARING IN THE VAR2 AND VAR4 EXPRESSIONS ARE THE 
! APPROXIMATE VOIGT CORRECTIONS FOR H2O AND O3,RESPECTIVELY.
!--------------------------------------------------------------------------------------------------
    DO 131 K=1,L
        DO 131 I=MYIS,MYIE
            QH2O(I,K) = RH2O(I,K) * DIFFCTR
!------------------------------------------------------------------------------------------- 
! VV IS THE LAYER-MEAN PRESSURE (IN ATM),WHICH IS NOT THE SAME AS THE LEVEL PRESSURE (PRESS)
!------------------------------------------------------------------------------------------- 
              VV(I,K) = HAF * (P(I,K+1) + P(I,K)) * P0INV
!
            VAR1(I,K) = DELP2(I,K) * QH2O(I,K) * GINV
            VAR3(I,K) = DELP2(I,K) *  QO3(I,K) * DIFFCTR * GINV
            VAR2(I,K) =  VAR1(I,K) *  (VV(I,K) + H3M4)
            VAR4(I,K) =  VAR3(I,K) *  (VV(I,K) + H3M3)
!--------------------------------------------------------------------------------------------------
! COMPUTE OPTICAL PATH FOR THE H2O CONTINUUM, USING ROBERTS COEFFS.
! (BETINW), AND TEMP. CORRECTION (TEXPSL). THE DIFFUSIVITY FACTOR (WHICH CANCELS OUT IN THIS
! EXPRESSION) IS ASSUMED TO BE 1.66. THE USE OF THE DIFFUSIVITY FACTOR HAS BEEN SHOWN TO BE A 
! SIGNIFICANT SOURCE OF ERROR IN THE CONTINUUM CALCS.,BUT THE TIME PENALTY OF AN ANGULAR 
! INTEGRATION IS SEVERE.
!--------------------------------------------------------------------------------------------------         
            CNTVAL(I,K) = TEXPSL(I,K) * RH2O(I,K) *VAR2(I,K) * BETINW / (RH2O(I,K) + RATH2OMW)
131 END DO
!-------------------------------------------------------  
! COMPUTE SUMMED OPTICAL PATHS FOR H2O, O3 AND CONTINUUM
!------------------------------------------------------- 
    DO 201 I=MYIS,MYIE
        TOTPHI(I,1) = ZERO
         TOTO3(I,1) = ZERO
        TPHIO3(I,1) = ZERO
        TOTVO2(I,1) = ZERO
201 END DO
!
    DO 203 K=2,LP1
        DO 203 I=MYIS,MYIE
            TOTPHI(I,K) = TOTPHI(I,K-1) +   VAR2(I,K-1)
             TOTO3(I,K) =  TOTO3(I,K-1) +   VAR3(I,K-1)
            TPHIO3(I,K) = TPHIO3(I,K-1) +   VAR4(I,K-1)
            TOTVO2(I,K) = TOTVO2(I,K-1) + CNTVAL(I,K-1)
203 END DO
!--------------------------------------------------------------------------------------------------
! EMX1 IS THE ADDITIONAL PRESSURE-SCALED MASS FROM PRESS(L) TO P(L). IT IS USED IN NEARBY LAYER AND
! EMISS CALCULATIONS.
! EMX2 IS THE ADDITIONAL PRESSURE-SCALED MASS FROM PRESS(L) TO P(LP1). IT IS USED IN CALCULATIONS 
! BETWEEN FLUX LEVELS L AND LP1.
!--------------------------------------------------------------------------------------------------
    DO 801 I=MYIS,MYIE
        EMX1(I) = QH2O(I,L) * PRESS(I,L) * (PRESS(I,L  ) -     P(I,L)) * GP0INV
        EMX2(I) = QH2O(I,L) * PRESS(I,L) * (    P(I,LP1) - PRESS(I,L)) * GP0INV
801 END DO
!--------------------------------------------------------------------------------------------------
! EMPL IS THE PRESSURE SCALED MASS FROM P(K) TO PRESS(K) (INDEX 2-LP1) 
! OR TO PRESS(K+1) (INDEX LP2-LL)
!--------------------------------------------------------------------------------------------------
    DO 811 K=1,L
        DO 811 I=MYIS,MYIE
            EMPL(I,K+1 )    = QH2O(I,K  ) * P(I,K+1) * (P(I,K+1) - PRESS(I,K  )) * GP0INV
811 END DO
!
    DO 812 K=1,LM1
        DO 812 I=MYIS,MYIE
            EMPL(I,LP2+K-1) = QH2O(I,K+1) * P(I,K+1) * (PRESS(I,K+1) - P(I,K+1)) * GP0INV
812 END DO
!
    DO 821 I=MYIS,MYIE
        EMPL(I,1   ) = VAR2(I,L)
        EMPL(I,LLP1) = EMPL(I,LL)
821 END DO
!----------------------------------------------------------------------------------------------- 
! COMPUTE WEIGHTED TEMPERATURE (TDAV) AND PRESSURE (TSTDAV) INTEGRALS FOR USE IN OBTAINING TEMP. 
! DIFFERENCE BET. SOUNDING AND STD. TEMP. SOUNDING (DIFT)
!-----------------------------------------------------------------------------------------------
    DO 161 I=MYIS,MYIE
        TSTDAV(I,1) = ZERO
          TDAV(I,1) = ZERO
161 END DO
!
    DO 162 K=1,LP1
        DO 162 I=MYIS,MYIE
            VSUM3(I,K) = TEMP(I,K) - STEMP(K)
162 END DO
!
    DO 163 K=1,L
        DO 165 I=MYIS,MYIE
            VSUM2(I) = GTEMP(K) * DELP2(I,K)
            VSUM1(I) = VSUM2(I) * VSUM3(I,K)
!
            TSTDAV(I,K+1) = TSTDAV(I,K) + VSUM2(I)
              TDAV(I,K+1) =   TDAV(I,K) + VSUM1(I)
    165 END DO
163 END DO
!------------------------------------------------------------- 
! EVALUATE COEFFICIENTS FOR CO2 PRESSURE INTERPOLATION (A1,A2)
!-------------------------------------------------------------
    DO 171 I=MYIS,MYIE
        A1(I) = (PRESS(I,LP1) - P0XZP8      ) / P0XZP2
        A2(I) = (P0           - PRESS(I,LP1)) / P0XZP2
171 END DO
!--------------------------------------------------------------------------------------------------
! PERFORM CO2 PRESSURE INTERPOLATION ON ALL INPUTTED TRANSMISSION FUNCTIONS AND TEMP. 
! DERIVATIVES SUCCESSIVELY COMPUTING CO2R,DCO2DT AND D2CDT2 IS DONE TO SAVE STORAGE 
! (AT A SLIGHT LOSS IN COMPUTATION TIME)
!--------------------------------------------------------------------------------------------------
    DO 184 K=1,LP1
        DO 184 I=MYIS,MYIE
             CO2R1(I,K) = A1(I) * CO231(K) + A2(I) * CO238(K)
            D2CD21(I,K) = H1M3  * (A1(I) * C2D31(K) + A2(I) * C2D38(K))
            DCO2D1(I,K) = H1M2  * (A1(I) * CDT31(K) + A2(I) * CDT38(K))
             CO2R2(I,K) = A1(I) * CO271(K) + A2(I) * CO278(K)
            D2CD22(I,K) = H1M3  * (A1(I) * C2D71(K) + A2(I) * C2D78(K))
            DCO2D2(I,K) = H1M2  * (A1(I) * CDT71(K) + A2(I) * CDT78(K))
184 END DO
!
    DO 190 K=1,L
        DO 190 I=MYIS,MYIE
             CO2MR(I,K) =         A1(I) * CO2M51(K) + A2(I) * CO2M58(K)
             CO2MD(I,K) = H1M2 * (A1(I) * CDTM51(K) + A2(I) * CDTM58(K))
            CO2M2D(I,K) = H1M3 * (A1(I) * C2DM51(K) + A2(I) * C2DM58(K))
190 END DO
!--------------------------------------------------------------------------------------------------
! COMPUTE CO2 TEMPERATURE INTERPOLATIONS FOR ALL BANDS, USING DIFT THE CASE WHERE K=1 IS HANDLED 
! FIRST.
! WE ARE NOW REPLACING 3-DIMENSIONAL ARRAYS BY 2-D ARRAYS, TO SAVE SPACE. 
! THUS THIS CALCULATION IS FOR (I,KP,1)
!--------------------------------------------------------------------------------------------------
    DO 211 KP=2,LP1
        DO 211 I=MYIS,MYIE
            DIFT(I,KP) = TDAV(I,KP) / TSTDAV(I,KP)
211 END DO
!
    DO 212 I=MYIS,MYIE
          CO21(I,1,1) = 1.0
        CO2SP1(I,1)   = 1.0
        CO2SP2(I,1)   = 1.0
212 END DO
!
    DO 215 KP=2,LP1
        DO 215 I=MYIS,MYIE
!------------------------------ 
! CALCULATIONS FOR KP>1 FOR K=1
!------------------------------
              CO2R(I,KP) =         A1(I) * CO251(KP,1) + A2(I) * CO258(KP,1)
            DCO2DT(I,KP) = H1M2 * (A1(I) * CDT51(KP,1) + A2(I) * CDT58(KP,1))
            D2CDT2(I,KP) = H1M3 * (A1(I) * C2D51(KP,1) + A2(I) * C2D58(KP,1))
!
            CO21(I,KP,1) = CO2R(I,KP) + DIFT(I,KP) * (DCO2DT(I,KP)                                &
    &                    +        HAF * DIFT(I,KP) *  D2CDT2(I,KP))
!-------------------------------------------------------------------------------------------        
! CALCULATIONS FOR (EFFECTIVELY) KP=1,K>KP. THESE USE THE SAME VALUE OF DIFT DUE TO SYMMETRY
!-------------------------------------------------------------------------------------------
            CO2R(I,KP)   =         A1(I) * CO251(1,KP) + A2(I) * CO258(1,KP)
            DCO2DT(I,KP) = H1M2 * (A1(I) * CDT51(1,KP) + A2(I) * CDT58(1,KP))
            D2CDT2(I,KP) = H1M3 * (A1(I) * C2D51(1,KP) + A2(I) * C2D58(1,KP))
!
            CO21(I,1,KP) = CO2R(I,KP) + DIFT(I,KP) * (DCO2DT(I,KP)                                &
    &                    +        HAF * DIFT(I,KP) *  D2CDT2(I,KP))
215 END DO
!--------------------------------------------------------------------------------------------------
! THE TRANSMISSION FUNCTIONS USED IN SPA88 MAY BE COMPUTED NOW.
! (IN THE 250 LOOP,DIFT REALLY SHOULD BE (I,1,K), BUT DIFT IS INVARIANT WITH RESPECT TO K, KP, AND
! SO (I,1,K)=(I,K,1))
!--------------------------------------------------------------------------------------------------
    DO 250 K=2,LP1
        DO 250 I=MYIS,MYIE
            CO2SP1(I,K) = CO2R1(I,K) + DIFT(I,K) * (DCO2D1(I,K) + HAF * DIFT(I,K) * D2CD21(I,K))
            CO2SP2(I,K) = CO2R2(I,K) + DIFT(I,K) * (DCO2D2(I,K) + HAF * DIFT(I,K) * D2CD22(I,K))
250 END DO
!--------------------------- 
! NEXT THE CASE WHEN K=2...L
!---------------------------
    DO 220 K=2,L
        DO 222 KP=K+1,LP1
            DO 222 I=MYIS,MYIE
                  DIFT(I,KP)    = (TDAV(I,KP) - TDAV(I,K)) / (TSTDAV(I,KP) - TSTDAV(I,K))
!
                  CO2R(I,KP)    =         A1(I) * CO251(KP,K) + A2(I) * CO258(KP,K)
                DCO2DT(I,KP)    = H1M2 * (A1(I) * CDT51(KP,K) + A2(I) * CDT58(KP,K))
                D2CDT2(I,KP)    = H1M3 * (A1(I) * C2D51(KP,K) + A2(I) * C2D58(KP,K))
!
                  CO21(I,KP ,K) = CO2R(I,KP) + DIFT(I,KP) * (DCO2DT(I,KP)                         &
    &                           +        HAF * DIFT(I,KP) * D2CDT2(I,KP))
!
                  CO2R(I,KP)    =         A1(I) * CO251(K,KP) + A2(I) * CO258(K,KP)
                DCO2DT(I,KP)    = H1M2 * (A1(I) * CDT51(K,KP) + A2(I) * CDT58(K,KP))
                D2CDT2(I,KP)    = H1M3 * (A1(I) * C2D51(K,KP) + A2(I) * C2D58(K,KP))
!
                  CO21(I,K ,KP) = CO2R(I,KP) + DIFT(I,KP) * (DCO2DT(I,KP)                         &
    &                           +        HAF  * DIFT(I,KP) * D2CDT2(I,KP))
    222 END DO
220 END DO
!------------------------------------
! FINALLY THE CASE WHEN K=KP,K=2..LP1
!------------------------------------
    DO 206 K=2,LP1
        DO 206 I=MYIS,MYIE
              DIFT(I,K)   = HAF  * (VSUM3(I,K) + VSUM3(I,K-1))
!
              CO2R(I,K)   =         A1(I) * CO251(K,K) + A2(I) * CO258(K,K)
            DCO2DT(I,K)   = H1M2 * (A1(I) * CDT51(K,K) + A2(I) * CDT58(K,K))
            D2CDT2(I,K)   = H1M3 * (A1(I) * C2D51(K,K) + A2(I) * C2D58(K,K))
!
              CO21(I,K,K) = CO2R(I,K) + DIFT(I,K) * (DCO2DT(I,K) + HAF * DIFT(I,K) * D2CDT2(I,K))
206 END DO
!---------------------------------------------- 
! WE ARENT DOING NBL TFS ON THE 100 CM-1 BANDS.
!----------------------------------------------
    DO 260 K=1,L
        DO 260 I=MYIS,MYIE
            CO2NBL(I,K) = CO2MR(I,K) + VSUM3(I,K) * (CO2MD(I,K) + HAF * VSUM3(I,K) * CO2M2D(I,K))
260 END DO
!----------------------------------------------------
! COMPUTE TEMP. COEFFICIENT BASED ON T(K) (SEE REF.2)
!----------------------------------------------------
    DO 264 K=1,LP1
        DO 264 I=MYIS,MYIE
            IF (T(I,K) <= H25E2) THEN
                TLSQU(I,K) =  B0 + (T(I,K) - H25E2)                                               &
    &                      * (B1 + (T(I,K) - H25E2) * (B2 + B3 * (T(I,K) - H25E2)))
            ELSE
                TLSQU(I,K) =  B0
            END IF
264 END DO
!--------------------- 
! APPLY TO ALL CO2 TFS
!---------------------
    DO 280 K=1,LP1
        DO 282 KP=1,LP1
            DO 282 I=MYIS,MYIE
                CO21(I,KP,K) = CO21(I,KP,K) * (ONE - TLSQU(I,KP)) + TLSQU(I,KP)
    282 END DO
280 END DO
!
    DO 284 K=1,LP1
        DO 286 I=MYIS,MYIE
            CO2SP1(I,K)      = CO2SP1(I,K)  * (ONE - TLSQU(I,1))  + TLSQU(I,1)
            CO2SP2(I,K)      = CO2SP2(I,K)  * (ONE - TLSQU(I,1))  + TLSQU(I,1)
    286 END DO
284 END DO
!
    DO 288 K=1,L
        DO 290 I=MYIS,MYIE
            CO2NBL(I,K)      = CO2NBL(I,K)  * (ONE - TLSQU(I,K))  + TLSQU(I,K)
    290 END DO
288 END DO
!
    CALL FST88(HEATRA, GRNFLX, TOPFLX, QH2O  , PRESS , P     , DELP  , DELP2 , TEMP  , T     ,    &
    &          CLDFAC, NCLDS , KTOP  , KBTM  , CAMT  , CO21  , CO2NBL, CO2SP1, CO2SP2, VAR1  ,    &
    &          VAR2  , VAR3  , VAR4  , CNTVAL, TOTO3 , TPHIO3, TOTPHI, TOTVO2, EMX1  , EMX2  ,    &
    &          EMPL)
!
    RETURN
!
    END SUBROUTINE LWR88

    MODULE ACMCLH
!>--------------------------------------------------------------------------------------------------
!> MODULE ACMCLH
!>
!> USE MODULES: F77KINDS
!>              PARMETA        
!>
!> DRIVER     : CHKOUT
!>              CUCNVC
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              INIT
!>              INITS
!>              PRECPD
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NHEAT
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & THEAT   , AVRAIN  , AVCNVC  , ARATIM  , ACUTIM 
! 
    REAL   (KIND=R4KIND), DIMENSION (IDIM1:IDIM2, JDIM1:JDIM2, LM)                              ::&
    & TRAIN   , TCUCN
!
    END MODULE ACMCLH

    SUBROUTINE GSMCOLUMN (ARAIN    , ASNOW , DTPH  , I_INDEX, J_INDEX, LSFC     ,                 &
    &                     P_COL    , QI_COL, QR_COL, QV_COL , QW_COL , RIMEF_COL, T_COL,          &
    &                     THICK_COL, WC_COL)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GSMCOLUMN
!>
!> SUBPROGRAM: GSMCOLUMN - GRID-SCALE MICROPHYSICAL PROCESSES - CONDENSATION AND PRECIPITATION
!> PROGRAMMER: FERRIER
!> ORG: W/NP22
!> DATE: 01-08-??
!>
!> ABSTRACT: 
!> MERGES ORIGINAL GSCOND AND PRECPD SUBROUTINES.
!> CODE HAS BEEN SUBSTANTIALLY STREAMLINED AND RESTRUCTURED.
!> EXCHANGE BETWEEN WATER VAPOR & SMALL CLOUD CONDENSATE IS CALCULATED USING THE ORIGINAL ASAI 
!> (1965, J. JAPAN) ALGORITHM.
!> SEE ALSO REFERENCES TO YAU AND AUSTIN (1979, JAS), RUTLEDGE AND HOBBS (1983, JAS), AND TAO 
!> ET AL. (1989, MWR).  
!> THIS ALGORITHM REPLACES THE SUNDQVIST ET AL. (1989, MWR) PARAMETERIZATION.
!>
!> VERSION OF MICROPHYSICS DESIGNED FOR HIGHER RESOLUTION MESO ETA MODEL
!> (1) REPRESENTS SEDIMENTATION BY PRESERVING A PORTION OF THE PRECIPITATION THROUGH TOP-DOWN 
!>     INTEGRATION FROM CLOUD-TOP. MODIFIED PROCEDURE TO ZHAO AND CARR (1997).
!>
!> (2) MICROPHYSICAL EQUATIONS ARE MODIFIED TO BE LESS SENSITIVE TO TIME STEPS BY USE OF CLAUSIUS-
!>     CLAPEYRON EQUATION TO ACCOUNT FOR CHANGES IN SATURATION MIXING RATIOS IN RESPONSE TO LATENT 
!>     HEATING/COOLING.
!>
!> (3) PREVENT SPURIOUS TEMPERATURE OSCILLATIONS ACROSS 0C DUE TO MICROPHYSICS.
!>
!> (4) USES LOOKUP TABLES FOR: CALCULATING TWO DIFFERENT VENTILATION COEFFICIENTS IN CONDENSATION 
!>     AND DEPOSITION PROCESSES;
!>     ACCRETION OF CLOUD WATER BY PRECIPITATION; PRECIPITATION MASS; 
!>     PRECIPITATION RATE (AND MASS-WEIGHTED PRECIPITATION FALL SPEEDS).
!>
!> (5) ASSUMES TEMPERATURE-DEPENDENT VARIATION IN MEAN DIAMETER OF LARGE ICE 
!>     (HOUZE ET AL., 1979; RYAN ET AL., 1996).
!>     8/22/01: THIS RELATIONSHIP HAS BEEN EXTENDED TO COLDER TEMPERATURES TO PARAMETERIZE SMALLER 
!>              LARGE-ICE PARTICLES DOWN TO MEAN SIZES OF MDIMIN, WHICH IS 50 MICRONS REACHED AT 
!>              -55.9C.
!>
!> (6) ATTEMPTS TO DIFFERENTIATE GROWTH OF LARGE AND SMALL ICE, MAINLY FOR IMPROVED TRANSITION FROM
!>     THIN CIRRUS TO THICK, PRECIPITATING ICE ANVILS.
!>     8/22/01: THIS FEATURE HAS BEEN DIMINISHED BY EFFECTIVELY ADJUSTING TO ICE SATURATION DURING 
!>              DEPOSITIONAL GROWTH AT TEMPERATURES COLDER THAN -10C.  ICE SUBLIMATION IS CALCULATED
!>              MORE EXPLICITLY. THE LOGIC IS THAT SOURCES OF ARE EITHER POORLY UNDERSTOOD 
!>              (E.G., NUCLEATION FOR NWP) OR ARE NOT REPRESENTED IN THE ETA MODEL 
!>              (E.G., DETRAINMENT OF ICE FROM CONVECTION). OTHERWISE THE MODEL IS TOO WET COMPARED 
!>              TO THE RADIOSONDE OBSERVATIONS BASED ON 1 FEB - 18 MARCH 2001 RETROSPECTIVE RUNS.
!>
!> (7) TOP-DOWN INTEGRATION ALSO ATTEMPTS TO TREAT MIXED-PHASE PROCESSES, ALLOWING A MIXTURE OF ICE 
!>     AND WATER.  BASED ON NUMEROUS OBSERVATIONAL STUDIES, ICE GROWTH IS BASED ON NUCLEATION AT 
!>     CLOUD TOP SUBSEQUENT GROWTH BY VAPOR DEPOSITION AND RIMING AS THE ICE PARTICLES FALL THROUGH 
!>     THE CLOUD. EFFECTIVE NUCLEATION RATES ARE A FUNCTION OF ICE SUPERSATURATION FOLLOWING MEYERS
!>     ET AL. (JAM, 1992).
!>     8/22/01: THE SIMULATED RELATIVE HUMIDITIES WERE FAR TOO MOIST COMPARED TO THE RAWINSONDE 
!>              OBSERVATIONS. THIS FEATURE HAS BEEN SUBSTANTIALLY DIMINISHED, LIMITED TO A MUCH 
!>              NARROWER TEMPERATURE RANGE OF 0 TO -10C.
!>
!> (8) DEPOSITIONAL GROWTH OF NEWLY NUCLEATED ICE IS CALCULATED FOR LARGE TIME STEPS USING FIG. 8 
!>     OF MILLER AND YOUNG (JAS, 1979), AT 1 DEG INTERVALS USING THEIR ICE CRYSTAL MASSES CALCULATED
!>     AFTER 600 S OF GROWTH IN WATER SATURATED CONDITIONS. THE GROWTH RATES ARE NORMALIZED BY TIME
!>     STEP ASSUMING 3D GROWTH WITH TIME**1.5 FOLLOWING EQ. (6.3) IN YOUNG (1993).
!>     8/22/01: THIS FEATURE HAS BEEN EFFECTIVELY LIMITED TO 0 TO -10C.
!>
!> (9) ICE PRECIPITATION RATES CAN INCREASE DUE TO INCREASE IN RESPONSE TO CLOUD WATER RIMING DUE TO
!>     (A) INCREASED DENSITY AND MASS OF THE RIMED ICE, AND (B) INCREASED FALL SPEEDS OF RIMED ICE.
!>     8/22/01: THIS FEATURE HAS BEEN EFFECTIVELY LIMITED TO 0 TO -10C.
!>
!> NOTE:  CODE IS CURRENTLY SET UP W/O THREADING
!> 
!> PROGRAM HISTORY LOG:
!> 01-08-??  FERRIER    - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> DTPH       - PHYSICS TIME STEP (S)
!> I_INDEX    - I INDEX
!> J_INDEX    - J INDEX
!> LSFC       - ETA LEVEL OF LEVEL ABOVE SURFACE, GROUND
!> P_COL      - VERTICAL COLUMN OF MODEL PRESSURE (PA)
!> THICK_COL  - VERTICAL COLUMN OF MODEL MASS THICKNESS (DENSITY*HEIGHT INCREMENT)
!>
!> OUTPUT ARGUMENT LIST:
!> ARAIN      - ACCUMULATED RAINFALL AT THE SURFACE (KG)
!> ASNOW      - ACCUMULATED SNOWFALL AT THE SURFACE (KG)
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> QI_COL     - VERTICAL COLUMN OF MODEL ICE MIXING RATIO (KG/KG)
!> QR_COL     - VERTICAL COLUMN OF MODEL RAIN RATIO (KG/KG)
!> QV_COL     - VERTICAL COLUMN OF MODEL WATER VAPOR SPECIFIC HUMIDITY (KG/KG)
!> QW_COL     - VERTICAL COLUMN OF MODEL CLOUD WATER MIXING RATIO (KG/KG)
!> RIMEF_COL  - VERTICAL COLUMN OF RIME FACTOR FOR ICE IN MODEL (RATIO, DEFINED BELOW)
!> T_COL      - VERTICAL COLUMN OF MODEL TEMPERATURE (DEG K)
!> WC_COL     - VERTICAL COLUMN OF MODEL MIXING RATIO OF TOTAL CONDENSATE (KG/KG)
!>
!> USE MODULES: CMICRO_CONS
!>              CMICRO_STATS
!>              CMY600
!>              F77KINDS
!>              GLB_TABLE
!>              IACCR_TABLES 
!>              IMASS_TABLES
!>              IRATE_TABLES
!>              IRIME_TABLES
!>              IVENT_TABLES
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              RACCR_TABLES
!>              RRATE_TABLES
!>              RVELR_TABLES
!>              RVENT_TABLES
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : GSMDRIVE
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CMICRO_CONS
    USE CMICRO_STATS
    USE CMY600
    USE F77KINDS
    USE GLB_TABLE
    USE IACCR_TABLES
    USE IMASS_TABLES
    USE IRATE_TABLES
    USE IRIME_TABLES
    USE IVENT_TABLES
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE RACCR_TABLES
    USE RRATE_TABLES
    USE RVELR_TABLES
    USE RVENT_TABLES
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!-------------------------------------- 
! ARRAYS AND CONSTANTS IN ARGUMENT LIST
!--------------------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)         ::&
    & ARAIN   , ASNOW      
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::& 
    & P_COL   , THICK_COL 
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(INOUT)       ::& 
    & QI_COL  , QR_COL  , QV_COL  , QW_COL  , RIMEF_COL, T_COL  , WC_COL
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & I_INDEX , J_INDEX , LSFC
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTPH     
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TK       , TC      , PP        , QV       , WV       , ESW     , FPVS0   , QSW       ,      &
    & WS       , ESI     , FPVS      , QSI      , QSWGRD   , QSIGRD  , WSGRD   , RHO       ,      &
    & DTRHO    , BLDTRH  , THICK     , ARAINNEW , ASNOWNEW , QI      , WC      , RRHO      ,      &
    & QINEW    , QR      , QRNEW     , QW       , QWNEW    , PCOND   , PIDEP   , PIACW     ,      &
    & PIACWI   , PIACWR  , PIACR     , PICND    , PIEVP    , PIMLT   , PRAUT   , PRACW     ,      &
    & PREVP    , XLV     , XLF       , XLV1     , XLF1     , TK2     , XLV2    , DENOMW    ,      &
    & TFACTOR  , DYNVIS  , THERM_COND, DIFFUS   , GAMMAS   , GAMMAR  , QLICE   , QTICE     ,      &
    & WVQW     , FLARGE  , FSMALL    , XSIMASS  , TOT_ICE  , PILOSS  , RIMEF1  , TOT_ICENEW,      &
    & VRIMEF   , VEL_INC , VSNOW     , XLIMASS  , FLIMASS  , DUM     , DUM1    , DUM2      ,      &
    & XRF      , XLI     , DLI       , QW0      , FWS      , DEPOSIT , DWVI    , DENOMI    ,      &
    & PIDEP_MAX, SFACTOR , ABI       , VENTIL   , VENTIS   , DIDEP   , CONDENSE, DENOMWI   ,      &
    & DENOMF   , TCC     , AIEVP     , DIEVP    , QSW0     , DWV0    , TOT_RAIN, VRAIN1    ,      &
    & QTRAIN   , PRLOSS  , RQR       , RR       , DWVR     , RFACTOR ,                            &
    & ABW      , VENTR   , CREVP     , FWR      , FIR      , DELW    , DELT    , TNEW      ,      &
    & DELV     , WVNEW   , DELI      , RIMEF    , VRAIN2   , WCNEW   , QT      , QTNEW     ,      &
    & BUDGET   , QSWNEW  , QSINEW    , WSNEW    , DELR     , TOT_RAINNEW
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & L        , LBEF    , IPASS     , IXS      , IXRF     , INDEX_MY, IDR     , ITDX      ,      &
    & INDEXR1  , INDEXR  , INDEXS   
!--------------------------------------------------------------------------------------------------
! KEY PARAMETERS, LOCAL VARIABLES, AND IMPORTANT COMMENTS 
!
! KEY PARAMETERS:
! COMMENTS ON 2 AUGUST 2000
! EPSQ=1.E-20 IS THE LOWER LIMIT FOR SPECIFIC HUMIDITY AND CLOUD CONDENSATE. 
! THE VALUE OF EPSQ WILL NEED TO BE CHANGED IN THE OTHER SUBROUTINES IN ORDER TO MAKE IT CONSISTENT
! THROUGHOUT THE ETA CODE.
! - NLIMAX - MAXIMUM NUMBER CONCENTRATION OF LARGE ICE CRYSTALS (20,000 /M**3, 20 PER LITER)
! - NLIMIN - MINIMUM NUMBER CONCENTRATION OF LARGE ICE CRYSTALS (100 /M**3, 0.1 PER LITER)
!--------------------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), PARAMETER :: CP         = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ       =    1.E-20      
    REAL   (KIND=R4KIND), PARAMETER :: EPSW       =    1.E-12    
    REAL   (KIND=R4KIND), PARAMETER :: RD         =  287.04    
    REAL   (KIND=R4KIND), PARAMETER :: RHOL       = 1000.   
    REAL   (KIND=R4KIND), PARAMETER :: RV         =  461.5 
    REAL   (KIND=R4KIND), PARAMETER :: T0C        =  273.15        
    REAL   (KIND=R4KIND), PARAMETER :: XLS        =    2.834E6    
    REAL   (KIND=R4KIND), PARAMETER :: EPS        = RD         / RV     
    REAL   (KIND=R4KIND), PARAMETER :: NLIMAX     =   20.E3   
    REAL   (KIND=R4KIND), PARAMETER :: NLIMIN     =  100.    
    REAL   (KIND=R4KIND), PARAMETER :: T_ICE      =  -10.        
    REAL   (KIND=R4KIND), PARAMETER :: T_ICE_INIT =   -5. 
    REAL   (KIND=R4KIND), PARAMETER :: TOLER      =    5.E-7   
    REAL   (KIND=R4KIND), PARAMETER :: CLIMIT     =   10.      * EPSQ      
    REAL   (KIND=R4KIND), PARAMETER :: CLIMIT1    = -CLIMIT 
    REAL   (KIND=R4KIND), PARAMETER :: EPS1       = RV         / RD - 1.     
    REAL   (KIND=R4KIND), PARAMETER :: RCP        =    1.      / CP      
    REAL   (KIND=R4KIND), PARAMETER :: RCPRV      = RCP        / RV  
    REAL   (KIND=R4KIND), PARAMETER :: RRHOL      =    1.      / RHOL  
    REAL   (KIND=R4KIND), PARAMETER :: XLS1       = XLS        * RCP   
    REAL   (KIND=R4KIND), PARAMETER :: XLS2       = XLS        * XLS * RCPRV 
    REAL   (KIND=R4KIND), PARAMETER :: XLS3       = XLS        * XLS / RV
    REAL   (KIND=R4KIND), PARAMETER :: C1         =    1.      / 3.      
    REAL   (KIND=R4KIND), PARAMETER :: C2         =    1.      / 6.       
    REAL   (KIND=R4KIND), PARAMETER :: C3         =    3.31    / 6.     
    REAL   (KIND=R4KIND), PARAMETER :: DMR1       =     .1E-3        
    REAL   (KIND=R4KIND), PARAMETER :: DMR2       =     .2E-3     
    REAL   (KIND=R4KIND), PARAMETER :: DMR3       =     .32E-3   
    REAL   (KIND=R4KIND), PARAMETER :: N0R0       =    8.E6      
    REAL   (KIND=R4KIND), PARAMETER :: N0RMIN     =    1.E4    
    REAL   (KIND=R4KIND), PARAMETER :: N0S0       =    4.E6         
    REAL   (KIND=R4KIND), PARAMETER :: RHO0       =    1.194    
    REAL   (KIND=R4KIND), PARAMETER :: XMR1       =    1.E6    * DMR1 
    REAL   (KIND=R4KIND), PARAMETER :: XMR2       =    1.E6    * DMR2 
    REAL   (KIND=R4KIND), PARAMETER :: XMR3       =    1.E6    * DMR3 
    REAL   (KIND=R4KIND), PARAMETER :: XRATIO     =     .025
!
    INTEGER(KIND=I4KIND), PARAMETER :: MDR1       = XMR1
    INTEGER(KIND=I4KIND), PARAMETER :: MDR2       = XMR2
    INTEGER(KIND=I4KIND), PARAMETER :: MDR3       = XMR3
!-------------------------------------------------------------------------------------------------- 
! IF BLEND=1:
! PRECIPITATION (LARGE) ICE AMOUNTS ARE ESTIMATED AT EACH LEVEL AS A BLEND OF ICE FALLING FROM THE 
! GRID POINT ABOVE AND THE PRECIP ICE PRESENT AT THE START OF THE TIME STEP (SEE TOT_ICE BELOW).
! IF BLEND=0:
! PRECIPITATION (LARGE) ICE AMOUNTS ARE ESTIMATED TO BE THE PRECIP ICE PRESENT AT THE START OF THE
! TIME STEP.
!
! EXTENDED TO INCLUDE SEDIMENTATION OF RAIN ON 2/5/01
!-------------------------------------------------------------------------------------------------- 
    REAL   (KIND=R4KIND), PARAMETER :: BLEND = 1.
!----------------------------------------------------  
! THIS VARIABLE IS FOR DEBUGGING PURPOSES (IF .TRUE.)
!---------------------------------------------------- 
    LOGICAL(KIND=L4KIND), PARAMETER :: PRINT_DIAG = .TRUE. 
!----------------  
! LOCAL VARIABLES
!----------------
    REAL   (KIND=R4KIND)                                                                        ::&
    & EMAIRI  , N0R     , NLICE   , NSMICE
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & CLEAR   , ICE_LOGICAL       , DBG_LOGICAL           , DIAG_PRINT    , RAIN_LOGICAL
!---------------- 
! BEGIN EXECUTION  
!----------------
    ARAIN      = 0. ! ACCUMULATED RAINFALL INTO GRID BOX FROM ABOVE (KG/M**2)
    ASNOW      = 0. ! ACCUMULATED SNOWFALL INTO GRID BOX FROM ABOVE (KG/M**2)
!
    DIAG_PRINT = .FALSE. 
!---------------------------------------- 
! LOOP FROM TOP (L=1) TO SURFACE (L=LSFC) 
!----------------------------------------
    DO 10 L=1,LSFC
!-------------------------------------------------------------------------------------------------
! SKIP THIS LEVEL AND GO TO THE NEXT LOWER LEVEL IF NO CONDENSATE AND VERY LOW SPECIFIC HUMIDITIES
!-------------------------------------------------------------------------------------------------
        IF (QV_COL(L) <= EPSQ .AND. WC_COL(L) <= EPSQ) GOTO 10
!--------------------------------------------- 
! PROCEED WITH CLOUD MICROPHYSICS CALCULATIONS 
!--------------------------------------------- 
        TK = T_COL(L)     ! TEMPERATURE (DEG K)
        TC = TK - T0C     ! TEMPERATURE (DEG C)
        PP = P_COL(L)     ! PRESSURE (PA)
        QV = QV_COL(L)    ! SPECIFIC HUMIDITY OF WATER VAPOR (KG/KG)
        WV = QV / (1.-QV) ! WATER VAPOR MIXING RATIO (KG/KG)
        WC = WC_COL(L)    ! GRID-SCALE MIXING RATIO OF TOTAL CONDENSATE (WATER OR ICE; KG/KG)   
!-------------------------------------------------------------------- 
! MOISTURE VARIABLES BELOW ARE MIXING RATIOS & NOT SPECIFC HUMIDITIES
!--------------------------------------------------------------------   
        CLEAR = .TRUE. 
!-------------------------------------------------------------------------------    
! THIS CHECK IS TO DETERMINE GRID-SCALE SATURATION WHEN NO CONDENSATE IS PRESENT
!-------------------------------------------------------------------------------   
        ESW = 1000. * FPVS0(TK)          ! SATURATION VAPOR PRESSURE W/R/T WATER
        QSW = EPS   * ESW / (PP-ESW)     ! SATURATION MIXING RATIO W/R/T WATER
        WS  = QSW                        ! GENERAL SATURATION MIXING RATIO (WATER/ICE)
!
        IF (TC < 0.) THEN
            ESI = 1000. * FPVS(TK)       ! SATURATION VAPOR PRESSURE W/R/T ICE
            QSI = EPS   * ESI / (PP-ESI) ! SATURATION MIXING RATIO W/R/T WATER
            WS  = QSI                    ! GENERAL SATURATION MIXING RATIO (WATER/ICE)
        END IF
!----------------------------------------------     
! EFFECTIVE GRID-SCALE SATURATION MIXING RATIOS
!-----------------------------------------------------------------------
        QSWGRD = RHGRD * QSW
        QSIGRD = RHGRD * QSI
        WSGRD  = RHGRD * WS
!------------------------------------------------     
! CHECK IF AIR IS SUBSATURATED AND W/O CONDENSATE
!------------------------------------------------   
        IF (WV > WSGRD .OR. WC > EPSW) CLEAR = .FALSE. 
!---------------------------------------------------     
! CHECK IF ANY RAIN IS FALLING INTO LAYER FROM ABOVE
!---------------------------------------------------    
        IF (ARAIN > CLIMIT) THEN
            CLEAR = .FALSE. 
        ELSE
            ARAIN = 0.
        END IF
!-----------------------------------------------------------------------------------------    
! CHECK IF ANY ICE IS FALLING INTO LAYER FROM ABOVE
!    
! NOTE THAT "SNOW" IN VARIABLE NAMES IS SYNONOMOUS WITH LARGE, PRECIPITATION ICE PARTICLES
!----------------------------------------------------------------------------------------- 
        IF (ASNOW > CLIMIT) THEN
            CLEAR = .FALSE. 
        ELSE
            ASNOW = 0.
        END IF
!----------------------------------------------------------------- 
! LOOP TO THE END IF IN CLEAR, SUBSATURATED AIR FREE OF CONDENSATE 
!----------------------------------------------------------------- 
        IF (CLEAR) GOTO 10
!-------------------------------------------------------------------------------------------------- 
! INITIALIZE RHO, THICK AND MICROPHYSICAL PROCESSES 
!
! VIRTUAL TEMPERATURE, TV=T*(1./EPS-1)*Q, Q IS SPECIFIC HUMIDITY; 
! (SEE PP. 63-65 IN FLEAGLE & BUSINGER, 1963)
!--------------------------------------------------------------------------------------------------
        RHO    = PP / (RD * TK * (1. + EPS1 * QV)) ! AIR DENSITY (KG/M**3)
        RRHO   = 1. / RHO                          ! RECIPROCAL OF AIR DENSITY
        DTRHO  = DTPH  * RHO                       ! TIME STEP * AIR DENSITY
        BLDTRH = BLEND * DTRHO                 ! BLEND PARAMETER * TIME STEP * AIR DENSITY
        THICK  = THICK_COL(L)                      ! LAYER THICKNESS = RHO*DZ = -DP/G = 
                                                   ! (PSFC-PTOP)*D_ETA/(G*ETA_SFC)
!    
        ARAINNEW = 0.                      ! UPDATED ACCUMULATED RAINFALL
        ASNOWNEW = 0.                      ! UPDATED ACCUMULATED SNOWFALL
        QI       = QI_COL(L)               ! ICE MIXING RATIO
        QINEW    = 0.                      ! UPDATED ICE MIXING RATIO
        QR       = QR_COL(L)               ! RAIN MIXING RATIO
        QRNEW    = 0.                      ! UPDATED RAIN RATIO
        QW       = QW_COL(L)               ! CLOUD WATER MIXING RATIO
        QWNEW    = 0.                      ! UPDATED CLOUD WATER RATIO
!    
        PCOND  = 0.            ! CONDENSATION (>0) OR EVAPORATION (<0) OF CLOUD WATER (KG/KG)
        PIDEP  = 0.            ! DEPOSITION (>0) OR SUBLIMATION (<0) OF ICE CRYSTALS (KG/KG)
        PIACW  = 0.            ! CLOUD WATER COLLECTION (RIMING) BY PRECIPITATION ICE (KG/KG; >0)
        PIACWI = 0.            ! GROWTH OF PRECIP ICE BY RIMING (KG/KG; >0)
        PIACWR = 0.            ! SHEDDING OF ACCRETED CLOUD WATER TO FORM RAIN (KG/KG; >0)
        PIACR  = 0.            ! FREEZING OF RAIN ONTO LARGE ICE AT SUPERCOOLED TEMPS (KG/KG; >0)
        PICND  = 0.            ! CONDENSATION (>0) ONTO WET, MELTING ICE (KG/KG)
        PIEVP  = 0.            ! EVAPORATION (<0) FROM WET, MELTING ICE (KG/KG)
        PIMLT  = 0.            ! MELTING ICE (KG/KG; >0)
        PRAUT  = 0.            ! CLOUD WATER AUTOCONVERSION TO RAIN (KG/KG; >0)
        PRACW  = 0.            ! CLOUD WATER COLLECTION (ACCRETION) BY RAIN (KG/KG; >0)
        PREVP  = 0.            ! RAIN EVAPORATION (KG/KG; <0)
!---------------------------------------------    
! DOUBLE CHECK INPUT HYDROMETEOR MIXING RATIOS
!--------------------------------------------- 
!    
!------------------------------------------ 
! MAIN MICROPHYSICS CALCULATIONS NOW FOLLOW 
!------------------------------------------ 
!
!--------------------------------------------------------------- 
! CALCULATE A FEW VARIABLES, WHICH ARE USED MORE THAN ONCE BELOW
!--------------------------------------------------------------- 
!
!--------------------------------------------------------------------------------
! LATENT HEAT OF VAPORIZATION AS A FUNCTION OF TEMPERATURE FROM BOLTON (1980,JAS)
!--------------------------------------------------------------------------------    
        XLV    = 3.148E6 - 2370 * TK        ! LATENT HEAT OF VAPORIZATION (LV)
        XLF    = XLS - XLV                  ! LATENT HEAT OF FUSION (LF)
        XLV1   = XLV * RCP                  ! LV/CP
        XLF1   = XLF * RCP                  ! LF/CP
        TK2    = 1. / (TK*TK)               ! 1./TK**2
        XLV2   = XLV * XLV * QSW * TK2 / RV ! LV**2*QSW/(RV*TK**2)
        DENOMW = 1. + XLV2 * RCP            ! DENOMINATOR TERM, CLAUSIUS-CLAPEYRON CORRECTION
!-------------------------------------------------     
! BASIC THERMODYNAMIC QUANTITIES
! DYNVIS - DYNAMIC VISCOSITY  [ KG/(M*S) ]
! THERM_COND - THERMAL CONDUCTIVITY  [ J/(M*S*K) ]
! DIFFUS - DIFFUSIVITY OF WATER VAPOR  [ M**2/S ]
!-------------------------------------------------     
        TFACTOR    = TK ** 1.5 / (TK + 120.)
        DYNVIS     = 1.496E-6 * TFACTOR
        THERM_COND = 2.116E-3 * TFACTOR
        DIFFUS     = 8.794E-5 * TK ** 1.81 / PP
!--------------------------------------------------------------------------------------------------    
! AIR RESISTANCE TERM FOR THE FALL SPEED OF ICE FOLLOWING THE BASIC RESEARCH BY HEYMSFIELD, 
! KAJIKAWA, OTHERS
!--------------------------------------------------------------------------------------------------   
        GAMMAS = (1.E5 / PP) ** C1
!--------------------------------------------------------------------------------------------------   
! AIR RESISTANCE FOR RAIN FALL SPEED (BEARD, 1985, JAS, P.470)
!-------------------------------------------------------------------------------------------------- 
        GAMMAR = (RHO0 / RHO) ** .4
!-------------------------------------  
! IMPORTANT MICROPHYSICS DECISION TREE 
!-------------------------------------   
!
!---------------------------------------------------  
! DETERMINE IF CONDITIONS SUPPORTING ICE ARE PRESENT
!--------------------------------------------------- 
        IF (TC < 0. .OR. QI > CLIMIT .OR. ASNOW > CLIMIT) THEN
            ICE_LOGICAL = .TRUE. 
        ELSE
            ICE_LOGICAL = .FALSE. 
            QLICE = 0.
            QTICE = 0.
        END IF
!-----------------------------  
! DETERMINE IF RAIN IS PRESENT
!----------------------------- 
        RAIN_LOGICAL = .FALSE. 
!
        IF (ARAIN > CLIMIT .OR. QR > CLIMIT) RAIN_LOGICAL = .TRUE. 
!    
        IF (ICE_LOGICAL) THEN
!--------------------------------------------------------------------------------------------------     
! IMPORTANT:  ESTIMATE TIME-AVERAGED PROPERTIES.
!
! FLARGE  - RATIO OF NUMBER OF LARGE ICE TO TOTAL (LARGE & SMALL) ICE
! FSMALL  - RATIO OF NUMBER OF SMALL ICE CRYSTALS TO LARGE ICE PARTICLES
!           SMALL ICE PARTICLES ARE ASSUMED TO HAVE A MEAN DIAMETER OF 50 MICRONS.
! XSIMASS - USED FOR CALCULATING SMALL ICE MIXING RATIO
!
! TOT_ICE - TOTAL MASS (SMALL & LARGE) ICE BEFORE MICROPHYSICS, WHICH IS THE SUM OF THE TOTAL MASS 
!           OF LARGE ICE IN THE CURRENT LAYER AND THE INPUT FLUX OF ICE FROM ABOVE
! PILOSS  - GREATEST LOSS (<0) OF TOTAL (SMALL & LARGE) ICE BY SUBLIMATION, REMOVING ALL OF THE ICE 
!           FALLING FROM ABOVE AND THE ICE WITHIN THE LAYER
! RIMEF1  - RIME FACTOR, WHICH IS THE MASS RATIO OF TOTAL (UNRIMED & RIMED) ICE MASS TO THE UNRIMED
!           ICE MASS (>=1)
! VRIMEF  - THE VELOCITY INCREASE DUE TO RIME FACTOR OR MELTING (RATIO, >=1)
! VSNOW   - FALL SPEED OF RIMED SNOW W/ AIR RESISTANCE CORRECTION
! EMAIRI  - EQUIVALENT MASS OF AIR ASSOCIATED LAYER AND WITH FALL OF SNOW INTO LAYER
! XLIMASS - USED FOR CALCULATING LARGE ICE MIXING RATIO
! FLIMASS - MASS FRACTION OF LARGE ICE
! QTICE   - TIME-AVERAGED MIXING RATIO OF TOTAL ICE
! QLICE   - TIME-AVERAGED MIXING RATIO OF LARGE ICE
! NLICE   - TIME-AVERAGED NUMBER CONCENTRATION OF LARGE ICE
! NSMICE  - NUMBER CONCENTRATION OF SMALL ICE CRYSTALS AT CURRENT LEVEL
! 
! ASSUMED NUMBER FRACTION OF LARGE ICE PARTICLES TO TOTAL (LARGE & SMALL) ICE PARTICLES, WHICH IS 
! BASED ON A GENERAL IMPRESSION OF THE LITERATURE.
!--------------------------------------------------------------------------------------------------   
            WVQW = WV + QW                ! WATER VAPOR AND CLOUD WATER
!        
            IF (TC >= 0. .OR. WVQW < QSIGRD) THEN
!-----------------------------------------------------------------------              
! ELIMINATE SMALL ICE PARTICLE CONTRIBUTIONS FOR MELTING AND SUBLIMATION
!-----------------------------------------------------------------------   
                FLARGE = 1.
            ELSE
!--------------------------------------------------------------------------------------------------            
! ENHANCED NUMBER OF SMALL ICE PARTICLES DURING DEPOSITIONAL GROWTH 
! (EFFECTIVE ONLY WHEN 0C > T >= T_ICE [-10C])
!--------------------------------------------------------------------------------------------------   
                FLARGE = .2
!-------------------------------------------------------------             
! LARGER NUMBER OF SMALL ICE PARTICLES DUE TO RIME SPLINTERING
!------------------------------------------------------------- 
                IF (TC >= -8. .AND. TC <= -3.) FLARGE = .5 * FLARGE
            
            END IF  ! END IF (TC >= 0. .OR. WVQW < QSIGRD)
!
            FSMALL  = (1. - FLARGE) / FLARGE
            XSIMASS = RRHO * MASSI(MDIMIN) * FSMALL
!
            IF (QI <= CLIMIT .AND. ASNOW <= CLIMIT) THEN
                INDEXS  = MDIMIN
                TOT_ICE = 0.
                PILOSS  = 0.
                RIMEF1  = 1.
                VRIMEF  = 1.
                VEL_INC = GAMMAS
                VSNOW   = 0.
                EMAIRI  = THICK
                XLIMASS = RRHO * RIMEF1 * MASSI(INDEXS)
                FLIMASS = XLIMASS / (XLIMASS + XSIMASS)
                QLICE   = 0.
                QTICE   = 0.
                NLICE   = 0.
                NSMICE  = 0.
            ELSE
!--------------------------------------------------------------------------------------------------        
! FOR T<0C MEAN PARTICLE SIZE FOLLOWS HOUZE ET AL. (JAS, 1979, P. 160), CONVERTED FROM FIG. 5 PLOT 
! OF LAMDAS. SIMILAR SET OF RELATIONSHIPS ALSO SHOWN IN FIG. 8 OF RYAN (BAMS, 1996, P. 66).
!--------------------------------------------------------------------------------------------------  
                DUM     = XMIMAX * EXP(.0536 * TC)
                INDEXS  = MIN(MDIMAX, MAX(MDIMIN, INT(DUM)))
                TOT_ICE = THICK * QI + BLEND * ASNOW
                PILOSS  = -TOT_ICE / THICK
                LBEF    = MAX(1,L-1)
                DUM1    = RIMEF_COL(LBEF)
                DUM2    = RIMEF_COL(L)
                RIMEF1  = (DUM2 * THICK * QI + DUM1 * BLEND * ASNOW) / TOT_ICE
                RIMEF1  = MIN(RIMEF1, RFMAX)
!
                DO IPASS=0,1
                    IF (RIMEF1 <= 1.) THEN
                        RIMEF1 = 1.
                        VRIMEF = 1.
                    ELSE
                        IXS  = MAX(2, MIN(INDEXS/100, 9))
                        XRF  = 10.492 * ALOG (RIMEF1)
                        IXRF = MAX(0, MIN(INT(XRF), NRIME))
!
                        IF (IXRF >= NRIME) THEN
                            VRIMEF = VEL_RF(IXS,NRIME)
                        ELSE
                            VRIMEF =  VEL_RF(IXS,IXRF)   + (XRF-FLOAT(IXRF))                      &
    &                              * (VEL_RF(IXS,IXRF+1) - VEL_RF(IXS,IXRF))
                        END IF
!
                    END IF             ! END IF (RIMEF1 <= 1.)
!
                    VEL_INC = GAMMAS  * VRIMEF
                    VSNOW   = VEL_INC * VSNOWI(INDEXS)
                    EMAIRI  = THICK   + BLDTRH * VSNOW
                    XLIMASS = RRHO    * RIMEF1 * MASSI(INDEXS)
                    FLIMASS = XLIMASS / (XLIMASS + XSIMASS)
                    QTICE   = TOT_ICE / EMAIRI
                    QLICE   = FLIMASS * QTICE
                    NLICE   = QLICE   / XLIMASS
                    NSMICE  = FSMALL  * NLICE
                
                    IF ( (NLICE >= NLIMIN .AND. NLICE <= NLIMAX) .OR. IPASS == 1) THEN
                        EXIT
                    ELSE
!-------------------------------------------------------------------------------------------------   
! REDUCE EXCESSIVE ACCUMULATION OF ICE AT UPPER LEVELS ASSOCIATED WITH STRONG GRID-RESOLVED ASCENT
!                    
! FORCE NLICE TO BE BETWEEN NLIMIN AND NLIMAX
!------------------------------------------------------------------------------------------------- 
                    
                        DUM = MAX(NLIMIN, MIN(NLIMAX, NLICE))
                        XLI = RHO * (QTICE / DUM - XSIMASS) / RIMEF1
!
                        IF (XLI <= MASSI(MDIMIN)) THEN
                            INDEXS = MDIMIN
                        ELSE IF (XLI <= MASSI(450) ) THEN
                            DLI = 9.5885E5 * XLI ** .42066 ! DLI IN MICRONS
                            INDEXS = MIN(MDIMAX, MAX(MDIMIN, INT(DLI)))
                        ELSE IF (XLI <= MASSI(MDIMAX)) THEN
                            DLI = 3.9751E6 * XLI ** .49870 ! DLI IN MICRONS
                            INDEXS = MIN(MDIMAX, MAX(MDIMIN, INT(DLI)))
                        ELSE
                            INDEXS = MDIMAX
!--------------------------------------------------------------------------------------------------                        
! 8/22/01: INCREASE DENSITY OF LARGE ICE IF MAXIMUM LIMITS ARE REACHED FOR NUMBER CONCENTRATION 
! (NLIMAX) AND MEAN SIZE (MDIMAX).
! DONE TO INCREASE FALL OUT OF ICE.
!--------------------------------------------------------------------------------------------------  
                            IF (DUM >= NLIMAX)                                                    &
    &                         RIMEF1 = RHO * (QTICE / NLIMAX - XSIMASS) / MASSI(INDEXS)
!
                        END IF ! END IF (XLI <= MASSI(MDIMIN) )
                    END IF ! END IF ( (NLICE >= NLIMIN .AND. NLICE <= NLIMAX) 
                END DO     ! END DO IPASS=0,1
            END IF         ! END IF (QI <= CLIMIT .AND. ASNOW <= CLIMIT)
        END IF             ! END IF (ICE_LOGICAL)
!------------------------------- 
! CALCULATE INDIVIDUAL PROCESSES 
!-------------------------------  
!
!---------------------------------------------------------- 
! CLOUD WATER AUTOCONVERSION TO RAIN AND COLLECTION BY RAIN
!----------------------------------------------------------  	
        IF (QW > CLIMIT .AND. TC >= T_ICE) THEN
!--------------------------------------------------------------------------------------------------        
! QW0 COULD BE MODIFIED BASED ON LAND/SEA PROPERTIES, PRESENCE OF CONVECTION, ETC.  
! THIS IS WHY QAUT0 AND CRAUT ARE PASSED INTO THE SUBROUTINE AS EXTERNALLY DETERMINED PARAMETERS. 
! CAN BE CHANGED IN THE FUTURE IF DESIRED.
!--------------------------------------------------------------------------------------------------    
            QW0 = QAUT0 * RRHO
            PRAUT = MAX(0., QW - QW0) * CRAUT
!
            IF (QLICE > CLIMIT) THEN
!----------------------------------------------------------             
! COLLECTION OF CLOUD WATER BY LARGE ICE PARTICLES ("SNOW")
! PIACWI=PIACW FOR RIMING, PIACWI=0 FOR SHEDDING
!---------------------------------------------------------- 
                FWS   = MIN(1., CIACW * VEL_INC * NLICE * ACCRI(INDEXS) / PP ** C1)
                PIACW = FWS * QW
!
                IF (TC < 0.) PIACWI = PIACW   ! LARGE ICE RIMING
            END IF                            ! END IF (QLICE > CLIMIT)
        END IF                                ! END IF (QW > CLIMIT .AND. TC >= T_ICE)
!------------------------------------------------------------------------
! LOOP AROUND SOME OF THE ICE-PHASE PROCESSES IF NO ICE SHOULD BE PRESENT
!------------------------------------------------------------------------
    
        IF (ICE_logical .EQV. .FALSE. ) GOTO 20
!----------------------------------------------------     
! NOW THE PRETZEL LOGIC OF CALCULATING ICE DEPOSITION
!----------------------------------------------------   
        IF (TC < T_ICE .AND. (WV > QSIgrd .OR. QW > CLIMIT)) THEN
!--------------------------------------------------------------------------------------------------         
! ADJUST TO ICE SATURATION AT T<T_ICE (-10C) IF SUPERSATURATED.
! SOURCES OF ICE DUE TO NUCLEATION AND CONVECTIVE DETRAINMENT ARE EITHER POORLY UNDERSTOOD, POORLY
! RESOLVED AT TYPICAL NWP RESOLUTIONS, OR ARE NOT REPRESENTED 
! (E.G., NO DETRAINED CONDENSATE IN BMJ CU SCHEME).
!--------------------------------------------------------------------------------------------------    
            PCOND = -QW
            DUM1  =  TK + XLV1 * PCOND                 ! UPDATED (DUMMY) TEMPERATURE (DEG K)
            DUM2  =  WV + QW                           ! UPDATED (DUMMY) WATER VAPOR MIXING RATIO
            DUM   =  1000. * FPVS(DUM1)                ! UPDATED (DUMMY) SATURATION VAPOR PRESSURE W/R/T ICE
            DUM   =  RHgrd * EPS * DUM / (PP - DUM)    ! UPDATED (DUMMY) SATURATION MIXING RATIO W/R/T ICE
!
            IF (DUM2 > DUM) PIDEP = DEPOSIT(PP, RHGRD, DUM1, DUM2)
            DWVI = 0.                                  ! USED ONLY FOR DEBUGGING
!        
        ELSE IF (TC < 0.) THEN
!--------------------------------------------------------------------         
! THESE QUANTITIES ARE HANDY FOR ICE DEPOSITION/SUBLIMATION
! PIDEP_MAX - MAX DEPOSITION OR MINIMUM SUBLIMATION TO ICE SATURATION
!--------------------------------------------------------------------  
            DENOMI    = 1. + XLS2 * QSI * TK2
            DWVI      = MIN(WVQW, QSW) - QSI
            PIDEP_MAX = MAX(PILOSS, DWVI / DENOMI)
!
            IF (QTICE > 0.) THEN
!--------------------------------------------------------------------------------------------------            
! CALCULATE ICE DEPOSITION/SUBLIMATION
! SFACTOR - [VEL_INC**.5]*[SCHMIDT**(1./3.)]*[(RHO/DYNVIS)**.5], WHERE SCHMIDT 
! (SCHMIDT NUMBER) = DYNVIS/(RHO*DIFFUS)
! UNITS: SFACTOR - S**.5/M; ABI - M**2/S; NLICE - M**-3; VENTIL, VENTIS - M**-2; VENTI1 - M;
! VENTI2 - M**2/S**.5; DIDEP - UNITLESS
!-------------------------------------------------------------------------------------------------- 
                SFACTOR = VEL_INC ** .5 * (RHO / (DIFFUS * DIFFUS * DYNVIS)) ** C2
                ABI     = 1. / (RHO * XLS3 * QSI * TK2 / THERM_COND + 1. / DIFFUS)
!--------------------------------------------------------------------------------------------------              
! VENTIL - NUMBER CONCENTRATION * VENTILATION FACTORS FOR LARGE ICE
! VENTIS - NUMBER CONCENTRATION * VENTILATION FACTORS FOR SMALL ICE
!            
! VARIATION IN THE NUMBER CONCENTRATION OF ICE WITH TIME IS NOT ACCOUNTED FOR IN THESE CALCULATIONS
! (COULD BE IN THE FUTURE).
!-------------------------------------------------------------------------------------------------- 
                VENTIL = (VENTI1(INDEXS) + SFACTOR * VENTI2(INDEXS)) * NLICE
                VENTIS = (VENTI1(MDIMIN) + SFACTOR * VENTI2(MDIMIN)) * NSMICE
!
                DIDEP  = ABI * (VENTIL + VENTIS) * DTPH
!------------------------------------------------             
! ACCOUNT FOR CHANGE IN WATER VAPOR SUPPLY W/TIME
!------------------------------------------------             
                IF (DIDEP >= XRATIO) DIDEP = (1. - EXP(-DIDEP * DENOMI)) / DENOMI
!
                IF (DWVI > 0.) THEN
                    PIDEP = MIN(DWVI * DIDEP, PIDEP_MAX)
                ELSE IF (DWVI < 0.) THEN
                    PIDEP = MAX(DWVI * DIDEP, PIDEP_MAX)
                END IF
!            
            ELSE IF (WVQW > QSI .AND. TC <= T_ICE_INIT) THEN
!--------------------------------------------------------------------------------------------------             
! ICE NUCLEATION IN NEAR WATER-SATURATED CONDITIONS. ICE CRYSTAL GROWTH DURING TIME STEP CALCULATED
! USING MILLER & YOUNG (1979, JAS)
! THESE DEPOSITION RATES COULD DRIVE CONDITIONS BELOW WATER SATURATION, WHICH IS THE BASIS OF THESE
! CALCULATIONS.
! INTENDED TO APPROXIMATE MORE COMPLEX AND COMPUTATIONALLY INTENSIVE CALCULATIONS.
!-------------------------------------------------------------------------------------------------- 
                INDEX_MY = MAX(MY_T1, MIN(INT(.5 - TC), MY_T2))
!--------------------------------------------------------------------------------------------------             
! DUM1 IS THE SUPERSATURATION W/R/T ICE AT WATER-SATURATED CONDITIONS
! DUM2 IS THE NUMBER OF ICE CRYSTALS NUCLEATED AT WATER-SATURATED CONDITIONS 
! BASED ON MEYERS ET AL. (JAM, 1992).
!            
! PREVENT UNREALISTICALLY LARGE ICE INITIATION (LIMITED BY PIDEP_MAX) IF DUM2 VALUES ARE INCREASED 
! IN FUTURE EXPERIMENTS
!-------------------------------------------------------------------------------------------------- 
                DUM1  = QSW / QSI - 1.
                DUM2  = 1.E3 * EXP(12.96 * DUM1 - .039)
                PIDEP = MIN(PIDEP_MAX, DUM2 * MY_GROWTH(INDEX_MY) * RRHO)
            END IF       ! END IF (QTICE > 0.)
!        
        END IF           ! END IF (TC < T_ICE .AND. (WV > QSIGRD .OR. QW > CLIMIT))
!
     20 CONTINUE      ! JUMP HERE IF CONDITIONS FOR ICE ARE NOT PRESENT
!-------------------------     
! CLOUD WATER CONDENSATION
!-------------------------    
        IF (TC >= T_ICE .AND. (QW > CLIMIT .OR. WV > QSWGRD)) THEN
            IF (PIACWI == 0. .AND. PIDEP == 0.) THEN
                PCOND = CONDENSE(PP, QW, RHGRD, TK, WV)
            ELSE
!-------------------------------------------------------            
! MODIFY CLOUD CONDENSATION IN RESPONSE TO ICE PROCESSES
!-------------------------------------------------------   
                DUM     = XLV * QSWGRD * RCPRV * TK2
                DENOMWI = 1. + XLS * DUM
                DENOMF  = XLF * DUM
                DUM     = MAX(0., PIDEP)
                PCOND   = (WV - QSWGRD - DENOMWI * DUM - DENOMF * PIACWI) / DENOMW
                DUM1    = -QW
                DUM2    = PCOND - PIACW
!
                IF (DUM2 < DUM1) THEN
!------------------------                   
! LIMIT CLOUD WATER SINKS
!------------------------ 
                    DUM    = DUM1 / DUM2
                    PCOND  = DUM  * PCOND
                    PIACW  = DUM  * PIACW
                    PIACWI = DUM  * PIACWI
                END IF ! END IF (DUM2 < DUM1)
            END IF     ! END IF (PIACWI == 0. .AND. PIDEP == 0.)
        END IF         ! END IF (TC >= T_ICE .AND. (QW > CLIMIT .OR. WV > QSWGRD))
!--------------------------------------------------------------------------------------------------     
! LIMIT FREEZING OF ACCRETED RIME TO PREVENT TEMPERATURE OSCILLATIONS, A CRUDE SCHUMANN-LUDLAM 
! LIMIT (P. 209 OF YOUNG, 1993).
!--------------------------------------------------------------------------------------------------   
        TCC = TC + XLV1 * PCOND + XLS1 * PIDEP + XLF1 * PIACWI
!
        IF (TCC > 0.) THEN
            PIACWI = 0.
            TCC = TC + XLV1 * PCOND + XLS1 * PIDEP
        END IF
 !   
        IF (TC > 0. .AND. TCC > 0. .AND. ICE_LOGICAL) THEN
!--------------------------------------------------------------------------------------------------         
! CALCULATE MELTING AND EVAPORATION/CONDENSATION
! UNITS: SFACTOR - S**.5/M; ABI    - M**2/S    ; NLICE - M**-3; VENTIL - M**-2;
!        VENTI1  - M      ; VENTI2 - M**2/S**.5; CIEVP - /S
!-------------------------------------------------------------------------------------------------- 
            SFACTOR = VEL_INC ** .5 * (RHO / (DIFFUS * DIFFUS * DYNVIS)) ** C2
            VENTIL  = NLICE * (VENTI1(INDEXS) + SFACTOR * VENTI2(INDEXS))
            AIEVP   = VENTIL * DIFFUS * DTPH
!
            IF (AIEVP < XRATIO) THEN
                DIEVP = AIEVP
            ELSE
                DIEVP = 1. - EXP(-AIEVP)
            END IF
!
            QSW0 = EPS * ESW0 / (PP - ESW0)
            DWV0 = MIN(WV,QSW) - QSW0
            DUM  = QW + PCOND
!
            IF (WV < QSW .AND. DUM <= CLIMIT) THEN
!--------------------------------------------------------------------------------------------------           
! EVAPORATION FROM MELTING SNOW (SINK OF SNOW) OR SHEDDING OF WATER CONDENSED ONTO MELTING SNOW 
! (SOURCE OF RAIN)
!-------------------------------------------------------------------------------------------------- 
                DUM   = DWV0 * DIEVP
                PIEVP = MAX(MIN(0., DUM), PILOSS)
                PICND = MAX(0., DUM)
            END IF            ! END IF (WV < QSW .AND. DUM <= CLIMIT)
!
            PIMLT = THERM_COND * TCC * VENTIL * RRHO * DTPH / XLF
!------------------------------------------------------------          
! LIMIT MELTING TO PREVENT TEMPERATURE OSCILLATIONS ACROSS 0C
!------------------------------------------------------------  
            DUM1  = MAX(0., (TCC + XLV1 * PIEVP) / XLF1)
            PIMLT = MIN(PIMLT, DUM1)
!--------------------------------------------------- 
! LIMIT LOSS OF SNOW BY MELTING (>0) AND EVAPORATION
!---------------------------------------------------     
            DUM = PIEVP - PIMLT
!
            IF (DUM < PILOSS) THEN
                DUM1  = PILOSS / DUM
                PIMLT = PIMLT * DUM1
                PIEVP = PIEVP * DUM1
            END IF           ! END IF (DUM > QTICE)
        END IF               ! END IF (TC > 0. .AND. TCC > 0. .AND. ICE_LOGICAL)
!--------------------------------------------------------------------------------------------------    
! IMPORTANT:  ESTIMATE TIME-AVERAGED PROPERTIES.
!    
!TOT_RAIN - TOTAL MASS OF RAIN BEFORE MICROPHYSICS, WHICH IS THE SUM OF THE TOTAL MASS OF RAIN IN 
!           THE CURRENT LAYER AND THE INPUT FLUX OF RAIN FROM ABOVE
! VRAIN1   - FALL SPEED OF RAIN INTO GRID FROM ABOVE (WITH AIR RESISTANCE CORRECTION)
! QTRAIN   - TIME-AVERAGED MIXING RATIO OF RAIN (KG/KG)
! PRLOSS   - GREATEST LOSS (<0) OF RAIN, REMOVING ALL RAIN FALLING FROM ABOVE AND THE RAIN WITHIN 
!            THE LAYER
! RQR      - RAIN CONTENT (KG/M**3)
! INDEXR   - MEAN SIZE OF RAIN DROPS TO THE NEAREST 1 MICRON IN SIZE
! N0R      - INTERCEPT OF RAIN SIZE DISTRIBUTION (TYPICALLY 10**6 M**-4)
!--------------------------------------------------------------------------------------------------  
        TOT_RAIN = 0.
        VRAIN1   = 0.
        QTRAIN   = 0.
        PRLOSS   = 0.
        RQR      = 0.
        N0R      = 0.
        INDEXR1  = INDEXR    ! FOR DEBUGGING ONLY
        INDEXR   = MDRMIN
!
        IF (RAIN_LOGICAL) THEN
            IF (ARAIN <= 0.) THEN
                INDEXR = MDRMIN
                VRAIN1 = 0.
            ELSE
!--------------------------------------------------------------------------------------------------             
! INDEXR (RELATED TO MEAN DIAMETER) & N0R COULD BE MODIFIED BY LAND/SEA PROPERTIES, PRESENCE OF 
! CONVECTION, ETC.
!            
! RAIN RATE NORMALIZED TO A DENSITY OF 1.194 KG/M**3
!--------------------------------------------------------------------------------------------------          
                RR = ARAIN / (DTPH * GAMMAR)
!            
                IF (RR <= RR_DRMIN) THEN
!------------------------------------------------------------------------------------------------                 
! ASSUME FIXED MEAN DIAMETER OF RAIN (0.2 MM) FOR LOW RAIN RATES, INSTEAD VARY N0R WITH RAIN RATE
!------------------------------------------------------------------------------------------------ 
                
                    INDEXR = MDRMIN
                ELSE IF (RR <= RR_DR1) THEN
!--------------------------------------------------------------------------------------------------                
! BEST FIT TO MASS-WEIGHTED FALL SPEEDS (V) FROM RAIN LOOKUP TABLES FOR MEAN DIAMETERS (DR) BETWEEN
! 0.05 AND 0.10 MM:
! V(DR)=5.6023E4*DR**1.136, V IN M/S AND DR IN M
! RR = PI*1000.*N0R0*5.6023E4*DR**(4+1.136) = 1.408E15*DR**5.136, RR IN KG/(M**2*S)
! DR (M) = 1.123E-3*RR**.1947 -> DR (MICRONS) = 1.123E3*RR**.1947
!-------------------------------------------------------------------------------------------------- 
                    INDEXR = INT(1.123E3 * RR ** .1947 + .5)
                    INDEXR = MAX(MDRMIN, MIN(INDEXR, MDR1))
!
                ELSE IF (RR <= RR_DR2) THEN
!--------------------------------------------------------------------------------------------------                 
! BEST FIT TO MASS-WEIGHTED FALL SPEEDS (V) FROM RAIN LOOKUP TABLES FOR MEAN DIAMETERS (DR) BETWEEN
! 0.10 AND 0.20 MM:
! V(DR)=1.0867E4*DR**.958, V IN M/S AND DR IN M
! RR = PI*1000.*N0R0*1.0867E4*DR**(4+.958) = 2.731E14*DR**4.958, RR IN KG/(M**2*S)
! DR (M) = 1.225E-3*RR**.2017 -> DR (MICRONS) = 1.225E3*RR**.2017
!--------------------------------------------------------------------------------------------------           
                    INDEXR = INT(1.225E3 * RR ** .2017 + .5)
                    INDEXR = MAX(MDR1, MIN(INDEXR, MDR2))
!
                ELSE IF (RR <= RR_DR3) THEN
!--------------------------------------------------------------------------------------------------                 
! BEST FIT TO MASS-WEIGHTED FALL SPEEDS (V) FROM RAIN LOOKUP TABLES FOR MEAN DIAMETERS (DR) BETWEEN
! 0.20 AND 0.32 MM:
! V(DR)=2831.*DR**.80, V IN M/S AND DR IN M
! RR = PI*1000.*N0R0*2831.*DR**(4+.80) = 7.115E13*DR**4.80, RR IN KG/(M**2*S)
! DR (M) = 1.3006E-3*RR**.2083 -> DR (MICRONS) = 1.3006E3*RR**.2083
!--------------------------------------------------------------------------------------------------  
                    INDEXR = INT(1.3006E3 * RR ** .2083 + .5)
                    INDEXR = MAX(MDR2, MIN(INDEXR, MDR3))
!
                ELSE IF (RR <= RR_DRMAX) THEN
!--------------------------------------------------------------------------------------------------                
! BEST FIT TO MASS-WEIGHTED FALL SPEEDS (V) FROM RAIN LOOKUP TABLES FOR MEAN DIAMETERS (DR) BETWEEN
! 0.32 AND 0.45 MM:
! V(DR)=944.8*DR**.6636, V IN M/S AND DR IN M
! RR = PI*1000.*N0R0*944.8*DR**(4+.6636) = 2.3745E13*DR**4.6636, RR IN KG/(M**2*S)
! DR (M) = 1.355E-3*RR**.2144 -> DR (MICRONS) = 1.355E3*RR**.2144
!-------------------------------------------------------------------------------------------------- 
                    INDEXR = INT(1.355E3 * RR ** .2144 + .5)
                    INDEXR = MAX(MDR3, MIN(INDEXR, MDRMAX))
                ELSE
!--------------------------------------------------------------------------------------------------  
! ASSUME FIXED MEAN DIAMETER OF RAIN (0.45 MM) FOR HIGH RAIN RATES, INSTEAD VARY N0R WITH RAIN RATE
!-------------------------------------------------------------------------------------------------- 
                    INDEXR = MDRMAX
                END IF              ! END IF (RR <= RR_DRMIN) ETC.
                VRAIN1 = GAMMAR * VRAIN(INDEXR)
            END IF                  ! END IF (ARAIN <= 0.)
!
            INDEXR1  = INDEXR       ! FOR DEBUGGING ONLY
            TOT_RAIN = THICK * QR + BLEND * ARAIN
            QTRAIN   = TOT_RAIN / (THICK + BLDTRH * VRAIN1)
            PRLOSS   =-TOT_RAIN / THICK
            RQR      = RHO * QTRAIN
!-------------------------------------------         
! RQR - TIME-AVERAGED RAIN CONTENT (KG/M**3)
!------------------------------------------- 
            IF (RQR <= RQR_DRMIN) THEN
                N0R    = MAX(N0RMIN, CN0R_DMRMIN * RQR)
                INDEXR = MDRMIN
            ELSE IF (RQR >= RQR_DRMAX) THEN
                N0R    = CN0R_DMRMAX * RQR
                INDEXR = MDRMAX
            ELSE
                N0R    = N0R0
                INDEXR = MAX(XMRMIN, MIN(CN0R0 * RQR ** .25, XMRMAX))
            END IF
!        
            IF (TC < T_ICE) THEN
                PIACR = -PRLOSS
            ELSE
                DWVR = WV - PCOND - QSW
                DUM  = QW + PCOND
!
                IF (DWVR < 0. .AND. DUM <= CLIMIT) THEN
!--------------------------------------------------------------------------------------------------                
! RAIN EVAPORATION
!                
! RFACTOR - [GAMMAR**.5]*[SCHMIDT**(1./3.)]*[(RHO/DYNVIS)**.5], 
! WHERE SCHMIDT (SCHMIDT NUMBER) = DYNVIS/(RHO*DIFFUS)
!                
! UNITS: RFACTOR - S**.5/M; ABW    - M**2/S    ; VENTR - M**-2   ;N0R - M**-4; 
!         VENTR1 - M**2   ; VENTR2 - M**3/S**.5; CREVP - UNITLESS
!-------------------------------------------------------------------------------------------------- 
                    RFACTOR = GAMMAR ** .5 * (RHO / (DIFFUS * DIFFUS * DYNVIS)) ** C2
                    ABW     = 1. / (RHO * XLV2 / THERM_COND + 1. / DIFFUS)
!-------------------------------------------------------------------------------------------------- 
! NOTE THAT VENTR1, VENTR2 LOOKUP TABLES DO NOT INCLUDE THE 1/DAVG MULTIPLIER AS IN THE ICE TABLES
!--------------------------------------------------------------------------------------------------  
                    VENTR = N0R * (VENTR1(INDEXR) + RFACTOR * VENTR2(INDEXR))
                    CREVP = ABW * VENTR * DTPH
!
                    IF (CREVP < XRATIO) THEN
                        DUM = DWVR * CREVP
                    ELSE
                        DUM=DWVR * (1. - EXP(-CREVP * DENOMW)) / DENOMW
                    END IF
!
                    PREVP = MAX(DUM, PRLOSS)
!
                ELSE IF (QW > CLIMIT) THEN
                    FWR   = CRACW * GAMMAR * N0R * ACCRR(INDEXR)
                    PRACW = MIN(1.,FWR) * QW
                END IF       ! END IF (DWVR < 0. .AND. DUM <= CLIMIT)
!            
                IF (TC < 0. .AND. TCC < 0.) THEN
!--------------------------------------------------------------                 
! BIGGS (1953) HETEOROGENEOUS FREEZING (E.G., LIN ET AL., 1983)
!--------------------------------------------------------------
                    PIACR = CBFR * N0R * RRHO * (EXP(ABFR * TC) - 1.) * (FLOAT(INDEXR)) ** 7
!
                    IF (QLICE > CLIMIT) THEN
!-------------------------------------------                     
! FREEZING OF RAIN BY COLLISIONS W/LARGE ICE
!------------------------------------------- 
                        DUM  = GAMMAR * VRAIN(INDEXR)
                        DUM1 = DUM - VSNOW
!--------------------------------------------------------------------------------------------------                    
! DUM2 - DIFFERENCE IN SPECTRAL FALL SPEEDS OF RAIN AND LARGE ICE, PARAMETERIZED FOLLOWING EQ. (48)
! ON P. 112 OF MURAKAMI (J. METEOR. SOC. JAPAN, 1990)
!--------------------------------------------------------------------------------------------------  
                        DUM2 = (DUM1 * DUM1 + .04 * DUM * VSNOW) ** .5
                        DUM1 = 5.E-12 * INDEXR * INDEXR + 2.E-12 * INDEXR * INDEXS                &
    &                        + .5E-12 * INDEXS * INDEXS
!
                        FIR = MIN(1., CIACR*NLICE*DUM1*DUM2)
!--------------------------------------------------------------                     
! FUTURE ?  SHOULD COLLECTION BY SMALL ICE SHOULD BE INCLUDED ?
!-------------------------------------------------------------- 
                        PIACR = MIN(PIACR+FIR*QTRAIN, QTRAIN)
                    END IF   ! END IF (QLICE > CLIMIT)
!
                    DUM = PREVP - PIACR
!
                    If (DUM < PRLOSS) THEN
                        DUM1  = PRLOSS / DUM
                        PREVP = DUM1   * PREVP
                        PIACR = DUM1   * PIACR
                    END IF ! END IF (DUM < PRLOSS)
                END IF     ! END IF (TC < 0. .AND. TCC < 0.)
            END IF         ! END IF (TC < T_ICE)
        END IF             ! END IF (RAIN_LOGICAL)
!---------------------- 
! MAIN BUDGET EQUATIONS 
!---------------------- 
!
!-------------------------------------------------------------- 
! UPDATE FIELDS, DETERMINE CHARACTERISTICS FOR NEXT LOWER LAYER 
!-------------------------------------------------------------- 
!
!------------------------------------- 
! CAREFULLY LIMIT SINKS OF CLOUD WATER
!-------------------------------------
        DUM1 = PIACW + PRAUT + PRACW - MIN(0.,PCOND)
!
        IF (DUM1 > QW) THEN
            DUM    = QW  / DUM1
            PIACW  = DUM * PIACW
            PIACWI = DUM * PIACWI
            PRAUT  = DUM * PRAUT
            PRACW  = DUM * PRACW
!
            IF (PCOND < 0.) PCOND = DUM * PCOND
        END IF
!
        PIACWR = PIACW - PIACWI          ! TC >= 0C
!-----------------------------------------     
! QWNEW - UPDATED CLOUD WATER MIXING RATIO
!----------------------------------------- 
        DELW  = PCOND - PIACW - PRAUT - PRACW
        QWnew = QW + DELW
!
        IF (QWNEW <= CLIMIT) QWNEW = 0.
!
        IF (QW > 0. .AND. QWNEW /= 0.) THEN
            DUM = QWNEW / QW
!
            IF (DUM < TOLER) QWNEW = 0.
        END IF
!-------------------------------------------------    
! UPDATE TEMPERATURE AND WATER VAPOR MIXING RATIOS
!-------------------------------------------------  
        DELT = XLV1 * (PCOND + PIEVP +  PICND  + PREVP)                                           &
    &        + XLS1 *  PIDEP + XLF1  * (PIACWI + PIACR - PIMLT)
!
        TNEW = TK + DELT
!    
        DELV  = -PCOND - PIDEP - PIEVP - PICND - PREVP
        WVNEW = WV + DELV
!--------------------------------------------------------------------------------------------------   
! UPDATE ICE MIXING RATIOS
!
! TOT_ICENEW - TOTAL MASS (SMALL AND LARGE) ICE AFTER MICROPHYSICS, WHICH IS THE SUM OF THE TOTAL 
!              MASS OF LARGE ICE IN THE CURRENT LAYER AND THE FLUX OF ICE OUT OF THE GRID BOX BELOW
! RIMEF      - RIME FACTOR, WHICH IS THE MASS RATIO OF TOTAL (UNRIMED AND RIMED) ICE MASS TO THE 
!              UNRIMED ICE MASS (>=1)
! QINEW      - UPDATED MIXING RATIO OF TOTAL (LARGE & SMALL) ICE IN LAYER
!              TOT_ICENEW=QINEW*THICK+BLDTRH*QLICENEW*VSNOW 
!              BUT QLICENEW=QINEW*FLIMASS, 
!              SO TOT_ICENEW=QINEW*(THICK+BLDTRH*FLIMASS*VSNOW)
! ASNOWNEW   - UPDATED ACCUMULATION OF SNOW AT BOTTOM OF GRID CELL
!--------------------------------------------------------------------------------------------------
        DELI  = 0.
        RIMEF = 1.
!
        IF (ICE_LOGICAL) THEN
            DELI = PIDEP + PIEVP + PIACWI + PIACR - PIMLT
            TOT_ICENEW = TOT_ICE + THICK * DELI
!
            IF (TOT_ICE > 0. .AND. TOT_ICENEW /= 0.) THEN
                DUM = TOT_ICENEW / TOT_ICE
                IF (DUM < TOLER) TOT_ICENEW = 0.
            END IF
!
            IF (TOT_ICENEW <= CLIMIT) THEN
                TOT_ICENEW = 0.
                RIMEF      = 1.
                QINEW      = 0.
                ASNOWNEW   = 0.
            ELSE
!----------------------------------            
! UPDATE RIME FACTOR IF APPROPRIATE
!----------------------------------  
                DUM = PIACWI + PIACR
                IF (DUM <= CLIMIT .AND. PIDEP <= CLIMIT) THEN
                    RIMEF = RIMEF1
                ELSE
!--------------------------------------------------------------- 
! RIME FACTOR, RIMEF = (TOTAL ICE MASS)/(TOTAL UNRIMED ICE MASS)
! DUM1 - TOTAL ICE MASS, RIMED & UNRIMED
! DUM2 - ESTIMATED MASS OF *UNRIMED* ICE
!---------------------------------------------------------------
                    DUM1 = TOT_ICE + THICK  * (PIDEP + DUM)
                    DUM2 = TOT_ICE / RIMEF1 + THICK  * PIDEP
!
                    IF (DUM2 <= 0.) THEN
                        RIMEF = RFmax
                    ELSE
                        RIMEF = MIN(RFMAX, MAX(1., DUM1 / DUM2))
                    END IF
                END IF   ! END IF (DUM <= CLIMIT .AND. PIDEP <= CLIMIT)
!
                QINEW = TOT_ICENEW / (THICK + BLDTRH * FLIMASS * VSNOW)
!
                IF (QINEW <= CLIMIT) QINEW = 0.
!
                IF (QI > 0. .AND. QINEW /= 0.) THEN
                    DUM = QINEW / QI
                    IF (DUM < TOLER) QINEW = 0.
                END IF
!
                ASNOWNEW = BLDTRH * FLIMASS * VSNOW * QINEW
!
                IF (ASNOW > 0. .AND. ASNOWNEW /= 0.) THEN
                    DUM = ASNOWNEW / ASNOW
                    IF (DUM < TOLER) ASNOWNEW = 0.
                END IF
            END IF     ! END IF (TOT_ICENEW <= CLIMIT)
        END IF         ! END IF (ICE_LOGICAL)
!--------------------------------------------------------------------------------------------------    
! UPDATE RAIN MIXING RATIOS
!
! TOT_RAINNEW - TOTAL MASS OF RAIN AFTER MICROPHYSICS CURRENT LAYER AND THE INPUT FLUX OF ICE FROM 
!               ABOVE
! VRAIN2      - TIME-AVERAGED FALL SPEED OF RAIN IN GRID AND BELOW (WITH AIR RESISTANCE CORRECTION)
! QRNEW       - UPDATED RAIN MIXING RATIO IN LAYER
!               TOT_RAINNEW=QRNEW*(THICK+BLDTRH*VRAIN2)
! ARAINNEW    - UPDATED ACCUMULATION OF RAIN AT BOTTOM OF GRID CELL
!--------------------------------------------------------------------------------------------------
        DELR        = PRAUT    + PRACW + PIACWR - PIACR + PIMLT + PREVP + PICND
        TOT_RAINNEW = TOT_RAIN + THICK * DELR
!
        IF (TOT_RAIN > 0. .AND. TOT_RAINNEW /= 0.) THEN
            DUM = TOT_RAINNEW / TOT_RAIN
            IF (DUM < TOLER) TOT_RAINNEW = 0.
        END IF
!
        IF (TOT_RAINnew <= CLIMIT) THEN
            TOT_RAINNEW = 0.
            VRAIN2      = 0.
            QRNEW       = 0.
            ARAINNEW    = 0.
        ELSE
!--------------------------------------------------------         
! 1ST GUESS TIME-AVERAGED RAIN RATE AT BOTTOM OF GRID BOX
!--------------------------------------------------------   
            RR = TOT_RAINNEW / (DTPH * GAMMAR)
!--------------------------------------------------------------------------------------------------        
! USE SAME ALGORITHM AS ABOVE FOR CALCULATING MEAN DROP DIAMETER (IDR, IN MICRONS), WHICH IS USED 
! TO ESTIMATE THE TIME-AVERAGED FALL SPEED OF RAIN DROPS AT THE BOTTOM OF THE GRID LAYER. 
! THIS ISNT PERFECT, BUT THE ALTERNATIVE IS SOLVING A TRANSCENDENTAL EQUATION THAT IS NUMERICALLY 
! INEFFICIENT AND NASTY TO PROGRAM (CODED IN EARLIER VERSIONS OF GSMCOLUMN PRIOR TO 8-22-01).
!--------------------------------------------------------------------------------------------------
            IF (RR <= RR_DRMIN) THEN
                IDR = MDRMIN
            ELSE IF (RR <= RR_DR1) THEN
                IDR = INT(1.123E3 * RR ** .1947 + .5)
                IDR = MAX(MDRMIN, MIN(IDR, MDR1))
            ELSE IF (RR <= RR_DR2) THEN
                IDR = INT(1.225E3 * RR ** .2017 + .5)
                IDR = MAX(MDR1, MIN(IDR, MDR2))
            ELSE IF (RR <= RR_DR3) THEN
                IDR = INT(1.3006E3 * RR ** .2083 + .5)
                IDR = MAX(MDR2, MIN(IDR, MDR3) )
            ELSE IF (RR <= RR_DRMAX) THEN
                IDR = INT(1.355E3 * RR ** .2144 + .5)
                IDR = MAX(MDR3, MIN(IDR, MDRMAX))
            ELSE
                IDR = MDRMAX
            END IF  ! END IF (RR <= RR_DRMIN)
!
            VRAIN2 = GAMMAR * VRAIN(IDR)
            QRNEW  = TOT_RAINNEW / (THICK + BLDTRH * VRAIN2)
!
            IF (QRNEW <= CLIMIT) QRNEW = 0.
            IF (QR > 0. .AND. QRNEW /= 0.) THEN
                DUM = QRNEW / QR
                IF (DUM < TOLER) QRNEW = 0.
            END IF
!
            ARAINNEW = BLDTRH * VRAIN2 * QRNEW
            IF (ARAIN > 0. .AND. ARAINNEW /= 0.) THEN
                DUM = ARAINNEW / ARAIN
                IF (DUM < TOLER) ARAINNEW = 0.
            END IF
        END IF
!    
        WCNEW = QWNEW + QRNEW + QINEW
!--------------------------------- 
! BEGIN DEBUGGING AND VERIFICATION  
!--------------------------------- 
!
!------------------------------------------------------------------------------------ 
! QT, QTNEW - TOTAL WATER (VAPOR AND CONDENSATE) BEFORE AND AFTER MICROPHYSICS, RESP.
!------------------------------------------------------------------------------------ 
        QT     = THICK * (WV + WC) + ARAIN + ASNOW
        QTNEW  = THICK * (WVNEW + WCNEW) + ARAINNEW + ASNOWNEW
        BUDGET = QT - QTNEW
!---------------------------------------------------------------------------     
! ADDITIONAL CHECK ON BUDGET PRESERVATION, ACCOUNTING FOR TRUNCATION EFFECTS
!--------------------------------------------------------------------------- 
        DBG_LOGICAL = .FALSE. 
!
        IF ((WVNEW < CLIMIT .OR. DBG_LOGICAL) .AND. PRINT_DIAG) THEN
        
            WRITE(6,"(/2(A,I4),2(A,I2))") '{} I=',I_INDEX,' J=',J_INDEX,' L=',L,' LSFC=',LSFC
!        
            ESW    = 1000. * FPVS0(TNEW)
            QSWNEW = EPS * ESW / (PP - ESW)
!
            IF (TC < 0. .OR. TNEW < 0.) THEN
                ESI    = 1000. * FPVS(TNEW)
                QSINEW = EPS * ESI / (PP - ESI)
            ELSE
                QSI    = QSW
                QSINEW = QSWNEW
            END IF
!
            WSNEW = QSINEW
!
            WRITE(6,"(4(A12,G11.4,1x))")                                                          &
    &       '{} TCOLD=',TC,'TCNEW=',TNEW-T0C,'P=',.01*PP,'RHO=',RHO,                              &
    &       '{} THICK=',THICK,'RHOLD=',WV/WS,'RHNEW=',WVNEW/WSNEW,                                &
    &       'RHGRD=',RHGRD,                                                                       &
    &       '{} RHWOLD=',WV/QSW,'RHWNEW=',WVNEW/QSWNEW,'RHIOLD=',WV/QSI,                          &
    &       'RHINEW=',WVNEW/QSINEW,                                                               &
    &       '{} QSWOLD=',QSW,'QSWNEW=',QSWNEW,'QSIOLD=',QSI,'QSINEW=',QSINEW,                     &
    &       '{} WSOLD=',WS,'WSNEW=',WSNEW,'WVOLD=',WV,'WVNEW=',WVNEW,                             &
    &       '{} WCOLD=',WC,'WCNEW=',WCNEW,'QWOLD=',QW,'QWNEW=',QWNEW,                             &
    &       '{} QIOLD=',QI,'QINEW=',QINEW,'QROLD=',QR,'QRNEW=',QRNEW,                             &
    &       '{} ARAINOLD=',ARAIN,'ARAINNEW=',ARAINNEW,'ASNOWOLD=',ASNOW,                          &
    &       'ASNOWNEW=',ASNOWNEW,                                                                 &
    &       '{} TOT_RAIN=',TOT_RAIN,'TOT_RAINNEW=',TOT_RAINNEW,                                   &
    &       'TOT_ICE=',TOT_ICE,'TOT_ICENEW=',TOT_ICENEW,                                          &
    &       '{} BUDGET=',BUDGET,'QTOLD=',QT,'QTNEW=',QTNEW
        
            WRITE(6,"(4(A12,G11.4,1x))")                                                          &
    &       '{} DELT=',DELT,'DELV=',DELV,'DELW=',DELW,'DELI=',DELI,                               &
    &       '{} DELR=',DELR,'PCOND=',PCOND,'PIDEP=',PIDEP,'PIEVP=',PIEVP,                         &
    &       '{} PICND=',PICND,'PREVP=',PREVP,'PRAUT=',PRAUT,'PRACW=',PRACW,                       &
    &       '{} PIACW=',PIACW,'PIACWI=',PIACWI,'PIACWR=',PIACWR,'PIMLT=',PIMLT,                   &
    &       '{} PIACR=',PIACR
!        
            IF (ICE_LOGICAL) WRITE(6,"(4(A12,G11.4,1x))")                                         &
    &       '{} RIMEF1=',RIMEF1,'GAMMAS=',GAMMAS,'VRIMEF=',VRIMEF,                                &
    &       'VSNOW=',VSNOW,                                                                       &
    &       '{} INDEXS=',FLOAT(INDEXS),'FLARGE=',FLARGE,'FSMALL=',FSMALL,                         &
    &       'FLIMASS=',FLIMASS,                                                                   &
    &       '{} XSIMASS=',XSIMASS,'XLIMASS=',XLIMASS,'QLICE=',QLICE,                              &
    &       'QTICE=',QTICE,                                                                       &
    &       '{} NLICE=',NLICE,'NSMICE=',NSMICE,'PILOSS=',PILOSS,                                  &
    &       'EMAIRI=',EMAIRI,                                                                     &
    &       '{} RIMEF=',RIMEF
!        
            IF (TOT_RAIN > 0. .OR. TOT_RAINNEW > 0.)                                              &
    &       WRITE(6,"(4(A12,G11.4,1x))")                                                          &
    &       '{} INDEXR1=',FLOAT(INDEXR1),'INDEXR=',FLOAT(INDEXR),                                 &
    &       'GAMMAR=',GAMMAR,'N0R=',N0R,                                                          &
    &       '{} VRAIN1=',VRAIN1,'VRAIN2=',VRAIN2,'QTRAIN=',QTRAIN,'RQR=',RQR,                     &
    &       '{} PRLOSS=',PRLOSS,'VOLR1=',THICK+BLDTRH*VRAIN1,                                     &
    &       'VOLR2=',THICK+BLDTRH*VRAIN2
!        
            IF (PRAUT > 0.) WRITE(6,"(A12,G11.4,1x)") '{} QW0=',QW0
!        
            IF (PRACW > 0.) WRITE(6,"(A12,G11.4,1x)") '{} FWR=',FWR
!        
            IF (PIACR > 0.) WRITE(6,"(A12,G11.4,1x)") '{} FIR=',FIR
!        
            DUM = PIMLT + PICND - PREVP - PIEVP
!
            IF (DUM > 0. .OR. DWVI /= 0.)                                                         &
    &       WRITE(6,"(4(A12,G11.4,1x))")                                                          &
    &       '{} TFACTOR=',TFACTOR,'DYNVIS=',DYNVIS,                                               &
    &       'THERM_CON=',THERM_COND,'DIFFUS=',DIFFUS
!        
            IF (PREVP < 0.) WRITE(6,"(4(A12,G11.4,1x))")                                          &
    &       '{} RFACTOR=',RFACTOR,'ABW=',ABW,'VENTR=',VENTR,'CREVP=',CREVP,                       &
    &       '{} DWVR=',DWVR,'DENOMW=',DENOMW
!        
            IF (PIDEP /= 0. .AND. DWVI /= 0.)                                                     &
    &        WRITE(6,"(4(A12,G11.4,1x))")                                                         &
    &       '{} DWVI=',DWVI,'DENOMI=',DENOMI,'PIDEP_MAX=',PIDEP_MAX,                              &
    &       'SFACTOR=',SFACTOR,                                                                   &
    &       '{} ABI=',ABI,'VENTIL=',VENTIL,'VENTIL1=',VENTI1(INDEXS),                             &
    &       'VENTIL2=',SFACTOR*VENTI2(INDEXS),                                                    &
    &       '{} VENTIS=',VENTIS,'DIDEP=',DIDEP
!        
            IF (PIDEP > 0. .AND. PCOND /= 0.)                                                     &
    &       WRITE(6,"(4(A12,G11.4,1x))")                                                          &
    &       '{} DENOMW=',DENOMW,'DENOMWI=',DENOMWI,'DENOMF=',DENOMF,                              &
    &       'DUM2=',PCOND-PIACW
!        
            IF (FWS > 0.) WRITE(6,"(4(A12,G11.4,1x))")                                            &
    &       '{} FWS=',FWS
!        
            DUM = PIMLT + PICND - PIEVP
!
            IF (DUM > 0.) WRITE(6,"(4(A12,G11.4,1x))")                                            &
    &       '{} SFACTOR=',SFACTOR,'VENTIL=',VENTIL,'VENTIL1=',VENTI1(INDEXS),                     &
    &       'VENTIL2=',SFACTOR*VENTI2(INDEXS),                                                    &
    &       '{} AIEVP=',AIEVP,'DIEVP=',DIEVP,'QSW0=',QSW0,'DWV0=',DWV0
!        
        END IF
!------------------------------------------- 
! WATER BUDGET STATISTICS AND MAXIMUM VALUES 
!-------------------------------------------
        IF (PRINT_DIAG) THEN
            ITdX = MAX(ITLO, MIN( INT(TNEW - T0C), ITHI))
!
            IF (QINEW > CLIMIT)                               NSTATS(ITDX,1) = NSTATS(ITDX,1) + 1
            IF (QINEW > CLIMIT .AND.  QRNEW + QWNEW > CLIMIT) NSTATS(ITDX,2) = NSTATS(ITDX,2) + 1
            IF (QWNEW > CLIMIT)                               NSTATS(ITDX,3) = NSTATS(ITDX,3) + 1
            IF (QRNEW > CLIMIT)                               NSTATS(ITDX,4) = NSTATS(ITDX,4) + 1
!        
            QMAX(ITDX,1) = MAX(QMAX(ITDX,1), QINEW)
            QMAX(ITDX,2) = MAX(QMAX(ITDX,2), QWNEW)
            QMAX(ITDX,3) = MAX(QMAX(ITDX,3), QRNEW)
            QMAX(ITDX,4) = MAX(QMAX(ITDX,4), ASNOWNEW)
            QMAX(ITDX,5) = MAX(QMAX(ITDX,5), ARAINNEW)
!
            QTOT(ITDX,1)  = QTOT(ITDX,1) + QINEW * THICK
            QTOT(ITDX,2)  = QTOT(ITDX,2) + QWNEW * THICK
            QTOT(ITDX,3)  = QTOT(ITDX,3) + QRNEW * THICK
!        
            QTOT(ITDX,4)  = QTOT(ITDX,4)  + PCOND  * THICK
            QTOT(ITDX,5)  = QTOT(ITDX,5)  + PICND  * THICK
            QTOT(ITDX,6)  = QTOT(ITDX,6)  + PIEVP  * THICK
            QTOT(ITDX,7)  = QTOT(ITDX,7)  + PIDEP  * THICK
            QTOT(ITDX,8)  = QTOT(ITDX,8)  + PREVP  * THICK
            QTOT(ITDX,9)  = QTOT(ITDX,9)  + PRAUT  * THICK
            QTOT(ITDX,10) = QTOT(ITDX,10) + PRACW  * THICK
            QTOT(ITDX,11) = QTOT(ITDX,11) + PIMLT  * THICK
            QTOT(ITDX,12) = QTOT(ITDX,12) + PIACW  * THICK
            QTOT(ITDX,13) = QTOT(ITDX,13) + PIACWI * THICK
            QTOT(ITDX,14) = QTOT(ITDX,14) + PIACWR * THICK
            QTOT(ITDX,15) = QTOT(ITDX,15) + PIACR  * THICK
!        
            QTOT(ITDX,16) = QTOT(ITDX,16) + (WVNEW - WV) * THICK
            QTOT(ITDX,17) = QTOT(ITDX,17) + (QWNEW - QW) * THICK
            QTOT(ITDX,18) = QTOT(ITDX,18) + (QINEW - QI) * THICK
            QTOT(ITDX,19) = QTOT(ITDX,19) + (QRNEW - QR) * THICK
!
            QTOT(ITDX,20) = QTOT(ITDX,20) + (ARAINNEW - ARAIN)
            QTOT(ITDX,21) = QTOT(ITDX,21) + (ASNOWNEW - ASNOW)
!
            IF (QINEW > 0.) QTOT(ITdX,22) = QTOT(ITDX,22) + QINEW * THICK / RIMEF
!        
        END IF
!-------------- 
! UPDATE ARRAYS 
!-------------- 
            T_COL(L) = TNEW                             ! UPDATED TEMPERATURE   
           QV_COL(L) = MAX(EPSQ, WVNEW  / (1. + WVNEW)) ! UPDATED SPECIFIC HUMIDITY
           WC_COL(L) = MAX(EPSQ, WCNEW)                 ! UPDATED TOTAL CONDENSATE MIXING RATIO
           QI_COL(L) = MAX(EPSQ, QINEW)                 ! UPDATED ICE MIXING RATIO
           QR_COL(L) = MAX(EPSQ, QRNEW)                 ! UPDATED RAIN MIXING RATIO
           QW_COL(L) = MAX(EPSQ, QWNEW)                 ! UPDATED CLOUD WATER MIXING RATIO
        RIMEF_COL(L) = RIMEF                            ! UPDATED RIME FACTOR
!
        ASNOW        = ASNOWNEW                         ! UPDATED ACCUMULATED SNOW
        ARAIN        = ARAINNEW                         ! UPDATED ACCUMULATED RAIN
!
        CONTINUE   ! END "L" LOOP THROUGH MODEL LEVELS
!
 10 END DO

!------------------- 
! RETURN TO GSMDRIVE 
!------------------- 
    RETURN
!
    END SUBROUTINE GSMCOLUMN
!
!
!
!---------------------------------------------------- 
! PRODUCES ACCURATE CALCULATION OF CLOUD CONDENSATION 
!---------------------------------------------------- 
    REAL FUNCTION CONDENSE(PP, QW, RHGRD, TK, WV)
!
    USE F77KINDS
!--------------------------------------------------------------------------------------------------
! THE ASAI (1965) ALGORITHM TAKES INTO CONSIDERATION THE RELEASE OF LATENT HEAT IN INCREASING THE 
! TEMPERATURE AND IN INCREASING THE SATURATION MIXING RATIO (FOLLOWING THE CLAUSIUS-CLAPEYRON EQN.)
!--------------------------------------------------------------------------------------------------
    INTEGER, PARAMETER :: HIGH_PRES = SELECTED_REAL_KIND(15)
!
    REAL   (KIND=HIGH_PRES), PARAMETER :: CLIMIT   = 1.E-20
    REAL   (KIND=HIGH_PRES), PARAMETER :: RHLIMIT  =  .001
    REAL   (KIND=HIGH_PRES), PARAMETER :: RHLIMIT1 = -RHLIMIT
!
    REAL   (KIND=R4KIND), PARAMETER :: CP    = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: RD    =  287.04
    REAL   (KIND=R4KIND), PARAMETER :: RV    =  461.5
    REAL   (KIND=R4KIND), PARAMETER :: EPS   =  RD / RV
    REAL   (KIND=R4KIND), PARAMETER :: RCP   =  1. / CP
    REAL   (KIND=R4KIND), PARAMETER :: RCPRV = RCP / RV
!
    REAL   (KIND=HIGH_PRES)                                                                     ::&
    & COND    , SSAT    , WCDUM
!---------------------------------- 
! LV (T) IS FROM BOLTON (JAS, 1980)
!----------------------------------
    XLV      = 3.148E6 - 2370. * TK
    XLV1     = XLV * RCP
    XLV2     = XLV * XLV * RCPRV
    TDUM     = TK
    WVDUM    = WV
    WCDUM    = QW
    ESW      = 1000. * FPVS0(TDUM)                 ! SATURATION VAPOR PRESS W/R/T ICE
    WS       = RHGRD * EPS * ESW / (PP - ESW)      ! SATURATION MIXING RATIO
    DWV      = WVDUM - WS                          ! DEFICIT GRID-SCALE WATER VAPOR MIXING RATIO
    SSAT     = DWV / WS                            ! SUPERSATURATION RATIO
    CONDENSE = 0.
!
    DO WHILE ((SSAT < RHLIMIT1 .AND. WCDUM > CLIMIT) .OR. SSAT > RHLIMIT)
        COND     = DWV / (1. + XLV2 * WS / (TDUM*TDUM))       ! ASAI (1965, J. JAPAN)
        COND     = MAX(COND, -WCDUM)                          ! LIMIT CLOUD WATER EVAPORATION
        TDUM     = TDUM + XLV1 * COND                         ! UPDATED TEMPERATURE
        WVDUM    = WVDUM    - COND                            ! UPDATED WATER VAPOR MIXING RATIO
        WCDUM    = WCDUM    + COND                            ! UPDATED CLOUD WATER MIXING RATIO
        CONDENSE = CONDENSE + COND                            ! TOTAL CLOUD WATER CONDENSATION
        ESW      = 1000. * FPVS0(TDUM)                        ! UPDATED SATURATION VAPOR PRESS W/R/T WATER
        WS       = RHGRD * EPS * ESW / (PP - ESW)             ! UPDATED SATURATION MIXING RATIO W/R/T WATER
        DWV      = WVDUM - WS                                 ! DEFICIT GRID-SCALE WATER VAPOR MIXING RATIO
        SSAT     = DWV / WS                                   ! GRID-SCALE SUPERSATURATION RATIO
    END DO
!
    RETURN
!
    END FUNCTION CONDENSE
!
!
!
!------------------------------------
! CALCULATE ICE DEPOSITION AT T<T_ICE 
!------------------------------------
    REAL FUNCTION DEPOSIT(PP, RHGRD, TDUM, WVDUM)
!
    USE F77KINDS
!--------------------------------------------------------------------------------------------------
! ALSO USES THE ASAI (1965) ALGORITHM BUT USES A DIFFERENT TARGET VAPOR PRESSURE FOR THE ADJUSTMENT
!--------------------------------------------------------------------------------------------------
    INTEGER                , PARAMETER :: HIGH_PRES=SELECTED_REAL_KIND(15)
!
    REAL   (KIND=HIGH_PRES), PARAMETER :: RHLIMIT  =      .001
    REAL   (KIND=HIGH_PRES), PARAMETER :: RHLIMIT1 = -RHLIMIT
!
    REAL   (KIND=R4KIND)   , PARAMETER :: CP       =  1004.6 
    REAL   (KIND=R4KIND)   , PARAMETER :: RD       =   287.04
    REAL   (KIND=R4KIND)   , PARAMETER :: RV       =   461.5
    REAL   (KIND=R4KIND)   , PARAMETER :: XLS      =     2.834E6 
    REAL   (KIND=R4KIND)   , PARAMETER :: EPS      = RD / RV
    REAL   (KIND=R4KIND)   , PARAMETER :: RCP      =     1. / CP
    REAL   (KIND=R4KIND)   , PARAMETER :: RCPRV    = RCP / RV
    REAL   (KIND=R4KIND)   , PARAMETER :: XLS1     = XLS * RCP
    REAL   (KIND=R4KIND)   , PARAMETER :: XLS2     = XLS * XLS * RCPRV
!
    REAL   (KIND=HIGH_PRES)                                                                     ::&
    & DEP     , SSAT
!
    ESI     = 1000. * FPVS(TDUM)             ! SATURATION VAPOR PRESS W/R/T ICE
    WS      = RHGRD * EPS * ESI / (PP - ESI) ! SATURATION MIXING RATIO
    DWV     = WVDUM - WS                     ! DEFICIT GRID-SCALE WATER VAPOR MIXING RATIO
    SSAT    = DWV   / WS                     ! SUPERSATURATION RATIO
    DEPOSIT = 0.
!
    DO WHILE (SSAT > RHLIMIT .OR. SSAT < RHLIMIT1)
!--------------------------------------------------------------------------------------------------    
! NOTE THAT XLVS2=LS*LV/(CP*RV)=LV*WS/(RV*T*T)*(LS/CP*DEP1), WHERE WS IS THE SATURATION MIXING 
! RATIO FOLLOWING CLAUSIUS-CLAPEYRON (SEE ASAI,1965; YOUNG,1993,P.405)
!--------------------------------------------------------------------------------------------------   
        DEP     = DWV / (1. + XLS2 * WS / (TDUM * TDUM)) ! ASAI (1965, J. JAPAN)
!
        TDUM    = TDUM    + XLS1 * DEP               ! UPDATED TEMPERATURE
        WVDUM   = WVDUM   - DEP                      ! UPDATED ICE MIXING RATIO
        DEPOSIT = DEPOSIT + DEP                      ! TOTAL ICE DEPOSITION
        ESI     = 1000.   * FPVS(TDUM)               ! UPDATED SATURATION VAPOR PRESS W/R/T ICE
        WS      = RHGRD   * EPS  * ESI / (PP - ESI)  ! UPDATED SATURATION MIXING RATIO W/R/T ICE
        DWV     = WVDUM   - WS                       ! DEFICIT GRID-SCALE WATER VAPOR MIXING RATIO
        SSAT    = DWV     / WS                       ! GRID-SCALE SUPERSATURATION RATIO
    END DO
!
    RETURN
!
    END FUNCTION DEPOSIT

    SUBROUTINE TABLE
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE TABLE
!>
!> SUBPROGRAM: TABLE - COMPUTES TABLE ENTRIES USED IN THE LONGWAVE RADIA PROGRAM
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT:
!> SUBROUTINE TABLE COMPUTES TABLE ENTRIES USED IN THE LONGWAVE RADIA PROGRAM. ALSO CALCULATED ARE
!> INDICES USED IN STRIP-MINING AND FOR SOME PRE-COMPUTABLE FUNCTIONS.
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              RNDDTA
!>              SCRTCH
!>              TABCOM
!>              TBLTMP
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : CONRAD
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE RNDDTA
    USE SCRTCH
    USE TABCOM
    USE TBLTMP
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!------------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
! L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
! NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE BANDTA FOR DEFINITION
! NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
! NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE BDCOMB FOR DEFINITION
! INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
! NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS.
! NB, KO2 ARE SHORTWAVE PARAMETERS; OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
!------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), PARAMETER :: L      = LM
    INTEGER(KIND=I4KIND), PARAMETER :: NCOL   = IMAX
    INTEGER(KIND=I4KIND), PARAMETER :: NBLM   = NBLY  -  1
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = L     +  2 
    INTEGER(KIND=I4KIND), PARAMETER :: LP3    = L     +  3
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = L     -  1
    INTEGER(KIND=I4KIND), PARAMETER :: LM2    = L     -  2
    INTEGER(KIND=I4KIND), PARAMETER :: LM3    = L     -  3
    INTEGER(KIND=I4KIND), PARAMETER :: LL     =  2    *  L
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1   = LL    +  1 
    INTEGER(KIND=I4KIND), PARAMETER :: LLP2   = LL    +  2
    INTEGER(KIND=I4KIND), PARAMETER :: LLP3   = LL    +  3
    INTEGER(KIND=I4KIND), PARAMETER :: LLM1   = LL    -  1
    INTEGER(KIND=I4KIND), PARAMETER :: LLM2   = LL    -  2
    INTEGER(KIND=I4KIND), PARAMETER :: LLM3   = LL    -  3
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M   = LP1   *  LP1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1M1  = LP1M  -  1 
    INTEGER(KIND=I4KIND), PARAMETER :: LP121  = LP1   * NBLY
    INTEGER(KIND=I4KIND), PARAMETER :: LL3P   =  3    *  L + 2
    INTEGER(KIND=I4KIND), PARAMETER :: NB     = 12
    INTEGER(KIND=I4KIND), PARAMETER :: INLTE  =  3 
    INTEGER(KIND=I4KIND), PARAMETER :: INLTEP = INLTE + 1 
    INTEGER(KIND=I4KIND), PARAMETER :: NNLTE  = 56
    INTEGER(KIND=I4KIND), PARAMETER :: LP1I   = IMAX  * LP1 
    INTEGER(KIND=I4KIND), PARAMETER :: LLP1I  = IMAX  * LLP1
    INTEGER(KIND=I4KIND), PARAMETER :: LL3PI  = IMAX  * LL3P
    INTEGER(KIND=I4KIND), PARAMETER :: NB1    = NB    - 1
    INTEGER(KIND=I4KIND), PARAMETER :: KO2    = 12
    INTEGER(KIND=I4KIND), PARAMETER :: KO21   = KO2   + 1 
    INTEGER(KIND=I4KIND), PARAMETER :: KO2M   = KO2   - 1
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , N       , ICNT    , I1      , I2      , I2E     , J       , JP      , IA      ,   &
    & NSB     , NSUBDS         
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & CENT    , DEL     , BDLO    , BDHI    , ANU     , C1
!--------------------------------------------------------------
! COMPUTE LOCAL QUANTITIES AND AO3,BO3,AB15 FOR NARROW-BANDS...
!--------------------------------------------------------------
    DO 101 N=1,NBLW
           ANB(N) = ARNDM(N)
           BNB(N) = BRNDM(N)
        CENTNB(N) = HAF       * (BANDLO(N) + BANDHI(N))
         DELNB(N) = BANDHI(N) -  BANDLO(N)
        BETANB(N) = BETAD(N)
101 END DO
!
    AB15(1) = ANB(57) * BNB(57)
    AB15(2) = ANB(58) * BNB(58)
!------------------  
! FOR WIDE BANDS...
!------------------ 
    AB15WD = AWIDE * BWIDE
!--------------------------------- 
! COMPUTE INDICES: IND,INDX2,KMAXV
!--------------------------------- 
    DO 111 I=1,IMAX
        IND(I) = I
111 END DO
!
    ICNT = 0
!
    DO 113 I1=1,L
        I2E = LP1 - I1
        DO 115 I2=1,I2E
            ICNT        = ICNT + 1
            INDX2(ICNT) = LP1 * (I2 - 1) + LP2 * I1
    115 END DO
113 END DO
!
    KMAXV(1) = 1
!
    DO 117 I=2,L
        KMAXV(I) = KMAXV(I-1) + (LP2-I)
117 END DO
!
    KMAXVM = KMAXV(L)
!------------------------------- 
! COMPUTE RATIOS OF CONT. COEFFS
!--------------------------------- 
    SKC1R = BETAWD    / BETINW
    SKO3R = BETAD(61) / BETINW
    SKO2D = ONE       / BETINW
!-------------------------------------------------------------------------------------------------- 
! BEGIN TABLE COMPUTATIONS HERE 
! COMPUTE TEMPS, MASSES FOR TABLE ENTRIES
! NOTE: THE DIMENSIONING AND INITIALIZATION OF XTEMV AND OTHER ARRAYS WITH DIMENSION OF 28 IMPLY
! A RESTRICTION OF MODEL TEMPERATURES FROM 100K TO 370K.
! THE DIMENSIONING OF ZMASS,ZROOT AND OTHER ARRAYS WITH DIMENSION OF 180 IMPLY A RESTRICTION OF
! MODEL H2O AMOUNTS SUCH THAT OPTICAL PATHS ARE BETWEEN 10**-16 AND 10**2, IN CGS UNITS.
!--------------------------------------------------------------------------------------------------
    ZMASS(1) = H1M16
!
    DO 201 J=1,180
        JP = J+1
        ZROOT(J) = SQRT(ZMASS(J))
        ZMASS(JP) = ZMASS(J) * H1P25892
201 END DO
!
    DO 203 I=1,28
         XTEMV(I) = HNINETY + TEN      * I
         TFOUR(I) =           XTEMV(I) * XTEMV(I) * XTEMV(I) * XTEMV(I)
        FORTCU(I) = FOUR    * XTEMV(I) * XTEMV(I) * XTEMV(I)
203 END DO
!------------------------------------------------------------------------------------------------------------------------------- 
! THE COMPUTATION OF SOURCE,DSRCE IS NEEDED ONLY FOR THE COMBINED WIDE-BAND CASE.TO OBTAIN THEM, THE SOURCE MUST BE COMPUTED FOR 
! EACH OF THE (NBLX) WIDE BANDS(=SRCWD) THEN COMBINED (USING IBAND) INTO SOURCE.
!-------------------------------------------------------------------------------------------------------------------------------
    DO 205 N=1,NBLY
        DO 205 I=1,28
            SOURCE(I,N) = ZERO
205 END DO
!
    DO 207 N=1,NBLX
        DO 207 I=1,28
             SRCWD(I,N) = ZERO
207 END DO
!------------------------ 
! BEGIN FREQ. LOOP (ON N)
!------------------------
    DO 211 N=1,NBLX
        IF (N <= 46) THEN
!------------------------
! THE 160-1200 BAND CASES
!------------------------
            CENT = CENTNB(N+16)
            DEL  =  DELNB(N+16)
            BDLO = BANDLO(N+16)
            BDHI = BANDHI(N+16)
        END IF
!
        IF (N == NBLX) THEN
!------------------------
! THE 2270-2380 BAND CASE
!------------------------
            CENT = CENTNB(NBLW)
            DEL  =  DELNB(NBLW)
            BDLO = BANDLO(NBLW)
            BDHI = BANDHI(NBLW)
        END IF
!---------------------------------------------------------------------------------------------------------------------------------
! FOR PURPOSES OF ACCURACY, ALL EVALUATIONS OF PLANCK FCTNS ARE MADE ON 10 CM-1 INTERVALS, THEN SUMMED INTO THE (NBLX) WIDE BANDS.
!---------------------------------------------------------------------------------------------------------------------------------
        NSUBDS = (DEL - H1M3) / 10 + 1
!
        DO 213 NSB=1,NSUBDS
            IF (NSB /= NSUBDS) THEN
                CNUSB(NSB) = TEN * (NSB-1) + BDLO + FIVE
                DNUSB(NSB) = TEN
            ELSE
                CNUSB(NSB) = HAF * (TEN*(NSB-1) + BDLO + BDHI)
                DNUSB(NSB) = BDHI - (TEN * (NSB-1) + BDLO)
            END IF
!
            C1 = (H37412M5) * CNUSB(NSB) ** 3
!------------------------ 
! BEGIN TEMP. LOOP (ON I)
!------------------------
            DO 215 I=1,28
                    X(I) = H1P4387 * CNUSB(NSB) / XTEMV(I)
                   X1(I) = EXP(X(I))
                 SRCS(I) = C1 / (X1(I) - ONE)
                SRCWD(I,N) = SRCWD(I,N) + SRCS(I) * DNUSB(NSB)
        215 END DO
    213 END DO
!
211 END DO
!------------------------------------------------------------------------------
! THE FOLLOWING LOOPS CREATE THE COMBINED WIDE BAND QUANTITIES SOURCE AND DSRCE
!------------------------------------------------------------------------------
    DO 221 N=1,40
        DO 221 I=1,28
            SOURCE(I,IBAND(N)) = SOURCE(I,IBAND(N)) + SRCWD(I,N)
221 END DO
!
    DO 223 N=9,NBLY
        DO 223 I=1,28
            SOURCE(I,N) = SRCWD(I,N+32)
223 END DO
!
    DO 225 N=1,NBLY
        DO 225 I=1,27
            DSRCE(I,N) = (SOURCE(I+1,N) - SOURCE(I,N)) * HP1
225 END DO
!
    DO 231 N=1,NBLW
        ALFANB(N) = BNB(N) * ANB(N)
        AROTNB(N) =  SQRT(ALFANB(N))
231 END DO
!--------------------------------------------------------------------------------------------------
! FIRST COMPUTE PLANCK FCTNS (SRC1NB) AND DERIVATIVES (DBDTNB) FOR USE IN TABLE EVALUATIONS. THESE
! ARE DIFFERENT FROM SOURCE,DSRCE BECAUSE DIFFERENT FREQUENCY PTS ARE USED IN EVALUATION, 
! THE FREQ. RANGES ARE DIFFERENT, AND THE DERIVATIVE ALGORITHM IS DIFFERENT.
!--------------------------------------------------------------------------------------------------
    DO 301 N=1,NBLW
        CENT = CENTNB(N)
         DEL =  DELNB(N)
!--------------------------------------------------------------------------------------------------
! NOTE: AT PRESENT, THE IA LOOP IS ONLY USED FOR IA=2. THE LOOP STRUCT IS KEPT SO THAT IN THE 
! FUTURE, WE MAY USE A QUADRATURE SCHEME FOR THE PLANCK FCTN EVALUATION, RATHER THAN USE THE 
! MID-BAND FREQUENCY.
!--------------------------------------------------------------------------------------------------
        DO 303 IA=1,3
            ANU = CENT + HAF * (IA-2) * DEL
             C1 = (H37412M5) * ANU * ANU * ANU + H1M20
!----------------- 
! TEMPERATURE LOOP
!-----------------
            DO 305 I=1,28
                  X(I) = H1P4387 * ANU / XTEMV(I)
                 X1(I) = EXP(X(I))
                 SC(I) = C1 / ((X1(I) - ONE) + H1M20)
                DSC(I) = SC(I) * SC(I) * X(I) * X1(I) / (XTEMV(I) *C1)
        305 END DO
!
            IF (IA == 2) THEN
                DO 307 I=1,28
                    SRC1NB(I,N) = DEL * SC(I)
                    DBDTNB(I,N) = DEL * DSC(I)
            307 END DO
            END IF
!
    303 END DO
!
301 END DO
!--------------------------------------------------------------------------------------------------
! NEXT COMPUTE R1,R2,S2,AND T3-COEFFICIENTS USED FOR E3 FUNCTION WHEN THE OPTICAL PATH IS LESS
! THAN 10-4. IN THIS CASE, WE ASSUME A DIFFERENT DEPENDENCE ON (ZMASS). ALSO OBTAIN R1WD, 
! WHICH IS R1 SUMMED OVER THE 160-560 CM-1 RANGE
!--------------------------------------------------------------------------------------------------
    DO 311 I=1,28
          SUM4(I) = ZERO
          SUM6(I) = ZERO
          SUM7(I) = ZERO
          SUM8(I) = ZERO
        SUM4WD(I) = ZERO
311 END DO
!
    DO 313 N=1,NBLW
        CENT = CENTNB(N)
!------------------------------------------------------------------------------------- 
! PERFORM SUMMATIONS FOR FREQ. RANGES OF 0-560,1200-2200 CM-1 FOR SUM4, SUM6,SUM7,SUM8
!------------------------------------------------------------------------------------- 
        IF (CENT < 560. .OR. CENT > 1200. .AND. CENT <= 2200.) THEN
            DO 315 I=1,28
                SUM4(I) = SUM4(I) + SRC1NB(I,N)
                SUM6(I) = SUM6(I) + DBDTNB(I,N)
                SUM7(I) = SUM7(I) + DBDTNB(I,N) * AROTNB(N)
                SUM8(I) = SUM8(I) + DBDTNB(I,N) * ALFANB(N)
        315 END DO
        END IF
!----------------------------------------------------------------------  
! PERFORM SUMMATIONS OVER 160-560 CM-1 FREQ RANGE FOR E1 CALCS (SUM4WD)
!----------------------------------------------------------------------
        IF (CENT > 160. .AND. CENT < 560.) THEN
            DO 316 I=1,28
                SUM4WD(I) = SUM4WD(I) + SRC1NB(I,N)
        316 END DO
        END IF
!
313 END DO
!
    DO 317 I=1,28
          R1(I) =   SUM4(I) /  TFOUR(I)
          R2(I) =   SUM6(I) / FORTCU(I)
          S2(I) =   SUM7(I) / FORTCU(I)
          T3(I) =   SUM8(I) / FORTCU(I)
        R1WD(I) = SUM4WD(I) /  TFOUR(I)
317 END DO
!
    DO 401 J=1,180
        DO 401 I=1,28
               SUM(I,J) = ZERO
            PERTSM(I,J) = ZERO
              SUM3(I,J) = ZERO
            SUMWDE(I,J) = ZERO
401 END DO
!---------------------- 
! FREQUENCY LOOP BEGINS 
!----------------------
    DO 411 N=1,NBLW
        CENT = CENTNB(N)
!--------------------------------------------------------------
! PERFORM CALCULATIONS FOR FREQ. RANGES OF 0-560,1200-2200 CM-1
!--------------------------------------------------------------
        IF (CENT < 560. .OR. CENT > 1200. .AND. CENT <= 2200.) THEN
            DO 413 J=1,180
                  X2(J) = AROTNB(N) * ZROOT(J)
                EXPO(J) = EXP(-X2(J))
        413 END DO
!
            DO 415 J=1,180
                IF (X2(J) >= HUNDRED) THEN
                    EXPO(J) = ZERO
                END IF
        415 END DO
!
            DO 417 J=121,180
                FAC(J) = ZMASS(J) * (ONE - (ONE + X2(J)) * EXPO(J)) / (X2(J) * X2(J))
        417 END DO
!
            DO 419 J=1,180
                DO 419 I=1,28
                       SUM(I,J) =    SUM(I,J) + SRC1NB(I,N) * EXPO(J)
                    PERTSM(I,J) = PERTSM(I,J) + DBDTNB(I,N) * EXPO(J)
        419 END DO
!
            DO 421 J=121,180
                DO 421 I=1,28
                    SUM3(I,J) = SUM3(I,J) + DBDTNB(I,N) * FAC(J)
        421 END DO
        END IF
!-----------------------------------------------------------------
! COMPUTE SUM OVER 160-560 CM-1 RANGE FOR USE IN E1 CALCS (SUMWDE)
!-----------------------------------------------------------------
        IF (CENT > 160. .AND. CENT < 560.) THEN
            DO 420 J=1,180
                DO 420 I=1,28
                    SUMWDE(I,J) = SUMWDE(I,J) + SRC1NB(I,N) * EXPO(J)
        420 END DO
        END IF
!
411 END DO
!
    DO 431 J=1,180
        DO 431 I=1,28
               EM1(I,J) =    SUM(I,J) /  TFOUR(I)
            TABLE1(I,J) = PERTSM(I,J) / FORTCU(I)
431 END DO
!
    DO 433 J=121,180
        DO 433 I=1,28
            EM3(I,J) = SUM3(I,J) / FORTCU(I)
433 END DO
!
    DO 441 J=1,179
        DO 441 I=1,28
            TABLE2(I,J) = (TABLE1(I,J+1) - TABLE1(I,J)) * TEN
441 END DO
!
    DO 443 J=1,180
        DO 443 I=1,27
            TABLE3(I,J) = (TABLE1(I+1,J) - TABLE1(I,J)) * HP1
443 END DO
!
    DO 445 I=1,28
        TABLE2(I,180) = ZERO
445 END DO
!
    DO 447 J=1,180
        TABLE3(28,J)  = ZERO
447 END DO
!
    DO 449 J=1,2
        DO 449 I=1,28
            EM1(I,J)  = R1(I)
449 END DO
!
    DO 451 J=1,120
        DO 451 I=1,28
            EM3(I,J)  = R2(I) / TWO-S2(I) * SQRT(ZMASS(J)) / THREE + T3(I) * ZMASS(J) / EIGHT
451 END DO
!
    DO 453 J=121,180
        DO 453 I=1,28
            EM3(I,J)  = EM3(I,J) / ZMASS(J)
453 END DO
!------------------------------------------------------------------------------------------
! NOW COMPUTE E1 TABLES FOR 160-560 CM-1 BANDS ONLY. WE USE R1WD AND SUMWDE OBTAINED ABOVE.
!------------------------------------------------------------------------------------------
    DO 501 J=1,180
        DO 501 I=1,28
            EM1WDE(I,J) = SUMWDE(I,J) / TFOUR(I)
501 END DO
!
    DO 503 J=1,2
        DO 503 I=1,28
            EM1WDE(I,J) = R1WD(I)
503 END DO
!
    RETURN
!
    END SUBROUTINE TABLE

    MODULE NHYDRO
!>--------------------------------------------------------------------------------------------------
!> MODULE NHYDRO
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              CHKOUT
!>              DIVHOA
!>              DIVHOAST
!>              EBU
!>              EPS
!>              GOSSIP
!>              HADZ
!>              INIT
!>              INITS
!>              PDTEDT
!>              PGCOR
!>              VADZ
!>              VTADV
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : LM, IDIM1, IDIM2, JDIM1, JDIM2
!
    IMPLICIT NONE
!
    SAVE
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & HYDRO   , SPLINE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & DWDT    , PDWDT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM+1)                             ::&
    & PINT    ,                                                                                   &
    & W       ,                                                                                   &
    & Z     
!
    END MODULE NHYDRO                             

    SUBROUTINE PDNEW
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PDNEW
!>
!> SUBROUTINE: PDNEW - UPDATE SURFACE PRESSURE
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 94-03-08
!>
!> ABSTRACT:
!> PDNEW UPDATES THE SURFACE PRESSURE FROM THE TENDENCY COMPUTED IN PDTE.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO     
!>              VRBLS     
!>
!> DRIVER     : DIGFLT
!>              EBU
!>              NEWFLT       
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J
!
#include "sp.h"
!----------------------------- 
! UPDATING PRESSURE DIFFERENCE 
!----------------------------- 
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
            PD(I,J) = PSDT(I,J) * DT + PD(I,J)
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE PDNEW

    SUBROUTINE TWR
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE TWR
!>
!> SUBPROGRAM: TWR - ?????
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : -----
!>
!> CALLS      : MPI_BARRIER
!>              MPI_RECV
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & JSTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE,4)                                          ::&
    & STATUS_ARRAY
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                                     ::&
    & TWRITE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    &  ARRAY_LOC
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IOUT    , I       , J       , L       , IPE     , MAXVALS , IRECV   , JOFFSET , JGLB    ,   &
    & JLOC    , IOFFSET , IGLB    , NUMVALS , ISEND   , IRTN    , IENDX
!
    IOUT = 80
!
    REWIND IOUT
!
    DO 500 L=1,LM
!    
        IF (MYPE == 0) THEN
            DO J=MY_JS_LOC,MY_JE_LOC
                DO I=MY_IS_LOC,MY_IE_LOC
                    TWRITE(I + MY_IS_GLB - 1, J + MY_JS_GLB - 1) = T(I,J,L)
                END DO
            END DO
!        
            DO IPE=1,NPES-1
                MAXVALS = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
!            
                CALL MPI_RECV(ARRAY_LOC, MAXVALS, MPI_REAL, IPE, IPE, MPI_COMM_COMP, JSTAT, IRECV)
!            
                JOFFSET = 0
!
                DO JGLB=JS_GLB_TABLE(IPE),JE_GLB_TABLE(IPE)
                    JLOC    = JS_LOC_TABLE(IPE) + JOFFSET
                    IOFFSET = 0
!
                    DO IGLB=IS_GLB_TABLE(IPE),IE_GLB_TABLE(IPE)
                        TWRITE(IGLB,JGLB) = ARRAY_LOC(IS_LOC_TABLE(IPE) + IOFFSET, JLOC)
                        IOFFSET           = IOFFSET                     + 1
                    END DO
!
                    JOFFSET = JOFFSET + 1
!
                END DO
            END DO
!        
        ELSE
!
            NUMVALS = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
!												   
            CALL MPI_SEND(T(IDIM1,JDIM1,L), NUMVALS, MPI_REAL, 0, MYPE,MPI_COMM_COMP, ISEND)
!
        END IF
!    
        CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!    
        IF (MYPE == 0) THEN
            DO J=1,JM
                IENDX = IM
!
                IF (MOD(J,2) == 0) IENDX = IM - 1
!
                WRITE(IOUT) (TWRITE(I,J), I=1,IENDX)
            END DO
        END IF
!
500 END DO
!
    RETURN
!
    END SUBROUTINE TWR

    MODULE INPUT
!>--------------------------------------------------------------------------------------------------
!> MODULE INPUT
!>
!> ABSTRACT:
!> THIS MODULE IS FOR THE INPUT DATA WHEN IT IS DERIVED INTERNALLY. 
!> IN RADMN, THESE DATA ARE TRANSFERRED INTO THE EAL INPUT MODULE, RADISW.
!>
!> USE MODULES: F77KINDS
!>              RDPARM
!>
!> DRIVER     : GFDLRD
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : L, LP1    
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ICH     , ICM     , ICT     , ICB
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & CH      , CM      , CL      , EMCH    , EMCM    , EMCL
!
    REAL   (KIND=R4KIND), DIMENSION(L)                                                          ::&
    & RR      , QQO3
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & DTEMP   , PPRESS 
!------------
! FROM GFDLRD
!------------
    DATA CH  , CM  , CL  , ICH, ICM, ICT, ICB / .159,  .07,  .269, 5, 11, 12, 14/
    DATA EMCH, EMCM, EMCL                     /1.   , 1.  , 1.                  /
!
    END MODULE INPUT

    SUBROUTINE COLLECT(A, B)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE COLLECT
!>
!> SUBROUTINE: COLLECT - COLLECT UP DATA ON TASK 0
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-20
!>
!> ABSTRACT: 
!> COLLECTS UP DATA ON TASK 0.
!>
!> PROGRAM HISTORY LOG:
!> 00-01-20  TUCCILLO - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> A -
!>
!> OUTPUT ARGUMENT LIST:
!> B - 
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> EXIT STATES:
!> CONDITION 0 - NORMAL EXIT
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : QUILT
!>
!> CALLS      : MPI_RECV
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                       , INTENT(IN)       ::&
    & A
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                  , INTENT(INOUT)    ::&
    & B
!
    REAL   (KIND=R4KIND), DIMENSION(IM*JM)                                                      ::&
    & BUF
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & STATUS
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , IERR
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & K       , II      , III
!
    IF (ME == 0) THEN
!   
        DO K=JSTA(ME),JEND(ME)
            DO J=MY_JS_GLB_A(K),MY_JE_GLB_A(K)
                DO I=MY_IS_GLB_A(K),MY_IE_GLB_A(K)
                    B(I,J) = A(I,J)
                END DO 
            END DO
        END DO
!---------------------------
! RECEIVE FROM EVERYONE ELSE
!---------------------------    
        DO II=1,NUM_PROCS-1
            CALL MPI_SEND(II , 1    , MPI_INTEGER, II, 0 , MPI_COMM_COMP, IERR)
            CALL MPI_RECV(BUF, IM*JM, MPI_REAL   , II, II, MPI_COMM_COMP, STATUS, IERR)
            III = 0
            DO K=JSTA(II),JEND(II)
                DO J=MY_JS_GLB_A(K),MY_JE_GLB_A(K)
                    DO I=MY_IS_GLB_A(K),MY_IE_GLB_A(K)
                        III = III + 1
                        B(I,J) = BUF(III)
                    END DO
                END DO
            END DO
        END DO
    ELSE 
        III = 0
        DO K=JSTA(ME),JEND(ME)
            DO J=MY_JS_GLB_A(K),MY_JE_GLB_A(K)
                DO I=MY_IS_GLB_A(K),MY_IE_GLB_A(K)
                    III = III + 1
                    BUF(III) = A(I,J)
                END DO 
            END DO
        END DO
!
        CALL MPI_RECV(II , 1  , MPI_INTEGER, 0, 0 , MPI_COMM_COMP, STATUS, IERR)
        CALL MPI_SEND(BUF, III, MPI_REAL   , 0, ME, MPI_COMM_COMP, IERR)
!    
    END IF
!
    END SUBROUTINE COLLECT

    SUBROUTINE VWR
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VWR
!>
!> SUBPROGRAM: VWR - ?????
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : -----
!>
!> CALLS      : MPI_BARRIER
!>              MPI_RECV
!>              MPI_SEND
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & JSTAT
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE, 4)                                         ::&
    & STATUS_ARRAY
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                                     ::&
    & VWRITE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , L       , IOUT    , IRTN    , IPE     , ISTAT   , IRECV   , ISEND   ,   &
    & IENDX
!
    IOUT = 80
!
    DO 500 L=1,LM
!    
        DO J=JS_LOC_TABLE(MYPE),JE_LOC_TABLE(MYPE)
            DO I=IS_LOC_TABLE(MYPE),IE_LOC_TABLE(MYPE)
                VWRITE(I+MY_IS_GLB-1,J+MY_JS_GLB-1) = V(I,J,L)
            END DO
        END DO
!    
        CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!    
        IF (MYPE == 0) THEN
            DO IPE=1,NPES-1
                DO J=JS_GLB_TABLE(IPE),JE_GLB_TABLE(IPE)
                    CALL MPI_RECV(VWRITE(IS_GLB_TABLE(IPE),J), ICHUNKTAB(IPE),                    &
    &                             MPI_REAL, IPE, 99, MPI_COMM_COMP, ISTAT, IRECV)
                END DO
            END DO
!        
        ELSE
!
            DO J=MY_JS_GLB,MY_JE_GLB
                CALL MPI_SEND(VWRITE(MY_IS_GLB,J), ICHUNKTAB(MYPE),                               &
    &                                MPI_REAL, 0, 99, MPI_COMM_COMP, ISEND)
            END DO
        END IF
!    
        IF (MYPE == 0) THEN
            DO J=1,JM
                IENDX=IM
                IF (MOD(J,2) == 1) IENDX = IM-1
                WRITE(IOUT) (VWRITE(I,J),I=1,IENDX)
            END DO
        END IF
!
500 END DO
!
    STOP 555
!
    RETURN
    END SUBROUTINE VWR

    MODULE CLDWTR
!>--------------------------------------------------------------------------------------------------
!> MODULE CLDWTR
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              CHKOUT
!>              DDAMP
!>              DIVHOA
!>              EBU
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADV2
!>              HZADVS
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDTE
!>              PRECPD
!>              RADTN
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              VADZ
!>              VTADV
!>              WRTRST
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IDIM1, IDIM2, JDIM1, JDIM2, LM
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & CWM
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & LC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & U00     , SR
!
    REAL   (KIND=R4KIND), DIMENSION(2*LM)                                                       ::&
    & UL
!
    END MODULE CLDWTR

    SUBROUTINE SLPSIGSPLINE(PD, FIS, TSIG, QSIG, SPL, LSL, DETA, PT, PSLP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SLPSIGSPLINE
!>
!> SUBROUTINE: SLPSIGSPLINE - SLP REDUCTION
!> PROGRAMMER: JANJIC, D. JOVIC, S. NICKOVIC
!> ORG: ?????
!> DATE: 81-02-??
!>
!> PROGRAMMER: JANJIC, D. JOVIC, S. NICKOVIC
!> ORG: ?????
!> DATE: 81-02-??
!>
!> ABSTRACT: THIS ROUTINE COMPUTES THE SEA LEVEL PRESSURE REDUCTION USING CUBIC SPLINE FITTING
!>           METHOD OR THE STANDARD NCEP REDUCTION FOR SIGMA COORDINATES.
!>
!> PROGRAM HISTORY LOG:
!> 81-02-??  JANJIC       - ORIGINATOR
!> 00-09-??  H CHUANG     - INCLUDED IN OPERATIONAL MPI QUILT 
!> 18-01-15  LUCCI        - MODERNIZATION OF THE CODE, INCLUDING:
!>                          * F77 TO F90/F95
!>                          * INDENTATION & UNIFORMIZATION CODE
!>                          * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                          * DOCUMENTATION WITH DOXYGEN
!>                          * OPENMP FUNCTIONALITY
!>
!> NOTE: CURRENT POST ONLY PROCESS UP TO 1000 MB PRESSURE LEVEL 2 ADDITIONAL LEVELS (1025 1050) ARE
!>       ADDED DURING SPLINE FITTING COMPUTATION BUT THE FIELDS ON THESE TWO LEVELS ARE NOT OUTPUT 
!>       TO GRID FILES.
!>
!> INPUT ARGUMENT LIST:
!> PD   - SFC PRESSURE MINUS PTOP
!> FIS  - SURFACE GEOPOTENTIAL
!> TSIG - TEMPERATURE
!> QSIG - SPECIFIC HUMIDITY
!> FI   - GEOPOTENTIAL
!> PT   - TOP PRESSURE OF DOMAIN
!>
!> OUTPUT ARGUMENT LIST:
!> PSLP - THE FINAL REDUCED SEA LEVEL PRESSURE ARRAY
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : QUILT
!>
!> CALLS      : SPLINEF
!>              UPDATE 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE	
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LMP1   = LM  + 1
    INTEGER(KIND=I4KIND), PARAMETER :: NSMUD  =  25 
    INTEGER(KIND=I4KIND), PARAMETER :: LP2    = LM  + 2
    INTEGER(KIND=I4KIND), PARAMETER :: LSMP2  = LSM + 2
    INTEGER(KIND=I4KIND), PARAMETER :: III    =  22
    INTEGER(KIND=I4KIND), PARAMETER :: JJJ    = 293
!
    REAL   (KIND=R4KIND), PARAMETER :: RD     = 287.04
    REAL   (KIND=R4KIND), PARAMETER :: ROG    = RD / 9.8
    REAL   (KIND=R4KIND), PARAMETER :: PQ0    = 379.90516
    REAL   (KIND=R4KIND), PARAMETER :: A2     =  17.2693882 
    REAL   (KIND=R4KIND), PARAMETER :: A3     = 273.16
    REAL   (KIND=R4KIND), PARAMETER :: A4     =  35.86
    REAL   (KIND=R4KIND), PARAMETER :: GAMMA  =   6.5E-3
    REAL   (KIND=R4KIND), PARAMETER :: RGAMOG = GAMMA * ROG
    REAL   (KIND=R4KIND), PARAMETER :: H1M12  =   1.E-12
    REAL   (KIND=R4KIND), PARAMETER :: G      =   9.8
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                    , INTENT(IN)          ::&
    & PD      , FIS     
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                                          ::&
    & TMASK   , FSLL
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LSMP2)                                   ::&
    & FI
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED, LM)                , INTENT(IN)          ::&
    & TSIG    , QSIG
!
    REAL   (KIND=R4KIND), DIMENSION(IM, MY_JSD:MY_JED)                    , INTENT(INOUT)       ::&
    & PSLP
!
    REAL   (KIND=R4KIND), DIMENSION(LSM)                                  , INTENT(IN)          ::&
    & SPL
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::&
    & DETA 
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & AETA
!
    REAL   (KIND=R4KIND), DIMENSION(LMP1)                                                       ::&
    & ETA
!
    REAL   (KIND=R4KIND), DIMENSION(LM+2)                                                       ::&
    & ZTH     , HCOL    , Y2      , PHLD    , QHLD
!
    REAL   (KIND=R4KIND), DIMENSION(LSMP2)                                                      ::&
    & ZTSL    , OVRLX   , HCOLSL
!
    REAL   (KIND=R4KIND), DIMENSION(3)                                                          ::&
    & HCOL3   , PCOL3   , Y23
!
    DATA Y2 /LP2 * 0./
    DATA OVRLX /LSMP2 * 0.175/
!
    INTEGER(KIND=I4KIND), DIMENSION(JM)                                                         ::&
    & IHE     , IHW
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & SIGMA, STDRD
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LSL
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & PT
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , L       , IHL     , IHH     , IVI     , LMD     , N       , LLL     ,   &
    & LMA
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ZTBOT   , PDP     , ALP1L   , ALP2L   , DH      , X       , DUM     , D2      , RLX     ,   &
    & HREF    , GAR     , SLP1    , ALP1U   , ALP2U   , ALPP1   , SLOP    , SLPP    , TTT
!
    STDRD = .FALSE. 
!------------------------------------------ 
!CALCULATE THE I-INDEX EAST-WEST INCREMENTS
!------------------------------------------ 
    DO J=1,JM
        IHE(J) = MOD(J+1,2)
        IHW(J) = IHE(J)-1
    END DO
!---------------------------------------------------------- 
! INITIALIZE ARRAYS.  LOAD SLP ARRAY WITH SURFACE PRESSURE.
!----------------------------------------------------------
!
!$omp parallel do
!
    DO J=JSTA_I,JEND_I
        DO I=1,IM
            PSLP(I,J) = PD(I,J) + PT
        END DO
    END DO
!
    DO 100 L=1,LSM
        ZTSL(L) = ALOG(SPL(L) ) ** 2
100 END DO
!
    ZTSL(LSM+1) = ALOG(102500.) ** 2
    ZTSL(LSMP2) = ALOG(105000.) ** 2
!
    ZTBOT = ZTSL(LSMP2)
!---------------------  
! COMPUTE ETA AND AETA
!--------------------- 
    ETA(1) = 0.0
!
    DO L=2,LM+1
         ETA(L) =        ETA(L-1) + DETA(L-1)
    END DO
!
    DO L=1,LM
        AETA(L) = 0.5 * (ETA(L  ) +  ETA(L+1))
    END DO
!
    DO 200 J=JSTA_I,JEND_I
        IHL = 1
        IHH = IM-1 + MOD(J,2)
!
        DO 201 I=IHL,IHH
            PDP        =  PD(I,J)
            HCOL(LM+1) = FIS(I,J) / G
!
            ALP1L      =  ALOG(PT  + PDP)
            ZTH(LM+1)  = (ALOG(PDP + PT )) ** 2
!
            DO 220 IVI=1,LM
                L       = LM + 1 - IVI
                ALP1U   =  ALOG(ETA(L) * PDP + PT)
                ALP2U   = (ALOG(ETA(L) * PDP + PT)) ** 2
                DH      = (QSIG(I,J,L) * 0.608 + 1.) * (ALP1L - ALP1U) * TSIG(I,J,L) * ROG
!
                 ZTH(L) = ALP2U
                HCOL(L) = HCOL(L+1) + DH
!
                ALP1L   = ALP1U
        220 END DO
!
            IF (ZTH(LM+1) >= ZTBOT) THEN
                LMD = LM + 1
            ELSE
                LMD        = LM + 2
                ZTH(LM+2)  = ZTBOT
                X          = ZTBOT - ZTH(LM+1)
                DUM        = (HCOL(LM+1) - HCOL(LM-5)) / (ZTH(LM+1) - ZTH(LM-5))
                D2         = 0.
                HCOL(LM+2) = D2 * X * X + DUM * X + HCOL(LM+1)
            END IF
!
            Y2(LMD) = 0.
!
            CALL SPLINEF(LMD, ZTH, HCOL, Y2, LSMP2, ZTSL, HCOLSL, PHLD, QHLD)
!
            DO 240 L=1,LSMP2
                FI(I,J,L) = HCOLSL(L)
        240 END DO
!
    201 END DO
!
 200 END DO
!-------------------------------------------------- 
! FILLING REMAINING UNDEFINED MASS POINT BOUNDARIES 
!-------------------------------------------------- 
    DO 300 L=1,LSMP2
!
        IF (MOD(JSTA_I,2) < 1) THEN !EVEN JSTA_I
!
            DO 351 J=JSTA_I,JEND_I,2
                FI(IM,J,L) = FI(IM-1,J,L)
        351 END DO
!
        ELSE
!
            DO 352 J=JSTA_I+1,JEND_I,2
                FI(IM,J,L) = FI(IM-1,J,L)
            352 END DO
!
        END IF
!
        RLX = OVRLX(L)
!
        DO 310 J=JSTA_I,JEND_I
            IHL = 1
            IHH = IM - 1 + MOD(J,2)
!
            DO 311 I=IHL,IHH
                HREF = FIS(I,J) / G
!
                IF (HREF > 300.) THEN
                    HREF = HREF + 1500.
                END IF
!
                IF (HREF >= FI(I,J,L)) THEN
                    TMASK(I,J) = RLX
                ELSE
                    TMASK(I,J) = 0.
                END IF
!
        311 END DO
!
    310 END DO
!
        DO 320 N=1,NSMUD
!
            CALL UPDATE(FI(1,MY_JSD,L))
!
            DO 330 J=JSTA_IM,JEND_IM
                IHL = 1 + MOD(J,2)
                IHH = IM-1
!
                DO 331 I=IHL,IHH
                    IF (TMASK(I,J) > 0.05) THEN
                        FSLL(I,J) = FI(I + IHW(J),J-1,L) + FI(I + IHE(J),J-1,L)                   &
    &                             + FI(I + IHW(J),J+1,L) + FI(I + IHE(J),J+1,L) - FI(I,J,L) * 4.
                    END IF
            331 END DO
!
        330 END DO
!------------------------- 
! PRINT*,'AFTER SMOOTHING'
!------------------------- 
            DO 340 J=JSTA_IM,JEND_IM
                IHL = 1 + MOD(J,2)
                IHH = IM-1
!
                DO 341 I=IHL,IHH
                    IF (TMASK(I,J) > 0.05) THEN
                        FI(I,J,L) = FSLL(I,J) * TMASK(I,J) + FI(I,J,L)
                    END IF
            341 END DO
!
        340 END DO
!
    320 END DO
!
300 END DO
!-------------------  
! SEA LEVEL PRESSURE 
!-------------------
    DO 600 J=JSTA_I,JEND_I
        IHL = 1
        IHH = IM - 1 + MOD(J,2)
!
        DO 601 I=IHL,IHH
            IF (FIS(I,J) > -1. .AND. FIS(I,J) < 1.) THEN
                PSLP(I,J) = PT + PD(I,J)
            ELSE
                IF (FI(I,J,LSMP2) > 0) THEN
!---------------------- 
! ASSUME PSLP < 1100 MB
!---------------------- 
                    GAR = EXP(ZTSL(LSMP2) ** 0.5) + 5000. 
                    HCOL3(1) = FI(I,J,LSMP2) + (FI(I,J,LSMP2) - FI(I,J,LSMP2-5))                  &
    &                        * (ALOG(GAR) ** 2. - ZTSL(LSMP2)) / (ZTSL(LSMP2) - ZTSL(LSMP2-5))
                    HCOL3(2) = FI(I,J,LSMP2  )
                    HCOL3(3) = FI(I,J,LSMP2-1)
                    PCOL3(1) = GAR
                    PCOL3(2) = EXP(ZTSL(LSMP2  ) ** 0.5)
                    PCOL3(3) = EXP(ZTSL(LSMP2-1) ** 0.5)
                ELSE
                    DO L=LSMP2,2,-1
                        IF (FI(I,J,L) <= 0. .AND. FI(I,J,L-1) > 0.) THEN
                            LLL = L
                            GOTO 603
                        END IF
                    END DO
!
                603 HCOL3(1) = FI(I,J,LLL  )
                    HCOL3(2) = FI(I,J,LLL-1)
                    HCOL3(3) = FI(I,J,LLL-2)
!
                    PCOL3(1) = EXP(ZTSL(LLL  ) ** 0.5)
                    PCOL3(2) = EXP(ZTSL(LLL-1) ** 0.5)
                    PCOL3(3) = EXP(ZTSL(LLL-2) ** 0.5)
                END IF
!
                DO L=1,3
                    Y23(L) = 0.0
                END DO
!
                IF (HCOL3(1) == HCOL3(2) .OR. HCOL3(2) == HCOL3(3))                               &
    &               PRINT*, 'PROBLEM SLP', I, J, HCOL3(1), HCOL3(2), HCOL3(3)
!
                CALL SPLINEF(3, HCOL3, PCOL3, Y23, 1, 0.0, SLP1, PHLD, QHLD)
                PSLP(I,J) = SLP1
            END IF
!
    601 END DO
!
600 END DO
!-------------------------- 
! SKIP THE STANDARD SCHEME.
!-------------------------- 
    GOTO 430
!-------------------------------------------------------------------------
! IF YOU WANT THE "STANDARD" ETA/SIGMA REDUCTION THIS IS WHERE IT IS DONE.
!-------------------------------------------------------------------------
    DO 410 J=JSTA_I,JEND_I
        DO 410 I=1,IM
            IF (FIS(I,J) >= 1.) THEN
                LMA   = LM
                ALPP1 = ALOG(PD(I,J) + PT)
                SLOP  = 0.0065 * ROG * TSIG(I,J,LM)
!
                IF (SLOP < 0.50) THEN
                    SLPP = ALPP1 + FIS(I,J) / (RD * TSIG(I,J,LMA))
                ELSE
                    TTT = -(ALOG(PD(I,J) + PT) + ALPP1) *   SLOP * 0.50 + TSIG(I,J,LMA)
                    SLPP = (-TTT + SQRT(TTT * TTT + 2. * SLOP * (FIS(I,J) / RD                    &
    &                    +  (TTT + 0.50 * SLOP * ALPP1) * ALPP1))) / SLOP
                END IF
!
                PSLP(I,J) = EXP(SLPP)
!
            END IF
410 END DO
!--------------------------------------------------------------------------------------------------
! AT THIS POINT WE HAVE A SEA LEVEL PRESSURE FIELD BY EITHER METHOD. 5-POINT AVERAGE THE FIELD ON
! THE E-GRID.
!--------------------------------------------------------------------------------------------------
!
430 CONTINUE
!
    RETURN
!
    END SUBROUTINE SLPSIGSPLINE
!
!
!
    SUBROUTINE SPLINEF(NOLD, XOLD, YOLD, Y2, NNEW, XNEW, YNEW, P, Q)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SPLINEF
!>
!> SUBROUTINE: SLPSIGSPLINE - SLP REDUCTION
!> PROGRAMMER: JZ. JANJIC, YUGOSLAV FED. HYDROMET.
!> ORG: INST. BEOGRAD
!> DATE: 81-02-??
!>
!> ABSTRACT:
!> THIS IS A ONE-DIMENSIONAL CUBIC SPLINE FITTING ROUTINE PROGRAMED FOR A SMALL SCALAR MACHINE.
!>
!> PROGRAM HISTORY LOG:
!> 81-02-??  JANJIC       - ORIGINATOR
!> 18-01-15  LUCCI        - MODERNIZATION OF THE CODE, INCLUDING:
!>                          * F77 TO F90/F95
!>                          * INDENTATION & UNIFORMIZATION CODE
!>                          * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                          * DOCUMENTATION WITH DOXYGEN
!>                          * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NOLD - 
!> XOLD -
!> YOLD -
!> NNEW -
!> XNEW - 
!> YNEW -
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> Y2   -
!> P    -
!> Q    - 
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : SLPSIGSPLINE
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
!
!--------------------------------------------------------------------------------------------------
! NOLD - NUMBER OF GIVEN VALUES OF THE FUNCTION. MUST BE GE 3.
! XOLD - LOCATIONS OF THE POINTS AT WHICH THE VALUES OF THE FUNCTION ARE GIVEN. MUST BE IN 
!        ASCENDING ORDER.
! YOLD - THE GIVEN VALUES OF THE FUNCTION AT THE POINTS XOLD. 
! Y2   - THE SECOND DERIVATIVES AT THE POINTS XOLD. IF NATURAL SPLINE IS FITTED Y2(1)=0. 
!        AND Y2(NOLD)=0. MUST BE SPECIFIED.
! NNEW - NUMBER OF VALUES OF THE FUNCTION TO BE CALCULATED.
! XNEW - LOCATIONS OF THE POINTS AT WHICH THE VALUES OF THE FUNCTION ARE CALCULATED. XNEW(K) 
!        MUST BE GE XOLD(1) AND LE XOLD(NOLD).
! YNEW - THE VALUES OF THE FUNCTION TO BE CALCULATED. P, Q - AUXILIARY VECTORS OF THE LENGTH NOLD-2
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & NOLD    , NNEW
!
    REAL   (KIND=R4KIND), DIMENSION(NOLD)                                 , INTENT(IN)          ::&
    & XOLD    , YOLD    
!
    REAL   (KIND=R4KIND), DIMENSION(NOLD)                                 , INTENT(INOUT)       ::&
    & Y2      , P       , Q
!
    REAL   (KIND=R4KIND), DIMENSION(NNEW)                                 , INTENT(IN)          ::&
    & XNEW     
!
    REAL   (KIND=R4KIND), DIMENSION(NNEW)                                 , INTENT(INOUT)       ::&
    & YNEW
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NOLDM1  , K       , K1      , K2      , KOLD     
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DXL     , DXR     , DYDXL   , DYDXR   , RTDXC   , DXC     , DEN     , XK      , Y2K     ,   &
    & Y2KP1   , DX      , RDX     , AK      , BK      , CK      , X       , XSQ
!
    NOLDM1 = NOLD - 1
!
    DXL   =  XOLD(2)  - XOLD(1)
    DXR   =  XOLD(3)  - XOLD(2)
    DYDXL = (YOLD(2)  - YOLD(1)) / DXL
    DYDXR = (YOLD(3)  - YOLD(2)) / DXR
    RTDXC = .5 / (DXL + DXR)
!
    P(1) =  RTDXC * (6. * (DYDXR - DYDXL) - DXL * Y2(1))
    Q(1) = -RTDXC * DXR
!
    IF (NOLD == 3) GOTO 700
!
    K = 3
!
100 DXL   = DXR
    DYDXL = DYDXR
    DXR   = XOLD(K+1) - XOLD(K)
!
    DYDXR = (YOLD(K+1) - YOLD(K)) / DXR
    DXC   = DXL + DXR
    DEN   = 1. / (DXL * Q(K-2) + DXC + DXC)
!
    P(K-1) =  DEN * (6. * (DYDXR - DYDXL) - DXL * P(K-2))
    Q(K-1) = -DEN * DXR
!
    K = K + 1
!
    IF (K < NOLD) GOTO 100
!
700 K = NOLDM1
!
200 Y2(K) = P(K-1) + Q(K-1) * Y2(K+1)
!
    K = K - 1
!
    IF (K > 1) GOTO 200
!
    K1 = 1
!
300 XK = XNEW(K1)
!
    DO 400 K2=2,NOLD
        IF (XOLD(K2) <= XK) GOTO 400
        KOLD = K2 - 1
        GOTO 450
400 END DO
!
    YNEW(K1) = YOLD(NOLD)
!
    GOTO 600
!
450 IF (K1 == 1)   GOTO 500
!
    IF (K == KOLD) GOTO 550
!
500 K = KOLD
!
    Y2K   = Y2(K  )
    Y2KP1 = Y2(K+1)
!
    DX    = XOLD(K+1) - XOLD(K)
    RDX   = 1. / DX
!
    AK = .1666667 * RDX * (Y2KP1 - Y2K)
    BK = .5 * Y2K
    CK = RDX * (YOLD(K+1) - YOLD(K)) - .1666667 * DX * (Y2KP1 + Y2K + Y2K)
!
550 X   = XK - XOLD(K)
    XSQ = X * X
!
    YNEW(K1) = AK * XSQ * X + BK * XSQ + CK * X + YOLD(K)
!
600 K1 = K1 + 1
!
    IF (K1 <= NNEW) GOTO 300
!
    RETURN
!
    END SUBROUTINE SPLINEF

    MODULE M_PRINTVEG
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE M_PRINTVEG
!>
!> SUBROUTINE: M_PRINTVEG - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> MODULE RESPONSIBLE FOR THE WRITING OF MATRICES IN FILES IN AN ENVIRONMENT WITH SUPPORT TO MPI. 
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????    - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!> 
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : ----- 
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    PRIVATE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & MPI_MYRANK
!
    PUBLIC INICIA, WRITEFILE2D
!
    CONTAINS
!
!
!
    SUBROUTINE INICIA(MRANK)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE INICIA
!>
!> SUBROUTINE: INICIA - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????    - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> MRANK - 
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!> 
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : -----
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & MRANK
!
    MPI_MYRANK = MRANK
!
    END SUBROUTINE INICIA
!
!
!
    SUBROUTINE WRITEFILE2D(FILE, MATRIX, DIM1, DIM2)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE WRITEFILE2D
!>
!> SUBROUTINE: WRITEFILE2D - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????    - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> FILE   - 
!> MATRIX - 
!> DIM1   -
!> DIM2   -
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!> 
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : -----
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    CHARACTER(*)                                                          , INTENT(IN)          ::&
    & FILE
!
    REAL   (KIND=R4KIND), DIMENSION(:,:)                                  , INTENT(IN)          ::&
    & MATRIX
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NTSD
!
    REAL   (KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & DIM1    , DIM2
!
    CHARACTER(LEN=1000)                                                                         ::&
    & FINALFILE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J           
!
    WRITE(FINALFILE, "(A,I6.6, I4.4, A)") TRIM(FILE), NTSD, MPI_MYRANK, ".OUT"
!
    OPEN(UNIT=1000+MPI_MYRANK, FILE=FINALFILE, STATUS='REPLACE')
!
    WRITE(UNIT=1000+MPI_MYRANK, FMT='(A, I2, A)') "PROCESSADOR ", MPI_MYRANK, ":"
!
    DO J=1,DIM2
       WRITE(UNIT=1000+MPI_MYRANK, FMT='(800(F10.5))') (MATRIX(I,J), I=1,DIM1)
    END DO
!
    CLOSE(UNIT=1000+MPI_MYRANK)
!
    END SUBROUTINE WRITEFILE2D
!
!
!
    END MODULE M_PRINTVEG

    MODULE LOOPS
!>--------------------------------------------------------------------------------------------------
!> MODULE LOOPS
!>
!> USE MODULES: F77KINDS
!>              PARAMETER
!>
!> DRIVER     : CHKOUT
!>              CUCNVC
!>              DIVHOA
!>              DIVHOAST
!>              EPS
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HADZ
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              RADTN
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              SURFCE
!>              TURBL
!>              VADZ
!>              WRTRST
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : JM, IDIM1, IDIM2, JDIM1, JDIM2
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND), PARAMETER :: JAM = 6 + 2 * (JM - 10)

    INTEGER(KIND=I4KIND), DIMENSION(JAM)                                                        ::&
    & IHLA    , IHHA    ,                                                                         &
    & IVLA    , IVHA    ,                                                                         &
    & JRA
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & LMH     , LMV
!
    END MODULE LOOPS

    SUBROUTINE MPPINIT
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE MPPINIT
!>
!> SUBROUTINE: MPPINIT - ?????
!> PROGRAMMER: BLACK
!> ORG: W/NP22
!> DATE: 98-10-28
!>
!> ABSTRACT:
!> MPPINIT DETERMINES ALL RELEVANT VALUES FOR DIMENSIONS OF THE DISTRIBUTED SUBDOMAINS AND THEIR
!> HALOES.
!>
!> PROGRAM HISTORY LOG:
!> 97-??-??  MEYS     - ORIGINATOR
!> 97-??-??  BLACK    - CHANGES MADE FOR CLARITY
!> 98-10-29  BLACK    - REWRITTEN FOR CLARITY
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : EBU
!>
!> CALLS      : INDTABLE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM 
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IICHUNK           , IPE               , JNCHUNKS          ,  NCHUNKS   ,                    &
    & ICHUNK            , JCHUNK            ,                                                     &
    & MY_IE_CALC        , MY_JE_CALC        ,                                                     &
    & MY_IS_CALC        , MY_JS_CALC        ,                                                     &
    & I                 , J                 ,                                                     &
    & ICHUNK_CALC       , JCHUNK_CALC       ,                                                     &
    & IS_INC1_BND       , IS_INC2_BND       ,                                                     &
    & IE_INC1_BND       , IE_INC2_BND       ,                                                     &
    & JS_INC1_BND       , JS_INC2_BND       , JS_INC3_BND       , JS_INC4_BND       ,             &
    & JS_INC5_BND       ,                                                                         &
    & JE_INC1_BND       , JE_INC2_BND       , JE_INC3_BND       , JE_INC4_BND       ,             &
    & JE_INC5_BND       ,                                                                         &
    & ILOC              , JLOC              ,                                                     &
    & MYI               , MYJ               ,                                                     &
    & MYJS1_P5          , MYJS2_P5          ,                                                     &
    & MYJE1_P5          , MYJE2_P5          ,                                                     &
    & MYJE3_P1          , MYJS3_P1          ,                                                     &
    & MYJE3_P5          , MYJE4_P5
!--------------------------------------------------------------------------------------------------  
! INPES AND JNPES ARE THE NUMBER OF PEs REQUESTED IN X AND Y.
! ICHUNK AND JCHUNK ARE THE FIRST GUESS OF THE NUMBER OF I's AND J's IN EACH SUBDOMAIN OBTAINED BY
! SIMPLY DIVIDING THE GLOBAL DIMENSIONS BY THE NUMBER OF PEs REQUESTED IN EACH DIRECTION.
!-------------------------------------------------------------------------------------------------- 
    ICHUNK  = IM / INPES
    JCHUNK  = JM / JNPES
    IICHUNK = ICHUNK + 1
!-------------------------------------------------------------------------------------------------- 
! COMPUTE THE GLOBAL START AND END INDEX VALUES FOR I (MY_IS_GLB,MY_IE_GLB) AND 
! J (MY_JS_GLB,MY_JE_GLB) ON EACH PE.
! IN GENERAL, THE NUMBER OF POINTS IN EACH DIRECTION WILL NOT DIVIDE EVENLY WITH INPES AND JNPES. 
! THE LOGIC BELOW GIVES ONE EXTRA POINT TO AS MANY OF THE EARLIEST PEs IN EACH DIRECTION AS IT 
! TAKES TO USE UP THE REMAINDER POINTS (ITAIL AND JTAIL, WHICH ARE COMPUTED IN PARMETA).
!-------------------------------------------------------------------------------------------------- 
    IPE = 0
    MY_JS_CALC = 1
    JNCHUNKS = 0
!
    DO J=1,JNPES
        JCHUNK_CALC = JCHUNK
!
        IF (J <= JTAIL) JCHUNK_CALC = JCHUNK + 1
        JNCHUNKS   = JNCHUNKS + JCHUNK_CALC
        MY_JE_CALC = JNCHUNKS
        MY_IS_CALC = 1
        NCHUNKS    = 0
!    
        DO I=1,INPES
            ICHUNK_CALC = ICHUNK
!
            IF (I <= ITAIL) ICHUNK_CALC = ICHUNK + 1
            NCHUNKS    = NCHUNKS + ICHUNK_CALC
            MY_IE_CALC = NCHUNKS
!
            IF (MYPE == IPE) THEN
                MY_IS_GLB = MY_IS_CALC
                MY_IE_GLB = MY_IE_CALC
                MY_JS_GLB = MY_JS_CALC
                MY_JE_GLB = MY_JE_CALC
            END IF
!
            MY_IS_CALC = MY_IE_CALC + 1
           IPE = IPE + 1
 !
        END DO
!    
        MY_JS_CALC = MY_JE_CALC + 1
!
    END DO
!------------------------------------------------------------------------------------------
! ILPADx IS THE INCREMENT INTO THE LEFT HALO OF A SUBDOMAIN.
! IRPADx IS THE INCREMENT INTO THE RIGHT HALO OF A SUBDOMAIN.
! ILPADx IS ALWAYS 0 FOR SUBDOMAINS ALONG THE WEST GLOBAL BOUNDARY.
! IRPADx IS ALWAYS 0 FOR SUBDOMAINS ALONG THE EAST GLOBAL BOUNDARY.
!
! ILCOL IS A FLAG TELLING WHETHER OR NOT A SUBDOMAIN IS ON THE WEST (LEFT) GLOBAL BOUNDARY.
!
! IS_INCx_BND AND IE_INCx_BND ARE INCREMENTS FROM THE LOCAL STARTING OR ENDING 
! I VALUE AWAY FROM THE LOCAL BOUNDARY INTO THE SURBDOMAIN.
! THEY ARE NONZERO ONLY FOR SUBDOMAINS ON THE WESTERN AND EASTERN GLOBAL BOUNDARIES.
!------------------------------------------------------------------------------------------
    ILPAD1 = 1
    ILPAD2 = 2
    ILPAD3 = 3
    ILPAD4 = 4
    ILPAD5 = 5
!
    IRPAD1 = 1
    IRPAD2 = 2
    IRPAD3 = 3
    IRPAD4 = 4
    IRPAD5 = 5
!
    ILCOL  = 0
    IRCOL  = 0
!
    IS_INC1_BND = 0
    IS_INC2_BND = 0
    IE_INC1_BND = 0
    IE_INC2_BND = 0
!-----------------------  
! WESTERNMOST SUBDOMAINS
!-----------------------  
    IF (MOD(MYPE,INPES) == 0) THEN             
        ILPAD1 = 0
        ILPAD2 = 0
        ILPAD3 = 0
        ILPAD4 = 0
        ILPAD5 = 0
        ILCOL  = 1
        IS_INC1_BND = 1
        IS_INC2_BND = 2
    END IF
!-----------------------
! EASTERNMOST SUBDOMAINS
!-----------------------
    IF (MOD(MYPE,INPES) == INPES-1) THEN       
        IRPAD1 = 0
        IRPAD2 = 0
        IRPAD3 = 0
        IRPAD4 = 0
        IRPAD5 = 0
        IRCOL  = 1
        IE_INC1_BND = 1
        IE_INC2_BND = 2
        MY_IE_GLB   = IM
    END IF
!------------------------------------ 
! NOW DO THE SAME FOR THE J DIRECTION
!------------------------------------ 
    JBPAD1 = 1
    JBPAD2 = 2
    JBPAD3 = 3
    JBPAD4 = 4
    JBPAD5 = 5
!
    JTPAD1 = 1
    JTPAD2 = 2
    JTPAD3 = 3
    JTPAD4 = 4
    JTPAD5 = 5
!
    IBROW  = 0
    ITROW  = 0
!
    JS_INC1_BND = 0
    JS_INC2_BND = 0
    JS_INC3_BND = 0
    JS_INC4_BND = 0
    JS_INC5_BND = 0
!
    JE_INC1_BND = 0
    JE_INC2_BND = 0
    JE_INC3_BND = 0
    JE_INC4_BND = 0
    JE_INC5_BND = 0
!------------------------  
! SOUTHERNMOST SUBDOMAINS
!------------------------ 
    IF (MYPE/INPES == 0) THEN              
        JBPAD1 = 0
        JBPAD2 = 0
        JBPAD3 = 0
        JBPAD4 = 0
        JBPAD5 = 0
        IBROW  = 1
!
        JS_INC1_BND = 1
        JS_INC2_BND = 2
        JS_INC3_BND = 3
        JS_INC4_BND = 4
        JS_INC5_BND = 5
    END IF
!------------------------  
! NORTHERNMOST SUBDOMAINS
!------------------------ 
    IF (MYPE/INPES == JNPES-1) THEN        
        JTPAD1 = 0
        JTPAD2 = 0
        JTPAD3 = 0
        JTPAD4 = 0
        JTPAD5 = 0
        ITROW  = 1
!
        JE_INC1_BND = 1
        JE_INC2_BND = 2
        JE_INC3_BND = 3
        JE_INC4_BND = 4
        JE_INC5_BND = 5
        MY_JE_GLB   = JM
    END IF
!---------------------------------------------------------------- 
! THE FOLLOWING ARE THE LOCAL LIMITS OF I AND J IN EACH SUBDOMAIN
!---------------------------------------------------------------- 
    MY_IS_LOC = 1
    MY_IE_LOC = MY_IE_GLB - MY_IS_GLB + 1
    MY_JS_LOC = 1
    MY_JE_LOC = MY_JE_GLB - MY_JS_GLB + 1
!-------------------------------------------------------------------------------------------------- 
! EACH PE WILL NOW FILL ITS OWN SECTIONS OF THE GLOBAL-TO-LOCAL TRANSLATION ARRAYS 
! (DIMENSIONED GLOBALLY) AND LOCAL-TO-GLOBAL TRANSLATION ARRAYS (DIMENSIONED LOCALLY)
!-------------------------------------------------------------------------------------------------- 
    ILOC = 0
!
    DO I=MY_IS_GLB-1,MY_IE_GLB+1
        G2LI(I)    = ILOC
        L2GI(ILOC) = I
        ILOC       = ILOC + 1
    END DO
!
    JLOC = 0
!
    DO J=MY_JS_GLB-1,MY_JE_GLB+1
        G2LJ(J)    = JLOC
        L2GJ(JLOC) = J
        JLOC       = JLOC + 1
    END DO
!-------------------------------------------------------------------------------------------------- 
! EACH PE WILL NOW FILL THE ARRAY CALLED MY_NEB WHICH HOLDS THE NUMBER OF THE 8 PEs THAT ARE ITS 
! NEIGHBORS: 
! NORTH(1), EAST(2), SOUTH(3), WEST(4), NORTHEAST(5), SOUTHEAST(6), SOUTHWEST(7), AND NORTHWEST(8).
! THE VALUE IN THE ARRAY WILL BE -1 FOR THOSE NEIGHBORS THAT DO NOT EXIST BECAUSE THEY ARE BEYOND 
! THE GLOBAL DOMAIN BOUNDARY.
!-------------------------------------------------------------------------------------------------- 
    IPE = 0
!
    DO J=1,JNPES
        DO I=1,INPES
            ITEMP(I,J) = IPE
            IF (IPE == MYPE) THEN
                MYI = I
                MYJ = J
            END IF
            IPE = IPE + 1
        END DO
    END DO
!
    MY_N = -1
    IF (MYJ+1 <= JNPES)                                MY_N=ITEMP(MYI  , MYJ+1)
!
    MY_E = -1
    IF (MYI+1 <= INPES)                                MY_E=ITEMP(MYI+1, MYJ  )
!
    MY_S = -1
    IF (MYJ-1 >= 1)                                    MY_S=ITEMP(MYI  , MYJ-1)
!
    MY_W = -1
    IF (MYI-1 >= 1)                                    MY_W=ITEMP(MYI-1, MYJ  )
!
    MY_NE = -1
    IF ((MYI+1 <= INPES) .AND. (MYJ+1 <= JNPES))      MY_NE=ITEMP(MYI+1, MYJ+1)
!
    MY_SE = -1
    IF ((MYI+1 <= INPES) .AND. (MYJ-1 >= 1))          MY_SE=ITEMP(MYI+1, MYJ-1)
!
    MY_SW = -1
    IF ((MYI-1 >= 1) .AND. (MYJ-1 >= 1))              MY_SW=ITEMP(MYI-1, MYJ-1)
!
    MY_NW = -1
    IF ((MYI-1 >= 1) .AND. (MYJ+1 <= JNPES))          MY_NW=ITEMP(MYI-1, MYJ+1)
!
    MY_NEB(1) = MY_N
    MY_NEB(2) = MY_E
    MY_NEB(3) = MY_S
    MY_NEB(4) = MY_W
    MY_NEB(5) = MY_NE
    MY_NEB(6) = MY_SE
    MY_NEB(7) = MY_SW
    MY_NEB(8) = MY_NW
!-------------------------------------------------------------------------------------------------- 
! GENERATE THE TABLES (DIMENSIONED INPES*JNPES) THAT HOLD THE STARTING AND ENDING VALUES OF I AND J
! FOR EACH PE IN TERMS OF BOTH THE GLOBAL AND THE LOCAL DOMAINS.
!-------------------------------------------------------------------------------------------------- 
    CALL INDTABLE
!------------------------------------------ 
! CREATE ABBREVIATED NAMES FOR LOOP LIMITS.
!------------------------------------------
    MYIS     = MY_IS_LOC
    MYIS_P1  = MY_IS_LOC               - ILPAD1
    MYIS_P2  = MY_IS_LOC               - ILPAD2
    MYIS_P3  = MY_IS_LOC               - ILPAD3
    MYIS_P4  = MY_IS_LOC               - ILPAD4
    MYIS_P5  = MY_IS_LOC               - ILPAD5
!
    MYIS1    = MY_IS_LOC + IS_INC1_BND
    MYIS1_P1 = MY_IS_LOC + IS_INC1_BND - ILPAD1
    MYIS1_P2 = MY_IS_LOC + IS_INC1_BND - ILPAD2
    MYIS1_P3 = MY_IS_LOC + IS_INC1_BND - ILPAD3
    MYIS1_P4 = MY_IS_LOC + IS_INC1_BND - ILPAD4
!
    MYIS2    = MY_IS_LOC + IS_INC2_BND
!
    MYIE    = MY_IE_LOC
    MYIE_P1 = MY_IE_LOC + IRPAD1
    MYIE_P2 = MY_IE_LOC + IRPAD2
    MYIE_P3 = MY_IE_LOC + IRPAD3
    MYIE_P4 = MY_IE_LOC + IRPAD4
    MYIE_P5 = MY_IE_LOC + IRPAD5
!-------------------------------------------------------------------------------------------------- 
! THE SIZE OF THESE INCREMENTS IS ZERO UNLESS THE SUBDOMAIN LIES ALONG A GLOBAL BOUNDARY IN WHICH 
! CASE THE INCREMENT IS INDICATED BY THE NUMBER FOLLOWING 'INC'
!-------------------------------------------------------------------------------------------------- 
    MYIE1    = MY_IE_LOC - IE_INC1_BND         
    MYIE1_P1 = MY_IE_LOC - IE_INC1_BND + IRPAD1
    MYIE1_P2 = MY_IE_LOC - IE_INC1_BND + IRPAD2
    MYIE1_P3 = MY_IE_LOC - IE_INC1_BND + IRPAD3 
    MYIE1_P4 = MY_IE_LOC - IE_INC1_BND + IRPAD4  
!                                            
    MYIE2    = MY_IE_LOC - IE_INC2_BND
    MYIE2_P1 = MY_IE_LOC - IE_INC2_BND + IRPAD1
!
    MYJS     = MY_JS_LOC
    MYJS_P1  = MY_JS_LOC - JBPAD1
    MYJS_P2  = MY_JS_LOC - JBPAD2
    MYJS_P3  = MY_JS_LOC - JBPAD3
    MYJS_P4  = MY_JS_LOC - JBPAD4
    MYJS_P5  = MY_JS_LOC - JBPAD5
!
    MYJS1    = MY_JS_LOC + JS_INC1_BND
    MYJS1_P1 = MY_JS_LOC + JS_INC1_BND - JBPAD1
    MYJS1_P2 = MY_JS_LOC + JS_INC1_BND - JBPAD2
    MYJS1_P3 = MY_JS_LOC + JS_INC1_BND - JBPAD3
    MYJS1_P4 = MY_JS_LOC + JS_INC1_BND - JBPAD4
    MYJS1_P5 = MY_JS_LOC + JS_INC1_BND - JBPAD5
!
    MYJS2    = MY_JS_LOC + JS_INC2_BND
    MYJS2_P1 = MY_JS_LOC + JS_INC2_BND - JBPAD1
    MYJS2_P2 = MY_JS_LOC + JS_INC2_BND - JBPAD2
    MYJS2_P3 = MY_JS_LOC + JS_INC2_BND - JBPAD3
    MYJS2_P4 = MY_JS_LOC + JS_INC2_BND - JBPAD4
    MYJS2_P5 = MY_JS_LOC + JS_INC2_BND - JBPAD5
!
    MYJS3    = MY_JS_LOC + JS_INC3_BND
    MYJS3_P1 = MY_JS_LOC + JS_INC3_BND - JBPAD1
    MYJS3_P4 = MY_JS_LOC + JS_INC3_BND - JBPAD4
!
    MYJS4    = MY_JS_LOC + JS_INC4_BND
    MYJS4_P1 = MY_JS_LOC + JS_INC4_BND - JBPAD1
    MYJS4_P4 = MY_JS_LOC + JS_INC4_BND - JBPAD4
!
    MYJS5    = MY_JS_LOC + JS_INC5_BND
    MYJS5_P1 = MY_JS_LOC + JS_INC5_BND - JBPAD1
    MYJS5_P2 = MY_JS_LOC + JS_INC5_BND - JBPAD2
!
    MYJE     = MY_JE_LOC
    MYJE_P1  = MY_JE_LOC + JTPAD1
    MYJE_P2  = MY_JE_LOC + JTPAD2
    MYJE_P3  = MY_JE_LOC + JTPAD3
    MYJE_P4  = MY_JE_LOC + JTPAD4
    MYJE_P5  = MY_JE_LOC + JTPAD5
!
    MYJE1    = MY_JE_LOC - JE_INC1_BND
    MYJE1_P1 = MY_JE_LOC - JE_INC1_BND + JTPAD1
    MYJE1_P2 = MY_JE_LOC - JE_INC1_BND + JTPAD2
    MYJE1_P3 = MY_JE_LOC - JE_INC1_BND + JTPAD3
    MYJE1_P4 = MY_JE_LOC - JE_INC1_BND + JTPAD4
    MYJE1_P5 = MY_JE_LOC - JE_INC1_BND + JTPAD5
!
    MYJE2    = MY_JE_LOC - JE_INC2_BND
    MYJE2_P1 = MY_JE_LOC - JE_INC2_BND + JTPAD1
    MYJE2_P2 = MY_JE_LOC - JE_INC2_BND + JTPAD2
    MYJE2_P3 = MY_JE_LOC - JE_INC2_BND + JTPAD3
    MYJE2_P4 = MY_JE_LOC - JE_INC2_BND + JTPAD4
    MYJE2_P5 = MY_JE_LOC - JE_INC2_BND + JTPAD5
!
    MYJE3    = MY_JE_LOC - JE_INC3_BND
    MYJE3_P1 = MY_JE_LOC - JE_INC3_BND + JTPAD1
    MYJE3_P4 = MY_JE_LOC - JE_INC3_BND + JTPAD4
    MYJE3_P5 = MY_JE_LOC - JE_INC3_BND + JTPAD5
!
    MYJE4    = MY_JE_LOC - JE_INC4_BND
    MYJE4_P1 = MY_JE_LOC - JE_INC4_BND + JTPAD1
    MYJE4_P4 = MY_JE_LOC - JE_INC4_BND + JTPAD4
    MYJE4_P5 = MY_JE_LOC - JE_INC4_BND + JTPAD5
!
    MYJE5    = MY_JE_LOC - JE_INC5_BND
    MYJE5_P1 = MY_JE_LOC - JE_INC5_BND + JTPAD1
    MYJE5_P2 = MY_JE_LOC - JE_INC5_BND + JTPAD2
!
    RETURN
!
    END SUBROUTINE MPPINIT
!
!
!
    SUBROUTINE INDTABLE
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE INDTABLE
!>
!> SUBROUTINE: INDTABLE - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> THIS ROUTINE GENERATES THE TABLES THAT WILL GIVE THE STARTING AND ENDING VALUES OF I AND J FOR 
!> EACH PE ON THE GLOBAL AND LOCAL DOMAINS. 
!> EACH PE WILL HAVE A COPY OF THE FULL TABLES. 
!> THE ARGUMENT USED IS SIMPLY THE NUMBER OF THE PE FOR WHICH THESE VALUES ARE DESIRED.
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????    - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : MPPINIT
!>
!> CALLS      : MPI_BARRIER
!>              MPI_BCAST
!>-------------------------------------------------------------------------------------------------- 
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IPE     ,                                                                                   &
    & IRTN    ,                                                                                   &
    & IGLB    , JGLB    ,                                                                         &
    & IRECV
  
!
    IS_LOC_TABLE(MYPE) = MY_IS_LOC
    JS_LOC_TABLE(MYPE) = MY_JS_LOC
    IE_LOC_TABLE(MYPE) = MY_IE_LOC
    JE_LOC_TABLE(MYPE) = MY_JE_LOC
!
    IS_GLB_TABLE(MYPE) = MY_IS_GLB
    IE_GLB_TABLE(MYPE) = MY_IE_GLB
    JS_GLB_TABLE(MYPE) = MY_JS_GLB
    JE_GLB_TABLE(MYPE) = MY_JE_GLB
!
    DO IPE=0,NPES-1
        CALL MPI_BCAST(IS_LOC_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(JS_LOC_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IE_LOC_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(JE_LOC_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
!    
        CALL MPI_BCAST(IS_GLB_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(JS_GLB_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IE_GLB_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(JE_GLB_TABLE(IPE), 1, MPI_INTEGER, IPE, MPI_COMM_COMP, IRTN)
    END DO
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!-------------------------------------------------------------------------------------------------- 
! ALL OF THE PEs CAN NOW GENERATE A COMPLETE TABLE OF THE NUMBER OF GRID POINTS IN THE I DIRECTION 
! THAT ARE ON ALL OTHER PEs.
! THIS WILL BE USED IN THE MESINGER MSLP REDUCTION AS WELL AS IN THE BROADCAST BELOW.
!-------------------------------------------------------------------------------------------------- 
    DO IPE=0,NPES-1
        ICHUNKTAB(IPE) = IE_LOC_TABLE(IPE) - IS_LOC_TABLE(IPE) + 1
    END DO
!-------------------------------------------------------------------------------------------------- 
! SET UP A MAP OF THE GLOBAL DOMAIN THAT GIVES THE PE THAT OWNS EACH POINT. 
! (THIS APPEARS TO BE VESTIGIAL)
!-------------------------------------------------------------------------------------------------- 
!
!------------------------------------------------ 
! FIRST EACH PE FILLS IN ITS SECTION OF THE ARRAY
!------------------------------------------------
    DO JGLB=JS_GLB_TABLE(MYPE),JE_GLB_TABLE(MYPE)
        DO IGLB=IS_GLB_TABLE(MYPE),IE_GLB_TABLE(MYPE)
            ITEMP(IGLB,JGLB) = MYPE
        END DO
    END DO
!----------------------------------------------------------------- 
! NEXT, ALL PEs EXCHANGE THEIR SECTIONS SO EVERYONE HAS A FULL MAP
!----------------------------------------------------------------- 
    DO IPE=0,NPES-1
        DO JGLB=JS_GLB_TABLE(IPE),JE_GLB_TABLE(IPE)
            CALL MPI_BCAST(ITEMP(IS_GLB_TABLE(IPE), JGLB),                                        &
    &                               ICHUNKTAB(IPE), MPI_INTEGER, IPE, MPI_COMM_COMP, IRECV)
        END DO
    END DO
!
    CALL MPI_BARRIER(MPI_COMM_COMP, IRTN)
!
    RETURN
!
    END SUBROUTINE INDTABLE

    MODULE UPDT
!>--------------------------------------------------------------------------------------------------
!> MODULE UPDT
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : READ_NHB
!>              SSTCH
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IM, JM ,IDIM1, IDIM2, JDIM1, JDIM2
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LSST
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & YR      , MON     , DAY     , UTC
!
    CHARACTER(LEN=10)                                                                           ::&
    & CHARDATE
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                                     ::&
    & VARUPDATED
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, 360)                                                ::&
    & SST_UP

    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, 12)                                                 ::&
    & VEGFRM
!
    END MODULE UPDT


MODULE UPDATE_FLDS
PUBLIC FLDS_UPDATE_DRIVER
PUBLIC GETDATE
PUBLIC WEGHT_DAY_DIST
PUBLIC READ_SST
PUBLIC SST_UPDATE
PUBLIC READ_VGREEN
PUBLIC VEGUPDT

CONTAINS

  SUBROUTINE FLDS_UPDATE_DRIVER(SUB_ACT,FLD,CALC_SST,NSST_UP)
    USE F77KINDS
    USE UPDT
    IMPLICIT NONE
    INTEGER(KIND=I4KIND),   INTENT(IN), OPTIONAL                                               ::&
    & CALC_SST
    INTEGER(KIND=I4KIND),   INTENT(IN), OPTIONAL                                               ::&
    & NSST_UP
    CHARACTER(LEN=16)                                                                          ::&
    & SUB_ACT, FLD
 
! NSST_UP=31
 SELECT CASE (TRIM(SUB_ACT))
   CASE ('READ')
     SELECT CASE (FLD)
       CASE ('SST')
         CALL READ_SST(NSST_UP)
       CASE ('VGREEN')
         CALL READ_VGREEN
      END SELECT
   CASE('UPDATE')
     SELECT CASE (TRIM(FLD))
       CASE ('SST')
         CALL SST_UPDATE(CALC_SST)
       CASE ('VGREEN')
         CALL VGREEN_UPDATE  
     END SELECT
  END SELECT  

  END SUBROUTINE FLDS_UPDATE_DRIVER

    SUBROUTINE GETDATE(IYR, IMO, IDY, IUTC, CYR, CMON, CDAY, CUTC)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE GETDATE
!>
!> SUBPROGRAM: GETDATE -
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> 87-08-??  ?????     - ORIGINATOR
!> 18-01-15  LUCCI     - MODERNIZATION OF THE CODE, INCLUDING:
!>                       * F77 TO F90/F95
!>                       * INDENTATION & UNIFORMIZATION CODE
!>                       * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                       * DOCUMENTATION WITH DOXYGEN
!>                       * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>
!>
!> DRIVER     : SOLARD
!>              SSTCH
!>              SSTCH_GREGORIAN_CALENDAR
!>              SSTCH_360_DAY_CALENDAR
!>              VEGUPDT
!>              VEGUPDT_GREGORIAN_CALENDAR
!>              VEGUPDT_360_DAY_CALENDAR
!>              ZENITH
!>              ZENITH_GREGORIAN_CALENDAR
!>              ZENITH_360_DAY_CALENDAR
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & IYR     , IMO     , IDY     , IUTC
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(OUT)         ::&
    & CYR     , CMON    , CDAY    , CUTC
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & YR      , MON     , DAY     , UTC
!
    INTEGER(KIND=I4KIND), DIMENSION(12)                                                         ::&
    & MONL
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & DYSTEP
!
    YR  = IYR
    MON = IMO
    DAY = IDY
    UTC = IUTC
!
    DATA MONL /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
!
    DYSTEP = 0
!
    IF (MOD(YR,4) == 0) THEN
        MONL(2) = 29
    ELSE
        MONL(2) = 28
    END IF
!
    IF (UTC >= 24) THEN
        DYSTEP = DYSTEP + (UTC / 24)
        UTC    = (MOD(UTC, 24))
    END IF
!
    DAY = DAY + DYSTEP
!
    DO
        IF (DAY > MONL(MON)) THEN
            DAY = DAY - MONL(MON)
            MON = MON + 1
!
            IF (MON == 13) THEN
                MON = 1
                YR  = YR + 1
!
                IF (MOD(YR, 4) == 0) THEN
                    MONL(2) = 29
                ELSE
                    MONL(2) = 28
                END IF
!
            END IF
!
        ELSE
!
            EXIT
!
        END IF
!
    END DO
!
    CYR  = YR
    CMON = MON
    CDAY = DAY
    CUTC = UTC
!
      RETURN
!
      END SUBROUTINE GETDATE


  SUBROUTINE WEGHT_DAY_DIST(YDAY,MA,MB,FA,FB)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE WEGHT_DAY_DIST
!>
!> SUBPROGRAM: WEGHT_DAY_DIST - ?????
!> PROGRAMMER: ?????
!> ORG:?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> 93-10-28  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NTSD  -
!> DT    -
!>
!> OUTPUT ARGUMENT LIST:
!> FA    -
!> FB    -
!> MA    -
!> MB    -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>
!> DRIVER     : 
!>
!> CALLS      : GETDATE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE CTLBLK, ONLY: DT,IDAT,NTSD
    USE MPPCOM
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & DAY     , MON     , YR      , UTC     , MA      , MB
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IYR     , IMO     , IDY    , IUTC   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & YDAY    , ADD     , FA      , FB
!
    INTEGER(KIND=I4KIND), DIMENSION(12)                                                         ::&
    & MONL
!
    IYR  = IDAT(3)
    IMO  = IDAT(1)
    IDY  = IDAT(2)
!-----------------
! CHOU DT EH 90SEG
!-----------------
    IUTC = NTSD * DT / 3600
!
    CALL GETDATE(IYR, IMO, IDY, IUTC, YR, MON, DAY, UTC)
!
    DATA MONL /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
!
    IF (MOD(YR,4) == 0) THEN
        MONL(2) = 29
    END IF

    YDAY = DAY
    MA   = MON - 1
!
    IF (MYPE == 0) PRINT*,"IN WEGHT_DAY_DIST",YDAY,1+INT(MONL(MON)/2.0)
    IF ((YDAY >= (1.0+INT(MONL(MON)/2.0))) .OR. ((NTSD == 1) .AND. (YDAY > 15))) MA = MON
    MB = MA + 1
    IF (MYPE == 0) PRINT*,"IN WEGHT_DAY_DIST",MA,MB
!
    IF (MA <  1) MA = 12
    IF (MB > 12) MB =  1
!
    ADD = FLOAT(MONL(MA)) / 2.0 - 1.0
!
    IF (MA == MON) ADD = -ADD - 2.0
!
    FB = 2.0 * (YDAY + ADD) / FLOAT(MONL(MA) + MONL(MB))
    FA = 1.0 - FB
!
!
!
    RETURN
!
    END SUBROUTINE  WEGHT_DAY_DIST

  SUBROUTINE SST_UPDATE(CALC_SST)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SSTSTP
!>
!> SUBPROGRAM: SSTSTP - ?????
!> PROGRAMMER: ?????
!> ORG:?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> 93-10-28  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> CALC_SSTUP (UNIT: DAY)
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>              PARMETA
!>              PHYS
!>              UPDT
!>
!> DRIVER     : EBU
!>
!>--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE F77KINDS
    USE MPPCOM
    USE PARMETA , ONLY : IM, JM
    USE PHYS, ONLY: SST
    USE UPDT, ONLY: SST_UP
!
   INCLUDE "mpif.h"
!

    INTEGER(KIND=I4KIND)                                                                  :: NREC_SST_UP
    INTEGER(KIND=I4KIND),   INTENT(IN)                                                    :: CALC_SST
!
    NREC_SST_UP=(NTSD/CALC_SST)
    IF (MYPE == 0) write(0,*)"SUM SST BEFORE",sum(SST)
    IF (MYPE == 0) write(0,*)"SST UPDATE",NTSD,CALC_SST,NREC_SST_UP
    SST(:,:) =  SST_UP(:,:,NREC_SST_UP)
    IF (MYPE == 0) write(0,*)"SUM SST AFTER",sum(SST)
!
    RETURN
!
    END SUBROUTINE SST_UPDATE
!
!
!
    SUBROUTINE READ_SST(NSST_UP)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_SST
!>
!> SUBROUTINE: READ_SST- ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: 
!>              CTLBLK
!>              F77KINDS
!>              MPPCOM
!>              PHYS
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : -----
!--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA , ONLY : IM, JM
    USE UPDT, ONLY: SST_UP
    USE TEMPCOM, ONLY: TEMP1 
!
    INCLUDE "mpif.h"
!
!------------------
! DECLARE VARIABLES
!-------------------
!
!
    INTEGER(KIND=I4KIND)    , INTENT(IN)                                                       ::&
    & NSST_UP 
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ISST_UP , N

!    NSST_UP = 19
    ISST_UP = 90

!-------------------------------------------------
! ADAPTADO PARA A LEITURA DO ARQUIVO DE SST DIARIA
!-------------------------------------------------
!    OPEN(ISST_UP, FORM='UNFORMATTED', ACCESS='SEQUENTIAL')
!---------------
! DISTRIBUTE SST_UP
!---------------
    DO N=1,NSST_UP
      IF (MYPE == 0) THEN
        write(6,*)N,NSST_UP
        READ(ISST_UP) TEMP1
      END IF
      CALL DSTRB(TEMP1, SST_UP, 1, 1, N)
    END DO
!
!------------------------------
! END OF SUBROUTINE READ_SST
!------------------------------
    RETURN
!
    END SUBROUTINE READ_SST
!
!

!
!
    SUBROUTINE READ_VGREEN
    USE CTLBLK
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA , ONLY : IM, JM
    USE UPDT, ONLY: VEGFRM
    USE TEMPCOM, ONLY: TEMP1 
    IMPLICIT NONE
    INTEGER(KIND=I8KIND)                                                                        ::&
    & N
    INCLUDE "mpif.h"
!------------------------------------------
! GSM XC
! CHOU 02-02-2008 READ MONTHLY VEG GREENESS
!------------------------------------------
    OPEN(UNIT=9, FILE='VGREEN_12MO.dat', FORM='UNFORMATTED')
!
    DO N=1,12
        IF (MYPE == 0) THEN
            READ(9) TEMP1
        END IF
!
        CALL DSTRB(TEMP1, VEGFRM, 1, 12, N)
!
    END DO
!GSM XC
    END SUBROUTINE READ_VGREEN
    SUBROUTINE VGREEN_UPDATE
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VEGUPDT
!>
!> SUBPROGRAM: VEGUPDT - ?????
!> PROGRAMMER: ?????
!> ORG:?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> 93-10-28  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> SSTUPSTEP -
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>              LOOPS
!>              MASKS
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              SOIL
!>
!> DRIVER     : EBU
!>
!> CALLS      : GETDATE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE CTLBLK, ONLY: DT,NTSD
    USE MPPCOM
    USE PARMETA , ONLY : IM, JM
    USE SOIL, ONLY: VEGFRC
    USE UPDT, ONLY: VEGFRM  
    INTEGER(KIND=I4KIND)                                                                        ::&
    & MA      , MB
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & YDAY    , FA      , FB
!
    CALL WEGHT_DAY_DIST(YDAY,MA,MB,FA,FB)

    IF (MYPE == 0) PRINT*,"VEGFRM", NTSD, MA, MB, FA, FB
!
    IF ((NTSD == 1) .AND. (INT(YDAY) == 15)) THEN
        VEGFRC(:,:) = VEGFRM(:,:,MA)
    ELSE
        VEGFRC(:,:) = FA * VEGFRM(:,:,MA) + FB * VEGFRM(:,:,MB)
    END IF
!
    RETURN
!
    END SUBROUTINE VGREEN_UPDATE


END MODULE UPDATE_FLDS

    SUBROUTINE READ_RESTRT2
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_RESTRT2
!>
!> SUBPROGRAM:READ_RESTRT2 - READ MULTIPLE SMALL RESTRT FILES
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 99-09-01
!>
!> ABSTRACT:
!> READ_RESTRT2 READS IN QUANTITIES FROM THE SMALL RESTRT FILES WHICH WERE PREVIOUSLY WRITTEN BY
!> INDIVIDUAL NODES
!>
!> PROGRAM HISTORY LOG:
!> 99-09-01  BLACK      - REWRITTEN ROM READ_RESTRT
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLD
!>              ACMCLH 
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              OUTFIL
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PRFHLD
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : GETENV
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE OUTFIL
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PRFHLD 
    USE PVRBLS
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JMP1 = JM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMT  =  2 * IM - 1
!------------------  
! DECLARE VARIABLES
!------------------  
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUNB
!
    CHARACTER(LEN=4)                                                                            ::&
    & RESTHR
!
    CHARACTER(LEN=32)                                                                           ::&
    & LABEL
    CHARACTER(40)                                                                               ::&
    & CONTRL  , FILALL  , FILMST  , FILTMP  , FILTKE  , FILUNV  , FILCLD  , FILRAD  , FILSFC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PSLP
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM, NSOIL)                                              ::&
    & TEMPSOIL
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDATB     
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
#ifdef DP_REAL
!
    LOGICAL(KIND=L8KIND)                                                                        ::&
    & RUNX    , FIRSTX
!
    INTEGER(KIND=I8KIND), DIMENSION(3)                                                          ::&
    & IDATX
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & IHRSTX  , NTSDX   , IOUTX   , NSHDEX
!
    INTEGER(KIND=I8KIND), DIMENSION(IM, JM)                                                     ::&
    & ITEMPX  , ITEMP2X
!
#endif
!
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , N       , IER   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART  , PDOMG   , RESOMG
!--------------------------------------------
! READ INITIAL CONDITIONS FROM RESTART FILES.
!--------------------------------------------
    IF (MYPE == 0) WRITE(LIST,*) 'INIT:  READ RESTART FILES'
!----------------------------- 
! CREATE NAME FOR RESTART FILE
!-----------------------------  
    TSTART = NINT(NSTART * DT / 3600.)
!-------------------- 
! NO LONGER HARDWIRED
!-------------------- 
    IF (NSTART == 0) THEN
        ITAG = 3
    ELSE
        ITAG = TSTART
    END IF
!
    IF (MYPE == 0) WRITE(6,*)'ITAG IN READ_RESTRT2 ', ITAG, TSTART, DT, NSTART, NTSD
!-------------------- 
! NO LONGER HARDWIRED
!-------------------- 
    CALL GETENV("TMMARKB", RESTHR)
!
    IF (RESTHR == '    ') THEN
        WRITE(RSTFIL,50) ITAG,MYPE
        50 FORMAT('RESTRT',I2.2,'.',I3.3)
    ELSE
        WRITE(RSTFIL,55)ITAG,MYPE,RESTHR
        55 FORMAT('RESTRT',I2.2,'.',I3.3,'.',A4)
    END IF
!---------------------------
! OPEN UNIT TO RESTART FILE.
!---------------------------
    LRSTRT = 8
!
    CLOSE(LRSTRT)
    OPEN (UNIT=LRSTRT, FILE=RSTFIL, FORM='UNFORMATTED', IOSTAT=IER)
    IF (IER /= 0) WRITE(LIST,*) ' LRSTRT OPEN UNIT ERROR IER=', IER
!
#ifdef DP_REAL
!
    READ(LRSTRT) RUNX, IDATX, IHRSTX, NTSDX, LABEL
    RUN   = RUNX
    IDAT  = IDATX
    IHRST = IHRSTX
    NTSD  = NTSDX
!
#else
!
    READ(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL
!
#endif
!
    NTSD = MAX(NTSD-1,0)
    READ(LRSTRT) PDOMG, RESOMG
!
    DO K=1,LM
        READ(LRSTRT) ((OMGALF(I,J,K),I=MYIS,MYIE),J=MYJS,MYJE)
    END DO
!
#ifdef DP_REAL
!
    READ(LRSTRT) RUNX, IDATX, IHRSTX, NTSDX, LABEL, FIRSTX, IOUTX, NSHDEX
    RUN   = RUNX
    IDAT  = IDATX
    IHRST = IHRSTX
    NTSD  = NTSDX
    FIRST = FIRSTX
    IOUT  = IOUTX
    NSHDE = NSHDEX
!
#else
!
    READ(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL, FIRST, IOUT, NSHDE
!
#endif
!
    NTSD  = MAX(NTSD-1,0)
    FIRST = .TRUE. 
!
    READ(LRSTRT) ((PD(I,J),I=MYIS,MYIE),J=MYJS,MYJE), ((RES(I,J),I=MYIS,MYIE),J=MYJS,MYJE),       &
    &           ((FIS(I,J),I=MYIS,MYIE),J=MYJS,MYJE)
!
    READ(LRSTRT)
!---------------------- 
! PRIMARY 3-D VARIABLES
!---------------------- 
    DO K=1,LM
        READ(LRSTRT) ((T    (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((Q    (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((U    (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((V    (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((Q2   (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT)
        READ(LRSTRT) ((CWM  (I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((TRAIN(I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT) ((TCUCN(I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
    END DO
!
#ifdef DP_REAL
!
    READ(LRSTRT) RUNX, IDATX, IHRSTX, NTSDX, LABEL,                                               &
    &            ((RSWIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((RSWOUT(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((TG    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((Z0    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((AKMS  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CZEN  (I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    RUN   = RUNX
    IDAT  = IDATX
    IHRST = IHRSTX
    NTSD  = NTSDX
!
#else
!
    READ(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL,                                                   &
    &            ((RSWIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((RSWOUT(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((TG    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((Z0    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((AKMS  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CZEN  (I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
#endif
!
    NTSD = MAX(NTSD-1,0)
!
    READ(LRSTRT) ((AKHS  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((THS   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((QS    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((TWBS  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((QWBS  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((HBOT  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CFRACL(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((THZ0  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((QZ0   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((UZ0   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((VZ0   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((USTAR (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((HTOP  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CFRACM(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((SNO   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SI    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CLDEFI(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((RF    (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((PSLP  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CUPPT (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CFRACH(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((SOILTB(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SFCEXC(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SMSTAV(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SMSTOT(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((GRNFLX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((PCTSNO(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((RLWIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
                 ((RADOT (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
                 ((CZMEAN(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
                 ((SIGT4 (I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!----------------------------------------------------------------
! ((U00(I,J),I=MYIS,MYIE),J=MYJS,MYJE) NOT USED IN NEW G/S SCHEME
! UL                                   NOT USED IN NEW G/S SCHEME
! ((LC(I,J),I=MYIS,MYIE),J=MYJS,MYJE)  NOT USED IN NEW G/S SCHEME 
!----------------------------------------------------------------
    READ(LRSTRT) ((U00(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                          &
    &            UL,                                                                              & 
    &            ((LC (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                          &
    &            ((SR (I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
#ifdef DP_REAL
!
    READ(LRSTRT) RUNX, IDATX, IHRSTX, NTSDX, LABEL,                                               & 
    &            ((PREC  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACPREC(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACCLIQ(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CUPREC(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    RUN   = RUNX
    IDAT  = IDATX
    IHRST = IHRSTX
    NTSD  = NTSDX
!
#else
!
    READ(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL,                                                   &
    &            ((PREC  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACPREC(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACCLIQ(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((CUPREC(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
#endif
!
    NTSD = MAX(NTSD-1,0)
!
    READ(LRSTRT) ((ACFRCV(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((NCFRCV(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACFRST(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((NCFRST(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((ACSNOW(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ACSNOM(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SSROFF(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((BGROFF(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((SFCSHX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SFCLHX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SUBSHX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SNOPCX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SFCUVX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((SFCEVP(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((POTEVP(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ((ASWIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ASWOUT(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ASWTOA(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ALWIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ALWOUT(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((ALWTOA(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) ARDSW, ARDLW, ASRFC, AVRAIN, AVCNVC
!
    READ(LRSTRT) ((TH10  (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((Q10   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((U10   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((V10   (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((TSHLTR(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((QSHLTR(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
    &            ((PSHLTR(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                       &
!--------- 
! SM v100M
!--------- 
    &            ((TH100(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                        &
    &            ((Q100 (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                        &
    &            ((U100 (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                        &
    &            ((V100 (I,J), I=MYIS,MYIE), J=MYJS,MYJE)
!
    READ(LRSTRT) (((SMC  (I,J,N), I=MYIS,MYIE), J=MYJS,MYJE), N=1,NSOIL)
    READ(LRSTRT) ((CMC   (I,J)  , I=MYIS,MYIE), J=MYJS,MYJE)
    READ(LRSTRT) (((STC  (I,J,N), I=MYIS,MYIE), J=MYJS,MYJE), N=1,NSOIL)
    READ(LRSTRT) (((SH2O (I,J,N), I=MYIS,MYIE), J=MYJS,MYJE), N=1,NSOIL)
    READ(LRSTRT) ((ALBEDO(I,J)  , I=MYIS,MYIE), J=MYJS,MYJE)
!--------------------------------------------------------------------------------
! IF FORECAST IS NOT BEGINNING AT TIME 0 THEN WE MUST READ ADDITIONAL INFORMATION
!--------------------------------------------------------------------------------
    IF (NINT(TSTART) /= 0) THEN
        READ(LRSTRT) ((POTFLX(I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                   &
    &                ((TLMIN (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                   &
    &                ((TLMAX (I,J), I=MYIS,MYIE), J=MYJS,MYJE),                                   &
    &                ACUTIM, ARATIM, APHTIM
!    
        DO K=1,LM
            READ(LRSTRT)((RSWTT(I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
            READ(LRSTRT)((RLWTT(I,J,K), I=MYIS,MYIE), J=MYJS,MYJE)
        END DO
!
        READ(LRSTRT)((CNVBOT(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT)((CNVTOP(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT)((RSWTOA(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
        READ(LRSTRT)((RLWTOA(I,J), I=MYIS,MYIE), J=MYJS,MYJE)
    END IF
!-----------------------------------------------------------------------
! CALL RADIATION TO OBTAIN THE SHORT AND LONGWAVE TEMPERATURE TENDENCIES
!
! CALL RADTN
!
! DONE READING RESTART FILES.
!
! END OF SUBROUTINE READ_RESTRT2
!-----------------------------------------------------------------------
    IF (MYPE == 0) THEN
        WRITE(LIST,*) 'INIT:  EXIT READ_RESTRT2'
        WRITE(LIST,*) ' '
    END IF
!
    RETURN
!
    END SUBROUTINE READ_RESTRT2

    SUBROUTINE HZADV2
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE HZADV2
!>
!> SUBPROGRAM: HZADV2 - HORIZONTAL ADVECTION OF VAPOR AND CLOUD
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 96-07-19
!>
!> ABSTRACT:
!> HZADV2 CALCULATES THE CONTRIBUTION OF THE HORIZONTAL ADVECTION TO THE TENDENCIES OF SPECIFIC 
!> HUMIDITY AND CLOUD WATER AND THEN UPDATES THOSE VARIABLES.  AN ANTI-FILTERING TECHNIQUE IS USED.
!>
!> PROGRAM HISTORY LOG:
!> 96-07-19  JANJIC   - ORIGINATOR
!> 98-11-02  BLACK    - MODIFIED FOR DISTRIBUTED MEMORY
!> 99-03-17  TUCCILLO - INCORPORATED MPI_ALLREDUCE FOR GLOBAL SUM
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              VRBLS
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : MPI_ALLREDUCE                
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE VRBLS
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =  2.E-12
    REAL   (KIND=R4KIND), PARAMETER :: CLIMIT =  1.E-20
    REAL   (KIND=R4KIND), PARAMETER :: FF1    =  0.52500
    REAL   (KIND=R4KIND), PARAMETER :: FF2    = -0.64813
    REAL   (KIND=R4KIND), PARAMETER :: FF3    =  0.24520
    REAL   (KIND=R4KIND), PARAMETER :: FF4    = -0.12189
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IM1    = IM - 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM   = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JAMD   = (JAM * 2 - 10) * 3
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & IFPA    , IFQA    ,                                                                         &
    & IFPF    , IFQF    ,                                                                         &
    & JFPA    , JFQA    ,                                                                         &
    & JFPF    , JFQF
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & AFP     , AFQ     ,                                                                         &
    & Q1      , DQST    ,                                                                         &
    & W1      , DWST    ,                                                                         &
    & DVOL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DARE    , EMH 
!
    REAL   (KIND=R4KIND), DIMENSION(4,LM)                                                       ::&
    & GSUMS   , XSUMS
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , JFP     , JFQ     , IRECV
!
    REAL(KIND=R4KIND)                                                                           ::&
    & HTMIJL  , SUMPQ   , SUMNQ   , SUMPW   , SUMNW   , DVOLP   , TTA     , TTB     , PP      ,   &
    & QP      , DQSTIJ  , DWSTIJ  , RFACQ   , RFACW   , RFQIJ   , RFWIJ   , Q1IJ    , W1IJ    ,   &
    & ENH     , D2PQQ   , D2PQW   , QSTIJ   , WSTIJ   , Q00     , QP0     , Q0Q     , W00     ,   &
    & WP0     , W0Q
!
    ENH = FLOAT(IDTAD) * DT / (08. * DY)
!
    DO J=MYJS_P2,MYJE_P2
        DO I=MYIS_P1,MYIE_P1
            EMH (I,J) = FLOAT(IDTAD) * DT / (08. * DX(I,J))
            DARE(I,J) = HBM2(I,J) * DX(I,J) * DY
        END DO
    END DO
!
!$omp parallel do
!$omp private (DQSTIJ   , DVOLP   , DWSTIJ  , HTMIJL  , JFP     , JFQ     , PP      , QP      ,   &
!$omp          SUMNQ    , SUMNW   , SUMPQ   , SUMPW   , TTA     , TTB     )
!
    DO K=1,LM
!
        DO 200 J=MYJS_P2,MYJE_P2
            DO 200 I=MYIS_P1,MYIE_P1
                DVOL(I,J,K) = DARE(I,J) * PDSL(I,J) * DETA(K)
                HTMIJL = HTM(I,J,K)
!
                 Q  (I,J,K) = AMAX1(Q  (I,J,K), EPSQ  ) * HTMIJL
                 CWM(I,J,K) = AMAX1(CWM(I,J,K), CLIMIT) * HTMIJL
                Q1  (I,J,K) = Q  (I,J,K)
                W1  (I,J,K) = CWM(I,J,K)
    200 END DO
!
        SUMPQ = 0.
        SUMNQ = 0.
        SUMPW = 0.
        SUMNW = 0.
!    
        DO 300 J=MYJS2_P1,MYJE2_P1
            DO 300 I=MYIS1_P1,MYIE1_P1
!            
                DVOLP = DVOL(I,J,K) * HBM3(I,J)
                TTA = (U(I       ,J-1,K) + U(I+IHW(J),J  ,K)                                      &
    &               +  U(I+IHE(J),J  ,K) + U(I       ,J+1,K)) * HBM2(I,J) * EMH(I,J)
!
                TTB = (V(I       ,J-1,K) + V(I+IHW(J),J  ,K)                                      &
    &               +  V(I+IHE(J),J  ,K) + V(I       ,J+1,K)) * HBM2(I,J) * ENH
!            
                PP = - TTA - TTB
                QP =   TTA - TTB
!            
                JFP = INT(SIGN(1.,PP))
                JFQ = INT(SIGN(1.,QP))
!            
                IFPA(I,J,K) = IHE(J) + I + ( JFP-1) / 2
                IFQA(I,J,K) = IHE(J) + I + (-JFQ-1) / 2
!            
                JFPA(I,J,K) = J + JFP
                JFQA(I,J,K) = J + JFQ
!            
                IFPF(I,J,K) = IHE(J) + I + (-JFP-1) / 2
                IFQF(I,J,K) = IHE(J) + I + ( JFQ-1) / 2
!            
                JFPF(I,J,K) = J - JFP
                JFQF(I,J,K) = J - JFQ
!            
                PP = ABS(PP) * HTM(I,J,K) * HTM(IFPA(I,J,K),JFPA(I,J,K),K)
                QP = ABS(QP) * HTM(I,J,K) * HTM(IFQA(I,J,K),JFQA(I,J,K),K)
!            
                AFP (I,J,K) = (((FF4*PP+FF3) * PP + FF2) * PP + FF1) * PP
                AFQ (I,J,K) = (((FF4*QP+FF3) * QP + FF2) * QP + FF1) * QP
!            
                DQSTIJ = (Q  (IFPA(I,J,K),JFPA(I,J,K),K) - Q  (I,J,K)) * PP                       &
    &                  + (Q  (IFQA(I,J,K),JFQA(I,J,K),K) - Q  (I,J,K)) * QP
!
                DWSTIJ = (CWM(IFPA(I,J,K),JFPA(I,J,K),K) - CWM(I,J,K)) * PP                       &
    &                  + (CWM(IFQA(I,J,K),JFQA(I,J,K),K) - CWM(I,J,K)) * QP
!            
                DQST(I,J,K) = DQSTIJ
                DWST(I,J,K) = DWSTIJ
!            
    300 END DO
!---------------------------- 
! GLOBAL SUM FOR CONSERVATION
!----------------------------
        DO 310 J=MYJS2,MYJE2
            DO 310 I=MYIS1,MYIE1
!            
                DVOLP =  DVOL(I,J,K) * HBM3(I,J)
                DQSTIJ = DQST(I,J,K) * DVOLP
                DWSTIJ = DWST(I,J,K) * DVOLP
!            
                IF (DQSTIJ > 0.) THEN
                    SUMPQ = SUMPQ + DQSTIJ
                ELSE
                    SUMNQ = SUMNQ + DQSTIJ
                END IF
!            
                IF (DWSTIJ > 0.) THEN
                    SUMPW = SUMPW + DWSTIJ
                ELSE
                    SUMNW = SUMNW + DWSTIJ
                END IF
!            
    310 END DO
!
        XSUMS(1,K) = SUMPQ
        XSUMS(2,K) = SUMNQ
        XSUMS(3,K) = SUMPW
        XSUMS(4,K) = SUMNW
!--------------- 
! END OF LM LOOP
!--------------- 
    END DO               
!----------------- 
! GLOBAL REDUCTION
!-----------------
    CALL MPI_ALLREDUCE(XSUMS, GSUMS, 4*LM, MPI_REAL, MPI_SUM, MPI_COMM_COMP, IRECV)
!------------------------
! END OF GLOBAL REDUCTION
!------------------------
!
!$omp parallel do
!$omp private (D2PQQ    , D2PQW   , DQSTIJ  , DVOLP   , DWSTIJ  , Q00     , Q0Q     , Q1IJ    ,   &
!$omp          QP0      , QSTIJ   , RFACQ   , RFACW   , RFQIJ   , RFWIJ   , SUMNQ   , SUMNW   ,   &
!$omp          SUMPQ    , SUMPW   , W00     , W0Q     , W1IJ    , WP0     , WSTIJ   )
!
    DO K=1,LM
!
        SUMPQ = GSUMS(1,K)
        SUMNQ = GSUMS(2,K)
        SUMPW = GSUMS(3,K)
        SUMNW = GSUMS(4,K)
!-------------------------------    
! FIRST MOMENT CONSERVING FACTOR 
!------------------------------- 
        IF (SUMPQ > 1.) THEN
            RFACQ = -SUMNQ / SUMPQ
        ELSE
            RFACQ = 1.
        END IF
!    
        IF (SUMPW > 1.) THEN
            RFACW = -SUMNW / SUMPW
        ELSE
            RFACW = 1.
        END IF
!    
        IF (RFACQ < 0.9 .OR. RFACQ > 1.1) RFACQ = 1.
        IF (RFACW < 0.9 .OR. RFACW > 1.1 )RFACW = 1.
!--------------------------------- 
! IMPOSE CONSERVATION ON ADVECTION
!---------------------------------
        IF (RFACQ < 1.) THEN
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DQSTIJ = DQST(I,J,K)
                    RFQIJ   = HBM3(I,J) * (RFACQ-1.) + 1.
                    IF (DQSTIJ < 0.) DQSTIJ = DQSTIJ / RFQIJ
                    Q1(I,J,K) = Q(I,J,K) + DQSTIJ
                END DO
            END DO
        ELSE
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DQSTIJ = DQST(I,J,K)
                    RFQIJ = HBM3(I,J) * (RFACQ-1.) + 1.
                    IF (DQSTIJ >= 0.) DQSTIJ = DQSTIJ * RFQIJ
                    Q1(I,J,K) = Q(I,J,K) + DQSTIJ
                END DO
            END DO
        END IF
!
        IF (RFACW < 1.) THEN
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ  = HBM3(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ < 0.) DWSTIJ = DWSTIJ / RFWIJ
                    W1(I,J,K) = CWM(I,J,K) + DWSTIJ
                END DO
            END DO
        ELSE
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ  = HBM3(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ >= 0.) DWSTIJ = DWSTIJ * RFWIJ
                    W1(I,J,K) = CWM(I,J,K) + DWSTIJ
                END DO
            END DO
        END IF
!-------------------- 
! ANTI-FILTERING STEP
!-------------------- 
        SUMPQ = 0.
        SUMNQ = 0.
        SUMPW = 0.
        SUMNW = 0.
!------------------------ 
! ANTI-FILTERING LIMITERS 
!------------------------
        DO 330 J=MYJS2,MYJE2
            DO 330 I=MYIS1,MYIE1
!            
                DVOLP = DVOL(I,J,K)
                Q1IJ  =   Q1(I,J,K)
                W1IJ  =   W1(I,J,K)
!            
                D2PQQ = (        (Q1(IFPA(I,J,K),JFPA(I,J,K),K)-Q1IJ)                             &
    &                 -  (Q1IJ -  Q1(IFPF(I,J,K),JFPF(I,J,K),K))                                  &
    &                 *          HTM(IFPF(I,J,K),JFPF(I,J,K),K)) * AFP(I,J,K)                     &
    &                 +         ((Q1(IFQA(I,J,K),JFQA(I,J,K),K)-Q1IJ)                             &
    &                 -  (Q1IJ -  Q1(IFQF(I,J,K),JFQF(I,J,K),K))                                  &
    &                 *          HTM(IFQF(I,J,K),JFQF(I,J,K),K)) * AFQ(I,J,K)
!            
                D2PQW = (    (W1(IFPA(I,J,K),JFPA(I,J,K),K)-W1IJ)                                 &
    &                 - (W1IJ-W1(IFPF(I,J,K),JFPF(I,J,K),K))                                      &
    &                 *      HTM(IFPF(I,J,K),JFPF(I,J,K),K)) * AFP(I,J,K)                         &
    &                 +     ((W1(IFQA(I,J,K),JFQA(I,J,K),K)-W1IJ)                                 &
    &                 - (W1IJ-W1(IFQF(I,J,K),JFQF(I,J,K),K))                                      &
    &                 *      HTM(IFQF(I,J,K),JFQF(I,J,K),K)) * AFQ(I,J,K)
!            
                QSTIJ = Q1IJ - D2PQQ
                WSTIJ = W1IJ - D2PQW
!            
                Q00 = Q(I          ,J          ,K)
                QP0 = Q(IFPA(I,J,K),JFPA(I,J,K),K)
                Q0Q = Q(IFQA(I,J,K),JFQA(I,J,K),K)
!            
                W00 = CWM(I          ,J          ,K)
                WP0 = CWM(IFPA(I,J,K),JFPA(I,J,K),K)
                W0Q = CWM(IFQA(I,J,K),JFQA(I,J,K),K)
!            
                QSTIJ = AMAX1(QSTIJ, AMIN1(Q00,QP0,Q0Q))
                QSTIJ = AMIN1(QSTIJ, AMAX1(Q00,QP0,Q0Q))
                WSTIJ = AMAX1(WSTIJ, AMIN1(W00,WP0,W0Q))
                WSTIJ = AMIN1(WSTIJ, AMAX1(W00,WP0,W0Q))
!            
                DQSTIJ = QSTIJ - Q1IJ
                DWSTIJ = WSTIJ - W1IJ
!            
                DQST(I,J,K) = DQSTIJ
                DWST(I,J,K) = DWSTIJ
!            
                DQSTIJ = DQSTIJ * DVOLP
                DWSTIJ = DWSTIJ * DVOLP
!            
                IF (DQSTIJ > 0.) THEN
                    SUMPQ = SUMPQ + DQSTIJ
                ELSE
                    SUMNQ = SUMNQ + DQSTIJ
                END IF
!            
                IF (DWSTIJ > 0.) THEN
                    SUMPW = SUMPW + DWSTIJ
                ELSE
                    SUMNW = SUMNW + DWSTIJ
                END IF
!            
    330 END DO
!
        XSUMS(1,K) = SUMPQ
        XSUMS(2,K) = SUMNQ
        XSUMS(3,K) = SUMPW
        XSUMS(4,K) = SUMNW
!---------------  
! END OF LM LOOP
!---------------
    END DO               
!----------------- 
! GLOBAL REDUCTION
!----------------- 
    CALL MPI_ALLREDUCE(XSUMS, GSUMS, 4*LM, MPI_REAL, MPI_SUM, MPI_COMM_COMP, IRECV)
!------------------------ 
! END OF GLOBAL REDUCTION
!------------------------
!
!$omp parallel do
!$omp private (DQSTIJ   , DWSTIJ  , HTMIJL  , RFACQ   , RFACW   , RFQIJ   , RFWIJ   , SUMNW   ,   &
!$omp          SUMNQ    , SUMPQ   , SUMPW   )
!
    DO K=1,LM
!    
        SUMPQ = GSUMS(1,K)
        SUMNQ = GSUMS(2,K)
        SUMPW = GSUMS(3,K)
        SUMNW = GSUMS(4,K)
!-------------------------------    
! FIRST MOMENT CONSERVING FACTOR
!-------------------------------
        IF (SUMPQ > 1.) THEN
            RFACQ = -SUMNQ / SUMPQ
        ELSE
            RFACQ = 1.
        END IF
!    
        IF (SUMPW > 1.) THEN
            RFACW = -SUMNW / SUMPW
        ELSE
            RFACW = 1.
        END IF
!    
        IF (RFACQ < 0.9 .OR. RFACQ > 1.1) RFACQ = 1.
        IF (RFACW < 0.9 .OR. RFACW > 1.1) RFACW = 1.
!-------------------------------------- 
! IMPOSE CONSERVATION ON ANTI-FILTERING 
!--------------------------------------
        IF (RFACQ < 1.) THEN
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DQSTIJ = DQST(I,J,K)
                    RFQIJ  = HBM2(I,J) * (RFACQ-1.) + 1.
                    IF (DQSTIJ >= 0.) DQSTIJ = DQSTIJ * RFQIJ
                    Q(I,J,K) = Q1(I,J,K) + DQSTIJ
                END DO
            END DO
        ELSE
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DQSTIJ = DQST(I,J,K)
                    RFQIJ  = HBM2(I,J) * (RFACQ-1.) + 1.
                    IF (DQSTIJ < 0.) DQSTIJ = DQSTIJ / RFQIJ
                    Q(I,J,K) = Q1(I,J,K) + DQSTIJ
                END DO
            END DO
        END IF
!
        IF (RFACW < 1.) THEN
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ = HBM2(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ >= 0.) DWSTIJ = DWSTIJ * RFWIJ
                    CWM(I,J,K) = W1(I,J,K) + DWSTIJ
                END DO
            END DO
        ELSE
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ = HBM2(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ < 0.) DWSTIJ = DWSTIJ / RFWIJ
                    CWM(I,J,K) = W1(I,J,K) + DWSTIJ
                END DO
            END DO
        END IF
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                HTMIJL = HTM(I,J,K)
                  Q(I,J,K) = AMAX1(  Q(I,J,K),   EPSQ) * HTMIJL
                CWM(I,J,K) = AMAX1(CWM(I,J,K), CLIMIT) * HTMIJL
            END DO
        END DO
!---------------  
! END OF LM LOOP 
!--------------- 
    END DO       
!
    RETURN
!
    END SUBROUTINE HZADV2

    SUBROUTINE VTADV
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VTADV
!>
!> SUBPROGRAM: VTADV - VERTICAL ADVECTION
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-11-17
!>
!> ABSTRACT:
!> VTADV CALCULATES THE CONTRIBUTION OF THE VERTICAL ADVECTION TO THE TENDENCIES OF TEMPERATURE,
!> SPECIFIC HUMIDITY, WIND COMPONENTS, AND TURBULENT KINETIC ENERGY AND THEN UPDATES THOSE
!> VARIABLES. FOR ALL VARIABLES EXCEPT SPECIFIC HUMIDITY A SIMPLE CENTERED DIFFERENCE SCHEME IN 
!> SPACE IS USED IN CONJUNCTION WITH THE PURE EULER-BACKWARD TIME SCHEME.
!> A PIECEWISE LINEAR SCHEME IS USED TO CALCULATE THE VERTICAL ADVECTION OF SPECIFIC HUMIDITY SO 
!> THAT NO FALSE MAXIMA OR MINIMA ARE PRODUCED.
!>
!> PIECEWISE LINEAR SCHEME (MESINGER AND JOVIC, NCEP OFFICE NOTE #439) HERE USED FOR ALL VARIABLES,
!> AVOIDING FALSE ADVECTION FROM BELOW GROUND, AND AT THE SAME TIME MAKING THE ETA VERY NEARLY A 
!> FINITE VOLUME MODEL.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 90-??-??  MESINGER   - INSERTED PIECEWISE LINEAR SCHEME FOR SPECIFIC HUMIDITY
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 96-03-29  BLACK      - ADDED EXTERNAL EDGE; REMOVED SCRCH COMMON
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 00-02-04  BLACK      - ADDED CLOUD WATER/ICE
!> 01-12-11  BLACK      - SMOOTHING FOR CFL VIOLATION
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!v
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : -----                 
!>--------------------------------------------------------------------------------------------------
!
!--------------------------------------------------------------------------------------------
! THIS IS THE CODE AS E-MAILED APRIL 10, 07, BUT WITH BUGS CORRECTED:
! 1)  FFD1, TWICE, 1 IS REMOVED,
! 2)  F4D, IN LOOP 1320, THE SECOND PAIR CHANGED INTO F4Q;
! 3)  ..TEND1.. 2ND TIME IN LOOP 1330 REPL. BY ..TEND2..
! AND ALSO:
! A) DEAD PIECES OF THE CODE - ABANDONED FINITE DIFFERENCE VERTICAL ADVECTION OF T AND U, V 
!    (TWICE "GO TO ..." SEGMENTS) - DELETED;
! B) SWITCHING TO CALLS EVERY TIME STEP COMMENTED OUT, AS THIS TAKES NON-NEGLIGIBLE TIME, AND
!    IN THE ETA HORIZONTAL ADVECTION IS CALLED EVERY SECOND TIME STEP ALSO (CONSISTENCY)
!--------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: EDQMX   =  2.E-5
    REAL   (KIND=R4KIND), PARAMETER :: EDQMN   = -2.E-5
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ    =  1.E-12
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2   =  0.2
    REAL   (KIND=R4KIND), PARAMETER :: CFL_MAX =  0.97
!
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD   =  0
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM    = IM * JM - JM / 2
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & NOSLA   , NOSLAW 
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::&
    & WFA     , WFB
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & ETADTL  ,                                                                                   &
    & TQ2B    ,                                                                                   &
    & DQTI    , DQBI    ,                                                                         &
    & RPDX    , RPDY    ,                                                                         &
    & QDEDB   , QDEUB   ,                                                                         &
    & EDBD    ,                                                                                   &
    & DQDEB   ,                                                                                   &
    & DUTI    , DUBI    ,                                                                         &
    & DVTI    , DVBI    ,                                                                         &
    & UDEDB   , UDEUB   ,                                                                         &
    & VDEDB   , VDEUB   ,                                                                         &
    & EDBDU   , EDBDV   ,                                                                         &
    & DUDEB   , DVDEB   ,                                                                         & 
    & FNE     , FSE 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & SAM     ,                                                                                   &
    & QBI     ,                                                                                   &
    & Q2ST    ,                                                                                   &
    & SAMU    ,                                                                                   &
    & UBI     ,                                                                                   &
    & SAMV    ,                                                                                   &
    & VBI     
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM1)                              ::&
    & ARRAY1  ,                                                                                   &
    & ARRAY2  ,                                                                                   &
    & ARRAYU1 ,                                                                                   &
    & ARRAYU2 ,                                                                                   &
    & ARRAYV1 ,                                                                                   &
    & ARRAYV2 
!
    REAL   (KIND=R4KIND), DIMENSION(:,:,:), ALLOCATABLE                                         ::&
    & S
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & VAD_TEND1         , VAD_TEND2
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & VAD_TNDX1         , VAD_TNDX2
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & LBOT_CFL_T        , LTOP_CFL_T        ,                                                     &
    & LBOT_CFL_U        , LTOP_CFL_U        ,                                                     &
    & LBOT_CFL_V        , LTOP_CFL_V
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & K       , NMSAP   , NMSAPW  , I       , J       , NSMUD   , KS      , NS      , MSA     ,   &
    & IER     , LSTART  , LSTOP
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTAD    , CFL     , EXTREM  , DQTIK   , ASTIK   , ASBIK   , QDEDTK  , QDEUTK  , SEDBK   ,   &
    & DQDEK   , EDBFK   , EDTDK   , TQ2AK   , EXTREMU , EXTREMV , DUTIK   , DVTIK   , ASTIKU  ,   &
    & ASTIKV  , ASBIKU  , ASBIKV  , VMIJ    , UDEDTK  , VDEDTK  , VDEUTK  , UDEUTK  , SEDBKU  ,   &
    & SEDBKV  , DUDEK   , DVDEK   , EDBFKU  , EDBFKV  , EDTDKU  , EDTDKV
!
    DTAD = IDTAD * DT
!------------------------------------------ 
! DEFINE ADDED UPSTREAM ADVECTION CONSTANTS 
!------------------------------------------
!    DO 25 K=1,LM1
!        WFA(K) = DETA(K  ) / (DETA(K) + DETA(K+1))
!        WFB(K) = DETA(K+1) / (DETA(K) + DETA(K+1))
! 25 END DO
       WFA(1:LM1) = DETA(1:LM1  ) / (DETA(1:LM1) + DETA(2:LM))
       WFB(1:LM1) = DETA(2:LM) / (DETA(1:LM1) + DETA(2:LM))  
!------------------------------------------- 
! NO MOISTURE SLOPE ADJUSTMENT IF NOT WANTED
!-------------------------------------------
    NOSLA  = .FALSE. 
    NOSLAW = .FALSE. 
!----------------------------------------------------- 
! IF FALSE, NUMBER OF MOISTURE SLOPE ADJUSTMENT PASSES
!----------------------------------------------------- 
    NMSAP  = 3
    NMSAPW = 3
!----------------------------------------  
! SMOOTHING VERTICAL VELOCITY AT H POINTS 
!----------------------------------------
    IF (KSMUD > 0) THEN
!
!$omp parallel do 
!
        DO 90 K=1,LM1
            DO 50 J=MYJS_P4,MYJE_P4
                DO 50 I=MYIS_P4,MYIE_P4
                    ETADT(I,J,K) = ETADT(I,J,K) * HBM2(I,J)
         50 END DO
!
            NSMUD = KSMUD
!-------------------------------------------------------------------------
! HE FNE, FSE, ETADTL, AND ETADT ARRAYS ARE ON OR ASSOCIATED WITH H POINTS
!-------------------------------------------------------------------------
            DO 90 KS=1,NSMUD
                DO 80 J=MYJS_P3,MYJE1_P3
                    DO 80 I=MYIS_P3,MYIE_P3
                        FNE(I,J) = (ETADT(I+IHE(J),J+1,K  ) - ETADT(I       ,J  ,K  ))            & 
    &                            *    HTM(I       ,J  ,K+1) *   HTM(I+IHE(J),J+1,K+1)
             80 END DO
!
                DO 82 J=MYJS1_P3,MYJE_P3
                    DO 82 I=MYIS_P3,MYIE_P3
                        FSE(I,J) = (ETADT(I+IHE(J),J-1,K  ) - ETADT(I,J,K  ))                     &
    &                            *    HTM(I+IHE(J),J-1,K+1) *   HTM(I,J,K+1)
             82 END DO
!
                DO 84 J=MYJS2_P1,MYJE2_P1
                    DO 84 I=MYIS_P1,MYIE_P1
                        ETADTL(I,J) = (FNE(I,J) - FNE(I+IHW(J),J-1)                               &
    &                               +  FSE(I,J) - FSE(I+IHW(J),J+1))                              &
    &                               * HBM2(I,J)
             84 END DO
!
                DO 86 J=MYJS2_P1,MYJE2_P1
                    DO 86 I=MYIS_P1,MYIE_P1
                        ETADT(I,J,K) = ETADTL(I,J) * 0.125 + ETADT(I,J,K)
             86 END DO
!
     90 END DO
!
    END IF
!------------------------------------------------------------------------------------------
!  IF THE CFL CRITERION IS VIOLATED THEN LOCATE VERTICAL LIMITS BETWEEN WHICH TO SMOOTH THE
!  TENDENCIES
!------------------------------------------------------------------------------------------
!
!$omp parallel do
! 
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            LTOP_CFL_T(I,J) = 0
            LBOT_CFL_T(I,J) = 0
            LTOP_CFL_U(I,J) = 0
            LBOT_CFL_U(I,J) = 0
            LTOP_CFL_V(I,J) = 0
            LBOT_CFL_V(I,J) = 0
        END DO
    END DO
!
    DO K=1,LM1
!
!$omp parallel do private (CFL)   
! 
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
!------------             
! MASS POINTS
!------------           
                CFL = ETADT(I,J,K) * DTAD * HBM2(I,J)/(0.5*(DETA(K)+DETA(K+1)))
                IF (ABS(CFL) > CFL_MAX) THEN
                    IF (LTOP_CFL_T(I,J) == 0) LTOP_CFL_T(I,J) = MAX(K,2)
                    IF (LBOT_CFL_T(I,J) < K ) LBOT_CFL_T(I,J) = MAX(K,2)
                END IF
!------------            
! U COMPONENT
!------------            
                CFL = (ETADT(I+IVW(J),J,K) + ETADT(I+IVE(J),J,K))                                 &
    &                * DTAD * VBM2(I,J) / (DETA(K)+DETA(K+1))
!            
                IF (ABS(CFL) > CFL_MAX) THEN
                    IF (LTOP_CFL_U(I,J) == 0) LTOP_CFL_U(I,J) = MAX(K,2)
                    IF (LBOT_CFL_U(I,J) < K ) LBOT_CFL_U(I,J) = MAX(K,2)
                END IF
!------------           
! V COMPONENT
!------------            
                CFL = (ETADT(I,J-1,K) + ETADT(I,J+1,K)) * DTAD * VBM2(I,J) / (DETA(K) + DETA(K+1))
!            
                IF (ABS(CFL) > CFL_MAX) THEN
                    IF (LTOP_CFL_V(I,J) == 0) LTOP_CFL_V(I,J) = MAX(K,2)
                    IF (LBOT_CFL_V(I,J) < K ) LBOT_CFL_V(I,J) = MAX(K,2)
                END IF
!            
            END DO
        END DO
!    
    END DO
!------------------------------------------------------------
! PIECEWISE LINEAR UPSTREAM VERTICAL ADVECTION OF Q AND CLOUD 
!------------------------------------------------------------
    ALLOCATE(S(IDIM1:IDIM2, JDIM1:JDIM2,LM), STAT=I)
!-------------------------------------------------------------------------------------------------
! INTIALIZE Q AT THE BOTTOM INTERFACE AND THE SLOPE ADJUSTMENT MASK (SAM=1 FOR SA PERMITTED, 0 FOR
! NOT PERMITTED)
!-------------------------------------------------------------------------------------------------
!
!--------------------------------
! LOOP OVER S VARIABLES (Q,CWM,T)
!--------------------------------
    DO 400 NS=1,3
!
        IF (NS == 1) THEN
!
!$omp parallel do
!
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        S(I,J,K) = Q(I,J,K)
                    END DO
                END DO
            END DO
        ELSE IF (NS == 2) THEN
!
!$omp parallel do
! 
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        S(I,J,K) = CWM(I,J,K)
                    END DO
                END DO
            END DO
        ELSE IF (NS == 3) THEN
!
!$omp parallel do 
!
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        S(I,J,K) = T(I,J,K)
                    END DO
                END DO
            END DO
        ELSE
            WRITE(0,*)'ERROR IN VTADV. WILL STOP NOW.'
            STOP
        END IF
!
!$omp parallel do 
!
        DO 175 K=1,LM
            DO 175 J=MYJS2,MYJE2
                DO 175 I=MYIS,MYIE
                    QBI(I,J,K) = S(I,J,K)
                    SAM(I,J,K) = 1.
    175 END DO
!
        IF (NOSLA) GOTO 290
!------------------------------------------------------
! THE SLOPE ADJUSTMENT CODE
! NO SLOPE PERMITTED AT THE TOP AND AT THE BOTTOM LAYER
!------------------------------------------------------ 
!
!$omp parallel do 
!
        DO 190 J=MYJS2,MYJE2
            DO 190 I=MYIS,MYIE
                SAM(I,J, 1) = 0.
                SAM(I,J,LM) = 0.
    190 END DO
!
!$omp parallel do 
!
        DO 200 K=1,LM1
            DO 200 J=MYJS2,MYJE2
                DO 200 I=MYIS,MYIE
                    SAM(I,J,K) = SAM(I,J,K) * HTM(I,J,K+1)
    200 END DO
!----------------------------------------------------------------------------------------
! NOW, SEARCH FOR THE MAXIMA AND MINIMA OF Q (AT THE FIRST PASS) AND FOR LAYERS WHICH HAD
! OVERADJUSTED (AT SUBSEQUENT PASSES) DUE TO ROUND-OFF ERRORS
!----------------------------------------------------------------------------------------
!
!$omp parallel do private (DQBI, DQTI, EXTREM)
!
        DO 220 K=2,LM1
            DO 220 J=MYJS2,MYJE2
                DO 220 I=MYIS,MYIE
                    DQTI(I,J) = S(I,J,K  ) - S(I,J,K-1)
                    DQBI(I,J) = S(I,J,K+1) - S(I,J,K  )
!
                    EXTREM    = DQTI(I,J) * DQBI(I,J)
!
                    IF (EXTREM <= 0.) SAM(I,J,K) = 0.
    220 END DO
!
!$omp parallel do 
!
        DO 230 K=2,LM1
            DO 230 J=MYJS2,MYJE2
                DO 230 I=MYIS,MYIE
                    ARRAY1(I,J,K) = WFA(K-1) * (1.-SAM(I,J,K-1)) + WFB(K-1)
                    ARRAY2(I,J,K) = WFA(K  ) + WFB(K) * (1.-SAM(I,J,K+1))
    230 END DO
!
        DO 260 MSA=1,NMSAP
!-------------------------------------------------------------------------------------------------
! CALCULATE DQ AT INTERFACES AND ADJUST THE SLOPES WHERE AND TO THE EXTENT PERMITTED OBSERVING THE
! MONOTONICITY CONDITION (E.G. VAN LEER, J. COMP. PHYS. 1977, 276-299)
!-------------------------------------------------------------------------------------------------
!
!$omp parallel do 
!
            DO 240 J=MYJS2,MYJE2
                DO 240 I=MYIS,MYIE
                    DQBI(I,J) = 2. * S(I,J,2) - QBI(I,J,2) - QBI(I,J,1)
        240 END DO
!        
            DO 250 K=2,LM1
!
!$omp parallel do private (ASBIK, ASTIK, DQTIK)
!
                DO 250 J=MYJS2,MYJE2
                    DO 250 I=MYIS,MYIE
                        DQTIK =   DQBI(I,J)
                        ASTIK = ARRAY1(I,J,K) * DQTIK
                        DQBI(I,J) = 2. * S(I,J,K+1) - QBI(I,J,K+1) - QBI(I,J,K)
                        ASBIK = ARRAY2(I,J,K) * DQBI(I,J)
                         QBI(I,J,K) = QBI(I,J,K)                                                  &
    &                               + (ASTIK-SIGN(1.,ASTIK) * DIM(ABS(ASTIK), ABS(ASBIK)))        &
    &                               *  SAM(I,J,K)
            250 END DO
!
    260 END DO
!------------------------------------------------------------------------------------------------
! SLOPE ADJUSTMENT OF THE LAYERS ABOVE THAT NEXT TO THE SURFACE IS DONE; NOW ADJUST THE LOWERMOST
! LAYER
!------------------------------------------------------------------------------------------------
        DO 270 K=9,LM1
!
!$omp parallel do 
!
            DO 270 J=MYJS2,MYJE2
                DO 270 I=MYIS,MYIE
                    IF (HTM(I,J,K+1) == 0.) QBI(I,J,K) = 2. * S(I,J,K) - QBI(I,J,K-1)
        270 END DO
!
!$omp parallel do 
!
        DO 280 J=MYJS2,MYJE2
            DO 280 I=MYIS,MYIE
                QBI(I,J,LM) = 2. * S(I,J,LM) - QBI(I,J,LM1)
    280 END DO
!--------------------------------- 
! END OF THE SLOPE ADJUSTMENT CODE 
!--------------------------------- 
    290 CONTINUE
!
!$omp parallel do 
!
        DO 300 J=MYJS2,MYJE2
            DO 300 I=MYIS,MYIE
                QDEDB(I,J) = 0.
                QDEUB(I,J) = 0.
                DQDEB(I,J) = 2. * (QBI(I,J,1) - S(I,J,1)) * RDETA(1)
                EDBD (I,J) = 0.
    300 END DO
!    
        DO 320 K=1,LM1
!
!$omp parallel do private (DQDEK, EDBFK, EDTDK, QDEDTK, QDEUTK, SEDBK)
!
            DO 320 J=MYJS2,MYJE2
                DO 320 I=MYIS,MYIE
                    QDEDTK     = QDEDB(I,J)
                    QDEUTK     = QDEUB(I,J)
                    SEDBK      = SIGN(1.,ETADT(I,J,K))
                    DQDEK      = DQDEB(I,J)
                    DQDEB(I,J) = 2. * (QBI(I,J,K+1) - S(I,J,K+1)) * RDETA(K+1)
                    EDBFK      = ETADT(I,J,K) * F4D
                    QDEDB(I,J) = (1.+SEDBK) * (QBI(I,J,K) + DQDEK * EDBFK) * (-EDBFK)
                    QDEUB(I,J) = (1.-SEDBK) * (2.*S(I,J,K+1) - QBI(I,J,K+1) + DQDEB(I,J)*EDBFK)   &
    &                          *  EDBFK
!
                    EDTDK      = EDBD(I,J)
                    EDBD (I,J) = ETADT(I,J,K) * (-F4Q)
                    S(I,J,K)   = S(I,J,K) + (QDEDTK - QDEUTK - QDEDB(I,J) + QDEUB(I,J)            &
    &                          + S(I,J,K) * (EDBD(I,J)-EDTDK)) * RDETA(K)
    320 END DO
!
!$omp parallel do 
!
        DO 330 J=MYJS2,MYJE2
            DO 330 I=MYIS,MYIE
                S(I,J,LM) = S(I,J,LM) + (QDEDB(I,J)  -  QDEUB(I,J)                                &
    &                     + S(I,J,LM) * (-EDBD(I,J))) * RDETA(LM)
    330 END DO
!-------------------------------------------------------- 
! NEGATIVE MOISTURE MAY OCCUR DUE TO VIOLATION OF THE CFL
!--------------------------------------------------------
        DO 350 K=1,LM1
!
!$omp parallel do 
!
            DO 350 J=MYJS2,MYJE2
                DO 350 I=MYIS,MYIE
                    IF (S(I,J,K) < EPSQ) THEN
                        DQBI(I,J)  = S(I,J,K  )
                        S(I,J,K  ) = EPSQ
                        S(I,J,K+1) = S(I,J,K+1) + DETA(K) * RDETA(K+1) * DQBI(I,J)
                    END IF
        350 END DO
!
!$omp parallel do 
!
        DO 360 J=MYJS2,MYJE2
            DO 360 I=MYIS,MYIE
                IF (S(I,J,LM) < EPSQ) S(I,J,LM) = EPSQ
    360 END DO
!
        IF (NS == 1) THEN
!
!$omp parallel do 
!
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        Q(I,J,K) = S(I,J,K)
                    END DO
                END DO
            END DO
        ELSE IF (NS == 2) THEN
!
!$omp parallel do 
!
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        CWM(I,J,K) = S(I,J,K)
                    END DO
                END DO
            END DO
        ELSE IF (NS == 3) THEN
!
!$omp parallel do 
!
            DO K=1,LM
                DO J=JDIM1,JDIM2
                    DO I=IDIM1,IDIM2
                        T(I,J,K) = S(I,J,K)
                    END DO
                END DO
            END DO
        ELSE
            WRITE(0,*)'ERROR IN VTADV. WILL STOP NOW.'
            STOP
        END IF
!
400 END DO
!
    DEALLOCATE(S,STAT=IER)
!----------------------------------- 
! VERTICAL (MATSUNO) ADVECTION OF Q2 
!----------------------------------- 
!
!$omp parallel do 
!
    DO 420 J=MYJS2,MYJE2
        DO 420 I=MYIS,MYIE
            TQ2B(I,J) = Q2(I,J,1) * ETADT(I,J,1) * F4Q2(1)
420 END DO
!
    DO 425 K=1,LM2
!
!$omp parallel do private (TQ2AK)
!
        DO 425 J=MYJS2,MYJE2
            DO 425 I=MYIS,MYIE
                TQ2AK = (Q2(I,J,K+1) - Q2(I,J,K)) * (ETADT(I,J,K) + ETADT(I,J,K+1)) * F4Q2(K+1)
                Q2ST(I,J,K) = TQ2AK + TQ2B(I,J) + Q2(I,J,K)
                TQ2B(I,J)   = TQ2AK
    425 END DO
!
!$omp parallel do private (TQ2AK)
!
    DO 440 J=MYJS2,MYJE2
        DO 440 I=MYIS,MYIE
            TQ2AK = (Q2(I,J,LM) - Q2(I,J,LM1)) * ETADT(I,J,LM1) * F4Q2(LM)
            Q2ST(I,J,LM1) = TQ2AK + TQ2B(I,J) + Q2(I,J,LM1)
            Q2ST(I,J,LM ) =                     Q2(I,J,LM)
440 END DO
!------------------------------- 
! SECOND (BACKWARD) MATSUNO STEP 
!------------------------------- 
!
!$omp parallel do 
!
    DO 450 J=MYJS2,MYJE2
        DO 450 I=MYIS,MYIE
            TQ2B(I,J) = Q2ST(I,J,1) * ETADT(I,J,1) * F4Q2(1)
450 END DO
!
    DO K=1,LM2
!
!$omp parallel do private (TQ2AK)
!
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
                TQ2AK = (Q2ST(I,J,K+1) - Q2ST(I,J,K)) * (ETADT(I,J,K) + ETADT(I,J,K+1)) * F4Q2(K+1)
                VAD_TEND1(I,J,K) = TQ2AK + TQ2B(I,J)
                TQ2B(I,J) = TQ2AK
            END DO
        END DO
!
    END DO
!
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
            TQ2AK = (Q2ST(I,J,LM) - Q2ST(I,J,LM1)) * ETADT(I,J,LM1) * F4Q2(LM)
            VAD_TEND1(I,J,LM1) = TQ2AK + TQ2B(I,J)
        END DO
    END DO
!--------------------------------------------------------------------- 
! IF THE CFL CRITERION IS VIOLATED THEN VERTICALLY SMOOTH THE TENDENCY
!--------------------------------------------------------------------- 
!
!$omp parallel do private (CFL, LBOT_CFL, LSTART, LSTOP, LTOP_CFL, VAD_TEND1, VAD_TNDX1)
!
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
!
            IF (LTOP_CFL_T(I,J) > 0) THEN
                LSTART =     LTOP_CFL_T(I,J)
                LSTOP  = MIN(LBOT_CFL_T(I,J),LM-2)
!            
                DO K=LSTART,LSTOP
                    VAD_TNDX1(K) = (VAD_TEND1(I,J,K-1)  + VAD_TEND1(I,J,K+1) + 2.                 &
    &                            *  VAD_TEND1(I,J,K  )) * 0.25
                END DO
                DO K=LSTART,LSTOP
                    VAD_TEND1(I,J,K) = VAD_TNDX1(K)
                END DO
            END IF
!        
        END DO
    END DO
!
    DO 470 K=1,LM2
!
!$omp parallel do 
!
        DO 470 J=MYJS2,MYJE2
            DO 470 I=MYIS,MYIE
                Q2(I,J,K) = VAD_TEND1(I,J,K) + Q2(I,J,K)
                Q2(I,J,K) =  AMAX1(Q2(I,J,K), EPSQ2)
    470 END DO
!
!$omp parallel do 
!
    DO 480 J=MYJS2,MYJE2
        DO 480 I=MYIS,MYIE
            Q2(I,J,LM1) = VAD_TEND1(I,J,LM1) + Q2(I,J,LM1)
            Q2(I,J,LM1) =  AMAX1(Q2(I,J,LM1), EPSQ2)
480 END DO
!------------------------------------------- 
! DEFINITION OF VARIABLES NEEDED AT V POINTS 
!------------------------------------------- 
!
!$omp parallel do 
!
    DO 500 K=1,LM1
        DO 500 J=MYJS_P1,MYJE_P1
            DO 500 I=MYIS_P1,MYIE_P1
                ETADT(I,J,K) = ETADT(I,J,K) * PDSL(I,J) * HBM2(I,J)
    500 END DO
!
!$omp parallel do 
!
    DO 510 J=MYJS2,MYJE2
        DO 510 I=MYIS,MYIE
            RPDX(I,J) = 1. / (PDSL(I+IVW(J),J  ) + PDSL(I+IVE(J),J  ))
            RPDY(I,J) = 1. / (PDSL(I       ,J-1) + PDSL(I       ,J+1))
510 END DO
!-------------------------------------------------------------------------------------------------- 
! PIECEWISE LINEAR UPSTREAM VERTICAL ADVECTION OF U AND V  
! INTIALIZE U AND V AT THE BOTTOM INTERFACE AND THE SLOPE ADJUSTMENT MASK (SAMU=1 AND SAMV=1 FOR SA
! PERMITTED, 0 FOR NOT PERMITTED)
!-------------------------------------------------------------------------------------------------- 
!
!$omp parallel do 
!
    DO 999 K=1,LM
        DO 999 J=MYJS2,MYJE2
            DO 999 I=MYIS,MYIE
                 UBI(I,J,K) = U(I,J,K)
                 VBI(I,J,K) = V(I,J,K)
                SAMU(I,J,K) = 1.
                SAMV(I,J,K) = 1.
999 END DO
!
    IF (NOSLAW) GOTO 998
!------------------------------------------------------
! THE SLOPE ADJUSTMENT CODE 
! NO SLOPE PERMITTED AT THE TOP AND AT THE BOTTOM LAYER
!------------------------------------------------------ 
!
!$omp parallel do 
!
    DO 997 J=MYJS2,MYJE2
        DO 997 I=MYIS,MYIE
            SAMU(I,J, 1) = 0.
            SAMU(I,J,LM) = 0.
            SAMV(I,J, 1) = 0.
            SAMV(I,J,LM) = 0.
997 END DO
!
!$omp parallel do
! 
    DO 996 K=1,LM1
        DO 996 J=MYJS2,MYJE2
            DO 996 I=MYIS,MYIE
                SAMU(I,J,K) = SAMU(I,J,K) * VTM(I,J,K+1)
                SAMV(I,J,K) = SAMV(I,J,K) * VTM(I,J,K+1)
996 END DO
!--------------------------------------------------------------------------------------------
! NOW, SEARCH FOR THE MAXIMA AND MINIMA OF U & V (AT THE FIRST PASS) AND FOR LAYERS WHICH HAD
! OVERADJUSTED (AT SUBSEQUENT PASSES) DUE TO ROUND-OFF ERRORS
!--------------------------------------------------------------------------------------------
!
!$omp parallel do private (DUBI, DVBI, DUTI, DVTI, EXTREMU, EXTREMV)
!
    DO 995 K=2,LM1
        DO 995 J=MYJS2,MYJE2
            DO 995 I=MYIS,MYIE
                DUTI(I,J) = U(I,J,K  ) - U(I,J,K-1)
                DVTI(I,J) = V(I,J,K  ) - V(I,J,K-1)
                DUBI(I,J) = U(I,J,K+1) - U(I,J,K  )
                DVBI(I,J) = V(I,J,K+1) - V(I,J,K  )
!
                EXTREMU = DUTI(I,J) * DUBI(I,J)
                EXTREMV = DVTI(I,J) * DVBI(I,J)
!
                IF (EXTREMU < 0.) SAMU(I,J,K) = 0.
                IF (EXTREMV < 0.) SAMV(I,J,K) = 0.
995 END DO
!
!$omp parallel do 
!
    DO 994 K=2,LM1
        DO 994 J=MYJS2,MYJE2
            DO 994 I=MYIS,MYIE
                ARRAYU1(I,J,K) = WFA(K-1) * (1.-SAMU(I,J,K-1)) + WFB(K-1)
                ARRAYV1(I,J,K) = WFA(K-1) * (1.-SAMV(I,J,K-1)) + WFB(K-1)
                ARRAYU2(I,J,K) = WFA(K  ) + WFB(K) * (1.-SAMU(I,J,K+1))
                ARRAYV2(I,J,K) = WFA(K  ) + WFB(K) * (1.-SAMV(I,J,K+1))
994 END DO
!
    DO 993 MSA=1,NMSAPW
!--------------------------------------------------------------------------------------------------
! CALCULATE DU & DV AT INTERFACES AND ADJUST THE SLOPES WHERE AND TO THE EXTENT PERMITTED OBSERVING
! THE MONOTONICITY CONDITION (E.G. VAN LEER, J. COMP. PHYS. 1977, 276-299, SCHEME USED HERE OF 
! MESINGER AND JOVIC, NCEP OFFICE NOTE #439)
!--------------------------------------------------------------------------------------------------
!
!$omp parallel do 
!
        DO 992 J=MYJS2,MYJE2
            DO 992 I=MYIS,MYIE
                DUBI(I,J) = 2. * U(I,J,2) - UBI(I,J,2) - UBI(I,J,1)
                DVBI(I,J) = 2. * V(I,J,2) - VBI(I,J,2) - VBI(I,J,1)
    992 END DO
!
!$omp parallel do private (ASBIKU, ASBIKV, ASTIKU, ASTIKV, DUTIK, DVTIK)
!
        DO 991 K=2,LM1
            DO 991 J=MYJS2,MYJE2
                DO 991 I=MYIS,MYIE
                    DUTIK = DUBI(I,J)
                    DVTIK = DVBI(I,J)
                    ASTIKU = ARRAYU1(I,J,K) * DUTIK
                    ASTIKV = ARRAYV1(I,J,K) * DVTIK
!
                    DUBI(I,J) = 2.0 * U(I,J,K+1) - UBI(I,J,K+1) - UBI(I,J,K)
                    DVBI(I,J) = 2.0 * V(I,J,K+1) - VBI(I,J,K+1) - VBI(I,J,K)
!
                    ASBIKU = ARRAYU2(I,J,K) * DUBI(I,J)
                    ASBIKV = ARRAYV2(I,J,K) * DVBI(I,J)
!
                    UBI(I,J,K) = UBI(I,J,K) + (ASTIKU-SIGN(1.,ASTIKU)                             &
    &                          * DIM(ABS(ASTIKU),ABS(ASBIKU))) * SAMU(I,J,K)
!
                    VBI(I,J,K) = VBI(I,J,K) + (ASTIKV-SIGN(1.,ASTIKV)                             &
    &                          * DIM(ABS(ASTIKV),ABS(ASBIKV))) * SAMV(I,J,K)
    991 END DO
993 END DO
!------------------------------------------------------------------------------------------------
! SLOPE ADJUSTMENT OF THE LAYERS ABOVE THAT NEXT TO THE SURFACE IS DONE; NOW ADJUST THE LOWERMOST
! LAYER
!------------------------------------------------------------------------------------------------
    DO 990 K=9,LM1
!
!$omp parallel do 
!
        DO 990 J=MYJS2,MYJE2
            DO 990 I=MYIS,MYIE
                IF (VTM(I,J,K+1) == 0.) UBI(I,J,K) = 2. * U(I,J,K) - UBI(I,J,K-1)
                IF (VTM(I,J,K+1) == 0.) VBI(I,J,K) = 2. * V(I,J,K) - VBI(I,J,K-1)
990 END DO
!
!$omp parallel do 
!
    DO 989 J=MYJS2,MYJE2
        DO 989 I=MYIS,MYIE
            UBI(I,J,LM) = 2. * U(I,J,LM) - UBI(I,J,LM1)
            VBI(I,J,LM) = 2. * V(I,J,LM) - VBI(I,J,LM1)
989 END DO
!--------------------------------- 
! END OF THE SLOPE ADJUSTMENT CODE 
!--------------------------------- 
998 CONTINUE
!
!$omp parallel do 
!
    DO 988 J=MYJS2,MYJE2
        DO 988 I=MYIS,MYIE
            UDEDB(I,J) = 0.
            VDEDB(I,J) = 0.
            UDEUB(I,J) = 0.
            VDEUB(I,J) = 0.
            DUDEB(I,J) = 2. * (UBI(I,J,1) - U(I,J,1)) * RDETA(1)
            DVDEB(I,J) = 2. * (VBI(I,J,1) - V(I,J,1)) * RDETA(1)
            EDBDU(I,J) = 0.
            EDBDV(I,J) = 0.
988 END DO
!
    DO 987 K=1,LM1
!
!$omp parallel do private (DQDEK, EDBFK, EDTDK, QDEDTK, QDEUTK, SEDBK)
!
        DO 987 J=MYJS2,MYJE2
            DO 987 I=MYIS,MYIE
                VMIJ   =   VTM(I,J,K) * VBM2(I,J)
!
                UDEDTK = UDEDB(I,J)
                VDEDTK = VDEDB(I,J)
                UDEUTK = UDEUB(I,J)
                VDEUTK = VDEUB(I,J)
!
                SEDBKU = SIGN(1.,(ETADT(I+IVW(J),J  ,K) + ETADT(I+IVE(J),J  ,K)))
                SEDBKV = SIGN(1.,(ETADT(I       ,J-1,K) + ETADT(I       ,J+1,K)))
!
                DUDEK = DUDEB(I,J)
                DVDEK = DVDEB(I,J)
!
                DUDEB(I,J) = 2. * (UBI(I,J,K+1) - U(I,J,K+1)) * RDETA(K+1)
                DVDEB(I,J) = 2. * (VBI(I,J,K+1) - V(I,J,K+1)) * RDETA(K+1)
!            
                EDBFKU = (ETADT(I+IVW(J),J  ,K) + ETADT(I+IVE(J),J  ,K)) * RPDX(I,J) * F4D
                EDBFKV = (ETADT(I       ,J-1,K) + ETADT(I       ,J+1,K)) * RPDY(I,J) * F4D
!            
                UDEDB(I,J) = (1.+SEDBKU) * (UBI(I,J,K) + DUDEK * EDBFKU) * (-EDBFKU)
                VDEDB(I,J) = (1.+SEDBKV) * (VBI(I,J,K) + DVDEK * EDBFKV) * (-EDBFKV)
!
                UDEUB(I,J) = (1.-SEDBKU) * (U(I,J,K+1) +     U(I,J,K+1)                           &
    &                      -              UBI(I,J,K+1) + DUDEB(I,J)                               &
    &                      *              EDBFKU)      * EDBFKU
!
                VDEUB(I,J) = (1.-SEDBKV) * (V(I,J,K+1) +     V(I,J,K+1)                           &
    &                      -              VBI(I,J,K+1) + DVDEB(I,J)                               &
    &                      *              EDBFKV)      * EDBFKV
                EDTDKU = EDBDU(I,J)
                EDTDKV = EDBDV(I,J)
!
                EDBDU(I,J) = (ETADT(I+IVW(J),J  ,K) + ETADT(I+IVE(J),J  ,K)) * RPDX(I,J) * (-F4Q)
                EDBDV(I,J) = (ETADT(I       ,J-1,K) + ETADT(I       ,J+1,K)) * RPDY(I,J) * (-F4Q)
!
                VAD_TEND1(I,J,K) = (UDEDTK - UDEUTK - UDEDB(I,J) + UDEUB(I,J) + U(I,J,K)          &
    &                            * (EDBDU(I,J) - EDTDKU)) * RDETA(K) * VMIJ
!
                VAD_TEND2(I,J,K) = (VDEDTK - VDEUTK - VDEDB(I,J) + VDEUB(I,J) + V(I,J,K)          &
    &                            * (EDBDV(I,J) - EDTDKV)) * RDETA(K) * VMIJ
987 END DO
!
!$omp parallel do 
!
    DO 986 J=MYJS2,MYJE2
        DO 986 I=MYIS,MYIE
            VMIJ = VTM(I,J,LM) * VBM2(I,J)
            VAD_TEND1(I,J,LM) = (UDEDB(I,J) - UDEUB(I,J) + U(I,J,LM) * (-EDBDU(I,J)))             &
    &                         * RDETA(LM) * VMIJ
            VAD_TEND2(I,J,LM) = (VDEDB(I,J) - VDEUB(I,J) + V(I,J,LM) * (-EDBDV(I,J)))             &
    &                         * RDETA(LM) * VMIJ
986 END DO
!-----------------------------------------------------------------------
! IF THE CFL CRITERION IS VIOLATED THEN VERTICALLY SMOOTH THE TENDENCIES
!-----------------------------------------------------------------------
!
!$omp parallel do private (LSTART, LSTOP, VAD_TNDX1, VAD_TNDX2)
!
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
!----------         
! COMPONENT
!----------        
            IF (LTOP_CFL_U(I,J) > 0) THEN
                LSTART =     LTOP_CFL_U(I,J)
                LSTOP  = MIN(LBOT_CFL_U(I,J), LM-1)
!
                DO K=LSTART,LSTOP
                    VAD_TNDX1(K) = (VAD_TEND1(I,J,K-1)  + VAD_TEND1(I,J,K+1) + 2.                 &
    &                            *  VAD_TEND1(I,J,K  )) * 0.25
                END DO
!
                DO K=LSTART,LSTOP
                    VAD_TEND1(I,J,K) = VAD_TNDX1(K)
                END DO
!
            END IF
!------------        
! V COMPONENT
!------------         
            IF (LTOP_CFL_V(I,J) > 0) THEN
                LSTART =     LTOP_CFL_V(I,J)
                LSTOP  = MIN(LBOT_CFL_V(I,J),LM-1)
!
                DO K=LSTART,LSTOP
                    VAD_TNDX2(K) = (VAD_TEND2(I,J,K-1)  + VAD_TEND2(I,J,K+1) + 2.                 &
    &                            *  VAD_TEND2(I,J,K  )) * 0.25
                END DO
                DO K=LSTART,LSTOP
                    VAD_TEND2(I,J,K) = VAD_TNDX2(K)
                END DO
!
            END IF
!        
        END DO
    END DO
!
    DO 580 K=1,LM
!
!$omp parallel do
! 
        DO 580 J=MYJS2,MYJE2
            DO 580 I=MYIS,MYIE
                U(I,J,K) = U(I,J,K) + VAD_TEND1(I,J,K)
                V(I,J,K) = V(I,J,K) + VAD_TEND2(I,J,K)
    580 END DO
!
    IF (.NOT. HYDRO) THEN
!
!$omp parallel do 
!
        DO K=1,LM1
            DO J=MYJS_P1,MYJE_P1
                DO I=MYIS_P1,MYIE_P1
                    ETADT(I,J,K) = ETADT(I,J,K) / PDSL(I,J)
                END DO
            END DO
        END DO
!
    END IF
!
    RETURN
!
    END SUBROUTINE VTADV

    MODULE SCRTCH
!>--------------------------------------------------------------------------------------------------
!> MODULE SCRTCH
!>
!> USE MODULES: F77KINDS
!>              RDPARM
!>
!> DRIVER     : TABLE
!>--------------------------------------------------------------------------------------------------
!
!--------------------------------------------------------------------------------------------------
! MODULE TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE TABLE FOR USE IN THE LONGWAVE     
! RADIATION PROGRAM:
! EM1     -  E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! EM1WDE  -  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL
! TABLE1  -  E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! TABLE2  -  TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3  -  MASS DERIVATIVE OF TABLE1
! EM3     -  E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! SOURCE  -  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS
! DSRCE   -  TEMPERATURE DERIVATIVE OF SOURCE
! IND     -  INDEX, WITH VALUE IND(I) = I. USED IN FST88
! INDX2   -  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88
! KMAXV   -  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI,ETC., IN FST88
! KMAXVM  -  KMAXV(L), USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : NBLX, NBLW
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(28,180)                                                     ::&
    & SUM     , PERTSM  , SUM3    , SUMWDE
!
    REAL   (KIND=R4KIND), DIMENSION(28,NBLX)                                                    ::&
    & SRCWD
!
    REAL   (KIND=R4KIND), DIMENSION(28,NBLW)                                                    ::&
    & SRC1NB  , DBDTNB
!
    REAL   (KIND=R4KIND), DIMENSION(181)                                                        ::&
    & ZMASS   , ZROOT
!
    REAL   (KIND=R4KIND), DIMENSION(28)                                                         ::&
    & SC      , DSC     , XTEMV   , TFOUR   , FORTCU  , X       , X1      ,                       &
    & SRCS    , SUM4    , SUM6    , SUM7    , SUM8    , SUM4WD  , R1      ,                       &
    & R2      , S2      , T3      , R1WD
!
    REAL   (KIND=R4KIND), DIMENSION(180)                                                        ::&
    & X2      , EXPO    , FAC
!
    REAL   (KIND=R4KIND), DIMENSION(30)                                                         ::&
    & CNUSB   , DNUSB
!
    REAL   (KIND=R4KIND), DIMENSION(NBLW)                                                       ::&
    & ALFANB  , AROTNB
!
    REAL   (KIND=R4KIND), DIMENSION(NBLW)                                                       ::&
    & ANB     , BNB     , CENTNB  , DELNB   , BETANB
!
    END MODULE SCRTCH

    SUBROUTINE QUILT
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE QUILT
!>
!> SUBROUTINE: QUILT - I/O SERVERS
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-20
!>
!> ABSTRACT:
!> I/O SERVERS
!>
!> PROGRAM HISTORY LOG:
!> 00-01-20  TUCCILLO - ORIGINATOR
!> 00-11-02  BLACK    - SLP FOR NEST BOUNDARIES
!> 00-12-12  BLACK    - RESTART CAPABILITY
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT FILES:  NONE
!>
!> OUTPUT FILES:  NONE
!>
!> USE MODULES: BUFFER
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARA
!>              PARMETA
!>              PARMSOIL
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : EBU
!>
!> CALLS      : COLLECT
!>              DECOAL
!>              GETENV
!>              MPI_ABORT
!>              MPI_BCAST
!>              MPI_FIRST
!>              MPI_RECV
!>              SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!-------------------------------------------------------------------------------------------------- 
!
!--------------------------------------------------------------------------------- 
! THIS CODE ASSUMES THAT NSOIL IS GE TO 4. IF THIS IS NOT TRUE,THE CODE WILL STOP. 
! THE EQUIVALENCING IS THE PROBLEM.
!--------------------------------------------------------------------------------- 
    USE BUFFER
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARA
    USE PARMETA
    USE PARMSOIL
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LB = 2 * IM + JM - 3
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                                     ::&
    & DUM1    , DUM2    , DUM3    , DUM4    , DUM5    , DUM6    , DUM7
!---------
! SM v100M
!---------
    REAL   (KIND=R4KIND), DIMENSION(IM, JM)                                                     ::&
    & DUM8    , DUM9    , DUM10   , DUM11
!---------
! SM v100M
!---------
    REAL   (KIND=R4KIND), DIMENSION(IM, JM, NSOIL)                                              ::&
    & DUMS
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & STATUS
!
    EQUIVALENCE (DUM1(1,1), DUMS(1,1,1))
    EQUIVALENCE (DUM2(1,1), DUMS(1,1,2))
    EQUIVALENCE (DUM3(1,1), DUMS(1,1,3))
    EQUIVALENCE (DUM4(1,1), DUMS(1,1,4))
!
    REAL   (KIND=R4KIND), DIMENSION(:,:), ALLOCATABLE                                           ::&
    & PDOMG   , RESOMG  , PD      , RES     , FIS     ,                                           &
    & RSWIN   , RSWOUT  , TG      , Z0      , AKMS    ,                                           &
    & CZEN    , AKHS    , THS     , QS      , TWBS    ,                                           &
    & QWBS    , HBOT    , CFRACL  , THZ0    , QZ0     ,                                           &
    & UZ0     , VZ0     , USTAR   , HTOP    , CFRACM  ,                                           &
    & SNO     , SI      , CLDEFI  , RF      , PSLP    ,                                           &
    & CUPPT   , CFRACH  , SOILTB  , SFCEXC  ,                                                     &
    & SMSTAV  , SMSTOT  , GRNFLX  , PCTSNO  ,                                                     &
    & RLWIN   , RADOT   , CZMEAN  , SIGT4   ,                                                     &
    & U00     , SR      ,   PREC  , ACPREC  , ACCLIQ  ,                                           &
    & CUPREC  , ACFRCV  , ACFRST  , SFCSHX  ,                                                     &
    & ACSNOW  , ACSNOM  , SSROFF  , BGROFF  ,                                                     &
    & SFCLHX  , SUBSHX  , SNOPCX  , SFCUVX  ,                                                     &
    & SFCEVP  , POTEVP  ,  ASWIN  , ASWOUT  ,                                                     &
    & ASWTOA  , ALWIN   , ALWOUT  , ALWTOA  ,                                                     &
!---------
! SM v100M
!---------
    & TH100   , Q100    , U100    , V100    ,                                                     &
!---------
! SM v100M
!---------
    & TH10    , Q10     , U10     , V10     , TSHLTR  ,                                           &
    & QSHLTR  , PSHLTR  , CMC     , POTFLX  ,                                                     &
    & TLMIN   , TLMAX   , RSWTOA  , RLWTOA  ,                                                     &
    & CNVBOT  , CNVTOP  , ALBEDO  ,                                                               &
!
    & SM      , HBM2 
    REAL   (KIND=R4KIND), DIMENSION(:), ALLOCATABLE                                             ::&
    & DETA
!
    REAL   (KIND=R4KIND), DIMENSION(2*LM)                                                       ::&
    & UL
!
    REAL   (KIND=R4KIND), DIMENSION(:,:,:), ALLOCATABLE                                         ::&
    & OMGALF  , T       , Q       , U       , V       , Q2      , TTND    , CWM     , TRAIN   ,   &
    & TCUCN   , RSWTT   , RLWTT   , SMC     , STC     , SH2O
!
    REAL   (KIND=R4KIND), DIMENSION(LB, 2)                                                      ::&
    & PDB
!
    REAL   (KIND=R4KIND), DIMENSION(LB, LM, 2)                                                  ::&
    & TB      , QB      , UB      , VB      , Q2B     , CWMB
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDAT
!
    INTEGER(KIND=I4KIND), DIMENSION(:,:), ALLOCATABLE                                           ::&
    & LC      , NCFRCV  , NCFRST
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUN     , FIRST   , HYDRO   , SIGMA
!
    CHARACTER(LEN= 56) :: RSTFIL1 , RSTFIL2 , ENVAR   , FINFIL
    CHARACTER(LEN=  8) :: RESTHR  , BLANK
    CHARACTER(LEN= 32) :: LABEL
    CHARACTER(LEN= 80) :: FNAME
    CHARACTER(LEN= 16) :: DONE 
!
    CHARACTER(LEN=200) :: SUBMIT !CHOU
    CHARACTER(LEN=200) :: CHMO
    CHARACTER(LEN= 88) :: LINE
    CHARACTER(LEN= 32) :: OUTJOB
!           
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LME     , OUTJ
!
    DATA LRSTRT1/21/, LRSTRT2/61/, NHB/12/, BLANK/'    '/
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF   , IST     , ISP     , RTC     , IST2    , ISP2    , ICUM
!
    REAL   (KIND=R4KIND), DIMENSION(999999)                                                     ::&
    & TSHDE
!
    REAL   (KIND=R4KIND), DIMENSION(LSM)                                                        ::&
    & SPL
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RESTRT  , SINGLRST, SUBPOST , NEST    , SPLINE
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LRSTRT1 , LRSTRT2 , NHB     , NMAP    , NPHS    , NCNVC   , NRADSH  , NRADLH  , NTDDMP  ,   &
    & LFCSTD  , IERR    , NFCST   , NBC     , LIST    , IDTAD   , IHOUR   , IER     , IXXX    ,   &
    & IPE     , IS      , IE      , JS      , JE      , LEN_CH  , IDUM    , IHRST   , NTSD    ,   &
    & L       , IOUT    , NSHDE   , NHEAT   , NPREC   , NRDSW   , NSRFC   , KPATH   , KRST    ,   &
    & ITAG    , LFINFIL , NRDLW  
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART  , TEND    , TCP     , TPREC   , THEAT   , TCLOD   , TRDSW   , TRDLW   , TSRFC   ,   &
    & DT      , ARDSW   , ARDLW   , ASRFC   , AVRAIN  , AVCNVC  , ACUTIM  , ARATIM  , APHTIM  ,   &
    & TPH0D   , TLM0D   , PT       
!-----------------
! DECLARE NAMELIST
!-----------------
    NAMELIST /FCSTDATA/                                                                           &
    & TSTART, TEND  , TCP  , RESTRT, SINGLRST, SUBPOST, NMAP , TSHDE, SPL, NPHS  , NCNVC , NRADSH,&
    & NRADLH, NTDDMP, TPREC, THEAT , TCLOD   , TRDSW  , TRDLW, TSRFC, NEST, HYDRO, SPLINE
!
    NAMELIST /POSTLIST/ CHMO
    NAMELIST /POSTLIST/ SUBMIT !CHOU
!
    CALL MPI_FIRST
!-----------------------------------------------------------
! READ NAMELIST FCSTDATA TO FIND OUT IF THIS IS A NESTED RUN
!-----------------------------------------------------------
    LFCSTD = 11
    OPEN(LFCSTD, FILE='FCSTDATA.meso', STATUS='OLD')
    READ(LFCSTD, FCSTDATA)
!
    IF (NSOIL < 4) THEN
        PRINT*, ' NSOIL IS LESS THAN 4. CHANGE THE EQUIVALENCES'
        PRINT*, ' STOPPING'
        CALL MPI_ABORT(MPI_COMM_WORLD, 1, IERR)
    END IF
!
    IF (ME == 0) THEN
        LME = .TRUE. 
    ELSE
        LME = .FALSE. 
    END IF
!------------------------------ 
! READ NHB FILE TO OBTAIN SIGMA
!------------------------------          
    OPEN(UNIT=NHB, FORM='UNFORMATTED', FILE='CNST.file')
    REWIND NHB
    READ(NHB) NFCST, NBC, LIST, DT, IDTAD, SIGMA
    PRINT*,'IN QUILT, SIGMA= ', SIGMA
    PRINT*,'IN QUILT, SIGMA= ', SIGMA
    PRINT*,'IN QUILT, SIGMA= ', SIGMA
!
    ALLOCATE   (PDOMG(IM,MY_JSD:MY_JED))
    ALLOCATE  (RESOMG(IM,MY_JSD:MY_JED))
    ALLOCATE  (OMGALF(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE      (PD(IM,MY_JSD:MY_JED))
    ALLOCATE     (RES(IM,MY_JSD:MY_JED))
    ALLOCATE     (FIS(IM,MY_JSD:MY_JED))
    ALLOCATE       (T(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE       (Q(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE       (U(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE       (V(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE      (Q2(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE    (TTND(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE     (CWM(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE   (TRAIN(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE   (TCUCN(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE   (RSWIN(IM,MY_JSD:MY_JED))
    ALLOCATE  (RSWOUT(IM,MY_JSD:MY_JED))
    ALLOCATE      (TG(IM,MY_JSD:MY_JED))
    ALLOCATE      (Z0(IM,MY_JSD:MY_JED))
    ALLOCATE    (AKMS(IM,MY_JSD:MY_JED))
    ALLOCATE    (CZEN(IM,MY_JSD:MY_JED))
    ALLOCATE    (AKHS(IM,MY_JSD:MY_JED))
    ALLOCATE     (THS(IM,MY_JSD:MY_JED))
    ALLOCATE      (QS(IM,MY_JSD:MY_JED))
    ALLOCATE    (TWBS(IM,MY_JSD:MY_JED))
    ALLOCATE    (QWBS(IM,MY_JSD:MY_JED))
    ALLOCATE    (HBOT(IM,MY_JSD:MY_JED))
    ALLOCATE  (CFRACL(IM,MY_JSD:MY_JED))
    ALLOCATE    (THZ0(IM,MY_JSD:MY_JED))
    ALLOCATE     (QZ0(IM,MY_JSD:MY_JED))
    ALLOCATE     (UZ0(IM,MY_JSD:MY_JED))
    ALLOCATE     (VZ0(IM,MY_JSD:MY_JED))
    ALLOCATE   (USTAR(IM,MY_JSD:MY_JED))
    ALLOCATE    (HTOP(IM,MY_JSD:MY_JED))
    ALLOCATE     (SNO(IM,MY_JSD:MY_JED))
    ALLOCATE      (SI(IM,MY_JSD:MY_JED))
    ALLOCATE  (CLDEFI(IM,MY_JSD:MY_JED))
    ALLOCATE      (RF(IM,MY_JSD:MY_JED))
    ALLOCATE    (PSLP(IM,MY_JSD:MY_JED))
    ALLOCATE   (CUPPT(IM,MY_JSD:MY_JED))
    ALLOCATE  (CFRACH(IM,MY_JSD:MY_JED))
    ALLOCATE  (CFRACM(IM,MY_JSD:MY_JED))
    ALLOCATE  (SOILTB(IM,MY_JSD:MY_JED))
    ALLOCATE  (SFCEXC(IM,MY_JSD:MY_JED))
    ALLOCATE  (SMSTAV(IM,MY_JSD:MY_JED))
    ALLOCATE  (SMSTOT(IM,MY_JSD:MY_JED))
    ALLOCATE  (GRNFLX(IM,MY_JSD:MY_JED))
    ALLOCATE  (PCTSNO(IM,MY_JSD:MY_JED))
    ALLOCATE   (RLWIN(IM,MY_JSD:MY_JED))
    ALLOCATE   (RADOT(IM,MY_JSD:MY_JED))
    ALLOCATE  (CZMEAN(IM,MY_JSD:MY_JED))
    ALLOCATE   (SIGT4(IM,MY_JSD:MY_JED))
    ALLOCATE     (U00(IM,MY_JSD:MY_JED))
    ALLOCATE      (LC(IM,MY_JSD:MY_JED))
    ALLOCATE      (SR(IM,MY_JSD:MY_JED))
    ALLOCATE    (PREC(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACPREC(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACCLIQ(IM,MY_JSD:MY_JED))
    ALLOCATE  (CUPREC(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACFRCV(IM,MY_JSD:MY_JED))
    ALLOCATE  (NCFRCV(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACFRST(IM,MY_JSD:MY_JED))
    ALLOCATE  (NCFRST(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACSNOW(IM,MY_JSD:MY_JED))
    ALLOCATE  (ACSNOM(IM,MY_JSD:MY_JED))
    ALLOCATE  (SSROFF(IM,MY_JSD:MY_JED))
    ALLOCATE  (BGROFF(IM,MY_JSD:MY_JED))
    ALLOCATE  (SFCSHX(IM,MY_JSD:MY_JED))
    ALLOCATE  (SFCLHX(IM,MY_JSD:MY_JED))
    ALLOCATE  (SUBSHX(IM,MY_JSD:MY_JED))
    ALLOCATE  (SNOPCX(IM,MY_JSD:MY_JED))
    ALLOCATE  (SFCUVX(IM,MY_JSD:MY_JED))
    ALLOCATE  (SFCEVP(IM,MY_JSD:MY_JED))
    ALLOCATE  (POTEVP(IM,MY_JSD:MY_JED))
    ALLOCATE   (ASWIN(IM,MY_JSD:MY_JED))
    ALLOCATE  (ASWOUT(IM,MY_JSD:MY_JED))
    ALLOCATE  (ASWTOA(IM,MY_JSD:MY_JED))
    ALLOCATE   (ALWIN(IM,MY_JSD:MY_JED))
    ALLOCATE  (ALWOUT(IM,MY_JSD:MY_JED))
    ALLOCATE  (ALWTOA(IM,MY_JSD:MY_JED))
!---------
! SM v100M
!---------
    ALLOCATE   (TH100(IM,MY_JSD:MY_JED))
    ALLOCATE    (Q100(IM,MY_JSD:MY_JED))
    ALLOCATE    (U100(IM,MY_JSD:MY_JED))
    ALLOCATE    (V100(IM,MY_JSD:MY_JED))
!---------
! SM v100M
!---------
    ALLOCATE    (TH10(IM,MY_JSD:MY_JED))
    ALLOCATE     (Q10(IM,MY_JSD:MY_JED))
    ALLOCATE     (U10(IM,MY_JSD:MY_JED))
    ALLOCATE     (V10(IM,MY_JSD:MY_JED))
    ALLOCATE  (TSHLTR(IM,MY_JSD:MY_JED))
    ALLOCATE  (QSHLTR(IM,MY_JSD:MY_JED))
    ALLOCATE  (PSHLTR(IM,MY_JSD:MY_JED))
    ALLOCATE     (SMC(IM,MY_JSD:MY_JED,1:NSOIL))
    ALLOCATE     (CMC(IM,MY_JSD:MY_JED))
    ALLOCATE     (STC(IM,MY_JSD:MY_JED,1:NSOIL))
    ALLOCATE    (SH2O(IM,MY_JSD:MY_JED,1:NSOIL))
    ALLOCATE  (ALBEDO(IM,MY_JSD:MY_JED))
    ALLOCATE  (POTFLX(IM,MY_JSD:MY_JED))
    ALLOCATE   (TLMIN(IM,MY_JSD:MY_JED))
    ALLOCATE   (TLMAX(IM,MY_JSD:MY_JED))
    ALLOCATE   (RSWTT(IM,MY_JSD:MY_JED,1:LM))
    ALLOCATE   (RLWTT(IM,MY_JSD:MY_JED,1:LM))
!
    ALLOCATE (CNVBOT(MY_ISD:MY_IED,MY_JSD:MY_JED))
    ALLOCATE (CNVTOP(MY_ISD:MY_IED,MY_JSD:MY_JED))
    ALLOCATE (RSWTOA(MY_ISD:MY_IED,MY_JSD:MY_JED))
    ALLOCATE (RLWTOA(MY_ISD:MY_IED,MY_JSD:MY_JED))
!
    ALLOCATE (HBM2(IM,MY_JSD:MY_JED))
    ALLOCATE   (SM(IM,MY_JSD:MY_JED))
!
    ALLOCATE (DETA(1:LM))
!------------------------------- 
! LOOP OVER ALL THE OUTPUT TIMES
!-------------------------------
    666 CONTINUE
!
    IF (ME == 0) THEN
        CALL MPI_RECV(IHOUR, 1, MPI_INTEGER, 0, 0, MPI_COMM_INTER, STATUS, IER)
        PRINT*,' IHOUR IN QUILT = ', IHOUR
    END IF
!
    CALL MPI_BCAST(IHOUR, 1, MPI_INTEGER, 0, MPI_COMM_COMP, IER)
!
    IF (IHOUR == -999) GOTO 667
!
    DO 200 IXXX=1,JEND(ME)-JSTA(ME)+1
!--------------------------------------------------------------------- 
! RECEIVE ALL THE DATA FROM CHKOUT FROM THE APPROPRIATE FORECAST TASKS
!---------------------------------------------------------------------
        IST = TIMEF()
!
        CALL MPI_RECV(BUF, IBUFMAX, MPI_REAL, MPI_ANY_SOURCE, IHOUR, MPI_COMM_INTER, STATUS, IER)
!
        IPE = STATUS(MPI_SOURCE)
!    
        IF (IER /= 0) THEN
            PRINT*,' ERROR FROM MPI_REC = ', IER
        END IF
!
        IS = MY_IS_GLB_A(IPE)
        IE = MY_IE_GLB_A(IPE)
        JS = MY_JS_GLB_A(IPE)
        JE = MY_JE_GLB_A(IPE)
!
        LEN_CH = (IE - IS + 1) * (JE - JS + 1)
!-----------------------------------------------------------------------     
! EXTRACT RECORD LENGTH - LETS KEEP THIS BECAUSE IT IS POTENTIALLY HANDY
!----------------------------------------------------------------------- 
        CALL DECOAL(IDUM               , -1    )   
        CALL DECOAL(RUN                ,  1    )
        CALL DECOAL(IDAT               ,  3    )
        CALL DECOAL(IHRST              ,  1    )
        CALL DECOAL(NTSD               ,  1    )
        CALL DECOAL(LABEL              ,  8    )
        CALL DECOAL( PDOMG(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(RESOMG(IS:IE,JS:JE), LEN_CH)
!    
        DO L=1,LM
            CALL DECOAL(OMGALF(IS:IE,JS:JE,L), LEN_CH)
        END DO
!    
        CALL DECOAL(RUN             , 1      )
        CALL DECOAL(IDAT            , 3      )
        CALL DECOAL(IHRST           , 1      )
        CALL DECOAL(NTSD            , 1      )
        CALL DECOAL(LABEL           , 8      )
        CALL DECOAL(FIRST           , 1      )
        CALL DECOAL(IOUT            , 1      )
        CALL DECOAL(NSHDE           , 1      )
        CALL DECOAL(PD(IS:IE,JS:JE) , LEN_CH )
        CALL DECOAL(RES(IS:IE,JS:JE), LEN_CH )
        CALL DECOAL(FIS(IS:IE,JS:JE), LEN_CH )
        CALL DECOAL(PDB             , LB*2   )
        CALL DECOAL(TB              , LB*LM*2)
        CALL DECOAL(QB              , LB*LM*2)
        CALL DECOAL(UB              , LB*LM*2)
        CALL DECOAL(VB              , LB*LM*2)
        CALL DECOAL(Q2B             , LB*LM*2)
        CALL DECOAL(CWMB            , LB*LM*2)
!    
        DO L=1,LM
            CALL DECOAL(    T(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(    Q(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(    U(IS:IE,JS:JE,l), LEN_CH)
            CALL DECOAL(    V(IS:IE,JS:JE,l), LEN_CH)
            CALL DECOAL(   Q2(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL( TTND(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(  CWM(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(TRAIN(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(TCUCN(IS:IE,JS:JE,L), LEN_CH)
        END DO
!    
        CALL DECOAL(RUN                , 1     )
        CALL DECOAL(IDAT               , 3     )
        CALL DECOAL(IHRST              , 1     )
        CALL DECOAL(NTSD               , 1     )
        CALL DECOAL(LABEL              , 8     )
        CALL DECOAL( RSWIN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(RSWOUT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    TG(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    Z0(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  AKMS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  CZEN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  AKHS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   THS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    QS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  TWBS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  QWBS(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  HBOT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CFRACL(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  THZ0(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   QZ0(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   UZ0(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   VZ0(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( USTAR(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  HTOP(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CFRACM(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   SNO(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    SI(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CLDEFI(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    RF(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  PSLP(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( CUPPT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CFRACH(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SOILTB(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SFCEXC(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SMSTAV(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SMSTOT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(GRNFLX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(PCTSNO(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( RLWIN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( RADOT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CZMEAN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( SIGT4(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   U00(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(UL                 , 2*LM  )
        CALL DECOAL(    LC(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(    SR(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(RUN                , 1     )
        CALL DECOAL(IDAT               , 3     )
        CALL DECOAL(IHRST              , 1     )
        CALL DECOAL(NTSD               , 1     )
        CALL DECOAL(LABEL              , 8     )
        CALL DECOAL(  PREC(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACPREC(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACCLIQ(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CUPREC(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACFRCV(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(NCFRCV(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACFRST(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(NCFRST(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACSNOW(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ACSNOM(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SSROFF(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(bgroff(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SFCSHX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SFCLHX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SUBSHX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SNOPCX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SFCUVX(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(SFCEVP(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(POTEVP(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( ASWIN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ASWOUT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ASWTOA(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( ALWIN(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ALWOUT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ALWTOA(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(ARDSW              , 1     )
        CALL DECOAL(ARDLW              , 1     )
        CALL DECOAL(ASRFC              , 1     )
        CALL DECOAL(AVRAIN             , 1     )
        CALL DECOAL(AVCNVC             , 1     )
        CALL DECOAL(  TH10(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   Q10(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   U10(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(   V10(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(TSHLTR(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(QSHLTR(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(PSHLTR(IS:IE,JS:JE), LEN_CH)
!---------
! SM v100 M
!---------
        CALL DECOAL( TH100(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  Q100(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  U100(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  V100(IS:IE,JS:JE), LEN_CH)
!---------
! SM v100M
!---------
        CALL DECOAL(    SMC(IS:IE,JS:JE,1:NSOIL), LEN_CH*NSOIL)
        CALL DECOAL(    CMC(IS:IE,JS:JE)        , LEN_CH)
        CALL DECOAL(    STC(IS:IE,JS:JE,1:NSOIL), LEN_CH*NSOIL)
        CALL DECOAL(   SH2O(IS:IE,JS:JE,1:NSOIL), LEN_CH*NSOIL)
        CALL DECOAL( ALBEDO(IS:IE,JS:JE)        , LEN_CH)
        CALL DECOAL( POTFLX(IS:IE,JS:JE)        , LEN_CH)
        CALL DECOAL(  TLMIN(IS:IE,JS:JE)        , LEN_CH)
        CALL DECOAL(  TLMAX(IS:IE,JS:JE)        , LEN_CH)
!
        CALL DECOAL(ACUTIM,1)
        CALL DECOAL(ARATIM,1)
        CALL DECOAL(APHTIM,1)
        CALL DECOAL(NHEAT ,1)
        CALL DECOAL(NPHS  ,1)
        CALL DECOAL(NCNVC ,1)
        CALL DECOAL(NPREC ,1)
        CALL DECOAL(NRDSW ,1)
        CALL DECOAL(NRDLW ,1)
        CALL DECOAL(NSRFC ,1)
        CALL DECOAL(TPH0D ,1)
        CALL DECOAL(TLM0D ,1)
        CALL DECOAL(RESTRT,1)
!    
        DO L=1,LM
            CALL DECOAL(RSWTT(IS:IE,JS:JE,L), LEN_CH)
            CALL DECOAL(RLWTT(IS:IE,JS:JE,L), LEN_CH)
        END DO
!    
        CALL DECOAL(CNVBOT(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(CNVTOP(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(RSWTOA(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(RLWTOA(IS:IE,JS:JE), LEN_CH)
!-----------------------
! ADDED FOR SLPSIG STUFF
!-----------------------
        CALL DECOAL(HBM2(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL(  SM(IS:IE,JS:JE), LEN_CH)
        CALL DECOAL( SPL(1:LSM), LSM)
        CALL DECOAL(DETA(1:LM) , LM)
        CALL DECOAL(PT         , 1)
        CALL DECOAL(SPLINE     , 1)
        WRITE(6,*) 'DECOALED IN QUILT THAT SPLINE= ', SPLINE
!
200 END DO
!-----------------------------------------------------
! BEFORE WRITING OUT THE RESTRT FILE, COMPUTE THE MSLP
!-----------------------------------------------------
    IF (SIGMA) THEN
        IF (SPLINE) THEN
            PRINT*,'CALLING SLPSIGSPLINE'
            CALL SLPSIGSPLINE(PD, FIS, T, Q, SPL, LSM, DETA, PT, PSLP)
        ELSE
            PRINT*,'CALLING SLPSIG'
            CALL SLPSIG(PD, FIS, SM, T, Q, CWM, HBM2, U00, SPL, LSM, UL, DETA, PT, PSLP)
        END IF
    ELSE
        PRINT*,'CALLING SLP'
!
        CALL SLP(NHB, PD, RES, FIS, T, Q, NTSD, NEST, PSLP)
!
    END IF
!---------------------------------- 
! WRITE OUT THE GLOBAL RESTRT FILE.
!---------------------------------- 
!
!--------------------------------------------------- 
! GENERATE THE NAME OF THE GLOBAL OUTPUT RESTRT FILE
!--------------------------------------------------- 
    ENVAR = ' '
    CALL GETENV("RSTFNL", ENVAR)
    CALL GETENV("TMMARK", RESTHR)
    RESTHR='T00S'
    KPATH = INDEX(ENVAR,' ') -1
!
    IF (KPATH <= 0) KPATH = LEN(ENVAR)

    IF (RESTHR == '    ') THEN
        WRITE(RSTFIL2,280) IHOUR
        280 FORMAT('RESTRT', I6.6)
    ELSE
        WRITE(RSTFIL2,285) IHOUR, RESTHR
        285 FORMAT('RESTRT',I6.6,'.',A4)
    END IF
!
    KRST = INDEX(RSTFIL2,' ') -1
    IF (KRST <= 0) KRST = LEN(RSTFIL2)
!------------------------------------- 
! OPEN UNIT TO THE GLOBAL RESTART FILE
!------------------------------------- 
    CLOSE(LRSTRT2)
!
    IF (ENVAR(1:4) == BLANK) THEN
        OPEN(UNIT=LRSTRT2, FILE=RSTFIL2, FORM='UNFORMATTED', IOSTAT=IER)
    ELSE
        FNAME = ENVAR(1:KPATH) // RSTFIL2(1:KRST)
        OPEN(UNIT=LRSTRT2, FILE=FNAME, FORM='UNFORMATTED', IOSTAT=IER)
    END IF
!
    IF (LME) WRITE(LRSTRT2) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR
!
    CALL COLLECT(PDOMG , DUM1)
    CALL COLLECT(RESOMG, DUM2)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2
!
    DO L=1,LM
        CALL COLLECT(OMGALF(:,:,L), DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
    END DO
!
    IF (LME) WRITE(LRSTRT2) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR, FIRST, IOUT, NSHDE
!
    CALL COLLECT(PD ,DUM1)
    CALL COLLECT(RES,DUM2)
    CALL COLLECT(FIS,DUM3)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3
    IF (LME) WRITE(LRSTRT2) PDB , TB  , QB  , UB, VB, Q2B, CWMB
!
    DO L=1,LM
        CALL COLLECT     (T(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT     (Q(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT     (U(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT     (V(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT    (Q2(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT  (TTND(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT   (CWM(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT (TRAIN(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
        CALL COLLECT (TCUCN(:,:,L),DUM1)
        IF (LME) WRITE(LRSTRT2) DUM1
    END DO
!
    CALL COLLECT(RSWIN , DUM1)
    CALL COLLECT(RSWOUT, DUM2)
    CALL COLLECT(TG    , DUM3)
    CALL COLLECT(Z0    , DUM4)
    CALL COLLECT(AKMS  , DUM5)
    CALL COLLECT(CZEN  , DUM6)
!
    IF (LME) WRITE(LRSTRT2) RUN , IDAT, IHRST, NTSD, LABEL, IHOUR,                                 &
    &                       DUM1, DUM2, DUM3 , DUM4, DUM5 , DUM6
!
    CALL COLLECT(AKHS  ,DUM1)
    CALL COLLECT(THS   ,DUM2)
    CALL COLLECT(QS    ,DUM3)
    CALL COLLECT(TWBS  ,DUM4)
    CALL COLLECT(QWBS  ,DUM5)
    CALL COLLECT(HBOT  ,DUM6)
    CALL COLLECT(CFRACL,DUM7)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, DUM7
!
    CALL COLLECT(THZ0  ,DUM1)
    CALL COLLECT(QZ0   ,DUM2)
    CALL COLLECT(UZ0   ,DUM3)
    CALL COLLECT(VZ0   ,DUM4)
    CALL COLLECT(USTAR ,DUM5)
    CALL COLLECT(HTOP  ,DUM6)
    CALL COLLECT(CFRACM,DUM7)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, DUM7
!
    CALL COLLECT(SNO   ,DUM1)
    CALL COLLECT(SI    ,DUM2)
    CALL COLLECT(CLDEFI,DUM3)
    CALL COLLECT(RF    ,DUM4)
    CALL COLLECT(PSLP  ,DUM5)
    CALL COLLECT(CUPPT ,DUM6)
    CALL COLLECT(CFRACH,DUM7)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, DUM7
!
    CALL COLLECT(SOILTB,DUM1)
    CALL COLLECT(SFCEXC,DUM2)
    CALL COLLECT(SMSTAV,DUM3)
    CALL COLLECT(SMSTOT,DUM4)
    CALL COLLECT(GRNFLX,DUM5)
    CALL COLLECT(PCTSNO,DUM6)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6
!
    CALL COLLECT(RLWIN ,DUM1)
    CALL COLLECT(RADOT ,DUM2)
    CALL COLLECT(CZMEAN,DUM3)
    CALL COLLECT(SIGT4 ,DUM4)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4
!
    CALL COLLECT(U00,DUM1)
    CALL COLLECT(LC ,DUM2)
    CALL COLLECT(SR ,DUM3)
!
    IF (LME) WRITE(LRSTRT2) DUM1, UL, DUM2, DUM3
!
    CALL COLLECT(PREC  ,DUM1)
    CALL COLLECT(ACPREC,DUM2)
    CALL COLLECT(ACCLIQ,DUM3)
    CALL COLLECT(CUPREC,DUM4)
!
    IF (LME) WRITE(LRSTRT2) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR, DUM1, DUM2, DUM3, DUM4
!
    CALL COLLECT(ACFRCV,DUM1)
    CALL COLLECT(NCFRCV,DUM2)
    CALL COLLECT(ACFRST,DUM3)
    CALL COLLECT(NCFRST,DUM4)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4
!
    CALL COLLECT(ACSNOW,DUM1)
    CALL COLLECT(ACSNOM,DUM2)
    CALL COLLECT(SSROFF,DUM3)
    CALL COLLECT(BGROFF,DUM4)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4
!
    CALL COLLECT(SFCSHX,DUM1)
    CALL COLLECT(SFCLHX,DUM2)
    CALL COLLECT(SUBSHX,DUM3)
    CALL COLLECT(SNOPCX,DUM4)
    CALL COLLECT(SFCUVX,DUM5)
    CALL COLLECT(SFCEVP,DUM6)
    CALL COLLECT(POTEVP,DUM7)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, DUM7
!
    CALL COLLECT(ASWIN ,DUM1)
    CALL COLLECT(ASWOUT,DUM2)
    CALL COLLECT(ASWTOA,DUM3)
    CALL COLLECT(ALWIN ,DUM4)
    CALL COLLECT(ALWOUT,DUM5)
    CALL COLLECT(ALWTOA,DUM6)
!
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6
!
    IF (LME) WRITE(LRSTRT2) ARDSW, ARDLW, ASRFC, AVRAIN, AVCNVC
!
    CALL COLLECT(TH10  ,DUM1)
    CALL COLLECT(Q10   ,DUM2)
    CALL COLLECT(U10   ,DUM3)
    CALL COLLECT(V10   ,DUM4)
    CALL COLLECT(TSHLTR,DUM5)
    CALL COLLECT(QSHLTR,DUM6)
    CALL COLLECT(PSHLTR,DUM7)
!---------
! SM V100M
!---------
    CALL COLLECT(TH100,DUM8 )
    CALL COLLECT(Q100 ,DUM9 )
    CALL COLLECT(U100 ,DUM10)
    CALL COLLECT(V100 ,DUM11)
!---------
! SM V100M
!---------          
    IF (LME) WRITE(LRSTRT2) DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, DUM7, DUM8, DUM9, DUM10, DUM11
!---------
! SM V100M
!---------   
    DO L=1,NSOIL
        CALL COLLECT(SMC(:,:,L), DUMS(:,:,L))
    END DO
!
    IF (LME) WRITE(LRSTRT2) DUMS
!
    CALL COLLECT(CMC, DUM1)
!
    IF (LME) WRITE(LRSTRT2) DUM1
!
    DO L=1,NSOIL
        CALL COLLECT(STC(:,:,L), DUMS(:,:,L))
    END DO
!
    IF (LME) WRITE(LRSTRT2) DUMS
!
    DO L=1,NSOIL
        CALL COLLECT(SH2O(:,:,L), DUMS(:,:,L))
    END DO
!
    IF (LME) WRITE(LRSTRT2) DUMS
!
    CALL COLLECT(ALBEDO, DUM1)
!
    IF (LME) WRITE(LRSTRT2) DUM1
!
    CALL COLLECT(POTFLX,DUM1)
    CALL COLLECT(TLMIN ,DUM2)
    CALL COLLECT(TLMAX ,DUM3)
!
    IF (LME) WRITE(LRSTRT2) DUM1 , DUM2 , DUM3 , ACUTIM, ARATIM, APHTIM, NHEAT , NPHS, NCNVC,     &
    &                       NPREC, NRDSW, NRDLW, NSRFC , TPH0D , TLM0D , RESTRT
!
    DO L=1,LM
        CALL COLLECT(RSWTT(:,:,L), DUM1)
!
        IF (LME) WRITE(LRSTRT2)    DUM1
!
        CALL COLLECT(RLWTT(:,:,L), DUM1)
!
        IF (LME) WRITE(LRSTRT2)    DUM1
    END DO
!
    CALL COLLECT(CNVBOT(:,:), DUM1)
!
    IF (LME) WRITE(LRSTRT2)   DUM1
!
    CALL COLLECT(CNVTOP(:,:), DUM1)
!
    IF (LME) WRITE(LRSTRT2)   DUM1
!
    CALL COLLECT(RSWTOA(:,:), DUM1)
!
    IF (LME) WRITE(LRSTRT2)   DUM1
!
    CALL COLLECT(RLWTOA(:,:), DUM1)
!
    IF (LME) WRITE(LRSTRT2)   DUM1
!
    CLOSE(LRSTRT2)

!----------------------------------------------------------------------------------
! SM - ALTERA\E7\E3O FEITA PARA O IO - PARA N\E3O MAIS ESCREVER O OUTJOB E FCSTDONE
!----------------------------------------------------------------------------------          
    OUTJ = .TRUE. 
!
    IF (OUTJ) THEN
!              
        IF (LME) THEN
            DONE = 'DONE'
            ITAG = IHOUR
!
            WRITE(FINFIL,1190) ITAG, RESTHR
!
            1190 FORMAT('FCSTDONE',I6.6,'.',A4)
            LFINFIL = 91
            CLOSE(LFINFIL)
!
            OPEN(UNIT=LFINFIL, FILE=FINFIL, FORM='UNFORMATTED', IOSTAT=IER)
            WRITE(LFINFIL) DONE
            CLOSE(LFINFIL)
!
            IF (IER /= 0) WRITE(LIST,*)' SIGNAL SENT TO FINFIL:  DONE'
        END IF
    END IF
!
    GOTO 666
    667 CONTINUE
!
    PRINT*,' QUILT I/O SERVER SHUTTING DOWN NOW'
    END SUBROUTINE QUILT
!
!
    SUBROUTINE DECOAL(A, LEN_CH)
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE BUFFER
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & A(*)
!
    IF (LEN_CH < 0) THEN
        IP = 0
    END IF
!
    DO I=1,ABS(LEN_CH)
        IP   = IP + 1
        A(I) = BUF(IP)
    END DO
!
    END SUBROUTINE DECOAL

    MODULE CTLBLK
!>--------------------------------------------------------------------------------------------------
!> MODULE CTLBLK
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>              RDPARM
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLTEND
!>              CUCNVC
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              EBU
!>              EPS
!>              GSCOND
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDNEW
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              SOLARD
!>              SURFCE
!>              TURBL
!>              VADZ
!>              VTADV
!>              VTADVF
!>              ZENITH
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
    USE RDPARM
!
    IMPLICIT NONE
!
    SAVE
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUN     , FIRST   , RESTRT  , SIGMA   , NEST    , SINGLRST, SUBPOST
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IHRST   , NFCST   , NBC     , LIST    , IOUT    , NTSD    , NTSTM   , NSTART  , NTDDMP  ,   &
    & NPREC   , IDTAD   , NBOCO   , NSHDE   , NCP     , NPHS    , NCNVC   , NRADS   , NRADL 
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDAT
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DT
! 
    END MODULE CTLBLK

    SUBROUTINE MPI_LAST
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE MPI_LAST
!>
!> SUBROUTINE: MPI_LAST - SHUTS DOWN MPI
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-20
!>
!> ABSTRACT:
!> SHUTS DOWN MPI
!>
!> PROGRAM HISTORY LOG:
!> 00-01-20  TUCCILLO - ORIGINATOR
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> EXIT STATES:
!> COND =   0 - NORMAL EXIT
!>
!> USE MODULES: -----
!>
!> DRIVER     : -----
!>
!> CALLS      : ----- 
!-------------------------------------------------------------------------------------------------- 
    IMPLICIT NONE
!
    CALL MPI_FINALIZE(IERR)
!
    END SUBROUTINE MPI_LAST

    MODULE GLB_TABLE
!>--------------------------------------------------------------------------------------------------
!> MODULE GLB_TABLE 
!>
!> ABSTRACT:
!> IT WAS CREATED FROM MPP.h
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLO89
!>              CLTEND
!>              COLLECT
!>              CONRAD
!>              CUCNVC
!>              DDAMP
!>              DIFCOF
!>              DIGFLT
!>              DIST
!>              DIVHOA
!>              DIVHOAST 
!>              DSTRB
!>              E1E290
!>              E290
!>              E2SPEC
!>              E3V88
!>              EBU
!>              EPS
!>              FILT25
!>              FST88
!>              GOSSIP
!>              GSCOND
!>              GSMCOLUMN
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              IDSTRB
!>              INIT
!>              INITS
!>              LOC2GLB
!>              LWR88
!>              MIXLEN
!>              MODULE_EXCHM
!>              MPI_FIRST
!>              MPPINIT
!>              NEWFLT
!>              OZON2D
!>              PDNEW
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              QUILT
!>              RADFS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SFCDIF
!>              SFCDIF_BHS
!>              SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!>              SPA88
!>              SURFCE
!>              SWR93
!>              TABLE
!>              TTBLEX
!>              TURBL
!>              TWR
!>              UPDATE
!>              VADZ
!>              VDIFH
!>              VDIFV
!>              VTADV
!>              VTADVF
!>              VWR
!>              ZENITH
!>              ZERO2
!>              ZERO3
!>              ZERO3_T      
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : INPES, JNPES
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND), DIMENSION(0:INPES*JNPES)                                              ::&
    & IS_GLB_TABLE      , IE_GLB_TABLE      ,                                                     &
    & JS_GLB_TABLE      , JE_GLB_TABLE
!
    END MODULE GLB_TABLE 

    SUBROUTINE CHKOUT
!>-------------------------------------------------------------------------------------------------- 
!> SUBROUTINE CHKOUT
!>
!> SUBPROGRAM: CHKOUT - POSTS PROFILES AND OUTPUT POST DATA
!> PROGRAMMER: TREADON
!> ORG: W/NP2
!> DATE: 93-02-26
!
!> ABSTRACT: 
!> THIS ROUTINE POSTS PROFILE DATA AND WRITES COMMON BLOCKS TO TEMPORARY FILE FOR USE BY THE POST
!> PROCESSOR.
!> OPTIONALLY, IF RUN UNDER PSHELL THIS ROUTINE WILL SUBMIT POST JOBS AS THE MODEL RUNS.
!> THIS ROUTINE REPLACES ETA MODEL SUBROUTINE OUTMAP.
!>
!> PROGRAM HISTORY LOG:
!> 93-02-26  RUSS TREADON
!> 93-08-30  RUSS TREADON - ADDED DOCBLOC AND DIAGNOSTIC PROFILES
!> 95-03-31  T BLACK      - CONVERTED FROM 1-D TO 2-D IN HORIZONTAL
!> 95-07-31  MIKE BALDWIN - REMOVED SOUNDING DIAGNOSTICS AND BUFR
!> 96-03-13  F MESINGER   - IMPROVED REDUCTION TO SEA LEVEL (TO ACHIEVE EXACT CONSISTENCY WITH THE
!>                          MODELS HYDROSTATIC EQUATION NEXT TO MOUNTAIN SIDES)
!> 96-04-12  MIKE BALDWIN - MODIFIED SOUNDING OUTPUT
!> 96-10-31  T BLACK      - MODIFICATIONS FOR GENERATIONS OF NESTS BCS
!> 98-11-17  T BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 99-05-03  T BLACK      - SLP REDUCTION, BCEX, AND PROFILES REMOVED. EACH PE WRITES ITS OWN 
!>                          MINI-RESTRT FILE
!> 00-08-01  JIM TUCCILLO - QUILT SERVER CAPABILITY ADDED
!> 00-10-11  T BLACK      - MODIFICATIONS FOR RESTART CAPABILITY
!> 18-01-15  LUCCI        - MODERNIZATION OF THE CODE, INCLUDING:
!>                          * F77 TO F90/F95
!>                          * INDENTATION & UNIFORMIZATION CODE
!>                          * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                          * DOCUMENTATION WITH DOXYGEN
!>                          * OPENMP FUNCTIONALITY
!>
!> INPUT  ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: ACMCLD
!>              ACMCLH
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              BUFFER
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              CUINIT
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              OUTFIL
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PRFHLD
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TEMPV
!>              TIMCHK
!>              TIMMING
!>              VRBLS
!>
!> DRIVER     : EBU
!>
!> CALLS      : MPI_BARRIER
!>              MPI_COAL
!>              MPI_REDUCE
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE BUFFER
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE CUINIT
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE OUTFIL
    USE PARMETA
    USE PARM_TBL
    USE PHYS
    USE PRFHLD
    USE PVRBLS
    USE SOIL
    USE TEMPCOM
    USE TEMPV
    USE TIMCHK
    USE TIMMING
    USE VRBLS
    USE TOPO
!
    IMPLICIT NONE
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER  :: IMJM  = IM * JM - JM / 2 
    INTEGER(KIND=I4KIND), PARAMETER  :: IMT   = 2  * IM - 1
    INTEGER(KIND=I4KIND), PARAMETER  :: JMT   = JM / 2  + 1
    INTEGER(KIND=I4KIND), PARAMETER  :: NRLX1 = 250
    INTEGER(KIND=I4KIND), PARAMETER  :: NRLX2 = 100
!
    REAL   (KIND=R4KIND), PARAMETER  :: CAPA = 0.285896  
!------------------
! DECLARE VARIABLES
!------------------
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & OUTJ    , STDRD   , MESO    , ONHOUR  , EXBC    , MULTIWRITE
!
    CHARACTER(LEN=8)                                                                            ::&
    & FHR
!
    CHARACTER(LEN=24)                                                                           ::&
    & OUTJOB
!
    CHARACTER(LEN=16)                                                                           ::&
    & ASSIGN
!
    CHARACTER(LEN=8)                                                                            ::&
    & CITAG
!
    CHARACTER(LEN=8)                                                                            ::&
    & ASTMRK  , TMYY
!
    CHARACTER(LEN=200)                                                                          ::&
    & SUBMIT ! CHOU
!
    CHARACTER(LEN=200)                                                                          ::&
    & CHMO
!
    CHARACTER(LEN=32)                                                                           ::&
    & LABEL
!
    INTEGER(KIND=I4KIND), DIMENSION(4)                                                          ::&
    & LABINT
!
    CHARACTER(LEN=88)                                                                           ::&
    & LINE
!
    CHARACTER(LEN=8)    , DIMENSION(85)                                                         ::&
    & LINE1
!
    CHARACTER(LEN=8)                                                                            ::&
    & RESTHR
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & CHX
!
    EQUIVALENCE (LABEL, LABINT)
    EQUIVALENCE (LINE , LINE1 )
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PSLP    , PDS     , FACTR 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & SWTTC   , TTND
!
    INTEGER(KIND=I4KIND), DIMENSION(0:INPES*JNPES-1)                                            ::&
    & IKNTS   , IDISP
!
    REAL   (KIND=R4KIND), ALLOCATABLE, DIMENSION(:,:,:)                                         ::&
    & TEMPSOIL
!
    CHARACTER(LEN=48)                                                                           ::&
    & FINFIL
!
    CHARACTER(LEN=8)                                                                            ::&
    & DONE
!---------------------
! DECLARE EQUIVALENCES
!---------------------
    EQUIVALENCE (TTND(1,1,1), SWTTC(1,1,1))
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & JSTAT
!
    REAL   (KIND=R8KIND), DIMENSION(LM)                                                         ::&
    & SUMT    , SUMT_0  , SUMT2   , SUMT2_0
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & STDEV   , RMS     , TMEAN
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & TMAX    , TMAX_0  ,  TMIN   ,  TMIN_0
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & STRWAIT , ENDWAIT , RTC
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IHS
!
    DATA IHS /MPI_REQUEST_NULL/
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & STATUS
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ISERVE
!
    DATA ISERVE / 1 /
!------------------------------------------------
! THE FOLLOWING ARE USED FOR TIMIMG PURPOSES ONLY
!------------------------------------------------
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & MPP_TIM , INIT_TIM
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , NTSPH   , LLMH    , LMHK    , IHR     , JL      , JJ      , IIMAX   ,   &
    & IRTN    , ISTAT   , K       , IER     , N       , IPMAX   , IERR    , IBLOCK  , IRECLEN ,   &
    & ISTART  , IEND    , MYPE_ROW, LUNIN   , LUNOT   , IDX 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TLL1    , TERM1   , BTIM0   , BTIMW   , DUMMY   , DIF_TIM , WRT_TIM_0
!
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMES 
!
    NAMELIST /POSTLIST/ CHMO 
    NAMELIST /POSTLIST/ SUBMIT    !CHOU
!------------------
! START CHKOUT HERE
!------------------
!--------------------------------------------------------------------------------------------------
! ON FIRST ENTRY INITIALIZE THE OUTPUT FILE TAG TO ZERO AND DO PRELIMINARY PROFILE DATA ASSIGNMENTS
!--------------------------------------------------------------------------------------------------
    IF (NTSD == 1) THEN
        ITAG = 0
!    
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                LMHK = LMH(I,J)
                TLL1 = T(I,J,LMHK)
                TLMIN(I,J) = TLL1
                TLMAX(I,J) = TLL1
            END DO
        END DO
    END IF
!--------------------------------------
! UPDATE MAX AND MIN LOWEST LAYER TEMPS
!--------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            LMHK = LMH(I,J)
            TLL1 = T(I,J,LMHK)
            IF (TLL1 < TLMIN(I,J)) TLMIN(I,J) = TLL1
            IF (TLL1 > TLMAX(I,J)) TLMAX(I,J) = TLL1
        END DO
    END DO
!---------------------------------------------
! FIGURE OUT JUST WHERE IN THE FORECAST WE ARE
!---------------------------------------------
    NTSPH  = INT(3600. / DT + 0.50)
    TIMES  = (NTSD - 1) * DT
    ONHOUR = .FALSE. 
!
    IF ((MOD(TIMES,3600.) == 0.) .OR. (MOD(TIMES,3600.) > 3600.-DT)) ONHOUR = .TRUE. 
!--------------------------------------------------------------------------------------------------
! IF THE CURRENT FORECAST TIME IS A FULL HOUR OR EQUALS A FULL BLOWN POST TIME THEN WRITE THE FIELD
! IF NOT, EXIT THIS ROUTINE
!--------------------------------------------------------------------------------------------------
    IF ((NTSD == NSHDE) .OR. ONHOUR) GOTO 100
    IF (NSTART > 0 .AND. NSTART+1 == NSHDE .AND.NTSD-1 == NSHDE) GOTO 100
!--------------------------------------------------------------------------------------------------
! BEGIN: INITIALIZE CONVECTIVE CLOUD FIELDS FOR RADIATION BEFORE RETURNING TO EBU (FERR. 23 JAN 02)
!--------------------------------------------------------------------------------------------------
    IF (CURAD) THEN
        IF (MYPE == 0) THEN
            WRITE(0,"(a)") 'CHKOUT: INITIALIZE CUPPT,HTOP,HBOT'
            WRITE(6,"(a)") 'CHKOUT: INITIALIZE CUPPT,HTOP,HBOT'
        END IF
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                CUPPT(I,J) =   0.
                 HTOP(I,J) = 100.
                 HBOT(I,J) =   0.
            END DO
        END DO
!
        CURAD = .FALSE. 
!
    END IF
!
    RETURN
!-------------------------------------------------------------------------------------------
! IT IS TIME TO WRITE TO THE PROFILE FILE AND/OR WRITE TEMPORARY FILES FOR A FULL BLOWN POST
!-------------------------------------------------------------------------------------------
100 CONTINUE
!--------------------------------------------------
! (CHOU 21 JUN 09)
! PDS IS SURFACE PRESSURE
! TSHLTR HOLDS THE 2M THETA, CONVERT TO TEMPERATURE
! TERM1 IS 2m*G/(Rd*T)
!--------------------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            LLMH = LMH(I,J)
            PDS(I,J) = PD(I,J) + PT
            TERM1 = -0.068283 / T(I,J,LLMH)
            PSHLTR(I,J) = PDS(I,J) * EXP(TERM1)
            TSHLTR1(I,J) = TSHLTR(I,J) * (PSHLTR(I,J) * 1.E-5) ** CAPA
                  
            IF (CZMEAN(I,J) > 0.) THEN
                FACTR(I,J) = CZEN(I,J) / CZMEAN(I,J)
            ELSE
                FACTR(I,J) = 0.
            END IF
!
        END DO
    END DO
!-------------------------------------------------------------------------------         
! MAKE SURE POST DOES NOT BLOW UP WHEN COMPUTING RH ON THE GLOBAL N/S BOUNDARIES
!-------------------------------------------------------------------------------        
    IF (MYPE < INPES) THEN
        DO J=1,2
            DO I=MYIS,MYIE
                TSHLTR1(I,J) = TSHLTR1(I,3)
                 QSHLTR(I,J) =  QSHLTR(I,3)
            END DO
        END DO
    END IF
!       
    IF (MYPE >= NPES-INPES) THEN
        DO J=MYJE-1,MYJE
            DO I=MYIS,MYIE
                TSHLTR1(I,J) = TSHLTR1(I,MYJE-2)
                 QSHLTR(I,J) =  QSHLTR(I,MYJE-2)
            END DO
        END DO
    END IF
!         
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            TLMIN(I,J) = AMIN1(TSHLTR1(I,J), TLMIN(I,J))
            TLMAX(I,J) = AMAX1(TSHLTR1(I,J), TLMAX(I,J))
        END DO
    END DO
!------------------
! SET FORECAST HOUR
!------------------
    IHR = NTSD / TSPH + 0.5
!----------------------------------------------------------------------------------------------------------------------------------- 
! IF THIS IS NOT A FULL BLOWN OUTPUT TIME, SKIP THE RESTART FILE AND POST JOB WRITES AND GO TO SECTION WHERE ACCUMULATION ARRAYS
! ARE ZEROED OUT IF NECESSARY
!-----------------------------------------------------------------------------------------------------------------------------------
    IF (NTSD /= NSHDE .AND. NSTART+1 /= NSHDE) GOTO 1310
!-------------------------------
! COMPUTE TEMPERATURE STATISTICS
!-------------------------------
    BTIM0 = TIMEF()
!
    DO 900 JL=1,LM
!    
         TMAX(JL) = -1.E6
         TMIN(JL) =  1.E6
         SUMT(JL) =  0.
        SUMT2(JL) =  0.
!    
        JJ=0
        DO J=MY_JS_GLB,MY_JE_GLB
            JJ = JJ + 1
!
            IF (MOD(J+1,2) /= 0 .AND. MY_IE_GLB == IM) THEN
                IIMAX = MY_IE_LOC - 1
            ELSE
                IIMAX = MY_IE_LOC
            END IF
!
            DO I=MYIS,IIMAX
                 SUMT(JL) =  SUMT(JL) + T(I,JJ,JL)
                SUMT2(JL) = SUMT2(JL) + T(I,JJ,JL) ** 2
                 TMAX(JL) = AMAX1(TMAX(JL), T(I,JJ,JL))
                 TMIN(JL) = AMIN1(TMIN(JL), T(I,JJ,JL))
            END DO
        END DO
!
900 END DO
!-------------
! GLOBAL STATS
!-------------
    CALL MPI_REDUCE( SUMT,  SUMT_0, LM, MPI_REAL8, MPI_SUM, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_REDUCE(SUMT2, SUMT2_0, LM, MPI_REAL8, MPI_SUM, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_REDUCE( TMAX,  TMAX_0, LM, MPI_REAL , MPI_MAX, 0, MPI_COMM_COMP, IRTN)
    CALL MPI_REDUCE( TMIN,  TMIN_0, LM, MPI_REAL , MPI_MIN, 0, MPI_COMM_COMP, IRTN)
!
    IF (MYPE == 0) THEN
        DO JL=1,LM
            TMEAN = SUMT_0(JL) / DBLE(IMJM)
            STDEV = DSQRT((DBLE(IMJM)*SUMT2_0(JL)-SUMT_0(JL)**2) / DBLE(DBLE(IMJM)*(DBLE(IMJM-1))))
              RMS = DSQRT(SUMT2_0(JL) / DBLE(IMJM))
        END DO
    END IF
!
    STAT_TIM = STAT_TIM + TIMEF() - BTIM0
!----------------------------------------------------------------
! WE REACH THE CODE BELOW ONLY IF IT IS A FULL BLOWN POSTING TIME
! WRITE DATA REQUIRED TO RESTART THE MODEL/INITIALIZE THE POST
!----------------------------------------------------------------
    CALL MPI_BARRIER(MPI_COMM_COMP, ISTAT)
!--------------------------------------------------
! PDS IS SURFACE PRESSURE
! TSHLTR HOLDS THE 2M THETA, CONVERT TO TEMPERATURE
! TERM1 IS 2M*G/(RD*T)
!--------------------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            LLMH = LMH(I,J)
            PDS(I,J) = PD(I,J) + PT
            TERM1 = -0.068283 / T(I,J,LLMH)
            PSHLTR(I,J) = PDS(I,J) * EXP(TERM1)
            TSHLTR(I,J) = TSHLTR(I,J) * (PSHLTR(I,J) * 1.E-5) ** CAPA
!
            IF (CZMEAN(I,J) > 0.) THEN
                FACTR(I,J) = CZEN(I,J) / CZMEAN(I,J)
            ELSE
                FACTR(I,J) = 0.
            END IF
!        
        END DO
    END DO
!-------------------------------------------------------------------------------
! MAKE SURE POST DOES NOT BLOW UP WHEN COMPUTING RH ON THE GLOBAL N/S BOUNDARIES
!-------------------------------------------------------------------------------
    IF (MYPE < INPES) THEN
        DO J=1,2
            DO I=MYIS,MYIE
                TSHLTR(I,J) = TSHLTR(I,3)
                QSHLTR(I,J) = QSHLTR(I,3)
            END DO
        END DO
    END IF
!
    IF (MYPE >= NPES-INPES) THEN
        DO J=MYJE-1,MYJE
            DO I=MYIS,MYIE
                TSHLTR(I,J) = TSHLTR(I,MYJE-2)
                QSHLTR(I,J) = QSHLTR(I,MYJE-2)
            END DO
        END DO
    END IF
!----------------------------------------
! SWTTC IS THE CURRENT SW TEMP TENDENCIES
!----------------------------------------
!
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                SWTTC(I,J,K) = RSWTT(I,J,K) * FACTR(I,J)
            END DO
        END DO
    END DO
!----------------------------------------
! TTND IS THE CURRENT RAD TEMP TENDENCIES
!----------------------------------------
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                TTND(I,J,K) = RLWTT(I,J,K) + SWTTC(I,J,K)
            END DO
        END DO
    END DO
!-----------------------------
! CREATE NAME FOR RESTART FILE
!-----------------------------
    ITAG = NTSD / TSPH + 0.5
!
    CALL GETENV("TMMARK",RESTHR)
!
    IF (RESTHR == '    ') THEN
        WRITE(RSTFIL,1150) ITAG
        1150 FORMAT('RESTRT',I6.6,'.quilt')
    ELSE IF (RESTHR == 'TM00' .AND. IQUILT_GROUP > 0) THEN
        WRITE(RSTFIL,1152) ITAG, MYPE
        1152 FORMAT('RESTRT',I6.6,'.',I3.3)
        MULTIWRITE = .FALSE. 
        IF (NTSD == NTSTM) MULTIWRITE = .TRUE. 
    ELSE
        MULTIWRITE = .FALSE. 
        WRITE(RSTFIL,1155) ITAG, RESTHR
        1155 FORMAT('RESTRT',I6.6,'.quilt.',A4)
    END IF
!--------------------------
! OPEN UNIT TO RESTART FILE
!--------------------------
    LRSTRT  = 8
!
    WRT_TIM = 0.
    BTIMW   = TIMEF()
    BTIM0   = TIMEF()
!
    CLOSE(LRSTRT)
!
    IF (MULTIWRITE) THEN
        OPEN (UNIT=LRSTRT, FILE=RSTFIL, FORM='UNFORMATTED', IOSTAT=IER)
        IF (IER /= 0) WRITE(LIST,*)' LRSTRT OPEN UNIT ERROR IER=',IER
    END IF
!-------------------------------------
! BE SURE THAT THE BUFFER IF AVAILABLE
!-------------------------------------
    CALL COAL(DUMMY,-1)
!----------------------------------------------------
! WRITE DATE AND TIMESTEP INFORMATION TO RESTART FILE
!----------------------------------------------------
    LABEL = 'OMEGA-ALPHA*DT/CP'
!
    IF (MULTIWRITE) WRITE(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL, ITAG
!
    CALL COAL(RUN  ,1)
    CALL COAL(IDAT ,3)
    CALL COAL(IHRST,1)
    CALL COAL(NTSD ,1)
    CALL COAL(LABEL,8)
!------------------------------
! BEGIN WRITING THE RESTRT FILE
!------------------------------
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((PD(I,J),I=1,MYIE),J=1,MYJE), ((RES(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL( PD(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(RES(1:MYIE,1:MYJE), MYIE*MYJE)
!
    DO K=1,LM
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((OMGALF(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!    
        CALL COAL(OMGALF(1:MYIE,1:MYJE,K), MYIE*MYJE)
    END DO
!
    LABEL = 'BND, PD, RES, T, Q, U, V, Q2, TTND, CWM, TRAIN, TCUCN'
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL, ITAG, FIRST, IOUT, NSHDE
    END IF
!
    CALL COAL(RUN  ,1)
    CALL COAL(IDAT ,3)
    CALL COAL(IHRST,1)
    CALL COAL(NTSD ,1)
    CALL COAL(LABEL,8)
    CALL COAL(FIRST,1)
    CALL COAL(IOUT ,1)
    CALL COAL(NSHDE,1)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((PD(I,J),I=1,MYIE),J=1,MYJE),                                              &
    &                ((RES(I,J),I=1,MYIE),J=1,MYJE),                                              &
    &                ((FIS(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(PD (1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(RES(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(FIS(1:MYIE,1:MYJE), MYIE*MYJE)
!-------------------------------------------------
! BOUNDARY CONDITION WRITE CHANGED TO BLANK RECORD
!-------------------------------------------------
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) PDB, TB, QB, UB, VB, Q2B, CWMB
    END IF
!
    CALL COAL(PDB , LB*2)
    CALL COAL(TB  , LB*LM*2)
    CALL COAL(QB  , LB*LM*2)
    CALL COAL(UB  , LB*LM*2)
    CALL COAL(VB  , LB*LM*2)
    CALL COAL(Q2B , LB*LM*2)
    CALL COAL(CWMB, LB*LM*2)
!
    DO K=1,LM
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((T(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(T(1:MYIE,1:MYJE,K), MYIE*MYJE)
!  
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((Q(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(Q(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((U(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(U(1:MYIE,1:MYJE,K), MYIE*MYJE)
    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((V(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(V(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((Q2(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(Q2(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((TTND(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(TTND(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((CWM(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(CWM(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((TRAIN(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(TRAIN(1:MYIE,1:MYJE,K), MYIE*MYJE)
!    
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((TCUCN(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(TCUCN(1:MYIE,1:MYJE,K), MYIE*MYJE)
!
    END DO
!
    LABEL = 'MISC VARIABLES'
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL, ITAG                                ,        &
    &                 ((RSWIN(I,J),I=1,MYIE),J=1,MYJE), ((RSWOUT(I,J),I=1,MYIE),J=1,MYJE),        &
    &                    ((TG(I,J),I=1,MYIE),J=1,MYJE),     ((Z0(I,J),I=1,MYIE),J=1,MYJE),        &
    &                  ((AKMS(I,J),I=1,MYIE),J=1,MYJE),   ((CZEN(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(RUN,  1)
    CALL COAL(IDAT, 3)
    CALL COAL(IHRST,1)
    CALL COAL(NTSD, 1)
    CALL COAL(LABEL,8)
    CALL COAL( RSWIN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(RSWOUT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    TG(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    Z0(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  AKMS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  CZEN(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((AKHS(I,J),I=1,MYIE),J=1,MYJE),  ((THS(I,J),I=1,MYIE),J=1,MYJE),           &
    &                   ((QS(I,J),I=1,MYIE),J=1,MYJE), ((TWBS(I,J),I=1,MYIE),J=1,MYJE),           &
    &                 ((QWBS(I,J),I=1,MYIE),J=1,MYJE), ((HBOT(I,J),I=1,MYIE),J=1,MYJE),           &
    &               ((CFRACL(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(  AKHS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   THS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    QS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  TWBS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  QWBS(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  HBOT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CFRACL(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((THZ0(I,J),I=1,MYIE),J=1,MYJE),  ((QZ0(I,J),I=1,MYIE),J=1,MYJE),           &
    &                  ((UZ0(I,J),I=1,MYIE),J=1,MYJE),  ((VZ0(I,J),I=1,MYIE),J=1,MYJE),           &
    &                ((USTAR(I,J),I=1,MYIE),J=1,MYJE), ((HTOP(I,J),I=1,MYIE),J=1,MYJE),           &
    &               ((CFRACM(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(  THZ0(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   QZ0(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   UZ0(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   VZ0(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( USTAR(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  HTOP(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CFRACM(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((SNO(I,J),I=1,MYIE),J=1,MYJE), ((   SI(I,J),I=1,MYIE),J=1,MYJE),           &
    &              ((CLDEFI(I,J),I=1,MYIE),J=1,MYJE), ((   RF(I,J),I=1,MYIE),J=1,MYJE),           &
    &                ((PSLP(I,J),I=1,MYIE),J=1,MYJE), ((CUPPT(I,J),I=1,MYIE),J=1,MYJE),           &
    &              ((CFRACH(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(   SNO(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    SI(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CLDEFI(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    RF(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(  PSLP(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( CUPPT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CFRACH(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((SOILTB(I,J),I=1,MYIE),J=1,MYJE), ((SFCEXC(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((SMSTAV(I,J),I=1,MYIE),J=1,MYJE), ((SMSTOT(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((GRNFLX(I,J),I=1,MYIE),J=1,MYJE), ((PCTSNO(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(SOILTB(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SFCEXC(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SMSTAV(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SMSTOT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(GRNFLX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(PCTSNO(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((RLWIN(I,J),I=1,MYIE),J=1,MYJE), ((RADOT(I,J),I=1,MYIE),J=1,MYJE),         & 
    &                ((CZMEAN(I,J),I=1,MYIE),J=1,MYJE), ((SIGT4(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL( RLWIN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( RADOT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CZMEAN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( SIGT4(1:MYIE,1:MYJE), MYIE*MYJE)
!--------------------------------------------------------------------------------------------------
! U00, UL, AND LC ARE NO LONGER USED AND WILL BE REMOVED WHEN THE NEW CLOUD FIELDS ARE PUT INTO THE 
! RESTART FILES AND THE POST (FERRIER 23 JAN 02)
!--------------------------------------------------------------------------------------------------  
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((U00(I,J),I=1,MYIE),J=1,MYJE), UL, ((LC(I,J),I=1,MYIE),J=1,MYJE),          &
    &                  ((SR(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(U00(1:MYIE,1:MYJE),MYIE*MYJE)
    CALL COAL(UL,2*LM)
    CALL COAL( LC(1:MYIE,1:MYJE),MYIE*MYJE)
    CALL COAL( SR(1:MYIE,1:MYJE),MYIE*MYJE)
!
    LABEL = 'ACCUMULATED VARIABLES'
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) RUN, IDAT, IHRST, NTSD, LABEL, ITAG,                                        &
    &                 ((PREC(I,J),I=1,MYIE),J=1,MYJE), ((ACPREC(I,J),I=1,MYIE),J=1,MYJE),         &
    &               ((ACCLIQ(I,J),I=1,MYIE),J=1,MYJE), ((CUPREC(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(RUN  ,1)
    CALL COAL(IDAT ,3)
    CALL COAL(IHRST,1)
    CALL COAL(NTSD ,1)
    CALL COAL(LABEL,8)
!
    CALL COAL(  PREC(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ACPREC(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ACCLIQ(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CUPREC(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((ACFRCV(I,J),I=1,MYIE),J=1,MYJE), ((NCFRCV(I,J),I=1,MYIE),J=1,MYJE),       & 
    &                 ((ACFRST(I,J),I=1,MYIE),J=1,MYJE), ((NCFRST(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(ACFRCV(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(NCFRCV(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ACFRST(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(NCFRST(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((ACSNOW(I,J),I=1,MYIE),J=1,MYJE), ((ACSNOM(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((SSROFF(I,J),I=1,MYIE),J=1,MYJE), ((BGROFF(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(ACSNOW(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ACSNOM(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SSROFF(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(BGROFF(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((SFCSHX(I,J),I=1,MYIE),J=1,MYJE), ((SFCLHX(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((SUBSHX(I,J),I=1,MYIE),J=1,MYJE), ((SNOPCX(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((SFCUVX(I,J),I=1,MYIE),J=1,MYJE), ((SFCEVP(I,J),I=1,MYIE),J=1,MYJE),       &
    &                 ((POTEVP(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(SFCSHX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SFCLHX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SUBSHX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SNOPCX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SFCUVX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(SFCEVP(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(POTEVP(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((ASWIN(I,J),I=1,MYIE),J=1,MYJE), ((ASWOUT(I,J),I=1,MYIE),J=1,MYJE),         &
    &                ((ASWTOA(I,J),I=1,MYIE),J=1,MYJE),  ((ALWIN(I,J),I=1,MYIE),J=1,MYJE),         &
    &                ((ALWOUT(I,J),I=1,MYIE),J=1,MYJE), ((ALWTOA(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL( ASWIN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ASWOUT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ASWTOA(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( ALWIN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ALWOUT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ALWTOA(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ARDSW, ARDLW, ASRFC, AVRAIN, AVCNVC
    END IF
!
    CALL COAL( ARDSW,1)
    CALL COAL( ARDLW,1)
    CALL COAL( ASRFC,1)
    CALL COAL(AVRAIN,1)
    CALL COAL(AVCNVC,1)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((TH10(I,J),I=1,MYIE),J=1,MYJE),    ((Q10(I,J),I=1,MYIE),J=1,MYJE),         &
    &                  ((U10(I,J),I=1,MYIE),J=1,MYJE),    ((V10(I,J),I=1,MYIE),J=1,MYJE),         &
    &               ((TSHLTR(I,J),I=1,MYIE),J=1,MYJE), ((QSHLTR(I,J),I=1,MYIE),J=1,MYJE),         &
    &               ((PSHLTR(I,J),I=1,MYIE),J=1,MYJE),                                            &
!---------
! SM V100M
!---------
    &                ((TH100(I,J),I=1,MYIE),J=1,MYJE),   ((Q100(I,J),I=1,MYIE),J=1,MYJE),         &
    &                 ((U100(I,J),I=1,MYIE),J=1,MYJE),   ((V100(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(  TH10(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   Q10(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   U10(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   V10(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(TSHLTR(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(QSHLTR(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(PSHLTR(1:MYIE,1:MYJE), MYIE*MYJE)
!---------
! SM V100M
!---------
    CALL COAL(TH100(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( Q100(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( U100(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( V100(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) (((SMC(I,J,N),I=1,MYIE),J=1,MYJE),N=1,NSOIL)
    END IF
!
    CALL COAL(SMC(1:MYIE,1:MYJE,1:NSOIL), MYIE*MYJE*NSOIL)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((CMC(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(CMC(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) (((STC(I,J,N),I=1,MYIE),J=1,MYJE),N=1,NSOIL)
    END IF
    CALL COAL(STC(1:MYIE,1:MYJE,1:NSOIL), MYIE*MYJE*NSOIL)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) (((SH2O(I,J,N),I=1,MYIE),J=1,MYJE),N=1,NSOIL)
    END IF
!
    CALL COAL(SH2O(1:MYIE,1:MYJE,1:NSOIL), MYIE*MYJE*NSOIL)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((ALBEDO(I,J),I=1,MYIE),J=1,MYJE)
    END IF
!
    CALL COAL(ALBEDO(1:MYIE,1:MYJE), MYIE*MYJE)
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((POTFLX(I,J),I=1,MYIE),J=1,MYJE), ((TLMIN(I,J),I=1,MYIE),J=1,MYJE),        &
    &                  ((TLMAX(I,J),I=1,MYIE),J=1,MYJE),                                          &
    &                 ACUTIM, ARATIM, APHTIM, NHEAT, NPHS, NCNVC, NPREC, NRDSW, NRDLW, NSRFC,     &
    &                 TPH0D, TLM0D, RESTRT
    END IF
!
    CALL COAL(POTFLX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( TLMIN(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL( TLMAX(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(ACUTIM,1)
    CALL COAL(ARATIM,1)
    CALL COAL(APHTIM,1)
    CALL COAL(NHEAT ,1)
    CALL COAL(NPHS  ,1)
    CALL COAL(NCNVC ,1)
    CALL COAL(NPREC ,1)
    CALL COAL(NRDSW ,1)
    CALL COAL(NRDLW ,1)
    CALL COAL(NSRFC ,1)
    CALL COAL(TPH0D ,1)
    CALL COAL(TLM0D ,1)
    CALL COAL(RESTRT,1)
!
    DO K=1,LM
        IF (MULTIWRITE) THEN
            WRITE(LRSTRT) ((RSWTT(I,J,K),I=1,MYIE),J=1,MYJE)
            WRITE(LRSTRT) ((RLWTT(I,J,K),I=1,MYIE),J=1,MYJE)
        END IF
!
        CALL COAL(RSWTT(1:MYIE,1:MYJE,K), MYIE*MYJE)
        CALL COAL(RLWTT(1:MYIE,1:MYJE,K), MYIE*MYJE)
    END DO
!
    IF (MULTIWRITE) THEN
        WRITE(LRSTRT) ((CNVBOT(I,J),I=1,MYIE),J=1,MYJE)
        WRITE(LRSTRT) ((CNVTOP(I,J),I=1,MYIE),J=1,MYJE)
        WRITE(LRSTRT) ((RSWTOA(I,J),I=1,MYIE),J=1,MYJE)
        WRITE(LRSTRT) ((RLWTOA(I,J),I=1,MYIE),J=1,MYJE)
        CLOSE(LRSTRT)
    END IF
!
    CALL COAL(CNVBOT(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(CNVTOP(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(RSWTOA(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(RLWTOA(1:MYIE,1:MYJE), MYIE*MYJE)
!
    CALL COAL(  HBM2(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(    SM(1:MYIE,1:MYJE), MYIE*MYJE)
    CALL COAL(   SPL(1:LSL),LSL)
    CALL COAL(  DETA(1:LM),LM)
    CALL COAL(PT,1)
    CALL COAL(SPLINE,1)
!------------------------------------------------------------------------------------------------
! AT THIS POINT WE HAVE ACCUMULATED ALL OF THE DATA INTO BUF
! WE WANT TO KNOW THE MAXIMUM AMOUNT ACROSS ALL MPI TASKS
! THIS IS USEFUL IN CASE WE DECIDE TO WRITE A FILE INSTEAD OF SENDING THE DATA TO THE I/O SERVERS
!------------------------------------------------------------------------------------------------
    CALL MPI_ALLREDUCE(IP, IPMAX, 1, MPI_INTEGER, MPI_MAX, MPI_COMM_COMP, IERR)
!-----------------------------------------------------------------
! IPMAX IS THE MAXIMUM NUMBER OF 4 BYTE REALS ACROSS THE MPI TASKS
! LETS COMPUTE A RECLEN THAT IS A MULTIPLE OF 2**18 BYTES
! WE WILL USE THIS WHEN OPENING THE DIRECT ACCESS FILE
!-----------------------------------------------------------------
    IBLOCK = ((IPMAX * 4) / (2 ** 18)) + 1
    IRECLEN = IBLOCK * (2 ** 18)
!------------------------------------------------------
! WE WILL PLACE THE RECLEN IN THE BEGINNING OF THE FILE
! THIS IS HANDY
!------------------------------------------------------
    CALL REPLACE(IRECLEN, 1, 1)
!------------------------------------------------------------------------
! IF WE HAVE ANY I/O SERVERS WE WILL SEND THE DATA TO THEM FOR PROCESSING
!------------------------------------------------------------------------
    IF (IQUILT_GROUP > 0) THEN
    
        IF (MYPE == 0) THEN
            CALL MPI_SEND(ITAG, 1, MPI_INTEGER, 0, 0, MPI_COMM_INTER_ARRAY(ISERVE), IERR)
        END IF
!    
        DO I=0,INUMQ(ISERVE) -1
            CALL PARA_RANGE(0, JNPES-1, INUMQ(ISERVE), I, ISTART, IEND)
            MYPE_ROW = MYPE / INPES
!        
            IF (MYPE_ROW >= ISTART .AND. MYPE_ROW <= IEND ) THEN
               IF (MYPE == 0) WRITE(0,*)  'CALL MPI_ISEND.... ', IP, ITAG
                CALL MPI_ISEND(BUF, IP, MPI_REAL, I, ITAG, MPI_COMM_INTER_ARRAY(ISERVE), IHS, IERR)
            END IF
!        
        END DO
!--------------------------------------------------------------------------------------------------    
! IN CASE WE HAVE MULTIPLE GROUPS OF I/O SERVERS, INCREMENT TO THE NEXT SERVER FOR THE NEXT OUTPUT
! TIME
!--------------------------------------------------------------------------------------------------    
        ISERVE = ISERVE + 1
        IF (ISERVE > IQUILT_GROUP) ISERVE = 1
!---------------------------------------------------------
! APPARENTLY, WE HAVE CHOSEN NOT TO SUPPLY ANY I/O SERVERS
! WE WILL WRITE A DIRECT ACCESS FILE INSTEAD
!---------------------------------------------------------   
    ELSE  
        OPEN(UNIT=LRSTRT,FILE=RSTFIL,FORM='UNFORMATTED',IOSTAT=IER,ACCESS='DIRECT',RECL=IRECLEN)
!
        IF (IER /= 0) WRITE(LIST,*)' LRSTRT OPEN UNIT ERROR IER=', IER
!    
        WRITE(LRSTRT,REC=MYPE+1) (BUF(I),I=1,IP)
        CLOSE(LRSTRT)
!    
    END IF
!
    DIF_TIM = TIMEF() - BTIM0
    WRT_TIM = WRT_TIM + DIF_TIM
!
    CALL MPI_REDUCE(WRT_TIM, WRT_TIM_0, 1, MPI_REAL, MPI_MAX, 0, MPI_COMM_COMP, IERR)
!
    IF (MYPE == 0) THEN
        WRITE(6,*)' SHIPPED OR WROTE DATA, TIME = ', WRT_TIM_0*1.E-03
    END IF
!
    CALL MPI_BARRIER(MPI_COMM_COMP, ISTAT)
!-------------------------------------------------
! SEND SIGNAL THAT ALL TASKS HAVE FINISHED WRITING
!-------------------------------------------------
!
!----------------------------------------------------------------------------
! SM - ALTERACAO FEITA PARA O IO - PARA NAO MAIS ESCREVER O FCSTDONE E OUTJOB
!----------------------------------------------------------------------------
    OUTJ = .FALSE. 
    IF (OUTJ) THEN
        IF (IQUILT_GROUP == 0) THEN
            IF (MYPE == 0) THEN
                DONE = 'DONE'
!
                REWIND(11)
                READ(11,POSTLIST)                        !CHOU
                WRITE(LIST,POSTLIST)                     !CHOU
!                
                WRITE(OUTJOB,1240) ITAG
                1240 FORMAT('OUTJOB_SPECIAL',I6.6,'.ksh')
!
                LUNIN = 67
                LUNOT = 68
                OPEN(LUNIN, FILE='OUTJOB_SPECIAL.ksh')
                OPEN(LUNOT, FILE=OUTJOB)
                1260 FORMAT(A85)
!
                REWIND(LUNIN)
                DO I=1,11
                    READ(LUNIN,1260) LINE
                    IDX = INDEX(LINE,' ') - 1
                    WRITE(LUNOT,1260) LINE
                END DO
                1261 FORMAT('HFCT=',I6.6)
                WRITE(LUNOT,1261) ITAG
!
                1250 READ(LUNIN,1260,END=1290) LINE
                WRITE(LUNOT,1260) LINE
                GO TO 1250
                1290 CONTINUE
!
                CLOSE(LUNOT)
                CLOSE(LUNIN)
!                        
                IDX    = INDEX(SUBMIT,'#') - 1
                SUBMIT = SUBMIT(1:IDX) // OUTJOB
!                         
                CHX  = INDEX(CHMO,'#') - 1
                CHMO = CHMO(1:CHX) // OUTJOB
!
                CALL SYSTEM(CHMO)
!                         
                WRITE(LIST,*) 'CHKOUT:  SUBMIT POST JOB ', SUBMIT
                CALL SYSTEM(SUBMIT)    ! NEC EQUIVALENT
!
                IF (IER /= 0) WRITE(LIST,*)' SIGNAL SENT TO FINFIL:  DONE'
            END IF
        END IF
    END IF
!------------------------------------
! RESET ACCUMULATION COUNTERS TO ZERO
!------------------------------------
    APHTIM = 0.
    ACUTIM = 0.
    ARATIM = 0.
!---------------------------------------
! POST-POSTING UPDATING AND INITIALIZING
!---------------------------------------
!
!----------------------------------------------------------------------------------------------------------------------------
!IF (NTSD.EQ.NSHDE), THEN THIS WAS ALSO A FORECAST OUTPUT TIME.  WE NEED TO INCREMENT NSHDE FOR THE NEXT FORECAST OUTPUT TIME
!----------------------------------------------------------------------------------------------------------------------------
    IF (NTSD == NSHDE .OR. NSTART+1 == NSHDE) THEN
        IOUT = IOUT + 1
        IF (.NOT. RESTRT)   GOTO 1300
        IF (NTSD == NSHDE .OR. NSTART+1 == NSHDE) GOTO 1300
        IOUT = IOUT - 1
        1300 NSHDE = ISHDE(IOUT)
    END IF
!---------------------------
! ZERO ACCUMULATOR ARRAYS
! AVERAGE CLOUD AMOUNT ARRAY
!---------------------------
    1310 CONTINUE
!
    IF (MOD(NTSD,NCLOD) < NPHS) THEN
        IF (MYPE == 0) WRITE(LIST,*)'CHKOUT: ZERO AVG CLD AMT ARRAY'
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                ACFRCV(I,J) = 0.
                NCFRCV(I,J) = 0
                ACFRST(I,J) = 0.
                NCFRST(I,J) = 0
            END DO
        END DO
    END IF
!---------------------------------------------
! TOTAL AND CONVECTIVE PRECIPITATION ARRAYS
! TOTAL SNOW AND SNOW MELT ARRAYS
! STORM SURFACE AND BASE GROUND RUN OFF ARRAYS
! PRECIPITATION TYPE ARRAY
!---------------------------------------------
    IF (MOD(NTSD,NPREC) < NCNVC) THEN
        IF(MYPE == 0) WRITE(LIST,*) 'CHKOUT: ZERO ACCUM PRECIP ARRAYS'
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                ACPREC(I,J) = 0.
                CUPREC(I,J) = 0.
                ACSNOW(I,J) = 0.
                ACSNOM(I,J) = 0.
                SSROFF(I,J) = 0.
                BGROFF(I,J) = 0.
                SFCEVP(I,J) = 0.
                POTEVP(I,J) = 0.
            END DO
        END DO
    END IF
!--------------------------------------------------
! GRID-SCALE AND CONVECTIVE (LATENT) HEATING ARRAYS
!--------------------------------------------------
    IF (MOD(NTSD,NHEAT) < NCNVC) THEN
        IF (MYPE == 0) WRITE(LIST,*) 'CHKOUT: ZERO ACCUM LATENT HEATING ARRAYS'
        AVRAIN = 0.
        AVCNVC = 0.
        DO K=1,LM
            DO J=MYJS,MYJE
                DO I=MYIS,MYIE
                    TRAIN(I,J,K) = 0.
                    TCUCN(I,J,K) = 0.
                END DO
            END DO
        END DO
    END IF
!----------------------------------------------------------------------------------------------------
! BEGIN: INITIALIZE CONVECTIVE CLOUD FIELDS FOR RADIATION BEFORE RETURNING TO EBU (FERRIER 23 JAN 02)
!----------------------------------------------------------------------------------------------------
    IF (CURAD) THEN
        IF (MYPE == 0) THEN
            WRITE(0,"(a)") 'CHKOUT: INITIALIZE CUPPT,HTOP,HBOT'
            WRITE(6,"(a)") 'CHKOUT: INITIALIZE CUPPT,HTOP,HBOT'
        END IF
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                CUPPT(I,J) =   0.
                HTOP(I,J)  = 100.
                HBOT(I,J)  =   0.
            END DO
        END DO
!
        CURAD = .FALSE. 
!
    END IF
!-----------------------------------------------------------------------------------------------------------------------
! RESET CONVECTIVE CLOUD TOP AND BOTTOM ARRAYS (DIAGNOSTIC ONLY; THESE FIELDS ARE NOT CYCLED AND NOT READ WHEN TSTART=0)
!-----------------------------------------------------------------------------------------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            CNVTOP(I,J) = 100.
            CNVBOT(I,J) =   0.
        END DO
    END DO
!----
! END
!----
!
!---------------------------
! LONG WAVE RADIATION ARRAYS
!---------------------------
    IF (MOD(NTSD,NRDLW) < NPHS) THEN
        IF (MYPE == 0) WRITE(LIST,*) 'CHKOUT: ZERO ACCUM LW RADTN ARRAYS'
        ARDLW = 0.
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                 ALWIN(I,J) = 0.
                ALWOUT(I,J) = 0.
                ALWTOA(I,J) = 0.
            END DO
        END DO
    END IF
!----------------------------
! SHORT WAVE RADIATION ARRAYS
!----------------------------
    IF (MOD(NTSD,NRDSW) < NPHS) THEN
        IF (MYPE == 0) WRITE(LIST,*) 'CHKOUT:  ZERO ACCUM SW RADTN ARRAYS'
        ARDSW = 0.
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                 ASWIN(I,J) = 0.
                ASWOUT(I,J) = 0.
                ASWTOA(I,J) = 0.
            END DO
        END DO
    END IF
!---------------------------------------------
! SURFACE SENSIBLE AND LATENT HEAT FLUX ARRAYS
!---------------------------------------------
    IF (MOD(NTSD,NSRFC) < NPHS) THEN
        IF (MYPE == 0) WRITE(LIST,*) 'CHKOUT:  ZERO ACCUM SFC FLUX ARRAYS'
        ASRFC = 0.
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                SFCSHX(I,J) = 0.
                SFCLHX(I,J) = 0.
                SUBSHX(I,J) = 0.
                SNOPCX(I,J) = 0.
                SFCUVX(I,J) = 0.
                POTFLX(I,J) = 0.
            END DO
        END DO
    END IF
!-------------------------------------
! RESET THE MAX/MIN TEMPERATURE ARRAYS
!-------------------------------------
    DO J=MYJS,MYJE
        DO I=MYIS,MYIE
            TLMIN(I,J) =  999.
            TLMAX(I,J) = -999.
        END DO
    END DO
!----------------------------------------------------------------
! WRITING IN A SEPARATE FILE FOR EACH MYPE AND EACH OUTPUT PERIOD
!----------------------------------------------------------------
!    IOUT = IOUT -1
!    NSHDE = ISHDE(IOUT)
!    IF (NTSD == NSHDE .OR. NSTART+1 == NSHDE) THEN
!        CALL OUT2RESTRT(ITAG)
!    ENDIF
!    IOUT = IOUT +1
!    NSHDE = ISHDE(IOUT)    
!
    IF (MYPE == 0) THEN
        WRITE(0,"(a)") 'FINISHED CHKOUT'
        WRITE(6,"(a)") 'FINISHED CHKOUT'
    END IF
!---------------
! END OF ROUTINE
!---------------
    RETURN
!
    END SUBROUTINE CHKOUT
!
!
!
    SUBROUTINE COAL(A, LEN)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE COAL
!> 
!> SUBPROGRAM: COAL - ?????
!> PROGRAMMER: ?????          
!> ORG: W/NP22 
!> DATE: ??-??-??
!>     
!> ABSTRACT:
!> ?????
!>     
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 06-07-16  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> A   -
!> LEN -
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>   
!> CALLS : BUFFER
!>         F77KINDS
!>
!> DRIVER: CHKOUT
!>--------------------------------------------------------------------------------------------------
    USE BUFFER
    USE F77KINDS
!
    IMPLICIT NONE
!
    INCLUDE 'mpif.h'
!
    REAL   (KIND=R4KIND), DIMENSION(*)                                    , INTENT(IN)          ::&
    & A
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LEN       
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IERR    , I
!
    IF (LEN < 0) THEN
        IP = 0
    END IF
!
    IF (IP + LEN > IBUFMAX) THEN
        PRINT *, ' IBUFMAX IN MODULE_BUFFER.f90 IS TOO SMALL, STOPPING'
        PRINT *, ' CHANGE IBUFMAX IN PARMBUF.f90 AND RECOMPILE'
        CALL MPI_ABORT(MPI_COMM_WORLD, 1, IERR)
    END IF
!
    DO I=1,ABS(LEN)
        IP = IP + 1
        BUF(IP) = A(I)
    END DO
!
    END SUBROUTINE COAL
!
!
!
    SUBROUTINE REPLACE(A, LEN, IW)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE REPLACE
!> 
!> SUBPROGRAM: REPLACE - ?????
!> PROGRAMMER: ?????          
!> ORG: W/NP22 
!> DATE: ??-??-??
!>     
!> ABSTRACT:
!> ?????
!>     
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 06-07-16  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY 
!>
!> INPUT  ARGUMENT LIST:
!> A   -
!> LEN -
!> IW  -
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>   
!> CALLS : BUFFER
!>         F77KINDS
!>
!> DRIVER: CHKOUT
!>--------------------------------------------------------------------------------------------------
    USE BUFFER
    USE F77KINDS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), DIMENSION(*)                                    , INTENT(IN)          ::&
    & A
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LEN     , IW        
!
    INTEGER(KIND=I4KIND)                                                                        ::&  
    & I       , IPP 
!
    IPP = IW
!
    DO I=1,LEN
        BUF(IPP) = A(I)
        IPP = IPP + 1
    END DO
!
    END SUBROUTINE REPLACE          

    SUBROUTINE PDTE
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PDTE
!>
!> SUBROUTINE: PDTE - SURFACE PRESSURE TENDENCY CALC
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 94-03-08
!>
!> ABSTRACT:
!> PDTE VERTICALLY INTEGRATES THE MASS FLUX DIVERGENCE TO OBTAIN THE SURFACE PRESSURE TENDENCY AND 
!> ETADOT ON THE LAYER INTERFACES.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 96-03-29  BLACK      - REMOVED SCRCH
!> 98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: CLDWTR
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : NEWFLT
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CLDWTR
    USE CONST
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: CP   = 1004.6
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM -  JM /  2
    INTEGER(KIND=I4KIND), PARAMETER :: JAM  =  6 +  2 * (JM - 10)
    INTEGER(KIND=I4KIND), PARAMETER :: LM1  = LM -  1
    INTEGER(KIND=I4KIND), PARAMETER :: LP1  = LM + 1
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUN     , FIRST   , RESTRT  , SIGMA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PRET    , RPSL
!--------------------------------------------------
! COMPUTATION OF PRESSURE TENDENCY AND PREPARATIONS
!--------------------------------------------------
    DO 100 L=2,LM
!
!$omp parallel do
!
        DO 100 J=MYJS,MYJE2
            DO 100 I=MYIS,MYIE
                DIV(I,J,L) = DIV(I,J,L-1) + DIV(I,J,L)
100 END DO
!
!$omp parallel do 
!
    DO 110 J=MYJS2,MYJE2
        DO 110 I=MYIS,MYIE
            PSDT(I,J) = -DIV(I,J,LM)
            PRET(I,J) = PSDT(I,J) * RES(I,J)
            RPSL(I,J) = 1. / PDSL(I,J)
110 END DO
!--------------------- 
! COMPUTATION OF ETADT 
!--------------------- 
!
!$omp parallel do
!
    DO 120 L=1,LM1
        DO 120 J=MYJS2,MYJE2
            DO 120 I=MYIS,MYIE
                ETADT(I,J,L) = -(PRET(I,J) * ETA(L+1) + DIV(I,J,L)) * HTM(I,J,L+1) * RPSL(I,J)
120 END DO
!---------------------------------------------- 
! KINETIC ENERGY GENERATION TERMS IN T EQUATION 
!----------------------------------------------
!
!$omp parallel do 
!
    DO 130 J=MYJS2,MYJE2
        DO 130 I=MYIS,MYIE
            OMGALF(I,J,1) = OMGALF(I,J,1) - DIV(I,J,1) * RTOP(I,J,1) * EF4T
                 T(I,J,1) =      T(I,J,1) - DIV(I,J,1) * RTOP(I,J,1) * EF4T
130 END DO
!
!$omp parallel do
!
    DO 140 J=MYJS2,MYJE2
        DO 140 I=MYIS,MYIE
            OMGALF(I,J,L) = OMGALF(I,J,L) - (DIV(I,J,L-1) + DIV(I,J,L)) * RTOP(I,J,L) * EF4T      &
    &                     *    HTM(I,J,L)
!
                 T(I,J,L) =      T(I,J,L) - (DIV(I,J,L-1) + DIV(I,J,L)) * RTOP(I,J,L) * EF4T
140 END DO
145 CONTINUE
!
!$omp parallel do
!
    DO 150 J=MYJS2,MYJE2
        DO 150 I=MYIS,MYIE
            OMGALF(I,J,LM) = OMGALF(I,J,LM) + (PRET(I,J) - DIV(I,J,LM1)) * RTOP(I,J,LM) * EF4T    &
    &                      *    HTM(I,J,LM)
!
                 T(I,J,LM) =      T(I,J,LM) + (PRET(I,J) - DIV(I,J,LM1)) * RTOP(I,J,LM) * EF4T
150 END DO
!
    DO 160 L=LM,2,-1
!
!$omp parallel do
!
        DO 160 J=MYJS,MYJE2
            DO 160 I=MYIS,MYIE
                DIV(I,J,L) = DIV(I,J,L) - DIV(I,J,L-1)
160 END DO
!
    RETURN
!
    END SUBROUTINE PDTE

    MODULE CO2BD3
!>--------------------------------------------------------------------------------------------------
!> MODULE CO2BD3
!>
!> ABSTRACT:
!> THE FOLLOWING MODULE CONTAIN PRETABULATED CO2 TRANSMISSION FUNCTIONS, EVALUATED USING THE 
!> METHODS OF FELS AND SCHWARZKOPF (1981) AND SCHWARZKOPF AND FELS (1985), MODULE CO2BD3 CONTAINS 
!> CO2 TRANSMISSION FUNCTIONS AND TEMPERATURE AND PRESSURE DERIVATIVES FOR THE 560-800 CM-1 BAND. 
!> ALSO INCLUDED ARE THE STANDARD TEMPERATURES AND THE WEIGHTING FUNCTION. THESE DATA ARE IN BLOCK
!> DATA BD3:
!>         
!> CO251  - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)=1013.25 MB
!> CO258  - TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) WITH P(SFC)= ^810 MB
!> CDT51  - FIRST  TEMPERATURE DERIVATIVE OF CO251
!> CDT58  - FIRST  TEMPERATURE DERIVATIVE OF CO258
!> C2D51  - SECOND TEMPERATURE DERIVATIVE OF CO251
!> C2D58  - SECOND TEMPERATURE DERIVATIVE OF CO251
!> CO2M51 - TRANSMISSION FCTNS FOR T0 FOR ADJACENT PRESSURE LEVELS, WITH NO PRESSURE QUADRATURE.
!>          USED FOR NEARBY LAYER COMPUTATIONS. P(SFC)=1013.25 MB
!> CO2M58 - SAME AS CO2M51,WITH P(SFC)= ^810 MB
!> CDTM51 - FIRST  TEMPERATURE DERIVATIVE OF CO2M51
!> CDTM58 - FIRST  TEMPERATURE DERIVATIVE OF CO2M58
!> C2DM51 - SECOND TEMPERATURE DERIVATIVE OF CO2M51
!> C2DM58 - SECOND TEMPERATURE DERIVATIVE OF CO2M58
!> STEMP  - STANDARD TEMPERATURES FOR MODEL PRESSURE LEVEL STRUCTURE WITH P(SFC)=1013.25 MB
!> GTEMP  - WEIGHTING FUNCTION FOR MODEL PRESSURE LEVEL STRUCTURE WITH P(SFC)=1013.25 MB.
!> B0     - TEMP. COEFFICIENT USED FOR CO2 TRANS. FCTN. CORRECTION FOR T(K). (SEE REF. 4 AND BD3)
!> B1     - TEMP. COEFFICIENT, USED ALONG WITH B0
!> B2     - TEMP. COEFFICIENT, USED ALONG WITH B0
!> B3     - TEMP. COEFFICIENT, USED ALONG WITH B0
!>
!> USE MODULES: F77KINDS
!>              RDPARM
!>
!> DRIVER     : CO2DTA 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : L, LP1
! 
    IMPLICIT NONE
!
    SAVE
! 
    REAL   (KIND=R4KIND), DIMENSION(LP1, LP1)                                                   ::&
    & CO251   , CO258   , CDT51   , CDT58   , C2D51   , C2D58
!
    REAL   (KIND=R4KIND), DIMENSION(L)                                                          ::&
    & CO2M51  , CO2M58  , CDTM51  , CDTM58  , C2DM51  , C2DM58
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & STEMP   , GTEMP
!   
    REAL   (KIND=R4KIND)                                                                        ::&
    & B0      , B1      , B2      , B3 
!--------------------------------------------------------------------------------------------------
! FROM GFDLRD.f90
! B0,B1,B2,B3 ARE COEFFICIENTS USED TO CORRECT FOR THE USE OF 250K IN THE PLANCK FUNCTION USED IN 
! EVALUATING PLANCK-WEIGHTED CO2 TRANSMISSION FUNCTIONS. (SEE REF. 4)
!--------------------------------------------------------------------------------------------------
    DATA B0, B1, B2, B3 /-.51926410E-4, -.18113332E-3, -.10680132E-5, -.67303519E-7 /
!
    END MODULE CO2BD3

    SUBROUTINE VDIFH(LMHK, KTM, DTQ2, THZ0, QZ0, AKHS, CT, CKLQ, T, Q, AKH, APE, Z, EVPR)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VDIFH
!>
!> SUBPROGRAM: VDIFH - VERTICAL DIFFUSION OF MASS VARIABLES
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT: 
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LMHK  - MASS POINT MODEL SURFACE (LOWEST MODEL HEIGHT)
!> KTM   -
!> DTQ2  - PHYSICS TINE STEP
!> THZ0  - POTENTIAL TEMPERATURE AT TOP OF VISCOUS LAYER
!> QZ0   - SPECIF HUMIDITY AT TOP OF VISCOUS LAYER
!> AKHS  - SURFACE COEF. FOR T AND Q DIVIDED BY DELTA Z
!> CT    -
!> CKLQ  - MASK VALUE
!> AKH   - SURFACE EXCHANGE COEF. FOR T AND Q (TRANSPOSED)
!> APE   - EXNER FUNCTION (TRANSPOSED)
!> Z     - INTERFACE HEIGHT (TRANSPOSED)
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> T     - (TRANSPOSED)
!> Q     - (TRANSPOSED)
!> EVPR  - 
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : TURBL
!>
!> CALLS      : ----- 
!>--------------------------------------------------------------------------------------------------	
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LM1 = LM - 1
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(INOUT)       ::&
    & T       , Q
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::&
    & APE
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                  , INTENT(IN)          ::&
    & Z
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                  , INTENT(IN)          ::&
    & AKH      
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::&
    & CM      , CR      , RST     , RSQ     , DTOZ    , AKCT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LMHK    , KTM      
!
    REAL   (KIND=R4KIND)                                                  , INTENT(IN)          ::&
    & DTQ2    , THZ0    , QZ0     , AKHS    , CT      , CKLQ
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)       ::&
    & EVPR
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LMHM    , LMHP    , L       , KT   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & DTDIF   , DTOZL   , CF      , DTOZS   , AKHH    , AKQS    , CMB     , CMTB    , RSTB    ,   &
    & RSQB    , RCML    , CMQB
!
    DTDIF = DTQ2 / FLOAT(KTM)
    LMHM  = LMHK-1
    LMHP  = LMHK+1
!
    EVPR = 0.E0 !DULE
!
    DO 100 L=1,LMHM
        DTOZ(L) =  DTDIF    /  (Z(L) - Z(L+1))
          CR(L) = -DTOZ(L)  * AKH(L)
        AKCT(L) =  AKH(L)   *  (Z(L) - Z(L+2)) * 0.5 * CT
100 END DO
!
    CM(1) = DTOZ(1) * AKH(1) + 1.
!
    DO 300 KT=1,KTM
!
        RST(1) = -AKCT(1) * DTOZ(1) + T(1) * APE(1)
        RSQ(1) =     Q(1)
!
        DO 110 L=2,LMHM
            DTOZL  =  DTOZ(L)
            CF     = -DTOZL     * AKH(L-1) /    CM(L-1)
            CM(L)  = -  CR(L-1) * CF       +  (AKH(L-1) +  AKH(L)) * DTOZL + 1.
            RST(L) = - RST(L-1) * CF       + (AKCT(L-1) - AKCT(L)) * DTOZL + T(L) * APE(L)
            RSQ(L) = - RSQ(L-1) * CF       +     Q(L)
    110 END DO
!
        DTOZS   =  DTDIF     / (Z(LMHK) - Z(LMHP))
        AKHH    =  AKH(LMHM)
!    
        CF      = - DTOZS    * AKHH     / CM(LMHM)
        AKQS    =   AKHS     * CKLQ
!    
        CMB     =   CR(LMHM) * CF
        CMTB    = - CMB      + (AKHH    + AKHS)       * DTOZS + 1.
        CMQB    = - CMB      + (AKHH    + AKQS)       * DTOZS + 1.
!    
        RSTB    = -RST(LMHM) * CF       + (AKCT(LMHM) - AKHS  * CT) * DTOZS + T(LMHK) * APE(LMHK)
        RSQB    = -RSQ(LMHM) * CF       + Q(LMHK)
!
        T(LMHK) = ( DTOZS    * AKHS     * THZ0 + RSTB) / (APE(LMHK)  * CMTB)
        EVPR    =   EVPR     - Q(LMHK)  * DETA(LMHK)                           !DULE
        Q(LMHK) = ( DTOZS    * AKQS     * QZ0          + RSQB)       / CMQB
        EVPR    =   EVPR     + Q(LMHK)  * DETA(LMHK)                           !DULE
!
        DO 120 L=LMHM,1,-1
            RCML = 1.        / CM(L) 
            T(L) = (-CR(L)   *  T(L+1) *  APE(L+1) + RST(L)) * RCML / APE(L)
            EVPR =  EVPR     -  Q(L)   * DETA(L)                              !DULE
            Q(L) = (-CR(L)   *  Q(L+1) +  RSQ(L))  * RCML
            EVPR =  EVPR     +  Q(L)   * DETA(L)                              !DULE
    120 END DO
!
300 END DO
!
    RETURN
!
    END SUBROUTINE VDIFH

    SUBROUTINE SWR93(FSWC ,      HSWC,      UFSWC,     DFSWC,     FSWL,      HSWL,      UFSWL,     &
    &                DFSWL,     PRESS,     COSZRO,    TAUDAR,     RH2O,     RRCO2,     SSOLAR,     &
    &                  QO3,     NCLDS,     KTOPSW,    KBTMSW,     CAMT,       CRR,        CTT,     &
    &                 ALVB,      ALNB,       ALVD,      ALND,    GDFVB,     GDFNB,      GDFVD,     &
    &                GDFND)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SWR93
!>
!> SUBPROGRAM: SWR93 - CALCULATE SURFACE CONDITIONS
!> PROGRAMMER: ?????   
!> ORG: ?????
!> DATE: ??-??-??
!> 
!> ABSTRACT:
!> ?????
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????       - ORIGINATOR
!> 92-03-06  K. CAMPANA  - INCLUDE HPCON, PARMC CHANGED TO HCON, RDPARM
!> 93-02-??  Y. HOU      - INPUTS 12 BANDS CLD REFLECTTANCE AND TRANSMITTANCE CRR, CTT TO REPLACE
!>                         CIRAB, CIRRF, CUVRF
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> PRESS  -
!> COSZRO -
!> TAUDAR -
!> RH2O   -
!> RRCO2  -
!> SSOLAR -
!> QO3    -
!> NCLDS  -
!> KTOPSW -
!> KBTMSW -
!> CRR    -
!> CTT    - 
!> CAMT   -
!> ALVB   -
!> ALVD   -
!> ALNB   -
!> ALND   -
!>
!> OUTPUT ARGUMENT LIST:
!> FSWC   -
!> HSWC   -
!> UFSWC  -
!> DFSWC  -
!> FSWL   -
!> HSWL   -
!> UFSWL  -
!> DFSWL  -
!> GDFVB  -
!> GDFVD  -
!> GDFNB  -
!> GDFND  -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              HCON
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              PHYCON
!>              RDPARM
!>              SWRSAV
!>              TEMPCOM     
!>              TOPO
!>
!> DRIVER     : RADFS
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE HCON
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE PHYCON
    USE RDPARM
    USE SWRSAV
    USE TEMPCOM
    USE TOPO
! 
    IMPLICIT NONE
!
#include "sp.h"
!-------------------------------------------------------------------------------------
! PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
! L =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
! NB IS A SHORTWAVE PARAMETER; OTHER QUANTITIES ARE DERIVED FROM THE ABOVE PARAMETERS.
! VARIABLES AS IN ARGUMENT LIST
!-------------------------------------------------------------------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(INOUT)       ::&
    & FSWC    , HSWC    , FSWL    , HSWL    , UFSWC   , DFSWC   , UFSWL   , DFSWL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(INOUT)       ::&
    & GDFVB   , GDFNB   , GDFVD   , GDFND
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & PRESS   , CAMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, L)                       , INTENT(IN)          ::&
    & RH2O    , QO3      
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, NB, LP1)                 , INTENT(IN)          ::&
    & CRR     , CTT 
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, LP1)                     , INTENT(IN)          ::&
    & KBTMSW  , KTOPSW
!  
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & COSZRO  , TAUDAR  , ALVB    , ALNB    , ALVD    , ALND
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2)                          , INTENT(IN)          ::&
    & NCLDS    
!---------------- 
! LOCAL VARIABLES
!----------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & PP      , DP      , PR2     , DU      , DUCO2   , DUO3    , FF      , FFCO2   , FFO3    ,   &
    & XAMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2)                                                ::&
    & RRAY    , SECZ    , REFL    , TMP1    , REFL2   , CCMAX
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, NB)                                            ::&
    & DFNTOP
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & UD      , UR      , UDCO2   , URCO2   , UDO3    , URO3    , TDCO2   , TUCO2   , TDO3    ,   &
    & TUO3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LLP2)                                          ::&
    & UCO2    , UO3     , TCO2    , TO3
!    
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & DFN     , UFN     , CR      , TTD     , TTU     , CT      , PPTOP   , DPCLD
!-----------------------------
! EQUIVALENCED LOCAL VARIABLES
!-----------------------------
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, LP1)                                           ::&
    & TTUB1   , TUCL1   , TTDB1   , TDCL1    , TDCL2  , UFNTRN  , UFNCLU  , TCLU    , DFNTRN  ,   &
    & DFNCLU  , TCLD    , ALFA    , ALFAU 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I      , N        , K       , IP      , KCLDS   , NNCLDS  , JTOP    , J1      , J2      ,   &
    & J3     , KK 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & RRCO2   , SSOLAR  , HTEMP   , TEMPF   , TEMPG   , DENOM
!    
    EQUIVALENCE (UDO3 , UO3 (IDIM1,1   ), DFNCLU)
    EQUIVALENCE (URO3 , UO3 (IDIM1,LP2 ), UFNCLU)
    EQUIVALENCE (UDCO2, UCO2(IDIM1,1   ), TCLD  )
    EQUIVALENCE (URCO2, UCO2(IDIM1,LP2 ), TCLU  )
    EQUIVALENCE (TDO3 , TO3 (IDIM1,1   ), DFNTRN)
    EQUIVALENCE (TUO3 , TO3 (IDIM1,LP2 ), UFNTRN)
    EQUIVALENCE (TDCO2, TCO2(IDIM1,1   ))
    EQUIVALENCE (TUCO2, TCO2(IDIM1,LP2 ))
    EQUIVALENCE (FF   , ALFA )
    EQUIVALENCE (FFCO2, ALFAU)
    EQUIVALENCE (FFO3 , TTDB1)
    EQUIVALENCE (DU   , TTUB1)
    EQUIVALENCE (DUCO2, TUCL1)
    EQUIVALENCE (DUO3 , TDCL1)
    EQUIVALENCE (PR2  , TDCL2)
!--------------------------------------------------------------------------------------------------
! CALCULATE SECANT OF ZENITH ANGLE (SECZ), FLUX PRESSURES(PP), LAYER WIDTH (DP) AND PRESSURE 
! SCALING FACTOR (PR2).
!--------------------------------------------------------------------------------------------------
    DO 100 I=MYIS,MYIE
        SECZ(I)     = H35E1 / SQRT(H1224E3 * COSZRO(I) * COSZRO(I) + ONE)
          PP(I,1  ) = ZERO
          PP(I,LP1) =       PRESS(I,LP1)
        TMP1(I)     = ONE / PRESS(I,LP1)
100 END DO
!
    DO 110 K=1,LM1
        DO 110 I=MYIS,MYIE
            PP(I,K+1) = HAF * (PRESS(I,K+1) + PRESS(I,K))
110 END DO
!
    DO 120 K=1,L
        DO 120 I=MYIS,MYIE
            DP (I,K) = PP(I,K+1) -  PP(I,K)
            PR2(I,K) = HAF       * (PP(I,K) + PP(I,K+1))
120 END DO
!
    DO 130 K=1,L
        DO 130 I=MYIS,MYIE
            PR2(I,K) = PR2(I,K) * TMP1(I)
130 END DO
!--------------------------------------------------------------- 
! CALCULATE ENTERING FLUX AT THE TOP FOR EACH BAND(IN CGS UNITS)
!---------------------------------------------------------------
    DO 140 N=1,NB
        DO 140 IP=MYIS,MYIE
            DFNTOP(IP,N) = SSOLAR * H69766E5 * COSZRO(IP) * TAUDAR(IP) * PWTS(N)
140 END DO
!----------------------------------------------------------------------------
! EXECUTE THE LACIS-HANSEN REFLECTIVITY PARAMETERIZATION FOR THE VISIBLE BAND
!----------------------------------------------------------------------------
    DO 150 I=MYIS,MYIE
        RRAY(I) = HP219   / (ONE + HP816   * COSZRO(I))
        REFL(I) = RRAY(I) + (ONE - RRAY(I))* (ONE - RRAYAV) * ALVB(I) / (ONE - ALVD(I) * RRAYAV)
150 END DO
!
    DO 155 I=MYIS,MYIE
        RRAY (I) = 0.104   / (ONE + 4.8     * COSZRO(I))
        REFL2(I) = RRAY(I) + (ONE - RRAY(I))* (ONE - 0.093) * ALVB(I) / (ONE - ALVD(I) * 0.093)
155 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE PRESSURE-WEIGHTED OPTICAL PATHS FOR EACH LAYER IN UNITS OF CM-ATM. PRESSURE WEIGHTING 
! IS USING PR2.
! DU= VALUE FOR H2O;DUCO2 FOR CO2;DUO3 FOR O3.
!--------------------------------------------------------------------------------------------------
    DO 160 K=1,L
        DO 160 I=MYIS,MYIE
            DU   (I,K) =  GINV  * RH2O (I,K) * DP (I,K) * PR2(I,K)
            DUCO2(I,K) = (RRCO2 * GINV       * CFCO2)   * DP (I,K) * PR2(I,K)
            DUO3 (I,K) = (GINV  * CFO3)      * QO3(I,K) * DP (I,K)
160 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE CLEAR SKY SW FLUX
!
! OBTAIN THE OPTICAL PATH FROM THE TOP OF THE ATMOSPHERE TO THE FLUX PRESSURE. ANGULAR FACTORS ARE 
! NOW INCLUDED. 
! UD=DOWNWARD PATH FOR H2O,WIGTH UR THE UPWARD PATH FOR H2O. CORRESPONDING QUANTITIES FOR CO2,O3 
! ARE UDCO2/URCO2 AND UDO3/URO3.
!--------------------------------------------------------------------------------------------------
    DO 200 IP=MYIS,MYIE
        UD   (IP,1) = ZERO
        UDCO2(IP,1) = ZERO
        UDO3 (IP,1) = ZERO
200 END DO
!
    DO 210 K=2,LP1
        DO 210 I=MYIS,MYIE
            UD   (I,K) = UD   (I,K-1) + DU   (I,K-1) * SECZ(I)
            UDCO2(I,K) = UDCO2(I,K-1) + DUCO2(I,K-1) * SECZ(I)
            UDO3 (I,K) = UDO3 (I,K-1) + DUO3 (I,K-1) * SECZ(I)
210 END DO
!
    DO 220 IP=MYIS,MYIE
        UR   (IP,LP1) = UD   (IP,LP1)
        URCO2(IP,LP1) = UDCO2(IP,LP1)
        URO3 (IP,LP1) = UDO3 (IP,LP1)
220 END DO
!
    DO 230 K=L,1,-1
        DO 230 IP=MYIS,MYIE
            UR   (IP,K) = UR   (IP,K+1) + DU   (IP,K) *  DIFFCTR
            URCO2(IP,K) = URCO2(IP,K+1) + DUCO2(IP,K) *  DIFFCTR
            URO3 (IP,K) = URO3 (IP,K+1) + DUO3 (IP,K) * O3DIFCTR
230 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE CO2 ABSORPTIONS. THEY WILL BE USED IN NEAR INFRARED BANDS.SINCE THE ABSORPTION AMOUNT 
! IS GIVEN (IN THE FORMULA USED BELOW, DERIVED FROM SASAMORI) IN TERMS OF THE TOTAL SOLAR FLUX, AND
! THE ABSORPTION IS ONLY INCLUDED IN THE NEAR IR (50 PERCENT OF THE SOLAR SPECTRUM), THE 
! ABSORPTIONS ARE MULTIPLIED BY 2. SINCE CODE ACTUALLY REQUIRES TRANSMISSIONS, THESE ARE THE VALUES
! ACTUALLY STORED IN TCO2.
!--------------------------------------------------------------------------------------------------
    DO 240 K=1,LL
        DO 240 I=MYIS,MYIE
            TCO2(I,K+1) = ONE - TWO * (H235M3 * EXP(HP26 * LOG(UCO2(I,K+1) + H129M2)) - H75826M4)
240 END DO
!--------------------------------------------------------------------------------------------------
! NOW CALCULATE OZONE ABSORPTIONS. THESE WILL BE USED IN THE VISIBLE BAND.JUST AS IN THE CO2 CASE, 
! SINCE THIS BAND IS 50 PERCENT OF THE SOLAR SPECTRUM,THE ABSORPTIONS ARE MULTIPLIED BY 2. THE 
! TRANSMISSIONS ARE STORED IN TO3.
!--------------------------------------------------------------------------------------------------
    HTEMP = H1036E2 * H1036E2 * H1036E2
    DO 250 K=1,LL
        DO 250 I=MYIS,MYIE
            TO3(I,K+1) = ONE - TWO    * UO3(I,K+1)  * (H1P082 * EXP(HMP805 * LOG(ONE    + H1386E2 &
    &                  * UO3(I,K+1))) + H658M2      / (ONE    + HTEMP      * UO3(I,K+1)           &
    &                  * UO3(I,K+1)   * UO3(I,K+1)) + H2118M2 / (ONE       + UO3(I,K+1)           &
    &                  * (H42M2       + H323M4                             * UO3(I,K+1))))
!
250 END DO
!--------------------------------- 
! START FREQUENCY LOOP (ON N) HERE
!--------------------------------- 
!
!------------------------------------------------ 
! BAND 1 (VISIBLE) INCLUDES O3 AND H2O ABSORPTION
!------------------------------------------------ 
    DO 260 K=1,L
        DO 260 I=MYIS,MYIE
            TTD(I,K+1) = EXP(HM1EZ  * MIN(FIFTY,ABCFF(1) * UD(I,K+1)))
            TTU(I,K  ) = EXP(HM1EZ  * MIN(FIFTY,ABCFF(1) * UR(I,K  )))
            DFN(I,K+1) = TTD(I,K+1) * TDO3(I,K+1)
            UFN(I,K  ) = TTU(I,K  ) * TUO3(I,K  )
260 END DO
!
    DO 270 I=MYIS,MYIE
        DFN(I,1  ) = ONE
        UFN(I,LP1) = DFN(I,LP1)
270 END DO
!----------------------------------------------------------------------------------- 
! SCALE VISIBLE BAND FLUXES BY SOLAR FLUX AT THE TOP OF THE ATMOSPHERE (DFNTOP(I,1)) 
! DFSW/UFSW WILL BE THE FLUXES, SUMMED OVER ALL BANDS
!-----------------------------------------------------------------------------------
    DO 280  K=1,LP1
        DO 280  I=MYIS,MYIE
            DFSWL(I,K) = DFN (I,K) * DFNTOP(I,1)
            UFSWL(I,K) = REFL(I)   * UFN   (I,K) * DFNTOP(I,1)
280 END DO
!
    DO 285 I=MYIS,MYIE
        GDFVB(I) = DFSWL(I,LP1)      * EXP(-0.15746 *      SECZ(I))
        GDFVD(I) = ((ONE - REFL2(I)) * DFSWL(I,LP1) - (ONE-ALVB(I)) * GDFVB(I)) / (ONE - ALVD(I))
        GDFNB(I) = ZERO
        GDFND(I) = ZERO
285 END DO
!--------------------------------------------------------------------------------------------------
! NOW OBTAIN FLUXES FOR THE NEAR IR BANDS. THE METHODS ARE THE SAME AS FOR THE VISIBLE BAND, EXCEPT
! THAT THE REFLECTION AND TRANSMISSION COEFFICIENTS (OBTAINED BELOW) ARE DIFFERENT, AS RAYLEIGH 
! SCATTERING NEED NOT BE CONSIDERED.
!--------------------------------------------------------------------------------------------------
    DO 350 N=2,NB
        IF (N == 2) THEN
!--------------------------------------------------------------------------------------------------
! THE WATER VAPOR TRANSMISSION FUNCTION FOR BAND 2 IS EQUAL TO THAT OF BAND 1 (SAVED AS TTD,TTU) 
! BAND 2-9 (NEAR-IR) INCLUDES O3, CO2 AND H2O ABSORPTION
!--------------------------------------------------------------------------------------------------
            DO 290 K=1,L
                DO 290 I=MYIS,MYIE
                    DFN(I,K+1) = TTD(I,K+1) * TDCO2(I,K+1)
                    UFN(I,K  ) = TTU(I,K  ) * TUCO2(I,K  )
        290 END DO
!
        ELSE
!---------------------------------------------------------------------------------- 
! CALCULATE WATER VAPOR TRANSMISSION FUNCTIONS FOR NEAR INFRARED BANDS. 
! INCLUDE CO2 TRANSMISSION (TDCO2/TUCO2), WHICH IS THE SAME FOR ALL INFRARED BANDS.
!----------------------------------------------------------------------------------
            DO 300 K=1,L
                DO 300 I=MYIS,MYIE
                    DFN(I,K+1) = EXP(HM1EZ * MIN(FIFTY, ABCFF(N) * UD(I,K+1))) * TDCO2(I,K+1)
                    UFN(I,K  ) = EXP(HM1EZ * MIN(FIFTY, ABCFF(N) * UR(I,K  ))) * TUCO2(I,K  )
        300 END DO
!
        END IF
!--------------------------------------------------------------------------------------------------
! AT THIS POINT,INCLUDE DFN(1),UFN(LP1), NOTING THAT DFN(1)=1 FOR ALL BANDS, AND THAT 
! UFN(LP1)=DFN(LP1) FOR ALL BANDS.
!--------------------------------------------------------------------------------------------------
        DO 310 I=MYIS,MYIE
            DFN(I,1)   = ONE
            UFN(I,LP1) = DFN(I,LP1)
    310 END DO
!------------------------------------------------------------------------------- 
! SCALE THE PREVIOUSLY COMPUTED FLUXES BY THE FLUX AT THE TOP AND SUM OVER BANDS
!-------------------------------------------------------------------------------
        DO 320 K=1,LP1
            DO 320 I=MYIS,MYIE
                DFSWL(I,K) = DFSWL(I,K)            + DFN(I,K) * DFNTOP(I,N)
                UFSWL(I,K) = UFSWL(I,K) + ALNB(I)  * UFN(I,K) * DFNTOP(I,N)
    320 END DO
!
        DO 330 I=MYIS,MYIE
            GDFNB(I) = GDFNB(I) + DFN(I,LP1) * DFNTOP(I,N)
    330 END DO
!
350 END DO
!
    DO 360 K=1,LP1
        DO 360 I=MYIS,MYIE
            FSWL(I,K) = UFSWL(I,K) - DFSWL(I,K)
360 END DO
!
    DO 370 K=1,L
        DO 370 I=MYIS,MYIE
            HSWL(I,K) = RADCON * (FSWL(I,K+1) - FSWL(I,K  )) / DP(I,K)
370 END DO
!------------------------------- 
! END OF FREQUENCY LOOP (OVER N)
!------------------------------- 
!
!----------------------------- 
! CALCULATE CLOUDY SKY SW FLUX
!----------------------------- 
    KCLDS=NCLDS(MYIS)
    DO 400 I=MYIS1,MYIE
        KCLDS = MAX(NCLDS(I), KCLDS)
400 END DO
!
    DO 410 K=1,LP1
        DO 410 I=MYIS,MYIE
            DFSWC(I,K) = DFSWL(I,K)
            UFSWC(I,K) = UFSWL(I,K)
            FSWC (I,K) = FSWL (I,K)
410 END DO
!
    DO 420 K=1,L
        DO 420 I=MYIS,MYIE
            HSWC(I,K) = HSWL(I,K)
420 END DO
!
    IF (KCLDS == 0)  RETURN
!
    DO 430 K=1,LP1
        DO 430 I=MYIS,MYIE
            XAMT(I,K) = CAMT(I,K)
430 END DO
!
    DO 470 I=MYIS,MYIE
        NNCLDS   = NCLDS(I)
        CCMAX(I) = ZERO
!
        IF (NNCLDS <= 0) GOTO 470
!
        CCMAX(I) = ONE
!
        DO 450 K=1,NNCLDS
            CCMAX(I) = CCMAX(I) * (ONE - CAMT(I,K+1))
    450 END DO
!
        CCMAX(I) = ONE - CCMAX(I)
!
        IF (CCMAX(I) > ZERO) THEN
            DO 460 K=1,NNCLDS
                XAMT(I,K+1) = CAMT(I,K+1) / CCMAX(I)
        460 END DO
        END IF
!
470 END DO
!
    DO 480 K=1,LP1
        DO 480 I=MYIS,MYIE
            FF   (I,K) =  DIFFCTR
            FFCO2(I,K) =  DIFFCTR
            FFO3 (I,K) = O3DIFCTR
480 END DO
!
    DO 490 IP=MYIS,MYIE
        JTOP = KTOPSW(IP, NCLDS(IP) + 1)
        DO 490 K=1,JTOP
            FF   (IP,K) = SECZ(IP)
            FFCO2(IP,K) = SECZ(IP)
            FFO3 (IP,K) = SECZ(IP)
490 END DO
!
    DO 500 I=MYIS,MYIE
        RRAY(I) = HP219   / (ONE + HP816 * COSZRO(I))
        REFL(I) = RRAY(I) + (ONE - RRAY(I)) * (ONE - RRAYAV) * ALVD(I)                  &
    &           /           (ONE - ALVD(I)  *        RRAYAV)
!
500 END DO
!
    DO 510 IP=MYIS,MYIE
        UD   (IP,1) = ZERO
        UDCO2(IP,1) = ZERO
        UDO3 (IP,1) = ZERO
510 END DO
!
    DO 520 K=2,LP1
        DO 520 I=MYIS,MYIE
            UD   (I,K) = UD   (I,K-1) + DU   (I,K-1) * FF   (I,K)
            UDCO2(I,K) = UDCO2(I,K-1) + DUCO2(I,K-1) * FFCO2(I,K)
            UDO3 (I,K) = UDO3 (I,K-1) + DUO3 (I,K-1) * FFO3 (I,K)
520 END DO
!
    DO 530 IP=MYIS,MYIE
        UR   (IP,LP1) = UD   (IP,LP1)
        URCO2(IP,LP1) = UDCO2(IP,LP1)
        URO3 (IP,LP1) = UDO3 (IP,LP1)
530 END DO
!
    DO 540 K=L,1,-1
        DO 540 IP=MYIS,MYIE
            UR   (IP,K) = UR   (IP,K+1) + DU   (IP,K) *  DIFFCTR
            URCO2(IP,K) = URCO2(IP,K+1) + DUCO2(IP,K) *  DIFFCTR
            URO3 (IP,K) = URO3 (IP,K+1) + DUO3 (IP,K) * O3DIFCTR
540 END DO
!
    DO 550 K=1,LL
        DO 550 I=MYIS,MYIE
            TCO2(I,K+1) = ONE - TWO * (H235M3 * EXP(HP26 * LOG(UCO2(I,K+1) + H129M2)) - H75826M4)
550 END DO
!
    DO 560 K=1,LL
        DO 560 I=MYIS,MYIE
            TO3(I,K+1) = ONE - TWO * UO3(I,K+1) * (H1P082 * EXP(HMP805 * LOG(ONE + H1386E2        &
    &                  * UO3(I,K+1))) + H658M2  / (ONE + HTEMP * UO3(I,K+1) * UO3(I,K+1)          &
    &                  * UO3(I,K+1))  + H2118M2 / (ONE         + UO3(I,K+1) * (H42M2 + H323M4     &
    &                  * UO3(I,K+1))))
560 END DO
!--------------------------------------------------------------------------------------------------
! THE FIRST CLOUD IS THE GROUND; ITS PROPERTIES ARE GIVEN BY REFL (THE TRANSMISSION (0) IS  
! IRRELEVANT FOR NOW!).
!--------------------------------------------------------------------------------------------------
    DO 570 I=MYIS,MYIE
        CR(I,1) = REFL(I)
570 END DO
!--------------------------------------------------------------------------------------------------
! OBTAIN CLOUD REFLECTION AND TRANSMISSION COEFFICIENTS FOR REMAINING CLOUDS (IF ANY) IN THE 
! VISIBLE BAND THE MAXIMUM NO OF CLOUDS IN THE ROW (KCLDS) IS USED. THIS CREATES EXTRA WORK 
! (MAY BE REMOVED IN A SUBSEQUENT UPDATE).
!--------------------------------------------------------------------------------------------------
    DO 581 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 581
!
        DO 580 KK=2,KCLDS+1
            CR(I,KK) =             CRR(I,1,KK)  * XAMT(I,KK)
            CT(I,KK)= ONE - (ONE - CTT(I,1,KK)) * XAMT(I,KK)
    580 END DO
581 END DO
!--------------------------------------------------------------------------------------------------
! OBTAIN THE PRESSURE AT THE TOP,BOTTOM AND THE THICKNESS OF "THICK" CLOUDS (THOSE AT LEAST 2 
! LAYERS THICK). THIS IS USED LATER IS OBTAINING FLUXES INSIDE THE THICK CLOUDS, FOR ALL FREQUENCY
! BANDS.
!--------------------------------------------------------------------------------------------------
    DO 591 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 591
!
        DO 590 KK=1,KCLDS
            IF ((KBTMSW(I,KK+1) - 1) > KTOPSW(I,KK+1)) THEN
                PPTOP(I,KK) =                      PP(I,KTOPSW(I,KK+1))
                DPCLD(I,KK) = ONE / (PPTOP(I,KK) - PP(I,KBTMSW(I,KK+1)))
            END IF
    590 END DO
591 END DO
!
    DO 600 K=1,L
        DO 600 I=MYIS,MYIE
            TTDB1(I,K+1) = EXP(HM1EZ    * MIN(FIFTY, ABCFF(1) * UD(I,K+1)))
            TTUB1(I,K  ) = EXP(HM1EZ    * MIN(FIFTY, ABCFF(1) * UR(I,K  )))
            TTD  (I,K+1) = TTDB1(I,K+1) * TDO3(I,K+1)
            TTU  (I,K  ) = TTUB1(I,K  ) * TUO3(I,K  )
    600 END DO
!
    DO 610 I=MYIS,MYIE
        TTD(I,1)=ONE
        TTU(I,LP1)=TTD(I,LP1)
610 END DO
!--------------------------------------------------------------------------------------------------
! FOR EXECUTION OF THE CLOUD LOOP, IT IS NECESSARY TO SEPARATE OUT TRANSMISSION FCTNS AT THE TOP 
! AND BOTTOM OF THE CLOUDS, FOR EACH BAND N. THE REQUIRED QUANTITIES ARE:
! TTD(I,KTOPSW(I,K),N)  K RUNS FROM 1 TO NCLDS(I)+1:
! TTU(I,KTOPSW(I,K),N)  K RUNS FROM 1 TO NCLDS(I)+1:
! TTD(I,KBTMSW(I,K),N)  K RUNS FROM 1 TO NCLDS(I)+1:
! AND INVERSES OF THE FIRST TWO. THE ABOVE QUANTITIES ARE STORED IN TDCL1, TUCL1, TDCL2, AND 
! DFNTRN, UFNTRN, RESPECTIVELY, AS THEY  HAVE MULTIPLE USE IN THE PGM. FOR FIRST CLOUD LAYER 
! (GROUND) TDCL1,TUCL1 ARE KNOWN:
!--------------------------------------------------------------------------------------------------
    DO 620 I=MYIS,MYIE
        TDCL1 (I,1) =       TTD   (I,LP1)
        TUCL1 (I,1) =       TTU   (I,LP1)
        TDCL2 (I,1) =       TDCL1 (I,1  )
        DFNTRN(I,1) = ONE / TDCL1 (I,1  )
        UFNTRN(I,1) =       DFNTRN(I,1  )
620 END DO
!
    DO 631 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 631
!
        DO 630 KK=2,KCLDS+1
            TDCL1(I,KK) = TTD(I,KTOPSW(I,KK))
            TUCL1(I,KK) = TTU(I,KTOPSW(I,KK))
            TDCL2(I,KK) = TTD(I,KBTMSW(I,KK))
    630 END DO
631 END DO
!----------------- 
! COMPUTE INVERSES
!-----------------
    DO 641 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 641
!
        DO 640 KK=2,KCLDS
            DFNTRN(I,KK) = ONE / TDCL1(I,KK)
            UFNTRN(I,KK) = ONE / TUCL1(I,KK)
    640 END DO
641 END DO
!-------------------------------------------------------------------------------------------------- 
! COMPUTE THE TRANSMISSIVITY FROM THE TOP OF CLOUD (K+1) TO THE TOP OF CLOUD (K). THE CLOUD 
! TRANSMISSION (CT) IS INCLUDED. THIS QUANTITY IS CALLED TCLU (INDEX K). ALSO, OBTAIN THE 
! TRANSMISSIVITY FROM THE BOTTOM OF CLOUD (K+1) TO THE TOP OF CLOUD (K)(A PATH ENTIRELY OUTSIDE 
! CLOUDS). THIS QUANTITY IS CALLED TCLD (INDEX K).
!--------------------------------------------------------------------------------------------------
    DO 651 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 651
!
        DO 650 KK=1,KCLDS
            TCLU(I,KK) = TDCL1(I,KK) * DFNTRN(I,KK+1) * CT(I,KK+1)
            TCLD(I,KK) = TDCL1(I,KK) /  TDCL2(I,KK+1)
    650 END DO
651 END DO
!--------------------------------------------------------------------------------------------------
! THE FOLLOWING IS THE RECURSION RELATION FOR ALFA: THE REFLECTION COEFFICIENT FOR A SYSTEM 
! INCLUDING THE CLOUD IN QUESTION AND THE FLUX COMING OUT OF THE CLOUD SYSTEM INCLUDING ALL CLOUDS 
! BELOW THE CLOUD IN QUESTION. ALFAU IS ALFA WITHOUT THE REFLECTION OF THE CLOUD IN QUESTION
!--------------------------------------------------------------------------------------------------
    DO 660 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 660
!
        ALFA (I,1) = CR(I,1)
        ALFAU(I,1) = ZERO
660 END DO
!--------------------------------------------------- 
! AGAIN,EXCESSIVE CALCULATIONS-MAY BE CHANGED LATER!
!--------------------------------------------------- 
    DO 671 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 671
!
        DO 670 KK=2,KCLDS+1
            ALFAU(I,KK) =  TCLU(I,KK-1) * TCLU(I,KK-1) * ALFA(I,KK-1) / (ONE - TCLD(I,KK-1)       &
    &                   *  TCLD(I,KK-1) * ALFA(I,KK-1) *   CR(I,KK))
!
            ALFA (I,KK) = ALFAU(I,KK)   +   CR(I,KK)
    670 END DO
671 END DO
!--------------------------------------------------------------------------------------------------
! CALCULATE UFN AT CLOUD TOPS AND DFN AT CLOUD BOTTOMS NOTE THAT UFNCLU(I,KCLDS+1) GIVES THE UPWARD
! FLUX AT THE TOP OF THE HIGHEST REAL CLOUD (IF NCLDS(I)=KCLDS). IT GIVES THE FLUX AT THE TOP OF 
! THE ATMOSPHERE IF NCLDS(I) < KCLDS. IN THE FIRST CASE, TDCL1 EQUALS THE TRANSMISSION FCTN TO THE 
! TOP OF THE HIGHEST CLOUD, AS WE WANT. IN THE SECOND CASE, TDCL1=1, SO UFNCLU EQUALS ALFA. 
! THIS IS ALSO CORRECT.
!--------------------------------------------------------------------------------------------------
    DO 680 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 680
!
        UFNCLU(I,KCLDS+1) =  ALFA(I,KCLDS+1) * TDCL1(I,KCLDS+1)
        DFNCLU(I,KCLDS+1) = TDCL1(I,KCLDS+1)
680 END DO
!--------------------------------------------------------------------- 
! THIS CALCULATION IS THE REVERSE OF THE RECURSION RELATION USED ABOVE
!--------------------------------------------------------------------- 
    DO 691 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 691
!
        DO 690 KK=KCLDS,1,-1
            UFNCLU(I,KK) = UFNCLU(I,KK+1) * ALFAU(I,KK+1) / (ALFA(I,KK+1) * TCLU(I,KK))
            DFNCLU(I,KK) = UFNCLU(I,KK)   /  ALFA(I,KK)
    690 END DO
691 END DO
!
    DO 701 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 701
!
        DO 700 KK=1,KCLDS+1
            UFNTRN(I,KK) = UFNCLU(I,KK) * UFNTRN(I,KK)
            DFNTRN(I,KK) = DFNCLU(I,KK) * DFNTRN(I,KK)
    700 END DO
701 END DO
!-----------------------------------------------------------------  
! CASE OF KK=1( FROM THE GROUND TO THE BOTTOM OF THE LOWEST CLOUD)
!----------------------------------------------------------------- 
    DO 720 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 720
!
        J2 = KBTMSW(I,2)
        DO 710 K=J2,LP1
            UFN(I,K) = UFNTRN(I,1) * TTU(I,K)
            DFN(I,K) = DFNTRN(I,1) * TTD(I,K)
    710 END DO
720 END DO
!--------------------------- 
! REMAINING LEVELS (IF ANY!)
!--------------------------- 
    DO 760 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 760
!
        DO 755 KK=2,KCLDS+1
            J1 = KTOPSW(I,KK)
            J2 = KBTMSW(I,KK+1)
!
            IF (J1 == 1) GOTO 755
!
            DO 730 K=J2,J1
                UFN(I,K) = UFNTRN(I,KK) * TTU(I,K)
                DFN(I,K) = DFNTRN(I,KK) * TTD(I,K)
        730 END DO
!--------------------------------------------------------------------------------------------------  
! FOR THE THICK CLOUDS, THE FLUX DIVERGENCE THROUGH THE CLOUD LAYER IS ASSUMED TO BE CONSTANT. THE 
! FLUX DERIVATIVE IS GIVEN BY TEMPF (FOR THE UPWARD FLUX) AND TEMPG (FOR THE DOWNWARD FLUX).
!--------------------------------------------------------------------------------------------------
            J3 = KBTMSW(I,KK)
!
            IF ((J3-J1) > 1) THEN
                TEMPF = (UFNCLU(I,KK) - UFN(I,J3)) * DPCLD(I,KK-1)
                TEMPG = (DFNCLU(I,KK) - DFN(I,J3)) * DPCLD(I,KK-1)
                DO 740 K=J1+1,J3-1
                    UFN(I,K) = UFNCLU(I,KK) + TEMPF * (PP(I,K) - PPTOP(I,KK-1))
                    DFN(I,K) = DFNCLU(I,KK) + TEMPG * (PP(I,K) - PPTOP(I,KK-1))
            740 END DO
            END IF
!
    755 END DO
!
760 END DO
!
    DO 770 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 770
!
        DO 771 K=1,LP1
            DFSWC(I,K) = DFN(I,K) * DFNTOP(I,1)
            UFSWC(I,K) = UFN(I,K) * DFNTOP(I,1)
    771 END DO
770 END DO
!
    DO 780 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 780
!
        TMP1 (I) = ONE     - CCMAX(I)
        GDFVB(I) = TMP1(I) * GDFVB(I)
        GDFNB(I) = TMP1(I) * GDFNB(I)
        GDFVD(I) = TMP1(I) * GDFVD(I) + CCMAX(I) * DFSWC(I,LP1)
780 END DO
!-------------------------------------------------------------------------------------------------- 
! NOW OBTAIN FLUXES FOR THE NEAR IR BANDS. THE METHODS ARE THE SAME AS FOR THE VISIBLE BAND, EXCEPT
! THAT THE REFLECTION AND TRANSMISSION COEFFICIENTS ARE DIFFERENT, AS RAYLEIGH SCATTERING NEED NOT 
! BE CONSIDERED.
!-------------------------------------------------------------------------------------------------- 
    DO 991 N=2,NB
!
        DO 791 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 791
!
            DO 790 K=1,KCLDS+1
                CR(I,K) =              CRR(I,N,K)  * XAMT(I,K)
                CT(I,K) = ONE - (ONE - CTT(I,N,K)) * XAMT(I,K)
        790 END DO
    791 END DO
!
        IF (N == 2) THEN
!-------------------------------------------------------------------------------------------------- 
! THE WATER VAPOR TRANSMISSION FUNCTION FOR BAND 2 IS EQUAL TO THAT OF BAND 1
! (SAVED AS TTDB1,TTUB1)
!--------------------------------------------------------------------------------------------------
            DO 800 I=MYIS,MYIE
                KCLDS = NCLDS(I)
!
                IF (KCLDS == 0) GOTO 800
!
                DO 801 KK=2,LP1
                    TTD(I,KK) = TTDB1(I,KK) * TDCO2(I,KK)
            801 END DO
!
                DO 802 KK=1,L
                    TTU(I,KK) = TTUB1(I,KK) * TUCO2(I,KK)
            802 END DO
!
        800 END DO
!
        ELSE
!
            DO 810 I=MYIS,MYIE
                KCLDS = NCLDS(I)
!
                IF (KCLDS == 0) GOTO 810
!
                DO 811 KK=2,LP1
                    TTD(I,KK) = EXP(HM1EZ * MIN(FIFTY, ABCFF(N) * UD(I,KK))) * TDCO2(I,KK)
            811 END DO
!
                DO 812 KK=1,L
                    TTU(I,KK) = EXP(HM1EZ * MIN(FIFTY, ABCFF(N) * UR(I,KK))) * TUCO2(I,KK)
            812 END DO
!
        810 END DO
!
        END IF
!--------------------------------------------------------------------------------------------------
! AT THIS POINT,INCLUDE TTD(1),TTU(LP1), NOTING THAT TTD(1)=1 FOR ALL BANDS, AND THAT
! TTU(LP1)=TTD(LP1) FOR ALL BANDS.
!--------------------------------------------------------------------------------------------------
        DO 820 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 820
!
            TTU(I,LP1) = TTD(I,LP1)
            TTD(I,1)   = ONE
    820 END DO
!--------------------------------------------------------------------------------------------------
! FOR EXECUTION OF THE CLOUD LOOP, IT IS NECESSARY TO SEPARATE OUT TRANSMISSION FCTNS AT THE TOP 
! AND BOTTOM OF THE CLOUDS, FOR EACH BAND N. THE REQUIRED QUANTITIES ARE:
! TTD(I,KTOPSW(I,K),N)  K RUNS FROM 1 TO NCLDS(I)+1:
! TTD(I,KBTMSW(I,K),N)  K RUNS FROM 2 TO NCLDS(I)+1:
! TTU(I,KTOPSW(I,K),N)  K RUNS FROM 1 TO NCLDS(I)+1:
! AND INVERSES OF THE ABOVE. THE ABOVE QUANTITIES ARE STORED IN TDCL1, TDCL2, TUCL1, AND DFNTRN,
! UFNTRN, RESPECTIVELY, AS THEY HAVE MULTIPLE USE IN THE PGM. FOR FIRST CLOUD LAYER (GROUND) 
! TDCL1, TUCL1 ARE KNOWN:
!--------------------------------------------------------------------------------------------------
        DO 830 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 830
!
            TDCL1 (I,1) =       TTD   (I,LP1)
            TUCL1 (I,1) =       TTU   (I,LP1)
            TDCL2 (I,1) =       TDCL1 (I,1)
            DFNTRN(I,1) = ONE / TDCL1 (I,1)
            UFNTRN(I,1) =       DFNTRN(I,1)
    830 END DO
!
        DO 841 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 841
!
            DO 840 KK=2,KCLDS+1
                TDCL1(I,KK) = TTD(I,KTOPSW(I,KK))
                TUCL1(I,KK) = TTU(I,KTOPSW(I,KK))
                TDCL2(I,KK) = TTD(I,KBTMSW(I,KK))
        840 END DO
!
    841 END DO
!
        DO 851 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 851
!
            DO 850 KK=2,KCLDS+1
                DFNTRN(I,KK) = ONE / TDCL1(I,KK)
                UFNTRN(I,KK) = ONE / TUCL1(I,KK)
        850 END DO
!
    851 END DO
!
        DO 861 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 861
!
            DO 860 KK=1,KCLDS
                TCLU(I,KK) = TDCL1(I,KK) * DFNTRN(I,KK+1) * CT(I,KK+1)
                TCLD(I,KK) = TDCL1(I,KK) /  TDCL2(I,KK+1)
        860 END DO
    861 END DO
!--------------------------------------------------------------------------------------------------
! THE FOLLOWING IS THE RECURSION RELATION FOR ALFA: THE REFLECTION COEFFICIENT FOR A SYSTEM 
! INCLUDING THE CLOUD IN QUESTION AND THE FLUX COMING OUT OF THE CLOUD SYSTEM INCLUDING ALL CLOUDS 
! BELOW THE CLOUD IN QUESTION.
!--------------------------------------------------------------------------------------------------
        DO 870 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 870
!
            ALFA (I,1) = CR(I,1)
            ALFAU(I,1) = ZERO
    870 END DO
!--------------------------------------------------- 
! AGAIN, EXCESSIVE CALCULATIONS-MAY BE CHANGED LATER
!---------------------------------------------------
        DO 881 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 881
!
            DO 880 KK=2,KCLDS+1
                ALFAU(I,KK) = TCLU (I,KK-1) * TCLU(I,KK-1) * ALFA(I,KK-1) / (ONE - TCLD(I,KK-1)   &
    &                       * TCLD (I,KK-1) * ALFA(I,KK-1) *   CR(I,KK))
!                
                ALFA (I,KK) = ALFAU(I,KK)   +   CR(I,KK)
        880 END DO
!
    881 END DO
!-------------------------------------------------------------------------------------------------- 
! CALCULATE UFN AT CLOUD TOPS AND DFN AT CLOUD BOTTOMS NOTE THAT UFNCLU(I,KCLDS+1) GIVES THE UPWARD
! FLUX AT THE TOP OF THE HIGHEST REAL CLOUD (IF NCLDS(I)=KCLDS). IT GIVES THE FLUX AT THE TOP OF 
! THE ATMOSPHERE IF NCLDS(I) < KCLDS. IT THE FIRST CASE, TDCL1  EQUALS THE TRANSMISSION FCTN TO THE
! TOP OF THE HIGHEST CLOUD, AS WE WANT. IN THE SECOND CASE, TDCL1=1, SO UFNCLU EQUALS ALFA. 
! THIS IS ALSO CORRECT.
!-------------------------------------------------------------------------------------------------- 
        DO 890 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF(KCLDS == 0) GOTO 890
!
            UFNCLU(I,KCLDS+1) = ALFA (I,KCLDS+1) * TDCL1(I,KCLDS+1)
            DFNCLU(I,KCLDS+1) = TDCL1(I,KCLDS+1)
    890 END DO
!
        DO 901 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 901
!
            DO 900 KK=KCLDS,1,-1
!--------------------------------------------------------------------------------------------------            
! FERRIER, 6/17/02:  EMERGENCY CHANGE TO ELIMINATE PROBLEMATIC FEATURES OF UNREALISTICALLY SMALL 
! CLOUD AMOUNTS
!--------------------------------------------------------------------------------------------------   
                DENOM = ALFA(I,KK+1) * TCLU(I,KK)
                IF (DENOM > 1.E-15) THEN
                    UFNCLU(I,KK) = UFNCLU(I,KK+1) * ALFAU(I,KK+1) / DENOM
                ELSE
                    UFNCLU(I,KK) = 0.
                END IF
!
                DFNCLU(I,KK) = UFNCLU(I,KK)   / ALFA (I,KK)
        900 END DO
    901 END DO
!----------------------------------------------------- 
! NOW OBTAIN DFN AND UFN FOR LEVELS BETWEEN THE CLOUDS
!----------------------------------------------------- 
        DO 911 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 911
!
            DO 910 KK=1,KCLDS+1
                UFNTRN(I,KK) = UFNCLU(I,KK) * UFNTRN(I,KK)
                DFNTRN(I,KK) = DFNCLU(I,KK) * DFNTRN(I,KK)
        910 END DO
    911 END DO
!
        DO 930 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 930
!
            J2 = KBTMSW(I,2)
            DO 920 K=J2,LP1
                UFN(I,K) = UFNTRN(I,1) * TTU(I,K)
                DFN(I,K) = DFNTRN(I,1) * TTD(I,K)
        920 END DO
    930 END DO
!
        DO 970  I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 970
!
            DO 965  KK=2,KCLDS+1
                J1 = KTOPSW(I,KK)
                J2 = KBTMSW(I,KK+1)
!
                IF (J1 == 1) GOTO 965
!
                DO 940 K=J2,J1
                    UFN(I,K) =     UFNTRN(I,KK) * TTU(I,K)
                    DFN(I,K) =     DFNTRN(I,KK) * TTD(I,K)
            940 END DO
!
                J3 = KBTMSW(I,KK)
                IF ((J3-J1) > 1) THEN
                    TEMPF   =     (UFNCLU(I,KK) - UFN(I,J3)) * DPCLD(I,KK-1)
                    TEMPG   =     (DFNCLU(I,KK) - DFN(I,J3)) * DPCLD(I,KK-1)
                    DO 950 K=J1+1,J3-1
                        UFN(I,K) = UFNCLU(I,KK) + TEMPF      * (PP(I,K) - PPTOP(I,KK-1))
                        DFN(I,K) = DFNCLU(I,KK) + TEMPG      * (PP(I,K) - PPTOP(I,KK-1))
                950 END DO
                END IF
!
        965 END DO
!
    970 END DO
!
        DO 980 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 980
!
            DO 981 K=1,LP1
                DFSWC(I,K) = DFSWC(I,K) + DFN(I,K) * DFNTOP(I,N)
                UFSWC(I,K) = UFSWC(I,K) + UFN(I,K) * DFNTOP(I,N)
        981 END DO
!
    980 END DO
!
        DO 990 I=MYIS,MYIE
            KCLDS = NCLDS(I)
!
            IF (KCLDS == 0) GOTO 990
!
            GDFND(I) = GDFND(I) + CCMAX(I) * DFN(I,LP1) * DFNTOP(I,N)
     990 END DO
!
991 END DO
!
    DO 992 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 992
!
        DO 993 K=1,LP1
            DFSWC(I,K) = TMP1(I) * DFSWL(I,K) + CCMAX(I) * DFSWC(I,K)
            UFSWC(I,K) = TMP1(I) * UFSWL(I,K) + CCMAX(I) * UFSWC(I,K)
    993 END DO
992 END DO
!
    DO 994 I=MYIS,MYIE
        KCLDS = NCLDS(I)
!
        IF (KCLDS == 0) GOTO 994
!
        DO 995 KK=1,LP1
            FSWC(I,KK) = UFSWC(I,KK) - DFSWC(I,KK)
    995 END DO
994 END DO
!
    DO 996 I=MYIS,MYIE
        KCLDS=NCLDS(I)
!
        IF (KCLDS == 0) GOTO 996
!
        DO 997 KK=1, L
            HSWC(I,KK) = RADCON * (FSWC(I,KK+1) - FSWC(I,KK)) / DP(I,KK)
    997 END DO
996 END DO
!
    RETURN
!
    END SUBROUTINE SWR93

    MODULE TABCOM
!>--------------------------------------------------------------------------------------------------
!> MODULE TABCOM
!>
!> ABSTRACT:
!> MODULE TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE TABLE FOR USE IN THE LONGWAVE 
!> RADIATION PROGRAM:
!>
!> USE MODULES: F77KINDS
!>              RDPARM
!> 
!> DRIVER     : E1E290
!>              E290
!>              E2SPEC
!>              E3V88
!>              FST88
!>              RADFS
!>              TABLE 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE RDPARM  , ONLY : IMAX, LP1, LP1V, NBLY
!
    IMPLICIT NONE
!
    SAVE
!--------------------------------------------------------------------------------------------
! EM1    - E1 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! EM1WDE - E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1 INTERVAL
! TABLE1 - E2 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! TABLE2 - TEMPERATURE DERIVATIVE OF TABLE1
! TABLE3 - MASS DERIVATIVE OF TABLE1
! EM3    - E3 FUNCTION, EVALUATED OVER THE 0-560 AND 1200-2200 CM-1 INTERVALS
! SOURCE - PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR BANDS USED IN CTS CALCULATIONS
! DSRCE  - TEMPERATURE DERIVATIVE OF SOURCE
! IND    - INDEX, WITH VALUE IND(I)=I. USED IN FST88
! INDX2  - INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE" ELEMENTS OF AVEPHI, ETC., IN FST88
! KMAXV  - INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE" ELEMENTS OF AVEPHI, ETC., IN FST88
! KMAXVM - KMAXV(L),USED FOR DO LOOP INDICES
!--------------------------------------------------------------------------------------------
    INTEGER(KIND=I4KIND), DIMENSION(IMAX)                                                       ::&
    & IND
!
    INTEGER(KIND=I4KIND), DIMENSION(LP1V)                                                       ::&
    & INDX2
!
    INTEGER(KIND=I4KIND), DIMENSION(LP1)                                                        ::&
    & KMAXV
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & KMAXVM  
!
    REAL   (KIND=R4KIND), DIMENSION(28, 180)                                                    ::&
    & EM1     , EM1WDE  , TABLE1  , TABLE2  , TABLE3  , EM3
!
    REAL   (KIND=R4KIND), DIMENSION(28, NBLY)                                                   ::&
    & SOURCE  , DSRCE
!-----------------------------------  
! VARIABLES EQUIVALENCED FROM E1E290
!-----------------------------------  
    REAL   (KIND=R4KIND), DIMENSION(5040)                                                       ::&
    & T1      , T2      , T4      , EM1V    , EM1VW 
!
    EQUIVALENCE (EM1V(1),    EM1(1,1)), (EM1VW(1), EM1WDE(1,1))
    EQUIVALENCE (  T1(1), TABLE1(1,1)), (   T2(1), TABLE2(1,1))
    EQUIVALENCE (  T4(1), TABLE3(1,1)) 
!----------------------------------  
! VARIABLES EQUIVALENCED FROM E3V88
!----------------------------------
    REAL   (KIND=I4KIND), DIMENSION(5040)                                                       ::&
    & EM3V
!
    EQUIVALENCE (EM3V(1) , EM3(1,1))  
!
    END MODULE TABCOM

    SUBROUTINE READ_OUT2RESTRT(TSTART)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_OUT2RESTRT
!>
!> SUBPROGRAM: READ_OUT2RESTRT - 
!>
!> DRIVER     : INIT
!>              INITS
!>
!>--------------------------------------------------------------------------------------------------
    USE ABCI        !andre check
    USE ACMCLD      !andre check
    USE ACMCLH      !andre check
    USE ACMPRE      !andre check
    USE ACMRDL      !andre check
    USE ACMRDS      !andre check
    USE ACMSFC      !andre check
    USE ASTSAV      !andre check
    USE BANDTA      !andre check
    USE BDCOMB      !andre check
    USE BDWIDE      !andre check
    USE BOCO        !andre check
    USE BUFFER      !andre check
    USE C_FRACN     !andre check
    USE CLDWTR      !andre check
    USE CMICRO_CONS !andre check
    USE CMICRO_START!andre check
    USE CMICRO_STATS!andre check
    USE CMY600      !andre check  
    USE CNVCLD      !andre check
    USE CO2BD2      !andre check
    USE CO2BD3      !andre check
    USE CO2BD4      !andre check
    USE CO2BD5      !andre check
    USE COMPVS0     !andre check    
    USE COMPVS      !andre check
    USE CONTIN      !andre check   
    USE C_TADJ      !andre check    
    USE CTLBLK      !andre check
    USE CUINIT      !andre check
    USE DIUCON      !andre check
    USE DYNAM       !andre check
    USE MODULE EXCH_BUF_REAL!andre check
    USE GLB_TABLE   !andre check
    USE HCON
    USE IACCR_TABLES!andre check
    USE IMASS_TABLES!andre check
    USE INDX        !andre check
    USE INPUT       !andre check
    USE IRATE_TABLES!andre check
    USE IRIME_TABLES!andre check
    USE IVENT_TABLES!andre check
    USE LOOPS       !andre check
    USE MAPOT       !andre check
    USE MAPPINGS    !andre check
    USE MASKS       !andre check
    USE MOMENTO     !andre check
    USE MPPCOM
    USE NHYDRO      !andre check
    USE NSOILTYPE   !andre check
    USE OPTIONS     !andre check
    USE OUTFIL      !andre check  
    USE PHYCON      !andre check 
    USE PHYS        !andre check 
    USE PPTASM      !andre check
    USE PRFHLD      !andre check
    USE PVRBLS      !andre check
    USE RACCR_TABLES!andre check
    USE RD1TIM      !andre check
    USE RDFSAV      !andre check
    USE RITE        !andre check
    USE RMASS_TABLES!andre check
    USE RRATE_TABLES!andre check   
    USE RVELR_TABLES!andre check   
    USE RVENT_TABLES!andre check
    USE SAVEMEM     !andre check
    USE SCRTCH      !andre check
    USE SDENS_TABLES!andre check
    USE SEASO3      !andre check
    USE SLOPES      !andre check
    USE SOIL        !andre check
    USE SSALB       !andre check
    USE SWRSAV      !andre check
    USE TABCOM
    USE TEMPV       !andre check
    USE TOPO        !andre check
    USE VRBLS       !andre check
    USE UPDT
    USE Z0EFFT      !andre check
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & ITAG,  LISTOUT 
!    
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART
!
    CHARACTER(LEN=6)                                                                            ::&
    & C_NHRS     
!   
    CHARACTER(LEN=4)                                                                            ::&
    & C_MYPE     
!   
    CHARACTER(LEN=150)                                                                          ::&
    & OUTFILE 
!
    ITAG=TSTART
    WRITE(C_NHRS,'(I6.6)') ITAG  
!
    WRITE(C_MYPE,'(I4.4)') MYPE
!            
    OUTFILE = "OUT2RESTRT/OUT2RESTRT_"//C_MYPE//"."//C_NHRS
!
    LISTOUT=1001
!
    OPEN (UNIT=LISTOUT, FILE= TRIM(OUTFILE), FORM = 'UNFORMATTED')
!
!MODULE_ABCI
         READ(LISTOUT) NSOLD
         READ(LISTOUT) AI
	 READ(LISTOUT) BI
!MODULE ACMCLD
	 READ(LISTOUT) NCLOD    
	 READ(LISTOUT) TCLOD      
	 READ(LISTOUT) NCFRCV
	 READ(LISTOUT) NCFRST
	 READ(LISTOUT) ACFRCV
	 READ(LISTOUT) ACFRST  
!MODULE_ACMCLH 
         READ(LISTOUT) NHEAT
         READ(LISTOUT) THEAT
         READ(LISTOUT) AVRAIN
         READ(LISTOUT) AVCNVC
         READ(LISTOUT) ARATIM
         READ(LISTOUT) ACUTIM
         READ(LISTOUT) TRAIN
         READ(LISTOUT) TCUCN 
!MODULE_ACMPRE
	 READ(LISTOUT) TPREC
         READ(LISTOUT) ACSNOW
         READ(LISTOUT) ACSNOM 
         READ(LISTOUT) SSROFF
         READ(LISTOUT) BGROFF 
!MODULE_ACMRDL
	 READ(LISTOUT) NRDLW
	 READ(LISTOUT) ARDLW
	 READ(LISTOUT) TRDLW
         READ(LISTOUT) RLWIN
         READ(LISTOUT) RLWOUT 
         READ(LISTOUT) RLWTOA 
         READ(LISTOUT) ALWIN
         READ(LISTOUT) ALWOUT
         READ(LISTOUT) ALWTOA 
         READ(LISTOUT) RLWTT 
!MODULE_ACMRDS
	 READ(LISTOUT) NRDSW 
	 READ(LISTOUT) ARDSW
	 READ(LISTOUT) TRDSW
         READ(LISTOUT) RSWIN 
         READ(LISTOUT) RSWOUT
         READ(LISTOUT) RSWTOA
         READ(LISTOUT) ASWIN
         READ(LISTOUT) ASWOUT
         READ(LISTOUT) ASWTOA
         READ(LISTOUT) RSWTT
!MODULE_ACMSFC
	 READ(LISTOUT) NSRFC
	 READ(LISTOUT) ASRFC
	 READ(LISTOUT) TSRFC
	 READ(LISTOUT) APHTIM
	 READ(LISTOUT) SFCSHX
	 READ(LISTOUT) SFCLHX  								     &
	 READ(LISTOUT) SUBSHX 
	 READ(LISTOUT) SNOPCX  								     &
	 READ(LISTOUT) SFCUVX 
	 READ(LISTOUT) SFCEVP  								     &
	 READ(LISTOUT) POTEVP  
	 READ(LISTOUT) POTFLX
!MODULE_ASTSAV
	 READ(LISTOUT) SOLC    
	 READ(LISTOUT) RSIN1
	 READ(LISTOUT) RCOS1
	 READ(LISTOUT) RCOS2
!MODULE_BANDTA
         READ(LISTOUT) ARNDM
	 READ(LISTOUT) BRNDM  
	 READ(LISTOUT) BETAD   
	 READ(LISTOUT) AP     
	 READ(LISTOUT) BP      
	 READ(LISTOUT) ATP    
	 READ(LISTOUT) BTP    
	 READ(LISTOUT) BANDLO
	 READ(LISTOUT) BANDHI
         READ(LISTOUT) AO3RND  
	 READ(LISTOUT) BO3RND
	 READ(LISTOUT) AB15
         READ(LISTOUT) ARNDM1
	 READ(LISTOUT) ARNDM2  							
         READ(LISTOUT) BRNDM1  
         READ(LISTOUT) BRNDM2  							
         READ(LISTOUT) AP1    
         READ(LISTOUT) AP2     							
         READ(LISTOUT) BP1    
         READ(LISTOUT) BP2     							
         READ(LISTOUT) ATP1   
         READ(LISTOUT) ATP2    							
         READ(LISTOUT) BTP1   
         READ(LISTOUT) BTP2    							
         READ(LISTOUT) BETAD1  
         READ(LISTOUT) BETAD2  							
         READ(LISTOUT) BANDL1  
         READ(LISTOUT) BANDL2  							
         READ(LISTOUT) BANDH1 
         READ(LISTOUT) BANDH2   
         READ(LISTOUT) ARNDM3  							
         READ(LISTOUT) BRNDM3  							
         READ(LISTOUT) AP3     							
         READ(LISTOUT) BP3     							
         READ(LISTOUT) ATP3    							
         READ(LISTOUT) BTP3    							
         READ(LISTOUT) BETAD3  							
         READ(LISTOUT) BANDL3  							
         READ(LISTOUT) BANDH3
!MODULE_BDCOMB
         READ(LISTOUT) IBAND
         READ(LISTOUT) ACOMB
         READ(LISTOUT) BCOMB
         READ(LISTOUT) BETACM
         READ(LISTOUT) APCM
         READ(LISTOUT), BPCM
         READ(LISTOUT) ATPCM
         READ(LISTOUT) BTPCM
         READ(LISTOUT) BDLOCM
         READ(LISTOUT) BDHICM
         READ(LISTOUT) AB15CM
         READ(LISTOUT) AO3CM 
         READ(LISTOUT) BO3CM
         READ(LISTOUT) BETINC
!MODULE_BDWIDE
         READ(LISTOUT) AWIDE  
         READ(LISTOUT) BWIDE  
         READ(LISTOUT) BETAWD 
         READ(LISTOUT) APWD   
         READ(LISTOUT) BPWD   
         READ(LISTOUT) ATPWD  
         READ(LISTOUT) BTPWD  
         READ(LISTOUT) BDLOWD 
         READ(LISTOUT) BDHIWD 
         READ(LISTOUT) BETINW 
         READ(LISTOUT) AB15WD 
         READ(LISTOUT) SKO2D  
         READ(LISTOUT) SKC1R	
         READ(LISTOUT) SKO3R
!MODULE_BOCO	 
	 READ(LISTOUT) PDB
	 READ(LISTOUT) TB
	 READ(LISTOUT) QB
	 READ(LISTOUT) UB
	 READ(LISTOUT) VB
	 READ(LISTOUT) Q2B
	 READ(LISTOUT) CWMB     
!MODULE_BUFFER
	 READ(LISTOUT) IP
	 READ(LISTOUT) BUF
!MODULE_C_FRACN
	 READ(LISTOUT) F_ICE	   									  
	 READ(LISTOUT) F_RAIN     									  
	 READ(LISTOUT) F_RIMEF
!MODULE_CLDWTR
	 READ(LISTOUT) CWM
	 READ(LISTOUT) LC
	 READ(LISTOUT) U00
	 READ(LISTOUT) SR
	 READ(LISTOUT) UL
!MODULE_CMICRO_CONS
	 READ(LISTOUT)	ABFR		  
	 READ(LISTOUT)	CBFR	
	 READ(LISTOUT) CIACW 
	 READ(LISTOUT)	CIACR	      
	 READ(LISTOUT) C_N0R0
	 READ(LISTOUT)	CN0R0	      
	 READ(LISTOUT) CN0R_DMRMIN
	 READ(LISTOUT)	CN0R_DMRMAX   
	 READ(LISTOUT) CRACW 
	 READ(LISTOUT)	CRAUT	      
	 READ(LISTOUT) ESW0  
	 READ(LISTOUT)	QAUT0	
	 READ(LISTOUT)	RFMAX	
	 READ(LISTOUT)	RHGRD	      
	 READ(LISTOUT) RQR_DR1
	 READ(LISTOUT)	RQR_DR2 
	 READ(LISTOUT)	RQR_DR3 
	 READ(LISTOUT)	RQR_DRMIN
	 READ(LISTOUT)	RQR_DRMAX
	 READ(LISTOUT) RR_DR1
	 READ(LISTOUT)	RR_DR2  
	 READ(LISTOUT)	RR_DR3  
	 READ(LISTOUT)	RR_DRMIN	  
	 READ(LISTOUT)	RR_DRMAX
!MODULE_CMICRO_START
         READ(LISTOUT)	CMICRO_START
!MODULE_CMICRO_STATS
         READ(LISTOUT)	NSTATS
         READ(LISTOUT)	QMAX
         READ(LISTOUT)	QTOT
!MODULE_CMY600
         READ(LISTOUT)	MY_GROWTH
!MODULE_CNVCLD
         READ(LISTOUT)	CUPPT
	 READ(LISTOUT) CFRACL  
	 READ(LISTOUT) CFRACM 
	 READ(LISTOUT) CFRACH
!MODULE_CO2BD2
	 READ(LISTOUT)CO231
	 READ(LISTOUT)CO238
	 READ(LISTOUT)CDT31
	 READ(LISTOUT)CDT38
	 READ(LISTOUT)C2D31
	 READ(LISTOUT)C2D38
!MODULE_CO2BD3
	 READ(LISTOUT)CO251
	 READ(LISTOUT)CO258
	 READ(LISTOUT)CDT51
	 READ(LISTOUT)CDT58
	 READ(LISTOUT)C2D51
	 READ(LISTOUT)C2D58
	 READ(LISTOUT)CO2M51
	 READ(LISTOUT)CO2M58
	 READ(LISTOUT)CDTM51
	 READ(LISTOUT)CDTM58
	 READ(LISTOUT)C2DM51
	 READ(LISTOUT)C2DM58 
	 READ(LISTOUT)STEMP
	 READ(LISTOUT)GTEMP
!MODULE_CO2BD4
	 READ(LISTOUT) CO271
	 READ(LISTOUT) CO278
	 READ(LISTOUT) CDT71
	 READ(LISTOUT) CDT78
 	 READ(LISTOUT) C2D71
 	 READ(LISTOUT) C2D78
!MODULE_CO2BD5
         READ(LISTOUT) CO211
	 READ(LISTOUT) CO218
!MODULE_COMPVS0
         READ(LISTOUT) C1XPVS0
         READ(LISTOUT) C2XPVS0
         READ(LISTOUT) TBPVS0
!MODULE_COMPVS
         READ(LISTOUT) C1XPVS
         READ(LISTOUT) C2XPVS
         READ(LISTOUT) TBPVS
!MODULE_CONTIN
	 READ(LISTOUT) PDSL
         READ(LISTOUT) PDSLO
	 READ(LISTOUT) PSDT
	 READ(LISTOUT) RTOP
	 READ(LISTOUT) OMGALF
	 READ(LISTOUT) DIV
	 READ(LISTOUT) ETADT
!MODULE_C_TADJ
 	 READ(LISTOUT) T_ADJ
	 READ(LISTOUT) T_OLD
!MODULE_CTLBLK
 	 READ(LISTOUT) RUN 
 	 READ(LISTOUT) FIRST   
 	 READ(LISTOUT) RESTRT  
 	 READ(LISTOUT) SIGMA   
 	 READ(LISTOUT) NEST    
 	 READ(LISTOUT) SINGLRST
 	 READ(LISTOUT) SUBPOST
 	 READ(LISTOUT) IHRST   
 	 READ(LISTOUT) NFCST   
 	 READ(LISTOUT) NBC     
 	 READ(LISTOUT) LIST    
 	 READ(LISTOUT) IOUT    
 	 READ(LISTOUT) NTSD    
 	 READ(LISTOUT) NTSTM   
 	 READ(LISTOUT) NSTART  
 	 READ(LISTOUT) NTDDMP  
 	 READ(LISTOUT) NPREC	
 	 READ(LISTOUT) IDTAD	
 	 READ(LISTOUT) NBOCO	
 	 READ(LISTOUT) NSHDE	
 	 READ(LISTOUT) NCP	
 	 READ(LISTOUT) NPHS	
 	 READ(LISTOUT) NCNVC	
 	 READ(LISTOUT) NRADS	
 	 READ(LISTOUT) NRADL 
 	 READ(LISTOUT) IDAT
 	 READ(LISTOUT) DT
!MODULE_CUINIT
         READ(LISTOUT) CURAD
!MODULE_CUPARM, 
!         ONLY PARAMETER
!MODULE_DIUCON
         READ(LISTOUT) SEASON
         READ(LISTOUT) XXXX
         READ(LISTOUT) JDNMC
         READ(LISTOUT) FCSTDA
         READ(LISTOUT) FJDNMC
         READ(LISTOUT) TSLAG
         READ(LISTOUT) RLAG
         READ(LISTOUT) TIMIN
         READ(LISTOUT) TPI 
         READ(LISTOUT) HPI   
         READ(LISTOUT) YEAR
         READ(LISTOUT) DAY    
         READ(LISTOUT) DHR
         READ(LISTOUT) JTIME
         READ(LISTOUT) DAZ
!MODULE_DYNAM
         READ(LISTOUT) PT
         READ(LISTOUT) R      
         READ(LISTOUT) DY
         READ(LISTOUT) CPGFV
         READ(LISTOUT) EN
         READ(LISTOUT) ENT   
         READ(LISTOUT) F4D
         READ(LISTOUT) F4Q   
         READ(LISTOUT) EF4T  
         READ(LISTOUT) AETA
         READ(LISTOUT) DETA  
         READ(LISTOUT) RDETA
         READ(LISTOUT) F4Q2  
         READ(LISTOUT) ETA   
         READ(LISTOUT) DFL
         READ(LISTOUT) EM 
         READ(LISTOUT) EMT
         READ(LISTOUT) DX  
         READ(LISTOUT) WPDAR 
         READ(LISTOUT) CPGFU
         READ(LISTOUT) CURV  
         READ(LISTOUT) FCP   
         READ(LISTOUT) FDIV  
         READ(LISTOUT) F     
         READ(LISTOUT) DDMPU 
         READ(LISTOUT) DDMPV 
         READ(LISTOUT) FAD
!MODULE_EXCH_BUF_REAL
         READ(LISTOUT) BUF0
         READ(LISTOUT) BUF1
         READ(LISTOUT) BUF2
         READ(LISTOUT) BUF3
!MODULE_GLB_TABLE
         READ(LISTOUT) IS_GLB_TABLE
         READ(LISTOUT) IE_GLB_TABLE    
         READ(LISTOUT) JS_GLB_TABLE
         READ(LISTOUT) JE_GLB_TABLE
!MODULE_HCON
!MODULE_IACCR_TABLES
         READ(LISTOUT) ACCRI
!MODULE_IMASS_TABLES
         READ(LISTOUT) MASSI
!MODULE_INDX
!         READ(LISTOUT)IHE
!         READ(LISTOUT)IVE
!         READ(LISTOUT)IHW
!         READ(LISTOUT)IHW
!         READ(LISTOUT)IRAD
!         READ(LISTOUT)IHEG
!         READ(LISTOUT)IVEG
!         READ(LISTOUT)IHWG
!         READ(LISTOUT)IVWG
!         READ(LISTOUT)IRADG
!MODULE_INPUT
         READ(LISTOUT) ICH     
         READ(LISTOUT) ICM     
         READ(LISTOUT) ICT     
         READ(LISTOUT) ICB
         READ(LISTOUT) CH      
         READ(LISTOUT) CM      
         READ(LISTOUT) CL      
         READ(LISTOUT) EMCH    
         READ(LISTOUT) EMCM    
         READ(LISTOUT) EMCL
         READ(LISTOUT) RR      
         READ(LISTOUT) QQO3
         READ(LISTOUT) DTEMP   
         READ(LISTOUT) PPRESS 
!MODULE_IRATE_TABLES
         READ(LISTOUT) VSNOWI
!MODULE_IRIME_TABLES
         READ(LISTOUT) VEL_RF
!MODULE_IVENT_TABLES	 
         READ(LISTOUT) VENTI1
         READ(LISTOUT) VENTI2	 
!MODULE_LOOPS	 
	 READ(LISTOUT) IHLA
	 READ(LISTOUT) IHHA
	 READ(LISTOUT) IVLA
	 READ(LISTOUT) IVHA
	 READ(LISTOUT) JRA	 
	 READ(LISTOUT) LMH
	 READ(LISTOUT) LMV
!MODULE MAPOT
         READ(LISTOUT) LSL
         READ(LISTOUT) IXM
	 READ(LISTOUT) IYM
         READ(LISTOUT) ISHDE
         READ(LISTOUT) TSPH
         READ(LISTOUT) WBD
         READ(LISTOUT) SBD
         READ(LISTOUT) TLM0D
         READ(LISTOUT) TPH0D
         READ(LISTOUT) DLMD
	 READ(LISTOUT) DPHD
         READ(LISTOUT) CMLD
         READ(LISTOUT) DP30
         READ(LISTOUT) X1P
         READ(LISTOUT) Y1P
         READ(LISTOUT) DISLP
         READ(LISTOUT) Z0SLP
 	 READ(LISTOUT) SPL		 
	 READ(LISTOUT) ALSL 
	 READ(LISTOUT) TSHDE
	 READ(LISTOUT) ERLAM0 
	 READ(LISTOUT) CPHI0	 	 
	 READ(LISTOUT) SPHI0
!MODULE_MAPPINGS
	 READ(LISTOUT) G2LI    
	 READ(LISTOUT) L2GI
	 READ(LISTOUT) G2LJ
	 READ(LISTOUT) L2GJ
!MODULE_MASKS
	 READ(LISTOUT) VBM2    
	 READ(LISTOUT) VBM3    
	 READ(LISTOUT) SM      
	 READ(LISTOUT) SICE    
	 READ(LISTOUT) HBM2    
	 READ(LISTOUT) HBM3
	 READ(LISTOUT) HTM     
	 READ(LISTOUT) VTM
!MODULE_MOMENTO
	 READ(LISTOUT) UMFLX
	 READ(LISTOUT) VMFLX  
	 READ(LISTOUT) AKMS10
!MODULE_MPPCOM
         !colocar depois
!MODULE_NHYDRO
 	 READ(LISTOUT) HYDRO
 	 READ(LISTOUT) SPLINE	 
 	 READ(LISTOUT) DWDT
 	 READ(LISTOUT) PDWDT
 	 READ(LISTOUT) PINT	 
 	 READ(LISTOUT) W
 	 READ(LISTOUT) Z
!MODULE_NSOILTYPE
 	 READ(LISTOUT) NSOTYP
!MODULE_OPTIONS
 	 READ(LISTOUT) SPVAL
 	 READ(LISTOUT) IBESSL
 	 READ(LISTOUT) KSB     
 	 READ(LISTOUT) IOFFS   
 	 READ(LISTOUT) IFLAG   
 	 READ(LISTOUT) SATDEL
!MODULE_OUTFIL
 	 READ(LISTOUT) RSTFIL
 	 READ(LISTOUT) ITAG   
 	 READ(LISTOUT) LRSTRT
!MODULE_PHYCON
 	 READ(LISTOUT) AMOLWT  
 	 READ(LISTOUT) CSUBP   
 	 READ(LISTOUT) DIFFCTR 
 	 READ(LISTOUT) G       
 	 READ(LISTOUT) GRAVDR  
 	 READ(LISTOUT) O3DIFCTR
 	 READ(LISTOUT) P0      
 	 READ(LISTOUT) P0XZP2  
 	 READ(LISTOUT) P0XZP8  
 	 READ(LISTOUT) P0X2    
 	 READ(LISTOUT) RADCON  
 	 READ(LISTOUT) RGAS    
 	 READ(LISTOUT) RGASSP  
 	 READ(LISTOUT) SECPDA  
 	 READ(LISTOUT) RATCO2MW
 	 READ(LISTOUT) RATH2OMW                                                                       
 	 READ(LISTOUT) RADCON1                                                                        
 	 READ(LISTOUT) GINV    
 	 READ(LISTOUT) P0INV   
 	 READ(LISTOUT) GP0INV
!MODULE_PHYS
 	 READ(LISTOUT) KTM
 	 READ(LISTOUT) DTQ2    
 	 READ(LISTOUT) TDTQ2   
 	 READ(LISTOUT) DTD     
 	 READ(LISTOUT) TDTD    		   
 	 READ(LISTOUT) ROS     
 	 READ(LISTOUT) CS      
 	 READ(LISTOUT) DS      
 	 READ(LISTOUT) ROI     
 	 READ(LISTOUT) CI      
 	 READ(LISTOUT) DI      		   
 	 READ(LISTOUT) PL      
 	 READ(LISTOUT) THL     
 	 READ(LISTOUT) RDQ     
 	 READ(LISTOUT) RDTH    
 	 READ(LISTOUT) RDP     
 	 READ(LISTOUT) RDTHE   		   
 	 READ(LISTOUT) PLQ     
 	 READ(LISTOUT) RDPQ    
 	 READ(LISTOUT) RDTHEQ
 	 READ(LISTOUT) DFRLG
 	 READ(LISTOUT) QS0     
 	 READ(LISTOUT) SQS
 	 READ(LISTOUT) THE0    
 	 READ(LISTOUT) STHE
 	 READ(LISTOUT) THE0Q   
 	 READ(LISTOUT) STHEQ
 	 READ(LISTOUT) MXSNAL  
 	 READ(LISTOUT) EPSR	    				 
 	 READ(LISTOUT) RADIN
 	 READ(LISTOUT) RADOT	    				 
 	 READ(LISTOUT) GLAT
 	 READ(LISTOUT) GLON	    				 
 	 READ(LISTOUT) CZEN	    				 
 	 READ(LISTOUT) HTOP
 	 READ(LISTOUT) HBOT	    				 
 	 READ(LISTOUT) CNVTOP 
 	 READ(LISTOUT) CNVBOT      				 
 	 READ(LISTOUT) TG
 	 READ(LISTOUT) GFFC	    				 
 	 READ(LISTOUT) SST
 	 READ(LISTOUT) ALBASE      				 
 	 READ(LISTOUT) ALBEDO      				 
 	 READ(LISTOUT) HDAC
 	 READ(LISTOUT) HDACV	    				 
 	 READ(LISTOUT) CZMEAN 
 	 READ(LISTOUT) SIGT4
 	 READ(LISTOUT) PTBL
 	 READ(LISTOUT) TTBL
 	 READ(LISTOUT) TTBLQ
!MODULE_PPTASM
 	 READ(LISTOUT) MTSTPE  
 	 READ(LISTOUT) ITSTLOC 
 	 READ(LISTOUT) JTSTLOC 
 	 READ(LISTOUT) PHOUR   								     
 	 READ(LISTOUT) APREC
 	 READ(LISTOUT) TLATCU  								     
 	 READ(LISTOUT) TLATGS
 	 READ(LISTOUT) PPTDAT
!MODULE_PRFHLD
 	 READ(LISTOUT) TLMIN  
 	 READ(LISTOUT) TLMAX 
!MODULE_PVRBLS  
 	 READ(LISTOUT) Z0
 	 READ(LISTOUT) USTAR
 	 READ(LISTOUT) UZ0 
 	 READ(LISTOUT) VZ0 
 	 READ(LISTOUT) THZ0   
 	 READ(LISTOUT) QZ0   
 	 READ(LISTOUT) THS
 	 READ(LISTOUT) QS
 	 READ(LISTOUT) AKMS 
 	 READ(LISTOUT) AKHS 
 	 READ(LISTOUT) RF
 	 READ(LISTOUT) TWBS 
 	 READ(LISTOUT) QWBS 
 	 READ(LISTOUT) SNO 
 	 READ(LISTOUT) SI
 	 READ(LISTOUT) CLDEFI 
 	 READ(LISTOUT) PREC
 	 READ(LISTOUT) ACPREC    
 	 READ(LISTOUT) ACCLIQ
 	 READ(LISTOUT) CUPREC
 	 READ(LISTOUT) TH100
 	 READ(LISTOUT) Q100
 	 READ(LISTOUT) U100
 	 READ(LISTOUT) V100
 	 READ(LISTOUT) TH10    
 	 READ(LISTOUT) Q10     
 	 READ(LISTOUT) U10
 	 READ(LISTOUT) V10
 	 READ(LISTOUT) TSHLTR
 	 READ(LISTOUT) TSHLTR1
 	 READ(LISTOUT) QSHLTR
 	 READ(LISTOUT) PSHLTR    
 	 READ(LISTOUT) XMOMFLUX
 	 READ(LISTOUT) YMOMFLUX
         READ(LISTOUT) Q2   
!MODULE_RACCR_TABLES    
         READ(LISTOUT) ACCRR
!MODULE_RD1TIM
         READ(LISTOUT) K400
         READ(LISTOUT) RAD1
         READ(LISTOUT) CTHK
         READ(LISTOUT) TAUCV
         READ(LISTOUT) PTOPC
         READ(LISTOUT) LTOP
         READ(LISTOUT) LVL
!MODULE_RDFSAV
         READ(LISTOUT) EMISP   
         READ(LISTOUT) EMIST   
         READ(LISTOUT) XLATT   
         READ(LISTOUT) XLATP   
         READ(LISTOUT) Q19001  
         READ(LISTOUT) HP98    
         READ(LISTOUT) H3M6    
         READ(LISTOUT) HP75    
         READ(LISTOUT) H6M2    
         READ(LISTOUT) HP537   
         READ(LISTOUT) H74E1   
         READ(LISTOUT) H15E1   
         READ(LISTOUT) Q14330  
         READ(LISTOUT) HP2     
         READ(LISTOUT) TWENTY  
         READ(LISTOUT) HNINE   
         READ(LISTOUT) DEGRAD  
         READ(LISTOUT) HSIGMA 
         READ(LISTOUT) DAYSEC  
         READ(LISTOUT) RCO2
         READ(LISTOUT) CAO3SW  
         READ(LISTOUT) CAH2SW  
         READ(LISTOUT) CBSW
!MODULE_RITE
         READ(LISTOUT) BETA    
         READ(LISTOUT) DRIP    
         READ(LISTOUT) EC      
         READ(LISTOUT) EDIR    
         READ(LISTOUT) ETT     
         READ(LISTOUT) FLX1    
         READ(LISTOUT) FLX2    
         READ(LISTOUT) FLX3    
         READ(LISTOUT) RUNOF   
         READ(LISTOUT) DEW     
         READ(LISTOUT) RIB     
         READ(LISTOUT) RUNOFF3
!MODULE_RMASS_TABLES
         READ(LISTOUT) MASSR
!MODULE_RRATE_TABLES
         READ(LISTOUT) RRATE
!MODULE_RVELR_TABLES
         READ(LISTOUT) VRAIN
!MODULE_RVENT_TABLES
         READ(LISTOUT) VENTR1
         READ(LISTOUT) VENTR2
!MODULE_SAVEMEM
         READ(LISTOUT) DDUO3N
         READ(LISTOUT) DDO3N2  
         READ(LISTOUT) DDO3N3  
         READ(LISTOUT) DDO3N4
         READ(LISTOUT) RAD1    
         READ(LISTOUT) RAD2    
         READ(LISTOUT) RAD3    
         READ(LISTOUT) RAD4
!MODULE_SCRTCH
         READ(LISTOUT) SUM    
	 READ(LISTOUT) PERTSM 
	 READ(LISTOUT) SUM3   
	 READ(LISTOUT) SUMWDE
         READ(LISTOUT) SRCWD
         READ(LISTOUT) SRC1NB 
         READ(LISTOUT) DBDTNB
         READ(LISTOUT) ZMASS  
	 READ(LISTOUT) ZROOT
         READ(LISTOUT) SC     
         READ(LISTOUT) DSC    
         READ(LISTOUT) XTEMV
         READ(LISTOUT) TFOUR
         READ(LISTOUT) FORTCU
         READ(LISTOUT) X     
         READ(LISTOUT) X1
         READ(LISTOUT) SRCS 
         READ(LISTOUT) SUM4 
         READ(LISTOUT) SUM6
         READ(LISTOUT) SUM7	
	 READ(LISTOUT) SUM8	
	 READ(LISTOUT) SUM4WD  
	 READ(LISTOUT) R1  	 
         READ(LISTOUT) R2	
         READ(LISTOUT) S2	
         READ(LISTOUT) T3   
         READ(LISTOUT) R1WD
	 READ(LISTOUT) X2	
         READ(LISTOUT) EXPO	
         READ(LISTOUT) FAC
         READ(LISTOUT) CNUSB	
         READ(LISTOUT) DNUSB
         READ(LISTOUT) ALFANB  
         READ(LISTOUT) AROTNB
         READ(LISTOUT) ANB	
         READ(LISTOUT) BNB	
         READ(LISTOUT) CENTNB  
         READ(LISTOUT) DELNB	
         READ(LISTOUT) BETANB
!MODULE_SDENS_TABLES
         READ(LISTOUT) SDENS
!MODULE_SEASO3
	 READ(LISTOUT) XDUO3N
	 READ(LISTOUT) XDO3N2
	 READ(LISTOUT) XDO3N3
	 READ(LISTOUT) XDO3N4
	 READ(LISTOUT) PRGFDL
	 READ(LISTOUT) O3O3
	 READ(LISTOUT) XRAD1
	 READ(LISTOUT) XRAD2
	 READ(LISTOUT) XRAD3
	 READ(LISTOUT) XRAD4
!MODULE_SLOPES
         READ(LISTOUT) ISLD
         READ(LISTOUT) VTMS 
!MODULE_SOIL	  
         READ(LISTOUT) IVGTYP 
         READ(LISTOUT) ISLTYP 
	 READ(LISTOUT) ISLOPE
         READ(LISTOUT) SOILTB
         READ(LISTOUT) SFCEXC
	 READ(LISTOUT) SMSTAV
	 READ(LISTOUT) SMSTOT
         READ(LISTOUT) GRNFLX 
         READ(LISTOUT) PCTSNO
         READ(LISTOUT) VEGFRC 
         READ(LISTOUT) CMC
	 READ(LISTOUT) CTC
	 READ(LISTOUT) SH2O
	 READ(LISTOUT) SLDPTH
	 READ(LISTOUT) RTDPTH	 
!MODULE_SSALB	 
	 READ(LISTOUT) ZA
	 READ(LISTOUT) TRN
	 READ(LISTOUT) DZA
	 READ(LISTOUT) ALBD
	 READ(LISTOUT) ALB1
	 READ(LISTOUT) ALB2
	 READ(LISTOUT) ALB3	 
!MODULE_SWRSAV 
	 READ(LISTOUT) ABCFF
	 READ(LISTOUT) PWTS
	 READ(LISTOUT) CFCO2  
	 READ(LISTOUT) CFO3   
	 READ(LISTOUT) REFLO3 
	 READ(LISTOUT) RRAYAV
!MODULE_TABCOM
         !colocar depois
!MODULE_TEMPV
         READ(LISTOUT) P0
         READ(LISTOUT) T0
	 READ(LISTOUT) Q0
!MODULE_TOPO
         READ(LISTOUT) TEMP2X
         READ(LISTOUT) TTVG
	 READ(LISTOUT) HTMG
!MODULE_VRBLS
         READ(LISTOUT) PD
         READ(LISTOUT) FIS
         READ(LISTOUT) RES
         READ(LISTOUT) T
         READ(LISTOUT) U
         READ(LISTOUT) V
         READ(LISTOUT) Q
!MODULE_UPDT
         !colocar depois
!MODULE_Z0EFFT
	 READ(LISTOUT) ZEFFIJ
!
	 CLOSE(LISTOUT)
!--------------------------------------------------- 
! DONE READING INITIAL CONDITIONS OR A RESTART FILE.
!---------------------------------------------------
!
!------------------------------ 
! END OF SUBROUTINE READ_RESTRT
!------------------------------ 
    IF (MYPE == 0) THEN
        WRITE(*,*) 'INIT:  EXIT READ_OU2RESTRT'
        WRITE(*,*) ' '
    END IF
!
    RETURN
!
    END SUBROUTINE READ_OUT2RESTRT

    SUBROUTINE TURBL
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE TURBL
!>
!> SUBROUTINE: TURBL - VERTICAL TURBULENT EXCHANGE
!> PROGRAMMER: JANJIC
!> ORG: W/NP2
!> DATE: 95-03-20
!>
!> ABSTRACT:
!> TURBL UPDATES THE TURBULENT KINETIC ENERGY WITH THE PRODUCTION/DISSIPATION TERM AND THE VERTICAL 
!> DIFFUSION TERM DIFFUSION TERM (USING AN IMPLICIT FORMULATION). EXCHANGE COEFFICIENTS FOR THE 
!> SURFACE AND FOR ALL LAYER INTERFACES ARE THEN COMPUTED AND THE EXCHANGE IS EXECUTED.
!>
!> PROGRAM HISTORY LOG:
!> 95-03-15  JANJIC     - ORIGINATOR
!> 95-03-28  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 96-03-29  BLACK      - ADDED EXTERNAL EDGE; REMOVED SCRCH COMMON
!> 96-07-19  MESINGER   - ADDED Z0 EFFECTIVE
!> 98-??-??  TUCCILLO   - MODIFIED FOR CLASS VIII PARALLELISM
!> 98-10-27  BLACK      - PARALLEL CHANGES INTO MOST RECENT CODE
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              DYNAM
!>              EXCHM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MOMENTO
!>              MPPCOM
!>              PARMETA
!>              PARM_TBL
!>              PHYS
!>              PVRBLS
!>              TEMPCOM
!>              TIMMING
!>              TOPO
!>              VRBLS
!>              Z0EFFT         
!>
!> DRIVER     : EBU
!>              NEWFLT
!>
!> CALLS      : DIFCOF
!>              EXCH
!>              MIXLEN
!>              PRODQ2
!>              SGETMO
!>              SFCDIF
!>              SURFCE
!>              VDIFH
!>              VDIFQ
!>              VDIFV
!>              ZERO2
!>              ZERO3
!>              ZERO3_T
!>--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPPINGS
    USE MASKS
    USE MOMENTO
    USE MPPCOM
    USE PARMETA
    USE PARM_TBL, ONLY : ITB, JTB , ITBQ , JTBQ
    USE PHYS
    USE PVRBLS
    USE TEMPCOM
    USE TIMMING
    USE TOPO
    USE VRBLS
    USE Z0EFFT
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: KTMQ2 =   1
!
    REAL   (KIND=R4KIND), PARAMETER :: CAPA  =   0.28589641
    REAL   (KIND=R4KIND), PARAMETER :: G     =   9.8 
    REAL   (KIND=R4KIND), PARAMETER :: RG    =   1.   /  G 
    REAL   (KIND=R4KIND), PARAMETER :: ROG   = 287.04 /  G
    REAL   (KIND=R4KIND), PARAMETER :: EPSZ  =   1.E-4
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2 =   0.2
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM  = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: NHRZ  = (IDIM2 - IDIM1 + 1) * (JDIM2 - JDIM1 + 1)
! 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & CKLQ    , CT      , UZ0H    ,  VZ0H   , AKMSV
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & APE     , UCOL    , VCOL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM1)                              ::&
    & AKH     , AKM     , AKMCOL  , AKHCOL
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LP1)                              ::&
    & ZINT    , ZCOL
!
    REAL   (KIND=R4KIND), DIMENSION(LM1, IDIM1:IDIM2, JDIM1:JDIM2)                              ::&
    & AKH_T   , AKM_T
!
    REAL   (KIND=R4KIND), DIMENSION(LM, IDIM1:IDIM2, JDIM1:JDIM2)                               ::&
    & APECOL_T, UCOL_T  , VCOL_T  , TCOL_T  , QCOL_T  , Q2COL_T
!
    REAL   (KIND=R4KIND), DIMENSION(LP1, IDIM1:IDIM2, JDIM1:JDIM2)                              ::&
    & ZCOL_T  , ZCOL_T2
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::&
    & GM      , GH      , EL
! 
    REAL   (KIND=R4KIND), DIMENSION(4)                                                          ::&
    & ZEFF
!------------------------------------------------ 
! THE FOLLOWING ARE USED FOR TIMIMG PURPOSES ONLY
!------------------------------------------------ 
    REAL   (KIND=R8KIND)                                                                        ::&
    & TIMEF
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , LMHK    , LMHP    , LPBL    , IIM     , JJM     , JJ      ,   &
    & II      , LMVK    , LMHM 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & PDSL    , APESTS  , WMSK    , RWMSK   , HPBL    , ULM     , VLM     , WSTAR   , BTIM    ,   &
    & EVPR
!
    CALL ZERO3(AKM, LM1)
    CALL ZERO3(ZINT, LP1)
    CALL ZERO3_T(AKH_T, LM1)
    CALL ZERO3_T(AKM_T, LM1)
    CALL ZERO2(UZ0H)
    CALL ZERO2(VZ0H)
    CALL ZERO2(AKM10)
!--------------------------------------------------------------------- 
! AKMS WAS ZEROED OUT BY MISTAKE, SEE THE CORRESP. WITH SM, FEB.22, 07
!---------------------------------------------------------------------
!
!-------------------------------------------------------------------     
! COMPUTE THE HEIGHTS OF THE LAYER INTERFACES AND THE EXNER FUNCTION
!------------------------------------------------------------------- 
!
!$omp parallel do 
!
    DO J=MYJS_P1,MYJE_P1
        DO I=MYIS_P1,MYIE_P1
            ZINT(I,J,LP1) = EPSZ
            IF (SIGMA) ZINT(I,J,LP1) = RG * FIS(I,J)
        END DO
    END DO
!
    DO 10 K=LM,1,-1
!
!$omp parallel do private (APESTS, PDSL)
!
        DO J=MYJS1_P1,MYJE1_P1 
            DO I=MYIS_P1,MYIE_P1
                PDSL   = PD(I,J) * RES(I,J)
                APESTS = PDSL    * AETA(K) + PT
!            
                ZINT(I,J,K) =  ZINT(I,J,K+1) + T(I,J,K)  / APESTS     * PDSL * DETA(K) * ROG      &
    &                       *    (Q(I,J,K)   * 0.608     + 1.)
!
                ZINT(I,J,K) = (ZINT(I,J,K)   - DFRLG(K)) * HTM(I,J,K) + DFRLG(K)
!            
                 APE(I,J,K) = (1.E5/APESTS)  ** CAPA
            END DO
        END DO
!
 10 END DO
!------------------- 
! REMOVE NEGATIVE Q2
!------------------- 
!
!$omp parallel do 
!
    DO 40 K=1,LM
        DO J=MYJS_P1,MYJE_P1
            DO I=MYIS_P1,MYIE_P1
                Q2(I,J,K) = AMAX1(Q2(I,J,K) * HBM2(I,J), EPSQ2)
            END DO
        END DO
 40 END DO
!
!$omp parallel do 
!
    DO J=MYJS2_P1,MYJE2_P1
        DO I=MYIS_P1,MYIE_P1
            UZ0H(I,J) = (UZ0(I+IHE(J),J) + UZ0(I+IHW(J),J) + UZ0(I,J+1) + UZ0(I,J-1))             &
    &                 * HBM2(I       ,J) * 0.25
!
            VZ0H(I,J) = (VZ0(I+IHE(J),J) + VZ0(I+IHW(J),J) + VZ0(I,J+1) + VZ0(I,J-1))             &
    &                 * HBM2(I       ,J) * 0.25
        END DO
    END DO
!---------------------------------- 
! PREPARE THE EXCHANGE COEFFICIENTS
!---------------------------------- 
!
!---------------------------------------- 
! COMPUTE VELOCITY COMPONENTS AT H POINTS
!---------------------------------------- 
!
!$omp parallel do private (RWMSK, WMSK)
!
    DO 60 K=1,LM
!    
        DO J=MYJS2_P1,MYJE2_P1
            DO I=MYIS_P1,MYIE_P1
                WMSK = VTM(I+IHE(J),J,K) + VTM(I+IHW(J),J,K) + VTM(I,J+1,K) + VTM(I,J-1,K)
                IF (WMSK > 0.) THEN
                    RWMSK       = 0.25
                    UCOL(I,J,K) = (U(I+IHE(J),J  ,K) * VTM(I+IHE(J),J  ,K)                         &
    &                           +  U(I+IHW(J),J  ,K) * VTM(I+IHW(J),J  ,K)                         &
    &                           +  U(I       ,J+1,K) * VTM(I       ,J+1,K)                         &
    &                           +  U(I       ,J-1,K) * VTM(I       ,J-1,K))                        &
    &                           * RWMSK
!                    
                    VCOL(I,J,K) = (V(I+IHE(J),J  ,K) * VTM(I+IHE(J),J  ,K)                         &
    &                           +  V(I+IHW(J),J  ,K) * VTM(I+IHW(J),J  ,K)                         &
    &                           +  V(I       ,J+1,K) * VTM(I       ,J+1,K)                         &
    &                           +  V(I       ,J-1,K) * VTM(I       ,J-1,K))                        &
    &                           *  RWMSK
                ELSE
                    UCOL(I,J,K) = 0.
                    VCOL(I,J,K) = 0.
                END IF
            END DO
        END DO
!
 60 END DO
!----------------------- 
! FILL TRANSPOSED ARRAYS
!----------------------- 
! 
!$omp parallel sections
!$omp section
!
    CALL SGETMO(T   , NHRZ, NHRZ, LM ,   TCOL_T, LM)
!
!$omp section
!
    CALL SGETMO(Q   , NHRZ, NHRZ, LM ,   QCOL_T, LM)
!
!$omp section
!
    CALL SGETMO(APE , NHRZ, NHRZ, LM , APECOL_T, LM)
!
!$omp section
!
    CALL SGETMO(Q2  , NHRZ, NHRZ, LM ,  Q2COL_T, LM)
!
!$omp section
!
    CALL SGETMO(ZINT, NHRZ, NHRZ, LP1,   ZCOL_T, LP1)
!
!$omp section
!
    CALL SGETMO(UCOL, NHRZ, NHRZ, LM ,   UCOL_T, LM)
!
!$omp section
!
    CALL SGETMO(VCOL, NHRZ, NHRZ, LM ,   VCOL_T, LM)
!
!$omp end parallel sections
!
!----------------------- 
! FIND THE MIXING LENGTH
!----------------------- 
!
!$omp parallel do private (EL, GH, GM, HPBL, LMHK, LMHM, LMHP, LPBL)
!$omp private (ULM, VLM, WSTAR, ZEFF)
!
    DO 100 J=MYJS2_P1,MYJE2_P1
        DO 100 I=MYIS_P1,MYIE1_P1
!
            LMHK = LMH(I,J)
            LMHP = LMHK + 1
            LMHM = LMHK - 1
!        
            CALL MIXLEN(LMHK, LPBL, HPBL,                                                         &
    &                      UCOL_T(1,I,J),  VCOL_T(1,I,J),   TCOL_T(1,I,J),                        &
    &                      QCOL_T(1,I,J), Q2COL_T(1,I,J), APECOL_T(1,I,J),                        &
    &                      ZCOL_T(1,I,J),                                                         &
    &                   GM  , GH  , EL)
!--------------------------------------------------------------------- 
! SOLVE FOR THE PRODUCTION/DISSIPATION OF THE TURBULENT KINETIC ENERGY
!---------------------------------------------------------------------      
            CALL PRODQ2(LMHK, DTQ2,                                                               &
    &                   USTAR(I,J),                                                               &
    &                   GM, GH, EL,                                                               &
    &                   Q2COL_T(1,I,J))
!------------------------------------------------------  
! FIND THE EXCHANGE COEFFICIENTS IN THE FREE ATMOSPHERE
!------------------------------------------------------ 
            CALL DIFCOF(LMHK, GM, GH, EL,                                                         &
    &                   Q2COL_T(1,I,J), ZCOL_T(1,I,J), AKM_T(1,I,J), AKH_T(1,I,J))
!------------------------------------------------------------- 
! CARRY OUT THE VERTICAL DIFFUSION OF TURBULENT KINETIC ENERGY
!-------------------------------------------------------------      
            CALL VDIFQ(LMHK, KTMQ2, DTQ2,                                                         &
    &                  Q2COL_T(1,I,J),                                                            &
    &                  EL,                                                                        &
    &                  ZCOL_T(1,I,J))
!---------------------- 
! FIND THE Z0 EFFECTIVE
!----------------------  
            ZEFF(1) = ZEFFIJ(I,J,1)
            ZEFF(2) = ZEFFIJ(I,J,2)
            ZEFF(3) = ZEFFIJ(I,J,3)
            ZEFF(4) = ZEFFIJ(I,J,4)
!---------------------------------------  
! FIND THE SURFACE EXCHANGE COEFFICIENTS
!--------------------------------------- 
            ULM = UCOL(I,J,LMHK)
            VLM = VCOL(I,J,LMHK)
!        
            CALL SFCDIF(LMHK         ,        SM(I,J),        THS(I,J),       QS(I,J),            &
    &                       UZ0H(I,J),      VZ0H(I,J),       THZ0(I,J),      QZ0(I,J),            &
    &                      USTAR(I,J),  WSTAR        ,         Z0(I,J),  ZEFF        ,            &
    &                       AKMS(I,J),      AKHS(I,J), HPBL           ,       CT(I,J),            &
    &                        U10(I,J),       V10(I,J),     TSHLTR(I,J),     TH10(I,J),            &    
    &                     QSHLTR(I,J),       Q10(I,J),                                            &
!---------- 
! GSM V100M
!----------
    &                    TH100(I,J)  ,      Q100(I,J),       U100(I,J),     V100(I,J),            &
    &                   ULM          , VLM           ,                                            & 
    &                   TCOL_T(1,I,J),  QCOL_T(1,I,J), APECOL_T(1,I,J), ZCOL_T(1,I,J),            &
    &                         PD(I,J), PT            ,        T(I,J,LMHK))
!-------- 
! MORELLI
!--------
            XMOMFLUX(I,J) = UMFLX
            YMOMFLUX(I,J) = VMFLX
               AKM10(I,J) = AKMS10
!       
100 END DO
!-------------------------------------------- 
! FILL STANDARD ARRAYS FROM TRANSPOSED ARRAYS
!--------------------------------------------
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(Q2COL_T, LM , LM , NHRZ, Q2 , NHRZ)
!
!$omp section
!
    CALL SGETMO(  AKH_T, LM1, LM1, NHRZ, AKH, NHRZ)
!
!$omp section
!
    CALL SGETMO(  AKM_T, LM1, LM1, NHRZ, AKM, NHRZ)
!
!$omp end parallel sections
!
!-------------------------------------------------------------- 
! UNCOMPUTED LOCATIONS MUST BE FILLED IN FOR THE POST-PROCESSOR
!-------------------------------------------------------------- 
    IIM = IM - MY_IS_GLB + 1
    JJM = JM - MY_JS_GLB + 1
!------------------------  
! EASTERN GLOBAL BOUNDARY
!------------------------
    IF (MY_IE_GLB == IM) THEN
        DO J=1,JM
            IF (J >= MY_JS_GLB .AND. J <= MY_JE_GLB) THEN
                           JJ  = J - MY_JS_GLB + 1
!
                  TH10(IIM,JJ) =   TH10(IIM-1,JJ)
                   Q10(IIM,JJ) =    Q10(IIM-1,JJ)
                   U10(IIM,JJ) =    U10(IIM-1,JJ)
                   V10(IIM,JJ) =    V10(IIM-1,JJ)
                TSHLTR(IIM,JJ) = TSHLTR(IIM-1,JJ)
                QSHLTR(IIM,JJ) = QSHLTR(IIM-1,JJ)
!---------- 
! GSM V100M
!----------
                 TH100(IIM,JJ) =  TH100(IIM-1,JJ)
                  Q100(IIM,JJ) =   Q100(IIM-1,JJ)
                  U100(IIM,JJ) =   U100(IIM-1,JJ)
                  V100(IIM,JJ) =   V100(IIM-1,JJ)
            END IF
        END DO
    END IF
!-------------------------
! SOUTHERN GLOBAL BOUNDARY
!-------------------------
    IF (MY_JS_GLB == 1) THEN
        DO J=1,2
            DO I=1,IM
                IF (I >= MY_IS_GLB .AND. I <= MY_IE_GLB) THEN
                           II    = I - MY_IS_GLB + 1
!
                      TH10(II,J) =   TH10(II,3)
                       Q10(II,J) =    Q10(II,3)
                       U10(II,J) =    U10(II,3)
                       V10(II,J) =    V10(II,3)
                    TSHLTR(II,J) = TSHLTR(II,3)
                    QSHLTR(II,J) = QSHLTR(II,3)
!---------- 
! GSM V100M
!----------
                     TH100(II,J) = TH100(II,3)
                      Q100(II,J) =  Q100(II,3)
                      U100(II,J) =  U100(II,3)
                      V100(II,J) =  V100(II,3)
                END IF
            END DO
        END DO
    END IF
!-------------------------
! NORTHERN GLOBAL BOUNDARY
!-------------------------
    IF (MY_JE_GLB == JM) THEN
        DO J=JM-1,JM
            JJ = J - MY_JS_GLB + 1
            DO I=1,IM
                IF (I >= MY_IS_GLB .AND. I <= MY_IE_GLB) THEN
                          II      = I - MY_IS_GLB + 1
!
                      TH10(II,JJ) =   TH10(II,JJM-2)
                       Q10(II,JJ) =    Q10(II,JJM-2)
                       U10(II,JJ) =    U10(II,JJM-2)
                       V10(II,JJ) =    V10(II,JJM-2)
                    TSHLTR(II,JJ) = TSHLTR(II,JJM-2)
                    QSHLTR(II,JJ) = QSHLTR(II,JJM-2)
!---------- 
! GSM V100M
!----------
                     TH100(II,JJ) =  TH100(II,JJM-2)
                      Q100(II,JJ) =   Q100(II,JJM-2)
                      U100(II,JJ) =   U100(II,JJM-2)
                      V100(II,JJ) =   V100(II,JJM-2)
                END IF
            END DO
        END DO
    END IF
!
    BTIM = TIMEF()
!
    CALL EXCH(UZ0H, 1, VZ0H, 1, 1, 1)
!
    EXCH_TIM = EXCH_TIM + TIMEF() - BTIM
!-------------------------------------
! AVERAGE UZ0 AND VZ0 BACK TO V POINTS
!-------------------------------------
!
!$omp parallel do
!
    DO 125 J=MYJS2,MYJE2
        DO 125 I=MYIS,MYIE
            UZ0(I,J) = (UZ0H(I+IVE(J),J  ) * HBM2(I+IVE(J),J  )                                   &
    &                +  UZ0H(I+IVW(J),J  ) * HBM2(I+IVW(J),J  )                                   &
    &                +  UZ0H(I       ,J+1) * HBM2(I       ,J+1)                                   &
    &                +  UZ0H(I       ,J-1) * HBM2(I       ,J-1)) * 0.25
 !           
            VZ0(I,J) = (VZ0H(I+IVE(J),J  ) * HBM2(I+IVE(J),J  )                                   & 
    &                +  VZ0H(I+IVW(J),J  ) * HBM2(I+IVW(J),J  )                                   &
    &                +  VZ0H(I       ,J+1) * HBM2(I       ,J+1)                                   &
    &                +  VZ0H(I       ,J-1) * HBM2(I       ,J-1)) * 0.25
125 END DO
!----------------------------- 
! EXECUTE THE GROUND PROCESSES
!----------------------------- 
    CALL SURFCE(APE(IDIM1, JDIM1, 1), ZINT(IDIM1, JDIM1, 1), CKLQ(IDIM1, JDIM1))
!------------------------------ 
! EXECUTE THE VERTICAL EXCHANGE
!------------------------------ 
    BTIM=TIMEF()
!
    CALL EXCH(AKMS, 1, AKM, LM1, ZINT, LP1, 1, 1)
!
    EXCH_TIM = EXCH_TIM + TIMEF() - BTIM
!
!$omp parallel do 
!
    DO K=1,LM1
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
                AKMCOL(I,J,K) = (AKM(I+IVE(J),J  ,K) * HBM2(I+IVE(J),J  )                         &
    &                         +  AKM(I+IVW(J),J  ,K) * HBM2(I+IVW(J),J  )                         &
    &                         +  AKM(I       ,J+1,K) * HBM2(I       ,J+1)                         &
                              +  AKM(I       ,J-1,K) * HBM2(I       ,J-1))                        & 
    &                         *  VTM(I       ,J  ,K) * VBM2(I       ,J  ) * 0.25
!                
                AKHCOL(I,J,K) =  AKH(I       ,J  ,K) *  HTM(I       ,J,K) * HBM2(I,J)
            END DO
        END DO
    END DO
!
!$omp parallel do
! 
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
             THZ0(I,J) =   (1.-SM(I       ,J))  *  THS(I       ,J)                                &
    &                  +       SM(I       ,J)   * THZ0(I       ,J)
!             
             QZ0 (I,J) =   (1.-SM(I       ,J))  *  QS (I       ,J)                                &
    &                  +       SM(I       ,J)   * QZ0 (I       ,J)
!           
            AKMSV(I,J) =    (AKMS(I+IVE(J),J)   * HBM2(I+IVE(J),J)                                &
    &                  +     AKMS(I+IVW(J),J)   * HBM2(I+IVW(J),J)                                &
    &                  +     AKMS(I       ,J+1) * HBM2(I       ,J+1)                              &
    &                  +     AKMS(I       ,J-1) * HBM2(I       ,J-1)) * VBM2(I,J) * 0.25
        END DO
    END DO
!
!$omp parallel do 
!
    DO K=1,LP1
        DO J=MYJS2,MYJE2
            DO I=MYIS,MYIE
                ZCOL(I,J,K) = 0.25 * (ZINT(I+IVE(J),J  ,K) + ZINT(I+IVW(J),J  ,K)                 &
    &                       +         ZINT(I       ,J+1,K) + ZINT(I       ,J-1,K))
            END DO
        END DO
    END DO
!---------
! MORELLI
!---------
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
                   LMVK =    LMV(I       ,J)
!
            AKM10V(I,J) = (AKM10(I+IVE(J),J  ) * HBM2(I+IVE(J),J  )                               & 
    &                   +  AKM10(I+IVW(J),J  ) * HBM2(I+IVW(J),J  )                               &
    &                   +  AKM10(I       ,J+1) * HBM2(I       ,J+1)                               &
    &                   +  AKM10(I       ,J-1) * HBM2(I       ,J-1)) * VBM2(I,J) * 0.25
!
            IF (AKM10V(I,J) == 0) THEN
                   U10(I,J) =  0.
                   V10(I,J) =  0.
            ELSE
                   U10(I,J) = AKMSV(I,J) * (U(I,J,LMVK) - UZ0(I,J)) / AKM10V(I,J) + UZ0(I,J)
                   V10(I,J) = AKMSV(I,J) * (V(I,J,LMVK) - VZ0(I,J)) / AKM10V(I,J) + VZ0(I,J)
            END IF
        END DO
    END DO
!-----------------
! TRANSPOSE ARRAYS
!-----------------
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(ZCOL  , NHRZ, NHRZ, LP1, ZCOL_T2, LP1)
!
!$omp section
!
    CALL SGETMO(U     , NHRZ, NHRZ, LM , UCOL_T , LM)
!
!$omp section
!
    CALL SGETMO(V     , NHRZ, NHRZ, LM , VCOL_T , LM)
!
!$omp section
!
    CALL SGETMO(AKHCOL, NHRZ, NHRZ, LM1,  AKH_T , LM1)
!
!$omp section
!
    CALL SGETMO(AKMCOL, NHRZ, NHRZ, LM1,  AKM_T , LM1)
!
!$omp end parallel sections
!
!$omp parallel do private (LMHK,LMVK)
!
    DO 200 J=MYJS2,MYJE2
        DO 200 I=MYIS,MYIE1
!        
            LMHK = LMH(I,J)
            LMVK = LMV(I,J)
!----------------------------------------------------------------
! CARRY OUT THE VERTICAL DIFFUSION OF TEMPERATURE AND WATER VAPOR
!----------------------------------------------------------------
            CALL VDIFH(LMHK, KTMQ2, DTQ2,                                                         &
    &                    THZ0(I,J),      QZ0(I,J),    AKHS(I,J),                                  &
    &                      CT(I,J),     CKLQ(I,J),                                                &
    &                TCOL_T(1,I,J), QCOL_T(1,I,J), AKH_T(1,I,J),                                  &
    &              APECOL_T(1,I,J), ZCOL_T(1,I,J), EVPR)
!            
            PD(I,J) = PD(I,J) + PD(I,J) * RES(I,J) * EVPR
!-------------------------------------------------------- 
! CARRY OUT THE VERTICAL DIFFUSION OF VELOCITY COMPONENTS
!-------------------------------------------------------- 
            CALL VDIFV(LMVK         , KTMQ2        , DTQ2        ,                                &
    &                       UZ0(I,J),      VZ0(I,J),   AKMSV(I,J),                                &
    &                  UCOL_T(1,I,J), VCOL_T(1,I,J), AKM_T(1,I,J), ZCOL_T2(1,I,J))
!
200 END DO
!--------------------------------------------  
! FILL STANDARD ARRAYS FROM TRANSPOSED ARRAYS
!-------------------------------------------- 
!
!$omp parallel sections
!$omp section
!
    CALL SGETMO(QCOL_T, LM, LM, NHRZ, Q, NHRZ)
!
!$omp section
!
    CALL SGETMO(TCOL_T, LM, LM, NHRZ, T, NHRZ)
!
!$omp section
!
    CALL SGETMO(UCOL_T, LM, LM, NHRZ, U, NHRZ)
!
!$omp section
!
    CALL SGETMO(VCOL_T, LM, LM, NHRZ, V, NHRZ)
!
!$omp end parallel sections
!
!------------------- 
! REMOVE NEGATIVE Q2
!------------------- 
!
!$omp parallel do 
!
    DO K=1,LM
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                Q2(I,J,K) = AMAX1(Q2(I,J,K) * HBM2(I,J), EPSQ2)
            END DO
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE TURBL

    MODULE DYNAM
!>--------------------------------------------------------------------------------------------------
!> MODULE DYNAM
!>
!> USE MODULES: F77KINDS
!>              LOOPS
!>              PARMETA
!>              RDPARM
!>
!> DRIVER     : CHKOUT
!>              CUCNVC
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              EPS
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              SURFCE
!>              TURBL
!>              VADZ
!>              VDIFH
!>              VTADV
!>              VTADVF
!>              ZENITH
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE LOOPS   , ONLY : JAM
    USE PARMETA , ONLY : LM , IDIM1, IDIM2, JDIM1, JDIM2
    USE RDPARM  , ONLY : LP1
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & PT      , R       ,                                                                         &
    & DY      , CPGFV   , EN      , ENT     ,                                                     &
    & F4D     , F4Q     ,                                                                         &
    & EF4T    
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & AETA    , DETA    ,                                                                         &                                                                             
    & RDETA   , F4Q2       
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&
    & ETA     ,                                                                                   &
    & DFL
!
    REAL   (KIND=R4KIND), DIMENSION(JAM)                                                        ::&
    & EM      , EMT
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DX      , WPDAR   ,                                                                         & 
    & CPGFU   , CURV    ,                                                                         &
    & FCP     , FDIV    ,                                                                         &
    & F       ,                                                                                   &
    & DDMPU   , DDMPV   ,                                                                         &
    & FAD
!
    END MODULE DYNAM

    SUBROUTINE ZERO3_T(ARRAY, LL)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE ZERO3_T
!> 
!> SUBROUTINE: ZERO3_T - ZERO OUT TRANSPOSED 3-D ARRAYS
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 99-07-06
!>
!> ABSTRACT:
!> SET THE VALUES OF THE ARTIFICIAL EXTERNAL (OUT-OF-BOUNDS) EDGES TO ZERO
!>
!> PROGRAM HISTORY LOG:
!> 99-07-06  BLACK      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LL    -
!>
!> OUTPUT ARGUMENT LIST:
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> ARRAY - 
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOP
!> 
!> DRIVER     : TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(LL, IDIM1:IDIM2, JDIM1:JDIM2)         , INTENT(INOUT)       ::&
    & ARRAY
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , L
!
    DO J=JDIM1,JDIM2
        DO I=IDIM1,IDIM2
            DO L=1,LL
                ARRAY(L,I,J) = 0.
            END DO
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE ZERO3_T

    MODULE PARMEXCH
!>--------------------------------------------------------------------------------------------------
!> MODULE PARMEXCH
!>
!> SUBROUTINE: PARMEXCH - ?????
!> PROGRAMMER: JIM TUCCILLO
!> ORG: ?????
!> DATE: 01-02-??
!>
!> ABSTRACT:
!> IBUFEXCH IS THE SIZE OF THE EXCHANGE BUFFERS USED FOR THE HALO EXCHANGES. 
!> THE CURRENT SIZE SHOULD BE MORE THAN SUFFICIENT FOR THE FORSEEABLE FUTURE.
!>
!> IBUFEXCH WOULD NEED TO BE INCREASED IF YOU EVER RECEIVE AN ERROR FROM THE MPI LIBRARY INDICATING
!> THAT THE RECIEIVE BUFFER IS TOO SMALL. 
!> YOU SHOULD DO A "MAKE CLEAN" IF YOU INCREASE IBUFEXCH.
!>
!> PROGRAM HISTORY LOG:
!> 01-02-??  TUCCILLO - ORIGINAL
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                      * F77 TO F90/F95
!>                      * INDENTATION & UNIFORMIZATION CODE
!>                      * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                      * DOCUMENTATION WITH DOXYGEN
!>                      * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : MODULE_EXCH_BUF_INTEGER
!>              MODULE_EXCH_BUF_REAL
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    SAVE
!
!    INTEGER(KIND=I4KIND), PARAMETER :: IBUFEXCH = 340800
    INTEGER(KIND=I4KIND), PARAMETER :: IBUFEXCH = 340800
!
    END MODULE PARMEXCH

    MODULE MASKS
!>--------------------------------------------------------------------------------------------------
!> MODULE MASKS
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!> 
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLTEND
!>              CUCNVC
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              EPS
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADV2
!>              HZADV_LM1
!>              HZADVS
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SLADVT
!>              SURFCE
!>              TURBL
!>              VADZ
!>              VTADV
!>              VTADVF
!>              WRTRST
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IDIM1, IDIM2, JDIM1, JDIM2, LM
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & VBM2    , VBM3    ,                                                                         &
    & SM      , SICE    ,                                                                         &
    & HBM2    , HBM3
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & HTM     , VTM
!
    END MODULE MASKS

    SUBROUTINE PARA_RANGE(N1, N2, NPROCS, IRANK, ISTA, IEND)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE PARA_RANGE
!>
!> SUBROUTINE: PARA_RANGE - SET UP DECOMPOSITION VALUES
!> PROGRAMMER: TUCCILLO
!> ORG: IBM
!> DATE: 00-01-06
!>
!> ABSTRACT:
!> SETS UP DECOMOSITION VALUES
!>
!> PROGRAM HISTORY LOG:
!> 00-01-06  TUCCILLO - ORIGINAL
!> 18-01-15  LUCCI    - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> N1     - FIRST INTERATE VALUE
!> N2     - LAST INTERATE VALUE
!> NPROCS - NUMBER OF MPI TASKS
!> IRANK  - MY TAKS ID
!>
!> OUTPUT ARGUMENT LIST:
!> ISTA    - FIRST LOOP VALUE
!> IEND    - LAST LOOP VALUE
!>
!> OUTPUT FILES:
!> STDOUT  - RUN TIME STANDARD OUT.
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: F77KINDS
!>
!> DRIVER     : CHKOUT
!>              SETUP_SERVERS
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & N1      , N2      , NPROCS  , IRANK 
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(INOUT)       ::&
    & ISTA    , IEND
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & IWORK1  , IWORK2
!
    IWORK1 =    (N2 - N1 + 1) / NPROCS
    IWORK2 = MOD(N2 - N1 + 1,   NPROCS)
!
    ISTA = IRANK * IWORK1 + N1 + MIN(IRANK, IWORK2)
!
    IEND = ISTA + IWORK1 - 1
!
    IF (IWORK2 > IRANK) IEND = IEND + 1
!
    END SUBROUTINE PARA_RANGE

    SUBROUTINE EPS
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE EPS
!> 
!> SUBPROGRAM: EPS - ?????
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 9?-??-??
!>
!> ABSTRACT:
!> EPS COMPUTES THE VERTICAL AND HORIZONTAL ADVECTION OF DZ / DT.
!>
!> PROGRAM HISTORY LOG:
!> 9?-??-??  JANJIC      - ORIGINATOR
!> 00-01-05  BLACK       - DISTRIBUTED MEMORY AND THREADS
!> 26-11-12  RISTIC IVAN - LOT OF CHANGES AND BUG FIX
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              NHYDRO
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>  
!> DRIVER     : EBU
!>
!> CALLS      : EXCH
!>              MPI_ALLREDUCE
!--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE EXCHM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE NHYDRO
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    INCLUDE "EXCHM.h"
    INCLUDE "mpif.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IM1   = IM - 1 
    INTEGER(KIND=I4KIND), PARAMETER :: JAMD  = (JAM * 2 - 10) * 3
    INTEGER(KIND=I4KIND), PARAMETER :: NTSHY =  3
!
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ  =    1.E-12 
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2 =    0.2
    REAL   (KIND=R4KIND), PARAMETER :: FF1   =    0.52500
    REAL   (KIND=R4KIND), PARAMETER :: FF2   =   -0.64813
    REAL   (KIND=R4KIND), PARAMETER :: FF3   =    0.24520
    REAL   (KIND=R4KIND), PARAMETER :: FF4   =   -0.12189
    REAL   (KIND=R4KIND), PARAMETER :: EPSFC =    1. / 1.05
    REAL   (KIND=R4KIND), PARAMETER :: EPSN  = -EPSFC   
    REAL   (KIND=R4KIND), PARAMETER :: EPSP  =  EPSFC
    REAL   (KIND=R4KIND), PARAMETER :: ZERO  =    1.E-06
    REAL   (KIND=R4KIND), PARAMETER :: G     =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CP    = 1004.6
    REAL   (KIND=R4KIND), PARAMETER :: CAPA  =  287.04 / CP
    REAL   (KIND=R4KIND), PARAMETER :: GMA   = -287.04 * (1. - CAPA) / 2.
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & TOP     , BOT
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , LMP     , LAP     , LLAP    , JFP     , JFQ     , IRECV   ,   &
    & JHL     , JHH     , IHL     , IHH     , JX      , IX      , KN      , KP   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ADDT    , RDT     , RR      , ARR     , DWP     , DETAL   , RFACW   , W4P     , AFRP    ,   &
    & D2PQW   , WP      , W00     , WP0     , ENH     , HM      , DVOLP   , TTA     , TTB     ,   &
    & PP      , QP      , DWSTIJ  , RFWIJ   , W1IJ    , WSTIJ   , W0Q     , WA      , DWDTMX  ,   &
    & DWDTMN  , DWDTT   , GDT     , GDT2    , WGHT    , FFC     , PDP     , RDP     , DPPL    ,   &
    & DPSTR   , PP1     , TFC     , TTFC    , PSTRUP  , RDPDN   , RDPUP   , RPD     , PSTRDN  ,   &
    & TMP     , HBM2IJ  , DPTU    , FCT     , DPTL    , DELP       
!--------------------------------------
! LOCAL VARIABLES REQUIRING DECLARATION 
!-------------------------------------- 
    REAL   (KIND=R4KIND), DIMENSION(LM+1)                                                       ::&
    & PONE    , PSTR    , PNP1    , COFF    , DFRC    , CHI     , CHIN    , WRES    , CLIM
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & RDPP    , C0      , B1      , B2      , B3      , W3      , W4
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::&
    & ETADTL  , DWL     , AFR
!
    INTEGER(KIND=I4KIND), DIMENSION(LM)                                                         ::&
    & LA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & AFP     , AFQ     , W1      , DWST    , DVOL 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & DARE    , EMH     , ANE     , ASE
!
    INTEGER(KIND=I4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & IFPA    , IFQA    ,                                                                         &
    & IFPF    , IFQF    ,                                                                         &
    & JFPA    , JFQA    ,                                                                         &
    & JFPF    , JFQF
!
    REAL   (KIND=R4KIND), DIMENSION(2, LM)                                                      ::&
    & GSUMS   , XSUMS 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & SUMPW   , SUMNW
!
    IF (NTSD <= NTSHY .OR. HYDRO) THEN
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
        DO J=MYJS_P2,MYJE_P2
            DO I=MYIS_P1,MYIE_P1
                PINT(I,J,1) = PT
            END DO
        END DO
    
        DO K=1,LM
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
            DO J=MYJS_P2,MYJE_P2
                DO I=MYIS_P1,MYIE_P1
                     DWDT(I,J,K)  = 1.
                    PDWDT(I,J,K)  = 1.
                    PINT(I,J,K+1) = PDSL(I,J) * DETA(K) + PINT(I,J,K)
                END DO
            ENDDO
        END DO
!
        RETURN
!
    END IF
!
    ADDT = DT
    RDT  = 1. / ADDT
!--------------     
! TIME TENDENCY 
!--------------
!------- 
! OPENMP
!-------
! 
!$omp parallel do
!
    DO K=1,LM
        DO J=MYJS_P1,MYJE_P1
            DO I=MYIS_P1,MYIE_P1
                DWDT(I,J,K) = (W(I,J,K) - DWDT(I,J,K)) * HTM(I,J,K) * HBM2(I,J) * RDT
            END DO
        END DO
    END DO
!------------------- 
! VERTICAL ADVECTION 
!------------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (AFR      , AFRP    , ARR     , BOT     , D2PQW   , DETAL   , DWL     , DWP     ,   &
!$omp          ETADTL   , LA      , LAP     , LLAP    , LMP     , RFACW   , RR      , SUMNW   ,   &
!$omp          SUMPW    , TOP     , W00     , W3      , W4      , W4P     , WP      , WP0     )
!
    DO 200 J=MYJS_P1,MYJE_P1
        DO 200 I=MYIS_P1,MYIE_P1
!
            LMP=LMH(I,J)
!
            DO K=1,LMP
                W3(K) = W(I,J,K)
                W4(K) = W3(K)
            END DO
        
            ETADTL(1) = ETADT(I,J,1) * 0.5
        
            DO K=2,LMP-1
                ETADTL(K) = (ETADT(I,J,K-1) + ETADT(I,J,K)) * 0.5
            END DO
!        
            ETADTL(LMP) = ETADT(I,J,LMP-1) * 0.5
!
            SUMPW = 0.
            SUMNW = 0.
        
            DO K=1,LMP
                RR  = ETADTL(K) * (-ADDT)
                ARR = ABS(RR)
            
                IF (ARR > 0.) THEN
                    LAP = RR / ARR
                ELSE
                    LAP = 0
                END IF
!            
                LA(K) = LAP
                LLAP  = K + LAP
!            
                TOP = .FALSE. 
                BOT = .FALSE. 
!            
                IF (LLAP > 0 .AND. LLAP < LMH(I,J)+1 .AND. LAP /= 0) THEN
                    RR     = ARR / ABS(AETA(LLAP) - AETA(K))
                    AFR(K) = (((FF4 * RR + FF3) * RR + FF2) * RR + FF1) * RR
                    DWP    = (W3(LLAP) - W3(K)) * RR
                    DWL(K) = DWP
                ELSE
                    TOP = LLAP == 0
                    BOT = LLAP == LMH(I,J)+1
!                
                    RR     = 0.
                    AFR(K) = 0.
                    DWL(K) = 0.
                END IF
            END DO
!        
            IF (TOP) THEN
                IF (LA(2) < 0) THEN
                    DWL(1)   = -DWL(2)     * DETA(2)     / DETA(1)
                END IF
            END IF
!        
            IF (BOT) THEN
                IF (LA(LMP-1) > 0)THEN
                    DWL(LMP) = -DWL(LMP-1) * DETA(LMP-1) / DETA(LMP)
                END IF
            END IF
!        
            DO K=1,LMP
                DETAL = DETA(K)
                DWP   = DWL (K) * DETAL
                IF (DWP > 0.) THEN
                    SUMPW = SUMPW + DWP
                ELSE
                    SUMNW = SUMNW + DWP
                END IF
            END DO
!-------------------------------
! FIRST MOMENT CONSERVING FACTOR
!-------------------------------
            IF (SUMPW > 1.E-9) THEN
                RFACW = -SUMNW / SUMPW
            ELSE
                RFACW = 1.
            END IF
!        
            IF(RFACW < 0.9 .OR. RFACW > 1.1) RFACW = 1.
!---------------------------------
! IMPOSE CONSERVATION ON ADVECTION
!---------------------------------
            IF (RFACW < 1.) THEN
                DO K=1,LMP
                    DWP = DWL(K)
                    IF (DWP < 0.)  DWP = DWP / RFACW
                    W4(K) = W3(K) + DWP
                END DO
            ELSE
                DO K=1,LMP
                    DWP = DWL(K)
                    IF (DWP >= 0.) DWP = DWP * RFACW
                    W4(K) = W3(K) + DWP
                END DO
            END IF
!-------------------- 
! ANTI-FILTERING STEP
!-------------------- 
            SUMPW = 0.
            SUMNW = 0.
!------------------------ 
! ANTI-FILTERING LIMITERS
!------------------------ 
            DO 50 K=2,LMP-1
                DETAL = DETA(K)
!            
                W4P = W4(K)
!            
                LAP = LA(K)
!            
                IF (LAP /= 0) THEN
                    AFRP  = 2. * AFR(K) * (AETA(K+LAP) - AETA(K)) ** 2 / (AETA(K+LAP) - AETA(K-LAP))
                    D2PQW = ((W4(K+LAP) - W4P)       / (AETA(K+LAP) - AETA(K))                          &
    &                     -  (W4P       - W4(K-LAP)) / (AETA(K)     - AETA(K-LAP)))                     &
    &                     *   AFRP
                ELSE
                    D2PQW = 0.
                END IF
!            
                WP = W4P - D2PQW
!            
                W00 = W3(K)
                WP0 = W3(K+LAP)
!            
                WP = MAX(WP,MIN(W00,WP0))
                WP = MIN(WP,MAX(W00,WP0))
!            
                DWP = WP - W4P
!            
                DWL(K) = DWP
!            
                DWP = DWP * DETAL
!            
                IF (DWP > 0.) THEN
                    SUMPW = SUMPW + DWP
                ELSE
                    SUMNW = SUMNW + DWP
                END IF
!            
         50 END DO
!
            DWL(1)   = 0.
        
            DWL(LMP) = 0.
!------------------------------- 
! FIRST MOMENT CONSERVING FACTOR
!-------------------------------
            IF (SUMPW > 1.E-9) THEN
                RFACW = -SUMNW / SUMPW
            ELSE
                RFACW = 1.
            END IF
!        
            IF (RFACW < 0.9 .OR. RFACW > 1.1) RFACW = 1.
!--------------------------------------
! IMPOSE CONSERVATION ON ANTI-FILTERING 
!--------------------------------------
            IF (RFACW < 1.) THEN
                DO K=1,LMP
                    DWP = DWL(K)
                    IF (DWP >= 0.) DWP = DWP * RFACW
                    DWDT(I,J,K) = DWDT(I,J,K) - (W4(K) + DWP - W3(K)) * RDT
                END DO
            ELSE
                DO K=1,LMP
                    DWP = DWL(K)
                    IF (DWP < 0.)  DWP = DWP / RFACW
                    DWDT(I,J,K) = DWDT(I,J,K) - (W4(K) + DWP - W3(K)) * RDT
                END DO
            END IF
!
200 END DO
!-------------------------- 
! END OF VERTICAL ADVECTION
!-------------------------- 
!
    ENH = ADDT / (08. * DY)
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!
    DO J=MYJS_P2,MYJE_P2
        DO I=MYIS_P1,MYIE_P1
            EMH(I,J)  = ADDT / (08. * DX(I,J))
            DARE(I,J) = HBM2(I,J)   * DX(I,J) * DY
        END DO
    END DO
!--------------------- 
! HORIZONTAL ADVECTION 
!--------------------- 
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (DVOLP    , DWSTIJ  , HM      , JFP     , JFQ     , PP      , QP      , SUMNW   ,   &
!$omp          SUMPW    , TTA     , TTB     )
!
    DO 300 K=1,LM
!
        DO J=MYJS_P2,MYJE_P2
            DO I=MYIS_P1,MYIE_P1
                DVOL(I,J,K) = DARE(I,J)   * PDSL(I,J) * DETA(K)
                HM          =  HTM(I,J,K)
                  W1(I,J,K) =    W(I,J,K) * HM
            END DO
        END DO
!
        SUMPW = 0.
        SUMNW = 0.
!    
        DO 225 J=MYJS2_P1,MYJE2_P1
            DO 225 I=MYIS1_P1,MYIE1_P1
!            
                DVOLP = DVOL(I,J,K) * HBM3(I,J)
                  TTA = (U(I,J-1,K) + U(I+IHW(J),J,K) + U(I+IHE(J),J,K) + U(I,J+1,K))             &
    &                 *  HBM2(I,J)  * EMH(I,J)
!
                  TTB = (V(I,J-1,K) + V(I+IHW(J),J,K) + V(I+IHE(J),J,K) + V(I,J+1,K))             &
    &                 *  HBM2(I,J)  * ENH
!            
                PP = -TTA - TTB
                QP =  TTA - TTB
!            
                JFP = INT(SIGN(1.,PP))
                JFQ = INT(SIGN(1.,QP))
!            
                IFPA(I,J,K) = IHE(J) + I + ( JFP-1) / 2
                IFQA(I,J,K) = IHE(J) + I + (-JFQ-1) / 2
!            
                JFPA(I,J,K) = J + JFP
                JFQA(I,J,K) = J + JFQ
!            
                IFPF(I,J,K) = IHE(J) + I + (-JFP-1) / 2
                IFQF(I,J,K) = IHE(J) + I + ( JFQ-1) / 2
!            
                JFPF(I,J,K) = J - JFP
                JFQF(I,J,K) = J - JFQ
!            
                PP = ABS(PP) * HTM(I,J,K) * HTM(IFPA(I,J,K), JFPA(I,J,K),K)
                QP = ABS(QP) * HTM(I,J,K) * HTM(IFQA(I,J,K), JFQA(I,J,K),K)
!            
                AFP(I,J,K) = (((FF4 * PP + FF3) * PP + FF2) * PP + FF1) * PP
                AFQ(I,J,K) = (((FF4 * QP + FF3) * QP + FF2) * QP + FF1) * QP
!            
                DWSTIJ = (W(IFPA(I,J,K), JFPA(I,J,K),K) - W(I,J,K)) * PP                          &
    &                  + (W(IFQA(I,J,K), JFQA(I,J,K),K) - W(I,J,K)) * QP
!            
                DWST(I,J,K) = DWSTIJ
!            
    225 END DO
!---------------------------- 
! GLOBAL SUM FOR CONSERVATION
!---------------------------- 
        DO 230 J=MYJS2,MYJE2
            DO 230 I=MYIS1,MYIE1
!           
                DVOLP  = DVOL(I,J,K) * HBM3(I,J)
                DWSTIJ = DWST(I,J,K) * DVOLP
!            
                IF (DWSTIJ > 0.) THEN
                    SUMPW = SUMPW + DWSTIJ
                ELSE
                    SUMNW = SUMNW + DWSTIJ
                END IF
!            
    230 END DO
!
        XSUMS(1,K) = SUMPW
        XSUMS(2,K) = SUMNW
    
        CONTINUE !END OF VERTICAL LOOP
!
300 END DO
!----------------- 
! GLOBAL REDUCTION
!----------------- 
    CALL MPI_ALLREDUCE(XSUMS, GSUMS, 2*LM, MPI_REAL, MPI_SUM, MPI_COMM_COMP, IRECV)
!
    IF (IRECV /= 0) THEN
        PRINT*, ' RETURN CODE FROM 1ST ALLREDUCE IN EPS = ', IRECV
        STOP
    END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (D2PQW    , DVOLP   , DWSTIJ  , RFACW   , RFWIJ   , SUMNW   , SUMPW   , W00     ,   &
!$omp          W0Q      , W1IJ    , WP0     , WSTIJ   )
!
    DO 400 K=1,LM
!   
        SUMPW = GSUMS(1,K)
        SUMNW = GSUMS(2,K)
!-------------------------------    
! FIRST MOMENT CONSERVING FACTOR 
!-------------------------------
        IF (SUMPW > 1.) THEN
            RFACW = -SUMNW / SUMPW
        ELSE
            RFACW = 1.
        END IF
!
        IF (RFACW < 0.9 .OR. RFACW > 1.1) RFACW = 1.
!---------------------------------
! IMPOSE CONSERVATION ON ADVECTION 
!---------------------------------
        IF (RFACW < 1.) THEN
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ = HBM3(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ < 0.) DWSTIJ = DWSTIJ / RFWIJ
                    W1(I,J,K) = W(I,J,K) + DWSTIJ
                END DO
            END DO
        ELSE
            DO J=MYJS2_P1,MYJE2_P1
                DO I=MYIS1_P1,MYIE1_P1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ  = HBM3(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ >= 0.) DWSTIJ = DWSTIJ * RFWIJ
                    W1(I,J,K) = W(I,J,K) + DWSTIJ
                END DO
            END DO
        END IF
!-------------------- 
! ANTI-FILTERING STEP
!-------------------- 
        SUMPW = 0.
        SUMNW = 0.
!------------------------ 
! ANTI-FILTERING LIMITERS
!------------------------   
        DO 350 J=MYJS2,MYJE2
            DO 350 I=MYIS1,MYIE1
!            
                DVOLP = DVOL(I,J,K)
                W1IJ  =   W1(I,J,K)
!            
                D2PQW = ((             W1(IFPA(I,J,K), JFPA(I,J,K), K)  - W1IJ)                   &
    &                 -  (W1IJ     -   W1(IFPF(I,J,K), JFPF(I,J,K), K))                           &
    &                 *               HTM(IFPF(I,J,K), JFPF(I,J,K), K))                           &
    &                 * AFP(I,J,K) + ((W1(IFQA(I,J,K), JFQA(I,J,K), K)  - W1IJ)                   &
    &                 -  (W1IJ     -   W1(IFQF(I,J,K), JFQF(I,J,K), k))                           &
    &                 *               HTM(IFQF(I,J,K), JFQF(I,J,K), K)) * AFQ(I,J,K)
!            
                WSTIJ = W1IJ - D2PQW
!            
                W00 = W(I,J,K)
                WP0 = W(IFPA(I,J,K), JFPA(I,J,K), K)
                W0Q = W(IFQA(I,J,K), JFQA(I,J,K), K)
!            
                WSTIJ = AMAX1(WSTIJ, AMIN1(W00,WP0,W0Q))
                WSTIJ = AMIN1(WSTIJ, AMAX1(W00,WP0,W0Q))
!            
                DWSTIJ = WSTIJ  - W1IJ
!            
                DWST(I,J,K) = DWSTIJ
!            
                DWSTIJ = DWSTIJ * DVOLP
!            
                IF (DWSTIJ > 0.) THEN
                    SUMPW = SUMPW + DWSTIJ
                ELSE
                    SUMNW = SUMNW + DWSTIJ
                END IF
!            
    350 END DO
!
        XSUMS(1,K) = SUMPW
        XSUMS(2,K) = SUMNW
!    
        CONTINUE !END OF VERTICAL LOOP
400 END DO
!----------------- 
! GLOBAL REDUCTION
!----------------- 
    CALL MPI_ALLREDUCE(XSUMS, GSUMS, 2*LM, MPI_REAL, MPI_SUM, MPI_COMM_COMP, IRECV)
!
    IF (IRECV /= 0) THEN
        PRINT*, ' RETURN CODE FROM 2ND ALLREDUCE IN EPS = ', IRECV
        STOP
    END IF
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (DWSTIJ   , RFACW   , RFWIJ   , SUMNW   , SUMPW)
!
    DO 425 K=1,LM
!    
        SUMPW = GSUMS(1,K)
        SUMNW = GSUMS(2,K)
!-------------------------------    
! FIRST MOMENT CONSERVING FACTOR
!-------------------------------
        IF (SUMPW > 1.) THEN
            RFACW = -SUMNW / SUMPW
        ELSE
            RFACW = 1.
        END IF
!
        IF (RFACW < 0.9 .OR. RFACW > 1.1) RFACW = 1.
!--------------------------------------
! IMPOSE CONSERVATION ON ANTI-FILTERING
!--------------------------------------
        IF (RFACW < 1.) THEN
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ = HBM2(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ >= 0.) DWSTIJ = DWSTIJ * RFWIJ
                    DWDT(I,J,K) = (DWDT(I,J,K) - (W1(I,J,K) + DWSTIJ - W(I,J,K)) * RDT) * HBM3(I,J)
                END DO
            END DO
        ELSE
            DO J=MYJS2,MYJE2
                DO I=MYIS1,MYIE1
                    DWSTIJ = DWST(I,J,K)
                    RFWIJ = HBM2(I,J) * (RFACW-1.) + 1.
                    IF (DWSTIJ < 0.) DWSTIJ = DWSTIJ / RFWIJ
                    DWDT(I,J,K) = (DWDT(I,J,K) - (W1(I,J,K) + DWSTIJ - W(I,J,K)) * RDT) * HBM3(I,J)
                END DO
            END DO
        END IF
!
425 END DO
!--------------------------------------------------
! RESTRICTING THE ACCELERATION ALONG THE BOUNDARIES
!--------------------------------------------------
    JHL = 0
!
    IF (JHL > 1) THEN
        JHH = JM  - JHL + 1
!    
        IHL = JHL / 2   + 1
        IHH = IM  - IHL + MOD(J,2)
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (IX     , JX)
!
        DO 450 K=1,LM
!        
            DO J=1,JHL
                IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                    JX = J - MY_JS_GLB + 1
                    DO I=1,IM
                        IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                            IX = I - MY_IS_GLB + 1
                            DWDT(IX,JX,K) = MAX(DWDT(IX,JX,k) * HBM3(IX,JX), -0.03)
                            DWDT(IX,JX,K) = MIN(DWDT(IX,JX,K) * HBM3(IX,JX),  0.03)
                        END IF
                    END DO
                END IF
            END DO
!        
            DO J=JHH,JM
                IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                    JX = J - MY_JS_GLB + 1
                    DO I=1,IM
                        IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                            IX = I - MY_IS_GLB + 1
                            DWDT(IX,JX,K) = MAX(DWDT(IX,JX,K) * HBM3(IX,JX), -0.03)
                            DWDT(IX,JX,K) = MIN(DWDT(IX,JX,K) * HBM3(IX,JX),  0.03)
                        END IF
                    END DO
                END IF
            END DO
!        
            DO J=1,JM
                IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                    JX = J - MY_JS_GLB + 1
                    DO I=1,IHL
                        IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                            IX = I - MY_IS_GLB + 1
                            DWDT(IX,JX,L) = MAX(DWDT(IX,JX,L) * HBM3(IX,JX), -0.03)
                            DWDT(IX,JX,L) = MIN(DWDT(IX,JX,L) * HBM3(IX,JX),  0.03)
                        END IF
                    END DO
                END IF
            END DO
!        
            DO J=1,JM
                IF (J >= MY_JS_GLB-JBPAD2 .AND. J <= MY_JE_GLB+JTPAD2) THEN
                    JX = J - MY_JS_GLB + 1
                    DO I=IHH,IM
                        IF (I >= MY_IS_GLB-ILPAD2 .AND. I <= MY_IE_GLB+IRPAD2) THEN
                            IX = I - MY_IS_GLB + 1
                            DWDT(IX,JX,K) = MAX(DWDT(IX,JX,K) * HBM3(IX,JX), -0.03)
                            DWDT(IX,JX,K) = MIN(DWDT(IX,JX,K) * HBM3(IX,JX),  0.03)
                        END IF
                    END DO
                END IF
            END DO
!        
    450 END DO
!
    END IF
!
    CALL EXCH(DWDT,LM,1,1)
!
    WA = 0.15
!------- 
! OPENMP
!------- 
!
!$omp parallel do private (ANE    , ASE)
!
    DO 500 K=1,LM
!    
        DO J=MYJS1_P1,MYJE2_P1
            DO I=MYIS_P1,MYIE1_P1
                ANE(I,J) = (DWDT(I+IHE(J),J+1,K) - DWDT(I,J,K)) * HTM(I,J,K)                      &
    &                    *   HTM(I+IHE(J),J+1,K)
            END DO
        END DO
!    
        DO J=MYJS2_P1,MYJE1_P1
            DO I=MYIS_P1,MYIE1_P1
                ASE(I,J) = (DWDT(I+IHE(J),J-1,K) - DWDT(I,J,K)) * HTM(I+IHE(J),J-1,K)             &
    &                    *   HTM(I,J,K)
            END DO
        END DO
!    
        DO J=MYJS2,MYJE2
            DO I=MYIS1,MYIE1
                DWDT(I,J,K) = (ANE(I,J) - ANE(I+IHW(J),J-1) + ASE(I,J) - ASE(I+IHW(J),J+1))       &
    &                       *  WA * HBM2(I,J) + DWDT(I,J,K)
            END DO
        END DO
!
500 END DO
!
    WP     = 0.075
    KN     = 0
    KP     = 0
    DWDTMX = 0.
    DWDTMN = 0.
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (DWDTMN   , DWDTMX  , DWDTT   , HM      , KN      , KP)
!
    DO 525 K=1,LM
!
        DO J=MYJS,MYJE
            DO I=MYIS,MYIE
                HM     =  HTM(I,J,K) * HBM2(I,J)
                DWDTT  = DWDT(I,J,K) * HM
!            
                DWDTMX = AMAX1(DWDTT,DWDTMX)
                DWDTMN = AMIN1(DWDTT,DWDTMN)
!            
                IF (DWDTT < EPSN) THEN
                    DWDTT = EPSN
                    KN    = KN + 1
                END IF
!            
                IF (DWDTT > EPSP) THEN
                    DWDTT = EPSP
                    KP    = KP + 1
                END IF
!            
                DWDT(I,J,K) = (DWDTT/G+1.) * (1.-WP) + PDWDT(I,J,K) * WP
            END DO
        END DO
!
525 END DO
!
    GDT  = G * DT
    GDT2 = GDT * GDT
    WGHT = 0.35
    FFC  = -4. * R / GDT2
!------- 
! OPENMP
!------- 
!
!$omp parallel do
!$omp private (CHI      , CHIN    , CHMOD   , CLIM    , COFF    , DELP    , DFRC    , DP      ,   &
!$omp          DPSTR    , DPTL    , DPTU    , DWDTT   , HBM2IJ  , IMAX    , INOT    , ITER    ,   &
!$omp          ITMX     , JMAX    , K       , LMP     , PDP     , PNP1    , PONE    , PP1     ,   &
!$omp          PSTR     , RDP     , RESDL   , WIL     , WRES    )
!
    DO 600 J=MYJS2,MYJE2
        DO 600 I=MYIS1,MYIE1
!        
            LMP =  LMH(I,J)
            PDP = PDSL(I,J)
            RPD = 1. / PDP
!
            PONE(1) = PT
            PSTR(1) = PT
            PNP1(1) = PT
            CHI(1)  = 0.
!        
            DO K=2,LMP+1
                CHI(K)    = 0.
                DPPL      = DETA(K-1) * PDP
                RDPP(K-1) = 1. / DPPL
                PONE(K)   = PINT(I,J,K)
                DPSTR     = DWDT(I,J,K-1) * DPPL
                PSTR(K)   = PSTR(K-1) + DPSTR
                PP1       = PNP1(K-1) + DPSTR
                PNP1(K)   = (PP1-PONE(K)) * WGHT + PONE(K)
                TFC       = Q(I,J,K-1) * 0.608 + 1.
                TTFC      = -CAPA * TFC + 1.
                COFF(K-1) = T(I,J,K-1) * TTFC * TFC * DPPL * FFC / ((PNP1(K-1)+PNP1(K)) *         &
    &                                                               (PNP1(K-1)+PNP1(K)))
            END DO
!        
            PSTRUP = -(PSTR(1) + PSTR(2) - PONE(1) - PONE(2)) * COFF(1)
!        
            DO K=2,LMP
                RDPDN = RDPP(K)
                RDPUP = RDPP(K-1)
!            
                PSTRDN = -(PSTR(K) + PSTR(K+1) - PONE(K) - PONE(K+1)) * COFF(K)
!            
                B1(K)  =  COFF(K-1) + RDPUP
                B2(K)  = (COFF(K-1) + COFF(K)) - (RDPUP+RDPDN)
                B3(K)  =  COFF(K)   + RDPDN
                C0(K)  = PSTRUP     + PSTRDN
!            
                PSTRUP = PSTRDN
            END DO
!        
            B1(2)   = 0.
            B2(LMP) = B2(LMP) + B3(LMP)
!------------ 
! ELIMINATION 
!------------ 
            DO K=3,LMP
                TMP   = -B1(K)   / B2(K-1)
                B2(K) =  B3(K-1) * TMP + B2(K)
                C0(K) =  C0(K-1) * TMP + C0(K)
            END DO
!        
            CHI(1) = 0.
!------------------
! BACK SUBSTITUTION 
!------------------
            CHI(LMP)   =  C0(LMP) / B2(LMP)
            CHI(LMP+1) = CHI(LMP)
!        
            DO K=LMP-1,2,-1
                CHI(K) = (-B3(k) * CHI(K+1) + C0(K)) / B2(K)
            END DO
!
            HBM2IJ = HBM2(I,J)
            DPTU   = 0.
            FCT    = 0.5 / CP * HBM2IJ
!        
            DO K=1,LMP
                DPTL          = (CHI(K+1)      + PSTR(K+1)    - PINT(I,J,K+1)) * HBM2IJ
                PINT(I,J,K+1) = PINT(I,J,K+1)  + DPTL
                T   (I,J,K)   = (DPTU+DPTL)    * RTOP(I,J,K)  * FCT            + T(I,J,K)
                DELP          = (PINT(I,J,K+1) - PINT(I,J,K)) * RDPP(K)
                W(I,J,K)      = ((DELP         - DWDT(I,J,K)) * GDT            + W(I,J,K)) * HBM2IJ
                DWDT(I,J,K)   = (DELP-1.)      * HBM2IJ       + 1.
!
                DPTU = DPTL
            END DO
!        
            DO K=LMP,LM
                PINT(I,J,K+1) = PDSL(I,J) * DETA(K) + PINT(I,J,K)
            END DO
!
600 END DO
!
    RETURN
!
    END SUBROUTINE EPS

    BLOCK DATA  GFDLRD
!>--------------------------------------------------------------------------------------------------
!> BLOCK DATA GFDLRD
!> 
!> BLOCK DATA: GFDLRD - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> ?????
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  ?????      - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                       * F77 TO F90/F95
!>                       * INDENTATION & UNIFORMIZATION CODE
!>                       * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                       * DOCUMENTATION WITH DOXYGEN
!>                       * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CO2DTA
!>              DIUCON
!>              HCON
!>              INPUT 
!>              PARMETA
!>              PHYCON
!>              RDPARM
!>              RNDDTA
!>              SSALB
!>              SWRSAV
!>              TBLTMP
!>
!> DRIVER     : -----
!>
!> CALLS      : -----  
!--------------------------------------------------------------------------------------------------
    USE CO2DTA
    USE DIUCON
    USE HCON
    USE INPUT
    USE PARMETA
    USE PHYCON
    USE RDPARM
    USE RNDDTA
    USE SSALB
    USE SWRSAV
    USE TBLTMP
!
    IMPLICIT NONE
!
#include "sp.h"
!
    END BLOCK DATA GFDLRD

    SUBROUTINE VTADVF
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE VTADVF
!> 
!> SUBROUTINE: VTADVF - VERTICAL ADVECTION
!> PROGRAMMER: JANJIC
!> ORG: W/NP22
!> DATE: 93-11-17
!>
!> ABSTRACT:
!> VTADVF CALCULATES THE CONTRIBUTION OF THE VERTICAL ADVECTION TO THE TENDENCIES OF TEMPERATURE, 
!> WIND COMPONENTS, AND TURBULENT KINETIC ENERGY AND THEN UPDATES THOSE VARIABLES. FOR ALL THESE 
!> VARIABLES A SIMPLE CENTERED DIFFERENCE SCHEME IN SPACE IS USED IN CONJUNCTION WITH THE PURE 
!> EULER-BACKWARD TIME SCHEME.
!>
!> PROGRAM HISTORY LOG:
!> 87-06-??  JANJIC     - ORIGINATOR
!> 90-??-??  MESINGER   - INSERTED PIECEWISE LINEAR SCHEME FOR SPECIFIC HUMIDITY
!> 95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!> 95-11-20  ABELES     - PARALLEL OPTIMIZATION
!> 96-03-29  BLACK      - ADDED EXTERNAL EDGE; REMOVED SCRCH COMMON
!> 98-11-24  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY
!> 18-01-15  LUCCI      - INDENTATION, UNIFORMIZATION CODE AND FREE FORM WITH OPENMP
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT FILES:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              PARMETA
!>              PVRBLS
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : DIGFLT
!>              NEWFLT
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS    , ONLY : JAM
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE PARMETA
    USE PVRBLS
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: EDQMX   =  2.E-5
    REAL   (KIND=R4KIND), PARAMETER :: EDQMN   = -2.E-5
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ    =  1.E-12
!
    INTEGER(KIND=I4KIND), PARAMETER :: KSMUD   =  0
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM    = IM * JM - JM / 2
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & NOSLA  
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::&
    & WFA     , WFB
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & ETADTL  ,                                                                                   &
    & TTA     , TQ2A    ,                                                                         &
    & TUA     , TVA     ,                                                                         &
    & TTB     , TQ2B    ,                                                                         &
    & TUB     , TVB     ,                                                                         &
    & VM      ,                                                                                   &
    & RPDX    , RPDY    ,                                                                         &
    & FNE     , FSE   
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & TSTL    ,                                                                                   &
    & USTL    ,                                                                                   &
    & VSTL    ,                                                                                   &
    & Q2ST 
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , KS      , NMSAP   , NSMUD   
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TTAK    , TQ2AK   , VMK     , TUAK    , TVAK 
!------------------------------------------ 
! DEFINE ADDED UPSTREAM ADVECTION CONSTANTS 
!------------------------------------------ 
    DO 25 K=1,LM1
        WFA(K) = DETA(K  ) / (DETA(K) + DETA(K+1))
        WFB(K) = DETA(K+1) / (DETA(K) + DETA(K+1))
 25 END DO
!------------------------------------------- 
! NO MOISTURE SLOPE ADJUSTMENT IF NOT WANTED
!------------------------------------------- 
    NOSLA = .FALSE.
!----------------------------------------------------- 
! IF FALSE, NUMBER OF MOISTURE SLOPE ADJUSTMENT PASSES
!----------------------------------------------------- 
    NMSAP = 3
!----------------------------------------  
! SMOOTHING VERTICAL VELOCITY AT H POINTS
!----------------------------------------  
    IF (KSMUD > 0) THEN
!
!$omp parallel do 
!
        DO 90 K=1,LM1
            DO 50 J=MYJS_P4,MYJE_P4
                DO 50 I=MYIS_P4,MYIE_P4
                    ETADT(I,J,K) = ETADT(I,J,K) * HBM2(I,J)
         50 END DO
!
            NSMUD = KSMUD
!-------------------------------------------------------------------------- 
! THE FNE, FSE, ETADTL, AND ETADT ARRAYS ARE ON OR ASSOCIATED WITH H POINTS
!-------------------------------------------------------------------------- 
            DO 90 KS=1,NSMUD
                DO 80 J=MYJS_P3,MYJE1_P3
                    DO 80 I=MYIS_P3,MYIE_P3
                        FNE(I,J) = (ETADT(I+IHE(J),J+1,K  ) - ETADT(I     ,J  ,K  ))              &
    &                            *    HTM(I       ,J  ,K+1) * HTM(I+IHE(J),J+1,K+1)
             80 END DO
!
                DO 82 J=MYJS1_P3,MYJE_P3
                    DO 82 I=MYIS_P3,MYIE_P3
                        FSE(I,J) = (ETADT(I+IHE(J),J-1,K  ) - ETADT(I,J,K  ))                     &
    &                            *    HTM(I+IHE(J),J-1,K+1) *   HTM(I,J,K+1)
             82 END DO
!
                DO 84 J=MYJS2_P1,MYJE2_P1
                    DO 84 I=MYIS_P1,MYIE_P1
                        ETADTL(I,J) = (FNE(I,J) - FNE(I + IHW(J), J-1)                            &
    &                               +  FSE(I,J) - FSE(I + IHW(J), J+1))                           &
    &                               * HBM2(I,J)
             84 END DO
!
                DO 86 J=MYJS2_P1,MYJE2_P1
                    DO 86 I=MYIS_P1,MYIE_P1
                        ETADT(I,J,K) = ETADTL(I,J) * 0.125 + ETADT(I,J,K)
             86 END DO
!
         90 END DO
!
    END IF
!----------------------------------  
! VERTICAL (MATSUNO) ADVECTION OF T
!---------------------------------- 
!
!$omp parallel do
!
    DO 100 J=MYJS,MYJE
        DO 100 I=MYIS,MYIE
            TTB(I,J) = 0.
100 END DO
!
    DO 110 K=1,LM1
!
!$omp parallel do private (TTAK)
!
        DO 110 J=MYJS2,MYJE2
            DO 110 I=MYIS,MYIE
                TTAK        = (T(I,J,K+1) -   T(I,J,K)) * ETADT(I,J,K) * F4D
                TSTL(I,J,K) = (TTAK       + TTB(I,J))   * RDETA(K)     + T(I,J,K)
                TTB(I,J)    =  TTAK
110 END DO
!
!$omp parallel do
!
    DO 120 J=MYJS2,MYJE2
        DO 120 I=MYIS,MYIE
            TSTL(I,J,LM) = T(I,J,LM) + TTB(I,J) * RDETA(LM)
120 END DO
!------------------------------- 
! SECOND (BACKWARD) MATSUNO STEP
!-------------------------------  
!
!$omp parallel do
!
    DO 125 J=MYJS,MYJE
        DO 125 I=MYIS,MYIE
            TTB(I,J) = 0.
125 END DO
!
    DO 140 K=1,LM1
!
!$omp parallel do private (TTAK)
!
        DO 140 J=MYJS2,MYJE2
            DO 140 I=MYIS,MYIE
                TTAK     = (TSTL(I,J,K+1)    - TSTL(I,J,K)) * ETADT(I,J,K) * F4D
                T(I,J,K) = (TTAK             +  TTB(I,J))   * RDETA(K)     + T(I,J,K)
                TTB(I,J) =  TTAK
    140 END DO
!
!$omp parallel do 
!
    DO 150 J=MYJS2,MYJE2
        DO 150 I=MYIS,MYIE
            T(I,J,LM) = T(I,J,LM) + TTB(I,J) * RDETA(LM)
150 END DO
!-----------------------------------
! VERTICAL (MATSUNO) ADVECTION OF Q2 
!-----------------------------------
!
!$omp parallel do 
!
    DO 400 J=MYJS2,MYJE2
        DO 400 I=MYIS,MYIE
            TQ2B(I,J) = Q2(I,J,1) * ETADT(I,J,1) * F4Q2(1)
400 END DO
!
    DO 425 K=1,LM2
!
!$omp parallel do private(TQ2AK)
!
        DO 425 J=MYJS2,MYJE2
            DO 425 I=MYIS,MYIE
                TQ2AK       = (   Q2(I,J,K+1) -    Q2(I,J,K  ))                                   &
    &                       * (ETADT(I,J,K  ) + ETADT(I,J,K+1))                                   &
    &                       *       F4Q2(K+1)
!
                Q2ST(I,J,K) = TQ2AK + TQ2B(I,J) + Q2(I,J,K)
                TQ2B(I,J)   = TQ2AK
425 END DO
!
!$omp parallel do private(TQ2AK)
!
    DO 440 J=MYJS2,MYJE2
        DO 440 I=MYIS,MYIE
            TQ2AK         = (Q2(I,J,LM) -   Q2(I,J,LM1)) * ETADT(I,J,LM1) * F4Q2(LM)
            Q2ST(I,J,LM1) = TQ2AK       + TQ2B(I,J)      +    Q2(I,J,LM1)
            Q2ST(I,J,LM ) =  Q2(I,J,LM)
440 END DO
!------------------------------- 
! SECOND (BACKWARD) MATSUNO STEP 
!-------------------------------
!
!$omp parallel do
!
    DO 450 J=MYJS2,MYJE2
        DO 450 I=MYIS,MYIE
            TQ2B(I,J) = Q2ST(I,J,1) * ETADT(I,J,1) * F4Q2(1)
450 END DO
!
    DO 470 K=1,LM2
!
!$omp parallel do private(TQ2AK)
!
        DO 470 J=MYJS2,MYJE2
            DO 470 I=MYIS,MYIE
                TQ2AK       = ( Q2ST(I,J,K+1) -  Q2ST(I,J,K  ))                                   &
    &                       * (ETADT(I,J,K  ) + ETADT(I,J,K+1))                                   &
    &                       *       F4Q2(K+1)
!
                  Q2(I,J,K) = TQ2AK + TQ2B(I,J) + Q2(I,J,K)
                TQ2B(I,J)   = TQ2AK
470 END DO
!
!$omp parallel do private(TQ2AK)
!
    DO 480 J=MYJS2,MYJE2
        DO 480 I=MYIS,MYIE
            TQ2AK       =      (Q2ST(I,J,LM) - Q2ST(I,J,LM1)) * ETADT(I,J,LM1) * F4Q2(LM)
            Q2(I,J,LM1) = TQ2AK+TQ2B(I,J)    +   Q2(I,J,LM1)
480 END DO
!-------------------------------------------
! DEFINITION OF VARIABLES NEEDED AT V POINTS
!-------------------------------------------
!
!$omp parallel do
!
    DO 500 K=1,LM1
        DO 500 J=MYJS_P1,MYJE_P1
            DO 500 I=MYIS_P1,MYIE_P1
                ETADT(I,J,K) = ETADT(I,J,K) * PDSL(I,J) * HBM2(I,J)
500 END DO
!
!$omp parallel do
!
    DO 510 J=MYJS2,MYJE2
        DO 510 I=MYIS,MYIE
            RPDX(I,J) =1. / (PDSL(I+IVW(J),J  ) + PDSL(I+IVE(J),J  ))
            RPDY(I,J) =1. / (PDSL(I       ,J-1)      + PDSL(I  ,J+1))
510 END DO
!---------------------------------------- 
! VERTICAL (MATSUNO) ADVECTION OF U AND V
!----------------------------------------
!
!$omp parallel do
!
    DO 520 J=MYJS,MYJE
        DO 520 I=MYIS,MYIE
            TUB(I,J) = 0.
            TVB(I,J) = 0.
520 END DO
!
    DO 540 K=1,LM1
!
!$omp parallel do private (TUAK, TVAK, VMK)
!
        DO 540 J=MYJS2,MYJE2
            DO 540 I=MYIS,MYIE
                VMK         =    VTM(I       ,J,K+1) *  VBM2(I       ,J)
!
                TUAK        = (ETADT(I+IVW(J),J,K  ) + ETADT(I+IVE(J),J,K))                       &
    &                       *     (U(I       ,J,K+1) -     U(I       ,J,K))                       &
    &                       *   RPDX(I       ,J    ) * (VMK * F4D)
!
                USTL(I,J,K) = (TUAK + TUB(I,J))      * RDETA(K)             +  U(I,J,K)
                 TUB(I,J)   =  TUAK
!
                TVAK        = (ETADT(I,J-1,K)        + ETADT(I,J+1,K))                            &
    &                       * (    V(I,J,K+1)        -      V(I,J ,K))                            &
    &                       *   RPDY(I,J)            * (VMK * F4D)
!
                VSTL(I,J,K) = (TVAK + TVB(I,J))      * RDETA(K)             +  V(I,J,K)
!
                 TVB(I,J)   = TVAK
540 END DO
!
!$omp parallel do
!
    DO 550 J=MYJS2,MYJE2
        DO 550 I=MYIS,MYIE
            USTL(I,J,LM) = U(I,J,LM) + TUB(I,J) * RDETA(LM)
            VSTL(I,J,LM) = V(I,J,LM) + TVB(I,J) * RDETA(LM)
550 END DO
!------------------------------- 
! SECOND (BACKWARD) MATSUNO STEP
!------------------------------- 
!
!$omp parallel do
!
    DO 560 J=MYJS,MYJE
        DO 560 I=MYIS,MYIE
            TUB(I,J) = 0.
            TVB(I,J) = 0.
560 END DO
!
    DO 580 K=1,LM1
!
!$omp parallel do private (TUAK, TVAK, VMK)
!
        DO 580 J=MYJS2,MYJE2
            DO 580 I=MYIS,MYIE
                VMK      =    VTM(I       ,J,K+1) *  VBM2(I       ,J)
                TUAK     = (ETADT(I+IVW(J),J,K  ) + ETADT(I+IVE(J),J,K))                          &
    &                    * (USTL(I        ,J,K+1) -  USTL(I       ,J,K))                          &
    &                    *  RPDX(I,J) * (VMK * F4D)
!
                U(I,J,K) = (TUAK + TUB(I,J)) * RDETA(K) +  U(I,J,K)
              TUB(I,J)   =  TUAK
              TVAK       = (ETADT(I,J-1,K  ) + ETADT(I,J+1,K))                                  &
    &                    * ( VSTL(I,J  ,K+1) -  VSTL(I,J  ,K))                                  &
    &                    * RPDY(I,J) * (VMK * F4D)
!
                V(I,J,K) = (TVAK + TVB(I,J)) * RDETA(K) + V(I,J,K)
                TVB(I,J) =  TVAK											  
580 END DO
!
!$omp parallel do
!
    DO 590 J=MYJS2,MYJE2
        DO 590 I=MYIS,MYIE
            U(I,J,LM) = U(I,J,LM) + TUB(I,J) * RDETA(LM)
            V(I,J,LM) = V(I,J,LM) + TVB(I,J) * RDETA(LM)
590 END DO
!
    RETURN
!
    END SUBROUTINE VTADVF

    MODULE PHYS
!>--------------------------------------------------------------------------------------------------
!> MODULE PHYS
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>              PARM_TBL
!>              RDPARM
!>
!> DRIVER     : CHKOUT
!>              GOSSIP
!>              INIT
!>              INITS
!>              READ_NHB
!>              TURBL 
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : LM ,IDIM1, IDIM2, JDIM1, JDIM2
    USE PARM_TBL, ONLY : ITB, JTB , ITBQ , JTBQ
    USE RDPARM  , ONLY : LP1
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & KTM
!
    REAL   (KIND=R4KIND)                                                                        ::&    
    & DTQ2    , TDTQ2   , DTD     , TDTD    ,                                                     &
    & ROS     , CS      , DS      , ROI     , CI      , DI      ,                                 &
    & PL      , THL     , RDQ     , RDTH    , RDP     , RDTHE   ,                                 &
    & PLQ     , RDPQ    , RDTHEQ
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                                        ::&    
    & DFRLG
!
    REAL   (KIND=R4KIND), DIMENSION(JTB)                                                        ::&
    & QS0     , SQS
!
    REAL   (KIND=R4KIND), DIMENSION(ITB)                                                        ::&
    & THE0    , STHE
!
    REAL   (KIND=R4KIND), DIMENSION(ITBQ)                                                       ::&
    & THE0Q   , STHEQ
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & MXSNAL  , EPSR    ,                                                                         &
    & RADIN   , RADOT   ,                                                                         &
    & GLAT    , GLON    ,                                                                         &
    & CZEN    ,                                                                                   &
    & HTOP    , HBOT    ,                                                                         &
    & CNVTOP  , CNVBOT  ,                                                                         &
    & TG      , GFFC    ,                                                                         &
    & SST     , ALBASE  ,                                                                         &
    & ALBEDO  ,                                                                                   &
    & HDAC    , HDACV   ,                                                                         &
    & CZMEAN  , SIGT4
!
   REAL   (KIND=R4KIND), DIMENSION(ITB, JTB)                                                   ::&
    & PTBL
!
    REAL   (KIND=R4KIND), DIMENSION(JTB, ITB)                                                   ::&
    & TTBL
!
    REAL   (KIND=R4KIND), DIMENSION(JTBQ, ITBQ)                                                 ::&
    & TTBLQ
!
    END MODULE PHYS

    MODULE ACMSFC
!>--------------------------------------------------------------------------------------------------
!> MODULE ACMSFC
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : CHKOUT
!>              GOSSIP
!>              INIT
!>              INITS
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SURFCE  
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NSRFC
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ASRFC   , TSRFC   , APHTIM 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & SFCSHX  , SFCLHX  ,                                                                         &
    & SUBSHX  , SNOPCX  ,                                                                         &
    & SFCUVX  , SFCEVP  ,                                                                         &
    & POTEVP  , POTFLX
!
    END MODULE ACMSFC
